
# Create Project

create_project -force -name kcu105 -part xcku040-ffva1156-2-e
set_msg_config -id {Common 17-55} -new_severity {Warning}
set_property SEVERITY {Warning} [get_drc_checks REQP-1753]

# Add Sources

read_verilog {verilog/Ram_1w_1rs_Generic.v}
read_verilog {verilog/VexRiscvLitexSmpCluster_Cc4_Iw64Is8192Iy2_Dw64Ds8192Dy2_ITs4DTs4_Ldw512_Cdma_Ood.v}
read_verilog {verilog/kcu105.v}


# Add constraints

read_xdc constraints/kcu105.xdc
set_property PROCESSING_ORDER EARLY [get_files constraints/kcu105.xdc]

# Add pre-synthesis commands


# Synthesis

synth_design -directive default -top kcu105 -part xcku040-ffva1156-2-e

# Synthesis report

# report_timing_summary -file kcu105_timing_synth.rpt
# report_utilization -hierarchical -file kcu105_utilization_hierarchical_synth.rpt
# report_utilization -file kcu105_utilization_synth.rpt

# Optimize design

opt_design -directive default

# Add pre-placement commands


# Placement

place_design -directive default

# Placement report

# report_utilization -hierarchical -file kcu105_utilization_hierarchical_place.rpt
# report_utilization -file kcu105_utilization_place.rpt
# report_io -file kcu105_io.rpt
# report_control_sets -verbose -file kcu105_control_sets.rpt
# report_clock_utilization -file kcu105_clock_utilization.rpt

# Routing

route_design -directive default
phys_opt_design -directive default
write_checkpoint -force kcu105_route.dcp
write_edif -force kcu105_route.edf

# Routing report

# report_timing_summary -no_header -no_detailed_paths
# report_route_status -file kcu105_route_status.rpt
# report_drc -file kcu105_drc.rpt
# report_timing_summary -datasheet -max_paths 10 -file kcu105_timing.rpt
# report_power -file kcu105_power.rpt

# Bitstream generation

# write_bitstream -force kcu105.bit 

