// -----------------------------------------------------------------------------
// Auto-Generated by:        __   _ __      _  __
//                          / /  (_) /____ | |/_/
//                         / /__/ / __/ -_)>  <
//                        /____/_/\__/\__/_/|_|
//                     Build your hardware, easily!
//                   https://github.com/enjoy-digital/litex
//
// Filename   : kcu105.v
// Device     : xcku040-ffva1156-2-e
// LiteX sha1 : 7b5515ce
// Date       : 2023-06-21 10:56:39
//------------------------------------------------------------------------------

`timescale 1ns / 1ps

//------------------------------------------------------------------------------
// Module
//------------------------------------------------------------------------------

module kcu105 (
    input  wire          cpu_reset,
    (* dont_touch = "true" *)
    input  wire          clk125_p,
    input  wire          clk125_n,
    input  wire          serial_cts,
    input  wire          serial_rts,
    output reg           serial_tx,
    input  wire          serial_rx,
    output wire   [13:0] ddram_a,
    output wire    [1:0] ddram_ba,
    output wire          ddram_bg,
    output wire          ddram_ras_n,
    output wire          ddram_cas_n,
    output wire          ddram_we_n,
    output wire          ddram_cs_n,
    output wire          ddram_act_n,
    output wire    [7:0] ddram_dm,
    inout  wire   [63:0] ddram_dq,
    inout  wire    [7:0] ddram_dqs_p,
    inout  wire    [7:0] ddram_dqs_n,
    output wire          ddram_clk_p,
    output wire          ddram_clk_n,
    output wire          ddram_cke,
    output wire          ddram_odt,
    output wire          ddram_reset_n,
    output wire          sfp0_txp,
    output wire          sfp0_txn,
    input  wire          sfp0_rxp,
    input  wire          sfp0_rxn,
    output wire          sfp_tx_disable_n0,
    output wire          user_led0,
    output wire          user_led1,
    output wire          user_led2,
    output wire          user_led3,
    output wire          user_led4,
    output wire          user_led5,
    output wire          user_led6,
    output wire          user_led7,
    output wire          sdcard_clk,
    inout  wire          sdcard_cmd,
    inout  wire    [3:0] sdcard_data
);


//------------------------------------------------------------------------------
// Signals
//------------------------------------------------------------------------------

reg           main_crg_rst = 1'd0;
(* dont_touch = "true" *)
wire          sys_clk;
reg           sys_rst = 1'd0;
wire          sys4x_clk;
wire          pll4x_clk;
wire          idelay_clk;
wire          idelay_rst;
wire          eth_clk;
wire          eth_rst;
wire          main_crg_reset;
reg           main_crg_power_down = 1'd0;
wire          main_crg_locked;
(* dont_touch = "true" *)
wire          main_crg_clkin;
wire          main_crg_clkout0;
wire          main_crg_clkout1;
wire          main_crg_clkout_buf0;
wire          main_crg_clkout2;
wire          main_crg_clkout_buf1;
wire          ic_clk;
wire          ic_rst;
reg     [5:0] main_crg_idelayctrl_ic_reset_counter = 6'd63;
reg           main_crg_idelayctrl_ic_reset = 1'd1;
reg     [5:0] main_crg_idelayctrl_ic_ready_counter = 6'd63;
wire          main_crg_idelayctrl_ic_ready;
reg           main_soc_rst = 1'd0;
wire          main_cpu_rst;
reg     [1:0] main_reset_storage = 2'd0;
reg           main_reset_re = 1'd0;
reg    [31:0] main_scratch_storage = 32'd305419896;
reg           main_scratch_re = 1'd0;
wire   [31:0] main_bus_errors_status;
wire          main_bus_errors_we;
reg           main_bus_errors_re = 1'd0;
wire          main_bus_error;
reg    [31:0] main_bus_errors = 32'd0;
wire          main_cpu_reset;
reg           main_cpu_jtag_clk = 1'd0;
reg           main_cpu_jtag_enable = 1'd0;
reg           main_cpu_jtag_capture = 1'd0;
reg           main_cpu_jtag_shift = 1'd0;
reg           main_cpu_jtag_update = 1'd0;
reg           main_cpu_jtag_reset = 1'd0;
wire          main_cpu_jtag_tdo;
reg           main_cpu_jtag_tdi = 1'd0;
reg    [31:0] main_cpu_interrupt = 32'd0;
wire   [29:0] main_cpu_pbus_adr;
wire   [31:0] main_cpu_pbus_dat_w;
wire   [31:0] main_cpu_pbus_dat_r;
wire    [3:0] main_cpu_pbus_sel;
wire          main_cpu_pbus_cyc;
wire          main_cpu_pbus_stb;
wire          main_cpu_pbus_ack;
wire          main_cpu_pbus_we;
wire    [2:0] main_cpu_pbus_cti;
wire    [1:0] main_cpu_pbus_bte;
wire          main_cpu_pbus_err;
reg    [29:0] main_cpu_dma_bus_adr = 30'd0;
reg    [63:0] main_cpu_dma_bus_dat_w = 64'd0;
wire   [63:0] main_cpu_dma_bus_dat_r;
reg     [7:0] main_cpu_dma_bus_sel = 8'd0;
wire          main_cpu_dma_bus_cyc;
wire          main_cpu_dma_bus_stb;
wire          main_cpu_dma_bus_ack;
wire          main_cpu_dma_bus_we;
wire    [2:0] main_cpu_dma_bus_cti;
wire    [1:0] main_cpu_dma_bus_bte;
reg           main_cpu_dma_bus_err = 1'd0;
wire          main_cpu_dma_bus_stall;
reg           main_cpu_dma_bus_inhibit = 1'd0;
wire   [29:0] main_dma_bus_dma_bus_adr;
wire   [31:0] main_dma_bus_dma_bus_dat_w;
reg    [31:0] main_dma_bus_dma_bus_dat_r = 32'd0;
wire    [3:0] main_dma_bus_dma_bus_sel;
wire          main_dma_bus_dma_bus_cyc;
wire          main_dma_bus_dma_bus_stb;
wire          main_dma_bus_dma_bus_ack;
wire          main_dma_bus_dma_bus_we;
wire    [2:0] main_dma_bus_dma_bus_cti;
wire    [1:0] main_dma_bus_dma_bus_bte;
wire          main_dma_bus_dma_bus_err;
wire   [29:0] main_plicbus_adr;
wire   [31:0] main_plicbus_dat_w;
wire   [31:0] main_plicbus_dat_r;
wire    [3:0] main_plicbus_sel;
wire          main_plicbus_cyc;
wire          main_plicbus_stb;
wire          main_plicbus_ack;
wire          main_plicbus_we;
wire    [2:0] main_plicbus_cti;
wire    [1:0] main_plicbus_bte;
reg           main_plicbus_err = 1'd0;
wire   [29:0] main_clintbus_adr;
wire   [31:0] main_clintbus_dat_w;
wire   [31:0] main_clintbus_dat_r;
wire    [3:0] main_clintbus_sel;
wire          main_clintbus_cyc;
wire          main_clintbus_stb;
wire          main_clintbus_ack;
wire          main_clintbus_we;
wire    [2:0] main_clintbus_cti;
wire    [1:0] main_clintbus_bte;
reg           main_clintbus_err = 1'd0;
wire   [29:0] main_soclinux_ram_bus_adr;
wire   [31:0] main_soclinux_ram_bus_dat_w;
wire   [31:0] main_soclinux_ram_bus_dat_r;
wire    [3:0] main_soclinux_ram_bus_sel;
wire          main_soclinux_ram_bus_cyc;
wire          main_soclinux_ram_bus_stb;
reg           main_soclinux_ram_bus_ack = 1'd0;
wire          main_soclinux_ram_bus_we;
wire    [2:0] main_soclinux_ram_bus_cti;
wire    [1:0] main_soclinux_ram_bus_bte;
reg           main_soclinux_ram_bus_err = 1'd0;
reg           main_soclinux_adr_burst = 1'd0;
wire   [13:0] main_soclinux_adr;
wire   [31:0] main_soclinux_dat_r;
wire   [29:0] main_ram_bus_ram_bus_adr;
wire   [31:0] main_ram_bus_ram_bus_dat_w;
wire   [31:0] main_ram_bus_ram_bus_dat_r;
wire    [3:0] main_ram_bus_ram_bus_sel;
wire          main_ram_bus_ram_bus_cyc;
wire          main_ram_bus_ram_bus_stb;
reg           main_ram_bus_ram_bus_ack = 1'd0;
wire          main_ram_bus_ram_bus_we;
wire    [2:0] main_ram_bus_ram_bus_cti;
wire    [1:0] main_ram_bus_ram_bus_bte;
reg           main_ram_bus_ram_bus_err = 1'd0;
reg           main_ram_adr_burst = 1'd0;
wire   [10:0] main_ram_adr;
wire   [31:0] main_ram_dat_r;
reg     [3:0] main_ram_we = 4'd0;
wire   [31:0] main_ram_dat_w;
wire          main_tx_sink_valid;
reg           main_tx_sink_ready = 1'd0;
wire          main_tx_sink_first;
wire          main_tx_sink_last;
wire    [7:0] main_tx_sink_payload_data;
reg     [7:0] main_tx_data = 8'd0;
reg     [3:0] main_tx_count = 4'd0;
reg           main_tx_enable = 1'd0;
reg           main_tx_tick = 1'd0;
reg    [31:0] main_tx_phase = 32'd0;
reg           main_rx_source_valid = 1'd0;
wire          main_rx_source_ready;
reg           main_rx_source_first = 1'd0;
reg           main_rx_source_last = 1'd0;
reg     [7:0] main_rx_source_payload_data = 8'd0;
reg     [7:0] main_rx_data = 8'd0;
reg     [3:0] main_rx_count = 4'd0;
reg           main_rx_enable = 1'd0;
reg           main_rx_tick = 1'd0;
reg    [31:0] main_rx_phase = 32'd0;
wire          main_rx_rx;
reg           main_rx_rx_d = 1'd0;
reg           main_uart_rxtx_re = 1'd0;
wire    [7:0] main_uart_rxtx_r;
reg           main_uart_rxtx_we = 1'd0;
wire    [7:0] main_uart_rxtx_w;
wire          main_uart_txfull_status;
wire          main_uart_txfull_we;
reg           main_uart_txfull_re = 1'd0;
wire          main_uart_rxempty_status;
wire          main_uart_rxempty_we;
reg           main_uart_rxempty_re = 1'd0;
wire          main_uart_irq;
wire          main_uart_tx_status;
reg           main_uart_tx_pending = 1'd0;
wire          main_uart_tx_trigger;
reg           main_uart_tx_clear = 1'd0;
reg           main_uart_tx_trigger_d = 1'd0;
wire          main_uart_rx_status;
reg           main_uart_rx_pending = 1'd0;
wire          main_uart_rx_trigger;
reg           main_uart_rx_clear = 1'd0;
reg           main_uart_rx_trigger_d = 1'd0;
wire          main_uart_tx0;
wire          main_uart_rx0;
reg     [1:0] main_uart_status_status = 2'd0;
wire          main_uart_status_we;
reg           main_uart_status_re = 1'd0;
wire          main_uart_tx1;
wire          main_uart_rx1;
reg     [1:0] main_uart_pending_status = 2'd0;
wire          main_uart_pending_we;
reg           main_uart_pending_re = 1'd0;
reg     [1:0] main_uart_pending_r = 2'd0;
wire          main_uart_tx2;
wire          main_uart_rx2;
reg     [1:0] main_uart_enable_storage = 2'd0;
reg           main_uart_enable_re = 1'd0;
wire          main_uart_txempty_status;
wire          main_uart_txempty_we;
reg           main_uart_txempty_re = 1'd0;
wire          main_uart_rxfull_status;
wire          main_uart_rxfull_we;
reg           main_uart_rxfull_re = 1'd0;
wire          main_uart_uart_sink_valid;
wire          main_uart_uart_sink_ready;
wire          main_uart_uart_sink_first;
wire          main_uart_uart_sink_last;
wire    [7:0] main_uart_uart_sink_payload_data;
wire          main_uart_uart_source_valid;
wire          main_uart_uart_source_ready;
wire          main_uart_uart_source_first;
wire          main_uart_uart_source_last;
wire    [7:0] main_uart_uart_source_payload_data;
wire          main_uart_tx_fifo_sink_valid;
wire          main_uart_tx_fifo_sink_ready;
reg           main_uart_tx_fifo_sink_first = 1'd0;
reg           main_uart_tx_fifo_sink_last = 1'd0;
wire    [7:0] main_uart_tx_fifo_sink_payload_data;
wire          main_uart_tx_fifo_source_valid;
wire          main_uart_tx_fifo_source_ready;
wire          main_uart_tx_fifo_source_first;
wire          main_uart_tx_fifo_source_last;
wire    [7:0] main_uart_tx_fifo_source_payload_data;
wire          main_uart_tx_fifo_re;
reg           main_uart_tx_fifo_readable = 1'd0;
wire          main_uart_tx_fifo_syncfifo_we;
wire          main_uart_tx_fifo_syncfifo_writable;
wire          main_uart_tx_fifo_syncfifo_re;
wire          main_uart_tx_fifo_syncfifo_readable;
wire    [9:0] main_uart_tx_fifo_syncfifo_din;
wire    [9:0] main_uart_tx_fifo_syncfifo_dout;
reg     [4:0] main_uart_tx_fifo_level0 = 5'd0;
reg           main_uart_tx_fifo_replace = 1'd0;
reg     [3:0] main_uart_tx_fifo_produce = 4'd0;
reg     [3:0] main_uart_tx_fifo_consume = 4'd0;
reg     [3:0] main_uart_tx_fifo_wrport_adr = 4'd0;
wire    [9:0] main_uart_tx_fifo_wrport_dat_r;
wire          main_uart_tx_fifo_wrport_we;
wire    [9:0] main_uart_tx_fifo_wrport_dat_w;
wire          main_uart_tx_fifo_do_read;
wire    [3:0] main_uart_tx_fifo_rdport_adr;
wire    [9:0] main_uart_tx_fifo_rdport_dat_r;
wire          main_uart_tx_fifo_rdport_re;
wire    [4:0] main_uart_tx_fifo_level1;
wire    [7:0] main_uart_tx_fifo_fifo_in_payload_data;
wire          main_uart_tx_fifo_fifo_in_first;
wire          main_uart_tx_fifo_fifo_in_last;
wire    [7:0] main_uart_tx_fifo_fifo_out_payload_data;
wire          main_uart_tx_fifo_fifo_out_first;
wire          main_uart_tx_fifo_fifo_out_last;
wire          main_uart_rx_fifo_sink_valid;
wire          main_uart_rx_fifo_sink_ready;
wire          main_uart_rx_fifo_sink_first;
wire          main_uart_rx_fifo_sink_last;
wire    [7:0] main_uart_rx_fifo_sink_payload_data;
wire          main_uart_rx_fifo_source_valid;
wire          main_uart_rx_fifo_source_ready;
wire          main_uart_rx_fifo_source_first;
wire          main_uart_rx_fifo_source_last;
wire    [7:0] main_uart_rx_fifo_source_payload_data;
wire          main_uart_rx_fifo_re;
reg           main_uart_rx_fifo_readable = 1'd0;
wire          main_uart_rx_fifo_syncfifo_we;
wire          main_uart_rx_fifo_syncfifo_writable;
wire          main_uart_rx_fifo_syncfifo_re;
wire          main_uart_rx_fifo_syncfifo_readable;
wire    [9:0] main_uart_rx_fifo_syncfifo_din;
wire    [9:0] main_uart_rx_fifo_syncfifo_dout;
reg     [4:0] main_uart_rx_fifo_level0 = 5'd0;
reg           main_uart_rx_fifo_replace = 1'd0;
reg     [3:0] main_uart_rx_fifo_produce = 4'd0;
reg     [3:0] main_uart_rx_fifo_consume = 4'd0;
reg     [3:0] main_uart_rx_fifo_wrport_adr = 4'd0;
wire    [9:0] main_uart_rx_fifo_wrport_dat_r;
wire          main_uart_rx_fifo_wrport_we;
wire    [9:0] main_uart_rx_fifo_wrport_dat_w;
wire          main_uart_rx_fifo_do_read;
wire    [3:0] main_uart_rx_fifo_rdport_adr;
wire    [9:0] main_uart_rx_fifo_rdport_dat_r;
wire          main_uart_rx_fifo_rdport_re;
wire    [4:0] main_uart_rx_fifo_level1;
wire    [7:0] main_uart_rx_fifo_fifo_in_payload_data;
wire          main_uart_rx_fifo_fifo_in_first;
wire          main_uart_rx_fifo_fifo_in_last;
wire    [7:0] main_uart_rx_fifo_fifo_out_payload_data;
wire          main_uart_rx_fifo_fifo_out_first;
wire          main_uart_rx_fifo_fifo_out_last;
reg    [31:0] main_timer_load_storage = 32'd0;
reg           main_timer_load_re = 1'd0;
reg    [31:0] main_timer_reload_storage = 32'd0;
reg           main_timer_reload_re = 1'd0;
reg           main_timer_en_storage = 1'd0;
reg           main_timer_en_re = 1'd0;
reg           main_timer_update_value_storage = 1'd0;
reg           main_timer_update_value_re = 1'd0;
reg    [31:0] main_timer_value_status = 32'd0;
wire          main_timer_value_we;
reg           main_timer_value_re = 1'd0;
wire          main_timer_irq;
wire          main_timer_zero_status;
reg           main_timer_zero_pending = 1'd0;
wire          main_timer_zero_trigger;
reg           main_timer_zero_clear = 1'd0;
reg           main_timer_zero_trigger_d = 1'd0;
wire          main_timer_zero0;
wire          main_timer_status_status;
wire          main_timer_status_we;
reg           main_timer_status_re = 1'd0;
wire          main_timer_zero1;
wire          main_timer_pending_status;
wire          main_timer_pending_we;
reg           main_timer_pending_re = 1'd0;
reg           main_timer_pending_r = 1'd0;
wire          main_timer_zero2;
reg           main_timer_enable_storage = 1'd0;
reg           main_timer_enable_re = 1'd0;
reg    [31:0] main_timer_value = 32'd0;
reg           main_usddrphy_rst_storage = 1'd0;
reg           main_usddrphy_rst_re = 1'd0;
reg           main_usddrphy_en_vtc_storage = 1'd1;
reg           main_usddrphy_en_vtc_re = 1'd0;
wire    [8:0] main_usddrphy_half_sys8x_taps_status;
wire          main_usddrphy_half_sys8x_taps_we;
reg           main_usddrphy_half_sys8x_taps_re = 1'd0;
reg           main_usddrphy_wlevel_en_storage = 1'd0;
reg           main_usddrphy_wlevel_en_re = 1'd0;
reg           main_usddrphy_wlevel_strobe_re = 1'd0;
wire          main_usddrphy_wlevel_strobe_r;
reg           main_usddrphy_wlevel_strobe_we = 1'd0;
reg           main_usddrphy_wlevel_strobe_w = 1'd0;
reg           main_usddrphy_cdly_rst_re = 1'd0;
wire          main_usddrphy_cdly_rst_r;
reg           main_usddrphy_cdly_rst_we = 1'd0;
reg           main_usddrphy_cdly_rst_w = 1'd0;
reg           main_usddrphy_cdly_inc_re = 1'd0;
wire          main_usddrphy_cdly_inc_r;
reg           main_usddrphy_cdly_inc_we = 1'd0;
reg           main_usddrphy_cdly_inc_w = 1'd0;
wire    [8:0] main_usddrphy_cdly_value_status;
wire          main_usddrphy_cdly_value_we;
reg           main_usddrphy_cdly_value_re = 1'd0;
reg     [7:0] main_usddrphy_dly_sel_storage = 8'd0;
reg           main_usddrphy_dly_sel_re = 1'd0;
reg           main_usddrphy_rdly_dq_rst_re = 1'd0;
wire          main_usddrphy_rdly_dq_rst_r;
reg           main_usddrphy_rdly_dq_rst_we = 1'd0;
reg           main_usddrphy_rdly_dq_rst_w = 1'd0;
reg           main_usddrphy_rdly_dq_inc_re = 1'd0;
wire          main_usddrphy_rdly_dq_inc_r;
reg           main_usddrphy_rdly_dq_inc_we = 1'd0;
reg           main_usddrphy_rdly_dq_inc_w = 1'd0;
reg           main_usddrphy_rdly_dq_bitslip_rst_re = 1'd0;
wire          main_usddrphy_rdly_dq_bitslip_rst_r;
reg           main_usddrphy_rdly_dq_bitslip_rst_we = 1'd0;
reg           main_usddrphy_rdly_dq_bitslip_rst_w = 1'd0;
reg           main_usddrphy_rdly_dq_bitslip_re = 1'd0;
wire          main_usddrphy_rdly_dq_bitslip_r;
reg           main_usddrphy_rdly_dq_bitslip_we = 1'd0;
reg           main_usddrphy_rdly_dq_bitslip_w = 1'd0;
reg           main_usddrphy_wdly_dq_rst_re = 1'd0;
wire          main_usddrphy_wdly_dq_rst_r;
reg           main_usddrphy_wdly_dq_rst_we = 1'd0;
reg           main_usddrphy_wdly_dq_rst_w = 1'd0;
reg           main_usddrphy_wdly_dq_inc_re = 1'd0;
wire          main_usddrphy_wdly_dq_inc_r;
reg           main_usddrphy_wdly_dq_inc_we = 1'd0;
reg           main_usddrphy_wdly_dq_inc_w = 1'd0;
reg           main_usddrphy_wdly_dqs_rst_re = 1'd0;
wire          main_usddrphy_wdly_dqs_rst_r;
reg           main_usddrphy_wdly_dqs_rst_we = 1'd0;
reg           main_usddrphy_wdly_dqs_rst_w = 1'd0;
reg           main_usddrphy_wdly_dqs_inc_re = 1'd0;
wire          main_usddrphy_wdly_dqs_inc_r;
reg           main_usddrphy_wdly_dqs_inc_we = 1'd0;
reg           main_usddrphy_wdly_dqs_inc_w = 1'd0;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count_status = 9'd0;
wire          main_usddrphy_wdly_dqs_inc_count_we;
reg           main_usddrphy_wdly_dqs_inc_count_re = 1'd0;
reg           main_usddrphy_wdly_dq_bitslip_rst_re = 1'd0;
wire          main_usddrphy_wdly_dq_bitslip_rst_r;
reg           main_usddrphy_wdly_dq_bitslip_rst_we = 1'd0;
reg           main_usddrphy_wdly_dq_bitslip_rst_w = 1'd0;
reg           main_usddrphy_wdly_dq_bitslip_re = 1'd0;
wire          main_usddrphy_wdly_dq_bitslip_r;
reg           main_usddrphy_wdly_dq_bitslip_we = 1'd0;
reg           main_usddrphy_wdly_dq_bitslip_w = 1'd0;
reg     [1:0] main_usddrphy_rdphase_storage = 2'd3;
reg           main_usddrphy_rdphase_re = 1'd0;
reg     [1:0] main_usddrphy_wrphase_storage = 2'd3;
reg           main_usddrphy_wrphase_re = 1'd0;
wire   [16:0] main_usddrphy_interface0_dfi_p0_address;
wire    [2:0] main_usddrphy_interface0_dfi_p0_bank;
wire          main_usddrphy_interface0_dfi_p0_cas_n;
wire          main_usddrphy_interface0_dfi_p0_cs_n;
wire          main_usddrphy_interface0_dfi_p0_ras_n;
wire          main_usddrphy_interface0_dfi_p0_we_n;
wire          main_usddrphy_interface0_dfi_p0_cke;
wire          main_usddrphy_interface0_dfi_p0_odt;
wire          main_usddrphy_interface0_dfi_p0_reset_n;
wire          main_usddrphy_interface0_dfi_p0_act_n;
wire  [127:0] main_usddrphy_interface0_dfi_p0_wrdata;
wire          main_usddrphy_interface0_dfi_p0_wrdata_en;
wire   [15:0] main_usddrphy_interface0_dfi_p0_wrdata_mask;
wire          main_usddrphy_interface0_dfi_p0_rddata_en;
wire  [127:0] main_usddrphy_interface0_dfi_p0_rddata;
wire          main_usddrphy_interface0_dfi_p0_rddata_valid;
wire   [16:0] main_usddrphy_interface0_dfi_p1_address;
wire    [2:0] main_usddrphy_interface0_dfi_p1_bank;
wire          main_usddrphy_interface0_dfi_p1_cas_n;
wire          main_usddrphy_interface0_dfi_p1_cs_n;
wire          main_usddrphy_interface0_dfi_p1_ras_n;
wire          main_usddrphy_interface0_dfi_p1_we_n;
wire          main_usddrphy_interface0_dfi_p1_cke;
wire          main_usddrphy_interface0_dfi_p1_odt;
wire          main_usddrphy_interface0_dfi_p1_reset_n;
wire          main_usddrphy_interface0_dfi_p1_act_n;
wire  [127:0] main_usddrphy_interface0_dfi_p1_wrdata;
wire          main_usddrphy_interface0_dfi_p1_wrdata_en;
wire   [15:0] main_usddrphy_interface0_dfi_p1_wrdata_mask;
wire          main_usddrphy_interface0_dfi_p1_rddata_en;
wire  [127:0] main_usddrphy_interface0_dfi_p1_rddata;
wire          main_usddrphy_interface0_dfi_p1_rddata_valid;
wire   [16:0] main_usddrphy_interface0_dfi_p2_address;
wire    [2:0] main_usddrphy_interface0_dfi_p2_bank;
wire          main_usddrphy_interface0_dfi_p2_cas_n;
wire          main_usddrphy_interface0_dfi_p2_cs_n;
wire          main_usddrphy_interface0_dfi_p2_ras_n;
wire          main_usddrphy_interface0_dfi_p2_we_n;
wire          main_usddrphy_interface0_dfi_p2_cke;
wire          main_usddrphy_interface0_dfi_p2_odt;
wire          main_usddrphy_interface0_dfi_p2_reset_n;
wire          main_usddrphy_interface0_dfi_p2_act_n;
wire  [127:0] main_usddrphy_interface0_dfi_p2_wrdata;
wire          main_usddrphy_interface0_dfi_p2_wrdata_en;
wire   [15:0] main_usddrphy_interface0_dfi_p2_wrdata_mask;
wire          main_usddrphy_interface0_dfi_p2_rddata_en;
wire  [127:0] main_usddrphy_interface0_dfi_p2_rddata;
wire          main_usddrphy_interface0_dfi_p2_rddata_valid;
wire   [16:0] main_usddrphy_interface0_dfi_p3_address;
wire    [2:0] main_usddrphy_interface0_dfi_p3_bank;
wire          main_usddrphy_interface0_dfi_p3_cas_n;
wire          main_usddrphy_interface0_dfi_p3_cs_n;
wire          main_usddrphy_interface0_dfi_p3_ras_n;
wire          main_usddrphy_interface0_dfi_p3_we_n;
wire          main_usddrphy_interface0_dfi_p3_cke;
wire          main_usddrphy_interface0_dfi_p3_odt;
wire          main_usddrphy_interface0_dfi_p3_reset_n;
wire          main_usddrphy_interface0_dfi_p3_act_n;
wire  [127:0] main_usddrphy_interface0_dfi_p3_wrdata;
wire          main_usddrphy_interface0_dfi_p3_wrdata_en;
wire   [15:0] main_usddrphy_interface0_dfi_p3_wrdata_mask;
wire          main_usddrphy_interface0_dfi_p3_rddata_en;
wire  [127:0] main_usddrphy_interface0_dfi_p3_rddata;
wire          main_usddrphy_interface0_dfi_p3_rddata_valid;
wire   [16:0] main_usddrphy_interface1_dfi_p0_address;
wire    [2:0] main_usddrphy_interface1_dfi_p0_bank;
reg           main_usddrphy_interface1_dfi_p0_cas_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p0_cs_n;
reg           main_usddrphy_interface1_dfi_p0_ras_n = 1'd1;
reg           main_usddrphy_interface1_dfi_p0_we_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p0_cke;
wire          main_usddrphy_interface1_dfi_p0_odt;
wire          main_usddrphy_interface1_dfi_p0_reset_n;
reg           main_usddrphy_interface1_dfi_p0_act_n = 1'd1;
wire  [127:0] main_usddrphy_interface1_dfi_p0_wrdata;
wire          main_usddrphy_interface1_dfi_p0_wrdata_en;
wire   [15:0] main_usddrphy_interface1_dfi_p0_wrdata_mask;
wire          main_usddrphy_interface1_dfi_p0_rddata_en;
reg   [127:0] main_usddrphy_interface1_dfi_p0_rddata = 128'd0;
wire          main_usddrphy_interface1_dfi_p0_rddata_valid;
wire   [16:0] main_usddrphy_interface1_dfi_p1_address;
wire    [2:0] main_usddrphy_interface1_dfi_p1_bank;
reg           main_usddrphy_interface1_dfi_p1_cas_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p1_cs_n;
reg           main_usddrphy_interface1_dfi_p1_ras_n = 1'd1;
reg           main_usddrphy_interface1_dfi_p1_we_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p1_cke;
wire          main_usddrphy_interface1_dfi_p1_odt;
wire          main_usddrphy_interface1_dfi_p1_reset_n;
reg           main_usddrphy_interface1_dfi_p1_act_n = 1'd1;
wire  [127:0] main_usddrphy_interface1_dfi_p1_wrdata;
wire          main_usddrphy_interface1_dfi_p1_wrdata_en;
wire   [15:0] main_usddrphy_interface1_dfi_p1_wrdata_mask;
wire          main_usddrphy_interface1_dfi_p1_rddata_en;
reg   [127:0] main_usddrphy_interface1_dfi_p1_rddata = 128'd0;
wire          main_usddrphy_interface1_dfi_p1_rddata_valid;
wire   [16:0] main_usddrphy_interface1_dfi_p2_address;
wire    [2:0] main_usddrphy_interface1_dfi_p2_bank;
reg           main_usddrphy_interface1_dfi_p2_cas_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p2_cs_n;
reg           main_usddrphy_interface1_dfi_p2_ras_n = 1'd1;
reg           main_usddrphy_interface1_dfi_p2_we_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p2_cke;
wire          main_usddrphy_interface1_dfi_p2_odt;
wire          main_usddrphy_interface1_dfi_p2_reset_n;
reg           main_usddrphy_interface1_dfi_p2_act_n = 1'd1;
wire  [127:0] main_usddrphy_interface1_dfi_p2_wrdata;
wire          main_usddrphy_interface1_dfi_p2_wrdata_en;
wire   [15:0] main_usddrphy_interface1_dfi_p2_wrdata_mask;
wire          main_usddrphy_interface1_dfi_p2_rddata_en;
reg   [127:0] main_usddrphy_interface1_dfi_p2_rddata = 128'd0;
wire          main_usddrphy_interface1_dfi_p2_rddata_valid;
wire   [16:0] main_usddrphy_interface1_dfi_p3_address;
wire    [2:0] main_usddrphy_interface1_dfi_p3_bank;
reg           main_usddrphy_interface1_dfi_p3_cas_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p3_cs_n;
reg           main_usddrphy_interface1_dfi_p3_ras_n = 1'd1;
reg           main_usddrphy_interface1_dfi_p3_we_n = 1'd1;
wire          main_usddrphy_interface1_dfi_p3_cke;
wire          main_usddrphy_interface1_dfi_p3_odt;
wire          main_usddrphy_interface1_dfi_p3_reset_n;
reg           main_usddrphy_interface1_dfi_p3_act_n = 1'd1;
wire  [127:0] main_usddrphy_interface1_dfi_p3_wrdata;
wire          main_usddrphy_interface1_dfi_p3_wrdata_en;
wire   [15:0] main_usddrphy_interface1_dfi_p3_wrdata_mask;
wire          main_usddrphy_interface1_dfi_p3_rddata_en;
reg   [127:0] main_usddrphy_interface1_dfi_p3_rddata = 128'd0;
wire          main_usddrphy_interface1_dfi_p3_rddata_valid;
wire          main_usddrphy_clk_o_nodelay;
wire          main_usddrphy_clk_o_delayed;
wire    [2:0] main_usddrphy_pads_ba;
wire          main_usddrphy_o_nodelay0;
wire          main_usddrphy_o_nodelay1;
wire          main_usddrphy_o_nodelay2;
wire          main_usddrphy_o_nodelay3;
wire          main_usddrphy_o_nodelay4;
wire          main_usddrphy_o_nodelay5;
wire          main_usddrphy_o_nodelay6;
wire          main_usddrphy_o_nodelay7;
wire          main_usddrphy_o_nodelay8;
wire          main_usddrphy_o_nodelay9;
wire          main_usddrphy_o_nodelay10;
wire          main_usddrphy_o_nodelay11;
wire          main_usddrphy_o_nodelay12;
wire          main_usddrphy_o_nodelay13;
wire          main_usddrphy_o_nodelay14;
wire          main_usddrphy_o_nodelay15;
wire          main_usddrphy_o_nodelay16;
wire          main_usddrphy_o_nodelay17;
wire          main_usddrphy_o_nodelay18;
wire          main_usddrphy_o_nodelay19;
wire          main_usddrphy_o_nodelay20;
wire          main_usddrphy_o_nodelay21;
wire          main_usddrphy_o_nodelay22;
wire          main_usddrphy_o_nodelay23;
wire          main_usddrphy_o_nodelay24;
reg           main_usddrphy_dqs_oe = 1'd0;
wire          main_usddrphy_dqs_preamble;
wire          main_usddrphy_dqs_postamble;
wire          main_usddrphy_dqs_oe_delay_tappeddelayline;
reg           main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline = 1'd0;
reg           main_usddrphy_dqspattern0 = 1'd0;
reg           main_usddrphy_dqspattern1 = 1'd0;
reg     [7:0] main_usddrphy_dqspattern_o = 8'd0;
reg     [7:0] main_usddrphy_bitslip00 = 8'd0;
reg     [2:0] main_usddrphy_bitslip0_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip0_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay0;
wire          main_usddrphy_dqs_delayed0;
wire          main_usddrphy_dqs_t0;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count0 = 9'd0;
reg     [7:0] main_usddrphy_bitslip10 = 8'd0;
reg     [2:0] main_usddrphy_bitslip1_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip1_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay1;
wire          main_usddrphy_dqs_delayed1;
wire          main_usddrphy_dqs_t1;
wire          main_usddrphy0;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count1 = 9'd0;
reg     [7:0] main_usddrphy_bitslip20 = 8'd0;
reg     [2:0] main_usddrphy_bitslip2_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip2_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay2;
wire          main_usddrphy_dqs_delayed2;
wire          main_usddrphy_dqs_t2;
wire          main_usddrphy1;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count2 = 9'd0;
reg     [7:0] main_usddrphy_bitslip30 = 8'd0;
reg     [2:0] main_usddrphy_bitslip3_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip3_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay3;
wire          main_usddrphy_dqs_delayed3;
wire          main_usddrphy_dqs_t3;
wire          main_usddrphy2;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count3 = 9'd0;
reg     [7:0] main_usddrphy_bitslip40 = 8'd0;
reg     [2:0] main_usddrphy_bitslip4_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip4_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay4;
wire          main_usddrphy_dqs_delayed4;
wire          main_usddrphy_dqs_t4;
wire          main_usddrphy3;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count4 = 9'd0;
reg     [7:0] main_usddrphy_bitslip50 = 8'd0;
reg     [2:0] main_usddrphy_bitslip5_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip5_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay5;
wire          main_usddrphy_dqs_delayed5;
wire          main_usddrphy_dqs_t5;
wire          main_usddrphy4;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count5 = 9'd0;
reg     [7:0] main_usddrphy_bitslip60 = 8'd0;
reg     [2:0] main_usddrphy_bitslip6_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip6_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay6;
wire          main_usddrphy_dqs_delayed6;
wire          main_usddrphy_dqs_t6;
wire          main_usddrphy5;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count6 = 9'd0;
reg     [7:0] main_usddrphy_bitslip70 = 8'd0;
reg     [2:0] main_usddrphy_bitslip7_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip7_r0 = 16'd0;
wire          main_usddrphy_dqs_nodelay7;
wire          main_usddrphy_dqs_delayed7;
wire          main_usddrphy_dqs_t7;
wire          main_usddrphy6;
reg     [8:0] main_usddrphy_wdly_dqs_inc_count7 = 9'd0;
wire          main_usddrphy_dm_o_nodelay0;
reg     [7:0] main_usddrphy_bitslip01 = 8'd0;
reg     [2:0] main_usddrphy_bitslip0_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip0_r1 = 16'd0;
wire          main_usddrphy_dm_o_nodelay1;
reg     [7:0] main_usddrphy_bitslip11 = 8'd0;
reg     [2:0] main_usddrphy_bitslip1_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip1_r1 = 16'd0;
wire          main_usddrphy_dm_o_nodelay2;
reg     [7:0] main_usddrphy_bitslip21 = 8'd0;
reg     [2:0] main_usddrphy_bitslip2_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip2_r1 = 16'd0;
wire          main_usddrphy_dm_o_nodelay3;
reg     [7:0] main_usddrphy_bitslip31 = 8'd0;
reg     [2:0] main_usddrphy_bitslip3_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip3_r1 = 16'd0;
wire          main_usddrphy_dm_o_nodelay4;
reg     [7:0] main_usddrphy_bitslip41 = 8'd0;
reg     [2:0] main_usddrphy_bitslip4_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip4_r1 = 16'd0;
wire          main_usddrphy_dm_o_nodelay5;
reg     [7:0] main_usddrphy_bitslip51 = 8'd0;
reg     [2:0] main_usddrphy_bitslip5_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip5_r1 = 16'd0;
wire          main_usddrphy_dm_o_nodelay6;
reg     [7:0] main_usddrphy_bitslip61 = 8'd0;
reg     [2:0] main_usddrphy_bitslip6_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip6_r1 = 16'd0;
wire          main_usddrphy_dm_o_nodelay7;
reg     [7:0] main_usddrphy_bitslip71 = 8'd0;
reg     [2:0] main_usddrphy_bitslip7_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip7_r1 = 16'd0;
wire          main_usddrphy_dq_oe;
wire          main_usddrphy_dq_oe_delay_tappeddelayline;
reg           main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline = 1'd0;
wire          main_usddrphy_dq_o_nodelay0;
wire          main_usddrphy_dq_o_delayed0;
wire          main_usddrphy_dq_i_nodelay0;
wire          main_usddrphy_dq_i_delayed0;
wire          main_usddrphy_dq_t0;
reg     [7:0] main_usddrphy_bitslip02 = 8'd0;
reg     [2:0] main_usddrphy_bitslip0_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip0_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip03;
reg     [7:0] main_usddrphy_bitslip04 = 8'd0;
reg     [2:0] main_usddrphy_bitslip0_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip0_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay1;
wire          main_usddrphy_dq_o_delayed1;
wire          main_usddrphy_dq_i_nodelay1;
wire          main_usddrphy_dq_i_delayed1;
wire          main_usddrphy_dq_t1;
reg     [7:0] main_usddrphy_bitslip12 = 8'd0;
reg     [2:0] main_usddrphy_bitslip1_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip1_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip13;
reg     [7:0] main_usddrphy_bitslip14 = 8'd0;
reg     [2:0] main_usddrphy_bitslip1_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip1_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay2;
wire          main_usddrphy_dq_o_delayed2;
wire          main_usddrphy_dq_i_nodelay2;
wire          main_usddrphy_dq_i_delayed2;
wire          main_usddrphy_dq_t2;
reg     [7:0] main_usddrphy_bitslip22 = 8'd0;
reg     [2:0] main_usddrphy_bitslip2_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip2_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip23;
reg     [7:0] main_usddrphy_bitslip24 = 8'd0;
reg     [2:0] main_usddrphy_bitslip2_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip2_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay3;
wire          main_usddrphy_dq_o_delayed3;
wire          main_usddrphy_dq_i_nodelay3;
wire          main_usddrphy_dq_i_delayed3;
wire          main_usddrphy_dq_t3;
reg     [7:0] main_usddrphy_bitslip32 = 8'd0;
reg     [2:0] main_usddrphy_bitslip3_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip3_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip33;
reg     [7:0] main_usddrphy_bitslip34 = 8'd0;
reg     [2:0] main_usddrphy_bitslip3_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip3_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay4;
wire          main_usddrphy_dq_o_delayed4;
wire          main_usddrphy_dq_i_nodelay4;
wire          main_usddrphy_dq_i_delayed4;
wire          main_usddrphy_dq_t4;
reg     [7:0] main_usddrphy_bitslip42 = 8'd0;
reg     [2:0] main_usddrphy_bitslip4_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip4_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip43;
reg     [7:0] main_usddrphy_bitslip44 = 8'd0;
reg     [2:0] main_usddrphy_bitslip4_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip4_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay5;
wire          main_usddrphy_dq_o_delayed5;
wire          main_usddrphy_dq_i_nodelay5;
wire          main_usddrphy_dq_i_delayed5;
wire          main_usddrphy_dq_t5;
reg     [7:0] main_usddrphy_bitslip52 = 8'd0;
reg     [2:0] main_usddrphy_bitslip5_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip5_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip53;
reg     [7:0] main_usddrphy_bitslip54 = 8'd0;
reg     [2:0] main_usddrphy_bitslip5_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip5_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay6;
wire          main_usddrphy_dq_o_delayed6;
wire          main_usddrphy_dq_i_nodelay6;
wire          main_usddrphy_dq_i_delayed6;
wire          main_usddrphy_dq_t6;
reg     [7:0] main_usddrphy_bitslip62 = 8'd0;
reg     [2:0] main_usddrphy_bitslip6_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip6_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip63;
reg     [7:0] main_usddrphy_bitslip64 = 8'd0;
reg     [2:0] main_usddrphy_bitslip6_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip6_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay7;
wire          main_usddrphy_dq_o_delayed7;
wire          main_usddrphy_dq_i_nodelay7;
wire          main_usddrphy_dq_i_delayed7;
wire          main_usddrphy_dq_t7;
reg     [7:0] main_usddrphy_bitslip72 = 8'd0;
reg     [2:0] main_usddrphy_bitslip7_value2 = 3'd7;
reg    [15:0] main_usddrphy_bitslip7_r2 = 16'd0;
wire    [7:0] main_usddrphy_bitslip73;
reg     [7:0] main_usddrphy_bitslip74 = 8'd0;
reg     [2:0] main_usddrphy_bitslip7_value3 = 3'd7;
reg    [15:0] main_usddrphy_bitslip7_r3 = 16'd0;
wire          main_usddrphy_dq_o_nodelay8;
wire          main_usddrphy_dq_o_delayed8;
wire          main_usddrphy_dq_i_nodelay8;
wire          main_usddrphy_dq_i_delayed8;
wire          main_usddrphy_dq_t8;
reg     [7:0] main_usddrphy_bitslip80 = 8'd0;
reg     [2:0] main_usddrphy_bitslip8_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip8_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip81;
reg     [7:0] main_usddrphy_bitslip82 = 8'd0;
reg     [2:0] main_usddrphy_bitslip8_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip8_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay9;
wire          main_usddrphy_dq_o_delayed9;
wire          main_usddrphy_dq_i_nodelay9;
wire          main_usddrphy_dq_i_delayed9;
wire          main_usddrphy_dq_t9;
reg     [7:0] main_usddrphy_bitslip90 = 8'd0;
reg     [2:0] main_usddrphy_bitslip9_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip9_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip91;
reg     [7:0] main_usddrphy_bitslip92 = 8'd0;
reg     [2:0] main_usddrphy_bitslip9_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip9_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay10;
wire          main_usddrphy_dq_o_delayed10;
wire          main_usddrphy_dq_i_nodelay10;
wire          main_usddrphy_dq_i_delayed10;
wire          main_usddrphy_dq_t10;
reg     [7:0] main_usddrphy_bitslip100 = 8'd0;
reg     [2:0] main_usddrphy_bitslip10_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip10_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip101;
reg     [7:0] main_usddrphy_bitslip102 = 8'd0;
reg     [2:0] main_usddrphy_bitslip10_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip10_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay11;
wire          main_usddrphy_dq_o_delayed11;
wire          main_usddrphy_dq_i_nodelay11;
wire          main_usddrphy_dq_i_delayed11;
wire          main_usddrphy_dq_t11;
reg     [7:0] main_usddrphy_bitslip110 = 8'd0;
reg     [2:0] main_usddrphy_bitslip11_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip11_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip111;
reg     [7:0] main_usddrphy_bitslip112 = 8'd0;
reg     [2:0] main_usddrphy_bitslip11_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip11_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay12;
wire          main_usddrphy_dq_o_delayed12;
wire          main_usddrphy_dq_i_nodelay12;
wire          main_usddrphy_dq_i_delayed12;
wire          main_usddrphy_dq_t12;
reg     [7:0] main_usddrphy_bitslip120 = 8'd0;
reg     [2:0] main_usddrphy_bitslip12_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip12_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip121;
reg     [7:0] main_usddrphy_bitslip122 = 8'd0;
reg     [2:0] main_usddrphy_bitslip12_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip12_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay13;
wire          main_usddrphy_dq_o_delayed13;
wire          main_usddrphy_dq_i_nodelay13;
wire          main_usddrphy_dq_i_delayed13;
wire          main_usddrphy_dq_t13;
reg     [7:0] main_usddrphy_bitslip130 = 8'd0;
reg     [2:0] main_usddrphy_bitslip13_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip13_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip131;
reg     [7:0] main_usddrphy_bitslip132 = 8'd0;
reg     [2:0] main_usddrphy_bitslip13_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip13_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay14;
wire          main_usddrphy_dq_o_delayed14;
wire          main_usddrphy_dq_i_nodelay14;
wire          main_usddrphy_dq_i_delayed14;
wire          main_usddrphy_dq_t14;
reg     [7:0] main_usddrphy_bitslip140 = 8'd0;
reg     [2:0] main_usddrphy_bitslip14_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip14_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip141;
reg     [7:0] main_usddrphy_bitslip142 = 8'd0;
reg     [2:0] main_usddrphy_bitslip14_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip14_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay15;
wire          main_usddrphy_dq_o_delayed15;
wire          main_usddrphy_dq_i_nodelay15;
wire          main_usddrphy_dq_i_delayed15;
wire          main_usddrphy_dq_t15;
reg     [7:0] main_usddrphy_bitslip150 = 8'd0;
reg     [2:0] main_usddrphy_bitslip15_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip15_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip151;
reg     [7:0] main_usddrphy_bitslip152 = 8'd0;
reg     [2:0] main_usddrphy_bitslip15_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip15_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay16;
wire          main_usddrphy_dq_o_delayed16;
wire          main_usddrphy_dq_i_nodelay16;
wire          main_usddrphy_dq_i_delayed16;
wire          main_usddrphy_dq_t16;
reg     [7:0] main_usddrphy_bitslip160 = 8'd0;
reg     [2:0] main_usddrphy_bitslip16_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip16_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip161;
reg     [7:0] main_usddrphy_bitslip162 = 8'd0;
reg     [2:0] main_usddrphy_bitslip16_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip16_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay17;
wire          main_usddrphy_dq_o_delayed17;
wire          main_usddrphy_dq_i_nodelay17;
wire          main_usddrphy_dq_i_delayed17;
wire          main_usddrphy_dq_t17;
reg     [7:0] main_usddrphy_bitslip170 = 8'd0;
reg     [2:0] main_usddrphy_bitslip17_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip17_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip171;
reg     [7:0] main_usddrphy_bitslip172 = 8'd0;
reg     [2:0] main_usddrphy_bitslip17_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip17_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay18;
wire          main_usddrphy_dq_o_delayed18;
wire          main_usddrphy_dq_i_nodelay18;
wire          main_usddrphy_dq_i_delayed18;
wire          main_usddrphy_dq_t18;
reg     [7:0] main_usddrphy_bitslip180 = 8'd0;
reg     [2:0] main_usddrphy_bitslip18_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip18_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip181;
reg     [7:0] main_usddrphy_bitslip182 = 8'd0;
reg     [2:0] main_usddrphy_bitslip18_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip18_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay19;
wire          main_usddrphy_dq_o_delayed19;
wire          main_usddrphy_dq_i_nodelay19;
wire          main_usddrphy_dq_i_delayed19;
wire          main_usddrphy_dq_t19;
reg     [7:0] main_usddrphy_bitslip190 = 8'd0;
reg     [2:0] main_usddrphy_bitslip19_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip19_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip191;
reg     [7:0] main_usddrphy_bitslip192 = 8'd0;
reg     [2:0] main_usddrphy_bitslip19_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip19_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay20;
wire          main_usddrphy_dq_o_delayed20;
wire          main_usddrphy_dq_i_nodelay20;
wire          main_usddrphy_dq_i_delayed20;
wire          main_usddrphy_dq_t20;
reg     [7:0] main_usddrphy_bitslip200 = 8'd0;
reg     [2:0] main_usddrphy_bitslip20_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip20_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip201;
reg     [7:0] main_usddrphy_bitslip202 = 8'd0;
reg     [2:0] main_usddrphy_bitslip20_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip20_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay21;
wire          main_usddrphy_dq_o_delayed21;
wire          main_usddrphy_dq_i_nodelay21;
wire          main_usddrphy_dq_i_delayed21;
wire          main_usddrphy_dq_t21;
reg     [7:0] main_usddrphy_bitslip210 = 8'd0;
reg     [2:0] main_usddrphy_bitslip21_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip21_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip211;
reg     [7:0] main_usddrphy_bitslip212 = 8'd0;
reg     [2:0] main_usddrphy_bitslip21_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip21_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay22;
wire          main_usddrphy_dq_o_delayed22;
wire          main_usddrphy_dq_i_nodelay22;
wire          main_usddrphy_dq_i_delayed22;
wire          main_usddrphy_dq_t22;
reg     [7:0] main_usddrphy_bitslip220 = 8'd0;
reg     [2:0] main_usddrphy_bitslip22_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip22_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip221;
reg     [7:0] main_usddrphy_bitslip222 = 8'd0;
reg     [2:0] main_usddrphy_bitslip22_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip22_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay23;
wire          main_usddrphy_dq_o_delayed23;
wire          main_usddrphy_dq_i_nodelay23;
wire          main_usddrphy_dq_i_delayed23;
wire          main_usddrphy_dq_t23;
reg     [7:0] main_usddrphy_bitslip230 = 8'd0;
reg     [2:0] main_usddrphy_bitslip23_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip23_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip231;
reg     [7:0] main_usddrphy_bitslip232 = 8'd0;
reg     [2:0] main_usddrphy_bitslip23_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip23_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay24;
wire          main_usddrphy_dq_o_delayed24;
wire          main_usddrphy_dq_i_nodelay24;
wire          main_usddrphy_dq_i_delayed24;
wire          main_usddrphy_dq_t24;
reg     [7:0] main_usddrphy_bitslip240 = 8'd0;
reg     [2:0] main_usddrphy_bitslip24_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip24_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip241;
reg     [7:0] main_usddrphy_bitslip242 = 8'd0;
reg     [2:0] main_usddrphy_bitslip24_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip24_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay25;
wire          main_usddrphy_dq_o_delayed25;
wire          main_usddrphy_dq_i_nodelay25;
wire          main_usddrphy_dq_i_delayed25;
wire          main_usddrphy_dq_t25;
reg     [7:0] main_usddrphy_bitslip250 = 8'd0;
reg     [2:0] main_usddrphy_bitslip25_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip25_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip251;
reg     [7:0] main_usddrphy_bitslip252 = 8'd0;
reg     [2:0] main_usddrphy_bitslip25_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip25_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay26;
wire          main_usddrphy_dq_o_delayed26;
wire          main_usddrphy_dq_i_nodelay26;
wire          main_usddrphy_dq_i_delayed26;
wire          main_usddrphy_dq_t26;
reg     [7:0] main_usddrphy_bitslip260 = 8'd0;
reg     [2:0] main_usddrphy_bitslip26_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip26_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip261;
reg     [7:0] main_usddrphy_bitslip262 = 8'd0;
reg     [2:0] main_usddrphy_bitslip26_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip26_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay27;
wire          main_usddrphy_dq_o_delayed27;
wire          main_usddrphy_dq_i_nodelay27;
wire          main_usddrphy_dq_i_delayed27;
wire          main_usddrphy_dq_t27;
reg     [7:0] main_usddrphy_bitslip270 = 8'd0;
reg     [2:0] main_usddrphy_bitslip27_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip27_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip271;
reg     [7:0] main_usddrphy_bitslip272 = 8'd0;
reg     [2:0] main_usddrphy_bitslip27_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip27_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay28;
wire          main_usddrphy_dq_o_delayed28;
wire          main_usddrphy_dq_i_nodelay28;
wire          main_usddrphy_dq_i_delayed28;
wire          main_usddrphy_dq_t28;
reg     [7:0] main_usddrphy_bitslip280 = 8'd0;
reg     [2:0] main_usddrphy_bitslip28_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip28_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip281;
reg     [7:0] main_usddrphy_bitslip282 = 8'd0;
reg     [2:0] main_usddrphy_bitslip28_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip28_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay29;
wire          main_usddrphy_dq_o_delayed29;
wire          main_usddrphy_dq_i_nodelay29;
wire          main_usddrphy_dq_i_delayed29;
wire          main_usddrphy_dq_t29;
reg     [7:0] main_usddrphy_bitslip290 = 8'd0;
reg     [2:0] main_usddrphy_bitslip29_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip29_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip291;
reg     [7:0] main_usddrphy_bitslip292 = 8'd0;
reg     [2:0] main_usddrphy_bitslip29_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip29_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay30;
wire          main_usddrphy_dq_o_delayed30;
wire          main_usddrphy_dq_i_nodelay30;
wire          main_usddrphy_dq_i_delayed30;
wire          main_usddrphy_dq_t30;
reg     [7:0] main_usddrphy_bitslip300 = 8'd0;
reg     [2:0] main_usddrphy_bitslip30_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip30_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip301;
reg     [7:0] main_usddrphy_bitslip302 = 8'd0;
reg     [2:0] main_usddrphy_bitslip30_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip30_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay31;
wire          main_usddrphy_dq_o_delayed31;
wire          main_usddrphy_dq_i_nodelay31;
wire          main_usddrphy_dq_i_delayed31;
wire          main_usddrphy_dq_t31;
reg     [7:0] main_usddrphy_bitslip310 = 8'd0;
reg     [2:0] main_usddrphy_bitslip31_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip31_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip311;
reg     [7:0] main_usddrphy_bitslip312 = 8'd0;
reg     [2:0] main_usddrphy_bitslip31_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip31_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay32;
wire          main_usddrphy_dq_o_delayed32;
wire          main_usddrphy_dq_i_nodelay32;
wire          main_usddrphy_dq_i_delayed32;
wire          main_usddrphy_dq_t32;
reg     [7:0] main_usddrphy_bitslip320 = 8'd0;
reg     [2:0] main_usddrphy_bitslip32_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip32_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip321;
reg     [7:0] main_usddrphy_bitslip322 = 8'd0;
reg     [2:0] main_usddrphy_bitslip32_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip32_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay33;
wire          main_usddrphy_dq_o_delayed33;
wire          main_usddrphy_dq_i_nodelay33;
wire          main_usddrphy_dq_i_delayed33;
wire          main_usddrphy_dq_t33;
reg     [7:0] main_usddrphy_bitslip330 = 8'd0;
reg     [2:0] main_usddrphy_bitslip33_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip33_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip331;
reg     [7:0] main_usddrphy_bitslip332 = 8'd0;
reg     [2:0] main_usddrphy_bitslip33_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip33_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay34;
wire          main_usddrphy_dq_o_delayed34;
wire          main_usddrphy_dq_i_nodelay34;
wire          main_usddrphy_dq_i_delayed34;
wire          main_usddrphy_dq_t34;
reg     [7:0] main_usddrphy_bitslip340 = 8'd0;
reg     [2:0] main_usddrphy_bitslip34_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip34_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip341;
reg     [7:0] main_usddrphy_bitslip342 = 8'd0;
reg     [2:0] main_usddrphy_bitslip34_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip34_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay35;
wire          main_usddrphy_dq_o_delayed35;
wire          main_usddrphy_dq_i_nodelay35;
wire          main_usddrphy_dq_i_delayed35;
wire          main_usddrphy_dq_t35;
reg     [7:0] main_usddrphy_bitslip350 = 8'd0;
reg     [2:0] main_usddrphy_bitslip35_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip35_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip351;
reg     [7:0] main_usddrphy_bitslip352 = 8'd0;
reg     [2:0] main_usddrphy_bitslip35_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip35_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay36;
wire          main_usddrphy_dq_o_delayed36;
wire          main_usddrphy_dq_i_nodelay36;
wire          main_usddrphy_dq_i_delayed36;
wire          main_usddrphy_dq_t36;
reg     [7:0] main_usddrphy_bitslip360 = 8'd0;
reg     [2:0] main_usddrphy_bitslip36_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip36_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip361;
reg     [7:0] main_usddrphy_bitslip362 = 8'd0;
reg     [2:0] main_usddrphy_bitslip36_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip36_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay37;
wire          main_usddrphy_dq_o_delayed37;
wire          main_usddrphy_dq_i_nodelay37;
wire          main_usddrphy_dq_i_delayed37;
wire          main_usddrphy_dq_t37;
reg     [7:0] main_usddrphy_bitslip370 = 8'd0;
reg     [2:0] main_usddrphy_bitslip37_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip37_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip371;
reg     [7:0] main_usddrphy_bitslip372 = 8'd0;
reg     [2:0] main_usddrphy_bitslip37_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip37_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay38;
wire          main_usddrphy_dq_o_delayed38;
wire          main_usddrphy_dq_i_nodelay38;
wire          main_usddrphy_dq_i_delayed38;
wire          main_usddrphy_dq_t38;
reg     [7:0] main_usddrphy_bitslip380 = 8'd0;
reg     [2:0] main_usddrphy_bitslip38_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip38_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip381;
reg     [7:0] main_usddrphy_bitslip382 = 8'd0;
reg     [2:0] main_usddrphy_bitslip38_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip38_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay39;
wire          main_usddrphy_dq_o_delayed39;
wire          main_usddrphy_dq_i_nodelay39;
wire          main_usddrphy_dq_i_delayed39;
wire          main_usddrphy_dq_t39;
reg     [7:0] main_usddrphy_bitslip390 = 8'd0;
reg     [2:0] main_usddrphy_bitslip39_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip39_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip391;
reg     [7:0] main_usddrphy_bitslip392 = 8'd0;
reg     [2:0] main_usddrphy_bitslip39_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip39_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay40;
wire          main_usddrphy_dq_o_delayed40;
wire          main_usddrphy_dq_i_nodelay40;
wire          main_usddrphy_dq_i_delayed40;
wire          main_usddrphy_dq_t40;
reg     [7:0] main_usddrphy_bitslip400 = 8'd0;
reg     [2:0] main_usddrphy_bitslip40_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip40_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip401;
reg     [7:0] main_usddrphy_bitslip402 = 8'd0;
reg     [2:0] main_usddrphy_bitslip40_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip40_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay41;
wire          main_usddrphy_dq_o_delayed41;
wire          main_usddrphy_dq_i_nodelay41;
wire          main_usddrphy_dq_i_delayed41;
wire          main_usddrphy_dq_t41;
reg     [7:0] main_usddrphy_bitslip410 = 8'd0;
reg     [2:0] main_usddrphy_bitslip41_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip41_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip411;
reg     [7:0] main_usddrphy_bitslip412 = 8'd0;
reg     [2:0] main_usddrphy_bitslip41_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip41_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay42;
wire          main_usddrphy_dq_o_delayed42;
wire          main_usddrphy_dq_i_nodelay42;
wire          main_usddrphy_dq_i_delayed42;
wire          main_usddrphy_dq_t42;
reg     [7:0] main_usddrphy_bitslip420 = 8'd0;
reg     [2:0] main_usddrphy_bitslip42_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip42_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip421;
reg     [7:0] main_usddrphy_bitslip422 = 8'd0;
reg     [2:0] main_usddrphy_bitslip42_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip42_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay43;
wire          main_usddrphy_dq_o_delayed43;
wire          main_usddrphy_dq_i_nodelay43;
wire          main_usddrphy_dq_i_delayed43;
wire          main_usddrphy_dq_t43;
reg     [7:0] main_usddrphy_bitslip430 = 8'd0;
reg     [2:0] main_usddrphy_bitslip43_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip43_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip431;
reg     [7:0] main_usddrphy_bitslip432 = 8'd0;
reg     [2:0] main_usddrphy_bitslip43_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip43_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay44;
wire          main_usddrphy_dq_o_delayed44;
wire          main_usddrphy_dq_i_nodelay44;
wire          main_usddrphy_dq_i_delayed44;
wire          main_usddrphy_dq_t44;
reg     [7:0] main_usddrphy_bitslip440 = 8'd0;
reg     [2:0] main_usddrphy_bitslip44_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip44_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip441;
reg     [7:0] main_usddrphy_bitslip442 = 8'd0;
reg     [2:0] main_usddrphy_bitslip44_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip44_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay45;
wire          main_usddrphy_dq_o_delayed45;
wire          main_usddrphy_dq_i_nodelay45;
wire          main_usddrphy_dq_i_delayed45;
wire          main_usddrphy_dq_t45;
reg     [7:0] main_usddrphy_bitslip450 = 8'd0;
reg     [2:0] main_usddrphy_bitslip45_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip45_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip451;
reg     [7:0] main_usddrphy_bitslip452 = 8'd0;
reg     [2:0] main_usddrphy_bitslip45_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip45_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay46;
wire          main_usddrphy_dq_o_delayed46;
wire          main_usddrphy_dq_i_nodelay46;
wire          main_usddrphy_dq_i_delayed46;
wire          main_usddrphy_dq_t46;
reg     [7:0] main_usddrphy_bitslip460 = 8'd0;
reg     [2:0] main_usddrphy_bitslip46_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip46_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip461;
reg     [7:0] main_usddrphy_bitslip462 = 8'd0;
reg     [2:0] main_usddrphy_bitslip46_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip46_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay47;
wire          main_usddrphy_dq_o_delayed47;
wire          main_usddrphy_dq_i_nodelay47;
wire          main_usddrphy_dq_i_delayed47;
wire          main_usddrphy_dq_t47;
reg     [7:0] main_usddrphy_bitslip470 = 8'd0;
reg     [2:0] main_usddrphy_bitslip47_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip47_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip471;
reg     [7:0] main_usddrphy_bitslip472 = 8'd0;
reg     [2:0] main_usddrphy_bitslip47_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip47_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay48;
wire          main_usddrphy_dq_o_delayed48;
wire          main_usddrphy_dq_i_nodelay48;
wire          main_usddrphy_dq_i_delayed48;
wire          main_usddrphy_dq_t48;
reg     [7:0] main_usddrphy_bitslip480 = 8'd0;
reg     [2:0] main_usddrphy_bitslip48_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip48_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip481;
reg     [7:0] main_usddrphy_bitslip482 = 8'd0;
reg     [2:0] main_usddrphy_bitslip48_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip48_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay49;
wire          main_usddrphy_dq_o_delayed49;
wire          main_usddrphy_dq_i_nodelay49;
wire          main_usddrphy_dq_i_delayed49;
wire          main_usddrphy_dq_t49;
reg     [7:0] main_usddrphy_bitslip490 = 8'd0;
reg     [2:0] main_usddrphy_bitslip49_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip49_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip491;
reg     [7:0] main_usddrphy_bitslip492 = 8'd0;
reg     [2:0] main_usddrphy_bitslip49_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip49_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay50;
wire          main_usddrphy_dq_o_delayed50;
wire          main_usddrphy_dq_i_nodelay50;
wire          main_usddrphy_dq_i_delayed50;
wire          main_usddrphy_dq_t50;
reg     [7:0] main_usddrphy_bitslip500 = 8'd0;
reg     [2:0] main_usddrphy_bitslip50_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip50_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip501;
reg     [7:0] main_usddrphy_bitslip502 = 8'd0;
reg     [2:0] main_usddrphy_bitslip50_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip50_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay51;
wire          main_usddrphy_dq_o_delayed51;
wire          main_usddrphy_dq_i_nodelay51;
wire          main_usddrphy_dq_i_delayed51;
wire          main_usddrphy_dq_t51;
reg     [7:0] main_usddrphy_bitslip510 = 8'd0;
reg     [2:0] main_usddrphy_bitslip51_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip51_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip511;
reg     [7:0] main_usddrphy_bitslip512 = 8'd0;
reg     [2:0] main_usddrphy_bitslip51_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip51_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay52;
wire          main_usddrphy_dq_o_delayed52;
wire          main_usddrphy_dq_i_nodelay52;
wire          main_usddrphy_dq_i_delayed52;
wire          main_usddrphy_dq_t52;
reg     [7:0] main_usddrphy_bitslip520 = 8'd0;
reg     [2:0] main_usddrphy_bitslip52_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip52_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip521;
reg     [7:0] main_usddrphy_bitslip522 = 8'd0;
reg     [2:0] main_usddrphy_bitslip52_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip52_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay53;
wire          main_usddrphy_dq_o_delayed53;
wire          main_usddrphy_dq_i_nodelay53;
wire          main_usddrphy_dq_i_delayed53;
wire          main_usddrphy_dq_t53;
reg     [7:0] main_usddrphy_bitslip530 = 8'd0;
reg     [2:0] main_usddrphy_bitslip53_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip53_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip531;
reg     [7:0] main_usddrphy_bitslip532 = 8'd0;
reg     [2:0] main_usddrphy_bitslip53_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip53_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay54;
wire          main_usddrphy_dq_o_delayed54;
wire          main_usddrphy_dq_i_nodelay54;
wire          main_usddrphy_dq_i_delayed54;
wire          main_usddrphy_dq_t54;
reg     [7:0] main_usddrphy_bitslip540 = 8'd0;
reg     [2:0] main_usddrphy_bitslip54_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip54_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip541;
reg     [7:0] main_usddrphy_bitslip542 = 8'd0;
reg     [2:0] main_usddrphy_bitslip54_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip54_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay55;
wire          main_usddrphy_dq_o_delayed55;
wire          main_usddrphy_dq_i_nodelay55;
wire          main_usddrphy_dq_i_delayed55;
wire          main_usddrphy_dq_t55;
reg     [7:0] main_usddrphy_bitslip550 = 8'd0;
reg     [2:0] main_usddrphy_bitslip55_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip55_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip551;
reg     [7:0] main_usddrphy_bitslip552 = 8'd0;
reg     [2:0] main_usddrphy_bitslip55_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip55_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay56;
wire          main_usddrphy_dq_o_delayed56;
wire          main_usddrphy_dq_i_nodelay56;
wire          main_usddrphy_dq_i_delayed56;
wire          main_usddrphy_dq_t56;
reg     [7:0] main_usddrphy_bitslip560 = 8'd0;
reg     [2:0] main_usddrphy_bitslip56_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip56_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip561;
reg     [7:0] main_usddrphy_bitslip562 = 8'd0;
reg     [2:0] main_usddrphy_bitslip56_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip56_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay57;
wire          main_usddrphy_dq_o_delayed57;
wire          main_usddrphy_dq_i_nodelay57;
wire          main_usddrphy_dq_i_delayed57;
wire          main_usddrphy_dq_t57;
reg     [7:0] main_usddrphy_bitslip570 = 8'd0;
reg     [2:0] main_usddrphy_bitslip57_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip57_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip571;
reg     [7:0] main_usddrphy_bitslip572 = 8'd0;
reg     [2:0] main_usddrphy_bitslip57_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip57_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay58;
wire          main_usddrphy_dq_o_delayed58;
wire          main_usddrphy_dq_i_nodelay58;
wire          main_usddrphy_dq_i_delayed58;
wire          main_usddrphy_dq_t58;
reg     [7:0] main_usddrphy_bitslip580 = 8'd0;
reg     [2:0] main_usddrphy_bitslip58_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip58_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip581;
reg     [7:0] main_usddrphy_bitslip582 = 8'd0;
reg     [2:0] main_usddrphy_bitslip58_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip58_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay59;
wire          main_usddrphy_dq_o_delayed59;
wire          main_usddrphy_dq_i_nodelay59;
wire          main_usddrphy_dq_i_delayed59;
wire          main_usddrphy_dq_t59;
reg     [7:0] main_usddrphy_bitslip590 = 8'd0;
reg     [2:0] main_usddrphy_bitslip59_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip59_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip591;
reg     [7:0] main_usddrphy_bitslip592 = 8'd0;
reg     [2:0] main_usddrphy_bitslip59_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip59_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay60;
wire          main_usddrphy_dq_o_delayed60;
wire          main_usddrphy_dq_i_nodelay60;
wire          main_usddrphy_dq_i_delayed60;
wire          main_usddrphy_dq_t60;
reg     [7:0] main_usddrphy_bitslip600 = 8'd0;
reg     [2:0] main_usddrphy_bitslip60_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip60_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip601;
reg     [7:0] main_usddrphy_bitslip602 = 8'd0;
reg     [2:0] main_usddrphy_bitslip60_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip60_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay61;
wire          main_usddrphy_dq_o_delayed61;
wire          main_usddrphy_dq_i_nodelay61;
wire          main_usddrphy_dq_i_delayed61;
wire          main_usddrphy_dq_t61;
reg     [7:0] main_usddrphy_bitslip610 = 8'd0;
reg     [2:0] main_usddrphy_bitslip61_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip61_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip611;
reg     [7:0] main_usddrphy_bitslip612 = 8'd0;
reg     [2:0] main_usddrphy_bitslip61_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip61_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay62;
wire          main_usddrphy_dq_o_delayed62;
wire          main_usddrphy_dq_i_nodelay62;
wire          main_usddrphy_dq_i_delayed62;
wire          main_usddrphy_dq_t62;
reg     [7:0] main_usddrphy_bitslip620 = 8'd0;
reg     [2:0] main_usddrphy_bitslip62_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip62_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip621;
reg     [7:0] main_usddrphy_bitslip622 = 8'd0;
reg     [2:0] main_usddrphy_bitslip62_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip62_r1 = 16'd0;
wire          main_usddrphy_dq_o_nodelay63;
wire          main_usddrphy_dq_o_delayed63;
wire          main_usddrphy_dq_i_nodelay63;
wire          main_usddrphy_dq_i_delayed63;
wire          main_usddrphy_dq_t63;
reg     [7:0] main_usddrphy_bitslip630 = 8'd0;
reg     [2:0] main_usddrphy_bitslip63_value0 = 3'd7;
reg    [15:0] main_usddrphy_bitslip63_r0 = 16'd0;
wire    [7:0] main_usddrphy_bitslip631;
reg     [7:0] main_usddrphy_bitslip632 = 8'd0;
reg     [2:0] main_usddrphy_bitslip63_value1 = 3'd7;
reg    [15:0] main_usddrphy_bitslip63_r1 = 16'd0;
reg           main_usddrphy_rddata_en_tappeddelayline0 = 1'd0;
reg           main_usddrphy_rddata_en_tappeddelayline1 = 1'd0;
reg           main_usddrphy_rddata_en_tappeddelayline2 = 1'd0;
reg           main_usddrphy_rddata_en_tappeddelayline3 = 1'd0;
reg           main_usddrphy_rddata_en_tappeddelayline4 = 1'd0;
reg           main_usddrphy_rddata_en_tappeddelayline5 = 1'd0;
reg           main_usddrphy_rddata_en_tappeddelayline6 = 1'd0;
reg           main_usddrphy_rddata_en_tappeddelayline7 = 1'd0;
reg           main_usddrphy_wrdata_en_tappeddelayline0 = 1'd0;
reg           main_usddrphy_wrdata_en_tappeddelayline1 = 1'd0;
reg           main_usddrphy_wrdata_en_tappeddelayline2 = 1'd0;
reg           main_usddrphy_wrdata_en_tappeddelayline3 = 1'd0;
wire   [14:0] main_sdram_slave_p0_address;
wire    [2:0] main_sdram_slave_p0_bank;
wire          main_sdram_slave_p0_cas_n;
wire          main_sdram_slave_p0_cs_n;
wire          main_sdram_slave_p0_ras_n;
wire          main_sdram_slave_p0_we_n;
wire          main_sdram_slave_p0_cke;
wire          main_sdram_slave_p0_odt;
wire          main_sdram_slave_p0_reset_n;
wire          main_sdram_slave_p0_act_n;
wire  [127:0] main_sdram_slave_p0_wrdata;
wire          main_sdram_slave_p0_wrdata_en;
wire   [15:0] main_sdram_slave_p0_wrdata_mask;
wire          main_sdram_slave_p0_rddata_en;
reg   [127:0] main_sdram_slave_p0_rddata = 128'd0;
reg           main_sdram_slave_p0_rddata_valid = 1'd0;
wire   [14:0] main_sdram_slave_p1_address;
wire    [2:0] main_sdram_slave_p1_bank;
wire          main_sdram_slave_p1_cas_n;
wire          main_sdram_slave_p1_cs_n;
wire          main_sdram_slave_p1_ras_n;
wire          main_sdram_slave_p1_we_n;
wire          main_sdram_slave_p1_cke;
wire          main_sdram_slave_p1_odt;
wire          main_sdram_slave_p1_reset_n;
wire          main_sdram_slave_p1_act_n;
wire  [127:0] main_sdram_slave_p1_wrdata;
wire          main_sdram_slave_p1_wrdata_en;
wire   [15:0] main_sdram_slave_p1_wrdata_mask;
wire          main_sdram_slave_p1_rddata_en;
reg   [127:0] main_sdram_slave_p1_rddata = 128'd0;
reg           main_sdram_slave_p1_rddata_valid = 1'd0;
wire   [14:0] main_sdram_slave_p2_address;
wire    [2:0] main_sdram_slave_p2_bank;
wire          main_sdram_slave_p2_cas_n;
wire          main_sdram_slave_p2_cs_n;
wire          main_sdram_slave_p2_ras_n;
wire          main_sdram_slave_p2_we_n;
wire          main_sdram_slave_p2_cke;
wire          main_sdram_slave_p2_odt;
wire          main_sdram_slave_p2_reset_n;
wire          main_sdram_slave_p2_act_n;
wire  [127:0] main_sdram_slave_p2_wrdata;
wire          main_sdram_slave_p2_wrdata_en;
wire   [15:0] main_sdram_slave_p2_wrdata_mask;
wire          main_sdram_slave_p2_rddata_en;
reg   [127:0] main_sdram_slave_p2_rddata = 128'd0;
reg           main_sdram_slave_p2_rddata_valid = 1'd0;
wire   [14:0] main_sdram_slave_p3_address;
wire    [2:0] main_sdram_slave_p3_bank;
wire          main_sdram_slave_p3_cas_n;
wire          main_sdram_slave_p3_cs_n;
wire          main_sdram_slave_p3_ras_n;
wire          main_sdram_slave_p3_we_n;
wire          main_sdram_slave_p3_cke;
wire          main_sdram_slave_p3_odt;
wire          main_sdram_slave_p3_reset_n;
wire          main_sdram_slave_p3_act_n;
wire  [127:0] main_sdram_slave_p3_wrdata;
wire          main_sdram_slave_p3_wrdata_en;
wire   [15:0] main_sdram_slave_p3_wrdata_mask;
wire          main_sdram_slave_p3_rddata_en;
reg   [127:0] main_sdram_slave_p3_rddata = 128'd0;
reg           main_sdram_slave_p3_rddata_valid = 1'd0;
reg    [14:0] main_sdram_master_p0_address = 15'd0;
reg     [2:0] main_sdram_master_p0_bank = 3'd0;
reg           main_sdram_master_p0_cas_n = 1'd1;
reg           main_sdram_master_p0_cs_n = 1'd1;
reg           main_sdram_master_p0_ras_n = 1'd1;
reg           main_sdram_master_p0_we_n = 1'd1;
reg           main_sdram_master_p0_cke = 1'd0;
reg           main_sdram_master_p0_odt = 1'd0;
reg           main_sdram_master_p0_reset_n = 1'd0;
reg           main_sdram_master_p0_act_n = 1'd1;
reg   [127:0] main_sdram_master_p0_wrdata = 128'd0;
reg           main_sdram_master_p0_wrdata_en = 1'd0;
reg    [15:0] main_sdram_master_p0_wrdata_mask = 16'd0;
reg           main_sdram_master_p0_rddata_en = 1'd0;
wire  [127:0] main_sdram_master_p0_rddata;
wire          main_sdram_master_p0_rddata_valid;
reg    [14:0] main_sdram_master_p1_address = 15'd0;
reg     [2:0] main_sdram_master_p1_bank = 3'd0;
reg           main_sdram_master_p1_cas_n = 1'd1;
reg           main_sdram_master_p1_cs_n = 1'd1;
reg           main_sdram_master_p1_ras_n = 1'd1;
reg           main_sdram_master_p1_we_n = 1'd1;
reg           main_sdram_master_p1_cke = 1'd0;
reg           main_sdram_master_p1_odt = 1'd0;
reg           main_sdram_master_p1_reset_n = 1'd0;
reg           main_sdram_master_p1_act_n = 1'd1;
reg   [127:0] main_sdram_master_p1_wrdata = 128'd0;
reg           main_sdram_master_p1_wrdata_en = 1'd0;
reg    [15:0] main_sdram_master_p1_wrdata_mask = 16'd0;
reg           main_sdram_master_p1_rddata_en = 1'd0;
wire  [127:0] main_sdram_master_p1_rddata;
wire          main_sdram_master_p1_rddata_valid;
reg    [14:0] main_sdram_master_p2_address = 15'd0;
reg     [2:0] main_sdram_master_p2_bank = 3'd0;
reg           main_sdram_master_p2_cas_n = 1'd1;
reg           main_sdram_master_p2_cs_n = 1'd1;
reg           main_sdram_master_p2_ras_n = 1'd1;
reg           main_sdram_master_p2_we_n = 1'd1;
reg           main_sdram_master_p2_cke = 1'd0;
reg           main_sdram_master_p2_odt = 1'd0;
reg           main_sdram_master_p2_reset_n = 1'd0;
reg           main_sdram_master_p2_act_n = 1'd1;
reg   [127:0] main_sdram_master_p2_wrdata = 128'd0;
reg           main_sdram_master_p2_wrdata_en = 1'd0;
reg    [15:0] main_sdram_master_p2_wrdata_mask = 16'd0;
reg           main_sdram_master_p2_rddata_en = 1'd0;
wire  [127:0] main_sdram_master_p2_rddata;
wire          main_sdram_master_p2_rddata_valid;
reg    [14:0] main_sdram_master_p3_address = 15'd0;
reg     [2:0] main_sdram_master_p3_bank = 3'd0;
reg           main_sdram_master_p3_cas_n = 1'd1;
reg           main_sdram_master_p3_cs_n = 1'd1;
reg           main_sdram_master_p3_ras_n = 1'd1;
reg           main_sdram_master_p3_we_n = 1'd1;
reg           main_sdram_master_p3_cke = 1'd0;
reg           main_sdram_master_p3_odt = 1'd0;
reg           main_sdram_master_p3_reset_n = 1'd0;
reg           main_sdram_master_p3_act_n = 1'd1;
reg   [127:0] main_sdram_master_p3_wrdata = 128'd0;
reg           main_sdram_master_p3_wrdata_en = 1'd0;
reg    [15:0] main_sdram_master_p3_wrdata_mask = 16'd0;
reg           main_sdram_master_p3_rddata_en = 1'd0;
wire  [127:0] main_sdram_master_p3_rddata;
wire          main_sdram_master_p3_rddata_valid;
wire   [14:0] main_sdram_csr_dfi_p0_address;
wire    [2:0] main_sdram_csr_dfi_p0_bank;
reg           main_sdram_csr_dfi_p0_cas_n = 1'd1;
reg           main_sdram_csr_dfi_p0_cs_n = 1'd1;
reg           main_sdram_csr_dfi_p0_ras_n = 1'd1;
reg           main_sdram_csr_dfi_p0_we_n = 1'd1;
wire          main_sdram_csr_dfi_p0_cke;
wire          main_sdram_csr_dfi_p0_odt;
wire          main_sdram_csr_dfi_p0_reset_n;
reg           main_sdram_csr_dfi_p0_act_n = 1'd1;
wire  [127:0] main_sdram_csr_dfi_p0_wrdata;
wire          main_sdram_csr_dfi_p0_wrdata_en;
wire   [15:0] main_sdram_csr_dfi_p0_wrdata_mask;
wire          main_sdram_csr_dfi_p0_rddata_en;
reg   [127:0] main_sdram_csr_dfi_p0_rddata = 128'd0;
reg           main_sdram_csr_dfi_p0_rddata_valid = 1'd0;
wire   [14:0] main_sdram_csr_dfi_p1_address;
wire    [2:0] main_sdram_csr_dfi_p1_bank;
reg           main_sdram_csr_dfi_p1_cas_n = 1'd1;
reg           main_sdram_csr_dfi_p1_cs_n = 1'd1;
reg           main_sdram_csr_dfi_p1_ras_n = 1'd1;
reg           main_sdram_csr_dfi_p1_we_n = 1'd1;
wire          main_sdram_csr_dfi_p1_cke;
wire          main_sdram_csr_dfi_p1_odt;
wire          main_sdram_csr_dfi_p1_reset_n;
reg           main_sdram_csr_dfi_p1_act_n = 1'd1;
wire  [127:0] main_sdram_csr_dfi_p1_wrdata;
wire          main_sdram_csr_dfi_p1_wrdata_en;
wire   [15:0] main_sdram_csr_dfi_p1_wrdata_mask;
wire          main_sdram_csr_dfi_p1_rddata_en;
reg   [127:0] main_sdram_csr_dfi_p1_rddata = 128'd0;
reg           main_sdram_csr_dfi_p1_rddata_valid = 1'd0;
wire   [14:0] main_sdram_csr_dfi_p2_address;
wire    [2:0] main_sdram_csr_dfi_p2_bank;
reg           main_sdram_csr_dfi_p2_cas_n = 1'd1;
reg           main_sdram_csr_dfi_p2_cs_n = 1'd1;
reg           main_sdram_csr_dfi_p2_ras_n = 1'd1;
reg           main_sdram_csr_dfi_p2_we_n = 1'd1;
wire          main_sdram_csr_dfi_p2_cke;
wire          main_sdram_csr_dfi_p2_odt;
wire          main_sdram_csr_dfi_p2_reset_n;
reg           main_sdram_csr_dfi_p2_act_n = 1'd1;
wire  [127:0] main_sdram_csr_dfi_p2_wrdata;
wire          main_sdram_csr_dfi_p2_wrdata_en;
wire   [15:0] main_sdram_csr_dfi_p2_wrdata_mask;
wire          main_sdram_csr_dfi_p2_rddata_en;
reg   [127:0] main_sdram_csr_dfi_p2_rddata = 128'd0;
reg           main_sdram_csr_dfi_p2_rddata_valid = 1'd0;
wire   [14:0] main_sdram_csr_dfi_p3_address;
wire    [2:0] main_sdram_csr_dfi_p3_bank;
reg           main_sdram_csr_dfi_p3_cas_n = 1'd1;
reg           main_sdram_csr_dfi_p3_cs_n = 1'd1;
reg           main_sdram_csr_dfi_p3_ras_n = 1'd1;
reg           main_sdram_csr_dfi_p3_we_n = 1'd1;
wire          main_sdram_csr_dfi_p3_cke;
wire          main_sdram_csr_dfi_p3_odt;
wire          main_sdram_csr_dfi_p3_reset_n;
reg           main_sdram_csr_dfi_p3_act_n = 1'd1;
wire  [127:0] main_sdram_csr_dfi_p3_wrdata;
wire          main_sdram_csr_dfi_p3_wrdata_en;
wire   [15:0] main_sdram_csr_dfi_p3_wrdata_mask;
wire          main_sdram_csr_dfi_p3_rddata_en;
reg   [127:0] main_sdram_csr_dfi_p3_rddata = 128'd0;
reg           main_sdram_csr_dfi_p3_rddata_valid = 1'd0;
reg    [14:0] main_sdram_ext_dfi_p0_address = 15'd0;
reg     [2:0] main_sdram_ext_dfi_p0_bank = 3'd0;
reg           main_sdram_ext_dfi_p0_cas_n = 1'd1;
reg           main_sdram_ext_dfi_p0_cs_n = 1'd1;
reg           main_sdram_ext_dfi_p0_ras_n = 1'd1;
reg           main_sdram_ext_dfi_p0_we_n = 1'd1;
reg           main_sdram_ext_dfi_p0_cke = 1'd0;
reg           main_sdram_ext_dfi_p0_odt = 1'd0;
reg           main_sdram_ext_dfi_p0_reset_n = 1'd0;
reg           main_sdram_ext_dfi_p0_act_n = 1'd1;
reg   [127:0] main_sdram_ext_dfi_p0_wrdata = 128'd0;
reg           main_sdram_ext_dfi_p0_wrdata_en = 1'd0;
reg    [15:0] main_sdram_ext_dfi_p0_wrdata_mask = 16'd0;
reg           main_sdram_ext_dfi_p0_rddata_en = 1'd0;
reg   [127:0] main_sdram_ext_dfi_p0_rddata = 128'd0;
reg           main_sdram_ext_dfi_p0_rddata_valid = 1'd0;
reg    [14:0] main_sdram_ext_dfi_p1_address = 15'd0;
reg     [2:0] main_sdram_ext_dfi_p1_bank = 3'd0;
reg           main_sdram_ext_dfi_p1_cas_n = 1'd1;
reg           main_sdram_ext_dfi_p1_cs_n = 1'd1;
reg           main_sdram_ext_dfi_p1_ras_n = 1'd1;
reg           main_sdram_ext_dfi_p1_we_n = 1'd1;
reg           main_sdram_ext_dfi_p1_cke = 1'd0;
reg           main_sdram_ext_dfi_p1_odt = 1'd0;
reg           main_sdram_ext_dfi_p1_reset_n = 1'd0;
reg           main_sdram_ext_dfi_p1_act_n = 1'd1;
reg   [127:0] main_sdram_ext_dfi_p1_wrdata = 128'd0;
reg           main_sdram_ext_dfi_p1_wrdata_en = 1'd0;
reg    [15:0] main_sdram_ext_dfi_p1_wrdata_mask = 16'd0;
reg           main_sdram_ext_dfi_p1_rddata_en = 1'd0;
reg   [127:0] main_sdram_ext_dfi_p1_rddata = 128'd0;
reg           main_sdram_ext_dfi_p1_rddata_valid = 1'd0;
reg    [14:0] main_sdram_ext_dfi_p2_address = 15'd0;
reg     [2:0] main_sdram_ext_dfi_p2_bank = 3'd0;
reg           main_sdram_ext_dfi_p2_cas_n = 1'd1;
reg           main_sdram_ext_dfi_p2_cs_n = 1'd1;
reg           main_sdram_ext_dfi_p2_ras_n = 1'd1;
reg           main_sdram_ext_dfi_p2_we_n = 1'd1;
reg           main_sdram_ext_dfi_p2_cke = 1'd0;
reg           main_sdram_ext_dfi_p2_odt = 1'd0;
reg           main_sdram_ext_dfi_p2_reset_n = 1'd0;
reg           main_sdram_ext_dfi_p2_act_n = 1'd1;
reg   [127:0] main_sdram_ext_dfi_p2_wrdata = 128'd0;
reg           main_sdram_ext_dfi_p2_wrdata_en = 1'd0;
reg    [15:0] main_sdram_ext_dfi_p2_wrdata_mask = 16'd0;
reg           main_sdram_ext_dfi_p2_rddata_en = 1'd0;
reg   [127:0] main_sdram_ext_dfi_p2_rddata = 128'd0;
reg           main_sdram_ext_dfi_p2_rddata_valid = 1'd0;
reg    [14:0] main_sdram_ext_dfi_p3_address = 15'd0;
reg     [2:0] main_sdram_ext_dfi_p3_bank = 3'd0;
reg           main_sdram_ext_dfi_p3_cas_n = 1'd1;
reg           main_sdram_ext_dfi_p3_cs_n = 1'd1;
reg           main_sdram_ext_dfi_p3_ras_n = 1'd1;
reg           main_sdram_ext_dfi_p3_we_n = 1'd1;
reg           main_sdram_ext_dfi_p3_cke = 1'd0;
reg           main_sdram_ext_dfi_p3_odt = 1'd0;
reg           main_sdram_ext_dfi_p3_reset_n = 1'd0;
reg           main_sdram_ext_dfi_p3_act_n = 1'd1;
reg   [127:0] main_sdram_ext_dfi_p3_wrdata = 128'd0;
reg           main_sdram_ext_dfi_p3_wrdata_en = 1'd0;
reg    [15:0] main_sdram_ext_dfi_p3_wrdata_mask = 16'd0;
reg           main_sdram_ext_dfi_p3_rddata_en = 1'd0;
reg   [127:0] main_sdram_ext_dfi_p3_rddata = 128'd0;
reg           main_sdram_ext_dfi_p3_rddata_valid = 1'd0;
reg           main_sdram_ext_dfi_sel = 1'd0;
wire          main_sdram_sel;
wire          main_sdram_cke;
wire          main_sdram_odt;
wire          main_sdram_reset_n;
reg     [3:0] main_sdram_storage = 4'd1;
reg           main_sdram_re = 1'd0;
wire          main_sdram_phaseinjector0_csrfield_cs;
wire          main_sdram_phaseinjector0_csrfield_we;
wire          main_sdram_phaseinjector0_csrfield_cas;
wire          main_sdram_phaseinjector0_csrfield_ras;
wire          main_sdram_phaseinjector0_csrfield_wren;
wire          main_sdram_phaseinjector0_csrfield_rden;
wire          main_sdram_phaseinjector0_csrfield_cs_top;
wire          main_sdram_phaseinjector0_csrfield_cs_bottom;
reg     [7:0] main_sdram_phaseinjector0_command_storage = 8'd0;
reg           main_sdram_phaseinjector0_command_re = 1'd0;
reg           main_sdram_phaseinjector0_command_issue_re = 1'd0;
wire          main_sdram_phaseinjector0_command_issue_r;
reg           main_sdram_phaseinjector0_command_issue_we = 1'd0;
reg           main_sdram_phaseinjector0_command_issue_w = 1'd0;
reg    [14:0] main_sdram_phaseinjector0_address_storage = 15'd0;
reg           main_sdram_phaseinjector0_address_re = 1'd0;
reg     [2:0] main_sdram_phaseinjector0_baddress_storage = 3'd0;
reg           main_sdram_phaseinjector0_baddress_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector0_wrdata_storage = 128'd0;
reg           main_sdram_phaseinjector0_wrdata_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector0_rddata_status = 128'd0;
wire          main_sdram_phaseinjector0_rddata_we;
reg           main_sdram_phaseinjector0_rddata_re = 1'd0;
wire          main_sdram_phaseinjector1_csrfield_cs;
wire          main_sdram_phaseinjector1_csrfield_we;
wire          main_sdram_phaseinjector1_csrfield_cas;
wire          main_sdram_phaseinjector1_csrfield_ras;
wire          main_sdram_phaseinjector1_csrfield_wren;
wire          main_sdram_phaseinjector1_csrfield_rden;
wire          main_sdram_phaseinjector1_csrfield_cs_top;
wire          main_sdram_phaseinjector1_csrfield_cs_bottom;
reg     [7:0] main_sdram_phaseinjector1_command_storage = 8'd0;
reg           main_sdram_phaseinjector1_command_re = 1'd0;
reg           main_sdram_phaseinjector1_command_issue_re = 1'd0;
wire          main_sdram_phaseinjector1_command_issue_r;
reg           main_sdram_phaseinjector1_command_issue_we = 1'd0;
reg           main_sdram_phaseinjector1_command_issue_w = 1'd0;
reg    [14:0] main_sdram_phaseinjector1_address_storage = 15'd0;
reg           main_sdram_phaseinjector1_address_re = 1'd0;
reg     [2:0] main_sdram_phaseinjector1_baddress_storage = 3'd0;
reg           main_sdram_phaseinjector1_baddress_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector1_wrdata_storage = 128'd0;
reg           main_sdram_phaseinjector1_wrdata_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector1_rddata_status = 128'd0;
wire          main_sdram_phaseinjector1_rddata_we;
reg           main_sdram_phaseinjector1_rddata_re = 1'd0;
wire          main_sdram_phaseinjector2_csrfield_cs;
wire          main_sdram_phaseinjector2_csrfield_we;
wire          main_sdram_phaseinjector2_csrfield_cas;
wire          main_sdram_phaseinjector2_csrfield_ras;
wire          main_sdram_phaseinjector2_csrfield_wren;
wire          main_sdram_phaseinjector2_csrfield_rden;
wire          main_sdram_phaseinjector2_csrfield_cs_top;
wire          main_sdram_phaseinjector2_csrfield_cs_bottom;
reg     [7:0] main_sdram_phaseinjector2_command_storage = 8'd0;
reg           main_sdram_phaseinjector2_command_re = 1'd0;
reg           main_sdram_phaseinjector2_command_issue_re = 1'd0;
wire          main_sdram_phaseinjector2_command_issue_r;
reg           main_sdram_phaseinjector2_command_issue_we = 1'd0;
reg           main_sdram_phaseinjector2_command_issue_w = 1'd0;
reg    [14:0] main_sdram_phaseinjector2_address_storage = 15'd0;
reg           main_sdram_phaseinjector2_address_re = 1'd0;
reg     [2:0] main_sdram_phaseinjector2_baddress_storage = 3'd0;
reg           main_sdram_phaseinjector2_baddress_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector2_wrdata_storage = 128'd0;
reg           main_sdram_phaseinjector2_wrdata_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector2_rddata_status = 128'd0;
wire          main_sdram_phaseinjector2_rddata_we;
reg           main_sdram_phaseinjector2_rddata_re = 1'd0;
wire          main_sdram_phaseinjector3_csrfield_cs;
wire          main_sdram_phaseinjector3_csrfield_we;
wire          main_sdram_phaseinjector3_csrfield_cas;
wire          main_sdram_phaseinjector3_csrfield_ras;
wire          main_sdram_phaseinjector3_csrfield_wren;
wire          main_sdram_phaseinjector3_csrfield_rden;
wire          main_sdram_phaseinjector3_csrfield_cs_top;
wire          main_sdram_phaseinjector3_csrfield_cs_bottom;
reg     [7:0] main_sdram_phaseinjector3_command_storage = 8'd0;
reg           main_sdram_phaseinjector3_command_re = 1'd0;
reg           main_sdram_phaseinjector3_command_issue_re = 1'd0;
wire          main_sdram_phaseinjector3_command_issue_r;
reg           main_sdram_phaseinjector3_command_issue_we = 1'd0;
reg           main_sdram_phaseinjector3_command_issue_w = 1'd0;
reg    [14:0] main_sdram_phaseinjector3_address_storage = 15'd0;
reg           main_sdram_phaseinjector3_address_re = 1'd0;
reg     [2:0] main_sdram_phaseinjector3_baddress_storage = 3'd0;
reg           main_sdram_phaseinjector3_baddress_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector3_wrdata_storage = 128'd0;
reg           main_sdram_phaseinjector3_wrdata_re = 1'd0;
reg   [127:0] main_sdram_phaseinjector3_rddata_status = 128'd0;
wire          main_sdram_phaseinjector3_rddata_we;
reg           main_sdram_phaseinjector3_rddata_re = 1'd0;
wire          main_sdram_interface_bank0_valid;
wire          main_sdram_interface_bank0_ready;
wire          main_sdram_interface_bank0_we;
wire   [21:0] main_sdram_interface_bank0_addr;
wire          main_sdram_interface_bank0_lock;
wire          main_sdram_interface_bank0_wdata_ready;
wire          main_sdram_interface_bank0_rdata_valid;
wire          main_sdram_interface_bank1_valid;
wire          main_sdram_interface_bank1_ready;
wire          main_sdram_interface_bank1_we;
wire   [21:0] main_sdram_interface_bank1_addr;
wire          main_sdram_interface_bank1_lock;
wire          main_sdram_interface_bank1_wdata_ready;
wire          main_sdram_interface_bank1_rdata_valid;
wire          main_sdram_interface_bank2_valid;
wire          main_sdram_interface_bank2_ready;
wire          main_sdram_interface_bank2_we;
wire   [21:0] main_sdram_interface_bank2_addr;
wire          main_sdram_interface_bank2_lock;
wire          main_sdram_interface_bank2_wdata_ready;
wire          main_sdram_interface_bank2_rdata_valid;
wire          main_sdram_interface_bank3_valid;
wire          main_sdram_interface_bank3_ready;
wire          main_sdram_interface_bank3_we;
wire   [21:0] main_sdram_interface_bank3_addr;
wire          main_sdram_interface_bank3_lock;
wire          main_sdram_interface_bank3_wdata_ready;
wire          main_sdram_interface_bank3_rdata_valid;
wire          main_sdram_interface_bank4_valid;
wire          main_sdram_interface_bank4_ready;
wire          main_sdram_interface_bank4_we;
wire   [21:0] main_sdram_interface_bank4_addr;
wire          main_sdram_interface_bank4_lock;
wire          main_sdram_interface_bank4_wdata_ready;
wire          main_sdram_interface_bank4_rdata_valid;
wire          main_sdram_interface_bank5_valid;
wire          main_sdram_interface_bank5_ready;
wire          main_sdram_interface_bank5_we;
wire   [21:0] main_sdram_interface_bank5_addr;
wire          main_sdram_interface_bank5_lock;
wire          main_sdram_interface_bank5_wdata_ready;
wire          main_sdram_interface_bank5_rdata_valid;
wire          main_sdram_interface_bank6_valid;
wire          main_sdram_interface_bank6_ready;
wire          main_sdram_interface_bank6_we;
wire   [21:0] main_sdram_interface_bank6_addr;
wire          main_sdram_interface_bank6_lock;
wire          main_sdram_interface_bank6_wdata_ready;
wire          main_sdram_interface_bank6_rdata_valid;
wire          main_sdram_interface_bank7_valid;
wire          main_sdram_interface_bank7_ready;
wire          main_sdram_interface_bank7_we;
wire   [21:0] main_sdram_interface_bank7_addr;
wire          main_sdram_interface_bank7_lock;
wire          main_sdram_interface_bank7_wdata_ready;
wire          main_sdram_interface_bank7_rdata_valid;
reg   [511:0] main_sdram_interface_wdata = 512'd0;
reg    [63:0] main_sdram_interface_wdata_we = 64'd0;
wire  [511:0] main_sdram_interface_rdata;
reg    [14:0] main_sdram_dfi_p0_address = 15'd0;
reg     [2:0] main_sdram_dfi_p0_bank = 3'd0;
reg           main_sdram_dfi_p0_cas_n = 1'd1;
reg           main_sdram_dfi_p0_cs_n = 1'd1;
reg           main_sdram_dfi_p0_ras_n = 1'd1;
reg           main_sdram_dfi_p0_we_n = 1'd1;
wire          main_sdram_dfi_p0_cke;
wire          main_sdram_dfi_p0_odt;
wire          main_sdram_dfi_p0_reset_n;
reg           main_sdram_dfi_p0_act_n = 1'd1;
wire  [127:0] main_sdram_dfi_p0_wrdata;
reg           main_sdram_dfi_p0_wrdata_en = 1'd0;
wire   [15:0] main_sdram_dfi_p0_wrdata_mask;
reg           main_sdram_dfi_p0_rddata_en = 1'd0;
wire  [127:0] main_sdram_dfi_p0_rddata;
wire          main_sdram_dfi_p0_rddata_valid;
reg    [14:0] main_sdram_dfi_p1_address = 15'd0;
reg     [2:0] main_sdram_dfi_p1_bank = 3'd0;
reg           main_sdram_dfi_p1_cas_n = 1'd1;
reg           main_sdram_dfi_p1_cs_n = 1'd1;
reg           main_sdram_dfi_p1_ras_n = 1'd1;
reg           main_sdram_dfi_p1_we_n = 1'd1;
wire          main_sdram_dfi_p1_cke;
wire          main_sdram_dfi_p1_odt;
wire          main_sdram_dfi_p1_reset_n;
reg           main_sdram_dfi_p1_act_n = 1'd1;
wire  [127:0] main_sdram_dfi_p1_wrdata;
reg           main_sdram_dfi_p1_wrdata_en = 1'd0;
wire   [15:0] main_sdram_dfi_p1_wrdata_mask;
reg           main_sdram_dfi_p1_rddata_en = 1'd0;
wire  [127:0] main_sdram_dfi_p1_rddata;
wire          main_sdram_dfi_p1_rddata_valid;
reg    [14:0] main_sdram_dfi_p2_address = 15'd0;
reg     [2:0] main_sdram_dfi_p2_bank = 3'd0;
reg           main_sdram_dfi_p2_cas_n = 1'd1;
reg           main_sdram_dfi_p2_cs_n = 1'd1;
reg           main_sdram_dfi_p2_ras_n = 1'd1;
reg           main_sdram_dfi_p2_we_n = 1'd1;
wire          main_sdram_dfi_p2_cke;
wire          main_sdram_dfi_p2_odt;
wire          main_sdram_dfi_p2_reset_n;
reg           main_sdram_dfi_p2_act_n = 1'd1;
wire  [127:0] main_sdram_dfi_p2_wrdata;
reg           main_sdram_dfi_p2_wrdata_en = 1'd0;
wire   [15:0] main_sdram_dfi_p2_wrdata_mask;
reg           main_sdram_dfi_p2_rddata_en = 1'd0;
wire  [127:0] main_sdram_dfi_p2_rddata;
wire          main_sdram_dfi_p2_rddata_valid;
reg    [14:0] main_sdram_dfi_p3_address = 15'd0;
reg     [2:0] main_sdram_dfi_p3_bank = 3'd0;
reg           main_sdram_dfi_p3_cas_n = 1'd1;
reg           main_sdram_dfi_p3_cs_n = 1'd1;
reg           main_sdram_dfi_p3_ras_n = 1'd1;
reg           main_sdram_dfi_p3_we_n = 1'd1;
wire          main_sdram_dfi_p3_cke;
wire          main_sdram_dfi_p3_odt;
wire          main_sdram_dfi_p3_reset_n;
reg           main_sdram_dfi_p3_act_n = 1'd1;
wire  [127:0] main_sdram_dfi_p3_wrdata;
reg           main_sdram_dfi_p3_wrdata_en = 1'd0;
wire   [15:0] main_sdram_dfi_p3_wrdata_mask;
reg           main_sdram_dfi_p3_rddata_en = 1'd0;
wire  [127:0] main_sdram_dfi_p3_rddata;
wire          main_sdram_dfi_p3_rddata_valid;
reg           main_sdram_cmd_valid = 1'd0;
reg           main_sdram_cmd_ready = 1'd0;
reg           main_sdram_cmd_last = 1'd0;
reg    [14:0] main_sdram_cmd_payload_a = 15'd0;
reg     [2:0] main_sdram_cmd_payload_ba = 3'd0;
reg           main_sdram_cmd_payload_cas = 1'd0;
reg           main_sdram_cmd_payload_ras = 1'd0;
reg           main_sdram_cmd_payload_we = 1'd0;
reg           main_sdram_cmd_payload_is_read = 1'd0;
reg           main_sdram_cmd_payload_is_write = 1'd0;
wire          main_sdram_wants_refresh;
wire          main_sdram_wants_zqcs;
wire          main_sdram_timer_wait;
wire          main_sdram_timer_done0;
wire    [9:0] main_sdram_timer_count0;
wire          main_sdram_timer_done1;
reg     [9:0] main_sdram_timer_count1 = 10'd976;
wire          main_sdram_postponer_req_i;
reg           main_sdram_postponer_req_o = 1'd0;
reg           main_sdram_postponer_count = 1'd0;
reg           main_sdram_sequencer_start0 = 1'd0;
wire          main_sdram_sequencer_done0;
wire          main_sdram_sequencer_start1;
reg           main_sdram_sequencer_done1 = 1'd0;
reg     [5:0] main_sdram_sequencer_counter = 6'd0;
reg           main_sdram_sequencer_count = 1'd0;
wire          main_sdram_zqcs_timer_wait;
wire          main_sdram_zqcs_timer_done0;
wire   [26:0] main_sdram_zqcs_timer_count0;
wire          main_sdram_zqcs_timer_done1;
reg    [26:0] main_sdram_zqcs_timer_count1 = 27'd124999999;
reg           main_sdram_zqcs_executer_start = 1'd0;
reg           main_sdram_zqcs_executer_done = 1'd0;
reg     [5:0] main_sdram_zqcs_executer_counter = 6'd0;
wire          main_sdram_bankmachine0_req_valid;
wire          main_sdram_bankmachine0_req_ready;
wire          main_sdram_bankmachine0_req_we;
wire   [21:0] main_sdram_bankmachine0_req_addr;
wire          main_sdram_bankmachine0_req_lock;
reg           main_sdram_bankmachine0_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine0_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine0_refresh_req;
reg           main_sdram_bankmachine0_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine0_cmd_valid = 1'd0;
reg           main_sdram_bankmachine0_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine0_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine0_cmd_payload_ba;
reg           main_sdram_bankmachine0_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine0_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine0_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine0_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine0_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine0_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine0_auto_precharge = 1'd0;
wire          main_sdram_bankmachine0_sink_valid;
wire          main_sdram_bankmachine0_sink_ready;
reg           main_sdram_bankmachine0_sink_first = 1'd0;
reg           main_sdram_bankmachine0_sink_last = 1'd0;
wire          main_sdram_bankmachine0_sink_payload_we;
wire   [21:0] main_sdram_bankmachine0_sink_payload_addr;
wire          main_sdram_bankmachine0_source_valid;
wire          main_sdram_bankmachine0_source_ready;
wire          main_sdram_bankmachine0_source_first;
wire          main_sdram_bankmachine0_source_last;
wire          main_sdram_bankmachine0_source_payload_we;
wire   [21:0] main_sdram_bankmachine0_source_payload_addr;
wire          main_sdram_bankmachine0_syncfifo0_we;
wire          main_sdram_bankmachine0_syncfifo0_writable;
wire          main_sdram_bankmachine0_syncfifo0_re;
wire          main_sdram_bankmachine0_syncfifo0_readable;
wire   [24:0] main_sdram_bankmachine0_syncfifo0_din;
wire   [24:0] main_sdram_bankmachine0_syncfifo0_dout;
reg     [3:0] main_sdram_bankmachine0_level = 4'd0;
reg           main_sdram_bankmachine0_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine0_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine0_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine0_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine0_wrport_dat_r;
wire          main_sdram_bankmachine0_wrport_we;
wire   [24:0] main_sdram_bankmachine0_wrport_dat_w;
wire          main_sdram_bankmachine0_do_read;
wire    [2:0] main_sdram_bankmachine0_rdport_adr;
wire   [24:0] main_sdram_bankmachine0_rdport_dat_r;
wire          main_sdram_bankmachine0_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine0_fifo_in_payload_addr;
wire          main_sdram_bankmachine0_fifo_in_first;
wire          main_sdram_bankmachine0_fifo_in_last;
wire          main_sdram_bankmachine0_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine0_fifo_out_payload_addr;
wire          main_sdram_bankmachine0_fifo_out_first;
wire          main_sdram_bankmachine0_fifo_out_last;
wire          main_sdram_bankmachine0_sink_sink_valid;
wire          main_sdram_bankmachine0_sink_sink_ready;
wire          main_sdram_bankmachine0_sink_sink_first;
wire          main_sdram_bankmachine0_sink_sink_last;
wire          main_sdram_bankmachine0_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine0_sink_sink_payload_addr;
wire          main_sdram_bankmachine0_source_source_valid;
wire          main_sdram_bankmachine0_source_source_ready;
wire          main_sdram_bankmachine0_source_source_first;
wire          main_sdram_bankmachine0_source_source_last;
wire          main_sdram_bankmachine0_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine0_source_source_payload_addr;
wire          main_sdram_bankmachine0_pipe_valid_sink_valid;
wire          main_sdram_bankmachine0_pipe_valid_sink_ready;
wire          main_sdram_bankmachine0_pipe_valid_sink_first;
wire          main_sdram_bankmachine0_pipe_valid_sink_last;
wire          main_sdram_bankmachine0_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine0_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine0_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine0_pipe_valid_source_ready;
reg           main_sdram_bankmachine0_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine0_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine0_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine0_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine0_row = 15'd0;
reg           main_sdram_bankmachine0_row_opened = 1'd0;
wire          main_sdram_bankmachine0_row_hit;
reg           main_sdram_bankmachine0_row_open = 1'd0;
reg           main_sdram_bankmachine0_row_close = 1'd0;
reg           main_sdram_bankmachine0_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine0_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine0_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine0_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine0_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine0_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine0_trccon_count = 3'd0;
wire          main_sdram_bankmachine0_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine0_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine0_trascon_count = 3'd0;
wire          main_sdram_bankmachine1_req_valid;
wire          main_sdram_bankmachine1_req_ready;
wire          main_sdram_bankmachine1_req_we;
wire   [21:0] main_sdram_bankmachine1_req_addr;
wire          main_sdram_bankmachine1_req_lock;
reg           main_sdram_bankmachine1_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine1_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine1_refresh_req;
reg           main_sdram_bankmachine1_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine1_cmd_valid = 1'd0;
reg           main_sdram_bankmachine1_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine1_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine1_cmd_payload_ba;
reg           main_sdram_bankmachine1_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine1_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine1_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine1_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine1_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine1_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine1_auto_precharge = 1'd0;
wire          main_sdram_bankmachine1_sink_valid;
wire          main_sdram_bankmachine1_sink_ready;
reg           main_sdram_bankmachine1_sink_first = 1'd0;
reg           main_sdram_bankmachine1_sink_last = 1'd0;
wire          main_sdram_bankmachine1_sink_payload_we;
wire   [21:0] main_sdram_bankmachine1_sink_payload_addr;
wire          main_sdram_bankmachine1_source_valid;
wire          main_sdram_bankmachine1_source_ready;
wire          main_sdram_bankmachine1_source_first;
wire          main_sdram_bankmachine1_source_last;
wire          main_sdram_bankmachine1_source_payload_we;
wire   [21:0] main_sdram_bankmachine1_source_payload_addr;
wire          main_sdram_bankmachine1_syncfifo1_we;
wire          main_sdram_bankmachine1_syncfifo1_writable;
wire          main_sdram_bankmachine1_syncfifo1_re;
wire          main_sdram_bankmachine1_syncfifo1_readable;
wire   [24:0] main_sdram_bankmachine1_syncfifo1_din;
wire   [24:0] main_sdram_bankmachine1_syncfifo1_dout;
reg     [3:0] main_sdram_bankmachine1_level = 4'd0;
reg           main_sdram_bankmachine1_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine1_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine1_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine1_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine1_wrport_dat_r;
wire          main_sdram_bankmachine1_wrport_we;
wire   [24:0] main_sdram_bankmachine1_wrport_dat_w;
wire          main_sdram_bankmachine1_do_read;
wire    [2:0] main_sdram_bankmachine1_rdport_adr;
wire   [24:0] main_sdram_bankmachine1_rdport_dat_r;
wire          main_sdram_bankmachine1_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine1_fifo_in_payload_addr;
wire          main_sdram_bankmachine1_fifo_in_first;
wire          main_sdram_bankmachine1_fifo_in_last;
wire          main_sdram_bankmachine1_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine1_fifo_out_payload_addr;
wire          main_sdram_bankmachine1_fifo_out_first;
wire          main_sdram_bankmachine1_fifo_out_last;
wire          main_sdram_bankmachine1_sink_sink_valid;
wire          main_sdram_bankmachine1_sink_sink_ready;
wire          main_sdram_bankmachine1_sink_sink_first;
wire          main_sdram_bankmachine1_sink_sink_last;
wire          main_sdram_bankmachine1_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine1_sink_sink_payload_addr;
wire          main_sdram_bankmachine1_source_source_valid;
wire          main_sdram_bankmachine1_source_source_ready;
wire          main_sdram_bankmachine1_source_source_first;
wire          main_sdram_bankmachine1_source_source_last;
wire          main_sdram_bankmachine1_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine1_source_source_payload_addr;
wire          main_sdram_bankmachine1_pipe_valid_sink_valid;
wire          main_sdram_bankmachine1_pipe_valid_sink_ready;
wire          main_sdram_bankmachine1_pipe_valid_sink_first;
wire          main_sdram_bankmachine1_pipe_valid_sink_last;
wire          main_sdram_bankmachine1_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine1_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine1_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine1_pipe_valid_source_ready;
reg           main_sdram_bankmachine1_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine1_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine1_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine1_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine1_row = 15'd0;
reg           main_sdram_bankmachine1_row_opened = 1'd0;
wire          main_sdram_bankmachine1_row_hit;
reg           main_sdram_bankmachine1_row_open = 1'd0;
reg           main_sdram_bankmachine1_row_close = 1'd0;
reg           main_sdram_bankmachine1_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine1_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine1_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine1_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine1_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine1_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine1_trccon_count = 3'd0;
wire          main_sdram_bankmachine1_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine1_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine1_trascon_count = 3'd0;
wire          main_sdram_bankmachine2_req_valid;
wire          main_sdram_bankmachine2_req_ready;
wire          main_sdram_bankmachine2_req_we;
wire   [21:0] main_sdram_bankmachine2_req_addr;
wire          main_sdram_bankmachine2_req_lock;
reg           main_sdram_bankmachine2_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine2_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine2_refresh_req;
reg           main_sdram_bankmachine2_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine2_cmd_valid = 1'd0;
reg           main_sdram_bankmachine2_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine2_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine2_cmd_payload_ba;
reg           main_sdram_bankmachine2_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine2_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine2_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine2_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine2_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine2_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine2_auto_precharge = 1'd0;
wire          main_sdram_bankmachine2_sink_valid;
wire          main_sdram_bankmachine2_sink_ready;
reg           main_sdram_bankmachine2_sink_first = 1'd0;
reg           main_sdram_bankmachine2_sink_last = 1'd0;
wire          main_sdram_bankmachine2_sink_payload_we;
wire   [21:0] main_sdram_bankmachine2_sink_payload_addr;
wire          main_sdram_bankmachine2_source_valid;
wire          main_sdram_bankmachine2_source_ready;
wire          main_sdram_bankmachine2_source_first;
wire          main_sdram_bankmachine2_source_last;
wire          main_sdram_bankmachine2_source_payload_we;
wire   [21:0] main_sdram_bankmachine2_source_payload_addr;
wire          main_sdram_bankmachine2_syncfifo2_we;
wire          main_sdram_bankmachine2_syncfifo2_writable;
wire          main_sdram_bankmachine2_syncfifo2_re;
wire          main_sdram_bankmachine2_syncfifo2_readable;
wire   [24:0] main_sdram_bankmachine2_syncfifo2_din;
wire   [24:0] main_sdram_bankmachine2_syncfifo2_dout;
reg     [3:0] main_sdram_bankmachine2_level = 4'd0;
reg           main_sdram_bankmachine2_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine2_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine2_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine2_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine2_wrport_dat_r;
wire          main_sdram_bankmachine2_wrport_we;
wire   [24:0] main_sdram_bankmachine2_wrport_dat_w;
wire          main_sdram_bankmachine2_do_read;
wire    [2:0] main_sdram_bankmachine2_rdport_adr;
wire   [24:0] main_sdram_bankmachine2_rdport_dat_r;
wire          main_sdram_bankmachine2_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine2_fifo_in_payload_addr;
wire          main_sdram_bankmachine2_fifo_in_first;
wire          main_sdram_bankmachine2_fifo_in_last;
wire          main_sdram_bankmachine2_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine2_fifo_out_payload_addr;
wire          main_sdram_bankmachine2_fifo_out_first;
wire          main_sdram_bankmachine2_fifo_out_last;
wire          main_sdram_bankmachine2_sink_sink_valid;
wire          main_sdram_bankmachine2_sink_sink_ready;
wire          main_sdram_bankmachine2_sink_sink_first;
wire          main_sdram_bankmachine2_sink_sink_last;
wire          main_sdram_bankmachine2_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine2_sink_sink_payload_addr;
wire          main_sdram_bankmachine2_source_source_valid;
wire          main_sdram_bankmachine2_source_source_ready;
wire          main_sdram_bankmachine2_source_source_first;
wire          main_sdram_bankmachine2_source_source_last;
wire          main_sdram_bankmachine2_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine2_source_source_payload_addr;
wire          main_sdram_bankmachine2_pipe_valid_sink_valid;
wire          main_sdram_bankmachine2_pipe_valid_sink_ready;
wire          main_sdram_bankmachine2_pipe_valid_sink_first;
wire          main_sdram_bankmachine2_pipe_valid_sink_last;
wire          main_sdram_bankmachine2_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine2_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine2_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine2_pipe_valid_source_ready;
reg           main_sdram_bankmachine2_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine2_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine2_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine2_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine2_row = 15'd0;
reg           main_sdram_bankmachine2_row_opened = 1'd0;
wire          main_sdram_bankmachine2_row_hit;
reg           main_sdram_bankmachine2_row_open = 1'd0;
reg           main_sdram_bankmachine2_row_close = 1'd0;
reg           main_sdram_bankmachine2_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine2_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine2_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine2_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine2_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine2_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine2_trccon_count = 3'd0;
wire          main_sdram_bankmachine2_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine2_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine2_trascon_count = 3'd0;
wire          main_sdram_bankmachine3_req_valid;
wire          main_sdram_bankmachine3_req_ready;
wire          main_sdram_bankmachine3_req_we;
wire   [21:0] main_sdram_bankmachine3_req_addr;
wire          main_sdram_bankmachine3_req_lock;
reg           main_sdram_bankmachine3_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine3_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine3_refresh_req;
reg           main_sdram_bankmachine3_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine3_cmd_valid = 1'd0;
reg           main_sdram_bankmachine3_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine3_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine3_cmd_payload_ba;
reg           main_sdram_bankmachine3_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine3_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine3_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine3_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine3_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine3_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine3_auto_precharge = 1'd0;
wire          main_sdram_bankmachine3_sink_valid;
wire          main_sdram_bankmachine3_sink_ready;
reg           main_sdram_bankmachine3_sink_first = 1'd0;
reg           main_sdram_bankmachine3_sink_last = 1'd0;
wire          main_sdram_bankmachine3_sink_payload_we;
wire   [21:0] main_sdram_bankmachine3_sink_payload_addr;
wire          main_sdram_bankmachine3_source_valid;
wire          main_sdram_bankmachine3_source_ready;
wire          main_sdram_bankmachine3_source_first;
wire          main_sdram_bankmachine3_source_last;
wire          main_sdram_bankmachine3_source_payload_we;
wire   [21:0] main_sdram_bankmachine3_source_payload_addr;
wire          main_sdram_bankmachine3_syncfifo3_we;
wire          main_sdram_bankmachine3_syncfifo3_writable;
wire          main_sdram_bankmachine3_syncfifo3_re;
wire          main_sdram_bankmachine3_syncfifo3_readable;
wire   [24:0] main_sdram_bankmachine3_syncfifo3_din;
wire   [24:0] main_sdram_bankmachine3_syncfifo3_dout;
reg     [3:0] main_sdram_bankmachine3_level = 4'd0;
reg           main_sdram_bankmachine3_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine3_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine3_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine3_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine3_wrport_dat_r;
wire          main_sdram_bankmachine3_wrport_we;
wire   [24:0] main_sdram_bankmachine3_wrport_dat_w;
wire          main_sdram_bankmachine3_do_read;
wire    [2:0] main_sdram_bankmachine3_rdport_adr;
wire   [24:0] main_sdram_bankmachine3_rdport_dat_r;
wire          main_sdram_bankmachine3_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine3_fifo_in_payload_addr;
wire          main_sdram_bankmachine3_fifo_in_first;
wire          main_sdram_bankmachine3_fifo_in_last;
wire          main_sdram_bankmachine3_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine3_fifo_out_payload_addr;
wire          main_sdram_bankmachine3_fifo_out_first;
wire          main_sdram_bankmachine3_fifo_out_last;
wire          main_sdram_bankmachine3_sink_sink_valid;
wire          main_sdram_bankmachine3_sink_sink_ready;
wire          main_sdram_bankmachine3_sink_sink_first;
wire          main_sdram_bankmachine3_sink_sink_last;
wire          main_sdram_bankmachine3_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine3_sink_sink_payload_addr;
wire          main_sdram_bankmachine3_source_source_valid;
wire          main_sdram_bankmachine3_source_source_ready;
wire          main_sdram_bankmachine3_source_source_first;
wire          main_sdram_bankmachine3_source_source_last;
wire          main_sdram_bankmachine3_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine3_source_source_payload_addr;
wire          main_sdram_bankmachine3_pipe_valid_sink_valid;
wire          main_sdram_bankmachine3_pipe_valid_sink_ready;
wire          main_sdram_bankmachine3_pipe_valid_sink_first;
wire          main_sdram_bankmachine3_pipe_valid_sink_last;
wire          main_sdram_bankmachine3_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine3_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine3_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine3_pipe_valid_source_ready;
reg           main_sdram_bankmachine3_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine3_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine3_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine3_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine3_row = 15'd0;
reg           main_sdram_bankmachine3_row_opened = 1'd0;
wire          main_sdram_bankmachine3_row_hit;
reg           main_sdram_bankmachine3_row_open = 1'd0;
reg           main_sdram_bankmachine3_row_close = 1'd0;
reg           main_sdram_bankmachine3_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine3_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine3_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine3_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine3_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine3_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine3_trccon_count = 3'd0;
wire          main_sdram_bankmachine3_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine3_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine3_trascon_count = 3'd0;
wire          main_sdram_bankmachine4_req_valid;
wire          main_sdram_bankmachine4_req_ready;
wire          main_sdram_bankmachine4_req_we;
wire   [21:0] main_sdram_bankmachine4_req_addr;
wire          main_sdram_bankmachine4_req_lock;
reg           main_sdram_bankmachine4_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine4_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine4_refresh_req;
reg           main_sdram_bankmachine4_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine4_cmd_valid = 1'd0;
reg           main_sdram_bankmachine4_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine4_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine4_cmd_payload_ba;
reg           main_sdram_bankmachine4_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine4_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine4_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine4_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine4_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine4_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine4_auto_precharge = 1'd0;
wire          main_sdram_bankmachine4_sink_valid;
wire          main_sdram_bankmachine4_sink_ready;
reg           main_sdram_bankmachine4_sink_first = 1'd0;
reg           main_sdram_bankmachine4_sink_last = 1'd0;
wire          main_sdram_bankmachine4_sink_payload_we;
wire   [21:0] main_sdram_bankmachine4_sink_payload_addr;
wire          main_sdram_bankmachine4_source_valid;
wire          main_sdram_bankmachine4_source_ready;
wire          main_sdram_bankmachine4_source_first;
wire          main_sdram_bankmachine4_source_last;
wire          main_sdram_bankmachine4_source_payload_we;
wire   [21:0] main_sdram_bankmachine4_source_payload_addr;
wire          main_sdram_bankmachine4_syncfifo4_we;
wire          main_sdram_bankmachine4_syncfifo4_writable;
wire          main_sdram_bankmachine4_syncfifo4_re;
wire          main_sdram_bankmachine4_syncfifo4_readable;
wire   [24:0] main_sdram_bankmachine4_syncfifo4_din;
wire   [24:0] main_sdram_bankmachine4_syncfifo4_dout;
reg     [3:0] main_sdram_bankmachine4_level = 4'd0;
reg           main_sdram_bankmachine4_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine4_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine4_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine4_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine4_wrport_dat_r;
wire          main_sdram_bankmachine4_wrport_we;
wire   [24:0] main_sdram_bankmachine4_wrport_dat_w;
wire          main_sdram_bankmachine4_do_read;
wire    [2:0] main_sdram_bankmachine4_rdport_adr;
wire   [24:0] main_sdram_bankmachine4_rdport_dat_r;
wire          main_sdram_bankmachine4_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine4_fifo_in_payload_addr;
wire          main_sdram_bankmachine4_fifo_in_first;
wire          main_sdram_bankmachine4_fifo_in_last;
wire          main_sdram_bankmachine4_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine4_fifo_out_payload_addr;
wire          main_sdram_bankmachine4_fifo_out_first;
wire          main_sdram_bankmachine4_fifo_out_last;
wire          main_sdram_bankmachine4_sink_sink_valid;
wire          main_sdram_bankmachine4_sink_sink_ready;
wire          main_sdram_bankmachine4_sink_sink_first;
wire          main_sdram_bankmachine4_sink_sink_last;
wire          main_sdram_bankmachine4_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine4_sink_sink_payload_addr;
wire          main_sdram_bankmachine4_source_source_valid;
wire          main_sdram_bankmachine4_source_source_ready;
wire          main_sdram_bankmachine4_source_source_first;
wire          main_sdram_bankmachine4_source_source_last;
wire          main_sdram_bankmachine4_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine4_source_source_payload_addr;
wire          main_sdram_bankmachine4_pipe_valid_sink_valid;
wire          main_sdram_bankmachine4_pipe_valid_sink_ready;
wire          main_sdram_bankmachine4_pipe_valid_sink_first;
wire          main_sdram_bankmachine4_pipe_valid_sink_last;
wire          main_sdram_bankmachine4_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine4_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine4_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine4_pipe_valid_source_ready;
reg           main_sdram_bankmachine4_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine4_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine4_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine4_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine4_row = 15'd0;
reg           main_sdram_bankmachine4_row_opened = 1'd0;
wire          main_sdram_bankmachine4_row_hit;
reg           main_sdram_bankmachine4_row_open = 1'd0;
reg           main_sdram_bankmachine4_row_close = 1'd0;
reg           main_sdram_bankmachine4_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine4_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine4_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine4_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine4_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine4_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine4_trccon_count = 3'd0;
wire          main_sdram_bankmachine4_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine4_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine4_trascon_count = 3'd0;
wire          main_sdram_bankmachine5_req_valid;
wire          main_sdram_bankmachine5_req_ready;
wire          main_sdram_bankmachine5_req_we;
wire   [21:0] main_sdram_bankmachine5_req_addr;
wire          main_sdram_bankmachine5_req_lock;
reg           main_sdram_bankmachine5_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine5_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine5_refresh_req;
reg           main_sdram_bankmachine5_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine5_cmd_valid = 1'd0;
reg           main_sdram_bankmachine5_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine5_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine5_cmd_payload_ba;
reg           main_sdram_bankmachine5_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine5_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine5_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine5_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine5_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine5_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine5_auto_precharge = 1'd0;
wire          main_sdram_bankmachine5_sink_valid;
wire          main_sdram_bankmachine5_sink_ready;
reg           main_sdram_bankmachine5_sink_first = 1'd0;
reg           main_sdram_bankmachine5_sink_last = 1'd0;
wire          main_sdram_bankmachine5_sink_payload_we;
wire   [21:0] main_sdram_bankmachine5_sink_payload_addr;
wire          main_sdram_bankmachine5_source_valid;
wire          main_sdram_bankmachine5_source_ready;
wire          main_sdram_bankmachine5_source_first;
wire          main_sdram_bankmachine5_source_last;
wire          main_sdram_bankmachine5_source_payload_we;
wire   [21:0] main_sdram_bankmachine5_source_payload_addr;
wire          main_sdram_bankmachine5_syncfifo5_we;
wire          main_sdram_bankmachine5_syncfifo5_writable;
wire          main_sdram_bankmachine5_syncfifo5_re;
wire          main_sdram_bankmachine5_syncfifo5_readable;
wire   [24:0] main_sdram_bankmachine5_syncfifo5_din;
wire   [24:0] main_sdram_bankmachine5_syncfifo5_dout;
reg     [3:0] main_sdram_bankmachine5_level = 4'd0;
reg           main_sdram_bankmachine5_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine5_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine5_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine5_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine5_wrport_dat_r;
wire          main_sdram_bankmachine5_wrport_we;
wire   [24:0] main_sdram_bankmachine5_wrport_dat_w;
wire          main_sdram_bankmachine5_do_read;
wire    [2:0] main_sdram_bankmachine5_rdport_adr;
wire   [24:0] main_sdram_bankmachine5_rdport_dat_r;
wire          main_sdram_bankmachine5_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine5_fifo_in_payload_addr;
wire          main_sdram_bankmachine5_fifo_in_first;
wire          main_sdram_bankmachine5_fifo_in_last;
wire          main_sdram_bankmachine5_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine5_fifo_out_payload_addr;
wire          main_sdram_bankmachine5_fifo_out_first;
wire          main_sdram_bankmachine5_fifo_out_last;
wire          main_sdram_bankmachine5_sink_sink_valid;
wire          main_sdram_bankmachine5_sink_sink_ready;
wire          main_sdram_bankmachine5_sink_sink_first;
wire          main_sdram_bankmachine5_sink_sink_last;
wire          main_sdram_bankmachine5_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine5_sink_sink_payload_addr;
wire          main_sdram_bankmachine5_source_source_valid;
wire          main_sdram_bankmachine5_source_source_ready;
wire          main_sdram_bankmachine5_source_source_first;
wire          main_sdram_bankmachine5_source_source_last;
wire          main_sdram_bankmachine5_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine5_source_source_payload_addr;
wire          main_sdram_bankmachine5_pipe_valid_sink_valid;
wire          main_sdram_bankmachine5_pipe_valid_sink_ready;
wire          main_sdram_bankmachine5_pipe_valid_sink_first;
wire          main_sdram_bankmachine5_pipe_valid_sink_last;
wire          main_sdram_bankmachine5_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine5_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine5_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine5_pipe_valid_source_ready;
reg           main_sdram_bankmachine5_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine5_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine5_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine5_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine5_row = 15'd0;
reg           main_sdram_bankmachine5_row_opened = 1'd0;
wire          main_sdram_bankmachine5_row_hit;
reg           main_sdram_bankmachine5_row_open = 1'd0;
reg           main_sdram_bankmachine5_row_close = 1'd0;
reg           main_sdram_bankmachine5_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine5_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine5_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine5_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine5_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine5_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine5_trccon_count = 3'd0;
wire          main_sdram_bankmachine5_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine5_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine5_trascon_count = 3'd0;
wire          main_sdram_bankmachine6_req_valid;
wire          main_sdram_bankmachine6_req_ready;
wire          main_sdram_bankmachine6_req_we;
wire   [21:0] main_sdram_bankmachine6_req_addr;
wire          main_sdram_bankmachine6_req_lock;
reg           main_sdram_bankmachine6_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine6_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine6_refresh_req;
reg           main_sdram_bankmachine6_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine6_cmd_valid = 1'd0;
reg           main_sdram_bankmachine6_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine6_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine6_cmd_payload_ba;
reg           main_sdram_bankmachine6_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine6_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine6_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine6_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine6_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine6_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine6_auto_precharge = 1'd0;
wire          main_sdram_bankmachine6_sink_valid;
wire          main_sdram_bankmachine6_sink_ready;
reg           main_sdram_bankmachine6_sink_first = 1'd0;
reg           main_sdram_bankmachine6_sink_last = 1'd0;
wire          main_sdram_bankmachine6_sink_payload_we;
wire   [21:0] main_sdram_bankmachine6_sink_payload_addr;
wire          main_sdram_bankmachine6_source_valid;
wire          main_sdram_bankmachine6_source_ready;
wire          main_sdram_bankmachine6_source_first;
wire          main_sdram_bankmachine6_source_last;
wire          main_sdram_bankmachine6_source_payload_we;
wire   [21:0] main_sdram_bankmachine6_source_payload_addr;
wire          main_sdram_bankmachine6_syncfifo6_we;
wire          main_sdram_bankmachine6_syncfifo6_writable;
wire          main_sdram_bankmachine6_syncfifo6_re;
wire          main_sdram_bankmachine6_syncfifo6_readable;
wire   [24:0] main_sdram_bankmachine6_syncfifo6_din;
wire   [24:0] main_sdram_bankmachine6_syncfifo6_dout;
reg     [3:0] main_sdram_bankmachine6_level = 4'd0;
reg           main_sdram_bankmachine6_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine6_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine6_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine6_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine6_wrport_dat_r;
wire          main_sdram_bankmachine6_wrport_we;
wire   [24:0] main_sdram_bankmachine6_wrport_dat_w;
wire          main_sdram_bankmachine6_do_read;
wire    [2:0] main_sdram_bankmachine6_rdport_adr;
wire   [24:0] main_sdram_bankmachine6_rdport_dat_r;
wire          main_sdram_bankmachine6_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine6_fifo_in_payload_addr;
wire          main_sdram_bankmachine6_fifo_in_first;
wire          main_sdram_bankmachine6_fifo_in_last;
wire          main_sdram_bankmachine6_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine6_fifo_out_payload_addr;
wire          main_sdram_bankmachine6_fifo_out_first;
wire          main_sdram_bankmachine6_fifo_out_last;
wire          main_sdram_bankmachine6_sink_sink_valid;
wire          main_sdram_bankmachine6_sink_sink_ready;
wire          main_sdram_bankmachine6_sink_sink_first;
wire          main_sdram_bankmachine6_sink_sink_last;
wire          main_sdram_bankmachine6_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine6_sink_sink_payload_addr;
wire          main_sdram_bankmachine6_source_source_valid;
wire          main_sdram_bankmachine6_source_source_ready;
wire          main_sdram_bankmachine6_source_source_first;
wire          main_sdram_bankmachine6_source_source_last;
wire          main_sdram_bankmachine6_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine6_source_source_payload_addr;
wire          main_sdram_bankmachine6_pipe_valid_sink_valid;
wire          main_sdram_bankmachine6_pipe_valid_sink_ready;
wire          main_sdram_bankmachine6_pipe_valid_sink_first;
wire          main_sdram_bankmachine6_pipe_valid_sink_last;
wire          main_sdram_bankmachine6_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine6_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine6_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine6_pipe_valid_source_ready;
reg           main_sdram_bankmachine6_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine6_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine6_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine6_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine6_row = 15'd0;
reg           main_sdram_bankmachine6_row_opened = 1'd0;
wire          main_sdram_bankmachine6_row_hit;
reg           main_sdram_bankmachine6_row_open = 1'd0;
reg           main_sdram_bankmachine6_row_close = 1'd0;
reg           main_sdram_bankmachine6_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine6_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine6_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine6_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine6_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine6_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine6_trccon_count = 3'd0;
wire          main_sdram_bankmachine6_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine6_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine6_trascon_count = 3'd0;
wire          main_sdram_bankmachine7_req_valid;
wire          main_sdram_bankmachine7_req_ready;
wire          main_sdram_bankmachine7_req_we;
wire   [21:0] main_sdram_bankmachine7_req_addr;
wire          main_sdram_bankmachine7_req_lock;
reg           main_sdram_bankmachine7_req_wdata_ready = 1'd0;
reg           main_sdram_bankmachine7_req_rdata_valid = 1'd0;
wire          main_sdram_bankmachine7_refresh_req;
reg           main_sdram_bankmachine7_refresh_gnt = 1'd0;
reg           main_sdram_bankmachine7_cmd_valid = 1'd0;
reg           main_sdram_bankmachine7_cmd_ready = 1'd0;
reg    [14:0] main_sdram_bankmachine7_cmd_payload_a = 15'd0;
wire    [2:0] main_sdram_bankmachine7_cmd_payload_ba;
reg           main_sdram_bankmachine7_cmd_payload_cas = 1'd0;
reg           main_sdram_bankmachine7_cmd_payload_ras = 1'd0;
reg           main_sdram_bankmachine7_cmd_payload_we = 1'd0;
reg           main_sdram_bankmachine7_cmd_payload_is_cmd = 1'd0;
reg           main_sdram_bankmachine7_cmd_payload_is_read = 1'd0;
reg           main_sdram_bankmachine7_cmd_payload_is_write = 1'd0;
reg           main_sdram_bankmachine7_auto_precharge = 1'd0;
wire          main_sdram_bankmachine7_sink_valid;
wire          main_sdram_bankmachine7_sink_ready;
reg           main_sdram_bankmachine7_sink_first = 1'd0;
reg           main_sdram_bankmachine7_sink_last = 1'd0;
wire          main_sdram_bankmachine7_sink_payload_we;
wire   [21:0] main_sdram_bankmachine7_sink_payload_addr;
wire          main_sdram_bankmachine7_source_valid;
wire          main_sdram_bankmachine7_source_ready;
wire          main_sdram_bankmachine7_source_first;
wire          main_sdram_bankmachine7_source_last;
wire          main_sdram_bankmachine7_source_payload_we;
wire   [21:0] main_sdram_bankmachine7_source_payload_addr;
wire          main_sdram_bankmachine7_syncfifo7_we;
wire          main_sdram_bankmachine7_syncfifo7_writable;
wire          main_sdram_bankmachine7_syncfifo7_re;
wire          main_sdram_bankmachine7_syncfifo7_readable;
wire   [24:0] main_sdram_bankmachine7_syncfifo7_din;
wire   [24:0] main_sdram_bankmachine7_syncfifo7_dout;
reg     [3:0] main_sdram_bankmachine7_level = 4'd0;
reg           main_sdram_bankmachine7_replace = 1'd0;
reg     [2:0] main_sdram_bankmachine7_produce = 3'd0;
reg     [2:0] main_sdram_bankmachine7_consume = 3'd0;
reg     [2:0] main_sdram_bankmachine7_wrport_adr = 3'd0;
wire   [24:0] main_sdram_bankmachine7_wrport_dat_r;
wire          main_sdram_bankmachine7_wrport_we;
wire   [24:0] main_sdram_bankmachine7_wrport_dat_w;
wire          main_sdram_bankmachine7_do_read;
wire    [2:0] main_sdram_bankmachine7_rdport_adr;
wire   [24:0] main_sdram_bankmachine7_rdport_dat_r;
wire          main_sdram_bankmachine7_fifo_in_payload_we;
wire   [21:0] main_sdram_bankmachine7_fifo_in_payload_addr;
wire          main_sdram_bankmachine7_fifo_in_first;
wire          main_sdram_bankmachine7_fifo_in_last;
wire          main_sdram_bankmachine7_fifo_out_payload_we;
wire   [21:0] main_sdram_bankmachine7_fifo_out_payload_addr;
wire          main_sdram_bankmachine7_fifo_out_first;
wire          main_sdram_bankmachine7_fifo_out_last;
wire          main_sdram_bankmachine7_sink_sink_valid;
wire          main_sdram_bankmachine7_sink_sink_ready;
wire          main_sdram_bankmachine7_sink_sink_first;
wire          main_sdram_bankmachine7_sink_sink_last;
wire          main_sdram_bankmachine7_sink_sink_payload_we;
wire   [21:0] main_sdram_bankmachine7_sink_sink_payload_addr;
wire          main_sdram_bankmachine7_source_source_valid;
wire          main_sdram_bankmachine7_source_source_ready;
wire          main_sdram_bankmachine7_source_source_first;
wire          main_sdram_bankmachine7_source_source_last;
wire          main_sdram_bankmachine7_source_source_payload_we;
wire   [21:0] main_sdram_bankmachine7_source_source_payload_addr;
wire          main_sdram_bankmachine7_pipe_valid_sink_valid;
wire          main_sdram_bankmachine7_pipe_valid_sink_ready;
wire          main_sdram_bankmachine7_pipe_valid_sink_first;
wire          main_sdram_bankmachine7_pipe_valid_sink_last;
wire          main_sdram_bankmachine7_pipe_valid_sink_payload_we;
wire   [21:0] main_sdram_bankmachine7_pipe_valid_sink_payload_addr;
reg           main_sdram_bankmachine7_pipe_valid_source_valid = 1'd0;
wire          main_sdram_bankmachine7_pipe_valid_source_ready;
reg           main_sdram_bankmachine7_pipe_valid_source_first = 1'd0;
reg           main_sdram_bankmachine7_pipe_valid_source_last = 1'd0;
reg           main_sdram_bankmachine7_pipe_valid_source_payload_we = 1'd0;
reg    [21:0] main_sdram_bankmachine7_pipe_valid_source_payload_addr = 22'd0;
reg    [14:0] main_sdram_bankmachine7_row = 15'd0;
reg           main_sdram_bankmachine7_row_opened = 1'd0;
wire          main_sdram_bankmachine7_row_hit;
reg           main_sdram_bankmachine7_row_open = 1'd0;
reg           main_sdram_bankmachine7_row_close = 1'd0;
reg           main_sdram_bankmachine7_row_col_n_addr_sel = 1'd0;
wire          main_sdram_bankmachine7_twtpcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine7_twtpcon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine7_twtpcon_count = 3'd0;
wire          main_sdram_bankmachine7_trccon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine7_trccon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine7_trccon_count = 3'd0;
wire          main_sdram_bankmachine7_trascon_valid;
(* dont_touch = "true" *)
reg           main_sdram_bankmachine7_trascon_ready = 1'd0;
reg     [2:0] main_sdram_bankmachine7_trascon_count = 3'd0;
wire          main_sdram_ras_allowed;
wire          main_sdram_cas_allowed;
wire    [1:0] main_sdram_rdcmdphase;
wire    [1:0] main_sdram_wrcmdphase;
reg           main_sdram_choose_cmd_want_reads = 1'd0;
reg           main_sdram_choose_cmd_want_writes = 1'd0;
reg           main_sdram_choose_cmd_want_cmds = 1'd0;
reg           main_sdram_choose_cmd_want_activates = 1'd0;
wire          main_sdram_choose_cmd_cmd_valid;
reg           main_sdram_choose_cmd_cmd_ready = 1'd0;
wire   [14:0] main_sdram_choose_cmd_cmd_payload_a;
wire    [2:0] main_sdram_choose_cmd_cmd_payload_ba;
reg           main_sdram_choose_cmd_cmd_payload_cas = 1'd0;
reg           main_sdram_choose_cmd_cmd_payload_ras = 1'd0;
reg           main_sdram_choose_cmd_cmd_payload_we = 1'd0;
wire          main_sdram_choose_cmd_cmd_payload_is_cmd;
wire          main_sdram_choose_cmd_cmd_payload_is_read;
wire          main_sdram_choose_cmd_cmd_payload_is_write;
reg     [7:0] main_sdram_choose_cmd_valids = 8'd0;
wire    [7:0] main_sdram_choose_cmd_request;
reg     [2:0] main_sdram_choose_cmd_grant = 3'd0;
wire          main_sdram_choose_cmd_ce;
reg           main_sdram_choose_req_want_reads = 1'd0;
reg           main_sdram_choose_req_want_writes = 1'd0;
reg           main_sdram_choose_req_want_cmds = 1'd0;
reg           main_sdram_choose_req_want_activates = 1'd0;
wire          main_sdram_choose_req_cmd_valid;
reg           main_sdram_choose_req_cmd_ready = 1'd0;
wire   [14:0] main_sdram_choose_req_cmd_payload_a;
wire    [2:0] main_sdram_choose_req_cmd_payload_ba;
reg           main_sdram_choose_req_cmd_payload_cas = 1'd0;
reg           main_sdram_choose_req_cmd_payload_ras = 1'd0;
reg           main_sdram_choose_req_cmd_payload_we = 1'd0;
wire          main_sdram_choose_req_cmd_payload_is_cmd;
wire          main_sdram_choose_req_cmd_payload_is_read;
wire          main_sdram_choose_req_cmd_payload_is_write;
reg     [7:0] main_sdram_choose_req_valids = 8'd0;
wire    [7:0] main_sdram_choose_req_request;
reg     [2:0] main_sdram_choose_req_grant = 3'd0;
wire          main_sdram_choose_req_ce;
reg    [14:0] main_sdram_nop_a = 15'd0;
reg     [2:0] main_sdram_nop_ba = 3'd0;
reg     [1:0] main_sdram_steerer_sel0 = 2'd0;
reg     [1:0] main_sdram_steerer_sel1 = 2'd0;
reg     [1:0] main_sdram_steerer_sel2 = 2'd0;
reg     [1:0] main_sdram_steerer_sel3 = 2'd0;
reg           main_sdram_steerer0 = 1'd1;
reg           main_sdram_steerer1 = 1'd1;
reg           main_sdram_steerer2 = 1'd1;
reg           main_sdram_steerer3 = 1'd1;
reg           main_sdram_steerer4 = 1'd1;
reg           main_sdram_steerer5 = 1'd1;
reg           main_sdram_steerer6 = 1'd1;
reg           main_sdram_steerer7 = 1'd1;
wire          main_sdram_trrdcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_trrdcon_ready = 1'd0;
reg           main_sdram_trrdcon_count = 1'd0;
wire          main_sdram_tfawcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_tfawcon_ready = 1'd1;
wire    [2:0] main_sdram_tfawcon_count;
reg     [6:0] main_sdram_tfawcon_window = 7'd0;
wire          main_sdram_tccdcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_tccdcon_ready = 1'd0;
reg           main_sdram_tccdcon_count = 1'd0;
wire          main_sdram_twtrcon_valid;
(* dont_touch = "true" *)
reg           main_sdram_twtrcon_ready = 1'd0;
reg     [2:0] main_sdram_twtrcon_count = 3'd0;
wire          main_sdram_read_available;
wire          main_sdram_write_available;
reg           main_sdram_en0 = 1'd0;
wire          main_sdram_max_time0;
reg     [4:0] main_sdram_time0 = 5'd0;
reg           main_sdram_en1 = 1'd0;
wire          main_sdram_max_time1;
reg     [3:0] main_sdram_time1 = 4'd0;
wire          main_sdram_go_to_refresh;
wire          main_ibus_cmd_valid;
wire          main_ibus_cmd_ready;
reg           main_ibus_cmd_first = 1'd0;
reg           main_ibus_cmd_last = 1'd0;
wire          main_ibus_cmd_payload_we;
wire   [31:0] main_ibus_cmd_payload_addr;
wire          main_ibus_wdata_valid;
wire          main_ibus_wdata_ready;
reg           main_ibus_wdata_first = 1'd0;
reg           main_ibus_wdata_last = 1'd0;
wire  [511:0] main_ibus_wdata_payload_data;
wire   [63:0] main_ibus_wdata_payload_we;
wire          main_ibus_rdata_valid;
wire          main_ibus_rdata_ready;
wire          main_ibus_rdata_first;
wire          main_ibus_rdata_last;
wire  [511:0] main_ibus_rdata_payload_data;
wire          main_dbus_cmd_valid;
wire          main_dbus_cmd_ready;
reg           main_dbus_cmd_first = 1'd0;
reg           main_dbus_cmd_last = 1'd0;
wire          main_dbus_cmd_payload_we;
wire   [31:0] main_dbus_cmd_payload_addr;
wire          main_dbus_wdata_valid;
wire          main_dbus_wdata_ready;
reg           main_dbus_wdata_first = 1'd0;
reg           main_dbus_wdata_last = 1'd0;
wire  [511:0] main_dbus_wdata_payload_data;
wire   [63:0] main_dbus_wdata_payload_we;
wire          main_dbus_rdata_valid;
wire          main_dbus_rdata_ready;
wire          main_dbus_rdata_first;
wire          main_dbus_rdata_last;
wire  [511:0] main_dbus_rdata_payload_data;
wire          main_litedramnativeport0_cmd_valid;
wire          main_litedramnativeport0_cmd_ready;
wire          main_litedramnativeport0_cmd_first;
wire          main_litedramnativeport0_cmd_last;
wire          main_litedramnativeport0_cmd_payload_we;
wire   [24:0] main_litedramnativeport0_cmd_payload_addr;
wire          main_litedramnativeport0_wdata_valid;
wire          main_litedramnativeport0_wdata_ready;
wire          main_litedramnativeport0_wdata_first;
wire          main_litedramnativeport0_wdata_last;
wire  [511:0] main_litedramnativeport0_wdata_payload_data;
wire   [63:0] main_litedramnativeport0_wdata_payload_we;
wire          main_litedramnativeport0_rdata_valid;
wire          main_litedramnativeport0_rdata_ready;
reg           main_litedramnativeport0_rdata_first = 1'd0;
reg           main_litedramnativeport0_rdata_last = 1'd0;
wire  [511:0] main_litedramnativeport0_rdata_payload_data;
wire          main_litedramnativeport1_cmd_valid;
wire          main_litedramnativeport1_cmd_ready;
wire          main_litedramnativeport1_cmd_first;
wire          main_litedramnativeport1_cmd_last;
wire          main_litedramnativeport1_cmd_payload_we;
wire   [24:0] main_litedramnativeport1_cmd_payload_addr;
wire          main_litedramnativeport1_wdata_valid;
wire          main_litedramnativeport1_wdata_ready;
wire          main_litedramnativeport1_wdata_first;
wire          main_litedramnativeport1_wdata_last;
wire  [511:0] main_litedramnativeport1_wdata_payload_data;
wire   [63:0] main_litedramnativeport1_wdata_payload_we;
wire          main_litedramnativeport1_rdata_valid;
wire          main_litedramnativeport1_rdata_ready;
reg           main_litedramnativeport1_rdata_first = 1'd0;
reg           main_litedramnativeport1_rdata_last = 1'd0;
wire  [511:0] main_litedramnativeport1_rdata_payload_data;
reg           main_ku_1000basex_pcstx_config_valid = 1'd0;
wire   [15:0] main_ku_1000basex_pcstx_config_reg;
wire          main_ku_1000basex_pcstx_tx_valid;
reg           main_ku_1000basex_pcstx_tx_ready = 1'd0;
wire    [7:0] main_ku_1000basex_pcstx_tx_data;
reg           main_ku_1000basex_pcstx_ce0 = 1'd1;
reg     [7:0] main_ku_1000basex_pcstx_d0 = 8'd0;
reg           main_ku_1000basex_pcstx_k0 = 1'd0;
reg     [9:0] main_ku_1000basex_pcstx_output0 = 10'd0;
reg           main_ku_1000basex_pcstx_disparity = 1'd0;
wire    [7:0] main_ku_1000basex_pcstx_d1;
wire          main_ku_1000basex_pcstx_k1;
reg           main_ku_1000basex_pcstx_disp_in = 1'd0;
reg     [9:0] main_ku_1000basex_pcstx_output1 = 10'd0;
reg           main_ku_1000basex_pcstx_disp_out = 1'd0;
reg     [5:0] main_ku_1000basex_pcstx_code6b = 6'd0;
reg           main_ku_1000basex_pcstx_code6b_unbalanced = 1'd0;
reg           main_ku_1000basex_pcstx_code6b_flip = 1'd0;
reg     [3:0] main_ku_1000basex_pcstx_code4b = 4'd0;
reg           main_ku_1000basex_pcstx_code4b_unbalanced = 1'd0;
reg           main_ku_1000basex_pcstx_code4b_flip = 1'd0;
reg           main_ku_1000basex_pcstx_alt7_rd0 = 1'd0;
reg           main_ku_1000basex_pcstx_alt7_rd1 = 1'd0;
reg     [5:0] main_ku_1000basex_pcstx_output_6b = 6'd0;
wire          main_ku_1000basex_pcstx_disp_inter;
reg     [3:0] main_ku_1000basex_pcstx_output_4b = 4'd0;
wire    [9:0] main_ku_1000basex_pcstx_output_msb_first;
wire          main_ku_1000basex_pcstx_ce1;
wire    [1:0] main_ku_1000basex_pcstx_sgmii_speed;
reg           main_ku_1000basex_pcstx_parity = 1'd0;
reg           main_ku_1000basex_pcstx_c_type = 1'd0;
reg    [15:0] main_ku_1000basex_pcstx_config_reg_buffer = 16'd0;
reg           main_ku_1000basex_pcstx_load_config_reg_buffer = 1'd0;
reg     [9:0] main_ku_1000basex_pcstx_timer = 10'd0;
reg           main_ku_1000basex_pcstx_timer_en = 1'd0;
reg           main_ku_1000basex_pcsrx_rx_en = 1'd0;
wire    [7:0] main_ku_1000basex_pcsrx_rx_data;
reg           main_ku_1000basex_pcsrx_seen_valid_ci = 1'd0;
reg           main_ku_1000basex_pcsrx_seen_config_reg = 1'd0;
reg    [15:0] main_ku_1000basex_pcsrx_config_reg = 16'd0;
reg           main_ku_1000basex_pcsrx_ce = 1'd1;
wire    [9:0] main_ku_1000basex_pcsrx_input;
wire    [7:0] main_ku_1000basex_pcsrx_d;
reg           main_ku_1000basex_pcsrx_k = 1'd0;
wire          main_ku_1000basex_pcsrx_invalid;
reg     [9:0] main_ku_1000basex_pcsrx_input_msb_first = 10'd0;
wire    [4:0] main_ku_1000basex_pcsrx_code5b;
reg     [2:0] main_ku_1000basex_pcsrx_code3b = 3'd0;
wire    [5:0] main_ku_1000basex_pcsrx_adr;
wire    [4:0] main_ku_1000basex_pcsrx_dat_r;
wire          main_ku_1000basex_pcsrx_re;
reg     [3:0] main_ku_1000basex_pcsrx_ones = 4'd0;
wire    [1:0] main_ku_1000basex_pcsrx_sgmii_speed;
wire          main_ku_1000basex_pcsrx_sample_en;
reg     [7:0] main_ku_1000basex_pcsrx_config_reg_lsb = 8'd0;
reg           main_ku_1000basex_pcsrx_load_config_reg_lsb = 1'd0;
reg           main_ku_1000basex_pcsrx_load_config_reg_msb = 1'd0;
reg           main_ku_1000basex_pcsrx_first_preamble_byte = 1'd0;
reg     [9:0] main_ku_1000basex_pcsrx_timer = 10'd0;
reg           main_ku_1000basex_pcsrx_timer_en = 1'd0;
wire          main_ku_1000basex_sink_valid;
wire          main_ku_1000basex_sink_ready;
wire          main_ku_1000basex_sink_first;
wire          main_ku_1000basex_sink_last;
wire    [7:0] main_ku_1000basex_sink_payload_data;
wire          main_ku_1000basex_sink_payload_last_be;
wire          main_ku_1000basex_sink_payload_error;
reg           main_ku_1000basex_source_valid = 1'd0;
wire          main_ku_1000basex_source_ready;
reg           main_ku_1000basex_source_first = 1'd0;
wire          main_ku_1000basex_source_last;
reg     [7:0] main_ku_1000basex_source_payload_data = 8'd0;
reg           main_ku_1000basex_source_payload_last_be = 1'd0;
reg           main_ku_1000basex_source_payload_error = 1'd0;
reg           main_ku_1000basex_link_up = 1'd0;
reg           main_ku_1000basex_restart = 1'd0;
reg    [15:0] main_ku_1000basex_lp_abi_i = 16'd0;
reg    [15:0] main_ku_1000basex_lp_abi_o = 16'd0;
reg           main_ku_1000basex_lp_abi_starter = 1'd1;
wire          main_ku_1000basex_lp_abi_ping_i;
wire          main_ku_1000basex_lp_abi_ping_o0;
reg           main_ku_1000basex_lp_abi_ping_toggle_i = 1'd0;
wire          main_ku_1000basex_lp_abi_ping_toggle_o;
reg           main_ku_1000basex_lp_abi_ping_toggle_o_r = 1'd0;
reg           main_ku_1000basex_lp_abi_ping_o1 = 1'd0;
wire          main_ku_1000basex_lp_abi_pong_i;
wire          main_ku_1000basex_lp_abi_pong_o;
reg           main_ku_1000basex_lp_abi_pong_toggle_i = 1'd0;
wire          main_ku_1000basex_lp_abi_pong_toggle_o;
reg           main_ku_1000basex_lp_abi_pong_toggle_o_r = 1'd0;
wire          main_ku_1000basex_lp_abi_wait;
wire          main_ku_1000basex_lp_abi_done;
reg     [7:0] main_ku_1000basex_lp_abi_count = 8'd128;
(* dont_touch = "true" *)
reg    [15:0] main_ku_1000basex_lp_abi_ibuffer = 16'd0;
wire   [15:0] main_ku_1000basex_lp_abi_obuffer;
reg           main_ku_1000basex_rx_en_d = 1'd0;
wire          main_ku_1000basex_seen_valid_ci_i;
wire          main_ku_1000basex_seen_valid_ci_o;
reg           main_ku_1000basex_seen_valid_ci_toggle_i = 1'd0;
wire          main_ku_1000basex_seen_valid_ci_toggle_o;
reg           main_ku_1000basex_seen_valid_ci_toggle_o_r = 1'd0;
reg    [19:0] main_ku_1000basex_checker_counter = 20'd0;
reg           main_ku_1000basex_checker_tick = 1'd0;
reg           main_ku_1000basex_checker_ok = 1'd0;
reg           main_ku_1000basex_tx_config_empty = 1'd0;
wire          main_ku_1000basex_is_sgmii;
wire          main_ku_1000basex_linkdown;
reg           main_ku_1000basex_autoneg_ack = 1'd0;
reg           main_ku_1000basex_rx_config_reg_abi_i = 1'd0;
wire          main_ku_1000basex_rx_config_reg_abi_o;
reg           main_ku_1000basex_rx_config_reg_abi_toggle_i = 1'd0;
wire          main_ku_1000basex_rx_config_reg_abi_toggle_o;
reg           main_ku_1000basex_rx_config_reg_abi_toggle_o_r = 1'd0;
reg           main_ku_1000basex_rx_config_reg_ack_i = 1'd0;
wire          main_ku_1000basex_rx_config_reg_ack_o;
reg           main_ku_1000basex_rx_config_reg_ack_toggle_i = 1'd0;
wire          main_ku_1000basex_rx_config_reg_ack_toggle_o;
reg           main_ku_1000basex_rx_config_reg_ack_toggle_o_r = 1'd0;
reg           main_ku_1000basex_waittimer0_wait = 1'd0;
wire          main_ku_1000basex_waittimer0_done;
reg    [20:0] main_ku_1000basex_waittimer0_count = 21'd1250000;
reg           main_ku_1000basex_waittimer1_wait = 1'd0;
wire          main_ku_1000basex_waittimer1_done;
reg    [17:0] main_ku_1000basex_waittimer1_count = 18'd200000;
reg     [2:0] main_ku_1000basex_c_counter = 3'd0;
reg    [15:0] main_ku_1000basex_prev_config_reg = 16'd0;
(* dont_touch = "true" *)
wire          eth_tx_clk;
wire          eth_tx_rst;
(* dont_touch = "true" *)
wire          eth_rx_clk;
wire          eth_rx_rst;
wire          eth_tx_half_clk;
wire          eth_rx_half_clk;
wire          main_ku_1000basex_txoutclk;
wire          main_ku_1000basex_rxoutclk;
wire          main_ku_1000basex_crg_reset;
reg           main_ku_1000basex_storage = 1'd0;
reg           main_ku_1000basex_re = 1'd0;
wire          main_ku_1000basex_gtpowergood;
reg           main_ku_1000basex_pll_reset = 1'd1;
wire          main_ku_1000basex_pll_locked;
wire          main_ku_1000basex_tx_reset;
wire   [19:0] main_ku_1000basex_tx_data0;
wire          main_ku_1000basex_tx_reset_done;
wire          main_ku_1000basex_rx_reset;
wire   [19:0] main_ku_1000basex_rx_data0;
wire          main_ku_1000basex_rx_reset_done;
wire          main_ku_1000basex0;
wire          main_ku_1000basex1;
wire          main_ku_1000basex2;
wire          main_ku_1000basex3;
wire          main_ku_1000basex4;
wire          main_ku_1000basex5;
wire          main_ku_1000basex6;
wire          main_ku_1000basex7;
wire          main_ku_1000basex8;
wire          main_ku_1000basex9;
wire          main_ku_1000basex10;
wire          main_ku_1000basex11;
wire          main_ku_1000basex12;
wire          main_ku_1000basex13;
wire          main_ku_1000basex14;
wire          main_ku_1000basex15;
wire          main_ku_1000basex16;
wire          main_ku_1000basex17;
wire          main_ku_1000basex18;
wire          main_ku_1000basex19;
wire          main_ku_1000basex20;
wire          main_ku_1000basex21;
wire          main_ku_1000basex22;
wire          main_ku_1000basex23;
wire          main_ku_1000basex24;
wire          main_ku_1000basex25;
wire          main_ku_1000basex26;
wire          main_ku_1000basex27;
wire          main_ku_1000basex28;
wire          main_ku_1000basex29;
wire          main_ku_1000basex30;
wire          main_ku_1000basex31;
wire          main_ku_1000basex32;
wire          main_ku_1000basex33;
wire          main_ku_1000basex34;
wire          main_ku_1000basex35;
wire          main_ku_1000basex36;
wire          main_ku_1000basex37;
wire          main_ku_1000basex38;
wire          main_ku_1000basex39;
wire          main_ku_1000basex40;
wire          main_ku_1000basex41;
wire          main_ku_1000basex42;
wire          main_ku_1000basex43;
wire          main_ku_1000basex44;
wire          main_ku_1000basex45;
wire          main_ku_1000basex46;
wire          main_ku_1000basex47;
wire          main_ku_1000basex48;
wire          main_ku_1000basex49;
wire          main_ku_1000basex50;
wire          main_ku_1000basex51;
wire          main_ku_1000basex52;
wire          main_ku_1000basex53;
wire          main_ku_1000basex54;
wire          main_ku_1000basex55;
wire          main_ku_1000basex56;
wire          main_ku_1000basex57;
wire          main_ku_1000basex58;
wire          main_ku_1000basex59;
wire          main_ku_1000basex60;
wire          main_ku_1000basex61;
wire          main_ku_1000basex62;
wire          main_ku_1000basex63;
wire          main_ku_1000basex64;
wire          main_ku_1000basex65;
wire          main_ku_1000basex66;
wire          main_ku_1000basex67;
wire          main_ku_1000basex68;
wire          main_ku_1000basex69;
wire          main_ku_1000basex70;
wire          main_ku_1000basex71;
wire          main_ku_1000basex72;
wire          main_ku_1000basex73;
wire          main_ku_1000basex74;
wire          main_ku_1000basex75;
wire          main_ku_1000basex76;
wire          main_ku_1000basex77;
wire          main_ku_1000basex78;
wire          main_ku_1000basex79;
wire          main_ku_1000basex80;
wire          main_ku_1000basex81;
wire          main_ku_1000basex82;
wire          main_ku_1000basex83;
wire          main_ku_1000basex84;
wire          main_ku_1000basex85;
reg    [15:0] main_ku_1000basex_reset_counter = 16'd0;
wire    [9:0] main_ku_1000basex_tx_data1;
reg    [19:0] main_ku_1000basex_tx_data_half = 20'd0;
wire   [19:0] main_ku_1000basex_rx_data_half;
reg     [9:0] main_ku_1000basex_rx_data1 = 10'd0;
reg    [19:0] main_ku_1000basex_buf = 20'd0;
reg           main_ku_1000basex_phase_half = 1'd0;
reg           main_ku_1000basex_phase_half_rereg = 1'd0;
wire          main_ethmac_sink_valid;
wire          main_ethmac_sink_ready;
wire          main_ethmac_sink_first;
wire          main_ethmac_sink_last;
wire   [31:0] main_ethmac_sink_payload_data;
wire    [3:0] main_ethmac_sink_payload_last_be;
wire    [3:0] main_ethmac_sink_payload_error;
wire          main_ethmac_source_valid;
wire          main_ethmac_source_ready;
wire          main_ethmac_source_first;
wire          main_ethmac_source_last;
wire   [31:0] main_ethmac_source_payload_data;
wire    [3:0] main_ethmac_source_payload_last_be;
wire    [3:0] main_ethmac_source_payload_error;
reg           main_ethmac_status = 1'd1;
wire          main_ethmac_we;
reg           main_ethmac_re = 1'd0;
wire          main_ethmac_tx_cdc_sink_sink_valid;
wire          main_ethmac_tx_cdc_sink_sink_ready;
wire          main_ethmac_tx_cdc_sink_sink_first;
wire          main_ethmac_tx_cdc_sink_sink_last;
wire   [31:0] main_ethmac_tx_cdc_sink_sink_payload_data;
wire    [3:0] main_ethmac_tx_cdc_sink_sink_payload_last_be;
wire    [3:0] main_ethmac_tx_cdc_sink_sink_payload_error;
wire          main_ethmac_tx_cdc_source_source_valid;
wire          main_ethmac_tx_cdc_source_source_ready;
wire          main_ethmac_tx_cdc_source_source_first;
wire          main_ethmac_tx_cdc_source_source_last;
wire   [31:0] main_ethmac_tx_cdc_source_source_payload_data;
wire    [3:0] main_ethmac_tx_cdc_source_source_payload_last_be;
wire    [3:0] main_ethmac_tx_cdc_source_source_payload_error;
wire          main_ethmac_tx_cdc_cdc_sink_valid;
wire          main_ethmac_tx_cdc_cdc_sink_ready;
wire          main_ethmac_tx_cdc_cdc_sink_first;
wire          main_ethmac_tx_cdc_cdc_sink_last;
wire   [31:0] main_ethmac_tx_cdc_cdc_sink_payload_data;
wire    [3:0] main_ethmac_tx_cdc_cdc_sink_payload_last_be;
wire    [3:0] main_ethmac_tx_cdc_cdc_sink_payload_error;
wire          main_ethmac_tx_cdc_cdc_source_valid;
wire          main_ethmac_tx_cdc_cdc_source_ready;
wire          main_ethmac_tx_cdc_cdc_source_first;
wire          main_ethmac_tx_cdc_cdc_source_last;
wire   [31:0] main_ethmac_tx_cdc_cdc_source_payload_data;
wire    [3:0] main_ethmac_tx_cdc_cdc_source_payload_last_be;
wire    [3:0] main_ethmac_tx_cdc_cdc_source_payload_error;
wire          main_ethmac_tx_cdc_cdc_asyncfifo_we;
wire          main_ethmac_tx_cdc_cdc_asyncfifo_writable;
wire          main_ethmac_tx_cdc_cdc_asyncfifo_re;
wire          main_ethmac_tx_cdc_cdc_asyncfifo_readable;
wire   [41:0] main_ethmac_tx_cdc_cdc_asyncfifo_din;
wire   [41:0] main_ethmac_tx_cdc_cdc_asyncfifo_dout;
wire          main_ethmac_tx_cdc_cdc_graycounter0_ce;
(* dont_touch = "true" *)
reg     [5:0] main_ethmac_tx_cdc_cdc_graycounter0_q = 6'd0;
wire    [5:0] main_ethmac_tx_cdc_cdc_graycounter0_q_next;
reg     [5:0] main_ethmac_tx_cdc_cdc_graycounter0_q_binary = 6'd0;
reg     [5:0] main_ethmac_tx_cdc_cdc_graycounter0_q_next_binary = 6'd0;
wire          main_ethmac_tx_cdc_cdc_graycounter1_ce;
(* dont_touch = "true" *)
reg     [5:0] main_ethmac_tx_cdc_cdc_graycounter1_q = 6'd0;
wire    [5:0] main_ethmac_tx_cdc_cdc_graycounter1_q_next;
reg     [5:0] main_ethmac_tx_cdc_cdc_graycounter1_q_binary = 6'd0;
reg     [5:0] main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary = 6'd0;
wire    [5:0] main_ethmac_tx_cdc_cdc_produce_rdomain;
wire    [5:0] main_ethmac_tx_cdc_cdc_consume_wdomain;
wire    [4:0] main_ethmac_tx_cdc_cdc_wrport_adr;
wire   [41:0] main_ethmac_tx_cdc_cdc_wrport_dat_r;
wire          main_ethmac_tx_cdc_cdc_wrport_we;
wire   [41:0] main_ethmac_tx_cdc_cdc_wrport_dat_w;
wire    [4:0] main_ethmac_tx_cdc_cdc_rdport_adr;
wire   [41:0] main_ethmac_tx_cdc_cdc_rdport_dat_r;
wire   [31:0] main_ethmac_tx_cdc_cdc_fifo_in_payload_data;
wire    [3:0] main_ethmac_tx_cdc_cdc_fifo_in_payload_last_be;
wire    [3:0] main_ethmac_tx_cdc_cdc_fifo_in_payload_error;
wire          main_ethmac_tx_cdc_cdc_fifo_in_first;
wire          main_ethmac_tx_cdc_cdc_fifo_in_last;
wire   [31:0] main_ethmac_tx_cdc_cdc_fifo_out_payload_data;
wire    [3:0] main_ethmac_tx_cdc_cdc_fifo_out_payload_last_be;
wire    [3:0] main_ethmac_tx_cdc_cdc_fifo_out_payload_error;
wire          main_ethmac_tx_cdc_cdc_fifo_out_first;
wire          main_ethmac_tx_cdc_cdc_fifo_out_last;
wire          main_ethmac_tx_converter_sink_valid;
wire          main_ethmac_tx_converter_sink_ready;
wire          main_ethmac_tx_converter_sink_first;
wire          main_ethmac_tx_converter_sink_last;
wire   [31:0] main_ethmac_tx_converter_sink_payload_data;
wire    [3:0] main_ethmac_tx_converter_sink_payload_last_be;
wire    [3:0] main_ethmac_tx_converter_sink_payload_error;
wire          main_ethmac_tx_converter_source_valid;
wire          main_ethmac_tx_converter_source_ready;
wire          main_ethmac_tx_converter_source_first;
wire          main_ethmac_tx_converter_source_last;
wire    [7:0] main_ethmac_tx_converter_source_payload_data;
wire          main_ethmac_tx_converter_source_payload_last_be;
wire          main_ethmac_tx_converter_source_payload_error;
wire          main_ethmac_tx_converter_converter_sink_valid;
wire          main_ethmac_tx_converter_converter_sink_ready;
wire          main_ethmac_tx_converter_converter_sink_first;
wire          main_ethmac_tx_converter_converter_sink_last;
reg    [39:0] main_ethmac_tx_converter_converter_sink_payload_data = 40'd0;
wire          main_ethmac_tx_converter_converter_source_valid;
wire          main_ethmac_tx_converter_converter_source_ready;
wire          main_ethmac_tx_converter_converter_source_first;
wire          main_ethmac_tx_converter_converter_source_last;
reg     [9:0] main_ethmac_tx_converter_converter_source_payload_data = 10'd0;
wire          main_ethmac_tx_converter_converter_source_payload_valid_token_count;
reg     [1:0] main_ethmac_tx_converter_converter_mux = 2'd0;
wire          main_ethmac_tx_converter_converter_first;
wire          main_ethmac_tx_converter_converter_last;
wire          main_ethmac_tx_converter_source_source_valid;
wire          main_ethmac_tx_converter_source_source_ready;
wire          main_ethmac_tx_converter_source_source_first;
wire          main_ethmac_tx_converter_source_source_last;
wire    [9:0] main_ethmac_tx_converter_source_source_payload_data;
wire          main_ethmac_tx_last_be_sink_valid;
reg           main_ethmac_tx_last_be_sink_ready = 1'd0;
wire          main_ethmac_tx_last_be_sink_first;
wire          main_ethmac_tx_last_be_sink_last;
wire    [7:0] main_ethmac_tx_last_be_sink_payload_data;
wire          main_ethmac_tx_last_be_sink_payload_last_be;
wire          main_ethmac_tx_last_be_sink_payload_error;
reg           main_ethmac_tx_last_be_source_valid = 1'd0;
wire          main_ethmac_tx_last_be_source_ready;
reg           main_ethmac_tx_last_be_source_first = 1'd0;
reg           main_ethmac_tx_last_be_source_last = 1'd0;
reg     [7:0] main_ethmac_tx_last_be_source_payload_data = 8'd0;
reg           main_ethmac_tx_last_be_source_payload_last_be = 1'd0;
reg           main_ethmac_tx_last_be_source_payload_error = 1'd0;
wire          main_ethmac_tx_padding_sink_valid;
reg           main_ethmac_tx_padding_sink_ready = 1'd0;
wire          main_ethmac_tx_padding_sink_first;
wire          main_ethmac_tx_padding_sink_last;
wire    [7:0] main_ethmac_tx_padding_sink_payload_data;
wire          main_ethmac_tx_padding_sink_payload_last_be;
wire          main_ethmac_tx_padding_sink_payload_error;
reg           main_ethmac_tx_padding_source_valid = 1'd0;
wire          main_ethmac_tx_padding_source_ready;
reg           main_ethmac_tx_padding_source_first = 1'd0;
reg           main_ethmac_tx_padding_source_last = 1'd0;
reg     [7:0] main_ethmac_tx_padding_source_payload_data = 8'd0;
reg           main_ethmac_tx_padding_source_payload_last_be = 1'd0;
reg           main_ethmac_tx_padding_source_payload_error = 1'd0;
reg    [15:0] main_ethmac_tx_padding_counter = 16'd0;
wire          main_ethmac_tx_padding_counter_done;
wire          main_ethmac_tx_crc_sink_valid;
reg           main_ethmac_tx_crc_sink_ready = 1'd0;
wire          main_ethmac_tx_crc_sink_first;
wire          main_ethmac_tx_crc_sink_last;
wire    [7:0] main_ethmac_tx_crc_sink_payload_data;
wire          main_ethmac_tx_crc_sink_payload_last_be;
wire          main_ethmac_tx_crc_sink_payload_error;
reg           main_ethmac_tx_crc_source_valid = 1'd0;
wire          main_ethmac_tx_crc_source_ready;
reg           main_ethmac_tx_crc_source_first = 1'd0;
reg           main_ethmac_tx_crc_source_last = 1'd0;
reg     [7:0] main_ethmac_tx_crc_source_payload_data = 8'd0;
reg           main_ethmac_tx_crc_source_payload_last_be = 1'd0;
reg           main_ethmac_tx_crc_source_payload_error = 1'd0;
reg     [7:0] main_ethmac_tx_crc_data0 = 8'd0;
reg           main_ethmac_tx_crc_last_be0 = 1'd0;
reg    [31:0] main_ethmac_tx_crc_value = 32'd0;
reg           main_ethmac_tx_crc_error = 1'd0;
reg           main_ethmac_tx_crc_last_be1 = 1'd0;
wire    [7:0] main_ethmac_tx_crc_data1;
wire   [31:0] main_ethmac_tx_crc_last;
reg    [31:0] main_ethmac_tx_crc_next = 32'd0;
reg    [31:0] main_ethmac_tx_crc_reg = 32'd4294967295;
reg           main_ethmac_tx_crc_ce = 1'd0;
reg           main_ethmac_tx_crc_reset = 1'd0;
reg    [31:0] main_ethmac_tx_crc_crc_packet = 32'd0;
reg           main_ethmac_tx_crc_last_be2 = 1'd0;
reg     [1:0] main_ethmac_tx_crc_cnt = 2'd3;
wire          main_ethmac_tx_crc_cnt_done;
reg           main_ethmac_tx_crc_is_ongoing0 = 1'd0;
reg           main_ethmac_tx_crc_is_ongoing1 = 1'd0;
wire          main_ethmac_tx_crc_sink_sink_valid;
wire          main_ethmac_tx_crc_sink_sink_ready;
wire          main_ethmac_tx_crc_sink_sink_first;
wire          main_ethmac_tx_crc_sink_sink_last;
wire    [7:0] main_ethmac_tx_crc_sink_sink_payload_data;
wire          main_ethmac_tx_crc_sink_sink_payload_last_be;
wire          main_ethmac_tx_crc_sink_sink_payload_error;
wire          main_ethmac_tx_crc_source_source_valid;
wire          main_ethmac_tx_crc_source_source_ready;
wire          main_ethmac_tx_crc_source_source_first;
wire          main_ethmac_tx_crc_source_source_last;
wire    [7:0] main_ethmac_tx_crc_source_source_payload_data;
wire          main_ethmac_tx_crc_source_source_payload_last_be;
wire          main_ethmac_tx_crc_source_source_payload_error;
wire          main_ethmac_tx_crc_pipe_valid_sink_valid;
wire          main_ethmac_tx_crc_pipe_valid_sink_ready;
wire          main_ethmac_tx_crc_pipe_valid_sink_first;
wire          main_ethmac_tx_crc_pipe_valid_sink_last;
wire    [7:0] main_ethmac_tx_crc_pipe_valid_sink_payload_data;
wire          main_ethmac_tx_crc_pipe_valid_sink_payload_last_be;
wire          main_ethmac_tx_crc_pipe_valid_sink_payload_error;
reg           main_ethmac_tx_crc_pipe_valid_source_valid = 1'd0;
wire          main_ethmac_tx_crc_pipe_valid_source_ready;
reg           main_ethmac_tx_crc_pipe_valid_source_first = 1'd0;
reg           main_ethmac_tx_crc_pipe_valid_source_last = 1'd0;
reg     [7:0] main_ethmac_tx_crc_pipe_valid_source_payload_data = 8'd0;
reg           main_ethmac_tx_crc_pipe_valid_source_payload_last_be = 1'd0;
reg           main_ethmac_tx_crc_pipe_valid_source_payload_error = 1'd0;
wire          main_ethmac_tx_preamble_sink_valid;
reg           main_ethmac_tx_preamble_sink_ready = 1'd0;
wire          main_ethmac_tx_preamble_sink_first;
wire          main_ethmac_tx_preamble_sink_last;
wire    [7:0] main_ethmac_tx_preamble_sink_payload_data;
wire          main_ethmac_tx_preamble_sink_payload_last_be;
wire          main_ethmac_tx_preamble_sink_payload_error;
reg           main_ethmac_tx_preamble_source_valid = 1'd0;
wire          main_ethmac_tx_preamble_source_ready;
reg           main_ethmac_tx_preamble_source_first = 1'd0;
reg           main_ethmac_tx_preamble_source_last = 1'd0;
reg     [7:0] main_ethmac_tx_preamble_source_payload_data = 8'd0;
wire          main_ethmac_tx_preamble_source_payload_last_be;
reg           main_ethmac_tx_preamble_source_payload_error = 1'd0;
reg    [63:0] main_ethmac_tx_preamble_preamble = 64'd15372286728091293013;
reg     [2:0] main_ethmac_tx_preamble_count = 3'd0;
wire          main_ethmac_tx_gap_sink_valid;
reg           main_ethmac_tx_gap_sink_ready = 1'd0;
wire          main_ethmac_tx_gap_sink_first;
wire          main_ethmac_tx_gap_sink_last;
wire    [7:0] main_ethmac_tx_gap_sink_payload_data;
wire          main_ethmac_tx_gap_sink_payload_last_be;
wire          main_ethmac_tx_gap_sink_payload_error;
reg           main_ethmac_tx_gap_source_valid = 1'd0;
wire          main_ethmac_tx_gap_source_ready;
reg           main_ethmac_tx_gap_source_first = 1'd0;
reg           main_ethmac_tx_gap_source_last = 1'd0;
reg     [7:0] main_ethmac_tx_gap_source_payload_data = 8'd0;
reg           main_ethmac_tx_gap_source_payload_last_be = 1'd0;
reg           main_ethmac_tx_gap_source_payload_error = 1'd0;
reg     [3:0] main_ethmac_tx_gap_counter = 4'd0;
reg    [31:0] main_ethmac_preamble_errors_status = 32'd0;
wire          main_ethmac_preamble_errors_we;
reg           main_ethmac_preamble_errors_re = 1'd0;
reg    [31:0] main_ethmac_crc_errors_status = 32'd0;
wire          main_ethmac_crc_errors_we;
reg           main_ethmac_crc_errors_re = 1'd0;
wire          main_ethmac_rx_preamble_sink_valid;
reg           main_ethmac_rx_preamble_sink_ready = 1'd0;
wire          main_ethmac_rx_preamble_sink_first;
wire          main_ethmac_rx_preamble_sink_last;
wire    [7:0] main_ethmac_rx_preamble_sink_payload_data;
wire          main_ethmac_rx_preamble_sink_payload_last_be;
wire          main_ethmac_rx_preamble_sink_payload_error;
reg           main_ethmac_rx_preamble_source_valid = 1'd0;
wire          main_ethmac_rx_preamble_source_ready;
reg           main_ethmac_rx_preamble_source_first = 1'd0;
reg           main_ethmac_rx_preamble_source_last = 1'd0;
wire    [7:0] main_ethmac_rx_preamble_source_payload_data;
wire          main_ethmac_rx_preamble_source_payload_last_be;
reg           main_ethmac_rx_preamble_source_payload_error = 1'd0;
reg           main_ethmac_rx_preamble_error = 1'd0;
reg    [63:0] main_ethmac_rx_preamble_preamble = 64'd15372286728091293013;
wire          main_ethmac_pulsesynchronizer0_i;
wire          main_ethmac_pulsesynchronizer0_o;
reg           main_ethmac_pulsesynchronizer0_toggle_i = 1'd0;
wire          main_ethmac_pulsesynchronizer0_toggle_o;
reg           main_ethmac_pulsesynchronizer0_toggle_o_r = 1'd0;
wire          main_ethmac_liteethmaccrc32checker_sink_sink_valid;
reg           main_ethmac_liteethmaccrc32checker_sink_sink_ready = 1'd0;
wire          main_ethmac_liteethmaccrc32checker_sink_sink_first;
wire          main_ethmac_liteethmaccrc32checker_sink_sink_last;
wire    [7:0] main_ethmac_liteethmaccrc32checker_sink_sink_payload_data;
wire          main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be;
wire          main_ethmac_liteethmaccrc32checker_sink_sink_payload_error;
reg           main_ethmac_liteethmaccrc32checker_source_source_valid = 1'd0;
wire          main_ethmac_liteethmaccrc32checker_source_source_ready;
reg           main_ethmac_liteethmaccrc32checker_source_source_first = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_source_source_last = 1'd0;
reg     [7:0] main_ethmac_liteethmaccrc32checker_source_source_payload_data = 8'd0;
reg           main_ethmac_liteethmaccrc32checker_source_source_payload_last_be = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_source_source_payload_error = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_error = 1'd0;
wire    [7:0] main_ethmac_liteethmaccrc32checker_crc_data0;
wire          main_ethmac_liteethmaccrc32checker_crc_last_be0;
reg    [31:0] main_ethmac_liteethmaccrc32checker_crc_value = 32'd0;
reg           main_ethmac_liteethmaccrc32checker_crc_error0 = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_crc_last_be1 = 1'd0;
wire    [7:0] main_ethmac_liteethmaccrc32checker_crc_data1;
wire   [31:0] main_ethmac_liteethmaccrc32checker_crc_last;
reg    [31:0] main_ethmac_liteethmaccrc32checker_crc_next = 32'd0;
reg    [31:0] main_ethmac_liteethmaccrc32checker_crc_reg = 32'd4294967295;
reg           main_ethmac_liteethmaccrc32checker_crc_ce = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_crc_reset = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_syncfifo_sink_valid = 1'd0;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_sink_ready;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_sink_first;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_sink_last;
wire    [7:0] main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_data;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_last_be;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_error;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_source_valid;
reg           main_ethmac_liteethmaccrc32checker_syncfifo_source_ready = 1'd0;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_source_first;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_source_last;
wire    [7:0] main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_data;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_last_be;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_error;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_we;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_writable;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_re;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_readable;
wire   [11:0] main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_din;
wire   [11:0] main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_dout;
reg     [2:0] main_ethmac_liteethmaccrc32checker_syncfifo_level = 3'd0;
reg           main_ethmac_liteethmaccrc32checker_syncfifo_replace = 1'd0;
reg     [2:0] main_ethmac_liteethmaccrc32checker_syncfifo_produce = 3'd0;
reg     [2:0] main_ethmac_liteethmaccrc32checker_syncfifo_consume = 3'd0;
reg     [2:0] main_ethmac_liteethmaccrc32checker_syncfifo_wrport_adr = 3'd0;
wire   [11:0] main_ethmac_liteethmaccrc32checker_syncfifo_wrport_dat_r;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_wrport_we;
wire   [11:0] main_ethmac_liteethmaccrc32checker_syncfifo_wrport_dat_w;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_do_read;
wire    [2:0] main_ethmac_liteethmaccrc32checker_syncfifo_rdport_adr;
wire   [11:0] main_ethmac_liteethmaccrc32checker_syncfifo_rdport_dat_r;
wire    [7:0] main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_data;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_last_be;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_error;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_first;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_last;
wire    [7:0] main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_data;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_last_be;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_error;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_first;
wire          main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_last;
reg           main_ethmac_liteethmaccrc32checker_fifo_reset = 1'd0;
wire          main_ethmac_liteethmaccrc32checker_fifo_in;
wire          main_ethmac_liteethmaccrc32checker_fifo_out;
wire          main_ethmac_liteethmaccrc32checker_fifo_full;
reg           main_ethmac_liteethmaccrc32checker_last_be = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_crc_error1 = 1'd0;
wire          main_ethmac_bufferizeendpoints_sink_sink_valid;
wire          main_ethmac_bufferizeendpoints_sink_sink_ready;
wire          main_ethmac_bufferizeendpoints_sink_sink_first;
wire          main_ethmac_bufferizeendpoints_sink_sink_last;
wire    [7:0] main_ethmac_bufferizeendpoints_sink_sink_payload_data;
wire          main_ethmac_bufferizeendpoints_sink_sink_payload_last_be;
wire          main_ethmac_bufferizeendpoints_sink_sink_payload_error;
wire          main_ethmac_bufferizeendpoints_source_source_valid;
wire          main_ethmac_bufferizeendpoints_source_source_ready;
wire          main_ethmac_bufferizeendpoints_source_source_first;
wire          main_ethmac_bufferizeendpoints_source_source_last;
wire    [7:0] main_ethmac_bufferizeendpoints_source_source_payload_data;
wire          main_ethmac_bufferizeendpoints_source_source_payload_last_be;
wire          main_ethmac_bufferizeendpoints_source_source_payload_error;
wire          main_ethmac_bufferizeendpoints_pipe_valid_sink_valid;
wire          main_ethmac_bufferizeendpoints_pipe_valid_sink_ready;
wire          main_ethmac_bufferizeendpoints_pipe_valid_sink_first;
wire          main_ethmac_bufferizeendpoints_pipe_valid_sink_last;
wire    [7:0] main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_data;
wire          main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_last_be;
wire          main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_error;
reg           main_ethmac_bufferizeendpoints_pipe_valid_source_valid = 1'd0;
wire          main_ethmac_bufferizeendpoints_pipe_valid_source_ready;
reg           main_ethmac_bufferizeendpoints_pipe_valid_source_first = 1'd0;
reg           main_ethmac_bufferizeendpoints_pipe_valid_source_last = 1'd0;
reg     [7:0] main_ethmac_bufferizeendpoints_pipe_valid_source_payload_data = 8'd0;
reg           main_ethmac_bufferizeendpoints_pipe_valid_source_payload_last_be = 1'd0;
reg           main_ethmac_bufferizeendpoints_pipe_valid_source_payload_error = 1'd0;
wire          main_ethmac_pulsesynchronizer1_i;
wire          main_ethmac_pulsesynchronizer1_o;
reg           main_ethmac_pulsesynchronizer1_toggle_i = 1'd0;
wire          main_ethmac_pulsesynchronizer1_toggle_o;
reg           main_ethmac_pulsesynchronizer1_toggle_o_r = 1'd0;
wire          main_ethmac_rx_padding_sink_valid;
wire          main_ethmac_rx_padding_sink_ready;
wire          main_ethmac_rx_padding_sink_first;
wire          main_ethmac_rx_padding_sink_last;
wire    [7:0] main_ethmac_rx_padding_sink_payload_data;
wire          main_ethmac_rx_padding_sink_payload_last_be;
wire          main_ethmac_rx_padding_sink_payload_error;
wire          main_ethmac_rx_padding_source_valid;
wire          main_ethmac_rx_padding_source_ready;
wire          main_ethmac_rx_padding_source_first;
wire          main_ethmac_rx_padding_source_last;
wire    [7:0] main_ethmac_rx_padding_source_payload_data;
wire          main_ethmac_rx_padding_source_payload_last_be;
wire          main_ethmac_rx_padding_source_payload_error;
wire          main_ethmac_rx_last_be_sink_valid;
wire          main_ethmac_rx_last_be_sink_ready;
wire          main_ethmac_rx_last_be_sink_first;
wire          main_ethmac_rx_last_be_sink_last;
wire    [7:0] main_ethmac_rx_last_be_sink_payload_data;
wire          main_ethmac_rx_last_be_sink_payload_last_be;
wire          main_ethmac_rx_last_be_sink_payload_error;
wire          main_ethmac_rx_last_be_source_valid;
wire          main_ethmac_rx_last_be_source_ready;
wire          main_ethmac_rx_last_be_source_first;
wire          main_ethmac_rx_last_be_source_last;
wire    [7:0] main_ethmac_rx_last_be_source_payload_data;
reg           main_ethmac_rx_last_be_source_payload_last_be = 1'd0;
wire          main_ethmac_rx_last_be_source_payload_error;
wire          main_ethmac_rx_converter_sink_valid;
wire          main_ethmac_rx_converter_sink_ready;
wire          main_ethmac_rx_converter_sink_first;
wire          main_ethmac_rx_converter_sink_last;
wire    [7:0] main_ethmac_rx_converter_sink_payload_data;
wire          main_ethmac_rx_converter_sink_payload_last_be;
wire          main_ethmac_rx_converter_sink_payload_error;
wire          main_ethmac_rx_converter_source_valid;
wire          main_ethmac_rx_converter_source_ready;
wire          main_ethmac_rx_converter_source_first;
wire          main_ethmac_rx_converter_source_last;
reg    [31:0] main_ethmac_rx_converter_source_payload_data = 32'd0;
reg     [3:0] main_ethmac_rx_converter_source_payload_last_be = 4'd0;
reg     [3:0] main_ethmac_rx_converter_source_payload_error = 4'd0;
wire          main_ethmac_rx_converter_converter_sink_valid;
wire          main_ethmac_rx_converter_converter_sink_ready;
wire          main_ethmac_rx_converter_converter_sink_first;
wire          main_ethmac_rx_converter_converter_sink_last;
wire    [9:0] main_ethmac_rx_converter_converter_sink_payload_data;
wire          main_ethmac_rx_converter_converter_source_valid;
wire          main_ethmac_rx_converter_converter_source_ready;
reg           main_ethmac_rx_converter_converter_source_first = 1'd0;
reg           main_ethmac_rx_converter_converter_source_last = 1'd0;
reg    [39:0] main_ethmac_rx_converter_converter_source_payload_data = 40'd0;
reg     [2:0] main_ethmac_rx_converter_converter_source_payload_valid_token_count = 3'd0;
reg     [1:0] main_ethmac_rx_converter_converter_demux = 2'd0;
wire          main_ethmac_rx_converter_converter_load_part;
reg           main_ethmac_rx_converter_converter_strobe_all = 1'd0;
wire          main_ethmac_rx_converter_source_source_valid;
wire          main_ethmac_rx_converter_source_source_ready;
wire          main_ethmac_rx_converter_source_source_first;
wire          main_ethmac_rx_converter_source_source_last;
wire   [39:0] main_ethmac_rx_converter_source_source_payload_data;
wire          main_ethmac_rx_cdc_sink_sink_valid;
wire          main_ethmac_rx_cdc_sink_sink_ready;
wire          main_ethmac_rx_cdc_sink_sink_first;
wire          main_ethmac_rx_cdc_sink_sink_last;
wire   [31:0] main_ethmac_rx_cdc_sink_sink_payload_data;
wire    [3:0] main_ethmac_rx_cdc_sink_sink_payload_last_be;
wire    [3:0] main_ethmac_rx_cdc_sink_sink_payload_error;
wire          main_ethmac_rx_cdc_source_source_valid;
wire          main_ethmac_rx_cdc_source_source_ready;
wire          main_ethmac_rx_cdc_source_source_first;
wire          main_ethmac_rx_cdc_source_source_last;
wire   [31:0] main_ethmac_rx_cdc_source_source_payload_data;
wire    [3:0] main_ethmac_rx_cdc_source_source_payload_last_be;
wire    [3:0] main_ethmac_rx_cdc_source_source_payload_error;
wire          main_ethmac_rx_cdc_cdc_sink_valid;
wire          main_ethmac_rx_cdc_cdc_sink_ready;
wire          main_ethmac_rx_cdc_cdc_sink_first;
wire          main_ethmac_rx_cdc_cdc_sink_last;
wire   [31:0] main_ethmac_rx_cdc_cdc_sink_payload_data;
wire    [3:0] main_ethmac_rx_cdc_cdc_sink_payload_last_be;
wire    [3:0] main_ethmac_rx_cdc_cdc_sink_payload_error;
wire          main_ethmac_rx_cdc_cdc_source_valid;
wire          main_ethmac_rx_cdc_cdc_source_ready;
wire          main_ethmac_rx_cdc_cdc_source_first;
wire          main_ethmac_rx_cdc_cdc_source_last;
wire   [31:0] main_ethmac_rx_cdc_cdc_source_payload_data;
wire    [3:0] main_ethmac_rx_cdc_cdc_source_payload_last_be;
wire    [3:0] main_ethmac_rx_cdc_cdc_source_payload_error;
wire          main_ethmac_rx_cdc_cdc_asyncfifo_we;
wire          main_ethmac_rx_cdc_cdc_asyncfifo_writable;
wire          main_ethmac_rx_cdc_cdc_asyncfifo_re;
wire          main_ethmac_rx_cdc_cdc_asyncfifo_readable;
wire   [41:0] main_ethmac_rx_cdc_cdc_asyncfifo_din;
wire   [41:0] main_ethmac_rx_cdc_cdc_asyncfifo_dout;
wire          main_ethmac_rx_cdc_cdc_graycounter0_ce;
(* dont_touch = "true" *)
reg     [5:0] main_ethmac_rx_cdc_cdc_graycounter0_q = 6'd0;
wire    [5:0] main_ethmac_rx_cdc_cdc_graycounter0_q_next;
reg     [5:0] main_ethmac_rx_cdc_cdc_graycounter0_q_binary = 6'd0;
reg     [5:0] main_ethmac_rx_cdc_cdc_graycounter0_q_next_binary = 6'd0;
wire          main_ethmac_rx_cdc_cdc_graycounter1_ce;
(* dont_touch = "true" *)
reg     [5:0] main_ethmac_rx_cdc_cdc_graycounter1_q = 6'd0;
wire    [5:0] main_ethmac_rx_cdc_cdc_graycounter1_q_next;
reg     [5:0] main_ethmac_rx_cdc_cdc_graycounter1_q_binary = 6'd0;
reg     [5:0] main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary = 6'd0;
wire    [5:0] main_ethmac_rx_cdc_cdc_produce_rdomain;
wire    [5:0] main_ethmac_rx_cdc_cdc_consume_wdomain;
wire    [4:0] main_ethmac_rx_cdc_cdc_wrport_adr;
wire   [41:0] main_ethmac_rx_cdc_cdc_wrport_dat_r;
wire          main_ethmac_rx_cdc_cdc_wrport_we;
wire   [41:0] main_ethmac_rx_cdc_cdc_wrport_dat_w;
wire    [4:0] main_ethmac_rx_cdc_cdc_rdport_adr;
wire   [41:0] main_ethmac_rx_cdc_cdc_rdport_dat_r;
wire   [31:0] main_ethmac_rx_cdc_cdc_fifo_in_payload_data;
wire    [3:0] main_ethmac_rx_cdc_cdc_fifo_in_payload_last_be;
wire    [3:0] main_ethmac_rx_cdc_cdc_fifo_in_payload_error;
wire          main_ethmac_rx_cdc_cdc_fifo_in_first;
wire          main_ethmac_rx_cdc_cdc_fifo_in_last;
wire   [31:0] main_ethmac_rx_cdc_cdc_fifo_out_payload_data;
wire    [3:0] main_ethmac_rx_cdc_cdc_fifo_out_payload_last_be;
wire    [3:0] main_ethmac_rx_cdc_cdc_fifo_out_payload_error;
wire          main_ethmac_rx_cdc_cdc_fifo_out_first;
wire          main_ethmac_rx_cdc_cdc_fifo_out_last;
wire          main_ethmac_sink_sink_valid;
wire          main_ethmac_sink_sink_ready;
wire          main_ethmac_sink_sink_first;
wire          main_ethmac_sink_sink_last;
wire   [31:0] main_ethmac_sink_sink_payload_data;
wire    [3:0] main_ethmac_sink_sink_payload_last_be;
wire    [3:0] main_ethmac_sink_sink_payload_error;
wire          main_ethmac_source_source_valid;
wire          main_ethmac_source_source_ready;
wire          main_ethmac_source_source_first;
wire          main_ethmac_source_source_last;
wire   [31:0] main_ethmac_source_source_payload_data;
wire    [3:0] main_ethmac_source_source_payload_last_be;
wire    [3:0] main_ethmac_source_source_payload_error;
wire   [29:0] main_ethmac_bus_adr;
wire   [31:0] main_ethmac_bus_dat_w;
wire   [31:0] main_ethmac_bus_dat_r;
wire    [3:0] main_ethmac_bus_sel;
wire          main_ethmac_bus_cyc;
wire          main_ethmac_bus_stb;
wire          main_ethmac_bus_ack;
wire          main_ethmac_bus_we;
wire    [2:0] main_ethmac_bus_cti;
wire    [1:0] main_ethmac_bus_bte;
wire          main_ethmac_bus_err;
wire          main_ethmac_sram0_sink_valid;
reg           main_ethmac_sram1_sink_ready = 1'd1;
wire          main_ethmac_sram2_sink_first;
wire          main_ethmac_sram3_sink_last;
wire   [31:0] main_ethmac_sram4_sink_payload_data;
wire    [3:0] main_ethmac_sram5_sink_payload_last_be;
wire    [3:0] main_ethmac_sram6_sink_payload_error;
wire          main_ethmac_sram7_status;
wire          main_ethmac_sram8_we;
reg           main_ethmac_sram9_re = 1'd0;
wire   [10:0] main_ethmac_sram10_status;
wire          main_ethmac_sram11_we;
reg           main_ethmac_sram12_re = 1'd0;
reg    [31:0] main_ethmac_sram13_status = 32'd0;
wire          main_ethmac_sram14_we;
reg           main_ethmac_sram15_re = 1'd0;
wire          main_ethmac_sram16_irq;
wire          main_ethmac_sram17_status;
wire          main_ethmac_sram18_pending;
wire          main_ethmac_sram19_trigger;
reg           main_ethmac_sram20_clear = 1'd0;
wire          main_ethmac_sram21_available;
wire          main_ethmac_sram22_status;
wire          main_ethmac_sram23_we;
reg           main_ethmac_sram24_re = 1'd0;
wire          main_ethmac_sram25_available;
wire          main_ethmac_sram26_status;
wire          main_ethmac_sram27_we;
reg           main_ethmac_sram28_re = 1'd0;
reg           main_ethmac_sram29_r = 1'd0;
wire          main_ethmac_sram30_available;
reg           main_ethmac_sram31_storage = 1'd0;
reg           main_ethmac_sram32_re = 1'd0;
reg           main_ethmac_write = 1'd0;
reg           main_ethmac_slot = 1'd0;
reg    [10:0] main_ethmac_sram35_length = 11'd0;
reg     [3:0] main_ethmac_length_inc = 4'd0;
reg           main_ethmac_sram37_sink_valid = 1'd0;
wire          main_ethmac_sram38_sink_ready;
reg           main_ethmac_sram39_sink_first = 1'd0;
reg           main_ethmac_sram40_sink_last = 1'd0;
reg           main_ethmac_sram41_sink_payload_slot = 1'd0;
reg    [10:0] main_ethmac_sram42_sink_payload_length = 11'd0;
wire          main_ethmac_sram43_source_valid;
wire          main_ethmac_sram44_source_ready;
wire          main_ethmac_sram45_source_first;
wire          main_ethmac_sram46_source_last;
wire          main_ethmac_sram47_source_payload_slot;
wire   [10:0] main_ethmac_sram48_source_payload_length;
wire          main_ethmac_sram49_we;
wire          main_ethmac_sram50_writable;
wire          main_ethmac_sram51_re;
wire          main_ethmac_sram52_readable;
wire   [13:0] main_ethmac_sram53_din;
wire   [13:0] main_ethmac_sram54_dout;
reg     [1:0] main_ethmac_sram55_level = 2'd0;
reg           main_ethmac_sram56_replace = 1'd0;
reg           main_ethmac_sram57_produce = 1'd0;
reg           main_ethmac_sram58_consume = 1'd0;
reg           main_ethmac_sram59_adr = 1'd0;
wire   [13:0] main_ethmac_sram60_dat_r;
wire          main_ethmac_sram61_we;
wire   [13:0] main_ethmac_sram62_dat_w;
wire          main_ethmac_sram63_do_read;
wire          main_ethmac_sram64_adr;
wire   [13:0] main_ethmac_sram65_dat_r;
wire          main_ethmac_sram66_fifo_in_payload_slot;
wire   [10:0] main_ethmac_sram67_fifo_in_payload_length;
wire          main_ethmac_sram68_fifo_in_first;
wire          main_ethmac_sram69_fifo_in_last;
wire          main_ethmac_sram70_fifo_out_payload_slot;
wire   [10:0] main_ethmac_sram71_fifo_out_payload_length;
wire          main_ethmac_sram72_fifo_out_first;
wire          main_ethmac_sram73_fifo_out_last;
wire   [31:0] main_ethmac_wr_data;
reg     [8:0] main_ethmac_sram75_adr = 9'd0;
wire   [31:0] main_ethmac_sram76_dat_r;
reg           main_ethmac_sram77_we = 1'd0;
reg    [31:0] main_ethmac_sram78_dat_w = 32'd0;
reg     [8:0] main_ethmac_sram79_adr = 9'd0;
wire   [31:0] main_ethmac_sram80_dat_r;
reg           main_ethmac_sram81_we = 1'd0;
reg    [31:0] main_ethmac_sram82_dat_w = 32'd0;
reg           main_ethmac_sram83_source_valid = 1'd0;
wire          main_ethmac_sram84_source_ready;
reg           main_ethmac_sram85_source_first = 1'd0;
reg           main_ethmac_sram86_source_last = 1'd0;
wire   [31:0] main_ethmac_sram87_source_payload_data;
reg     [3:0] main_ethmac_sram88_source_payload_last_be = 4'd0;
reg     [3:0] main_ethmac_sram89_source_payload_error = 4'd0;
reg           main_ethmac_start_re = 1'd0;
wire          main_ethmac_start_r;
reg           main_ethmac_start_we = 1'd0;
reg           main_ethmac_start_w = 1'd0;
wire          main_ethmac_sram94_status;
wire          main_ethmac_sram95_we;
reg           main_ethmac_sram96_re = 1'd0;
wire    [1:0] main_ethmac_sram97_status;
wire          main_ethmac_sram98_we;
reg           main_ethmac_sram99_re = 1'd0;
reg           main_ethmac_sram100_storage = 1'd0;
reg           main_ethmac_sram101_re = 1'd0;
reg    [10:0] main_ethmac_sram102_storage = 11'd0;
reg           main_ethmac_sram103_re = 1'd0;
wire          main_ethmac_sram104_irq;
wire          main_ethmac_sram105_status;
reg           main_ethmac_sram106_pending = 1'd0;
reg           main_ethmac_sram107_trigger = 1'd0;
reg           main_ethmac_sram108_clear = 1'd0;
wire          main_ethmac_sram109_event0;
wire          main_ethmac_sram110_status;
wire          main_ethmac_sram111_we;
reg           main_ethmac_sram112_re = 1'd0;
wire          main_ethmac_sram113_event0;
wire          main_ethmac_sram114_status;
wire          main_ethmac_sram115_we;
reg           main_ethmac_sram116_re = 1'd0;
reg           main_ethmac_sram117_r = 1'd0;
wire          main_ethmac_sram118_event0;
reg           main_ethmac_sram119_storage = 1'd0;
reg           main_ethmac_sram120_re = 1'd0;
reg           main_ethmac_read = 1'd0;
reg    [10:0] main_ethmac_sram122_length = 11'd0;
wire          main_ethmac_sram123_sink_valid;
wire          main_ethmac_sram124_sink_ready;
reg           main_ethmac_sram125_sink_first = 1'd0;
reg           main_ethmac_sram126_sink_last = 1'd0;
wire          main_ethmac_sram127_sink_payload_slot;
wire   [10:0] main_ethmac_sram128_sink_payload_length;
wire          main_ethmac_sram129_source_valid;
reg           main_ethmac_sram130_source_ready = 1'd0;
wire          main_ethmac_sram131_source_first;
wire          main_ethmac_sram132_source_last;
wire          main_ethmac_sram133_source_payload_slot;
wire   [10:0] main_ethmac_sram134_source_payload_length;
wire          main_ethmac_sram135_we;
wire          main_ethmac_sram136_writable;
wire          main_ethmac_sram137_re;
wire          main_ethmac_sram138_readable;
wire   [13:0] main_ethmac_sram139_din;
wire   [13:0] main_ethmac_sram140_dout;
reg     [1:0] main_ethmac_sram141_level = 2'd0;
reg           main_ethmac_sram142_replace = 1'd0;
reg           main_ethmac_sram143_produce = 1'd0;
reg           main_ethmac_sram144_consume = 1'd0;
reg           main_ethmac_sram145_adr = 1'd0;
wire   [13:0] main_ethmac_sram146_dat_r;
wire          main_ethmac_sram147_we;
wire   [13:0] main_ethmac_sram148_dat_w;
wire          main_ethmac_sram149_do_read;
wire          main_ethmac_sram150_adr;
wire   [13:0] main_ethmac_sram151_dat_r;
wire          main_ethmac_sram152_fifo_in_payload_slot;
wire   [10:0] main_ethmac_sram153_fifo_in_payload_length;
wire          main_ethmac_sram154_fifo_in_first;
wire          main_ethmac_sram155_fifo_in_last;
wire          main_ethmac_sram156_fifo_out_payload_slot;
wire   [10:0] main_ethmac_sram157_fifo_out_payload_length;
wire          main_ethmac_sram158_fifo_out_first;
wire          main_ethmac_sram159_fifo_out_last;
reg    [31:0] main_ethmac_rd_data = 32'd0;
wire    [8:0] main_ethmac_sram161_adr;
wire   [31:0] main_ethmac_sram162_dat_r;
wire          main_ethmac_sram163_re;
wire    [8:0] main_ethmac_sram164_adr;
wire   [31:0] main_ethmac_sram165_dat_r;
wire          main_ethmac_sram166_re;
wire          main_ethmac_sram167_irq;
wire   [29:0] main_ethmac_interface0_adr;
wire   [31:0] main_ethmac_interface0_dat_w;
wire   [31:0] main_ethmac_interface0_dat_r;
wire    [3:0] main_ethmac_interface0_sel;
wire          main_ethmac_interface0_cyc;
wire          main_ethmac_interface0_stb;
reg           main_ethmac_interface0_ack = 1'd0;
wire          main_ethmac_interface0_we;
wire    [2:0] main_ethmac_interface0_cti;
wire    [1:0] main_ethmac_interface0_bte;
reg           main_ethmac_interface0_err = 1'd0;
reg           main_ethmac_sram2_adr_burst = 1'd0;
wire    [8:0] main_ethmac_sram2_adr;
wire   [31:0] main_ethmac_sram2_dat_r;
wire   [29:0] main_ethmac_interface1_adr;
wire   [31:0] main_ethmac_interface1_dat_w;
wire   [31:0] main_ethmac_interface1_dat_r;
wire    [3:0] main_ethmac_interface1_sel;
wire          main_ethmac_interface1_cyc;
wire          main_ethmac_interface1_stb;
reg           main_ethmac_interface1_ack = 1'd0;
wire          main_ethmac_interface1_we;
wire    [2:0] main_ethmac_interface1_cti;
wire    [1:0] main_ethmac_interface1_bte;
reg           main_ethmac_interface1_err = 1'd0;
reg           main_ethmac_sram3_adr_burst = 1'd0;
wire    [8:0] main_ethmac_sram3_adr;
wire   [31:0] main_ethmac_sram3_dat_r;
wire   [29:0] main_ethmac_interface2_adr;
wire   [31:0] main_ethmac_interface2_dat_w;
wire   [31:0] main_ethmac_interface2_dat_r;
wire    [3:0] main_ethmac_interface2_sel;
wire          main_ethmac_interface2_cyc;
wire          main_ethmac_interface2_stb;
reg           main_ethmac_interface2_ack = 1'd0;
wire          main_ethmac_interface2_we;
wire    [2:0] main_ethmac_interface2_cti;
wire    [1:0] main_ethmac_interface2_bte;
reg           main_ethmac_interface2_err = 1'd0;
reg           main_ethmac_sram4_adr_burst = 1'd0;
wire    [8:0] main_ethmac_sram4_adr;
wire   [31:0] main_ethmac_sram4_dat_r;
reg     [3:0] main_ethmac_sram4_we = 4'd0;
wire   [31:0] main_ethmac_sram4_dat_w;
wire   [29:0] main_ethmac_interface3_adr;
wire   [31:0] main_ethmac_interface3_dat_w;
wire   [31:0] main_ethmac_interface3_dat_r;
wire    [3:0] main_ethmac_interface3_sel;
wire          main_ethmac_interface3_cyc;
wire          main_ethmac_interface3_stb;
reg           main_ethmac_interface3_ack = 1'd0;
wire          main_ethmac_interface3_we;
wire    [2:0] main_ethmac_interface3_cti;
wire    [1:0] main_ethmac_interface3_bte;
reg           main_ethmac_interface3_err = 1'd0;
reg           main_ethmac_sram5_adr_burst = 1'd0;
wire    [8:0] main_ethmac_sram5_adr;
wire   [31:0] main_ethmac_sram5_dat_r;
reg     [3:0] main_ethmac_sram5_we = 4'd0;
wire   [31:0] main_ethmac_sram5_dat_w;
reg     [3:0] main_ethmac_slave_sel = 4'd0;
reg     [3:0] main_ethmac_slave_sel_r = 4'd0;
reg     [7:0] main_storage = 8'd0;
reg           main_re = 1'd0;
reg     [7:0] main_chaser = 8'd0;
reg           main_mode = 1'd0;
wire          main_wait;
wire          main_done;
reg    [22:0] main_count = 23'd7812500;
reg     [7:0] main_leds = 8'd0;
wire          card_detect_status0;
wire          card_detect_we;
reg           card_detect_re = 1'd0;
reg     [8:0] clocker_storage = 9'd256;
reg           clocker_re = 1'd0;
wire          clocker_stop;
wire          clocker_ce;
wire          clocker_clk_en;
wire          clocker_clk0;
reg     [8:0] clocker_clks = 9'd0;
reg           clocker_clk1 = 1'd0;
reg           clocker_clk_d = 1'd0;
reg           clocker_ce_delayed = 1'd0;
reg           clocker_ce_latched = 1'd0;
reg           init_initialize_re = 1'd0;
wire          init_initialize_r;
reg           init_initialize_we = 1'd0;
reg           init_initialize_w = 1'd0;
wire          init_pads_in_valid;
wire          init_pads_in_payload_cmd_i;
wire    [3:0] init_pads_in_payload_data_i;
wire          init_pads_out_ready;
reg           init_pads_out_payload_clk = 1'd0;
reg           init_pads_out_payload_cmd_o = 1'd0;
reg           init_pads_out_payload_cmd_oe = 1'd0;
reg     [3:0] init_pads_out_payload_data_o = 4'd0;
reg           init_pads_out_payload_data_oe = 1'd0;
reg     [7:0] init_count = 8'd0;
wire          cmdw_pads_in_valid;
wire          cmdw_pads_in_payload_cmd_i;
wire    [3:0] cmdw_pads_in_payload_data_i;
wire          cmdw_pads_out_ready;
reg           cmdw_pads_out_payload_clk = 1'd0;
reg           cmdw_pads_out_payload_cmd_o = 1'd0;
reg           cmdw_pads_out_payload_cmd_oe = 1'd0;
reg     [3:0] cmdw_pads_out_payload_data_o = 4'd0;
reg           cmdw_pads_out_payload_data_oe = 1'd0;
reg           cmdw_sink_valid = 1'd0;
reg           cmdw_sink_ready = 1'd0;
reg           cmdw_sink_last = 1'd0;
reg     [7:0] cmdw_sink_payload_data = 8'd0;
reg     [1:0] cmdw_sink_payload_cmd_type = 2'd0;
reg           cmdw_done = 1'd0;
reg     [7:0] cmdw_count = 8'd0;
wire          cmdr_pads_in_pads_in_valid;
wire          cmdr_pads_in_pads_in_ready;
reg           cmdr_pads_in_pads_in_first = 1'd0;
reg           cmdr_pads_in_pads_in_last = 1'd0;
reg           cmdr_pads_in_pads_in_payload_clk = 1'd0;
wire          cmdr_pads_in_pads_in_payload_cmd_i;
reg           cmdr_pads_in_pads_in_payload_cmd_o = 1'd0;
reg           cmdr_pads_in_pads_in_payload_cmd_oe = 1'd0;
wire    [3:0] cmdr_pads_in_pads_in_payload_data_i;
reg     [3:0] cmdr_pads_in_pads_in_payload_data_o = 4'd0;
reg           cmdr_pads_in_pads_in_payload_data_oe = 1'd0;
reg           cmdr_pads_in_pads_in_payload_data_i_ce = 1'd0;
wire          cmdr_pads_out_ready;
reg           cmdr_pads_out_payload_clk = 1'd0;
reg           cmdr_pads_out_payload_cmd_o = 1'd0;
reg           cmdr_pads_out_payload_cmd_oe = 1'd0;
reg     [3:0] cmdr_pads_out_payload_data_o = 4'd0;
reg           cmdr_pads_out_payload_data_oe = 1'd0;
reg           cmdr_sink_valid = 1'd0;
reg           cmdr_sink_ready = 1'd0;
reg     [1:0] cmdr_sink_payload_cmd_type = 2'd0;
reg     [1:0] cmdr_sink_payload_data_type = 2'd0;
reg     [7:0] cmdr_sink_payload_length = 8'd0;
reg           cmdr_source_source_valid = 1'd0;
reg           cmdr_source_source_ready = 1'd0;
reg           cmdr_source_source_last = 1'd0;
reg     [7:0] cmdr_source_source_payload_data = 8'd0;
reg     [2:0] cmdr_source_source_payload_status = 3'd0;
reg    [31:0] cmdr_timeout = 32'd125000000;
reg     [7:0] cmdr_count = 8'd0;
reg           cmdr_busy = 1'd0;
wire          cmdr_cmdr_pads_in_valid;
reg           cmdr_cmdr_pads_in_ready = 1'd0;
wire          cmdr_cmdr_pads_in_first;
wire          cmdr_cmdr_pads_in_last;
wire          cmdr_cmdr_pads_in_payload_clk;
wire          cmdr_cmdr_pads_in_payload_cmd_i;
wire          cmdr_cmdr_pads_in_payload_cmd_o;
wire          cmdr_cmdr_pads_in_payload_cmd_oe;
wire    [3:0] cmdr_cmdr_pads_in_payload_data_i;
wire    [3:0] cmdr_cmdr_pads_in_payload_data_o;
wire          cmdr_cmdr_pads_in_payload_data_oe;
wire          cmdr_cmdr_pads_in_payload_data_i_ce;
wire          cmdr_cmdr_source_valid;
reg           cmdr_cmdr_source_ready = 1'd0;
wire          cmdr_cmdr_source_first;
wire          cmdr_cmdr_source_last;
wire    [7:0] cmdr_cmdr_source_payload_data;
wire          cmdr_cmdr_start;
reg           cmdr_cmdr_run = 1'd0;
wire          cmdr_cmdr_converter_converter_sink_valid;
wire          cmdr_cmdr_converter_converter_sink_ready;
reg           cmdr_cmdr_converter_converter_sink_first = 1'd0;
reg           cmdr_cmdr_converter_converter_sink_last = 1'd0;
wire          cmdr_cmdr_converter_converter_sink_payload_data;
wire          cmdr_cmdr_converter_converter_source_valid;
wire          cmdr_cmdr_converter_converter_source_ready;
reg           cmdr_cmdr_converter_converter_source_first = 1'd0;
reg           cmdr_cmdr_converter_converter_source_last = 1'd0;
reg     [7:0] cmdr_cmdr_converter_converter_source_payload_data = 8'd0;
reg     [3:0] cmdr_cmdr_converter_converter_source_payload_valid_token_count = 4'd0;
reg     [2:0] cmdr_cmdr_converter_converter_demux = 3'd0;
wire          cmdr_cmdr_converter_converter_load_part;
reg           cmdr_cmdr_converter_converter_strobe_all = 1'd0;
wire          cmdr_cmdr_converter_source_source_valid;
wire          cmdr_cmdr_converter_source_source_ready;
wire          cmdr_cmdr_converter_source_source_first;
wire          cmdr_cmdr_converter_source_source_last;
wire    [7:0] cmdr_cmdr_converter_source_source_payload_data;
wire          cmdr_cmdr_buf_sink_sink_valid;
wire          cmdr_cmdr_buf_sink_sink_ready;
wire          cmdr_cmdr_buf_sink_sink_first;
wire          cmdr_cmdr_buf_sink_sink_last;
wire    [7:0] cmdr_cmdr_buf_sink_sink_payload_data;
wire          cmdr_cmdr_buf_source_source_valid;
wire          cmdr_cmdr_buf_source_source_ready;
wire          cmdr_cmdr_buf_source_source_first;
wire          cmdr_cmdr_buf_source_source_last;
wire    [7:0] cmdr_cmdr_buf_source_source_payload_data;
wire          cmdr_cmdr_buf_pipe_valid_sink_valid;
wire          cmdr_cmdr_buf_pipe_valid_sink_ready;
wire          cmdr_cmdr_buf_pipe_valid_sink_first;
wire          cmdr_cmdr_buf_pipe_valid_sink_last;
wire    [7:0] cmdr_cmdr_buf_pipe_valid_sink_payload_data;
reg           cmdr_cmdr_buf_pipe_valid_source_valid = 1'd0;
wire          cmdr_cmdr_buf_pipe_valid_source_ready;
reg           cmdr_cmdr_buf_pipe_valid_source_first = 1'd0;
reg           cmdr_cmdr_buf_pipe_valid_source_last = 1'd0;
reg     [7:0] cmdr_cmdr_buf_pipe_valid_source_payload_data = 8'd0;
reg           cmdr_cmdr_reset = 1'd0;
wire          dataw_pads_in_pads_in_valid;
reg           dataw_pads_in_pads_in_ready = 1'd0;
reg           dataw_pads_in_pads_in_first = 1'd0;
reg           dataw_pads_in_pads_in_last = 1'd0;
reg           dataw_pads_in_pads_in_payload_clk = 1'd0;
wire          dataw_pads_in_pads_in_payload_cmd_i;
reg           dataw_pads_in_pads_in_payload_cmd_o = 1'd0;
reg           dataw_pads_in_pads_in_payload_cmd_oe = 1'd0;
wire    [3:0] dataw_pads_in_pads_in_payload_data_i;
reg     [3:0] dataw_pads_in_pads_in_payload_data_o = 4'd0;
reg           dataw_pads_in_pads_in_payload_data_oe = 1'd0;
reg           dataw_pads_in_pads_in_payload_data_i_ce = 1'd0;
wire          dataw_pads_out_ready;
reg           dataw_pads_out_payload_clk = 1'd0;
reg           dataw_pads_out_payload_cmd_o = 1'd0;
reg           dataw_pads_out_payload_cmd_oe = 1'd0;
reg     [3:0] dataw_pads_out_payload_data_o = 4'd0;
reg           dataw_pads_out_payload_data_oe = 1'd0;
reg           dataw_sink_valid = 1'd0;
reg           dataw_sink_ready = 1'd0;
reg           dataw_sink_first = 1'd0;
reg           dataw_sink_last = 1'd0;
reg     [7:0] dataw_sink_payload_data = 8'd0;
reg           dataw_stop = 1'd0;
wire          dataw_accepted0;
wire          dataw_crc_error0;
wire          dataw_write_error0;
reg     [2:0] dataw_status = 3'd0;
wire          dataw_we;
reg           dataw_re = 1'd0;
reg     [7:0] dataw_count = 8'd0;
reg           dataw_accepted1 = 1'd0;
reg           dataw_crc_error1 = 1'd0;
reg           dataw_write_error1 = 1'd0;
wire          dataw_crc_pads_in_valid;
wire          dataw_crc_pads_in_ready;
wire          dataw_crc_pads_in_first;
wire          dataw_crc_pads_in_last;
wire          dataw_crc_pads_in_payload_clk;
wire          dataw_crc_pads_in_payload_cmd_i;
wire          dataw_crc_pads_in_payload_cmd_o;
wire          dataw_crc_pads_in_payload_cmd_oe;
wire    [3:0] dataw_crc_pads_in_payload_data_i;
wire    [3:0] dataw_crc_pads_in_payload_data_o;
wire          dataw_crc_pads_in_payload_data_oe;
wire          dataw_crc_pads_in_payload_data_i_ce;
wire          dataw_crc_source_valid;
reg           dataw_crc_source_ready = 1'd0;
wire          dataw_crc_source_first;
wire          dataw_crc_source_last;
wire    [7:0] dataw_crc_source_payload_data;
wire          dataw_crc_start;
reg           dataw_crc_run = 1'd0;
wire          dataw_crc_converter_converter_sink_valid;
wire          dataw_crc_converter_converter_sink_ready;
reg           dataw_crc_converter_converter_sink_first = 1'd0;
reg           dataw_crc_converter_converter_sink_last = 1'd0;
wire          dataw_crc_converter_converter_sink_payload_data;
wire          dataw_crc_converter_converter_source_valid;
wire          dataw_crc_converter_converter_source_ready;
reg           dataw_crc_converter_converter_source_first = 1'd0;
reg           dataw_crc_converter_converter_source_last = 1'd0;
reg     [7:0] dataw_crc_converter_converter_source_payload_data = 8'd0;
reg     [3:0] dataw_crc_converter_converter_source_payload_valid_token_count = 4'd0;
reg     [2:0] dataw_crc_converter_converter_demux = 3'd0;
wire          dataw_crc_converter_converter_load_part;
reg           dataw_crc_converter_converter_strobe_all = 1'd0;
wire          dataw_crc_converter_source_source_valid;
wire          dataw_crc_converter_source_source_ready;
wire          dataw_crc_converter_source_source_first;
wire          dataw_crc_converter_source_source_last;
wire    [7:0] dataw_crc_converter_source_source_payload_data;
wire          dataw_crc_buf_sink_sink_valid;
wire          dataw_crc_buf_sink_sink_ready;
wire          dataw_crc_buf_sink_sink_first;
wire          dataw_crc_buf_sink_sink_last;
wire    [7:0] dataw_crc_buf_sink_sink_payload_data;
wire          dataw_crc_buf_source_source_valid;
wire          dataw_crc_buf_source_source_ready;
wire          dataw_crc_buf_source_source_first;
wire          dataw_crc_buf_source_source_last;
wire    [7:0] dataw_crc_buf_source_source_payload_data;
wire          dataw_crc_buf_pipe_valid_sink_valid;
wire          dataw_crc_buf_pipe_valid_sink_ready;
wire          dataw_crc_buf_pipe_valid_sink_first;
wire          dataw_crc_buf_pipe_valid_sink_last;
wire    [7:0] dataw_crc_buf_pipe_valid_sink_payload_data;
reg           dataw_crc_buf_pipe_valid_source_valid = 1'd0;
wire          dataw_crc_buf_pipe_valid_source_ready;
reg           dataw_crc_buf_pipe_valid_source_first = 1'd0;
reg           dataw_crc_buf_pipe_valid_source_last = 1'd0;
reg     [7:0] dataw_crc_buf_pipe_valid_source_payload_data = 8'd0;
reg           dataw_crc_reset = 1'd0;
wire          datar_pads_in_pads_in_valid;
wire          datar_pads_in_pads_in_ready;
reg           datar_pads_in_pads_in_first = 1'd0;
reg           datar_pads_in_pads_in_last = 1'd0;
reg           datar_pads_in_pads_in_payload_clk = 1'd0;
wire          datar_pads_in_pads_in_payload_cmd_i;
reg           datar_pads_in_pads_in_payload_cmd_o = 1'd0;
reg           datar_pads_in_pads_in_payload_cmd_oe = 1'd0;
wire    [3:0] datar_pads_in_pads_in_payload_data_i;
reg     [3:0] datar_pads_in_pads_in_payload_data_o = 4'd0;
reg           datar_pads_in_pads_in_payload_data_oe = 1'd0;
reg           datar_pads_in_pads_in_payload_data_i_ce = 1'd0;
wire          datar_pads_out_ready;
reg           datar_pads_out_payload_clk = 1'd0;
reg           datar_pads_out_payload_cmd_o = 1'd0;
reg           datar_pads_out_payload_cmd_oe = 1'd0;
reg     [3:0] datar_pads_out_payload_data_o = 4'd0;
reg           datar_pads_out_payload_data_oe = 1'd0;
reg           datar_sink_valid = 1'd0;
reg           datar_sink_ready = 1'd0;
reg           datar_sink_last = 1'd0;
reg     [9:0] datar_sink_payload_block_length = 10'd0;
reg           datar_source_source_valid = 1'd0;
reg           datar_source_source_ready = 1'd0;
reg           datar_source_source_first = 1'd0;
reg           datar_source_source_last = 1'd0;
reg     [7:0] datar_source_source_payload_data = 8'd0;
reg     [2:0] datar_source_source_payload_status = 3'd0;
reg           datar_stop = 1'd0;
reg    [31:0] datar_timeout = 32'd125000000;
reg     [9:0] datar_count = 10'd0;
wire          datar_datar_pads_in_valid;
reg           datar_datar_pads_in_ready = 1'd0;
wire          datar_datar_pads_in_first;
wire          datar_datar_pads_in_last;
wire          datar_datar_pads_in_payload_clk;
wire          datar_datar_pads_in_payload_cmd_i;
wire          datar_datar_pads_in_payload_cmd_o;
wire          datar_datar_pads_in_payload_cmd_oe;
wire    [3:0] datar_datar_pads_in_payload_data_i;
wire    [3:0] datar_datar_pads_in_payload_data_o;
wire          datar_datar_pads_in_payload_data_oe;
wire          datar_datar_pads_in_payload_data_i_ce;
wire          datar_datar_source_valid;
reg           datar_datar_source_ready = 1'd0;
wire          datar_datar_source_first;
wire          datar_datar_source_last;
wire    [7:0] datar_datar_source_payload_data;
wire          datar_datar_start;
reg           datar_datar_run = 1'd0;
wire          datar_datar_converter_converter_sink_valid;
wire          datar_datar_converter_converter_sink_ready;
reg           datar_datar_converter_converter_sink_first = 1'd0;
reg           datar_datar_converter_converter_sink_last = 1'd0;
wire    [3:0] datar_datar_converter_converter_sink_payload_data;
wire          datar_datar_converter_converter_source_valid;
wire          datar_datar_converter_converter_source_ready;
reg           datar_datar_converter_converter_source_first = 1'd0;
reg           datar_datar_converter_converter_source_last = 1'd0;
reg     [7:0] datar_datar_converter_converter_source_payload_data = 8'd0;
reg     [1:0] datar_datar_converter_converter_source_payload_valid_token_count = 2'd0;
reg           datar_datar_converter_converter_demux = 1'd0;
wire          datar_datar_converter_converter_load_part;
reg           datar_datar_converter_converter_strobe_all = 1'd0;
wire          datar_datar_converter_source_source_valid;
wire          datar_datar_converter_source_source_ready;
wire          datar_datar_converter_source_source_first;
wire          datar_datar_converter_source_source_last;
wire    [7:0] datar_datar_converter_source_source_payload_data;
wire          datar_datar_buf_sink_sink_valid;
wire          datar_datar_buf_sink_sink_ready;
wire          datar_datar_buf_sink_sink_first;
wire          datar_datar_buf_sink_sink_last;
wire    [7:0] datar_datar_buf_sink_sink_payload_data;
wire          datar_datar_buf_source_source_valid;
wire          datar_datar_buf_source_source_ready;
wire          datar_datar_buf_source_source_first;
wire          datar_datar_buf_source_source_last;
wire    [7:0] datar_datar_buf_source_source_payload_data;
wire          datar_datar_buf_pipe_valid_sink_valid;
wire          datar_datar_buf_pipe_valid_sink_ready;
wire          datar_datar_buf_pipe_valid_sink_first;
wire          datar_datar_buf_pipe_valid_sink_last;
wire    [7:0] datar_datar_buf_pipe_valid_sink_payload_data;
reg           datar_datar_buf_pipe_valid_source_valid = 1'd0;
wire          datar_datar_buf_pipe_valid_source_ready;
reg           datar_datar_buf_pipe_valid_source_first = 1'd0;
reg           datar_datar_buf_pipe_valid_source_last = 1'd0;
reg     [7:0] datar_datar_buf_pipe_valid_source_payload_data = 8'd0;
reg           datar_datar_reset = 1'd0;
wire          sdpads_clk;
wire          sdpads_cmd_i;
wire          sdpads_cmd_o;
wire          sdpads_cmd_oe;
wire    [3:0] sdpads_data_i;
wire    [3:0] sdpads_data_o;
wire          sdpads_data_oe;
reg           sdpads_data_i_ce = 1'd0;
reg     [1:0] clocker_clk_delay = 2'd0;
reg           card_detect_irq = 1'd0;
reg           card_detect_d = 1'd0;
wire          sdcore_sink_sink_valid0;
wire          sdcore_sink_sink_ready0;
wire          sdcore_sink_sink_first0;
wire          sdcore_sink_sink_last0;
wire    [7:0] sdcore_sink_sink_payload_data0;
wire          sdcore_source_source_valid0;
wire          sdcore_source_source_ready0;
wire          sdcore_source_source_first0;
wire          sdcore_source_source_last0;
wire    [7:0] sdcore_source_source_payload_data0;
reg    [31:0] sdcore_cmd_argument_storage = 32'd0;
reg           sdcore_cmd_argument_re = 1'd0;
wire    [1:0] sdcore_csrfield_cmd_type;
wire    [1:0] sdcore_csrfield_data_type;
wire    [5:0] sdcore_csrfield_cmd;
reg    [13:0] sdcore_cmd_command_storage = 14'd0;
reg           sdcore_cmd_command_re = 1'd0;
reg           sdcore_cmd_send_storage = 1'd0;
reg           sdcore_cmd_send_re = 1'd0;
reg   [127:0] sdcore_cmd_response_status = 128'd0;
wire          sdcore_cmd_response_we;
reg           sdcore_cmd_response_re = 1'd0;
wire          sdcore_csrfield_done0;
wire          sdcore_csrfield_error0;
wire          sdcore_csrfield_timeout0;
wire          sdcore_csrfield_crc0;
reg     [3:0] sdcore_cmd_event_status = 4'd0;
wire          sdcore_cmd_event_we;
reg           sdcore_cmd_event_re = 1'd0;
wire          sdcore_csrfield_done1;
wire          sdcore_csrfield_error1;
wire          sdcore_csrfield_timeout1;
wire          sdcore_csrfield_crc1;
reg     [3:0] sdcore_data_event_status = 4'd0;
wire          sdcore_data_event_we;
reg           sdcore_data_event_re = 1'd0;
reg     [9:0] sdcore_block_length_storage = 10'd0;
reg           sdcore_block_length_re = 1'd0;
reg    [31:0] sdcore_block_count_storage = 32'd0;
reg           sdcore_block_count_re = 1'd0;
wire          sdcore_crc7_inserter_reset;
wire          sdcore_crc7_inserter_enable;
wire   [39:0] sdcore_crc7_inserter_din;
reg     [6:0] sdcore_crc7_inserter_crc = 7'd0;
reg     [6:0] sdcore_crc7_inserter_reg0 = 7'd0;
wire    [6:0] sdcore_crc7_inserter_reg1;
wire    [6:0] sdcore_crc7_inserter_reg2;
wire    [6:0] sdcore_crc7_inserter_reg3;
wire    [6:0] sdcore_crc7_inserter_reg4;
wire    [6:0] sdcore_crc7_inserter_reg5;
wire    [6:0] sdcore_crc7_inserter_reg6;
wire    [6:0] sdcore_crc7_inserter_reg7;
wire    [6:0] sdcore_crc7_inserter_reg8;
wire    [6:0] sdcore_crc7_inserter_reg9;
wire    [6:0] sdcore_crc7_inserter_reg10;
wire    [6:0] sdcore_crc7_inserter_reg11;
wire    [6:0] sdcore_crc7_inserter_reg12;
wire    [6:0] sdcore_crc7_inserter_reg13;
wire    [6:0] sdcore_crc7_inserter_reg14;
wire    [6:0] sdcore_crc7_inserter_reg15;
wire    [6:0] sdcore_crc7_inserter_reg16;
wire    [6:0] sdcore_crc7_inserter_reg17;
wire    [6:0] sdcore_crc7_inserter_reg18;
wire    [6:0] sdcore_crc7_inserter_reg19;
wire    [6:0] sdcore_crc7_inserter_reg20;
wire    [6:0] sdcore_crc7_inserter_reg21;
wire    [6:0] sdcore_crc7_inserter_reg22;
wire    [6:0] sdcore_crc7_inserter_reg23;
wire    [6:0] sdcore_crc7_inserter_reg24;
wire    [6:0] sdcore_crc7_inserter_reg25;
wire    [6:0] sdcore_crc7_inserter_reg26;
wire    [6:0] sdcore_crc7_inserter_reg27;
wire    [6:0] sdcore_crc7_inserter_reg28;
wire    [6:0] sdcore_crc7_inserter_reg29;
wire    [6:0] sdcore_crc7_inserter_reg30;
wire    [6:0] sdcore_crc7_inserter_reg31;
wire    [6:0] sdcore_crc7_inserter_reg32;
wire    [6:0] sdcore_crc7_inserter_reg33;
wire    [6:0] sdcore_crc7_inserter_reg34;
wire    [6:0] sdcore_crc7_inserter_reg35;
wire    [6:0] sdcore_crc7_inserter_reg36;
wire    [6:0] sdcore_crc7_inserter_reg37;
wire    [6:0] sdcore_crc7_inserter_reg38;
wire    [6:0] sdcore_crc7_inserter_reg39;
wire    [6:0] sdcore_crc7_inserter_reg40;
wire          sdcore_crc16_inserter_sink_valid;
reg           sdcore_crc16_inserter_sink_ready = 1'd0;
wire          sdcore_crc16_inserter_sink_first;
wire          sdcore_crc16_inserter_sink_last;
wire    [7:0] sdcore_crc16_inserter_sink_payload_data;
reg           sdcore_crc16_inserter_source_valid = 1'd0;
reg           sdcore_crc16_inserter_source_ready = 1'd0;
reg           sdcore_crc16_inserter_source_first = 1'd0;
reg           sdcore_crc16_inserter_source_last = 1'd0;
reg     [7:0] sdcore_crc16_inserter_source_payload_data = 8'd0;
reg     [2:0] sdcore_crc16_inserter_count = 3'd0;
wire          sdcore_crc16_inserter_crc0_reset;
wire          sdcore_crc16_inserter_crc0_enable;
reg     [1:0] sdcore_crc16_inserter_crc0_din = 2'd0;
reg    [15:0] sdcore_crc16_inserter_crc0_crc = 16'd0;
reg    [15:0] sdcore_crc16_inserter_crc0_reg0 = 16'd0;
wire   [15:0] sdcore_crc16_inserter_crc0_reg1;
wire   [15:0] sdcore_crc16_inserter_crc0_reg2;
wire          sdcore_crc16_inserter_crc1_reset;
wire          sdcore_crc16_inserter_crc1_enable;
reg     [1:0] sdcore_crc16_inserter_crc1_din = 2'd0;
reg    [15:0] sdcore_crc16_inserter_crc1_crc = 16'd0;
reg    [15:0] sdcore_crc16_inserter_crc1_reg0 = 16'd0;
wire   [15:0] sdcore_crc16_inserter_crc1_reg1;
wire   [15:0] sdcore_crc16_inserter_crc1_reg2;
wire          sdcore_crc16_inserter_crc2_reset;
wire          sdcore_crc16_inserter_crc2_enable;
reg     [1:0] sdcore_crc16_inserter_crc2_din = 2'd0;
reg    [15:0] sdcore_crc16_inserter_crc2_crc = 16'd0;
reg    [15:0] sdcore_crc16_inserter_crc2_reg0 = 16'd0;
wire   [15:0] sdcore_crc16_inserter_crc2_reg1;
wire   [15:0] sdcore_crc16_inserter_crc2_reg2;
wire          sdcore_crc16_inserter_crc3_reset;
wire          sdcore_crc16_inserter_crc3_enable;
reg     [1:0] sdcore_crc16_inserter_crc3_din = 2'd0;
reg    [15:0] sdcore_crc16_inserter_crc3_crc = 16'd0;
reg    [15:0] sdcore_crc16_inserter_crc3_reg0 = 16'd0;
wire   [15:0] sdcore_crc16_inserter_crc3_reg1;
wire   [15:0] sdcore_crc16_inserter_crc3_reg2;
reg           sdcore_sink_sink_valid1 = 1'd0;
wire          sdcore_sink_sink_ready1;
reg           sdcore_sink_sink_first1 = 1'd0;
reg           sdcore_sink_sink_last1 = 1'd0;
reg     [7:0] sdcore_sink_sink_payload_data1 = 8'd0;
wire          sdcore_source_source_valid1;
wire          sdcore_source_source_ready1;
wire          sdcore_source_source_first1;
wire          sdcore_source_source_last1;
wire    [7:0] sdcore_source_source_payload_data1;
wire          sdcore_fifo_sink_valid;
wire          sdcore_fifo_sink_ready;
wire          sdcore_fifo_sink_first;
wire          sdcore_fifo_sink_last;
wire    [7:0] sdcore_fifo_sink_payload_data;
wire          sdcore_fifo_source_valid;
wire          sdcore_fifo_source_ready;
wire          sdcore_fifo_source_first;
wire          sdcore_fifo_source_last;
wire    [7:0] sdcore_fifo_source_payload_data;
wire          sdcore_fifo_syncfifo_we;
wire          sdcore_fifo_syncfifo_writable;
wire          sdcore_fifo_syncfifo_re;
wire          sdcore_fifo_syncfifo_readable;
wire    [9:0] sdcore_fifo_syncfifo_din;
wire    [9:0] sdcore_fifo_syncfifo_dout;
reg     [3:0] sdcore_fifo_level = 4'd0;
reg           sdcore_fifo_replace = 1'd0;
reg     [2:0] sdcore_fifo_produce = 3'd0;
reg     [2:0] sdcore_fifo_consume = 3'd0;
reg     [2:0] sdcore_fifo_wrport_adr = 3'd0;
wire    [9:0] sdcore_fifo_wrport_dat_r;
wire          sdcore_fifo_wrport_we;
wire    [9:0] sdcore_fifo_wrport_dat_w;
wire          sdcore_fifo_do_read;
wire    [2:0] sdcore_fifo_rdport_adr;
wire    [9:0] sdcore_fifo_rdport_dat_r;
wire    [7:0] sdcore_fifo_fifo_in_payload_data;
wire          sdcore_fifo_fifo_in_first;
wire          sdcore_fifo_fifo_in_last;
wire    [7:0] sdcore_fifo_fifo_out_payload_data;
wire          sdcore_fifo_fifo_out_first;
wire          sdcore_fifo_fifo_out_last;
wire          sdcore_fifo_reset;
wire    [1:0] sdcore_cmd_type;
reg     [2:0] sdcore_cmd_count = 3'd0;
reg           sdcore_cmd_done = 1'd0;
reg           sdcore_cmd_error = 1'd0;
reg           sdcore_cmd_timeout = 1'd0;
wire    [1:0] sdcore_data_type;
reg    [31:0] sdcore_data_count = 32'd0;
reg           sdcore_data_done = 1'd0;
reg           sdcore_data_error = 1'd0;
reg           sdcore_data_timeout = 1'd0;
wire    [5:0] sdcore_cmd;
wire   [31:0] interface0_bus_adr;
wire   [31:0] interface0_bus_dat_w;
wire   [31:0] interface0_bus_dat_r;
wire    [3:0] interface0_bus_sel;
wire          interface0_bus_cyc;
wire          interface0_bus_stb;
wire          interface0_bus_ack;
wire          interface0_bus_we;
reg     [2:0] interface0_bus_cti = 3'd0;
reg     [1:0] interface0_bus_bte = 2'd0;
wire          interface0_bus_err;
wire          sdblock2mem_sink_sink_valid0;
reg           sdblock2mem_sink_sink_ready0 = 1'd0;
wire          sdblock2mem_sink_sink_first;
wire          sdblock2mem_sink_sink_last0;
wire    [7:0] sdblock2mem_sink_sink_payload_data0;
reg           sdblock2mem_irq = 1'd0;
reg           sdblock2mem_fifo_sink_valid = 1'd0;
wire          sdblock2mem_fifo_sink_ready;
reg           sdblock2mem_fifo_sink_first = 1'd0;
reg           sdblock2mem_fifo_sink_last = 1'd0;
reg     [7:0] sdblock2mem_fifo_sink_payload_data = 8'd0;
wire          sdblock2mem_fifo_source_valid;
wire          sdblock2mem_fifo_source_ready;
wire          sdblock2mem_fifo_source_first;
wire          sdblock2mem_fifo_source_last;
wire    [7:0] sdblock2mem_fifo_source_payload_data;
wire          sdblock2mem_fifo_re;
reg           sdblock2mem_fifo_readable = 1'd0;
wire          sdblock2mem_fifo_syncfifo_we;
wire          sdblock2mem_fifo_syncfifo_writable;
wire          sdblock2mem_fifo_syncfifo_re;
wire          sdblock2mem_fifo_syncfifo_readable;
wire    [9:0] sdblock2mem_fifo_syncfifo_din;
wire    [9:0] sdblock2mem_fifo_syncfifo_dout;
reg     [9:0] sdblock2mem_fifo_level0 = 10'd0;
reg           sdblock2mem_fifo_replace = 1'd0;
reg     [8:0] sdblock2mem_fifo_produce = 9'd0;
reg     [8:0] sdblock2mem_fifo_consume = 9'd0;
reg     [8:0] sdblock2mem_fifo_wrport_adr = 9'd0;
wire    [9:0] sdblock2mem_fifo_wrport_dat_r;
wire          sdblock2mem_fifo_wrport_we;
wire    [9:0] sdblock2mem_fifo_wrport_dat_w;
wire          sdblock2mem_fifo_do_read;
wire    [8:0] sdblock2mem_fifo_rdport_adr;
wire    [9:0] sdblock2mem_fifo_rdport_dat_r;
wire          sdblock2mem_fifo_rdport_re;
wire    [9:0] sdblock2mem_fifo_level1;
wire    [7:0] sdblock2mem_fifo_fifo_in_payload_data;
wire          sdblock2mem_fifo_fifo_in_first;
wire          sdblock2mem_fifo_fifo_in_last;
wire    [7:0] sdblock2mem_fifo_fifo_out_payload_data;
wire          sdblock2mem_fifo_fifo_out_first;
wire          sdblock2mem_fifo_fifo_out_last;
wire          sdblock2mem_converter_sink_valid;
wire          sdblock2mem_converter_sink_ready;
wire          sdblock2mem_converter_sink_first;
wire          sdblock2mem_converter_sink_last;
wire    [7:0] sdblock2mem_converter_sink_payload_data;
wire          sdblock2mem_converter_source_valid;
wire          sdblock2mem_converter_source_ready;
reg           sdblock2mem_converter_source_first = 1'd0;
reg           sdblock2mem_converter_source_last = 1'd0;
reg    [31:0] sdblock2mem_converter_source_payload_data = 32'd0;
reg     [2:0] sdblock2mem_converter_source_payload_valid_token_count = 3'd0;
reg     [1:0] sdblock2mem_converter_demux = 2'd0;
wire          sdblock2mem_converter_load_part;
reg           sdblock2mem_converter_strobe_all = 1'd0;
wire          sdblock2mem_source_source_valid;
wire          sdblock2mem_source_source_ready;
wire          sdblock2mem_source_source_first;
wire          sdblock2mem_source_source_last;
wire   [31:0] sdblock2mem_source_source_payload_data;
reg           sdblock2mem_sink_sink_valid1 = 1'd0;
wire          sdblock2mem_sink_sink_ready1;
reg           sdblock2mem_sink_sink_last1 = 1'd0;
reg    [31:0] sdblock2mem_sink_sink_payload_address = 32'd0;
reg    [31:0] sdblock2mem_sink_sink_payload_data1 = 32'd0;
wire          sdblock2mem_wishbonedmawriter_sink_valid;
reg           sdblock2mem_wishbonedmawriter_sink_ready = 1'd0;
wire          sdblock2mem_wishbonedmawriter_sink_first;
wire          sdblock2mem_wishbonedmawriter_sink_last;
wire   [31:0] sdblock2mem_wishbonedmawriter_sink_payload_data;
reg    [63:0] sdblock2mem_wishbonedmawriter_base_storage = 64'd0;
reg           sdblock2mem_wishbonedmawriter_base_re = 1'd0;
reg    [31:0] sdblock2mem_wishbonedmawriter_length_storage = 32'd0;
reg           sdblock2mem_wishbonedmawriter_length_re = 1'd0;
reg           sdblock2mem_wishbonedmawriter_enable_storage = 1'd0;
reg           sdblock2mem_wishbonedmawriter_enable_re = 1'd0;
reg           sdblock2mem_wishbonedmawriter_done_status = 1'd0;
wire          sdblock2mem_wishbonedmawriter_done_we;
reg           sdblock2mem_wishbonedmawriter_done_re = 1'd0;
reg           sdblock2mem_wishbonedmawriter_loop_storage = 1'd0;
reg           sdblock2mem_wishbonedmawriter_loop_re = 1'd0;
wire   [31:0] sdblock2mem_wishbonedmawriter_offset_status;
wire          sdblock2mem_wishbonedmawriter_offset_we;
reg           sdblock2mem_wishbonedmawriter_offset_re = 1'd0;
wire   [31:0] sdblock2mem_wishbonedmawriter_base;
reg    [31:0] sdblock2mem_wishbonedmawriter_offset = 32'd0;
wire   [31:0] sdblock2mem_wishbonedmawriter_length;
wire          sdblock2mem_wishbonedmawriter_reset;
wire          sdblock2mem_start;
reg           sdblock2mem_connect = 1'd0;
reg           sdblock2mem_done_d = 1'd0;
wire   [31:0] interface1_bus_adr;
reg    [31:0] interface1_bus_dat_w = 32'd0;
wire   [31:0] interface1_bus_dat_r;
wire    [3:0] interface1_bus_sel;
wire          interface1_bus_cyc;
wire          interface1_bus_stb;
wire          interface1_bus_ack;
wire          interface1_bus_we;
reg     [2:0] interface1_bus_cti = 3'd0;
reg     [1:0] interface1_bus_bte = 2'd0;
wire          interface1_bus_err;
wire          sdmem2block_source_source_valid;
wire          sdmem2block_source_source_ready;
wire          sdmem2block_source_source_first;
reg           sdmem2block_source_source_last = 1'd0;
wire    [7:0] sdmem2block_source_source_payload_data;
reg           sdmem2block_irq = 1'd0;
reg           sdmem2block_dma_sink_sink_valid = 1'd0;
reg           sdmem2block_dma_sink_sink_ready = 1'd0;
reg           sdmem2block_dma_sink_sink_last = 1'd0;
reg    [31:0] sdmem2block_dma_sink_sink_payload_address = 32'd0;
wire          sdmem2block_dma_source_source_valid;
wire          sdmem2block_dma_source_source_ready;
wire          sdmem2block_dma_source_source_first;
wire          sdmem2block_dma_source_source_last;
wire   [31:0] sdmem2block_dma_source_source_payload_data;
reg           sdmem2block_dma_fifo_sink_valid = 1'd0;
wire          sdmem2block_dma_fifo_sink_ready;
reg           sdmem2block_dma_fifo_sink_first = 1'd0;
wire          sdmem2block_dma_fifo_sink_last;
wire   [31:0] sdmem2block_dma_fifo_sink_payload_data;
wire          sdmem2block_dma_fifo_source_valid;
wire          sdmem2block_dma_fifo_source_ready;
wire          sdmem2block_dma_fifo_source_first;
wire          sdmem2block_dma_fifo_source_last;
wire   [31:0] sdmem2block_dma_fifo_source_payload_data;
wire          sdmem2block_dma_fifo_syncfifo_we;
wire          sdmem2block_dma_fifo_syncfifo_writable;
wire          sdmem2block_dma_fifo_syncfifo_re;
wire          sdmem2block_dma_fifo_syncfifo_readable;
wire   [33:0] sdmem2block_dma_fifo_syncfifo_din;
wire   [33:0] sdmem2block_dma_fifo_syncfifo_dout;
reg     [4:0] sdmem2block_dma_fifo_level = 5'd0;
reg           sdmem2block_dma_fifo_replace = 1'd0;
reg     [3:0] sdmem2block_dma_fifo_produce = 4'd0;
reg     [3:0] sdmem2block_dma_fifo_consume = 4'd0;
reg     [3:0] sdmem2block_dma_fifo_wrport_adr = 4'd0;
wire   [33:0] sdmem2block_dma_fifo_wrport_dat_r;
wire          sdmem2block_dma_fifo_wrport_we;
wire   [33:0] sdmem2block_dma_fifo_wrport_dat_w;
wire          sdmem2block_dma_fifo_do_read;
wire    [3:0] sdmem2block_dma_fifo_rdport_adr;
wire   [33:0] sdmem2block_dma_fifo_rdport_dat_r;
wire   [31:0] sdmem2block_dma_fifo_fifo_in_payload_data;
wire          sdmem2block_dma_fifo_fifo_in_first;
wire          sdmem2block_dma_fifo_fifo_in_last;
wire   [31:0] sdmem2block_dma_fifo_fifo_out_payload_data;
wire          sdmem2block_dma_fifo_fifo_out_first;
wire          sdmem2block_dma_fifo_fifo_out_last;
reg    [63:0] sdmem2block_dma_base_storage = 64'd0;
reg           sdmem2block_dma_base_re = 1'd0;
reg    [31:0] sdmem2block_dma_length_storage = 32'd0;
reg           sdmem2block_dma_length_re = 1'd0;
reg           sdmem2block_dma_enable_storage = 1'd0;
reg           sdmem2block_dma_enable_re = 1'd0;
reg           sdmem2block_dma_done_status = 1'd0;
wire          sdmem2block_dma_done_we;
reg           sdmem2block_dma_done_re = 1'd0;
reg           sdmem2block_dma_loop_storage = 1'd0;
reg           sdmem2block_dma_loop_re = 1'd0;
wire   [31:0] sdmem2block_dma_offset_status;
wire          sdmem2block_dma_offset_we;
reg           sdmem2block_dma_offset_re = 1'd0;
wire   [31:0] sdmem2block_dma_base;
reg    [31:0] sdmem2block_dma_offset = 32'd0;
wire   [31:0] sdmem2block_dma_length;
wire          sdmem2block_dma_reset;
wire          sdmem2block_converter_converter_sink_valid;
wire          sdmem2block_converter_converter_sink_ready;
wire          sdmem2block_converter_converter_sink_first;
wire          sdmem2block_converter_converter_sink_last;
wire   [31:0] sdmem2block_converter_converter_sink_payload_data;
wire          sdmem2block_converter_converter_source_valid;
wire          sdmem2block_converter_converter_source_ready;
wire          sdmem2block_converter_converter_source_first;
wire          sdmem2block_converter_converter_source_last;
reg     [7:0] sdmem2block_converter_converter_source_payload_data = 8'd0;
wire          sdmem2block_converter_converter_source_payload_valid_token_count;
reg     [1:0] sdmem2block_converter_converter_mux = 2'd0;
wire          sdmem2block_converter_converter_first;
wire          sdmem2block_converter_converter_last;
wire          sdmem2block_converter_source_source_valid;
wire          sdmem2block_converter_source_source_ready;
wire          sdmem2block_converter_source_source_first;
wire          sdmem2block_converter_source_source_last;
wire    [7:0] sdmem2block_converter_source_source_payload_data;
wire          sdmem2block_fifo_sink_valid;
wire          sdmem2block_fifo_sink_ready;
wire          sdmem2block_fifo_sink_first;
wire          sdmem2block_fifo_sink_last;
wire    [7:0] sdmem2block_fifo_sink_payload_data;
wire          sdmem2block_fifo_source_valid;
wire          sdmem2block_fifo_source_ready;
wire          sdmem2block_fifo_source_first;
wire          sdmem2block_fifo_source_last;
wire    [7:0] sdmem2block_fifo_source_payload_data;
wire          sdmem2block_fifo_re;
reg           sdmem2block_fifo_readable = 1'd0;
wire          sdmem2block_fifo_syncfifo_we;
wire          sdmem2block_fifo_syncfifo_writable;
wire          sdmem2block_fifo_syncfifo_re;
wire          sdmem2block_fifo_syncfifo_readable;
wire    [9:0] sdmem2block_fifo_syncfifo_din;
wire    [9:0] sdmem2block_fifo_syncfifo_dout;
reg     [9:0] sdmem2block_fifo_level0 = 10'd0;
reg           sdmem2block_fifo_replace = 1'd0;
reg     [8:0] sdmem2block_fifo_produce = 9'd0;
reg     [8:0] sdmem2block_fifo_consume = 9'd0;
reg     [8:0] sdmem2block_fifo_wrport_adr = 9'd0;
wire    [9:0] sdmem2block_fifo_wrport_dat_r;
wire          sdmem2block_fifo_wrport_we;
wire    [9:0] sdmem2block_fifo_wrport_dat_w;
wire          sdmem2block_fifo_do_read;
wire    [8:0] sdmem2block_fifo_rdport_adr;
wire    [9:0] sdmem2block_fifo_rdport_dat_r;
wire          sdmem2block_fifo_rdport_re;
wire    [9:0] sdmem2block_fifo_level1;
wire    [7:0] sdmem2block_fifo_fifo_in_payload_data;
wire          sdmem2block_fifo_fifo_in_first;
wire          sdmem2block_fifo_fifo_in_last;
wire    [7:0] sdmem2block_fifo_fifo_out_payload_data;
wire          sdmem2block_fifo_fifo_out_first;
wire          sdmem2block_fifo_fifo_out_last;
reg     [8:0] sdmem2block_count = 9'd0;
reg           sdmem2block_done_d = 1'd0;
wire          sdirq_irq;
wire          card_detect_status1;
reg           card_detect_pending = 1'd0;
wire          card_detect_trigger;
reg           card_detect_clear = 1'd0;
wire          block2mem_dma_status;
reg           block2mem_dma_pending = 1'd0;
wire          block2mem_dma_trigger;
reg           block2mem_dma_clear = 1'd0;
wire          mem2block_dma_status;
reg           mem2block_dma_pending = 1'd0;
wire          mem2block_dma_trigger;
reg           mem2block_dma_clear = 1'd0;
wire          cmd_done_status;
wire          cmd_done_pending;
wire          cmd_done_trigger;
reg           cmd_done_clear = 1'd0;
wire          eventmanager_card_detect0;
wire          eventmanager_block2mem_dma0;
wire          eventmanager_mem2block_dma0;
wire          eventmanager_cmd_done0;
reg     [3:0] eventmanager_status_status = 4'd0;
wire          eventmanager_status_we;
reg           eventmanager_status_re = 1'd0;
wire          eventmanager_card_detect1;
wire          eventmanager_block2mem_dma1;
wire          eventmanager_mem2block_dma1;
wire          eventmanager_cmd_done1;
reg     [3:0] eventmanager_pending_status = 4'd0;
wire          eventmanager_pending_we;
reg           eventmanager_pending_re = 1'd0;
reg     [3:0] eventmanager_pending_r = 4'd0;
wire          eventmanager_card_detect2;
wire          eventmanager_block2mem_dma2;
wire          eventmanager_mem2block_dma2;
wire          eventmanager_cmd_done2;
reg     [3:0] eventmanager_enable_storage = 4'd0;
reg           eventmanager_enable_re = 1'd0;
reg    [13:0] builder_soclinux_adr = 14'd0;
reg           builder_soclinux_we = 1'd0;
reg    [31:0] builder_soclinux_dat_w = 32'd0;
wire   [31:0] builder_soclinux_dat_r;
wire   [29:0] builder_soclinux_wishbone_adr;
wire   [31:0] builder_soclinux_wishbone_dat_w;
reg    [31:0] builder_soclinux_wishbone_dat_r = 32'd0;
wire    [3:0] builder_soclinux_wishbone_sel;
wire          builder_soclinux_wishbone_cyc;
wire          builder_soclinux_wishbone_stb;
reg           builder_soclinux_wishbone_ack = 1'd0;
wire          builder_soclinux_wishbone_we;
wire    [2:0] builder_soclinux_wishbone_cti;
wire    [1:0] builder_soclinux_wishbone_bte;
reg           builder_soclinux_wishbone_err = 1'd0;
wire   [29:0] builder_socbushandler0_shared_adr;
wire   [31:0] builder_socbushandler0_shared_dat_w;
reg    [31:0] builder_socbushandler0_shared_dat_r = 32'd0;
wire    [3:0] builder_socbushandler0_shared_sel;
wire          builder_socbushandler0_shared_cyc;
wire          builder_socbushandler0_shared_stb;
reg           builder_socbushandler0_shared_ack = 1'd0;
wire          builder_socbushandler0_shared_we;
wire    [2:0] builder_socbushandler0_shared_cti;
wire    [1:0] builder_socbushandler0_shared_bte;
wire          builder_socbushandler0_shared_err;
wire          builder_socbushandler0_request;
wire          builder_socbushandler0_grant;
reg     [5:0] builder_socbushandler0_slave_sel = 6'd0;
reg     [5:0] builder_socbushandler0_slave_sel_r = 6'd0;
reg           builder_socbushandler0_error = 1'd0;
wire          builder_socbushandler0_wait;
wire          builder_socbushandler0_done;
reg    [19:0] builder_socbushandler0_count = 20'd1000000;
wire   [29:0] builder_socbushandler1_shared_adr;
wire   [31:0] builder_socbushandler1_shared_dat_w;
reg    [31:0] builder_socbushandler1_shared_dat_r = 32'd0;
wire    [3:0] builder_socbushandler1_shared_sel;
wire          builder_socbushandler1_shared_cyc;
wire          builder_socbushandler1_shared_stb;
reg           builder_socbushandler1_shared_ack = 1'd0;
wire          builder_socbushandler1_shared_we;
wire    [2:0] builder_socbushandler1_shared_cti;
wire    [1:0] builder_socbushandler1_shared_bte;
wire          builder_socbushandler1_shared_err;
wire    [1:0] builder_socbushandler1_request;
reg           builder_socbushandler1_grant = 1'd0;
wire          builder_socbushandler1_slave_sel;
reg           builder_socbushandler1_slave_sel_r = 1'd0;
reg           builder_socbushandler1_error = 1'd0;
wire          builder_socbushandler1_wait;
wire          builder_socbushandler1_done;
reg    [19:0] builder_socbushandler1_count = 20'd1000000;
wire   [13:0] builder_csr_bankarray_interface0_bank_bus_adr;
wire          builder_csr_bankarray_interface0_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface0_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface0_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank0_reset0_re = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank0_reset0_r;
reg           builder_csr_bankarray_csrbank0_reset0_we = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank0_reset0_w;
reg           builder_csr_bankarray_csrbank0_scratch0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank0_scratch0_r;
reg           builder_csr_bankarray_csrbank0_scratch0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank0_scratch0_w;
reg           builder_csr_bankarray_csrbank0_bus_errors_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank0_bus_errors_r;
reg           builder_csr_bankarray_csrbank0_bus_errors_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank0_bus_errors_w;
wire          builder_csr_bankarray_csrbank0_sel;
wire   [13:0] builder_csr_bankarray_interface1_bank_bus_adr;
wire          builder_csr_bankarray_interface1_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface1_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface1_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank1_rst0_re = 1'd0;
wire          builder_csr_bankarray_csrbank1_rst0_r;
reg           builder_csr_bankarray_csrbank1_rst0_we = 1'd0;
wire          builder_csr_bankarray_csrbank1_rst0_w;
reg           builder_csr_bankarray_csrbank1_en_vtc0_re = 1'd0;
wire          builder_csr_bankarray_csrbank1_en_vtc0_r;
reg           builder_csr_bankarray_csrbank1_en_vtc0_we = 1'd0;
wire          builder_csr_bankarray_csrbank1_en_vtc0_w;
reg           builder_csr_bankarray_csrbank1_half_sys8x_taps_re = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank1_half_sys8x_taps_r;
reg           builder_csr_bankarray_csrbank1_half_sys8x_taps_we = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank1_half_sys8x_taps_w;
reg           builder_csr_bankarray_csrbank1_wlevel_en0_re = 1'd0;
wire          builder_csr_bankarray_csrbank1_wlevel_en0_r;
reg           builder_csr_bankarray_csrbank1_wlevel_en0_we = 1'd0;
wire          builder_csr_bankarray_csrbank1_wlevel_en0_w;
reg           builder_csr_bankarray_csrbank1_cdly_value_re = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank1_cdly_value_r;
reg           builder_csr_bankarray_csrbank1_cdly_value_we = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank1_cdly_value_w;
reg           builder_csr_bankarray_csrbank1_dly_sel0_re = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank1_dly_sel0_r;
reg           builder_csr_bankarray_csrbank1_dly_sel0_we = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank1_dly_sel0_w;
reg           builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_re = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_r;
reg           builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_we = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_w;
reg           builder_csr_bankarray_csrbank1_rdphase0_re = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank1_rdphase0_r;
reg           builder_csr_bankarray_csrbank1_rdphase0_we = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank1_rdphase0_w;
reg           builder_csr_bankarray_csrbank1_wrphase0_re = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank1_wrphase0_r;
reg           builder_csr_bankarray_csrbank1_wrphase0_we = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank1_wrphase0_w;
wire          builder_csr_bankarray_csrbank1_sel;
wire   [13:0] builder_csr_bankarray_interface2_bank_bus_adr;
wire          builder_csr_bankarray_interface2_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface2_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface2_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank2_sram_writer_slot_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_slot_r;
reg           builder_csr_bankarray_csrbank2_sram_writer_slot_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_slot_w;
reg           builder_csr_bankarray_csrbank2_sram_writer_length_re = 1'd0;
wire   [10:0] builder_csr_bankarray_csrbank2_sram_writer_length_r;
reg           builder_csr_bankarray_csrbank2_sram_writer_length_we = 1'd0;
wire   [10:0] builder_csr_bankarray_csrbank2_sram_writer_length_w;
reg           builder_csr_bankarray_csrbank2_sram_writer_errors_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank2_sram_writer_errors_r;
reg           builder_csr_bankarray_csrbank2_sram_writer_errors_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank2_sram_writer_errors_w;
reg           builder_csr_bankarray_csrbank2_sram_writer_ev_status_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_ev_status_r;
reg           builder_csr_bankarray_csrbank2_sram_writer_ev_status_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_ev_status_w;
reg           builder_csr_bankarray_csrbank2_sram_writer_ev_pending_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_ev_pending_r;
reg           builder_csr_bankarray_csrbank2_sram_writer_ev_pending_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_ev_pending_w;
reg           builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_r;
reg           builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_w;
reg           builder_csr_bankarray_csrbank2_sram_reader_ready_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ready_r;
reg           builder_csr_bankarray_csrbank2_sram_reader_ready_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ready_w;
reg           builder_csr_bankarray_csrbank2_sram_reader_level_re = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank2_sram_reader_level_r;
reg           builder_csr_bankarray_csrbank2_sram_reader_level_we = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank2_sram_reader_level_w;
reg           builder_csr_bankarray_csrbank2_sram_reader_slot0_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_slot0_r;
reg           builder_csr_bankarray_csrbank2_sram_reader_slot0_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_slot0_w;
reg           builder_csr_bankarray_csrbank2_sram_reader_length0_re = 1'd0;
wire   [10:0] builder_csr_bankarray_csrbank2_sram_reader_length0_r;
reg           builder_csr_bankarray_csrbank2_sram_reader_length0_we = 1'd0;
wire   [10:0] builder_csr_bankarray_csrbank2_sram_reader_length0_w;
reg           builder_csr_bankarray_csrbank2_sram_reader_ev_status_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ev_status_r;
reg           builder_csr_bankarray_csrbank2_sram_reader_ev_status_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ev_status_w;
reg           builder_csr_bankarray_csrbank2_sram_reader_ev_pending_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ev_pending_r;
reg           builder_csr_bankarray_csrbank2_sram_reader_ev_pending_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ev_pending_w;
reg           builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_r;
reg           builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_w;
reg           builder_csr_bankarray_csrbank2_preamble_crc_re = 1'd0;
wire          builder_csr_bankarray_csrbank2_preamble_crc_r;
reg           builder_csr_bankarray_csrbank2_preamble_crc_we = 1'd0;
wire          builder_csr_bankarray_csrbank2_preamble_crc_w;
reg           builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_r;
reg           builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_w;
reg           builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_r;
reg           builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_w;
wire          builder_csr_bankarray_csrbank2_sel;
wire   [13:0] builder_csr_bankarray_interface3_bank_bus_adr;
wire          builder_csr_bankarray_interface3_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface3_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface3_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank3_crg_reset0_re = 1'd0;
wire          builder_csr_bankarray_csrbank3_crg_reset0_r;
reg           builder_csr_bankarray_csrbank3_crg_reset0_we = 1'd0;
wire          builder_csr_bankarray_csrbank3_crg_reset0_w;
wire          builder_csr_bankarray_csrbank3_sel;
wire   [13:0] builder_csr_bankarray_sram_bus_adr;
wire          builder_csr_bankarray_sram_bus_we;
wire   [31:0] builder_csr_bankarray_sram_bus_dat_w;
reg    [31:0] builder_csr_bankarray_sram_bus_dat_r = 32'd0;
wire    [4:0] builder_csr_bankarray_adr;
wire    [7:0] builder_csr_bankarray_dat_r;
wire          builder_csr_bankarray_sel;
reg           builder_csr_bankarray_sel_r = 1'd0;
wire   [13:0] builder_csr_bankarray_interface4_bank_bus_adr;
wire          builder_csr_bankarray_interface4_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface4_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface4_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank4_out0_re = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank4_out0_r;
reg           builder_csr_bankarray_csrbank4_out0_we = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank4_out0_w;
wire          builder_csr_bankarray_csrbank4_sel;
wire   [13:0] builder_csr_bankarray_interface5_bank_bus_adr;
wire          builder_csr_bankarray_interface5_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface5_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface5_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank5_dma_base1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_base1_r;
reg           builder_csr_bankarray_csrbank5_dma_base1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_base1_w;
reg           builder_csr_bankarray_csrbank5_dma_base0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_base0_r;
reg           builder_csr_bankarray_csrbank5_dma_base0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_base0_w;
reg           builder_csr_bankarray_csrbank5_dma_length0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_length0_r;
reg           builder_csr_bankarray_csrbank5_dma_length0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_length0_w;
reg           builder_csr_bankarray_csrbank5_dma_enable0_re = 1'd0;
wire          builder_csr_bankarray_csrbank5_dma_enable0_r;
reg           builder_csr_bankarray_csrbank5_dma_enable0_we = 1'd0;
wire          builder_csr_bankarray_csrbank5_dma_enable0_w;
reg           builder_csr_bankarray_csrbank5_dma_done_re = 1'd0;
wire          builder_csr_bankarray_csrbank5_dma_done_r;
reg           builder_csr_bankarray_csrbank5_dma_done_we = 1'd0;
wire          builder_csr_bankarray_csrbank5_dma_done_w;
reg           builder_csr_bankarray_csrbank5_dma_loop0_re = 1'd0;
wire          builder_csr_bankarray_csrbank5_dma_loop0_r;
reg           builder_csr_bankarray_csrbank5_dma_loop0_we = 1'd0;
wire          builder_csr_bankarray_csrbank5_dma_loop0_w;
reg           builder_csr_bankarray_csrbank5_dma_offset_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_offset_r;
reg           builder_csr_bankarray_csrbank5_dma_offset_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank5_dma_offset_w;
wire          builder_csr_bankarray_csrbank5_sel;
wire   [13:0] builder_csr_bankarray_interface6_bank_bus_adr;
wire          builder_csr_bankarray_interface6_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface6_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface6_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank6_cmd_argument0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_argument0_r;
reg           builder_csr_bankarray_csrbank6_cmd_argument0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_argument0_w;
reg           builder_csr_bankarray_csrbank6_cmd_command0_re = 1'd0;
wire   [13:0] builder_csr_bankarray_csrbank6_cmd_command0_r;
reg           builder_csr_bankarray_csrbank6_cmd_command0_we = 1'd0;
wire   [13:0] builder_csr_bankarray_csrbank6_cmd_command0_w;
reg           builder_csr_bankarray_csrbank6_cmd_send0_re = 1'd0;
wire          builder_csr_bankarray_csrbank6_cmd_send0_r;
reg           builder_csr_bankarray_csrbank6_cmd_send0_we = 1'd0;
wire          builder_csr_bankarray_csrbank6_cmd_send0_w;
reg           builder_csr_bankarray_csrbank6_cmd_response3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response3_r;
reg           builder_csr_bankarray_csrbank6_cmd_response3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response3_w;
reg           builder_csr_bankarray_csrbank6_cmd_response2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response2_r;
reg           builder_csr_bankarray_csrbank6_cmd_response2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response2_w;
reg           builder_csr_bankarray_csrbank6_cmd_response1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response1_r;
reg           builder_csr_bankarray_csrbank6_cmd_response1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response1_w;
reg           builder_csr_bankarray_csrbank6_cmd_response0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response0_r;
reg           builder_csr_bankarray_csrbank6_cmd_response0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_cmd_response0_w;
reg           builder_csr_bankarray_csrbank6_cmd_event_re = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank6_cmd_event_r;
reg           builder_csr_bankarray_csrbank6_cmd_event_we = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank6_cmd_event_w;
reg           builder_csr_bankarray_csrbank6_data_event_re = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank6_data_event_r;
reg           builder_csr_bankarray_csrbank6_data_event_we = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank6_data_event_w;
reg           builder_csr_bankarray_csrbank6_block_length0_re = 1'd0;
wire    [9:0] builder_csr_bankarray_csrbank6_block_length0_r;
reg           builder_csr_bankarray_csrbank6_block_length0_we = 1'd0;
wire    [9:0] builder_csr_bankarray_csrbank6_block_length0_w;
reg           builder_csr_bankarray_csrbank6_block_count0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_block_count0_r;
reg           builder_csr_bankarray_csrbank6_block_count0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank6_block_count0_w;
wire          builder_csr_bankarray_csrbank6_sel;
wire   [13:0] builder_csr_bankarray_interface7_bank_bus_adr;
wire          builder_csr_bankarray_interface7_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface7_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface7_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank7_status_re = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank7_status_r;
reg           builder_csr_bankarray_csrbank7_status_we = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank7_status_w;
reg           builder_csr_bankarray_csrbank7_pending_re = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank7_pending_r;
reg           builder_csr_bankarray_csrbank7_pending_we = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank7_pending_w;
reg           builder_csr_bankarray_csrbank7_enable0_re = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank7_enable0_r;
reg           builder_csr_bankarray_csrbank7_enable0_we = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank7_enable0_w;
wire          builder_csr_bankarray_csrbank7_sel;
wire   [13:0] builder_csr_bankarray_interface8_bank_bus_adr;
wire          builder_csr_bankarray_interface8_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface8_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface8_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank8_dma_base1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_base1_r;
reg           builder_csr_bankarray_csrbank8_dma_base1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_base1_w;
reg           builder_csr_bankarray_csrbank8_dma_base0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_base0_r;
reg           builder_csr_bankarray_csrbank8_dma_base0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_base0_w;
reg           builder_csr_bankarray_csrbank8_dma_length0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_length0_r;
reg           builder_csr_bankarray_csrbank8_dma_length0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_length0_w;
reg           builder_csr_bankarray_csrbank8_dma_enable0_re = 1'd0;
wire          builder_csr_bankarray_csrbank8_dma_enable0_r;
reg           builder_csr_bankarray_csrbank8_dma_enable0_we = 1'd0;
wire          builder_csr_bankarray_csrbank8_dma_enable0_w;
reg           builder_csr_bankarray_csrbank8_dma_done_re = 1'd0;
wire          builder_csr_bankarray_csrbank8_dma_done_r;
reg           builder_csr_bankarray_csrbank8_dma_done_we = 1'd0;
wire          builder_csr_bankarray_csrbank8_dma_done_w;
reg           builder_csr_bankarray_csrbank8_dma_loop0_re = 1'd0;
wire          builder_csr_bankarray_csrbank8_dma_loop0_r;
reg           builder_csr_bankarray_csrbank8_dma_loop0_we = 1'd0;
wire          builder_csr_bankarray_csrbank8_dma_loop0_w;
reg           builder_csr_bankarray_csrbank8_dma_offset_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_offset_r;
reg           builder_csr_bankarray_csrbank8_dma_offset_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank8_dma_offset_w;
wire          builder_csr_bankarray_csrbank8_sel;
wire   [13:0] builder_csr_bankarray_interface9_bank_bus_adr;
wire          builder_csr_bankarray_interface9_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface9_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface9_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank9_card_detect_re = 1'd0;
wire          builder_csr_bankarray_csrbank9_card_detect_r;
reg           builder_csr_bankarray_csrbank9_card_detect_we = 1'd0;
wire          builder_csr_bankarray_csrbank9_card_detect_w;
reg           builder_csr_bankarray_csrbank9_clocker_divider0_re = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank9_clocker_divider0_r;
reg           builder_csr_bankarray_csrbank9_clocker_divider0_we = 1'd0;
wire    [8:0] builder_csr_bankarray_csrbank9_clocker_divider0_w;
reg           builder_csr_bankarray_csrbank9_dataw_status_re = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank9_dataw_status_r;
reg           builder_csr_bankarray_csrbank9_dataw_status_we = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank9_dataw_status_w;
wire          builder_csr_bankarray_csrbank9_sel;
wire   [13:0] builder_csr_bankarray_interface10_bank_bus_adr;
wire          builder_csr_bankarray_interface10_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface10_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface10_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank10_dfii_control0_re = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank10_dfii_control0_r;
reg           builder_csr_bankarray_csrbank10_dfii_control0_we = 1'd0;
wire    [3:0] builder_csr_bankarray_csrbank10_dfii_control0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_command0_re = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi0_command0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_command0_we = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi0_command0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_address0_re = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi0_address0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_address0_we = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi0_address0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_re = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_we = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_command0_re = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi1_command0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_command0_we = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi1_command0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_address0_re = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi1_address0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_address0_we = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi1_address0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_re = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_we = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_command0_re = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi2_command0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_command0_we = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi2_command0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_address0_re = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi2_address0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_address0_we = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi2_address0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_re = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_we = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_command0_re = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi3_command0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_command0_we = 1'd0;
wire    [7:0] builder_csr_bankarray_csrbank10_dfii_pi3_command0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_address0_re = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi3_address0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_address0_we = 1'd0;
wire   [14:0] builder_csr_bankarray_csrbank10_dfii_pi3_address0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_re = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_we = 1'd0;
wire    [2:0] builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_w;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_r;
reg           builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_w;
wire          builder_csr_bankarray_csrbank10_sel;
wire   [13:0] builder_csr_bankarray_interface11_bank_bus_adr;
wire          builder_csr_bankarray_interface11_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface11_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface11_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank11_load0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank11_load0_r;
reg           builder_csr_bankarray_csrbank11_load0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank11_load0_w;
reg           builder_csr_bankarray_csrbank11_reload0_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank11_reload0_r;
reg           builder_csr_bankarray_csrbank11_reload0_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank11_reload0_w;
reg           builder_csr_bankarray_csrbank11_en0_re = 1'd0;
wire          builder_csr_bankarray_csrbank11_en0_r;
reg           builder_csr_bankarray_csrbank11_en0_we = 1'd0;
wire          builder_csr_bankarray_csrbank11_en0_w;
reg           builder_csr_bankarray_csrbank11_update_value0_re = 1'd0;
wire          builder_csr_bankarray_csrbank11_update_value0_r;
reg           builder_csr_bankarray_csrbank11_update_value0_we = 1'd0;
wire          builder_csr_bankarray_csrbank11_update_value0_w;
reg           builder_csr_bankarray_csrbank11_value_re = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank11_value_r;
reg           builder_csr_bankarray_csrbank11_value_we = 1'd0;
wire   [31:0] builder_csr_bankarray_csrbank11_value_w;
reg           builder_csr_bankarray_csrbank11_ev_status_re = 1'd0;
wire          builder_csr_bankarray_csrbank11_ev_status_r;
reg           builder_csr_bankarray_csrbank11_ev_status_we = 1'd0;
wire          builder_csr_bankarray_csrbank11_ev_status_w;
reg           builder_csr_bankarray_csrbank11_ev_pending_re = 1'd0;
wire          builder_csr_bankarray_csrbank11_ev_pending_r;
reg           builder_csr_bankarray_csrbank11_ev_pending_we = 1'd0;
wire          builder_csr_bankarray_csrbank11_ev_pending_w;
reg           builder_csr_bankarray_csrbank11_ev_enable0_re = 1'd0;
wire          builder_csr_bankarray_csrbank11_ev_enable0_r;
reg           builder_csr_bankarray_csrbank11_ev_enable0_we = 1'd0;
wire          builder_csr_bankarray_csrbank11_ev_enable0_w;
wire          builder_csr_bankarray_csrbank11_sel;
wire   [13:0] builder_csr_bankarray_interface12_bank_bus_adr;
wire          builder_csr_bankarray_interface12_bank_bus_we;
wire   [31:0] builder_csr_bankarray_interface12_bank_bus_dat_w;
reg    [31:0] builder_csr_bankarray_interface12_bank_bus_dat_r = 32'd0;
reg           builder_csr_bankarray_csrbank12_txfull_re = 1'd0;
wire          builder_csr_bankarray_csrbank12_txfull_r;
reg           builder_csr_bankarray_csrbank12_txfull_we = 1'd0;
wire          builder_csr_bankarray_csrbank12_txfull_w;
reg           builder_csr_bankarray_csrbank12_rxempty_re = 1'd0;
wire          builder_csr_bankarray_csrbank12_rxempty_r;
reg           builder_csr_bankarray_csrbank12_rxempty_we = 1'd0;
wire          builder_csr_bankarray_csrbank12_rxempty_w;
reg           builder_csr_bankarray_csrbank12_ev_status_re = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank12_ev_status_r;
reg           builder_csr_bankarray_csrbank12_ev_status_we = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank12_ev_status_w;
reg           builder_csr_bankarray_csrbank12_ev_pending_re = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank12_ev_pending_r;
reg           builder_csr_bankarray_csrbank12_ev_pending_we = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank12_ev_pending_w;
reg           builder_csr_bankarray_csrbank12_ev_enable0_re = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank12_ev_enable0_r;
reg           builder_csr_bankarray_csrbank12_ev_enable0_we = 1'd0;
wire    [1:0] builder_csr_bankarray_csrbank12_ev_enable0_w;
reg           builder_csr_bankarray_csrbank12_txempty_re = 1'd0;
wire          builder_csr_bankarray_csrbank12_txempty_r;
reg           builder_csr_bankarray_csrbank12_txempty_we = 1'd0;
wire          builder_csr_bankarray_csrbank12_txempty_w;
reg           builder_csr_bankarray_csrbank12_rxfull_re = 1'd0;
wire          builder_csr_bankarray_csrbank12_rxfull_r;
reg           builder_csr_bankarray_csrbank12_rxfull_we = 1'd0;
wire          builder_csr_bankarray_csrbank12_rxfull_w;
wire          builder_csr_bankarray_csrbank12_sel;
wire   [13:0] builder_csr_interconnect_adr;
wire          builder_csr_interconnect_we;
wire   [31:0] builder_csr_interconnect_dat_w;
wire   [31:0] builder_csr_interconnect_dat_r;
wire          builder_soclinux_reset0;
wire          builder_soclinux_reset1;
wire          builder_soclinux_reset2;
wire          builder_soclinux_reset3;
wire          builder_soclinux_reset4;
wire          builder_soclinux_reset5;
wire          builder_soclinux_reset6;
wire          builder_soclinux_reset7;
wire          builder_soclinux_mmcm_fb;
reg           builder_soclinux_rs232phytx_state = 1'd0;
reg           builder_soclinux_rs232phytx_next_state = 1'd0;
reg     [3:0] main_tx_count_rs232phytx_next_value0 = 4'd0;
reg           main_tx_count_rs232phytx_next_value_ce0 = 1'd0;
reg           main_serial_tx_rs232phytx_next_value1 = 1'd0;
reg           main_serial_tx_rs232phytx_next_value_ce1 = 1'd0;
reg     [7:0] main_tx_data_rs232phytx_next_value2 = 8'd0;
reg           main_tx_data_rs232phytx_next_value_ce2 = 1'd0;
reg           builder_soclinux_rs232phyrx_state = 1'd0;
reg           builder_soclinux_rs232phyrx_next_state = 1'd0;
reg     [3:0] main_rx_count_rs232phyrx_next_value0 = 4'd0;
reg           main_rx_count_rs232phyrx_next_value_ce0 = 1'd0;
reg     [7:0] main_rx_data_rs232phyrx_next_value1 = 8'd0;
reg           main_rx_data_rs232phyrx_next_value_ce1 = 1'd0;
reg     [1:0] builder_soclinux_refresher_state = 2'd0;
reg     [1:0] builder_soclinux_refresher_next_state = 2'd0;
reg     [3:0] builder_soclinux_bankmachine0_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine0_next_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine1_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine1_next_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine2_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine2_next_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine3_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine3_next_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine4_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine4_next_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine5_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine5_next_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine6_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine6_next_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine7_state = 4'd0;
reg     [3:0] builder_soclinux_bankmachine7_next_state = 4'd0;
reg     [3:0] builder_soclinux_multiplexer_state = 4'd0;
reg     [3:0] builder_soclinux_multiplexer_next_state = 4'd0;
wire    [1:0] builder_soclinux_roundrobin0_request;
reg           builder_soclinux_roundrobin0_grant = 1'd0;
wire          builder_soclinux_roundrobin0_ce;
wire    [1:0] builder_soclinux_roundrobin1_request;
reg           builder_soclinux_roundrobin1_grant = 1'd0;
wire          builder_soclinux_roundrobin1_ce;
wire    [1:0] builder_soclinux_roundrobin2_request;
reg           builder_soclinux_roundrobin2_grant = 1'd0;
wire          builder_soclinux_roundrobin2_ce;
wire    [1:0] builder_soclinux_roundrobin3_request;
reg           builder_soclinux_roundrobin3_grant = 1'd0;
wire          builder_soclinux_roundrobin3_ce;
wire    [1:0] builder_soclinux_roundrobin4_request;
reg           builder_soclinux_roundrobin4_grant = 1'd0;
wire          builder_soclinux_roundrobin4_ce;
wire    [1:0] builder_soclinux_roundrobin5_request;
reg           builder_soclinux_roundrobin5_grant = 1'd0;
wire          builder_soclinux_roundrobin5_ce;
wire    [1:0] builder_soclinux_roundrobin6_request;
reg           builder_soclinux_roundrobin6_grant = 1'd0;
wire          builder_soclinux_roundrobin6_ce;
wire    [1:0] builder_soclinux_roundrobin7_request;
reg           builder_soclinux_roundrobin7_grant = 1'd0;
wire          builder_soclinux_roundrobin7_ce;
reg           builder_soclinux_locked0 = 1'd0;
reg           builder_soclinux_locked1 = 1'd0;
reg           builder_soclinux_locked2 = 1'd0;
reg           builder_soclinux_locked3 = 1'd0;
reg           builder_soclinux_locked4 = 1'd0;
reg           builder_soclinux_locked5 = 1'd0;
reg           builder_soclinux_locked6 = 1'd0;
reg           builder_soclinux_locked7 = 1'd0;
reg           builder_soclinux_locked8 = 1'd0;
reg           builder_soclinux_locked9 = 1'd0;
reg           builder_soclinux_locked10 = 1'd0;
reg           builder_soclinux_locked11 = 1'd0;
reg           builder_soclinux_locked12 = 1'd0;
reg           builder_soclinux_locked13 = 1'd0;
reg           builder_soclinux_locked14 = 1'd0;
reg           builder_soclinux_locked15 = 1'd0;
reg           builder_soclinux_new_master_wdata_ready0 = 1'd0;
reg           builder_soclinux_new_master_wdata_ready1 = 1'd0;
reg           builder_soclinux_new_master_wdata_ready2 = 1'd0;
reg           builder_soclinux_new_master_wdata_ready3 = 1'd0;
reg           builder_soclinux_new_master_wdata_ready4 = 1'd0;
reg           builder_soclinux_new_master_wdata_ready5 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid0 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid1 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid2 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid3 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid4 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid5 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid6 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid7 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid8 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid9 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid10 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid11 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid12 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid13 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid14 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid15 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid16 = 1'd0;
reg           builder_soclinux_new_master_rdata_valid17 = 1'd0;
reg     [2:0] builder_soclinux_ku_1000basex_pcstx_state = 3'd0;
reg     [2:0] builder_soclinux_ku_1000basex_pcstx_next_state = 3'd0;
reg           main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value = 1'd0;
reg           main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value_ce = 1'd0;
reg     [2:0] builder_soclinux_ku_1000basex_pcsrx_state = 3'd0;
reg     [2:0] builder_soclinux_ku_1000basex_pcsrx_next_state = 3'd0;
reg     [2:0] builder_soclinux_ku_1000basex_fsm_state = 3'd0;
reg     [2:0] builder_soclinux_ku_1000basex_fsm_next_state = 3'd0;
reg           builder_soclinux_txdatapath_liteethmactxlastbe_state = 1'd0;
reg           builder_soclinux_txdatapath_liteethmactxlastbe_next_state = 1'd0;
reg           builder_soclinux_txdatapath_liteethmacpaddinginserter_state = 1'd0;
reg           builder_soclinux_txdatapath_liteethmacpaddinginserter_next_state = 1'd0;
reg    [15:0] main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value = 16'd0;
reg           main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value_ce = 1'd0;
reg     [1:0] builder_soclinux_txdatapath_bufferizeendpoints_state = 2'd0;
reg     [1:0] builder_soclinux_txdatapath_bufferizeendpoints_next_state = 2'd0;
reg    [31:0] main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value0 = 32'd0;
reg           main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce0 = 1'd0;
reg           main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value1 = 1'd0;
reg           main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce1 = 1'd0;
reg     [1:0] builder_soclinux_txdatapath_liteethmacpreambleinserter_state = 2'd0;
reg     [1:0] builder_soclinux_txdatapath_liteethmacpreambleinserter_next_state = 2'd0;
reg     [2:0] main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value = 3'd0;
reg           main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value_ce = 1'd0;
reg           builder_soclinux_txdatapath_liteethmacgap_state = 1'd0;
reg           builder_soclinux_txdatapath_liteethmacgap_next_state = 1'd0;
reg     [3:0] main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value = 4'd0;
reg           main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value_ce = 1'd0;
reg           builder_soclinux_rxdatapath_liteethmacpreamblechecker_state = 1'd0;
reg           builder_soclinux_rxdatapath_liteethmacpreamblechecker_next_state = 1'd0;
reg     [1:0] builder_soclinux_rxdatapath_bufferizeendpoints_state = 2'd0;
reg     [1:0] builder_soclinux_rxdatapath_bufferizeendpoints_next_state = 2'd0;
reg           main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value0 = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value_ce0 = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value1 = 1'd0;
reg           main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value_ce1 = 1'd0;
reg     [2:0] builder_soclinux_liteethmacsramwriter_state = 3'd0;
reg     [2:0] builder_soclinux_liteethmacsramwriter_next_state = 3'd0;
reg    [10:0] main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value = 11'd0;
reg           main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value_ce = 1'd0;
reg    [31:0] main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value = 32'd0;
reg           main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value_ce = 1'd0;
reg           main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value = 1'd0;
reg           main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value_ce = 1'd0;
reg     [1:0] builder_soclinux_liteethmacsramreader_state = 2'd0;
reg     [1:0] builder_soclinux_liteethmacsramreader_next_state = 2'd0;
reg    [10:0] main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value = 11'd0;
reg           main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value_ce = 1'd0;
reg           builder_soclinux_sdphyinit_state = 1'd0;
reg           builder_soclinux_sdphyinit_next_state = 1'd0;
reg     [7:0] init_count_sdphyinit_next_value = 8'd0;
reg           init_count_sdphyinit_next_value_ce = 1'd0;
reg     [1:0] builder_soclinux_sdphycmdw_state = 2'd0;
reg     [1:0] builder_soclinux_sdphycmdw_next_state = 2'd0;
reg     [7:0] cmdw_count_sdphycmdw_next_value = 8'd0;
reg           cmdw_count_sdphycmdw_next_value_ce = 1'd0;
reg     [2:0] builder_soclinux_sdphycmdr_state = 3'd0;
reg     [2:0] builder_soclinux_sdphycmdr_next_state = 3'd0;
reg    [31:0] cmdr_timeout_sdphycmdr_next_value0 = 32'd0;
reg           cmdr_timeout_sdphycmdr_next_value_ce0 = 1'd0;
reg     [7:0] cmdr_count_sdphycmdr_next_value1 = 8'd0;
reg           cmdr_count_sdphycmdr_next_value_ce1 = 1'd0;
reg           cmdr_busy_sdphycmdr_next_value2 = 1'd0;
reg           cmdr_busy_sdphycmdr_next_value_ce2 = 1'd0;
reg           cmdr_cmdr_reset_sdphycmdr_next_value3 = 1'd0;
reg           cmdr_cmdr_reset_sdphycmdr_next_value_ce3 = 1'd0;
reg     [2:0] builder_soclinux_sdphydataw_state = 3'd0;
reg     [2:0] builder_soclinux_sdphydataw_next_state = 3'd0;
reg           dataw_accepted1_sdphydataw_next_value0 = 1'd0;
reg           dataw_accepted1_sdphydataw_next_value_ce0 = 1'd0;
reg           dataw_crc_error1_sdphydataw_next_value1 = 1'd0;
reg           dataw_crc_error1_sdphydataw_next_value_ce1 = 1'd0;
reg           dataw_write_error1_sdphydataw_next_value2 = 1'd0;
reg           dataw_write_error1_sdphydataw_next_value_ce2 = 1'd0;
reg     [7:0] dataw_count_sdphydataw_next_value3 = 8'd0;
reg           dataw_count_sdphydataw_next_value_ce3 = 1'd0;
reg     [2:0] builder_soclinux_sdphydatar_state = 3'd0;
reg     [2:0] builder_soclinux_sdphydatar_next_state = 3'd0;
reg     [9:0] datar_count_sdphydatar_next_value0 = 10'd0;
reg           datar_count_sdphydatar_next_value_ce0 = 1'd0;
reg    [31:0] datar_timeout_sdphydatar_next_value1 = 32'd0;
reg           datar_timeout_sdphydatar_next_value_ce1 = 1'd0;
reg           datar_datar_reset_sdphydatar_next_value2 = 1'd0;
reg           datar_datar_reset_sdphydatar_next_value_ce2 = 1'd0;
reg           builder_soclinux_sdcore_crc16inserter_state = 1'd0;
reg           builder_soclinux_sdcore_crc16inserter_next_state = 1'd0;
reg     [2:0] sdcore_crc16_inserter_count_crc16inserter_next_value = 3'd0;
reg           sdcore_crc16_inserter_count_crc16inserter_next_value_ce = 1'd0;
reg     [2:0] builder_soclinux_sdcore_fsm_state = 3'd0;
reg     [2:0] builder_soclinux_sdcore_fsm_next_state = 3'd0;
reg           sdcore_cmd_done_fsm_next_value0 = 1'd0;
reg           sdcore_cmd_done_fsm_next_value_ce0 = 1'd0;
reg           sdcore_data_done_fsm_next_value1 = 1'd0;
reg           sdcore_data_done_fsm_next_value_ce1 = 1'd0;
reg     [2:0] sdcore_cmd_count_fsm_next_value2 = 3'd0;
reg           sdcore_cmd_count_fsm_next_value_ce2 = 1'd0;
reg    [31:0] sdcore_data_count_fsm_next_value3 = 32'd0;
reg           sdcore_data_count_fsm_next_value_ce3 = 1'd0;
reg           sdcore_cmd_error_fsm_next_value4 = 1'd0;
reg           sdcore_cmd_error_fsm_next_value_ce4 = 1'd0;
reg           sdcore_cmd_timeout_fsm_next_value5 = 1'd0;
reg           sdcore_cmd_timeout_fsm_next_value_ce5 = 1'd0;
reg           sdcore_data_error_fsm_next_value6 = 1'd0;
reg           sdcore_data_error_fsm_next_value_ce6 = 1'd0;
reg           sdcore_data_timeout_fsm_next_value7 = 1'd0;
reg           sdcore_data_timeout_fsm_next_value_ce7 = 1'd0;
reg   [127:0] sdcore_cmd_response_status_fsm_next_value8 = 128'd0;
reg           sdcore_cmd_response_status_fsm_next_value_ce8 = 1'd0;
reg     [1:0] builder_soclinux_sdblock2memdma_state = 2'd0;
reg     [1:0] builder_soclinux_sdblock2memdma_next_state = 2'd0;
reg    [31:0] sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value = 32'd0;
reg           sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value_ce = 1'd0;
reg     [1:0] builder_soclinux_sdmem2blockdma_state = 2'd0;
reg     [1:0] builder_soclinux_sdmem2blockdma_next_state = 2'd0;
reg    [31:0] sdmem2block_dma_offset_sdmem2blockdma_next_value = 32'd0;
reg           sdmem2block_dma_offset_sdmem2blockdma_next_value_ce = 1'd0;
reg     [1:0] builder_soclinux_wishbone2csr_state = 2'd0;
reg     [1:0] builder_soclinux_wishbone2csr_next_state = 2'd0;
reg    [31:0] builder_soclinux_dat_w_wishbone2csr_next_value0 = 32'd0;
reg           builder_soclinux_dat_w_wishbone2csr_next_value_ce0 = 1'd0;
reg    [13:0] builder_soclinux_adr_wishbone2csr_next_value1 = 14'd0;
reg           builder_soclinux_adr_wishbone2csr_next_value_ce1 = 1'd0;
reg           builder_soclinux_we_wishbone2csr_next_value2 = 1'd0;
reg           builder_soclinux_we_wishbone2csr_next_value_ce2 = 1'd0;
wire   [31:0] builder_t_slice_proxy0;
wire   [31:0] builder_t_slice_proxy1;
wire   [31:0] builder_t_slice_proxy2;
wire   [31:0] builder_t_slice_proxy3;
wire   [31:0] builder_t_slice_proxy4;
wire   [31:0] builder_t_slice_proxy5;
wire   [31:0] builder_t_slice_proxy6;
wire   [31:0] builder_t_slice_proxy7;
wire   [31:0] builder_t_slice_proxy8;
wire   [31:0] builder_t_slice_proxy9;
wire   [31:0] builder_t_slice_proxy10;
wire   [31:0] builder_t_slice_proxy11;
wire   [31:0] builder_t_slice_proxy12;
wire   [31:0] builder_t_slice_proxy13;
wire   [31:0] builder_t_slice_proxy14;
wire   [31:0] builder_t_slice_proxy15;
wire   [31:0] builder_t_slice_proxy16;
wire   [31:0] builder_t_slice_proxy17;
wire   [31:0] builder_t_slice_proxy18;
wire   [31:0] builder_t_slice_proxy19;
wire   [31:0] builder_t_slice_proxy20;
wire   [31:0] builder_t_slice_proxy21;
wire   [31:0] builder_t_slice_proxy22;
wire   [31:0] builder_t_slice_proxy23;
wire   [31:0] builder_t_slice_proxy24;
wire   [31:0] builder_t_slice_proxy25;
wire   [31:0] builder_t_slice_proxy26;
wire   [31:0] builder_t_slice_proxy27;
wire   [31:0] builder_t_slice_proxy28;
wire   [31:0] builder_t_slice_proxy29;
wire   [31:0] builder_t_slice_proxy30;
wire   [31:0] builder_t_slice_proxy31;
wire   [39:0] builder_cases_slice_proxy;
wire   [31:0] builder_t_slice_proxy32;
wire   [31:0] builder_t_slice_proxy33;
wire   [31:0] builder_t_slice_proxy34;
wire   [31:0] builder_t_slice_proxy35;
wire   [31:0] builder_t_slice_proxy36;
wire   [31:0] builder_t_slice_proxy37;
wire   [31:0] builder_t_slice_proxy38;
wire   [31:0] builder_t_slice_proxy39;
wire   [31:0] builder_t_slice_proxy40;
wire   [31:0] builder_t_slice_proxy41;
wire   [31:0] builder_t_slice_proxy42;
wire   [31:0] builder_t_slice_proxy43;
wire   [31:0] builder_t_slice_proxy44;
wire   [31:0] builder_t_slice_proxy45;
wire   [31:0] builder_t_slice_proxy46;
wire   [31:0] builder_t_slice_proxy47;
wire   [31:0] builder_t_slice_proxy48;
wire   [31:0] builder_t_slice_proxy49;
wire   [31:0] builder_t_slice_proxy50;
wire   [31:0] builder_t_slice_proxy51;
wire   [31:0] builder_t_slice_proxy52;
wire   [31:0] builder_t_slice_proxy53;
wire   [31:0] builder_t_slice_proxy54;
wire   [31:0] builder_t_slice_proxy55;
wire   [31:0] builder_t_slice_proxy56;
wire   [31:0] builder_t_slice_proxy57;
wire   [31:0] builder_t_slice_proxy58;
wire   [31:0] builder_t_slice_proxy59;
wire   [31:0] builder_t_slice_proxy60;
wire   [31:0] builder_t_slice_proxy61;
wire   [31:0] builder_t_slice_proxy62;
wire   [31:0] builder_t_slice_proxy63;
reg    [29:0] builder_comb_rhs_array_muxed0 = 30'd0;
reg    [31:0] builder_comb_rhs_array_muxed1 = 32'd0;
reg     [3:0] builder_comb_rhs_array_muxed2 = 4'd0;
reg           builder_comb_rhs_array_muxed3 = 1'd0;
reg           builder_comb_rhs_array_muxed4 = 1'd0;
reg           builder_comb_rhs_array_muxed5 = 1'd0;
reg     [2:0] builder_comb_rhs_array_muxed6 = 3'd0;
reg     [1:0] builder_comb_rhs_array_muxed7 = 2'd0;
reg    [31:0] builder_comb_rhs_array_muxed8 = 32'd0;
reg    [31:0] builder_comb_rhs_array_muxed9 = 32'd0;
reg     [3:0] builder_comb_rhs_array_muxed10 = 4'd0;
reg           builder_comb_rhs_array_muxed11 = 1'd0;
reg           builder_comb_rhs_array_muxed12 = 1'd0;
reg           builder_comb_rhs_array_muxed13 = 1'd0;
reg     [2:0] builder_comb_rhs_array_muxed14 = 3'd0;
reg     [1:0] builder_comb_rhs_array_muxed15 = 2'd0;
reg           builder_comb_rhs_array_muxed16 = 1'd0;
reg    [14:0] builder_comb_rhs_array_muxed17 = 15'd0;
reg     [2:0] builder_comb_rhs_array_muxed18 = 3'd0;
reg           builder_comb_rhs_array_muxed19 = 1'd0;
reg           builder_comb_rhs_array_muxed20 = 1'd0;
reg           builder_comb_rhs_array_muxed21 = 1'd0;
reg           builder_comb_t_array_muxed0 = 1'd0;
reg           builder_comb_t_array_muxed1 = 1'd0;
reg           builder_comb_t_array_muxed2 = 1'd0;
reg           builder_comb_rhs_array_muxed22 = 1'd0;
reg    [14:0] builder_comb_rhs_array_muxed23 = 15'd0;
reg     [2:0] builder_comb_rhs_array_muxed24 = 3'd0;
reg           builder_comb_rhs_array_muxed25 = 1'd0;
reg           builder_comb_rhs_array_muxed26 = 1'd0;
reg           builder_comb_rhs_array_muxed27 = 1'd0;
reg           builder_comb_t_array_muxed3 = 1'd0;
reg           builder_comb_t_array_muxed4 = 1'd0;
reg           builder_comb_t_array_muxed5 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed28 = 22'd0;
reg           builder_comb_rhs_array_muxed29 = 1'd0;
reg           builder_comb_rhs_array_muxed30 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed31 = 22'd0;
reg           builder_comb_rhs_array_muxed32 = 1'd0;
reg           builder_comb_rhs_array_muxed33 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed34 = 22'd0;
reg           builder_comb_rhs_array_muxed35 = 1'd0;
reg           builder_comb_rhs_array_muxed36 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed37 = 22'd0;
reg           builder_comb_rhs_array_muxed38 = 1'd0;
reg           builder_comb_rhs_array_muxed39 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed40 = 22'd0;
reg           builder_comb_rhs_array_muxed41 = 1'd0;
reg           builder_comb_rhs_array_muxed42 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed43 = 22'd0;
reg           builder_comb_rhs_array_muxed44 = 1'd0;
reg           builder_comb_rhs_array_muxed45 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed46 = 22'd0;
reg           builder_comb_rhs_array_muxed47 = 1'd0;
reg           builder_comb_rhs_array_muxed48 = 1'd0;
reg    [21:0] builder_comb_rhs_array_muxed49 = 22'd0;
reg           builder_comb_rhs_array_muxed50 = 1'd0;
reg           builder_comb_rhs_array_muxed51 = 1'd0;
reg     [2:0] builder_sync_t_array_muxed0 = 3'd0;
reg     [2:0] builder_sync_t_array_muxed1 = 3'd0;
reg     [2:0] builder_sync_f_array_muxed = 3'd0;
reg     [5:0] builder_sync_rhs_array_muxed0 = 6'd0;
reg           builder_sync_rhs_array_muxed1 = 1'd0;
reg           builder_sync_rhs_array_muxed2 = 1'd0;
reg     [3:0] builder_sync_rhs_array_muxed3 = 4'd0;
reg           builder_sync_rhs_array_muxed4 = 1'd0;
reg           builder_sync_rhs_array_muxed5 = 1'd0;
reg     [2:0] builder_sync_array_muxed0 = 3'd0;
reg    [14:0] builder_sync_array_muxed1 = 15'd0;
reg           builder_sync_array_muxed2 = 1'd0;
reg           builder_sync_array_muxed3 = 1'd0;
reg           builder_sync_array_muxed4 = 1'd0;
reg           builder_sync_array_muxed5 = 1'd0;
reg           builder_sync_array_muxed6 = 1'd0;
reg     [2:0] builder_sync_array_muxed7 = 3'd0;
reg    [14:0] builder_sync_array_muxed8 = 15'd0;
reg           builder_sync_array_muxed9 = 1'd0;
reg           builder_sync_array_muxed10 = 1'd0;
reg           builder_sync_array_muxed11 = 1'd0;
reg           builder_sync_array_muxed12 = 1'd0;
reg           builder_sync_array_muxed13 = 1'd0;
reg     [2:0] builder_sync_array_muxed14 = 3'd0;
reg    [14:0] builder_sync_array_muxed15 = 15'd0;
reg           builder_sync_array_muxed16 = 1'd0;
reg           builder_sync_array_muxed17 = 1'd0;
reg           builder_sync_array_muxed18 = 1'd0;
reg           builder_sync_array_muxed19 = 1'd0;
reg           builder_sync_array_muxed20 = 1'd0;
reg     [2:0] builder_sync_array_muxed21 = 3'd0;
reg    [14:0] builder_sync_array_muxed22 = 15'd0;
reg           builder_sync_array_muxed23 = 1'd0;
reg           builder_sync_array_muxed24 = 1'd0;
reg           builder_sync_array_muxed25 = 1'd0;
reg           builder_sync_array_muxed26 = 1'd0;
reg           builder_sync_array_muxed27 = 1'd0;
wire          builder_xilinxasyncresetsynchronizerimpl0;
wire          builder_xilinxasyncresetsynchronizerimpl0_rst_meta;
wire          builder_xilinxasyncresetsynchronizerimpl1;
wire          builder_xilinxasyncresetsynchronizerimpl1_rst_meta;
wire          builder_xilinxasyncresetsynchronizerimpl2_rst_meta;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl0_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl0_regs1 = 1'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl1_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl1_regs1 = 1'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl2_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl2_regs1 = 1'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg    [15:0] builder_xilinxmultiregimpl3_regs0 = 16'd0;
(* async_reg = "true", dont_touch = "true" *)
reg    [15:0] builder_xilinxmultiregimpl3_regs1 = 16'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl4_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl4_regs1 = 1'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl5_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl5_regs1 = 1'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl6_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl6_regs1 = 1'd0;
wire          builder_xilinxasyncresetsynchronizerimpl3;
wire          builder_xilinxasyncresetsynchronizerimpl3_rst_meta;
wire          builder_xilinxasyncresetsynchronizerimpl4;
wire          builder_xilinxasyncresetsynchronizerimpl4_rst_meta;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl7_regs0 = 6'd0;
(* async_reg = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl7_regs1 = 6'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl8_regs0 = 6'd0;
(* async_reg = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl8_regs1 = 6'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl9_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl9_regs1 = 1'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl10_regs0 = 1'd0;
(* async_reg = "true", dont_touch = "true" *)
reg           builder_xilinxmultiregimpl10_regs1 = 1'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl11_regs0 = 6'd0;
(* async_reg = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl11_regs1 = 6'd0;
(* async_reg = "true", mr_ff = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl12_regs0 = 6'd0;
(* async_reg = "true", dont_touch = "true" *)
reg     [5:0] builder_xilinxmultiregimpl12_regs1 = 6'd0;
wire          builder_xilinxsdrtristateimpl0__o;
wire          builder_xilinxsdrtristateimpl0_oe_n;
wire          builder_xilinxsdrtristateimpl0__i;
wire          builder_xilinxsdrtristateimpl1__o;
wire          builder_xilinxsdrtristateimpl1_oe_n;
wire          builder_xilinxsdrtristateimpl1__i;
wire          builder_xilinxsdrtristateimpl2__o;
wire          builder_xilinxsdrtristateimpl2_oe_n;
wire          builder_xilinxsdrtristateimpl2__i;
wire          builder_xilinxsdrtristateimpl3__o;
wire          builder_xilinxsdrtristateimpl3_oe_n;
wire          builder_xilinxsdrtristateimpl3__i;
wire          builder_xilinxsdrtristateimpl4__o;
wire          builder_xilinxsdrtristateimpl4_oe_n;
wire          builder_xilinxsdrtristateimpl4__i;

//------------------------------------------------------------------------------
// Combinatorial Logic
//------------------------------------------------------------------------------

assign main_cpu_reset = (main_soc_rst | main_cpu_rst);
assign main_litedramnativeport0_cmd_valid = main_ibus_cmd_valid;
assign main_ibus_cmd_ready = main_litedramnativeport0_cmd_ready;
assign main_litedramnativeport0_cmd_first = main_ibus_cmd_first;
assign main_litedramnativeport0_cmd_last = main_ibus_cmd_last;
assign main_litedramnativeport0_cmd_payload_we = main_ibus_cmd_payload_we;
assign main_litedramnativeport0_cmd_payload_addr = main_ibus_cmd_payload_addr;
assign main_litedramnativeport0_wdata_valid = main_ibus_wdata_valid;
assign main_ibus_wdata_ready = main_litedramnativeport0_wdata_ready;
assign main_litedramnativeport0_wdata_first = main_ibus_wdata_first;
assign main_litedramnativeport0_wdata_last = main_ibus_wdata_last;
assign main_litedramnativeport0_wdata_payload_data = main_ibus_wdata_payload_data;
assign main_litedramnativeport0_wdata_payload_we = main_ibus_wdata_payload_we;
assign main_ibus_rdata_valid = main_litedramnativeport0_rdata_valid;
assign main_litedramnativeport0_rdata_ready = main_ibus_rdata_ready;
assign main_ibus_rdata_first = main_litedramnativeport0_rdata_first;
assign main_ibus_rdata_last = main_litedramnativeport0_rdata_last;
assign main_ibus_rdata_payload_data = main_litedramnativeport0_rdata_payload_data;
assign main_litedramnativeport1_cmd_valid = main_dbus_cmd_valid;
assign main_dbus_cmd_ready = main_litedramnativeport1_cmd_ready;
assign main_litedramnativeport1_cmd_first = main_dbus_cmd_first;
assign main_litedramnativeport1_cmd_last = main_dbus_cmd_last;
assign main_litedramnativeport1_cmd_payload_we = main_dbus_cmd_payload_we;
assign main_litedramnativeport1_cmd_payload_addr = main_dbus_cmd_payload_addr;
assign main_litedramnativeport1_wdata_valid = main_dbus_wdata_valid;
assign main_dbus_wdata_ready = main_litedramnativeport1_wdata_ready;
assign main_litedramnativeport1_wdata_first = main_dbus_wdata_first;
assign main_litedramnativeport1_wdata_last = main_dbus_wdata_last;
assign main_litedramnativeport1_wdata_payload_data = main_dbus_wdata_payload_data;
assign main_litedramnativeport1_wdata_payload_we = main_dbus_wdata_payload_we;
assign main_dbus_rdata_valid = main_litedramnativeport1_rdata_valid;
assign main_litedramnativeport1_rdata_ready = main_dbus_rdata_ready;
assign main_dbus_rdata_first = main_litedramnativeport1_rdata_first;
assign main_dbus_rdata_last = main_litedramnativeport1_rdata_last;
assign main_dbus_rdata_payload_data = main_litedramnativeport1_rdata_payload_data;
assign sfp_tx_disable_n0 = 1'd1;
assign sdblock2mem_sink_sink_valid0 = sdcore_source_source_valid0;
assign sdcore_source_source_ready0 = sdblock2mem_sink_sink_ready0;
assign sdblock2mem_sink_sink_first = sdcore_source_source_first0;
assign sdblock2mem_sink_sink_last0 = sdcore_source_source_last0;
assign sdblock2mem_sink_sink_payload_data0 = sdcore_source_source_payload_data0;
assign sdcore_sink_sink_valid0 = sdmem2block_source_source_valid;
assign sdmem2block_source_source_ready = sdcore_sink_sink_ready0;
assign sdcore_sink_sink_first0 = sdmem2block_source_source_first;
assign sdcore_sink_sink_last0 = sdmem2block_source_source_last;
assign sdcore_sink_sink_payload_data0 = sdmem2block_source_source_payload_data;
assign block2mem_dma_trigger = sdblock2mem_irq;
assign mem2block_dma_trigger = sdmem2block_irq;
assign card_detect_trigger = card_detect_irq;
assign cmd_done_trigger = sdcore_csrfield_done0;
always @(*) begin
    main_crg_rst <= 1'd0;
    if (main_soc_rst) begin
        main_crg_rst <= 1'd1;
    end
end
assign main_bus_error = builder_socbushandler0_error;
always @(*) begin
    main_cpu_interrupt <= 32'd0;
    main_cpu_interrupt[3] <= main_ethmac_sram167_irq;
    main_cpu_interrupt[4] <= sdirq_irq;
    main_cpu_interrupt[2] <= main_timer_irq;
    main_cpu_interrupt[1] <= main_uart_irq;
end
assign main_crg_reset = (cpu_reset | main_crg_rst);
assign pll4x_clk = main_crg_clkout0;
assign idelay_clk = main_crg_clkout_buf0;
assign eth_clk = main_crg_clkout_buf1;
assign ic_clk = sys_clk;
assign builder_socbushandler0_shared_adr = builder_comb_rhs_array_muxed0;
assign builder_socbushandler0_shared_dat_w = builder_comb_rhs_array_muxed1;
assign builder_socbushandler0_shared_sel = builder_comb_rhs_array_muxed2;
assign builder_socbushandler0_shared_cyc = builder_comb_rhs_array_muxed3;
assign builder_socbushandler0_shared_stb = builder_comb_rhs_array_muxed4;
assign builder_socbushandler0_shared_we = builder_comb_rhs_array_muxed5;
assign builder_socbushandler0_shared_cti = builder_comb_rhs_array_muxed6;
assign builder_socbushandler0_shared_bte = builder_comb_rhs_array_muxed7;
assign main_cpu_pbus_dat_r = builder_socbushandler0_shared_dat_r;
assign main_cpu_pbus_ack = (builder_socbushandler0_shared_ack & (builder_socbushandler0_grant == 1'd0));
assign main_cpu_pbus_err = (builder_socbushandler0_shared_err & (builder_socbushandler0_grant == 1'd0));
assign builder_socbushandler0_request = {main_cpu_pbus_cyc};
assign builder_socbushandler0_grant = 1'd0;
always @(*) begin
    builder_socbushandler0_slave_sel <= 6'd0;
    builder_socbushandler0_slave_sel[0] <= (builder_socbushandler0_shared_adr[29:20] == 10'd963);
    builder_socbushandler0_slave_sel[1] <= (builder_socbushandler0_shared_adr[29:14] == 16'd61441);
    builder_socbushandler0_slave_sel[2] <= (builder_socbushandler0_shared_adr[29:14] == 1'd0);
    builder_socbushandler0_slave_sel[3] <= (builder_socbushandler0_shared_adr[29:11] == 16'd32768);
    builder_socbushandler0_slave_sel[4] <= (builder_socbushandler0_shared_adr[29:11] == 19'd262144);
    builder_socbushandler0_slave_sel[5] <= (builder_socbushandler0_shared_adr[29:14] == 16'd61440);
end
assign main_plicbus_adr = builder_socbushandler0_shared_adr;
assign main_plicbus_dat_w = builder_socbushandler0_shared_dat_w;
assign main_plicbus_sel = builder_socbushandler0_shared_sel;
assign main_plicbus_stb = builder_socbushandler0_shared_stb;
assign main_plicbus_we = builder_socbushandler0_shared_we;
assign main_plicbus_cti = builder_socbushandler0_shared_cti;
assign main_plicbus_bte = builder_socbushandler0_shared_bte;
assign main_clintbus_adr = builder_socbushandler0_shared_adr;
assign main_clintbus_dat_w = builder_socbushandler0_shared_dat_w;
assign main_clintbus_sel = builder_socbushandler0_shared_sel;
assign main_clintbus_stb = builder_socbushandler0_shared_stb;
assign main_clintbus_we = builder_socbushandler0_shared_we;
assign main_clintbus_cti = builder_socbushandler0_shared_cti;
assign main_clintbus_bte = builder_socbushandler0_shared_bte;
assign main_soclinux_ram_bus_adr = builder_socbushandler0_shared_adr;
assign main_soclinux_ram_bus_dat_w = builder_socbushandler0_shared_dat_w;
assign main_soclinux_ram_bus_sel = builder_socbushandler0_shared_sel;
assign main_soclinux_ram_bus_stb = builder_socbushandler0_shared_stb;
assign main_soclinux_ram_bus_we = builder_socbushandler0_shared_we;
assign main_soclinux_ram_bus_cti = builder_socbushandler0_shared_cti;
assign main_soclinux_ram_bus_bte = builder_socbushandler0_shared_bte;
assign main_ram_bus_ram_bus_adr = builder_socbushandler0_shared_adr;
assign main_ram_bus_ram_bus_dat_w = builder_socbushandler0_shared_dat_w;
assign main_ram_bus_ram_bus_sel = builder_socbushandler0_shared_sel;
assign main_ram_bus_ram_bus_stb = builder_socbushandler0_shared_stb;
assign main_ram_bus_ram_bus_we = builder_socbushandler0_shared_we;
assign main_ram_bus_ram_bus_cti = builder_socbushandler0_shared_cti;
assign main_ram_bus_ram_bus_bte = builder_socbushandler0_shared_bte;
assign main_ethmac_bus_adr = builder_socbushandler0_shared_adr;
assign main_ethmac_bus_dat_w = builder_socbushandler0_shared_dat_w;
assign main_ethmac_bus_sel = builder_socbushandler0_shared_sel;
assign main_ethmac_bus_stb = builder_socbushandler0_shared_stb;
assign main_ethmac_bus_we = builder_socbushandler0_shared_we;
assign main_ethmac_bus_cti = builder_socbushandler0_shared_cti;
assign main_ethmac_bus_bte = builder_socbushandler0_shared_bte;
assign builder_soclinux_wishbone_adr = builder_socbushandler0_shared_adr;
assign builder_soclinux_wishbone_dat_w = builder_socbushandler0_shared_dat_w;
assign builder_soclinux_wishbone_sel = builder_socbushandler0_shared_sel;
assign builder_soclinux_wishbone_stb = builder_socbushandler0_shared_stb;
assign builder_soclinux_wishbone_we = builder_socbushandler0_shared_we;
assign builder_soclinux_wishbone_cti = builder_socbushandler0_shared_cti;
assign builder_soclinux_wishbone_bte = builder_socbushandler0_shared_bte;
assign main_plicbus_cyc = (builder_socbushandler0_shared_cyc & builder_socbushandler0_slave_sel[0]);
assign main_clintbus_cyc = (builder_socbushandler0_shared_cyc & builder_socbushandler0_slave_sel[1]);
assign main_soclinux_ram_bus_cyc = (builder_socbushandler0_shared_cyc & builder_socbushandler0_slave_sel[2]);
assign main_ram_bus_ram_bus_cyc = (builder_socbushandler0_shared_cyc & builder_socbushandler0_slave_sel[3]);
assign main_ethmac_bus_cyc = (builder_socbushandler0_shared_cyc & builder_socbushandler0_slave_sel[4]);
assign builder_soclinux_wishbone_cyc = (builder_socbushandler0_shared_cyc & builder_socbushandler0_slave_sel[5]);
assign builder_socbushandler0_shared_err = (((((main_plicbus_err | main_clintbus_err) | main_soclinux_ram_bus_err) | main_ram_bus_ram_bus_err) | main_ethmac_bus_err) | builder_soclinux_wishbone_err);
assign builder_socbushandler0_wait = ((builder_socbushandler0_shared_stb & builder_socbushandler0_shared_cyc) & (~builder_socbushandler0_shared_ack));
always @(*) begin
    builder_socbushandler0_error <= 1'd0;
    builder_socbushandler0_shared_dat_r <= 32'd0;
    builder_socbushandler0_shared_ack <= 1'd0;
    builder_socbushandler0_shared_ack <= (((((main_plicbus_ack | main_clintbus_ack) | main_soclinux_ram_bus_ack) | main_ram_bus_ram_bus_ack) | main_ethmac_bus_ack) | builder_soclinux_wishbone_ack);
    builder_socbushandler0_shared_dat_r <= (((((({32{builder_socbushandler0_slave_sel_r[0]}} & main_plicbus_dat_r) | ({32{builder_socbushandler0_slave_sel_r[1]}} & main_clintbus_dat_r)) | ({32{builder_socbushandler0_slave_sel_r[2]}} & main_soclinux_ram_bus_dat_r)) | ({32{builder_socbushandler0_slave_sel_r[3]}} & main_ram_bus_ram_bus_dat_r)) | ({32{builder_socbushandler0_slave_sel_r[4]}} & main_ethmac_bus_dat_r)) | ({32{builder_socbushandler0_slave_sel_r[5]}} & builder_soclinux_wishbone_dat_r));
    if (builder_socbushandler0_done) begin
        builder_socbushandler0_shared_dat_r <= 32'd4294967295;
        builder_socbushandler0_shared_ack <= 1'd1;
        builder_socbushandler0_error <= 1'd1;
    end
end
assign builder_socbushandler0_done = (builder_socbushandler0_count == 1'd0);
assign main_bus_errors_status = main_bus_errors;
always @(*) begin
    main_soc_rst <= 1'd0;
    if (main_reset_re) begin
        main_soc_rst <= main_reset_storage[0];
    end
end
assign main_cpu_rst = main_reset_storage[1];
assign builder_csr_bankarray_csrbank0_reset0_w = main_reset_storage[1:0];
assign builder_csr_bankarray_csrbank0_scratch0_w = main_scratch_storage[31:0];
assign builder_csr_bankarray_csrbank0_bus_errors_w = main_bus_errors_status[31:0];
assign main_bus_errors_we = builder_csr_bankarray_csrbank0_bus_errors_we;
assign builder_socbushandler1_shared_adr = builder_comb_rhs_array_muxed8;
assign builder_socbushandler1_shared_dat_w = builder_comb_rhs_array_muxed9;
assign builder_socbushandler1_shared_sel = builder_comb_rhs_array_muxed10;
assign builder_socbushandler1_shared_cyc = builder_comb_rhs_array_muxed11;
assign builder_socbushandler1_shared_stb = builder_comb_rhs_array_muxed12;
assign builder_socbushandler1_shared_we = builder_comb_rhs_array_muxed13;
assign builder_socbushandler1_shared_cti = builder_comb_rhs_array_muxed14;
assign builder_socbushandler1_shared_bte = builder_comb_rhs_array_muxed15;
assign interface0_bus_dat_r = builder_socbushandler1_shared_dat_r;
assign interface1_bus_dat_r = builder_socbushandler1_shared_dat_r;
assign interface0_bus_ack = (builder_socbushandler1_shared_ack & (builder_socbushandler1_grant == 1'd0));
assign interface1_bus_ack = (builder_socbushandler1_shared_ack & (builder_socbushandler1_grant == 1'd1));
assign interface0_bus_err = (builder_socbushandler1_shared_err & (builder_socbushandler1_grant == 1'd0));
assign interface1_bus_err = (builder_socbushandler1_shared_err & (builder_socbushandler1_grant == 1'd1));
assign builder_socbushandler1_request = {interface1_bus_cyc, interface0_bus_cyc};
assign builder_socbushandler1_slave_sel = 1'd1;
assign main_dma_bus_dma_bus_adr = builder_socbushandler1_shared_adr;
assign main_dma_bus_dma_bus_dat_w = builder_socbushandler1_shared_dat_w;
assign main_dma_bus_dma_bus_sel = builder_socbushandler1_shared_sel;
assign main_dma_bus_dma_bus_stb = builder_socbushandler1_shared_stb;
assign main_dma_bus_dma_bus_we = builder_socbushandler1_shared_we;
assign main_dma_bus_dma_bus_cti = builder_socbushandler1_shared_cti;
assign main_dma_bus_dma_bus_bte = builder_socbushandler1_shared_bte;
assign main_dma_bus_dma_bus_cyc = (builder_socbushandler1_shared_cyc & builder_socbushandler1_slave_sel);
assign builder_socbushandler1_shared_err = main_dma_bus_dma_bus_err;
assign builder_socbushandler1_wait = ((builder_socbushandler1_shared_stb & builder_socbushandler1_shared_cyc) & (~builder_socbushandler1_shared_ack));
always @(*) begin
    builder_socbushandler1_error <= 1'd0;
    builder_socbushandler1_shared_dat_r <= 32'd0;
    builder_socbushandler1_shared_ack <= 1'd0;
    builder_socbushandler1_shared_ack <= main_dma_bus_dma_bus_ack;
    builder_socbushandler1_shared_dat_r <= ({32{builder_socbushandler1_slave_sel_r}} & main_dma_bus_dma_bus_dat_r);
    if (builder_socbushandler1_done) begin
        builder_socbushandler1_shared_dat_r <= 32'd4294967295;
        builder_socbushandler1_shared_ack <= 1'd1;
        builder_socbushandler1_error <= 1'd1;
    end
end
assign builder_socbushandler1_done = (builder_socbushandler1_count == 1'd0);
assign main_cpu_dma_bus_cyc = main_dma_bus_dma_bus_cyc;
assign main_cpu_dma_bus_stb = main_dma_bus_dma_bus_stb;
assign main_dma_bus_dma_bus_ack = main_cpu_dma_bus_ack;
assign main_cpu_dma_bus_we = main_dma_bus_dma_bus_we;
assign main_cpu_dma_bus_cti = main_dma_bus_dma_bus_cti;
assign main_cpu_dma_bus_bte = main_dma_bus_dma_bus_bte;
assign main_dma_bus_dma_bus_err = main_cpu_dma_bus_err;
always @(*) begin
    main_dma_bus_dma_bus_dat_r <= 32'd0;
    main_cpu_dma_bus_sel <= 8'd0;
    main_cpu_dma_bus_adr <= 30'd0;
    main_cpu_dma_bus_dat_w <= 64'd0;
    case (main_dma_bus_dma_bus_adr[0])
        1'd0: begin
            main_cpu_dma_bus_adr <= main_dma_bus_dma_bus_adr[29:1];
            main_cpu_dma_bus_sel[3:0] <= main_dma_bus_dma_bus_sel;
            main_cpu_dma_bus_dat_w[31:0] <= main_dma_bus_dma_bus_dat_w;
            main_dma_bus_dma_bus_dat_r <= main_cpu_dma_bus_dat_r[31:0];
        end
        1'd1: begin
            main_cpu_dma_bus_adr <= main_dma_bus_dma_bus_adr[29:1];
            main_cpu_dma_bus_sel[7:4] <= main_dma_bus_dma_bus_sel;
            main_cpu_dma_bus_dat_w[63:32] <= main_dma_bus_dma_bus_dat_w;
            main_dma_bus_dma_bus_dat_r <= main_cpu_dma_bus_dat_r[63:32];
        end
    endcase
end
assign main_soclinux_adr = main_soclinux_ram_bus_adr[13:0];
assign main_soclinux_ram_bus_dat_r = main_soclinux_dat_r;
always @(*) begin
    main_ram_we <= 4'd0;
    main_ram_we[0] <= (((main_ram_bus_ram_bus_cyc & main_ram_bus_ram_bus_stb) & main_ram_bus_ram_bus_we) & main_ram_bus_ram_bus_sel[0]);
    main_ram_we[1] <= (((main_ram_bus_ram_bus_cyc & main_ram_bus_ram_bus_stb) & main_ram_bus_ram_bus_we) & main_ram_bus_ram_bus_sel[1]);
    main_ram_we[2] <= (((main_ram_bus_ram_bus_cyc & main_ram_bus_ram_bus_stb) & main_ram_bus_ram_bus_we) & main_ram_bus_ram_bus_sel[2]);
    main_ram_we[3] <= (((main_ram_bus_ram_bus_cyc & main_ram_bus_ram_bus_stb) & main_ram_bus_ram_bus_we) & main_ram_bus_ram_bus_sel[3]);
end
assign main_ram_adr = main_ram_bus_ram_bus_adr[10:0];
assign main_ram_bus_ram_bus_dat_r = main_ram_dat_r;
assign main_ram_dat_w = main_ram_bus_ram_bus_dat_w;
always @(*) begin
    builder_soclinux_rs232phytx_next_state <= 1'd0;
    main_tx_count_rs232phytx_next_value0 <= 4'd0;
    main_tx_sink_ready <= 1'd0;
    main_tx_count_rs232phytx_next_value_ce0 <= 1'd0;
    main_serial_tx_rs232phytx_next_value1 <= 1'd0;
    main_serial_tx_rs232phytx_next_value_ce1 <= 1'd0;
    main_tx_enable <= 1'd0;
    main_tx_data_rs232phytx_next_value2 <= 8'd0;
    main_tx_data_rs232phytx_next_value_ce2 <= 1'd0;
    builder_soclinux_rs232phytx_next_state <= builder_soclinux_rs232phytx_state;
    case (builder_soclinux_rs232phytx_state)
        1'd1: begin
            main_tx_enable <= 1'd1;
            if (main_tx_tick) begin
                main_serial_tx_rs232phytx_next_value1 <= main_tx_data;
                main_serial_tx_rs232phytx_next_value_ce1 <= 1'd1;
                main_tx_count_rs232phytx_next_value0 <= (main_tx_count + 1'd1);
                main_tx_count_rs232phytx_next_value_ce0 <= 1'd1;
                main_tx_data_rs232phytx_next_value2 <= {1'd1, main_tx_data[7:1]};
                main_tx_data_rs232phytx_next_value_ce2 <= 1'd1;
                if ((main_tx_count == 4'd9)) begin
                    main_tx_sink_ready <= 1'd1;
                    builder_soclinux_rs232phytx_next_state <= 1'd0;
                end
            end
        end
        default: begin
            main_tx_count_rs232phytx_next_value0 <= 1'd0;
            main_tx_count_rs232phytx_next_value_ce0 <= 1'd1;
            main_serial_tx_rs232phytx_next_value1 <= 1'd1;
            main_serial_tx_rs232phytx_next_value_ce1 <= 1'd1;
            if (main_tx_sink_valid) begin
                main_serial_tx_rs232phytx_next_value1 <= 1'd0;
                main_serial_tx_rs232phytx_next_value_ce1 <= 1'd1;
                main_tx_data_rs232phytx_next_value2 <= main_tx_sink_payload_data;
                main_tx_data_rs232phytx_next_value_ce2 <= 1'd1;
                builder_soclinux_rs232phytx_next_state <= 1'd1;
            end
        end
    endcase
end
always @(*) begin
    builder_soclinux_rs232phyrx_next_state <= 1'd0;
    main_rx_source_valid <= 1'd0;
    main_rx_count_rs232phyrx_next_value0 <= 4'd0;
    main_rx_count_rs232phyrx_next_value_ce0 <= 1'd0;
    main_rx_source_payload_data <= 8'd0;
    main_rx_data_rs232phyrx_next_value1 <= 8'd0;
    main_rx_enable <= 1'd0;
    main_rx_data_rs232phyrx_next_value_ce1 <= 1'd0;
    builder_soclinux_rs232phyrx_next_state <= builder_soclinux_rs232phyrx_state;
    case (builder_soclinux_rs232phyrx_state)
        1'd1: begin
            main_rx_enable <= 1'd1;
            if (main_rx_tick) begin
                main_rx_count_rs232phyrx_next_value0 <= (main_rx_count + 1'd1);
                main_rx_count_rs232phyrx_next_value_ce0 <= 1'd1;
                main_rx_data_rs232phyrx_next_value1 <= {main_rx_rx, main_rx_data[7:1]};
                main_rx_data_rs232phyrx_next_value_ce1 <= 1'd1;
                if ((main_rx_count == 4'd9)) begin
                    main_rx_source_valid <= (main_rx_rx == 1'd1);
                    main_rx_source_payload_data <= main_rx_data;
                    builder_soclinux_rs232phyrx_next_state <= 1'd0;
                end
            end
        end
        default: begin
            main_rx_count_rs232phyrx_next_value0 <= 1'd0;
            main_rx_count_rs232phyrx_next_value_ce0 <= 1'd1;
            if (((main_rx_rx == 1'd0) & (main_rx_rx_d == 1'd1))) begin
                builder_soclinux_rs232phyrx_next_state <= 1'd1;
            end
        end
    endcase
end
assign main_uart_uart_sink_valid = main_rx_source_valid;
assign main_rx_source_ready = main_uart_uart_sink_ready;
assign main_uart_uart_sink_first = main_rx_source_first;
assign main_uart_uart_sink_last = main_rx_source_last;
assign main_uart_uart_sink_payload_data = main_rx_source_payload_data;
assign main_tx_sink_valid = main_uart_uart_source_valid;
assign main_uart_uart_source_ready = main_tx_sink_ready;
assign main_tx_sink_first = main_uart_uart_source_first;
assign main_tx_sink_last = main_uart_uart_source_last;
assign main_tx_sink_payload_data = main_uart_uart_source_payload_data;
assign main_uart_tx_fifo_sink_valid = main_uart_rxtx_re;
assign main_uart_tx_fifo_sink_payload_data = main_uart_rxtx_r;
assign main_uart_uart_source_valid = main_uart_tx_fifo_source_valid;
assign main_uart_tx_fifo_source_ready = main_uart_uart_source_ready;
assign main_uart_uart_source_first = main_uart_tx_fifo_source_first;
assign main_uart_uart_source_last = main_uart_tx_fifo_source_last;
assign main_uart_uart_source_payload_data = main_uart_tx_fifo_source_payload_data;
assign main_uart_txfull_status = (~main_uart_tx_fifo_sink_ready);
assign main_uart_txempty_status = (~main_uart_tx_fifo_source_valid);
assign main_uart_tx_trigger = main_uart_tx_fifo_sink_ready;
assign main_uart_rx_fifo_sink_valid = main_uart_uart_sink_valid;
assign main_uart_uart_sink_ready = main_uart_rx_fifo_sink_ready;
assign main_uart_rx_fifo_sink_first = main_uart_uart_sink_first;
assign main_uart_rx_fifo_sink_last = main_uart_uart_sink_last;
assign main_uart_rx_fifo_sink_payload_data = main_uart_uart_sink_payload_data;
assign main_uart_rxtx_w = main_uart_rx_fifo_source_payload_data;
assign main_uart_rx_fifo_source_ready = (main_uart_rx_clear | (1'd0 & main_uart_rxtx_we));
assign main_uart_rxempty_status = (~main_uart_rx_fifo_source_valid);
assign main_uart_rxfull_status = (~main_uart_rx_fifo_sink_ready);
assign main_uart_rx_trigger = main_uart_rx_fifo_source_valid;
assign main_uart_tx0 = main_uart_tx_status;
assign main_uart_tx1 = main_uart_tx_pending;
always @(*) begin
    main_uart_tx_clear <= 1'd0;
    if ((main_uart_pending_re & main_uart_pending_r[0])) begin
        main_uart_tx_clear <= 1'd1;
    end
end
assign main_uart_rx0 = main_uart_rx_status;
assign main_uart_rx1 = main_uart_rx_pending;
always @(*) begin
    main_uart_rx_clear <= 1'd0;
    if ((main_uart_pending_re & main_uart_pending_r[1])) begin
        main_uart_rx_clear <= 1'd1;
    end
end
assign main_uart_irq = ((main_uart_pending_status[0] & main_uart_enable_storage[0]) | (main_uart_pending_status[1] & main_uart_enable_storage[1]));
assign main_uart_tx_status = main_uart_tx_trigger;
assign main_uart_rx_status = main_uart_rx_trigger;
assign main_uart_tx_fifo_syncfifo_din = {main_uart_tx_fifo_fifo_in_last, main_uart_tx_fifo_fifo_in_first, main_uart_tx_fifo_fifo_in_payload_data};
assign {main_uart_tx_fifo_fifo_out_last, main_uart_tx_fifo_fifo_out_first, main_uart_tx_fifo_fifo_out_payload_data} = main_uart_tx_fifo_syncfifo_dout;
assign main_uart_tx_fifo_sink_ready = main_uart_tx_fifo_syncfifo_writable;
assign main_uart_tx_fifo_syncfifo_we = main_uart_tx_fifo_sink_valid;
assign main_uart_tx_fifo_fifo_in_first = main_uart_tx_fifo_sink_first;
assign main_uart_tx_fifo_fifo_in_last = main_uart_tx_fifo_sink_last;
assign main_uart_tx_fifo_fifo_in_payload_data = main_uart_tx_fifo_sink_payload_data;
assign main_uart_tx_fifo_source_valid = main_uart_tx_fifo_readable;
assign main_uart_tx_fifo_source_first = main_uart_tx_fifo_fifo_out_first;
assign main_uart_tx_fifo_source_last = main_uart_tx_fifo_fifo_out_last;
assign main_uart_tx_fifo_source_payload_data = main_uart_tx_fifo_fifo_out_payload_data;
assign main_uart_tx_fifo_re = main_uart_tx_fifo_source_ready;
assign main_uart_tx_fifo_syncfifo_re = (main_uart_tx_fifo_syncfifo_readable & ((~main_uart_tx_fifo_readable) | main_uart_tx_fifo_re));
assign main_uart_tx_fifo_level1 = (main_uart_tx_fifo_level0 + main_uart_tx_fifo_readable);
always @(*) begin
    main_uart_tx_fifo_wrport_adr <= 4'd0;
    if (main_uart_tx_fifo_replace) begin
        main_uart_tx_fifo_wrport_adr <= (main_uart_tx_fifo_produce - 1'd1);
    end else begin
        main_uart_tx_fifo_wrport_adr <= main_uart_tx_fifo_produce;
    end
end
assign main_uart_tx_fifo_wrport_dat_w = main_uart_tx_fifo_syncfifo_din;
assign main_uart_tx_fifo_wrport_we = (main_uart_tx_fifo_syncfifo_we & (main_uart_tx_fifo_syncfifo_writable | main_uart_tx_fifo_replace));
assign main_uart_tx_fifo_do_read = (main_uart_tx_fifo_syncfifo_readable & main_uart_tx_fifo_syncfifo_re);
assign main_uart_tx_fifo_rdport_adr = main_uart_tx_fifo_consume;
assign main_uart_tx_fifo_syncfifo_dout = main_uart_tx_fifo_rdport_dat_r;
assign main_uart_tx_fifo_rdport_re = main_uart_tx_fifo_do_read;
assign main_uart_tx_fifo_syncfifo_writable = (main_uart_tx_fifo_level0 != 5'd16);
assign main_uart_tx_fifo_syncfifo_readable = (main_uart_tx_fifo_level0 != 1'd0);
assign main_uart_rx_fifo_syncfifo_din = {main_uart_rx_fifo_fifo_in_last, main_uart_rx_fifo_fifo_in_first, main_uart_rx_fifo_fifo_in_payload_data};
assign {main_uart_rx_fifo_fifo_out_last, main_uart_rx_fifo_fifo_out_first, main_uart_rx_fifo_fifo_out_payload_data} = main_uart_rx_fifo_syncfifo_dout;
assign main_uart_rx_fifo_sink_ready = main_uart_rx_fifo_syncfifo_writable;
assign main_uart_rx_fifo_syncfifo_we = main_uart_rx_fifo_sink_valid;
assign main_uart_rx_fifo_fifo_in_first = main_uart_rx_fifo_sink_first;
assign main_uart_rx_fifo_fifo_in_last = main_uart_rx_fifo_sink_last;
assign main_uart_rx_fifo_fifo_in_payload_data = main_uart_rx_fifo_sink_payload_data;
assign main_uart_rx_fifo_source_valid = main_uart_rx_fifo_readable;
assign main_uart_rx_fifo_source_first = main_uart_rx_fifo_fifo_out_first;
assign main_uart_rx_fifo_source_last = main_uart_rx_fifo_fifo_out_last;
assign main_uart_rx_fifo_source_payload_data = main_uart_rx_fifo_fifo_out_payload_data;
assign main_uart_rx_fifo_re = main_uart_rx_fifo_source_ready;
assign main_uart_rx_fifo_syncfifo_re = (main_uart_rx_fifo_syncfifo_readable & ((~main_uart_rx_fifo_readable) | main_uart_rx_fifo_re));
assign main_uart_rx_fifo_level1 = (main_uart_rx_fifo_level0 + main_uart_rx_fifo_readable);
always @(*) begin
    main_uart_rx_fifo_wrport_adr <= 4'd0;
    if (main_uart_rx_fifo_replace) begin
        main_uart_rx_fifo_wrport_adr <= (main_uart_rx_fifo_produce - 1'd1);
    end else begin
        main_uart_rx_fifo_wrport_adr <= main_uart_rx_fifo_produce;
    end
end
assign main_uart_rx_fifo_wrport_dat_w = main_uart_rx_fifo_syncfifo_din;
assign main_uart_rx_fifo_wrport_we = (main_uart_rx_fifo_syncfifo_we & (main_uart_rx_fifo_syncfifo_writable | main_uart_rx_fifo_replace));
assign main_uart_rx_fifo_do_read = (main_uart_rx_fifo_syncfifo_readable & main_uart_rx_fifo_syncfifo_re);
assign main_uart_rx_fifo_rdport_adr = main_uart_rx_fifo_consume;
assign main_uart_rx_fifo_syncfifo_dout = main_uart_rx_fifo_rdport_dat_r;
assign main_uart_rx_fifo_rdport_re = main_uart_rx_fifo_do_read;
assign main_uart_rx_fifo_syncfifo_writable = (main_uart_rx_fifo_level0 != 5'd16);
assign main_uart_rx_fifo_syncfifo_readable = (main_uart_rx_fifo_level0 != 1'd0);
assign main_timer_zero_trigger = (main_timer_value == 1'd0);
assign main_timer_zero0 = main_timer_zero_status;
assign main_timer_zero1 = main_timer_zero_pending;
always @(*) begin
    main_timer_zero_clear <= 1'd0;
    if ((main_timer_pending_re & main_timer_pending_r)) begin
        main_timer_zero_clear <= 1'd1;
    end
end
assign main_timer_irq = (main_timer_pending_status & main_timer_enable_storage);
assign main_timer_zero_status = main_timer_zero_trigger;
assign ddram_ba = main_usddrphy_pads_ba;
assign ddram_bg = main_usddrphy_pads_ba[2];
assign main_usddrphy_dqs_oe_delay_tappeddelayline = ((main_usddrphy_dqs_preamble | main_usddrphy_dqs_oe) | main_usddrphy_dqs_postamble);
always @(*) begin
    main_usddrphy_wdly_dqs_inc_count_status <= 9'd0;
    if (main_usddrphy_dly_sel_storage[0]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count0;
    end
    if (main_usddrphy_dly_sel_storage[1]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count1;
    end
    if (main_usddrphy_dly_sel_storage[2]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count2;
    end
    if (main_usddrphy_dly_sel_storage[3]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count3;
    end
    if (main_usddrphy_dly_sel_storage[4]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count4;
    end
    if (main_usddrphy_dly_sel_storage[5]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count5;
    end
    if (main_usddrphy_dly_sel_storage[6]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count6;
    end
    if (main_usddrphy_dly_sel_storage[7]) begin
        main_usddrphy_wdly_dqs_inc_count_status <= main_usddrphy_wdly_dqs_inc_count7;
    end
end
assign main_usddrphy_dq_oe_delay_tappeddelayline = ((main_usddrphy_dqs_preamble | main_usddrphy_dq_oe) | main_usddrphy_dqs_postamble);
always @(*) begin
    main_usddrphy_interface1_dfi_p0_rddata <= 128'd0;
    main_usddrphy_interface1_dfi_p0_rddata[0] <= main_usddrphy_bitslip04[0];
    main_usddrphy_interface1_dfi_p0_rddata[64] <= main_usddrphy_bitslip04[1];
    main_usddrphy_interface1_dfi_p0_rddata[1] <= main_usddrphy_bitslip14[0];
    main_usddrphy_interface1_dfi_p0_rddata[65] <= main_usddrphy_bitslip14[1];
    main_usddrphy_interface1_dfi_p0_rddata[2] <= main_usddrphy_bitslip24[0];
    main_usddrphy_interface1_dfi_p0_rddata[66] <= main_usddrphy_bitslip24[1];
    main_usddrphy_interface1_dfi_p0_rddata[3] <= main_usddrphy_bitslip34[0];
    main_usddrphy_interface1_dfi_p0_rddata[67] <= main_usddrphy_bitslip34[1];
    main_usddrphy_interface1_dfi_p0_rddata[4] <= main_usddrphy_bitslip44[0];
    main_usddrphy_interface1_dfi_p0_rddata[68] <= main_usddrphy_bitslip44[1];
    main_usddrphy_interface1_dfi_p0_rddata[5] <= main_usddrphy_bitslip54[0];
    main_usddrphy_interface1_dfi_p0_rddata[69] <= main_usddrphy_bitslip54[1];
    main_usddrphy_interface1_dfi_p0_rddata[6] <= main_usddrphy_bitslip64[0];
    main_usddrphy_interface1_dfi_p0_rddata[70] <= main_usddrphy_bitslip64[1];
    main_usddrphy_interface1_dfi_p0_rddata[7] <= main_usddrphy_bitslip74[0];
    main_usddrphy_interface1_dfi_p0_rddata[71] <= main_usddrphy_bitslip74[1];
    main_usddrphy_interface1_dfi_p0_rddata[8] <= main_usddrphy_bitslip82[0];
    main_usddrphy_interface1_dfi_p0_rddata[72] <= main_usddrphy_bitslip82[1];
    main_usddrphy_interface1_dfi_p0_rddata[9] <= main_usddrphy_bitslip92[0];
    main_usddrphy_interface1_dfi_p0_rddata[73] <= main_usddrphy_bitslip92[1];
    main_usddrphy_interface1_dfi_p0_rddata[10] <= main_usddrphy_bitslip102[0];
    main_usddrphy_interface1_dfi_p0_rddata[74] <= main_usddrphy_bitslip102[1];
    main_usddrphy_interface1_dfi_p0_rddata[11] <= main_usddrphy_bitslip112[0];
    main_usddrphy_interface1_dfi_p0_rddata[75] <= main_usddrphy_bitslip112[1];
    main_usddrphy_interface1_dfi_p0_rddata[12] <= main_usddrphy_bitslip122[0];
    main_usddrphy_interface1_dfi_p0_rddata[76] <= main_usddrphy_bitslip122[1];
    main_usddrphy_interface1_dfi_p0_rddata[13] <= main_usddrphy_bitslip132[0];
    main_usddrphy_interface1_dfi_p0_rddata[77] <= main_usddrphy_bitslip132[1];
    main_usddrphy_interface1_dfi_p0_rddata[14] <= main_usddrphy_bitslip142[0];
    main_usddrphy_interface1_dfi_p0_rddata[78] <= main_usddrphy_bitslip142[1];
    main_usddrphy_interface1_dfi_p0_rddata[15] <= main_usddrphy_bitslip152[0];
    main_usddrphy_interface1_dfi_p0_rddata[79] <= main_usddrphy_bitslip152[1];
    main_usddrphy_interface1_dfi_p0_rddata[16] <= main_usddrphy_bitslip162[0];
    main_usddrphy_interface1_dfi_p0_rddata[80] <= main_usddrphy_bitslip162[1];
    main_usddrphy_interface1_dfi_p0_rddata[17] <= main_usddrphy_bitslip172[0];
    main_usddrphy_interface1_dfi_p0_rddata[81] <= main_usddrphy_bitslip172[1];
    main_usddrphy_interface1_dfi_p0_rddata[18] <= main_usddrphy_bitslip182[0];
    main_usddrphy_interface1_dfi_p0_rddata[82] <= main_usddrphy_bitslip182[1];
    main_usddrphy_interface1_dfi_p0_rddata[19] <= main_usddrphy_bitslip192[0];
    main_usddrphy_interface1_dfi_p0_rddata[83] <= main_usddrphy_bitslip192[1];
    main_usddrphy_interface1_dfi_p0_rddata[20] <= main_usddrphy_bitslip202[0];
    main_usddrphy_interface1_dfi_p0_rddata[84] <= main_usddrphy_bitslip202[1];
    main_usddrphy_interface1_dfi_p0_rddata[21] <= main_usddrphy_bitslip212[0];
    main_usddrphy_interface1_dfi_p0_rddata[85] <= main_usddrphy_bitslip212[1];
    main_usddrphy_interface1_dfi_p0_rddata[22] <= main_usddrphy_bitslip222[0];
    main_usddrphy_interface1_dfi_p0_rddata[86] <= main_usddrphy_bitslip222[1];
    main_usddrphy_interface1_dfi_p0_rddata[23] <= main_usddrphy_bitslip232[0];
    main_usddrphy_interface1_dfi_p0_rddata[87] <= main_usddrphy_bitslip232[1];
    main_usddrphy_interface1_dfi_p0_rddata[24] <= main_usddrphy_bitslip242[0];
    main_usddrphy_interface1_dfi_p0_rddata[88] <= main_usddrphy_bitslip242[1];
    main_usddrphy_interface1_dfi_p0_rddata[25] <= main_usddrphy_bitslip252[0];
    main_usddrphy_interface1_dfi_p0_rddata[89] <= main_usddrphy_bitslip252[1];
    main_usddrphy_interface1_dfi_p0_rddata[26] <= main_usddrphy_bitslip262[0];
    main_usddrphy_interface1_dfi_p0_rddata[90] <= main_usddrphy_bitslip262[1];
    main_usddrphy_interface1_dfi_p0_rddata[27] <= main_usddrphy_bitslip272[0];
    main_usddrphy_interface1_dfi_p0_rddata[91] <= main_usddrphy_bitslip272[1];
    main_usddrphy_interface1_dfi_p0_rddata[28] <= main_usddrphy_bitslip282[0];
    main_usddrphy_interface1_dfi_p0_rddata[92] <= main_usddrphy_bitslip282[1];
    main_usddrphy_interface1_dfi_p0_rddata[29] <= main_usddrphy_bitslip292[0];
    main_usddrphy_interface1_dfi_p0_rddata[93] <= main_usddrphy_bitslip292[1];
    main_usddrphy_interface1_dfi_p0_rddata[30] <= main_usddrphy_bitslip302[0];
    main_usddrphy_interface1_dfi_p0_rddata[94] <= main_usddrphy_bitslip302[1];
    main_usddrphy_interface1_dfi_p0_rddata[31] <= main_usddrphy_bitslip312[0];
    main_usddrphy_interface1_dfi_p0_rddata[95] <= main_usddrphy_bitslip312[1];
    main_usddrphy_interface1_dfi_p0_rddata[32] <= main_usddrphy_bitslip322[0];
    main_usddrphy_interface1_dfi_p0_rddata[96] <= main_usddrphy_bitslip322[1];
    main_usddrphy_interface1_dfi_p0_rddata[33] <= main_usddrphy_bitslip332[0];
    main_usddrphy_interface1_dfi_p0_rddata[97] <= main_usddrphy_bitslip332[1];
    main_usddrphy_interface1_dfi_p0_rddata[34] <= main_usddrphy_bitslip342[0];
    main_usddrphy_interface1_dfi_p0_rddata[98] <= main_usddrphy_bitslip342[1];
    main_usddrphy_interface1_dfi_p0_rddata[35] <= main_usddrphy_bitslip352[0];
    main_usddrphy_interface1_dfi_p0_rddata[99] <= main_usddrphy_bitslip352[1];
    main_usddrphy_interface1_dfi_p0_rddata[36] <= main_usddrphy_bitslip362[0];
    main_usddrphy_interface1_dfi_p0_rddata[100] <= main_usddrphy_bitslip362[1];
    main_usddrphy_interface1_dfi_p0_rddata[37] <= main_usddrphy_bitslip372[0];
    main_usddrphy_interface1_dfi_p0_rddata[101] <= main_usddrphy_bitslip372[1];
    main_usddrphy_interface1_dfi_p0_rddata[38] <= main_usddrphy_bitslip382[0];
    main_usddrphy_interface1_dfi_p0_rddata[102] <= main_usddrphy_bitslip382[1];
    main_usddrphy_interface1_dfi_p0_rddata[39] <= main_usddrphy_bitslip392[0];
    main_usddrphy_interface1_dfi_p0_rddata[103] <= main_usddrphy_bitslip392[1];
    main_usddrphy_interface1_dfi_p0_rddata[40] <= main_usddrphy_bitslip402[0];
    main_usddrphy_interface1_dfi_p0_rddata[104] <= main_usddrphy_bitslip402[1];
    main_usddrphy_interface1_dfi_p0_rddata[41] <= main_usddrphy_bitslip412[0];
    main_usddrphy_interface1_dfi_p0_rddata[105] <= main_usddrphy_bitslip412[1];
    main_usddrphy_interface1_dfi_p0_rddata[42] <= main_usddrphy_bitslip422[0];
    main_usddrphy_interface1_dfi_p0_rddata[106] <= main_usddrphy_bitslip422[1];
    main_usddrphy_interface1_dfi_p0_rddata[43] <= main_usddrphy_bitslip432[0];
    main_usddrphy_interface1_dfi_p0_rddata[107] <= main_usddrphy_bitslip432[1];
    main_usddrphy_interface1_dfi_p0_rddata[44] <= main_usddrphy_bitslip442[0];
    main_usddrphy_interface1_dfi_p0_rddata[108] <= main_usddrphy_bitslip442[1];
    main_usddrphy_interface1_dfi_p0_rddata[45] <= main_usddrphy_bitslip452[0];
    main_usddrphy_interface1_dfi_p0_rddata[109] <= main_usddrphy_bitslip452[1];
    main_usddrphy_interface1_dfi_p0_rddata[46] <= main_usddrphy_bitslip462[0];
    main_usddrphy_interface1_dfi_p0_rddata[110] <= main_usddrphy_bitslip462[1];
    main_usddrphy_interface1_dfi_p0_rddata[47] <= main_usddrphy_bitslip472[0];
    main_usddrphy_interface1_dfi_p0_rddata[111] <= main_usddrphy_bitslip472[1];
    main_usddrphy_interface1_dfi_p0_rddata[48] <= main_usddrphy_bitslip482[0];
    main_usddrphy_interface1_dfi_p0_rddata[112] <= main_usddrphy_bitslip482[1];
    main_usddrphy_interface1_dfi_p0_rddata[49] <= main_usddrphy_bitslip492[0];
    main_usddrphy_interface1_dfi_p0_rddata[113] <= main_usddrphy_bitslip492[1];
    main_usddrphy_interface1_dfi_p0_rddata[50] <= main_usddrphy_bitslip502[0];
    main_usddrphy_interface1_dfi_p0_rddata[114] <= main_usddrphy_bitslip502[1];
    main_usddrphy_interface1_dfi_p0_rddata[51] <= main_usddrphy_bitslip512[0];
    main_usddrphy_interface1_dfi_p0_rddata[115] <= main_usddrphy_bitslip512[1];
    main_usddrphy_interface1_dfi_p0_rddata[52] <= main_usddrphy_bitslip522[0];
    main_usddrphy_interface1_dfi_p0_rddata[116] <= main_usddrphy_bitslip522[1];
    main_usddrphy_interface1_dfi_p0_rddata[53] <= main_usddrphy_bitslip532[0];
    main_usddrphy_interface1_dfi_p0_rddata[117] <= main_usddrphy_bitslip532[1];
    main_usddrphy_interface1_dfi_p0_rddata[54] <= main_usddrphy_bitslip542[0];
    main_usddrphy_interface1_dfi_p0_rddata[118] <= main_usddrphy_bitslip542[1];
    main_usddrphy_interface1_dfi_p0_rddata[55] <= main_usddrphy_bitslip552[0];
    main_usddrphy_interface1_dfi_p0_rddata[119] <= main_usddrphy_bitslip552[1];
    main_usddrphy_interface1_dfi_p0_rddata[56] <= main_usddrphy_bitslip562[0];
    main_usddrphy_interface1_dfi_p0_rddata[120] <= main_usddrphy_bitslip562[1];
    main_usddrphy_interface1_dfi_p0_rddata[57] <= main_usddrphy_bitslip572[0];
    main_usddrphy_interface1_dfi_p0_rddata[121] <= main_usddrphy_bitslip572[1];
    main_usddrphy_interface1_dfi_p0_rddata[58] <= main_usddrphy_bitslip582[0];
    main_usddrphy_interface1_dfi_p0_rddata[122] <= main_usddrphy_bitslip582[1];
    main_usddrphy_interface1_dfi_p0_rddata[59] <= main_usddrphy_bitslip592[0];
    main_usddrphy_interface1_dfi_p0_rddata[123] <= main_usddrphy_bitslip592[1];
    main_usddrphy_interface1_dfi_p0_rddata[60] <= main_usddrphy_bitslip602[0];
    main_usddrphy_interface1_dfi_p0_rddata[124] <= main_usddrphy_bitslip602[1];
    main_usddrphy_interface1_dfi_p0_rddata[61] <= main_usddrphy_bitslip612[0];
    main_usddrphy_interface1_dfi_p0_rddata[125] <= main_usddrphy_bitslip612[1];
    main_usddrphy_interface1_dfi_p0_rddata[62] <= main_usddrphy_bitslip622[0];
    main_usddrphy_interface1_dfi_p0_rddata[126] <= main_usddrphy_bitslip622[1];
    main_usddrphy_interface1_dfi_p0_rddata[63] <= main_usddrphy_bitslip632[0];
    main_usddrphy_interface1_dfi_p0_rddata[127] <= main_usddrphy_bitslip632[1];
end
always @(*) begin
    main_usddrphy_interface1_dfi_p1_rddata <= 128'd0;
    main_usddrphy_interface1_dfi_p1_rddata[0] <= main_usddrphy_bitslip04[2];
    main_usddrphy_interface1_dfi_p1_rddata[64] <= main_usddrphy_bitslip04[3];
    main_usddrphy_interface1_dfi_p1_rddata[1] <= main_usddrphy_bitslip14[2];
    main_usddrphy_interface1_dfi_p1_rddata[65] <= main_usddrphy_bitslip14[3];
    main_usddrphy_interface1_dfi_p1_rddata[2] <= main_usddrphy_bitslip24[2];
    main_usddrphy_interface1_dfi_p1_rddata[66] <= main_usddrphy_bitslip24[3];
    main_usddrphy_interface1_dfi_p1_rddata[3] <= main_usddrphy_bitslip34[2];
    main_usddrphy_interface1_dfi_p1_rddata[67] <= main_usddrphy_bitslip34[3];
    main_usddrphy_interface1_dfi_p1_rddata[4] <= main_usddrphy_bitslip44[2];
    main_usddrphy_interface1_dfi_p1_rddata[68] <= main_usddrphy_bitslip44[3];
    main_usddrphy_interface1_dfi_p1_rddata[5] <= main_usddrphy_bitslip54[2];
    main_usddrphy_interface1_dfi_p1_rddata[69] <= main_usddrphy_bitslip54[3];
    main_usddrphy_interface1_dfi_p1_rddata[6] <= main_usddrphy_bitslip64[2];
    main_usddrphy_interface1_dfi_p1_rddata[70] <= main_usddrphy_bitslip64[3];
    main_usddrphy_interface1_dfi_p1_rddata[7] <= main_usddrphy_bitslip74[2];
    main_usddrphy_interface1_dfi_p1_rddata[71] <= main_usddrphy_bitslip74[3];
    main_usddrphy_interface1_dfi_p1_rddata[8] <= main_usddrphy_bitslip82[2];
    main_usddrphy_interface1_dfi_p1_rddata[72] <= main_usddrphy_bitslip82[3];
    main_usddrphy_interface1_dfi_p1_rddata[9] <= main_usddrphy_bitslip92[2];
    main_usddrphy_interface1_dfi_p1_rddata[73] <= main_usddrphy_bitslip92[3];
    main_usddrphy_interface1_dfi_p1_rddata[10] <= main_usddrphy_bitslip102[2];
    main_usddrphy_interface1_dfi_p1_rddata[74] <= main_usddrphy_bitslip102[3];
    main_usddrphy_interface1_dfi_p1_rddata[11] <= main_usddrphy_bitslip112[2];
    main_usddrphy_interface1_dfi_p1_rddata[75] <= main_usddrphy_bitslip112[3];
    main_usddrphy_interface1_dfi_p1_rddata[12] <= main_usddrphy_bitslip122[2];
    main_usddrphy_interface1_dfi_p1_rddata[76] <= main_usddrphy_bitslip122[3];
    main_usddrphy_interface1_dfi_p1_rddata[13] <= main_usddrphy_bitslip132[2];
    main_usddrphy_interface1_dfi_p1_rddata[77] <= main_usddrphy_bitslip132[3];
    main_usddrphy_interface1_dfi_p1_rddata[14] <= main_usddrphy_bitslip142[2];
    main_usddrphy_interface1_dfi_p1_rddata[78] <= main_usddrphy_bitslip142[3];
    main_usddrphy_interface1_dfi_p1_rddata[15] <= main_usddrphy_bitslip152[2];
    main_usddrphy_interface1_dfi_p1_rddata[79] <= main_usddrphy_bitslip152[3];
    main_usddrphy_interface1_dfi_p1_rddata[16] <= main_usddrphy_bitslip162[2];
    main_usddrphy_interface1_dfi_p1_rddata[80] <= main_usddrphy_bitslip162[3];
    main_usddrphy_interface1_dfi_p1_rddata[17] <= main_usddrphy_bitslip172[2];
    main_usddrphy_interface1_dfi_p1_rddata[81] <= main_usddrphy_bitslip172[3];
    main_usddrphy_interface1_dfi_p1_rddata[18] <= main_usddrphy_bitslip182[2];
    main_usddrphy_interface1_dfi_p1_rddata[82] <= main_usddrphy_bitslip182[3];
    main_usddrphy_interface1_dfi_p1_rddata[19] <= main_usddrphy_bitslip192[2];
    main_usddrphy_interface1_dfi_p1_rddata[83] <= main_usddrphy_bitslip192[3];
    main_usddrphy_interface1_dfi_p1_rddata[20] <= main_usddrphy_bitslip202[2];
    main_usddrphy_interface1_dfi_p1_rddata[84] <= main_usddrphy_bitslip202[3];
    main_usddrphy_interface1_dfi_p1_rddata[21] <= main_usddrphy_bitslip212[2];
    main_usddrphy_interface1_dfi_p1_rddata[85] <= main_usddrphy_bitslip212[3];
    main_usddrphy_interface1_dfi_p1_rddata[22] <= main_usddrphy_bitslip222[2];
    main_usddrphy_interface1_dfi_p1_rddata[86] <= main_usddrphy_bitslip222[3];
    main_usddrphy_interface1_dfi_p1_rddata[23] <= main_usddrphy_bitslip232[2];
    main_usddrphy_interface1_dfi_p1_rddata[87] <= main_usddrphy_bitslip232[3];
    main_usddrphy_interface1_dfi_p1_rddata[24] <= main_usddrphy_bitslip242[2];
    main_usddrphy_interface1_dfi_p1_rddata[88] <= main_usddrphy_bitslip242[3];
    main_usddrphy_interface1_dfi_p1_rddata[25] <= main_usddrphy_bitslip252[2];
    main_usddrphy_interface1_dfi_p1_rddata[89] <= main_usddrphy_bitslip252[3];
    main_usddrphy_interface1_dfi_p1_rddata[26] <= main_usddrphy_bitslip262[2];
    main_usddrphy_interface1_dfi_p1_rddata[90] <= main_usddrphy_bitslip262[3];
    main_usddrphy_interface1_dfi_p1_rddata[27] <= main_usddrphy_bitslip272[2];
    main_usddrphy_interface1_dfi_p1_rddata[91] <= main_usddrphy_bitslip272[3];
    main_usddrphy_interface1_dfi_p1_rddata[28] <= main_usddrphy_bitslip282[2];
    main_usddrphy_interface1_dfi_p1_rddata[92] <= main_usddrphy_bitslip282[3];
    main_usddrphy_interface1_dfi_p1_rddata[29] <= main_usddrphy_bitslip292[2];
    main_usddrphy_interface1_dfi_p1_rddata[93] <= main_usddrphy_bitslip292[3];
    main_usddrphy_interface1_dfi_p1_rddata[30] <= main_usddrphy_bitslip302[2];
    main_usddrphy_interface1_dfi_p1_rddata[94] <= main_usddrphy_bitslip302[3];
    main_usddrphy_interface1_dfi_p1_rddata[31] <= main_usddrphy_bitslip312[2];
    main_usddrphy_interface1_dfi_p1_rddata[95] <= main_usddrphy_bitslip312[3];
    main_usddrphy_interface1_dfi_p1_rddata[32] <= main_usddrphy_bitslip322[2];
    main_usddrphy_interface1_dfi_p1_rddata[96] <= main_usddrphy_bitslip322[3];
    main_usddrphy_interface1_dfi_p1_rddata[33] <= main_usddrphy_bitslip332[2];
    main_usddrphy_interface1_dfi_p1_rddata[97] <= main_usddrphy_bitslip332[3];
    main_usddrphy_interface1_dfi_p1_rddata[34] <= main_usddrphy_bitslip342[2];
    main_usddrphy_interface1_dfi_p1_rddata[98] <= main_usddrphy_bitslip342[3];
    main_usddrphy_interface1_dfi_p1_rddata[35] <= main_usddrphy_bitslip352[2];
    main_usddrphy_interface1_dfi_p1_rddata[99] <= main_usddrphy_bitslip352[3];
    main_usddrphy_interface1_dfi_p1_rddata[36] <= main_usddrphy_bitslip362[2];
    main_usddrphy_interface1_dfi_p1_rddata[100] <= main_usddrphy_bitslip362[3];
    main_usddrphy_interface1_dfi_p1_rddata[37] <= main_usddrphy_bitslip372[2];
    main_usddrphy_interface1_dfi_p1_rddata[101] <= main_usddrphy_bitslip372[3];
    main_usddrphy_interface1_dfi_p1_rddata[38] <= main_usddrphy_bitslip382[2];
    main_usddrphy_interface1_dfi_p1_rddata[102] <= main_usddrphy_bitslip382[3];
    main_usddrphy_interface1_dfi_p1_rddata[39] <= main_usddrphy_bitslip392[2];
    main_usddrphy_interface1_dfi_p1_rddata[103] <= main_usddrphy_bitslip392[3];
    main_usddrphy_interface1_dfi_p1_rddata[40] <= main_usddrphy_bitslip402[2];
    main_usddrphy_interface1_dfi_p1_rddata[104] <= main_usddrphy_bitslip402[3];
    main_usddrphy_interface1_dfi_p1_rddata[41] <= main_usddrphy_bitslip412[2];
    main_usddrphy_interface1_dfi_p1_rddata[105] <= main_usddrphy_bitslip412[3];
    main_usddrphy_interface1_dfi_p1_rddata[42] <= main_usddrphy_bitslip422[2];
    main_usddrphy_interface1_dfi_p1_rddata[106] <= main_usddrphy_bitslip422[3];
    main_usddrphy_interface1_dfi_p1_rddata[43] <= main_usddrphy_bitslip432[2];
    main_usddrphy_interface1_dfi_p1_rddata[107] <= main_usddrphy_bitslip432[3];
    main_usddrphy_interface1_dfi_p1_rddata[44] <= main_usddrphy_bitslip442[2];
    main_usddrphy_interface1_dfi_p1_rddata[108] <= main_usddrphy_bitslip442[3];
    main_usddrphy_interface1_dfi_p1_rddata[45] <= main_usddrphy_bitslip452[2];
    main_usddrphy_interface1_dfi_p1_rddata[109] <= main_usddrphy_bitslip452[3];
    main_usddrphy_interface1_dfi_p1_rddata[46] <= main_usddrphy_bitslip462[2];
    main_usddrphy_interface1_dfi_p1_rddata[110] <= main_usddrphy_bitslip462[3];
    main_usddrphy_interface1_dfi_p1_rddata[47] <= main_usddrphy_bitslip472[2];
    main_usddrphy_interface1_dfi_p1_rddata[111] <= main_usddrphy_bitslip472[3];
    main_usddrphy_interface1_dfi_p1_rddata[48] <= main_usddrphy_bitslip482[2];
    main_usddrphy_interface1_dfi_p1_rddata[112] <= main_usddrphy_bitslip482[3];
    main_usddrphy_interface1_dfi_p1_rddata[49] <= main_usddrphy_bitslip492[2];
    main_usddrphy_interface1_dfi_p1_rddata[113] <= main_usddrphy_bitslip492[3];
    main_usddrphy_interface1_dfi_p1_rddata[50] <= main_usddrphy_bitslip502[2];
    main_usddrphy_interface1_dfi_p1_rddata[114] <= main_usddrphy_bitslip502[3];
    main_usddrphy_interface1_dfi_p1_rddata[51] <= main_usddrphy_bitslip512[2];
    main_usddrphy_interface1_dfi_p1_rddata[115] <= main_usddrphy_bitslip512[3];
    main_usddrphy_interface1_dfi_p1_rddata[52] <= main_usddrphy_bitslip522[2];
    main_usddrphy_interface1_dfi_p1_rddata[116] <= main_usddrphy_bitslip522[3];
    main_usddrphy_interface1_dfi_p1_rddata[53] <= main_usddrphy_bitslip532[2];
    main_usddrphy_interface1_dfi_p1_rddata[117] <= main_usddrphy_bitslip532[3];
    main_usddrphy_interface1_dfi_p1_rddata[54] <= main_usddrphy_bitslip542[2];
    main_usddrphy_interface1_dfi_p1_rddata[118] <= main_usddrphy_bitslip542[3];
    main_usddrphy_interface1_dfi_p1_rddata[55] <= main_usddrphy_bitslip552[2];
    main_usddrphy_interface1_dfi_p1_rddata[119] <= main_usddrphy_bitslip552[3];
    main_usddrphy_interface1_dfi_p1_rddata[56] <= main_usddrphy_bitslip562[2];
    main_usddrphy_interface1_dfi_p1_rddata[120] <= main_usddrphy_bitslip562[3];
    main_usddrphy_interface1_dfi_p1_rddata[57] <= main_usddrphy_bitslip572[2];
    main_usddrphy_interface1_dfi_p1_rddata[121] <= main_usddrphy_bitslip572[3];
    main_usddrphy_interface1_dfi_p1_rddata[58] <= main_usddrphy_bitslip582[2];
    main_usddrphy_interface1_dfi_p1_rddata[122] <= main_usddrphy_bitslip582[3];
    main_usddrphy_interface1_dfi_p1_rddata[59] <= main_usddrphy_bitslip592[2];
    main_usddrphy_interface1_dfi_p1_rddata[123] <= main_usddrphy_bitslip592[3];
    main_usddrphy_interface1_dfi_p1_rddata[60] <= main_usddrphy_bitslip602[2];
    main_usddrphy_interface1_dfi_p1_rddata[124] <= main_usddrphy_bitslip602[3];
    main_usddrphy_interface1_dfi_p1_rddata[61] <= main_usddrphy_bitslip612[2];
    main_usddrphy_interface1_dfi_p1_rddata[125] <= main_usddrphy_bitslip612[3];
    main_usddrphy_interface1_dfi_p1_rddata[62] <= main_usddrphy_bitslip622[2];
    main_usddrphy_interface1_dfi_p1_rddata[126] <= main_usddrphy_bitslip622[3];
    main_usddrphy_interface1_dfi_p1_rddata[63] <= main_usddrphy_bitslip632[2];
    main_usddrphy_interface1_dfi_p1_rddata[127] <= main_usddrphy_bitslip632[3];
end
always @(*) begin
    main_usddrphy_interface1_dfi_p2_rddata <= 128'd0;
    main_usddrphy_interface1_dfi_p2_rddata[0] <= main_usddrphy_bitslip04[4];
    main_usddrphy_interface1_dfi_p2_rddata[64] <= main_usddrphy_bitslip04[5];
    main_usddrphy_interface1_dfi_p2_rddata[1] <= main_usddrphy_bitslip14[4];
    main_usddrphy_interface1_dfi_p2_rddata[65] <= main_usddrphy_bitslip14[5];
    main_usddrphy_interface1_dfi_p2_rddata[2] <= main_usddrphy_bitslip24[4];
    main_usddrphy_interface1_dfi_p2_rddata[66] <= main_usddrphy_bitslip24[5];
    main_usddrphy_interface1_dfi_p2_rddata[3] <= main_usddrphy_bitslip34[4];
    main_usddrphy_interface1_dfi_p2_rddata[67] <= main_usddrphy_bitslip34[5];
    main_usddrphy_interface1_dfi_p2_rddata[4] <= main_usddrphy_bitslip44[4];
    main_usddrphy_interface1_dfi_p2_rddata[68] <= main_usddrphy_bitslip44[5];
    main_usddrphy_interface1_dfi_p2_rddata[5] <= main_usddrphy_bitslip54[4];
    main_usddrphy_interface1_dfi_p2_rddata[69] <= main_usddrphy_bitslip54[5];
    main_usddrphy_interface1_dfi_p2_rddata[6] <= main_usddrphy_bitslip64[4];
    main_usddrphy_interface1_dfi_p2_rddata[70] <= main_usddrphy_bitslip64[5];
    main_usddrphy_interface1_dfi_p2_rddata[7] <= main_usddrphy_bitslip74[4];
    main_usddrphy_interface1_dfi_p2_rddata[71] <= main_usddrphy_bitslip74[5];
    main_usddrphy_interface1_dfi_p2_rddata[8] <= main_usddrphy_bitslip82[4];
    main_usddrphy_interface1_dfi_p2_rddata[72] <= main_usddrphy_bitslip82[5];
    main_usddrphy_interface1_dfi_p2_rddata[9] <= main_usddrphy_bitslip92[4];
    main_usddrphy_interface1_dfi_p2_rddata[73] <= main_usddrphy_bitslip92[5];
    main_usddrphy_interface1_dfi_p2_rddata[10] <= main_usddrphy_bitslip102[4];
    main_usddrphy_interface1_dfi_p2_rddata[74] <= main_usddrphy_bitslip102[5];
    main_usddrphy_interface1_dfi_p2_rddata[11] <= main_usddrphy_bitslip112[4];
    main_usddrphy_interface1_dfi_p2_rddata[75] <= main_usddrphy_bitslip112[5];
    main_usddrphy_interface1_dfi_p2_rddata[12] <= main_usddrphy_bitslip122[4];
    main_usddrphy_interface1_dfi_p2_rddata[76] <= main_usddrphy_bitslip122[5];
    main_usddrphy_interface1_dfi_p2_rddata[13] <= main_usddrphy_bitslip132[4];
    main_usddrphy_interface1_dfi_p2_rddata[77] <= main_usddrphy_bitslip132[5];
    main_usddrphy_interface1_dfi_p2_rddata[14] <= main_usddrphy_bitslip142[4];
    main_usddrphy_interface1_dfi_p2_rddata[78] <= main_usddrphy_bitslip142[5];
    main_usddrphy_interface1_dfi_p2_rddata[15] <= main_usddrphy_bitslip152[4];
    main_usddrphy_interface1_dfi_p2_rddata[79] <= main_usddrphy_bitslip152[5];
    main_usddrphy_interface1_dfi_p2_rddata[16] <= main_usddrphy_bitslip162[4];
    main_usddrphy_interface1_dfi_p2_rddata[80] <= main_usddrphy_bitslip162[5];
    main_usddrphy_interface1_dfi_p2_rddata[17] <= main_usddrphy_bitslip172[4];
    main_usddrphy_interface1_dfi_p2_rddata[81] <= main_usddrphy_bitslip172[5];
    main_usddrphy_interface1_dfi_p2_rddata[18] <= main_usddrphy_bitslip182[4];
    main_usddrphy_interface1_dfi_p2_rddata[82] <= main_usddrphy_bitslip182[5];
    main_usddrphy_interface1_dfi_p2_rddata[19] <= main_usddrphy_bitslip192[4];
    main_usddrphy_interface1_dfi_p2_rddata[83] <= main_usddrphy_bitslip192[5];
    main_usddrphy_interface1_dfi_p2_rddata[20] <= main_usddrphy_bitslip202[4];
    main_usddrphy_interface1_dfi_p2_rddata[84] <= main_usddrphy_bitslip202[5];
    main_usddrphy_interface1_dfi_p2_rddata[21] <= main_usddrphy_bitslip212[4];
    main_usddrphy_interface1_dfi_p2_rddata[85] <= main_usddrphy_bitslip212[5];
    main_usddrphy_interface1_dfi_p2_rddata[22] <= main_usddrphy_bitslip222[4];
    main_usddrphy_interface1_dfi_p2_rddata[86] <= main_usddrphy_bitslip222[5];
    main_usddrphy_interface1_dfi_p2_rddata[23] <= main_usddrphy_bitslip232[4];
    main_usddrphy_interface1_dfi_p2_rddata[87] <= main_usddrphy_bitslip232[5];
    main_usddrphy_interface1_dfi_p2_rddata[24] <= main_usddrphy_bitslip242[4];
    main_usddrphy_interface1_dfi_p2_rddata[88] <= main_usddrphy_bitslip242[5];
    main_usddrphy_interface1_dfi_p2_rddata[25] <= main_usddrphy_bitslip252[4];
    main_usddrphy_interface1_dfi_p2_rddata[89] <= main_usddrphy_bitslip252[5];
    main_usddrphy_interface1_dfi_p2_rddata[26] <= main_usddrphy_bitslip262[4];
    main_usddrphy_interface1_dfi_p2_rddata[90] <= main_usddrphy_bitslip262[5];
    main_usddrphy_interface1_dfi_p2_rddata[27] <= main_usddrphy_bitslip272[4];
    main_usddrphy_interface1_dfi_p2_rddata[91] <= main_usddrphy_bitslip272[5];
    main_usddrphy_interface1_dfi_p2_rddata[28] <= main_usddrphy_bitslip282[4];
    main_usddrphy_interface1_dfi_p2_rddata[92] <= main_usddrphy_bitslip282[5];
    main_usddrphy_interface1_dfi_p2_rddata[29] <= main_usddrphy_bitslip292[4];
    main_usddrphy_interface1_dfi_p2_rddata[93] <= main_usddrphy_bitslip292[5];
    main_usddrphy_interface1_dfi_p2_rddata[30] <= main_usddrphy_bitslip302[4];
    main_usddrphy_interface1_dfi_p2_rddata[94] <= main_usddrphy_bitslip302[5];
    main_usddrphy_interface1_dfi_p2_rddata[31] <= main_usddrphy_bitslip312[4];
    main_usddrphy_interface1_dfi_p2_rddata[95] <= main_usddrphy_bitslip312[5];
    main_usddrphy_interface1_dfi_p2_rddata[32] <= main_usddrphy_bitslip322[4];
    main_usddrphy_interface1_dfi_p2_rddata[96] <= main_usddrphy_bitslip322[5];
    main_usddrphy_interface1_dfi_p2_rddata[33] <= main_usddrphy_bitslip332[4];
    main_usddrphy_interface1_dfi_p2_rddata[97] <= main_usddrphy_bitslip332[5];
    main_usddrphy_interface1_dfi_p2_rddata[34] <= main_usddrphy_bitslip342[4];
    main_usddrphy_interface1_dfi_p2_rddata[98] <= main_usddrphy_bitslip342[5];
    main_usddrphy_interface1_dfi_p2_rddata[35] <= main_usddrphy_bitslip352[4];
    main_usddrphy_interface1_dfi_p2_rddata[99] <= main_usddrphy_bitslip352[5];
    main_usddrphy_interface1_dfi_p2_rddata[36] <= main_usddrphy_bitslip362[4];
    main_usddrphy_interface1_dfi_p2_rddata[100] <= main_usddrphy_bitslip362[5];
    main_usddrphy_interface1_dfi_p2_rddata[37] <= main_usddrphy_bitslip372[4];
    main_usddrphy_interface1_dfi_p2_rddata[101] <= main_usddrphy_bitslip372[5];
    main_usddrphy_interface1_dfi_p2_rddata[38] <= main_usddrphy_bitslip382[4];
    main_usddrphy_interface1_dfi_p2_rddata[102] <= main_usddrphy_bitslip382[5];
    main_usddrphy_interface1_dfi_p2_rddata[39] <= main_usddrphy_bitslip392[4];
    main_usddrphy_interface1_dfi_p2_rddata[103] <= main_usddrphy_bitslip392[5];
    main_usddrphy_interface1_dfi_p2_rddata[40] <= main_usddrphy_bitslip402[4];
    main_usddrphy_interface1_dfi_p2_rddata[104] <= main_usddrphy_bitslip402[5];
    main_usddrphy_interface1_dfi_p2_rddata[41] <= main_usddrphy_bitslip412[4];
    main_usddrphy_interface1_dfi_p2_rddata[105] <= main_usddrphy_bitslip412[5];
    main_usddrphy_interface1_dfi_p2_rddata[42] <= main_usddrphy_bitslip422[4];
    main_usddrphy_interface1_dfi_p2_rddata[106] <= main_usddrphy_bitslip422[5];
    main_usddrphy_interface1_dfi_p2_rddata[43] <= main_usddrphy_bitslip432[4];
    main_usddrphy_interface1_dfi_p2_rddata[107] <= main_usddrphy_bitslip432[5];
    main_usddrphy_interface1_dfi_p2_rddata[44] <= main_usddrphy_bitslip442[4];
    main_usddrphy_interface1_dfi_p2_rddata[108] <= main_usddrphy_bitslip442[5];
    main_usddrphy_interface1_dfi_p2_rddata[45] <= main_usddrphy_bitslip452[4];
    main_usddrphy_interface1_dfi_p2_rddata[109] <= main_usddrphy_bitslip452[5];
    main_usddrphy_interface1_dfi_p2_rddata[46] <= main_usddrphy_bitslip462[4];
    main_usddrphy_interface1_dfi_p2_rddata[110] <= main_usddrphy_bitslip462[5];
    main_usddrphy_interface1_dfi_p2_rddata[47] <= main_usddrphy_bitslip472[4];
    main_usddrphy_interface1_dfi_p2_rddata[111] <= main_usddrphy_bitslip472[5];
    main_usddrphy_interface1_dfi_p2_rddata[48] <= main_usddrphy_bitslip482[4];
    main_usddrphy_interface1_dfi_p2_rddata[112] <= main_usddrphy_bitslip482[5];
    main_usddrphy_interface1_dfi_p2_rddata[49] <= main_usddrphy_bitslip492[4];
    main_usddrphy_interface1_dfi_p2_rddata[113] <= main_usddrphy_bitslip492[5];
    main_usddrphy_interface1_dfi_p2_rddata[50] <= main_usddrphy_bitslip502[4];
    main_usddrphy_interface1_dfi_p2_rddata[114] <= main_usddrphy_bitslip502[5];
    main_usddrphy_interface1_dfi_p2_rddata[51] <= main_usddrphy_bitslip512[4];
    main_usddrphy_interface1_dfi_p2_rddata[115] <= main_usddrphy_bitslip512[5];
    main_usddrphy_interface1_dfi_p2_rddata[52] <= main_usddrphy_bitslip522[4];
    main_usddrphy_interface1_dfi_p2_rddata[116] <= main_usddrphy_bitslip522[5];
    main_usddrphy_interface1_dfi_p2_rddata[53] <= main_usddrphy_bitslip532[4];
    main_usddrphy_interface1_dfi_p2_rddata[117] <= main_usddrphy_bitslip532[5];
    main_usddrphy_interface1_dfi_p2_rddata[54] <= main_usddrphy_bitslip542[4];
    main_usddrphy_interface1_dfi_p2_rddata[118] <= main_usddrphy_bitslip542[5];
    main_usddrphy_interface1_dfi_p2_rddata[55] <= main_usddrphy_bitslip552[4];
    main_usddrphy_interface1_dfi_p2_rddata[119] <= main_usddrphy_bitslip552[5];
    main_usddrphy_interface1_dfi_p2_rddata[56] <= main_usddrphy_bitslip562[4];
    main_usddrphy_interface1_dfi_p2_rddata[120] <= main_usddrphy_bitslip562[5];
    main_usddrphy_interface1_dfi_p2_rddata[57] <= main_usddrphy_bitslip572[4];
    main_usddrphy_interface1_dfi_p2_rddata[121] <= main_usddrphy_bitslip572[5];
    main_usddrphy_interface1_dfi_p2_rddata[58] <= main_usddrphy_bitslip582[4];
    main_usddrphy_interface1_dfi_p2_rddata[122] <= main_usddrphy_bitslip582[5];
    main_usddrphy_interface1_dfi_p2_rddata[59] <= main_usddrphy_bitslip592[4];
    main_usddrphy_interface1_dfi_p2_rddata[123] <= main_usddrphy_bitslip592[5];
    main_usddrphy_interface1_dfi_p2_rddata[60] <= main_usddrphy_bitslip602[4];
    main_usddrphy_interface1_dfi_p2_rddata[124] <= main_usddrphy_bitslip602[5];
    main_usddrphy_interface1_dfi_p2_rddata[61] <= main_usddrphy_bitslip612[4];
    main_usddrphy_interface1_dfi_p2_rddata[125] <= main_usddrphy_bitslip612[5];
    main_usddrphy_interface1_dfi_p2_rddata[62] <= main_usddrphy_bitslip622[4];
    main_usddrphy_interface1_dfi_p2_rddata[126] <= main_usddrphy_bitslip622[5];
    main_usddrphy_interface1_dfi_p2_rddata[63] <= main_usddrphy_bitslip632[4];
    main_usddrphy_interface1_dfi_p2_rddata[127] <= main_usddrphy_bitslip632[5];
end
always @(*) begin
    main_usddrphy_interface1_dfi_p3_rddata <= 128'd0;
    main_usddrphy_interface1_dfi_p3_rddata[0] <= main_usddrphy_bitslip04[6];
    main_usddrphy_interface1_dfi_p3_rddata[64] <= main_usddrphy_bitslip04[7];
    main_usddrphy_interface1_dfi_p3_rddata[1] <= main_usddrphy_bitslip14[6];
    main_usddrphy_interface1_dfi_p3_rddata[65] <= main_usddrphy_bitslip14[7];
    main_usddrphy_interface1_dfi_p3_rddata[2] <= main_usddrphy_bitslip24[6];
    main_usddrphy_interface1_dfi_p3_rddata[66] <= main_usddrphy_bitslip24[7];
    main_usddrphy_interface1_dfi_p3_rddata[3] <= main_usddrphy_bitslip34[6];
    main_usddrphy_interface1_dfi_p3_rddata[67] <= main_usddrphy_bitslip34[7];
    main_usddrphy_interface1_dfi_p3_rddata[4] <= main_usddrphy_bitslip44[6];
    main_usddrphy_interface1_dfi_p3_rddata[68] <= main_usddrphy_bitslip44[7];
    main_usddrphy_interface1_dfi_p3_rddata[5] <= main_usddrphy_bitslip54[6];
    main_usddrphy_interface1_dfi_p3_rddata[69] <= main_usddrphy_bitslip54[7];
    main_usddrphy_interface1_dfi_p3_rddata[6] <= main_usddrphy_bitslip64[6];
    main_usddrphy_interface1_dfi_p3_rddata[70] <= main_usddrphy_bitslip64[7];
    main_usddrphy_interface1_dfi_p3_rddata[7] <= main_usddrphy_bitslip74[6];
    main_usddrphy_interface1_dfi_p3_rddata[71] <= main_usddrphy_bitslip74[7];
    main_usddrphy_interface1_dfi_p3_rddata[8] <= main_usddrphy_bitslip82[6];
    main_usddrphy_interface1_dfi_p3_rddata[72] <= main_usddrphy_bitslip82[7];
    main_usddrphy_interface1_dfi_p3_rddata[9] <= main_usddrphy_bitslip92[6];
    main_usddrphy_interface1_dfi_p3_rddata[73] <= main_usddrphy_bitslip92[7];
    main_usddrphy_interface1_dfi_p3_rddata[10] <= main_usddrphy_bitslip102[6];
    main_usddrphy_interface1_dfi_p3_rddata[74] <= main_usddrphy_bitslip102[7];
    main_usddrphy_interface1_dfi_p3_rddata[11] <= main_usddrphy_bitslip112[6];
    main_usddrphy_interface1_dfi_p3_rddata[75] <= main_usddrphy_bitslip112[7];
    main_usddrphy_interface1_dfi_p3_rddata[12] <= main_usddrphy_bitslip122[6];
    main_usddrphy_interface1_dfi_p3_rddata[76] <= main_usddrphy_bitslip122[7];
    main_usddrphy_interface1_dfi_p3_rddata[13] <= main_usddrphy_bitslip132[6];
    main_usddrphy_interface1_dfi_p3_rddata[77] <= main_usddrphy_bitslip132[7];
    main_usddrphy_interface1_dfi_p3_rddata[14] <= main_usddrphy_bitslip142[6];
    main_usddrphy_interface1_dfi_p3_rddata[78] <= main_usddrphy_bitslip142[7];
    main_usddrphy_interface1_dfi_p3_rddata[15] <= main_usddrphy_bitslip152[6];
    main_usddrphy_interface1_dfi_p3_rddata[79] <= main_usddrphy_bitslip152[7];
    main_usddrphy_interface1_dfi_p3_rddata[16] <= main_usddrphy_bitslip162[6];
    main_usddrphy_interface1_dfi_p3_rddata[80] <= main_usddrphy_bitslip162[7];
    main_usddrphy_interface1_dfi_p3_rddata[17] <= main_usddrphy_bitslip172[6];
    main_usddrphy_interface1_dfi_p3_rddata[81] <= main_usddrphy_bitslip172[7];
    main_usddrphy_interface1_dfi_p3_rddata[18] <= main_usddrphy_bitslip182[6];
    main_usddrphy_interface1_dfi_p3_rddata[82] <= main_usddrphy_bitslip182[7];
    main_usddrphy_interface1_dfi_p3_rddata[19] <= main_usddrphy_bitslip192[6];
    main_usddrphy_interface1_dfi_p3_rddata[83] <= main_usddrphy_bitslip192[7];
    main_usddrphy_interface1_dfi_p3_rddata[20] <= main_usddrphy_bitslip202[6];
    main_usddrphy_interface1_dfi_p3_rddata[84] <= main_usddrphy_bitslip202[7];
    main_usddrphy_interface1_dfi_p3_rddata[21] <= main_usddrphy_bitslip212[6];
    main_usddrphy_interface1_dfi_p3_rddata[85] <= main_usddrphy_bitslip212[7];
    main_usddrphy_interface1_dfi_p3_rddata[22] <= main_usddrphy_bitslip222[6];
    main_usddrphy_interface1_dfi_p3_rddata[86] <= main_usddrphy_bitslip222[7];
    main_usddrphy_interface1_dfi_p3_rddata[23] <= main_usddrphy_bitslip232[6];
    main_usddrphy_interface1_dfi_p3_rddata[87] <= main_usddrphy_bitslip232[7];
    main_usddrphy_interface1_dfi_p3_rddata[24] <= main_usddrphy_bitslip242[6];
    main_usddrphy_interface1_dfi_p3_rddata[88] <= main_usddrphy_bitslip242[7];
    main_usddrphy_interface1_dfi_p3_rddata[25] <= main_usddrphy_bitslip252[6];
    main_usddrphy_interface1_dfi_p3_rddata[89] <= main_usddrphy_bitslip252[7];
    main_usddrphy_interface1_dfi_p3_rddata[26] <= main_usddrphy_bitslip262[6];
    main_usddrphy_interface1_dfi_p3_rddata[90] <= main_usddrphy_bitslip262[7];
    main_usddrphy_interface1_dfi_p3_rddata[27] <= main_usddrphy_bitslip272[6];
    main_usddrphy_interface1_dfi_p3_rddata[91] <= main_usddrphy_bitslip272[7];
    main_usddrphy_interface1_dfi_p3_rddata[28] <= main_usddrphy_bitslip282[6];
    main_usddrphy_interface1_dfi_p3_rddata[92] <= main_usddrphy_bitslip282[7];
    main_usddrphy_interface1_dfi_p3_rddata[29] <= main_usddrphy_bitslip292[6];
    main_usddrphy_interface1_dfi_p3_rddata[93] <= main_usddrphy_bitslip292[7];
    main_usddrphy_interface1_dfi_p3_rddata[30] <= main_usddrphy_bitslip302[6];
    main_usddrphy_interface1_dfi_p3_rddata[94] <= main_usddrphy_bitslip302[7];
    main_usddrphy_interface1_dfi_p3_rddata[31] <= main_usddrphy_bitslip312[6];
    main_usddrphy_interface1_dfi_p3_rddata[95] <= main_usddrphy_bitslip312[7];
    main_usddrphy_interface1_dfi_p3_rddata[32] <= main_usddrphy_bitslip322[6];
    main_usddrphy_interface1_dfi_p3_rddata[96] <= main_usddrphy_bitslip322[7];
    main_usddrphy_interface1_dfi_p3_rddata[33] <= main_usddrphy_bitslip332[6];
    main_usddrphy_interface1_dfi_p3_rddata[97] <= main_usddrphy_bitslip332[7];
    main_usddrphy_interface1_dfi_p3_rddata[34] <= main_usddrphy_bitslip342[6];
    main_usddrphy_interface1_dfi_p3_rddata[98] <= main_usddrphy_bitslip342[7];
    main_usddrphy_interface1_dfi_p3_rddata[35] <= main_usddrphy_bitslip352[6];
    main_usddrphy_interface1_dfi_p3_rddata[99] <= main_usddrphy_bitslip352[7];
    main_usddrphy_interface1_dfi_p3_rddata[36] <= main_usddrphy_bitslip362[6];
    main_usddrphy_interface1_dfi_p3_rddata[100] <= main_usddrphy_bitslip362[7];
    main_usddrphy_interface1_dfi_p3_rddata[37] <= main_usddrphy_bitslip372[6];
    main_usddrphy_interface1_dfi_p3_rddata[101] <= main_usddrphy_bitslip372[7];
    main_usddrphy_interface1_dfi_p3_rddata[38] <= main_usddrphy_bitslip382[6];
    main_usddrphy_interface1_dfi_p3_rddata[102] <= main_usddrphy_bitslip382[7];
    main_usddrphy_interface1_dfi_p3_rddata[39] <= main_usddrphy_bitslip392[6];
    main_usddrphy_interface1_dfi_p3_rddata[103] <= main_usddrphy_bitslip392[7];
    main_usddrphy_interface1_dfi_p3_rddata[40] <= main_usddrphy_bitslip402[6];
    main_usddrphy_interface1_dfi_p3_rddata[104] <= main_usddrphy_bitslip402[7];
    main_usddrphy_interface1_dfi_p3_rddata[41] <= main_usddrphy_bitslip412[6];
    main_usddrphy_interface1_dfi_p3_rddata[105] <= main_usddrphy_bitslip412[7];
    main_usddrphy_interface1_dfi_p3_rddata[42] <= main_usddrphy_bitslip422[6];
    main_usddrphy_interface1_dfi_p3_rddata[106] <= main_usddrphy_bitslip422[7];
    main_usddrphy_interface1_dfi_p3_rddata[43] <= main_usddrphy_bitslip432[6];
    main_usddrphy_interface1_dfi_p3_rddata[107] <= main_usddrphy_bitslip432[7];
    main_usddrphy_interface1_dfi_p3_rddata[44] <= main_usddrphy_bitslip442[6];
    main_usddrphy_interface1_dfi_p3_rddata[108] <= main_usddrphy_bitslip442[7];
    main_usddrphy_interface1_dfi_p3_rddata[45] <= main_usddrphy_bitslip452[6];
    main_usddrphy_interface1_dfi_p3_rddata[109] <= main_usddrphy_bitslip452[7];
    main_usddrphy_interface1_dfi_p3_rddata[46] <= main_usddrphy_bitslip462[6];
    main_usddrphy_interface1_dfi_p3_rddata[110] <= main_usddrphy_bitslip462[7];
    main_usddrphy_interface1_dfi_p3_rddata[47] <= main_usddrphy_bitslip472[6];
    main_usddrphy_interface1_dfi_p3_rddata[111] <= main_usddrphy_bitslip472[7];
    main_usddrphy_interface1_dfi_p3_rddata[48] <= main_usddrphy_bitslip482[6];
    main_usddrphy_interface1_dfi_p3_rddata[112] <= main_usddrphy_bitslip482[7];
    main_usddrphy_interface1_dfi_p3_rddata[49] <= main_usddrphy_bitslip492[6];
    main_usddrphy_interface1_dfi_p3_rddata[113] <= main_usddrphy_bitslip492[7];
    main_usddrphy_interface1_dfi_p3_rddata[50] <= main_usddrphy_bitslip502[6];
    main_usddrphy_interface1_dfi_p3_rddata[114] <= main_usddrphy_bitslip502[7];
    main_usddrphy_interface1_dfi_p3_rddata[51] <= main_usddrphy_bitslip512[6];
    main_usddrphy_interface1_dfi_p3_rddata[115] <= main_usddrphy_bitslip512[7];
    main_usddrphy_interface1_dfi_p3_rddata[52] <= main_usddrphy_bitslip522[6];
    main_usddrphy_interface1_dfi_p3_rddata[116] <= main_usddrphy_bitslip522[7];
    main_usddrphy_interface1_dfi_p3_rddata[53] <= main_usddrphy_bitslip532[6];
    main_usddrphy_interface1_dfi_p3_rddata[117] <= main_usddrphy_bitslip532[7];
    main_usddrphy_interface1_dfi_p3_rddata[54] <= main_usddrphy_bitslip542[6];
    main_usddrphy_interface1_dfi_p3_rddata[118] <= main_usddrphy_bitslip542[7];
    main_usddrphy_interface1_dfi_p3_rddata[55] <= main_usddrphy_bitslip552[6];
    main_usddrphy_interface1_dfi_p3_rddata[119] <= main_usddrphy_bitslip552[7];
    main_usddrphy_interface1_dfi_p3_rddata[56] <= main_usddrphy_bitslip562[6];
    main_usddrphy_interface1_dfi_p3_rddata[120] <= main_usddrphy_bitslip562[7];
    main_usddrphy_interface1_dfi_p3_rddata[57] <= main_usddrphy_bitslip572[6];
    main_usddrphy_interface1_dfi_p3_rddata[121] <= main_usddrphy_bitslip572[7];
    main_usddrphy_interface1_dfi_p3_rddata[58] <= main_usddrphy_bitslip582[6];
    main_usddrphy_interface1_dfi_p3_rddata[122] <= main_usddrphy_bitslip582[7];
    main_usddrphy_interface1_dfi_p3_rddata[59] <= main_usddrphy_bitslip592[6];
    main_usddrphy_interface1_dfi_p3_rddata[123] <= main_usddrphy_bitslip592[7];
    main_usddrphy_interface1_dfi_p3_rddata[60] <= main_usddrphy_bitslip602[6];
    main_usddrphy_interface1_dfi_p3_rddata[124] <= main_usddrphy_bitslip602[7];
    main_usddrphy_interface1_dfi_p3_rddata[61] <= main_usddrphy_bitslip612[6];
    main_usddrphy_interface1_dfi_p3_rddata[125] <= main_usddrphy_bitslip612[7];
    main_usddrphy_interface1_dfi_p3_rddata[62] <= main_usddrphy_bitslip622[6];
    main_usddrphy_interface1_dfi_p3_rddata[126] <= main_usddrphy_bitslip622[7];
    main_usddrphy_interface1_dfi_p3_rddata[63] <= main_usddrphy_bitslip632[6];
    main_usddrphy_interface1_dfi_p3_rddata[127] <= main_usddrphy_bitslip632[7];
end
assign main_usddrphy_interface1_dfi_p0_rddata_valid = (main_usddrphy_rddata_en_tappeddelayline7 | main_usddrphy_wlevel_en_storage);
assign main_usddrphy_interface1_dfi_p1_rddata_valid = (main_usddrphy_rddata_en_tappeddelayline7 | main_usddrphy_wlevel_en_storage);
assign main_usddrphy_interface1_dfi_p2_rddata_valid = (main_usddrphy_rddata_en_tappeddelayline7 | main_usddrphy_wlevel_en_storage);
assign main_usddrphy_interface1_dfi_p3_rddata_valid = (main_usddrphy_rddata_en_tappeddelayline7 | main_usddrphy_wlevel_en_storage);
assign main_usddrphy_dq_oe = main_usddrphy_wrdata_en_tappeddelayline2;
always @(*) begin
    main_usddrphy_dqs_oe <= 1'd0;
    if (main_usddrphy_wlevel_en_storage) begin
        main_usddrphy_dqs_oe <= 1'd1;
    end else begin
        main_usddrphy_dqs_oe <= main_usddrphy_dq_oe;
    end
end
assign main_usddrphy_dqs_preamble = (main_usddrphy_wrdata_en_tappeddelayline1 & (~main_usddrphy_wrdata_en_tappeddelayline2));
assign main_usddrphy_dqs_postamble = (main_usddrphy_wrdata_en_tappeddelayline3 & (~main_usddrphy_wrdata_en_tappeddelayline2));
assign main_usddrphy_interface1_dfi_p0_address = main_usddrphy_interface0_dfi_p0_address;
assign main_usddrphy_interface1_dfi_p0_bank = main_usddrphy_interface0_dfi_p0_bank;
assign main_usddrphy_interface1_dfi_p0_cs_n = main_usddrphy_interface0_dfi_p0_cs_n;
assign main_usddrphy_interface1_dfi_p0_cke = main_usddrphy_interface0_dfi_p0_cke;
assign main_usddrphy_interface1_dfi_p0_odt = main_usddrphy_interface0_dfi_p0_odt;
assign main_usddrphy_interface1_dfi_p0_reset_n = main_usddrphy_interface0_dfi_p0_reset_n;
assign main_usddrphy_interface1_dfi_p0_wrdata = main_usddrphy_interface0_dfi_p0_wrdata;
assign main_usddrphy_interface1_dfi_p0_wrdata_en = main_usddrphy_interface0_dfi_p0_wrdata_en;
assign main_usddrphy_interface1_dfi_p0_wrdata_mask = main_usddrphy_interface0_dfi_p0_wrdata_mask;
assign main_usddrphy_interface1_dfi_p0_rddata_en = main_usddrphy_interface0_dfi_p0_rddata_en;
assign main_usddrphy_interface0_dfi_p0_rddata = main_usddrphy_interface1_dfi_p0_rddata;
assign main_usddrphy_interface0_dfi_p0_rddata_valid = main_usddrphy_interface1_dfi_p0_rddata_valid;
always @(*) begin
    main_usddrphy_interface1_dfi_p0_act_n <= 1'd1;
    main_usddrphy_interface1_dfi_p0_cas_n <= 1'd1;
    main_usddrphy_interface1_dfi_p0_ras_n <= 1'd1;
    main_usddrphy_interface1_dfi_p0_we_n <= 1'd1;
    main_usddrphy_interface1_dfi_p0_cas_n <= main_usddrphy_interface0_dfi_p0_cas_n;
    main_usddrphy_interface1_dfi_p0_ras_n <= main_usddrphy_interface0_dfi_p0_ras_n;
    main_usddrphy_interface1_dfi_p0_we_n <= main_usddrphy_interface0_dfi_p0_we_n;
    main_usddrphy_interface1_dfi_p0_act_n <= main_usddrphy_interface0_dfi_p0_act_n;
    if ((((~main_usddrphy_interface0_dfi_p0_ras_n) & main_usddrphy_interface0_dfi_p0_cas_n) & main_usddrphy_interface0_dfi_p0_we_n)) begin
        main_usddrphy_interface1_dfi_p0_act_n <= 1'd0;
        main_usddrphy_interface1_dfi_p0_we_n <= main_usddrphy_interface0_dfi_p0_address[14];
        main_usddrphy_interface1_dfi_p0_cas_n <= main_usddrphy_interface0_dfi_p0_address[15];
        main_usddrphy_interface1_dfi_p0_ras_n <= main_usddrphy_interface0_dfi_p0_address[16];
    end else begin
        main_usddrphy_interface1_dfi_p0_act_n <= 1'd1;
    end
end
assign main_usddrphy_interface1_dfi_p1_address = main_usddrphy_interface0_dfi_p1_address;
assign main_usddrphy_interface1_dfi_p1_bank = main_usddrphy_interface0_dfi_p1_bank;
assign main_usddrphy_interface1_dfi_p1_cs_n = main_usddrphy_interface0_dfi_p1_cs_n;
assign main_usddrphy_interface1_dfi_p1_cke = main_usddrphy_interface0_dfi_p1_cke;
assign main_usddrphy_interface1_dfi_p1_odt = main_usddrphy_interface0_dfi_p1_odt;
assign main_usddrphy_interface1_dfi_p1_reset_n = main_usddrphy_interface0_dfi_p1_reset_n;
assign main_usddrphy_interface1_dfi_p1_wrdata = main_usddrphy_interface0_dfi_p1_wrdata;
assign main_usddrphy_interface1_dfi_p1_wrdata_en = main_usddrphy_interface0_dfi_p1_wrdata_en;
assign main_usddrphy_interface1_dfi_p1_wrdata_mask = main_usddrphy_interface0_dfi_p1_wrdata_mask;
assign main_usddrphy_interface1_dfi_p1_rddata_en = main_usddrphy_interface0_dfi_p1_rddata_en;
assign main_usddrphy_interface0_dfi_p1_rddata = main_usddrphy_interface1_dfi_p1_rddata;
assign main_usddrphy_interface0_dfi_p1_rddata_valid = main_usddrphy_interface1_dfi_p1_rddata_valid;
always @(*) begin
    main_usddrphy_interface1_dfi_p1_act_n <= 1'd1;
    main_usddrphy_interface1_dfi_p1_cas_n <= 1'd1;
    main_usddrphy_interface1_dfi_p1_ras_n <= 1'd1;
    main_usddrphy_interface1_dfi_p1_we_n <= 1'd1;
    main_usddrphy_interface1_dfi_p1_cas_n <= main_usddrphy_interface0_dfi_p1_cas_n;
    main_usddrphy_interface1_dfi_p1_ras_n <= main_usddrphy_interface0_dfi_p1_ras_n;
    main_usddrphy_interface1_dfi_p1_we_n <= main_usddrphy_interface0_dfi_p1_we_n;
    main_usddrphy_interface1_dfi_p1_act_n <= main_usddrphy_interface0_dfi_p1_act_n;
    if ((((~main_usddrphy_interface0_dfi_p1_ras_n) & main_usddrphy_interface0_dfi_p1_cas_n) & main_usddrphy_interface0_dfi_p1_we_n)) begin
        main_usddrphy_interface1_dfi_p1_act_n <= 1'd0;
        main_usddrphy_interface1_dfi_p1_we_n <= main_usddrphy_interface0_dfi_p1_address[14];
        main_usddrphy_interface1_dfi_p1_cas_n <= main_usddrphy_interface0_dfi_p1_address[15];
        main_usddrphy_interface1_dfi_p1_ras_n <= main_usddrphy_interface0_dfi_p1_address[16];
    end else begin
        main_usddrphy_interface1_dfi_p1_act_n <= 1'd1;
    end
end
assign main_usddrphy_interface1_dfi_p2_address = main_usddrphy_interface0_dfi_p2_address;
assign main_usddrphy_interface1_dfi_p2_bank = main_usddrphy_interface0_dfi_p2_bank;
assign main_usddrphy_interface1_dfi_p2_cs_n = main_usddrphy_interface0_dfi_p2_cs_n;
assign main_usddrphy_interface1_dfi_p2_cke = main_usddrphy_interface0_dfi_p2_cke;
assign main_usddrphy_interface1_dfi_p2_odt = main_usddrphy_interface0_dfi_p2_odt;
assign main_usddrphy_interface1_dfi_p2_reset_n = main_usddrphy_interface0_dfi_p2_reset_n;
assign main_usddrphy_interface1_dfi_p2_wrdata = main_usddrphy_interface0_dfi_p2_wrdata;
assign main_usddrphy_interface1_dfi_p2_wrdata_en = main_usddrphy_interface0_dfi_p2_wrdata_en;
assign main_usddrphy_interface1_dfi_p2_wrdata_mask = main_usddrphy_interface0_dfi_p2_wrdata_mask;
assign main_usddrphy_interface1_dfi_p2_rddata_en = main_usddrphy_interface0_dfi_p2_rddata_en;
assign main_usddrphy_interface0_dfi_p2_rddata = main_usddrphy_interface1_dfi_p2_rddata;
assign main_usddrphy_interface0_dfi_p2_rddata_valid = main_usddrphy_interface1_dfi_p2_rddata_valid;
always @(*) begin
    main_usddrphy_interface1_dfi_p2_act_n <= 1'd1;
    main_usddrphy_interface1_dfi_p2_cas_n <= 1'd1;
    main_usddrphy_interface1_dfi_p2_ras_n <= 1'd1;
    main_usddrphy_interface1_dfi_p2_we_n <= 1'd1;
    main_usddrphy_interface1_dfi_p2_cas_n <= main_usddrphy_interface0_dfi_p2_cas_n;
    main_usddrphy_interface1_dfi_p2_ras_n <= main_usddrphy_interface0_dfi_p2_ras_n;
    main_usddrphy_interface1_dfi_p2_we_n <= main_usddrphy_interface0_dfi_p2_we_n;
    main_usddrphy_interface1_dfi_p2_act_n <= main_usddrphy_interface0_dfi_p2_act_n;
    if ((((~main_usddrphy_interface0_dfi_p2_ras_n) & main_usddrphy_interface0_dfi_p2_cas_n) & main_usddrphy_interface0_dfi_p2_we_n)) begin
        main_usddrphy_interface1_dfi_p2_act_n <= 1'd0;
        main_usddrphy_interface1_dfi_p2_we_n <= main_usddrphy_interface0_dfi_p2_address[14];
        main_usddrphy_interface1_dfi_p2_cas_n <= main_usddrphy_interface0_dfi_p2_address[15];
        main_usddrphy_interface1_dfi_p2_ras_n <= main_usddrphy_interface0_dfi_p2_address[16];
    end else begin
        main_usddrphy_interface1_dfi_p2_act_n <= 1'd1;
    end
end
assign main_usddrphy_interface1_dfi_p3_address = main_usddrphy_interface0_dfi_p3_address;
assign main_usddrphy_interface1_dfi_p3_bank = main_usddrphy_interface0_dfi_p3_bank;
assign main_usddrphy_interface1_dfi_p3_cs_n = main_usddrphy_interface0_dfi_p3_cs_n;
assign main_usddrphy_interface1_dfi_p3_cke = main_usddrphy_interface0_dfi_p3_cke;
assign main_usddrphy_interface1_dfi_p3_odt = main_usddrphy_interface0_dfi_p3_odt;
assign main_usddrphy_interface1_dfi_p3_reset_n = main_usddrphy_interface0_dfi_p3_reset_n;
assign main_usddrphy_interface1_dfi_p3_wrdata = main_usddrphy_interface0_dfi_p3_wrdata;
assign main_usddrphy_interface1_dfi_p3_wrdata_en = main_usddrphy_interface0_dfi_p3_wrdata_en;
assign main_usddrphy_interface1_dfi_p3_wrdata_mask = main_usddrphy_interface0_dfi_p3_wrdata_mask;
assign main_usddrphy_interface1_dfi_p3_rddata_en = main_usddrphy_interface0_dfi_p3_rddata_en;
assign main_usddrphy_interface0_dfi_p3_rddata = main_usddrphy_interface1_dfi_p3_rddata;
assign main_usddrphy_interface0_dfi_p3_rddata_valid = main_usddrphy_interface1_dfi_p3_rddata_valid;
always @(*) begin
    main_usddrphy_interface1_dfi_p3_act_n <= 1'd1;
    main_usddrphy_interface1_dfi_p3_cas_n <= 1'd1;
    main_usddrphy_interface1_dfi_p3_ras_n <= 1'd1;
    main_usddrphy_interface1_dfi_p3_we_n <= 1'd1;
    main_usddrphy_interface1_dfi_p3_cas_n <= main_usddrphy_interface0_dfi_p3_cas_n;
    main_usddrphy_interface1_dfi_p3_ras_n <= main_usddrphy_interface0_dfi_p3_ras_n;
    main_usddrphy_interface1_dfi_p3_we_n <= main_usddrphy_interface0_dfi_p3_we_n;
    main_usddrphy_interface1_dfi_p3_act_n <= main_usddrphy_interface0_dfi_p3_act_n;
    if ((((~main_usddrphy_interface0_dfi_p3_ras_n) & main_usddrphy_interface0_dfi_p3_cas_n) & main_usddrphy_interface0_dfi_p3_we_n)) begin
        main_usddrphy_interface1_dfi_p3_act_n <= 1'd0;
        main_usddrphy_interface1_dfi_p3_we_n <= main_usddrphy_interface0_dfi_p3_address[14];
        main_usddrphy_interface1_dfi_p3_cas_n <= main_usddrphy_interface0_dfi_p3_address[15];
        main_usddrphy_interface1_dfi_p3_ras_n <= main_usddrphy_interface0_dfi_p3_address[16];
    end else begin
        main_usddrphy_interface1_dfi_p3_act_n <= 1'd1;
    end
end
always @(*) begin
    main_usddrphy_dqspattern_o <= 8'd0;
    main_usddrphy_dqspattern_o <= 7'd85;
    if (main_usddrphy_dqspattern0) begin
        main_usddrphy_dqspattern_o <= 5'd21;
    end
    if (main_usddrphy_dqspattern1) begin
        main_usddrphy_dqspattern_o <= 7'd84;
    end
    if (main_usddrphy_wlevel_en_storage) begin
        main_usddrphy_dqspattern_o <= 1'd0;
        if (main_usddrphy_wlevel_strobe_re) begin
            main_usddrphy_dqspattern_o <= 1'd1;
        end
    end
end
always @(*) begin
    main_usddrphy_bitslip00 <= 8'd0;
    case (main_usddrphy_bitslip0_value0)
        1'd0: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip00 <= main_usddrphy_bitslip0_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip10 <= 8'd0;
    case (main_usddrphy_bitslip1_value0)
        1'd0: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip10 <= main_usddrphy_bitslip1_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip20 <= 8'd0;
    case (main_usddrphy_bitslip2_value0)
        1'd0: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip20 <= main_usddrphy_bitslip2_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip30 <= 8'd0;
    case (main_usddrphy_bitslip3_value0)
        1'd0: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip30 <= main_usddrphy_bitslip3_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip40 <= 8'd0;
    case (main_usddrphy_bitslip4_value0)
        1'd0: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip40 <= main_usddrphy_bitslip4_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip50 <= 8'd0;
    case (main_usddrphy_bitslip5_value0)
        1'd0: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip50 <= main_usddrphy_bitslip5_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip60 <= 8'd0;
    case (main_usddrphy_bitslip6_value0)
        1'd0: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip60 <= main_usddrphy_bitslip6_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip70 <= 8'd0;
    case (main_usddrphy_bitslip7_value0)
        1'd0: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip70 <= main_usddrphy_bitslip7_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip01 <= 8'd0;
    case (main_usddrphy_bitslip0_value1)
        1'd0: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip01 <= main_usddrphy_bitslip0_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip11 <= 8'd0;
    case (main_usddrphy_bitslip1_value1)
        1'd0: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip11 <= main_usddrphy_bitslip1_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip21 <= 8'd0;
    case (main_usddrphy_bitslip2_value1)
        1'd0: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip21 <= main_usddrphy_bitslip2_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip31 <= 8'd0;
    case (main_usddrphy_bitslip3_value1)
        1'd0: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip31 <= main_usddrphy_bitslip3_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip41 <= 8'd0;
    case (main_usddrphy_bitslip4_value1)
        1'd0: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip41 <= main_usddrphy_bitslip4_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip51 <= 8'd0;
    case (main_usddrphy_bitslip5_value1)
        1'd0: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip51 <= main_usddrphy_bitslip5_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip61 <= 8'd0;
    case (main_usddrphy_bitslip6_value1)
        1'd0: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip61 <= main_usddrphy_bitslip6_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip71 <= 8'd0;
    case (main_usddrphy_bitslip7_value1)
        1'd0: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip71 <= main_usddrphy_bitslip7_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip02 <= 8'd0;
    case (main_usddrphy_bitslip0_value2)
        1'd0: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip02 <= main_usddrphy_bitslip0_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip04 <= 8'd0;
    case (main_usddrphy_bitslip0_value3)
        1'd0: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip04 <= main_usddrphy_bitslip0_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip12 <= 8'd0;
    case (main_usddrphy_bitslip1_value2)
        1'd0: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip12 <= main_usddrphy_bitslip1_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip14 <= 8'd0;
    case (main_usddrphy_bitslip1_value3)
        1'd0: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip14 <= main_usddrphy_bitslip1_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip22 <= 8'd0;
    case (main_usddrphy_bitslip2_value2)
        1'd0: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip22 <= main_usddrphy_bitslip2_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip24 <= 8'd0;
    case (main_usddrphy_bitslip2_value3)
        1'd0: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip24 <= main_usddrphy_bitslip2_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip32 <= 8'd0;
    case (main_usddrphy_bitslip3_value2)
        1'd0: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip32 <= main_usddrphy_bitslip3_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip34 <= 8'd0;
    case (main_usddrphy_bitslip3_value3)
        1'd0: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip34 <= main_usddrphy_bitslip3_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip42 <= 8'd0;
    case (main_usddrphy_bitslip4_value2)
        1'd0: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip42 <= main_usddrphy_bitslip4_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip44 <= 8'd0;
    case (main_usddrphy_bitslip4_value3)
        1'd0: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip44 <= main_usddrphy_bitslip4_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip52 <= 8'd0;
    case (main_usddrphy_bitslip5_value2)
        1'd0: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip52 <= main_usddrphy_bitslip5_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip54 <= 8'd0;
    case (main_usddrphy_bitslip5_value3)
        1'd0: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip54 <= main_usddrphy_bitslip5_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip62 <= 8'd0;
    case (main_usddrphy_bitslip6_value2)
        1'd0: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip62 <= main_usddrphy_bitslip6_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip64 <= 8'd0;
    case (main_usddrphy_bitslip6_value3)
        1'd0: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip64 <= main_usddrphy_bitslip6_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip72 <= 8'd0;
    case (main_usddrphy_bitslip7_value2)
        1'd0: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip72 <= main_usddrphy_bitslip7_r2[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip74 <= 8'd0;
    case (main_usddrphy_bitslip7_value3)
        1'd0: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip74 <= main_usddrphy_bitslip7_r3[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip80 <= 8'd0;
    case (main_usddrphy_bitslip8_value0)
        1'd0: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip80 <= main_usddrphy_bitslip8_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip82 <= 8'd0;
    case (main_usddrphy_bitslip8_value1)
        1'd0: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip82 <= main_usddrphy_bitslip8_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip90 <= 8'd0;
    case (main_usddrphy_bitslip9_value0)
        1'd0: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip90 <= main_usddrphy_bitslip9_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip92 <= 8'd0;
    case (main_usddrphy_bitslip9_value1)
        1'd0: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip92 <= main_usddrphy_bitslip9_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip100 <= 8'd0;
    case (main_usddrphy_bitslip10_value0)
        1'd0: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip100 <= main_usddrphy_bitslip10_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip102 <= 8'd0;
    case (main_usddrphy_bitslip10_value1)
        1'd0: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip102 <= main_usddrphy_bitslip10_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip110 <= 8'd0;
    case (main_usddrphy_bitslip11_value0)
        1'd0: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip110 <= main_usddrphy_bitslip11_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip112 <= 8'd0;
    case (main_usddrphy_bitslip11_value1)
        1'd0: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip112 <= main_usddrphy_bitslip11_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip120 <= 8'd0;
    case (main_usddrphy_bitslip12_value0)
        1'd0: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip120 <= main_usddrphy_bitslip12_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip122 <= 8'd0;
    case (main_usddrphy_bitslip12_value1)
        1'd0: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip122 <= main_usddrphy_bitslip12_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip130 <= 8'd0;
    case (main_usddrphy_bitslip13_value0)
        1'd0: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip130 <= main_usddrphy_bitslip13_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip132 <= 8'd0;
    case (main_usddrphy_bitslip13_value1)
        1'd0: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip132 <= main_usddrphy_bitslip13_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip140 <= 8'd0;
    case (main_usddrphy_bitslip14_value0)
        1'd0: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip140 <= main_usddrphy_bitslip14_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip142 <= 8'd0;
    case (main_usddrphy_bitslip14_value1)
        1'd0: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip142 <= main_usddrphy_bitslip14_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip150 <= 8'd0;
    case (main_usddrphy_bitslip15_value0)
        1'd0: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip150 <= main_usddrphy_bitslip15_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip152 <= 8'd0;
    case (main_usddrphy_bitslip15_value1)
        1'd0: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip152 <= main_usddrphy_bitslip15_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip160 <= 8'd0;
    case (main_usddrphy_bitslip16_value0)
        1'd0: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip160 <= main_usddrphy_bitslip16_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip162 <= 8'd0;
    case (main_usddrphy_bitslip16_value1)
        1'd0: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip162 <= main_usddrphy_bitslip16_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip170 <= 8'd0;
    case (main_usddrphy_bitslip17_value0)
        1'd0: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip170 <= main_usddrphy_bitslip17_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip172 <= 8'd0;
    case (main_usddrphy_bitslip17_value1)
        1'd0: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip172 <= main_usddrphy_bitslip17_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip180 <= 8'd0;
    case (main_usddrphy_bitslip18_value0)
        1'd0: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip180 <= main_usddrphy_bitslip18_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip182 <= 8'd0;
    case (main_usddrphy_bitslip18_value1)
        1'd0: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip182 <= main_usddrphy_bitslip18_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip190 <= 8'd0;
    case (main_usddrphy_bitslip19_value0)
        1'd0: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip190 <= main_usddrphy_bitslip19_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip192 <= 8'd0;
    case (main_usddrphy_bitslip19_value1)
        1'd0: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip192 <= main_usddrphy_bitslip19_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip200 <= 8'd0;
    case (main_usddrphy_bitslip20_value0)
        1'd0: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip200 <= main_usddrphy_bitslip20_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip202 <= 8'd0;
    case (main_usddrphy_bitslip20_value1)
        1'd0: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip202 <= main_usddrphy_bitslip20_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip210 <= 8'd0;
    case (main_usddrphy_bitslip21_value0)
        1'd0: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip210 <= main_usddrphy_bitslip21_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip212 <= 8'd0;
    case (main_usddrphy_bitslip21_value1)
        1'd0: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip212 <= main_usddrphy_bitslip21_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip220 <= 8'd0;
    case (main_usddrphy_bitslip22_value0)
        1'd0: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip220 <= main_usddrphy_bitslip22_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip222 <= 8'd0;
    case (main_usddrphy_bitslip22_value1)
        1'd0: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip222 <= main_usddrphy_bitslip22_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip230 <= 8'd0;
    case (main_usddrphy_bitslip23_value0)
        1'd0: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip230 <= main_usddrphy_bitslip23_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip232 <= 8'd0;
    case (main_usddrphy_bitslip23_value1)
        1'd0: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip232 <= main_usddrphy_bitslip23_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip240 <= 8'd0;
    case (main_usddrphy_bitslip24_value0)
        1'd0: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip240 <= main_usddrphy_bitslip24_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip242 <= 8'd0;
    case (main_usddrphy_bitslip24_value1)
        1'd0: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip242 <= main_usddrphy_bitslip24_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip250 <= 8'd0;
    case (main_usddrphy_bitslip25_value0)
        1'd0: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip250 <= main_usddrphy_bitslip25_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip252 <= 8'd0;
    case (main_usddrphy_bitslip25_value1)
        1'd0: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip252 <= main_usddrphy_bitslip25_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip260 <= 8'd0;
    case (main_usddrphy_bitslip26_value0)
        1'd0: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip260 <= main_usddrphy_bitslip26_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip262 <= 8'd0;
    case (main_usddrphy_bitslip26_value1)
        1'd0: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip262 <= main_usddrphy_bitslip26_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip270 <= 8'd0;
    case (main_usddrphy_bitslip27_value0)
        1'd0: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip270 <= main_usddrphy_bitslip27_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip272 <= 8'd0;
    case (main_usddrphy_bitslip27_value1)
        1'd0: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip272 <= main_usddrphy_bitslip27_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip280 <= 8'd0;
    case (main_usddrphy_bitslip28_value0)
        1'd0: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip280 <= main_usddrphy_bitslip28_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip282 <= 8'd0;
    case (main_usddrphy_bitslip28_value1)
        1'd0: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip282 <= main_usddrphy_bitslip28_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip290 <= 8'd0;
    case (main_usddrphy_bitslip29_value0)
        1'd0: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip290 <= main_usddrphy_bitslip29_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip292 <= 8'd0;
    case (main_usddrphy_bitslip29_value1)
        1'd0: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip292 <= main_usddrphy_bitslip29_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip300 <= 8'd0;
    case (main_usddrphy_bitslip30_value0)
        1'd0: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip300 <= main_usddrphy_bitslip30_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip302 <= 8'd0;
    case (main_usddrphy_bitslip30_value1)
        1'd0: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip302 <= main_usddrphy_bitslip30_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip310 <= 8'd0;
    case (main_usddrphy_bitslip31_value0)
        1'd0: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip310 <= main_usddrphy_bitslip31_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip312 <= 8'd0;
    case (main_usddrphy_bitslip31_value1)
        1'd0: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip312 <= main_usddrphy_bitslip31_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip320 <= 8'd0;
    case (main_usddrphy_bitslip32_value0)
        1'd0: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip320 <= main_usddrphy_bitslip32_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip322 <= 8'd0;
    case (main_usddrphy_bitslip32_value1)
        1'd0: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip322 <= main_usddrphy_bitslip32_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip330 <= 8'd0;
    case (main_usddrphy_bitslip33_value0)
        1'd0: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip330 <= main_usddrphy_bitslip33_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip332 <= 8'd0;
    case (main_usddrphy_bitslip33_value1)
        1'd0: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip332 <= main_usddrphy_bitslip33_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip340 <= 8'd0;
    case (main_usddrphy_bitslip34_value0)
        1'd0: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip340 <= main_usddrphy_bitslip34_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip342 <= 8'd0;
    case (main_usddrphy_bitslip34_value1)
        1'd0: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip342 <= main_usddrphy_bitslip34_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip350 <= 8'd0;
    case (main_usddrphy_bitslip35_value0)
        1'd0: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip350 <= main_usddrphy_bitslip35_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip352 <= 8'd0;
    case (main_usddrphy_bitslip35_value1)
        1'd0: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip352 <= main_usddrphy_bitslip35_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip360 <= 8'd0;
    case (main_usddrphy_bitslip36_value0)
        1'd0: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip360 <= main_usddrphy_bitslip36_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip362 <= 8'd0;
    case (main_usddrphy_bitslip36_value1)
        1'd0: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip362 <= main_usddrphy_bitslip36_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip370 <= 8'd0;
    case (main_usddrphy_bitslip37_value0)
        1'd0: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip370 <= main_usddrphy_bitslip37_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip372 <= 8'd0;
    case (main_usddrphy_bitslip37_value1)
        1'd0: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip372 <= main_usddrphy_bitslip37_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip380 <= 8'd0;
    case (main_usddrphy_bitslip38_value0)
        1'd0: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip380 <= main_usddrphy_bitslip38_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip382 <= 8'd0;
    case (main_usddrphy_bitslip38_value1)
        1'd0: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip382 <= main_usddrphy_bitslip38_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip390 <= 8'd0;
    case (main_usddrphy_bitslip39_value0)
        1'd0: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip390 <= main_usddrphy_bitslip39_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip392 <= 8'd0;
    case (main_usddrphy_bitslip39_value1)
        1'd0: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip392 <= main_usddrphy_bitslip39_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip400 <= 8'd0;
    case (main_usddrphy_bitslip40_value0)
        1'd0: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip400 <= main_usddrphy_bitslip40_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip402 <= 8'd0;
    case (main_usddrphy_bitslip40_value1)
        1'd0: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip402 <= main_usddrphy_bitslip40_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip410 <= 8'd0;
    case (main_usddrphy_bitslip41_value0)
        1'd0: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip410 <= main_usddrphy_bitslip41_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip412 <= 8'd0;
    case (main_usddrphy_bitslip41_value1)
        1'd0: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip412 <= main_usddrphy_bitslip41_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip420 <= 8'd0;
    case (main_usddrphy_bitslip42_value0)
        1'd0: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip420 <= main_usddrphy_bitslip42_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip422 <= 8'd0;
    case (main_usddrphy_bitslip42_value1)
        1'd0: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip422 <= main_usddrphy_bitslip42_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip430 <= 8'd0;
    case (main_usddrphy_bitslip43_value0)
        1'd0: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip430 <= main_usddrphy_bitslip43_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip432 <= 8'd0;
    case (main_usddrphy_bitslip43_value1)
        1'd0: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip432 <= main_usddrphy_bitslip43_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip440 <= 8'd0;
    case (main_usddrphy_bitslip44_value0)
        1'd0: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip440 <= main_usddrphy_bitslip44_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip442 <= 8'd0;
    case (main_usddrphy_bitslip44_value1)
        1'd0: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip442 <= main_usddrphy_bitslip44_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip450 <= 8'd0;
    case (main_usddrphy_bitslip45_value0)
        1'd0: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip450 <= main_usddrphy_bitslip45_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip452 <= 8'd0;
    case (main_usddrphy_bitslip45_value1)
        1'd0: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip452 <= main_usddrphy_bitslip45_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip460 <= 8'd0;
    case (main_usddrphy_bitslip46_value0)
        1'd0: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip460 <= main_usddrphy_bitslip46_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip462 <= 8'd0;
    case (main_usddrphy_bitslip46_value1)
        1'd0: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip462 <= main_usddrphy_bitslip46_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip470 <= 8'd0;
    case (main_usddrphy_bitslip47_value0)
        1'd0: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip470 <= main_usddrphy_bitslip47_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip472 <= 8'd0;
    case (main_usddrphy_bitslip47_value1)
        1'd0: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip472 <= main_usddrphy_bitslip47_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip480 <= 8'd0;
    case (main_usddrphy_bitslip48_value0)
        1'd0: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip480 <= main_usddrphy_bitslip48_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip482 <= 8'd0;
    case (main_usddrphy_bitslip48_value1)
        1'd0: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip482 <= main_usddrphy_bitslip48_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip490 <= 8'd0;
    case (main_usddrphy_bitslip49_value0)
        1'd0: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip490 <= main_usddrphy_bitslip49_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip492 <= 8'd0;
    case (main_usddrphy_bitslip49_value1)
        1'd0: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip492 <= main_usddrphy_bitslip49_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip500 <= 8'd0;
    case (main_usddrphy_bitslip50_value0)
        1'd0: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip500 <= main_usddrphy_bitslip50_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip502 <= 8'd0;
    case (main_usddrphy_bitslip50_value1)
        1'd0: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip502 <= main_usddrphy_bitslip50_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip510 <= 8'd0;
    case (main_usddrphy_bitslip51_value0)
        1'd0: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip510 <= main_usddrphy_bitslip51_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip512 <= 8'd0;
    case (main_usddrphy_bitslip51_value1)
        1'd0: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip512 <= main_usddrphy_bitslip51_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip520 <= 8'd0;
    case (main_usddrphy_bitslip52_value0)
        1'd0: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip520 <= main_usddrphy_bitslip52_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip522 <= 8'd0;
    case (main_usddrphy_bitslip52_value1)
        1'd0: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip522 <= main_usddrphy_bitslip52_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip530 <= 8'd0;
    case (main_usddrphy_bitslip53_value0)
        1'd0: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip530 <= main_usddrphy_bitslip53_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip532 <= 8'd0;
    case (main_usddrphy_bitslip53_value1)
        1'd0: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip532 <= main_usddrphy_bitslip53_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip540 <= 8'd0;
    case (main_usddrphy_bitslip54_value0)
        1'd0: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip540 <= main_usddrphy_bitslip54_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip542 <= 8'd0;
    case (main_usddrphy_bitslip54_value1)
        1'd0: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip542 <= main_usddrphy_bitslip54_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip550 <= 8'd0;
    case (main_usddrphy_bitslip55_value0)
        1'd0: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip550 <= main_usddrphy_bitslip55_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip552 <= 8'd0;
    case (main_usddrphy_bitslip55_value1)
        1'd0: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip552 <= main_usddrphy_bitslip55_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip560 <= 8'd0;
    case (main_usddrphy_bitslip56_value0)
        1'd0: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip560 <= main_usddrphy_bitslip56_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip562 <= 8'd0;
    case (main_usddrphy_bitslip56_value1)
        1'd0: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip562 <= main_usddrphy_bitslip56_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip570 <= 8'd0;
    case (main_usddrphy_bitslip57_value0)
        1'd0: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip570 <= main_usddrphy_bitslip57_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip572 <= 8'd0;
    case (main_usddrphy_bitslip57_value1)
        1'd0: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip572 <= main_usddrphy_bitslip57_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip580 <= 8'd0;
    case (main_usddrphy_bitslip58_value0)
        1'd0: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip580 <= main_usddrphy_bitslip58_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip582 <= 8'd0;
    case (main_usddrphy_bitslip58_value1)
        1'd0: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip582 <= main_usddrphy_bitslip58_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip590 <= 8'd0;
    case (main_usddrphy_bitslip59_value0)
        1'd0: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip590 <= main_usddrphy_bitslip59_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip592 <= 8'd0;
    case (main_usddrphy_bitslip59_value1)
        1'd0: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip592 <= main_usddrphy_bitslip59_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip600 <= 8'd0;
    case (main_usddrphy_bitslip60_value0)
        1'd0: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip600 <= main_usddrphy_bitslip60_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip602 <= 8'd0;
    case (main_usddrphy_bitslip60_value1)
        1'd0: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip602 <= main_usddrphy_bitslip60_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip610 <= 8'd0;
    case (main_usddrphy_bitslip61_value0)
        1'd0: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip610 <= main_usddrphy_bitslip61_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip612 <= 8'd0;
    case (main_usddrphy_bitslip61_value1)
        1'd0: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip612 <= main_usddrphy_bitslip61_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip620 <= 8'd0;
    case (main_usddrphy_bitslip62_value0)
        1'd0: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip620 <= main_usddrphy_bitslip62_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip622 <= 8'd0;
    case (main_usddrphy_bitslip62_value1)
        1'd0: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip622 <= main_usddrphy_bitslip62_r1[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip630 <= 8'd0;
    case (main_usddrphy_bitslip63_value0)
        1'd0: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip630 <= main_usddrphy_bitslip63_r0[15:8];
        end
    endcase
end
always @(*) begin
    main_usddrphy_bitslip632 <= 8'd0;
    case (main_usddrphy_bitslip63_value1)
        1'd0: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[8:1];
        end
        1'd1: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[9:2];
        end
        2'd2: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[10:3];
        end
        2'd3: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[11:4];
        end
        3'd4: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[12:5];
        end
        3'd5: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[13:6];
        end
        3'd6: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[14:7];
        end
        3'd7: begin
            main_usddrphy_bitslip632 <= main_usddrphy_bitslip63_r1[15:8];
        end
    endcase
end
assign main_usddrphy_interface0_dfi_p0_address = main_sdram_master_p0_address;
assign main_usddrphy_interface0_dfi_p0_bank = main_sdram_master_p0_bank;
assign main_usddrphy_interface0_dfi_p0_cas_n = main_sdram_master_p0_cas_n;
assign main_usddrphy_interface0_dfi_p0_cs_n = main_sdram_master_p0_cs_n;
assign main_usddrphy_interface0_dfi_p0_ras_n = main_sdram_master_p0_ras_n;
assign main_usddrphy_interface0_dfi_p0_we_n = main_sdram_master_p0_we_n;
assign main_usddrphy_interface0_dfi_p0_cke = main_sdram_master_p0_cke;
assign main_usddrphy_interface0_dfi_p0_odt = main_sdram_master_p0_odt;
assign main_usddrphy_interface0_dfi_p0_reset_n = main_sdram_master_p0_reset_n;
assign main_usddrphy_interface0_dfi_p0_act_n = main_sdram_master_p0_act_n;
assign main_usddrphy_interface0_dfi_p0_wrdata = main_sdram_master_p0_wrdata;
assign main_usddrphy_interface0_dfi_p0_wrdata_en = main_sdram_master_p0_wrdata_en;
assign main_usddrphy_interface0_dfi_p0_wrdata_mask = main_sdram_master_p0_wrdata_mask;
assign main_usddrphy_interface0_dfi_p0_rddata_en = main_sdram_master_p0_rddata_en;
assign main_sdram_master_p0_rddata = main_usddrphy_interface0_dfi_p0_rddata;
assign main_sdram_master_p0_rddata_valid = main_usddrphy_interface0_dfi_p0_rddata_valid;
assign main_usddrphy_interface0_dfi_p1_address = main_sdram_master_p1_address;
assign main_usddrphy_interface0_dfi_p1_bank = main_sdram_master_p1_bank;
assign main_usddrphy_interface0_dfi_p1_cas_n = main_sdram_master_p1_cas_n;
assign main_usddrphy_interface0_dfi_p1_cs_n = main_sdram_master_p1_cs_n;
assign main_usddrphy_interface0_dfi_p1_ras_n = main_sdram_master_p1_ras_n;
assign main_usddrphy_interface0_dfi_p1_we_n = main_sdram_master_p1_we_n;
assign main_usddrphy_interface0_dfi_p1_cke = main_sdram_master_p1_cke;
assign main_usddrphy_interface0_dfi_p1_odt = main_sdram_master_p1_odt;
assign main_usddrphy_interface0_dfi_p1_reset_n = main_sdram_master_p1_reset_n;
assign main_usddrphy_interface0_dfi_p1_act_n = main_sdram_master_p1_act_n;
assign main_usddrphy_interface0_dfi_p1_wrdata = main_sdram_master_p1_wrdata;
assign main_usddrphy_interface0_dfi_p1_wrdata_en = main_sdram_master_p1_wrdata_en;
assign main_usddrphy_interface0_dfi_p1_wrdata_mask = main_sdram_master_p1_wrdata_mask;
assign main_usddrphy_interface0_dfi_p1_rddata_en = main_sdram_master_p1_rddata_en;
assign main_sdram_master_p1_rddata = main_usddrphy_interface0_dfi_p1_rddata;
assign main_sdram_master_p1_rddata_valid = main_usddrphy_interface0_dfi_p1_rddata_valid;
assign main_usddrphy_interface0_dfi_p2_address = main_sdram_master_p2_address;
assign main_usddrphy_interface0_dfi_p2_bank = main_sdram_master_p2_bank;
assign main_usddrphy_interface0_dfi_p2_cas_n = main_sdram_master_p2_cas_n;
assign main_usddrphy_interface0_dfi_p2_cs_n = main_sdram_master_p2_cs_n;
assign main_usddrphy_interface0_dfi_p2_ras_n = main_sdram_master_p2_ras_n;
assign main_usddrphy_interface0_dfi_p2_we_n = main_sdram_master_p2_we_n;
assign main_usddrphy_interface0_dfi_p2_cke = main_sdram_master_p2_cke;
assign main_usddrphy_interface0_dfi_p2_odt = main_sdram_master_p2_odt;
assign main_usddrphy_interface0_dfi_p2_reset_n = main_sdram_master_p2_reset_n;
assign main_usddrphy_interface0_dfi_p2_act_n = main_sdram_master_p2_act_n;
assign main_usddrphy_interface0_dfi_p2_wrdata = main_sdram_master_p2_wrdata;
assign main_usddrphy_interface0_dfi_p2_wrdata_en = main_sdram_master_p2_wrdata_en;
assign main_usddrphy_interface0_dfi_p2_wrdata_mask = main_sdram_master_p2_wrdata_mask;
assign main_usddrphy_interface0_dfi_p2_rddata_en = main_sdram_master_p2_rddata_en;
assign main_sdram_master_p2_rddata = main_usddrphy_interface0_dfi_p2_rddata;
assign main_sdram_master_p2_rddata_valid = main_usddrphy_interface0_dfi_p2_rddata_valid;
assign main_usddrphy_interface0_dfi_p3_address = main_sdram_master_p3_address;
assign main_usddrphy_interface0_dfi_p3_bank = main_sdram_master_p3_bank;
assign main_usddrphy_interface0_dfi_p3_cas_n = main_sdram_master_p3_cas_n;
assign main_usddrphy_interface0_dfi_p3_cs_n = main_sdram_master_p3_cs_n;
assign main_usddrphy_interface0_dfi_p3_ras_n = main_sdram_master_p3_ras_n;
assign main_usddrphy_interface0_dfi_p3_we_n = main_sdram_master_p3_we_n;
assign main_usddrphy_interface0_dfi_p3_cke = main_sdram_master_p3_cke;
assign main_usddrphy_interface0_dfi_p3_odt = main_sdram_master_p3_odt;
assign main_usddrphy_interface0_dfi_p3_reset_n = main_sdram_master_p3_reset_n;
assign main_usddrphy_interface0_dfi_p3_act_n = main_sdram_master_p3_act_n;
assign main_usddrphy_interface0_dfi_p3_wrdata = main_sdram_master_p3_wrdata;
assign main_usddrphy_interface0_dfi_p3_wrdata_en = main_sdram_master_p3_wrdata_en;
assign main_usddrphy_interface0_dfi_p3_wrdata_mask = main_sdram_master_p3_wrdata_mask;
assign main_usddrphy_interface0_dfi_p3_rddata_en = main_sdram_master_p3_rddata_en;
assign main_sdram_master_p3_rddata = main_usddrphy_interface0_dfi_p3_rddata;
assign main_sdram_master_p3_rddata_valid = main_usddrphy_interface0_dfi_p3_rddata_valid;
assign main_sdram_slave_p0_address = main_sdram_dfi_p0_address;
assign main_sdram_slave_p0_bank = main_sdram_dfi_p0_bank;
assign main_sdram_slave_p0_cas_n = main_sdram_dfi_p0_cas_n;
assign main_sdram_slave_p0_cs_n = main_sdram_dfi_p0_cs_n;
assign main_sdram_slave_p0_ras_n = main_sdram_dfi_p0_ras_n;
assign main_sdram_slave_p0_we_n = main_sdram_dfi_p0_we_n;
assign main_sdram_slave_p0_cke = main_sdram_dfi_p0_cke;
assign main_sdram_slave_p0_odt = main_sdram_dfi_p0_odt;
assign main_sdram_slave_p0_reset_n = main_sdram_dfi_p0_reset_n;
assign main_sdram_slave_p0_act_n = main_sdram_dfi_p0_act_n;
assign main_sdram_slave_p0_wrdata = main_sdram_dfi_p0_wrdata;
assign main_sdram_slave_p0_wrdata_en = main_sdram_dfi_p0_wrdata_en;
assign main_sdram_slave_p0_wrdata_mask = main_sdram_dfi_p0_wrdata_mask;
assign main_sdram_slave_p0_rddata_en = main_sdram_dfi_p0_rddata_en;
assign main_sdram_dfi_p0_rddata = main_sdram_slave_p0_rddata;
assign main_sdram_dfi_p0_rddata_valid = main_sdram_slave_p0_rddata_valid;
assign main_sdram_slave_p1_address = main_sdram_dfi_p1_address;
assign main_sdram_slave_p1_bank = main_sdram_dfi_p1_bank;
assign main_sdram_slave_p1_cas_n = main_sdram_dfi_p1_cas_n;
assign main_sdram_slave_p1_cs_n = main_sdram_dfi_p1_cs_n;
assign main_sdram_slave_p1_ras_n = main_sdram_dfi_p1_ras_n;
assign main_sdram_slave_p1_we_n = main_sdram_dfi_p1_we_n;
assign main_sdram_slave_p1_cke = main_sdram_dfi_p1_cke;
assign main_sdram_slave_p1_odt = main_sdram_dfi_p1_odt;
assign main_sdram_slave_p1_reset_n = main_sdram_dfi_p1_reset_n;
assign main_sdram_slave_p1_act_n = main_sdram_dfi_p1_act_n;
assign main_sdram_slave_p1_wrdata = main_sdram_dfi_p1_wrdata;
assign main_sdram_slave_p1_wrdata_en = main_sdram_dfi_p1_wrdata_en;
assign main_sdram_slave_p1_wrdata_mask = main_sdram_dfi_p1_wrdata_mask;
assign main_sdram_slave_p1_rddata_en = main_sdram_dfi_p1_rddata_en;
assign main_sdram_dfi_p1_rddata = main_sdram_slave_p1_rddata;
assign main_sdram_dfi_p1_rddata_valid = main_sdram_slave_p1_rddata_valid;
assign main_sdram_slave_p2_address = main_sdram_dfi_p2_address;
assign main_sdram_slave_p2_bank = main_sdram_dfi_p2_bank;
assign main_sdram_slave_p2_cas_n = main_sdram_dfi_p2_cas_n;
assign main_sdram_slave_p2_cs_n = main_sdram_dfi_p2_cs_n;
assign main_sdram_slave_p2_ras_n = main_sdram_dfi_p2_ras_n;
assign main_sdram_slave_p2_we_n = main_sdram_dfi_p2_we_n;
assign main_sdram_slave_p2_cke = main_sdram_dfi_p2_cke;
assign main_sdram_slave_p2_odt = main_sdram_dfi_p2_odt;
assign main_sdram_slave_p2_reset_n = main_sdram_dfi_p2_reset_n;
assign main_sdram_slave_p2_act_n = main_sdram_dfi_p2_act_n;
assign main_sdram_slave_p2_wrdata = main_sdram_dfi_p2_wrdata;
assign main_sdram_slave_p2_wrdata_en = main_sdram_dfi_p2_wrdata_en;
assign main_sdram_slave_p2_wrdata_mask = main_sdram_dfi_p2_wrdata_mask;
assign main_sdram_slave_p2_rddata_en = main_sdram_dfi_p2_rddata_en;
assign main_sdram_dfi_p2_rddata = main_sdram_slave_p2_rddata;
assign main_sdram_dfi_p2_rddata_valid = main_sdram_slave_p2_rddata_valid;
assign main_sdram_slave_p3_address = main_sdram_dfi_p3_address;
assign main_sdram_slave_p3_bank = main_sdram_dfi_p3_bank;
assign main_sdram_slave_p3_cas_n = main_sdram_dfi_p3_cas_n;
assign main_sdram_slave_p3_cs_n = main_sdram_dfi_p3_cs_n;
assign main_sdram_slave_p3_ras_n = main_sdram_dfi_p3_ras_n;
assign main_sdram_slave_p3_we_n = main_sdram_dfi_p3_we_n;
assign main_sdram_slave_p3_cke = main_sdram_dfi_p3_cke;
assign main_sdram_slave_p3_odt = main_sdram_dfi_p3_odt;
assign main_sdram_slave_p3_reset_n = main_sdram_dfi_p3_reset_n;
assign main_sdram_slave_p3_act_n = main_sdram_dfi_p3_act_n;
assign main_sdram_slave_p3_wrdata = main_sdram_dfi_p3_wrdata;
assign main_sdram_slave_p3_wrdata_en = main_sdram_dfi_p3_wrdata_en;
assign main_sdram_slave_p3_wrdata_mask = main_sdram_dfi_p3_wrdata_mask;
assign main_sdram_slave_p3_rddata_en = main_sdram_dfi_p3_rddata_en;
assign main_sdram_dfi_p3_rddata = main_sdram_slave_p3_rddata;
assign main_sdram_dfi_p3_rddata_valid = main_sdram_slave_p3_rddata_valid;
always @(*) begin
    main_sdram_master_p2_address <= 15'd0;
    main_sdram_master_p2_bank <= 3'd0;
    main_sdram_master_p2_cas_n <= 1'd1;
    main_sdram_ext_dfi_p0_rddata <= 128'd0;
    main_sdram_master_p2_cs_n <= 1'd1;
    main_sdram_ext_dfi_p0_rddata_valid <= 1'd0;
    main_sdram_master_p2_ras_n <= 1'd1;
    main_sdram_master_p2_we_n <= 1'd1;
    main_sdram_master_p2_cke <= 1'd0;
    main_sdram_master_p2_odt <= 1'd0;
    main_sdram_master_p2_reset_n <= 1'd0;
    main_sdram_master_p2_act_n <= 1'd1;
    main_sdram_master_p2_wrdata <= 128'd0;
    main_sdram_master_p2_wrdata_en <= 1'd0;
    main_sdram_master_p2_wrdata_mask <= 16'd0;
    main_sdram_master_p2_rddata_en <= 1'd0;
    main_sdram_master_p3_address <= 15'd0;
    main_sdram_master_p3_bank <= 3'd0;
    main_sdram_master_p3_cas_n <= 1'd1;
    main_sdram_ext_dfi_p1_rddata <= 128'd0;
    main_sdram_master_p3_cs_n <= 1'd1;
    main_sdram_ext_dfi_p1_rddata_valid <= 1'd0;
    main_sdram_master_p3_ras_n <= 1'd1;
    main_sdram_master_p3_we_n <= 1'd1;
    main_sdram_master_p3_cke <= 1'd0;
    main_sdram_master_p3_odt <= 1'd0;
    main_sdram_master_p3_reset_n <= 1'd0;
    main_sdram_master_p3_act_n <= 1'd1;
    main_sdram_master_p3_wrdata <= 128'd0;
    main_sdram_master_p3_wrdata_en <= 1'd0;
    main_sdram_master_p3_wrdata_mask <= 16'd0;
    main_sdram_master_p3_rddata_en <= 1'd0;
    main_sdram_ext_dfi_p2_rddata <= 128'd0;
    main_sdram_ext_dfi_p2_rddata_valid <= 1'd0;
    main_sdram_slave_p0_rddata <= 128'd0;
    main_sdram_slave_p0_rddata_valid <= 1'd0;
    main_sdram_ext_dfi_p3_rddata <= 128'd0;
    main_sdram_ext_dfi_p3_rddata_valid <= 1'd0;
    main_sdram_slave_p1_rddata <= 128'd0;
    main_sdram_slave_p1_rddata_valid <= 1'd0;
    main_sdram_csr_dfi_p0_rddata <= 128'd0;
    main_sdram_csr_dfi_p0_rddata_valid <= 1'd0;
    main_sdram_slave_p2_rddata <= 128'd0;
    main_sdram_slave_p2_rddata_valid <= 1'd0;
    main_sdram_csr_dfi_p1_rddata <= 128'd0;
    main_sdram_csr_dfi_p1_rddata_valid <= 1'd0;
    main_sdram_slave_p3_rddata <= 128'd0;
    main_sdram_slave_p3_rddata_valid <= 1'd0;
    main_sdram_csr_dfi_p2_rddata <= 128'd0;
    main_sdram_csr_dfi_p2_rddata_valid <= 1'd0;
    main_sdram_master_p0_address <= 15'd0;
    main_sdram_master_p0_bank <= 3'd0;
    main_sdram_master_p0_cas_n <= 1'd1;
    main_sdram_master_p0_cs_n <= 1'd1;
    main_sdram_master_p0_ras_n <= 1'd1;
    main_sdram_master_p0_we_n <= 1'd1;
    main_sdram_master_p0_cke <= 1'd0;
    main_sdram_master_p0_odt <= 1'd0;
    main_sdram_csr_dfi_p3_rddata <= 128'd0;
    main_sdram_master_p0_reset_n <= 1'd0;
    main_sdram_csr_dfi_p3_rddata_valid <= 1'd0;
    main_sdram_master_p0_act_n <= 1'd1;
    main_sdram_master_p0_wrdata <= 128'd0;
    main_sdram_master_p0_wrdata_en <= 1'd0;
    main_sdram_master_p0_wrdata_mask <= 16'd0;
    main_sdram_master_p0_rddata_en <= 1'd0;
    main_sdram_master_p1_address <= 15'd0;
    main_sdram_master_p1_bank <= 3'd0;
    main_sdram_master_p1_cas_n <= 1'd1;
    main_sdram_master_p1_cs_n <= 1'd1;
    main_sdram_master_p1_ras_n <= 1'd1;
    main_sdram_master_p1_we_n <= 1'd1;
    main_sdram_master_p1_cke <= 1'd0;
    main_sdram_master_p1_odt <= 1'd0;
    main_sdram_master_p1_reset_n <= 1'd0;
    main_sdram_master_p1_act_n <= 1'd1;
    main_sdram_master_p1_wrdata <= 128'd0;
    main_sdram_master_p1_wrdata_en <= 1'd0;
    main_sdram_master_p1_wrdata_mask <= 16'd0;
    main_sdram_master_p1_rddata_en <= 1'd0;
    if (main_sdram_sel) begin
        if (main_sdram_ext_dfi_sel) begin
            main_sdram_master_p0_address <= main_sdram_ext_dfi_p0_address;
            main_sdram_master_p0_bank <= main_sdram_ext_dfi_p0_bank;
            main_sdram_master_p0_cas_n <= main_sdram_ext_dfi_p0_cas_n;
            main_sdram_master_p0_cs_n <= main_sdram_ext_dfi_p0_cs_n;
            main_sdram_master_p0_ras_n <= main_sdram_ext_dfi_p0_ras_n;
            main_sdram_master_p0_we_n <= main_sdram_ext_dfi_p0_we_n;
            main_sdram_master_p0_cke <= main_sdram_ext_dfi_p0_cke;
            main_sdram_master_p0_odt <= main_sdram_ext_dfi_p0_odt;
            main_sdram_master_p0_reset_n <= main_sdram_ext_dfi_p0_reset_n;
            main_sdram_master_p0_act_n <= main_sdram_ext_dfi_p0_act_n;
            main_sdram_master_p0_wrdata <= main_sdram_ext_dfi_p0_wrdata;
            main_sdram_master_p0_wrdata_en <= main_sdram_ext_dfi_p0_wrdata_en;
            main_sdram_master_p0_wrdata_mask <= main_sdram_ext_dfi_p0_wrdata_mask;
            main_sdram_master_p0_rddata_en <= main_sdram_ext_dfi_p0_rddata_en;
            main_sdram_ext_dfi_p0_rddata <= main_sdram_master_p0_rddata;
            main_sdram_ext_dfi_p0_rddata_valid <= main_sdram_master_p0_rddata_valid;
            main_sdram_master_p1_address <= main_sdram_ext_dfi_p1_address;
            main_sdram_master_p1_bank <= main_sdram_ext_dfi_p1_bank;
            main_sdram_master_p1_cas_n <= main_sdram_ext_dfi_p1_cas_n;
            main_sdram_master_p1_cs_n <= main_sdram_ext_dfi_p1_cs_n;
            main_sdram_master_p1_ras_n <= main_sdram_ext_dfi_p1_ras_n;
            main_sdram_master_p1_we_n <= main_sdram_ext_dfi_p1_we_n;
            main_sdram_master_p1_cke <= main_sdram_ext_dfi_p1_cke;
            main_sdram_master_p1_odt <= main_sdram_ext_dfi_p1_odt;
            main_sdram_master_p1_reset_n <= main_sdram_ext_dfi_p1_reset_n;
            main_sdram_master_p1_act_n <= main_sdram_ext_dfi_p1_act_n;
            main_sdram_master_p1_wrdata <= main_sdram_ext_dfi_p1_wrdata;
            main_sdram_master_p1_wrdata_en <= main_sdram_ext_dfi_p1_wrdata_en;
            main_sdram_master_p1_wrdata_mask <= main_sdram_ext_dfi_p1_wrdata_mask;
            main_sdram_master_p1_rddata_en <= main_sdram_ext_dfi_p1_rddata_en;
            main_sdram_ext_dfi_p1_rddata <= main_sdram_master_p1_rddata;
            main_sdram_ext_dfi_p1_rddata_valid <= main_sdram_master_p1_rddata_valid;
            main_sdram_master_p2_address <= main_sdram_ext_dfi_p2_address;
            main_sdram_master_p2_bank <= main_sdram_ext_dfi_p2_bank;
            main_sdram_master_p2_cas_n <= main_sdram_ext_dfi_p2_cas_n;
            main_sdram_master_p2_cs_n <= main_sdram_ext_dfi_p2_cs_n;
            main_sdram_master_p2_ras_n <= main_sdram_ext_dfi_p2_ras_n;
            main_sdram_master_p2_we_n <= main_sdram_ext_dfi_p2_we_n;
            main_sdram_master_p2_cke <= main_sdram_ext_dfi_p2_cke;
            main_sdram_master_p2_odt <= main_sdram_ext_dfi_p2_odt;
            main_sdram_master_p2_reset_n <= main_sdram_ext_dfi_p2_reset_n;
            main_sdram_master_p2_act_n <= main_sdram_ext_dfi_p2_act_n;
            main_sdram_master_p2_wrdata <= main_sdram_ext_dfi_p2_wrdata;
            main_sdram_master_p2_wrdata_en <= main_sdram_ext_dfi_p2_wrdata_en;
            main_sdram_master_p2_wrdata_mask <= main_sdram_ext_dfi_p2_wrdata_mask;
            main_sdram_master_p2_rddata_en <= main_sdram_ext_dfi_p2_rddata_en;
            main_sdram_ext_dfi_p2_rddata <= main_sdram_master_p2_rddata;
            main_sdram_ext_dfi_p2_rddata_valid <= main_sdram_master_p2_rddata_valid;
            main_sdram_master_p3_address <= main_sdram_ext_dfi_p3_address;
            main_sdram_master_p3_bank <= main_sdram_ext_dfi_p3_bank;
            main_sdram_master_p3_cas_n <= main_sdram_ext_dfi_p3_cas_n;
            main_sdram_master_p3_cs_n <= main_sdram_ext_dfi_p3_cs_n;
            main_sdram_master_p3_ras_n <= main_sdram_ext_dfi_p3_ras_n;
            main_sdram_master_p3_we_n <= main_sdram_ext_dfi_p3_we_n;
            main_sdram_master_p3_cke <= main_sdram_ext_dfi_p3_cke;
            main_sdram_master_p3_odt <= main_sdram_ext_dfi_p3_odt;
            main_sdram_master_p3_reset_n <= main_sdram_ext_dfi_p3_reset_n;
            main_sdram_master_p3_act_n <= main_sdram_ext_dfi_p3_act_n;
            main_sdram_master_p3_wrdata <= main_sdram_ext_dfi_p3_wrdata;
            main_sdram_master_p3_wrdata_en <= main_sdram_ext_dfi_p3_wrdata_en;
            main_sdram_master_p3_wrdata_mask <= main_sdram_ext_dfi_p3_wrdata_mask;
            main_sdram_master_p3_rddata_en <= main_sdram_ext_dfi_p3_rddata_en;
            main_sdram_ext_dfi_p3_rddata <= main_sdram_master_p3_rddata;
            main_sdram_ext_dfi_p3_rddata_valid <= main_sdram_master_p3_rddata_valid;
        end else begin
            main_sdram_master_p0_address <= main_sdram_slave_p0_address;
            main_sdram_master_p0_bank <= main_sdram_slave_p0_bank;
            main_sdram_master_p0_cas_n <= main_sdram_slave_p0_cas_n;
            main_sdram_master_p0_cs_n <= main_sdram_slave_p0_cs_n;
            main_sdram_master_p0_ras_n <= main_sdram_slave_p0_ras_n;
            main_sdram_master_p0_we_n <= main_sdram_slave_p0_we_n;
            main_sdram_master_p0_cke <= main_sdram_slave_p0_cke;
            main_sdram_master_p0_odt <= main_sdram_slave_p0_odt;
            main_sdram_master_p0_reset_n <= main_sdram_slave_p0_reset_n;
            main_sdram_master_p0_act_n <= main_sdram_slave_p0_act_n;
            main_sdram_master_p0_wrdata <= main_sdram_slave_p0_wrdata;
            main_sdram_master_p0_wrdata_en <= main_sdram_slave_p0_wrdata_en;
            main_sdram_master_p0_wrdata_mask <= main_sdram_slave_p0_wrdata_mask;
            main_sdram_master_p0_rddata_en <= main_sdram_slave_p0_rddata_en;
            main_sdram_slave_p0_rddata <= main_sdram_master_p0_rddata;
            main_sdram_slave_p0_rddata_valid <= main_sdram_master_p0_rddata_valid;
            main_sdram_master_p1_address <= main_sdram_slave_p1_address;
            main_sdram_master_p1_bank <= main_sdram_slave_p1_bank;
            main_sdram_master_p1_cas_n <= main_sdram_slave_p1_cas_n;
            main_sdram_master_p1_cs_n <= main_sdram_slave_p1_cs_n;
            main_sdram_master_p1_ras_n <= main_sdram_slave_p1_ras_n;
            main_sdram_master_p1_we_n <= main_sdram_slave_p1_we_n;
            main_sdram_master_p1_cke <= main_sdram_slave_p1_cke;
            main_sdram_master_p1_odt <= main_sdram_slave_p1_odt;
            main_sdram_master_p1_reset_n <= main_sdram_slave_p1_reset_n;
            main_sdram_master_p1_act_n <= main_sdram_slave_p1_act_n;
            main_sdram_master_p1_wrdata <= main_sdram_slave_p1_wrdata;
            main_sdram_master_p1_wrdata_en <= main_sdram_slave_p1_wrdata_en;
            main_sdram_master_p1_wrdata_mask <= main_sdram_slave_p1_wrdata_mask;
            main_sdram_master_p1_rddata_en <= main_sdram_slave_p1_rddata_en;
            main_sdram_slave_p1_rddata <= main_sdram_master_p1_rddata;
            main_sdram_slave_p1_rddata_valid <= main_sdram_master_p1_rddata_valid;
            main_sdram_master_p2_address <= main_sdram_slave_p2_address;
            main_sdram_master_p2_bank <= main_sdram_slave_p2_bank;
            main_sdram_master_p2_cas_n <= main_sdram_slave_p2_cas_n;
            main_sdram_master_p2_cs_n <= main_sdram_slave_p2_cs_n;
            main_sdram_master_p2_ras_n <= main_sdram_slave_p2_ras_n;
            main_sdram_master_p2_we_n <= main_sdram_slave_p2_we_n;
            main_sdram_master_p2_cke <= main_sdram_slave_p2_cke;
            main_sdram_master_p2_odt <= main_sdram_slave_p2_odt;
            main_sdram_master_p2_reset_n <= main_sdram_slave_p2_reset_n;
            main_sdram_master_p2_act_n <= main_sdram_slave_p2_act_n;
            main_sdram_master_p2_wrdata <= main_sdram_slave_p2_wrdata;
            main_sdram_master_p2_wrdata_en <= main_sdram_slave_p2_wrdata_en;
            main_sdram_master_p2_wrdata_mask <= main_sdram_slave_p2_wrdata_mask;
            main_sdram_master_p2_rddata_en <= main_sdram_slave_p2_rddata_en;
            main_sdram_slave_p2_rddata <= main_sdram_master_p2_rddata;
            main_sdram_slave_p2_rddata_valid <= main_sdram_master_p2_rddata_valid;
            main_sdram_master_p3_address <= main_sdram_slave_p3_address;
            main_sdram_master_p3_bank <= main_sdram_slave_p3_bank;
            main_sdram_master_p3_cas_n <= main_sdram_slave_p3_cas_n;
            main_sdram_master_p3_cs_n <= main_sdram_slave_p3_cs_n;
            main_sdram_master_p3_ras_n <= main_sdram_slave_p3_ras_n;
            main_sdram_master_p3_we_n <= main_sdram_slave_p3_we_n;
            main_sdram_master_p3_cke <= main_sdram_slave_p3_cke;
            main_sdram_master_p3_odt <= main_sdram_slave_p3_odt;
            main_sdram_master_p3_reset_n <= main_sdram_slave_p3_reset_n;
            main_sdram_master_p3_act_n <= main_sdram_slave_p3_act_n;
            main_sdram_master_p3_wrdata <= main_sdram_slave_p3_wrdata;
            main_sdram_master_p3_wrdata_en <= main_sdram_slave_p3_wrdata_en;
            main_sdram_master_p3_wrdata_mask <= main_sdram_slave_p3_wrdata_mask;
            main_sdram_master_p3_rddata_en <= main_sdram_slave_p3_rddata_en;
            main_sdram_slave_p3_rddata <= main_sdram_master_p3_rddata;
            main_sdram_slave_p3_rddata_valid <= main_sdram_master_p3_rddata_valid;
            if (1'd0) begin
                main_sdram_master_p0_cs_n <= {2{main_sdram_slave_p0_cs_n}};
                main_sdram_master_p1_cs_n <= {2{main_sdram_slave_p1_cs_n}};
                main_sdram_master_p2_cs_n <= {2{main_sdram_slave_p2_cs_n}};
                main_sdram_master_p3_cs_n <= {2{main_sdram_slave_p3_cs_n}};
            end
        end
    end else begin
        main_sdram_master_p0_address <= main_sdram_csr_dfi_p0_address;
        main_sdram_master_p0_bank <= main_sdram_csr_dfi_p0_bank;
        main_sdram_master_p0_cas_n <= main_sdram_csr_dfi_p0_cas_n;
        main_sdram_master_p0_cs_n <= main_sdram_csr_dfi_p0_cs_n;
        main_sdram_master_p0_ras_n <= main_sdram_csr_dfi_p0_ras_n;
        main_sdram_master_p0_we_n <= main_sdram_csr_dfi_p0_we_n;
        main_sdram_master_p0_cke <= main_sdram_csr_dfi_p0_cke;
        main_sdram_master_p0_odt <= main_sdram_csr_dfi_p0_odt;
        main_sdram_master_p0_reset_n <= main_sdram_csr_dfi_p0_reset_n;
        main_sdram_master_p0_act_n <= main_sdram_csr_dfi_p0_act_n;
        main_sdram_master_p0_wrdata <= main_sdram_csr_dfi_p0_wrdata;
        main_sdram_master_p0_wrdata_en <= main_sdram_csr_dfi_p0_wrdata_en;
        main_sdram_master_p0_wrdata_mask <= main_sdram_csr_dfi_p0_wrdata_mask;
        main_sdram_master_p0_rddata_en <= main_sdram_csr_dfi_p0_rddata_en;
        main_sdram_csr_dfi_p0_rddata <= main_sdram_master_p0_rddata;
        main_sdram_csr_dfi_p0_rddata_valid <= main_sdram_master_p0_rddata_valid;
        main_sdram_master_p1_address <= main_sdram_csr_dfi_p1_address;
        main_sdram_master_p1_bank <= main_sdram_csr_dfi_p1_bank;
        main_sdram_master_p1_cas_n <= main_sdram_csr_dfi_p1_cas_n;
        main_sdram_master_p1_cs_n <= main_sdram_csr_dfi_p1_cs_n;
        main_sdram_master_p1_ras_n <= main_sdram_csr_dfi_p1_ras_n;
        main_sdram_master_p1_we_n <= main_sdram_csr_dfi_p1_we_n;
        main_sdram_master_p1_cke <= main_sdram_csr_dfi_p1_cke;
        main_sdram_master_p1_odt <= main_sdram_csr_dfi_p1_odt;
        main_sdram_master_p1_reset_n <= main_sdram_csr_dfi_p1_reset_n;
        main_sdram_master_p1_act_n <= main_sdram_csr_dfi_p1_act_n;
        main_sdram_master_p1_wrdata <= main_sdram_csr_dfi_p1_wrdata;
        main_sdram_master_p1_wrdata_en <= main_sdram_csr_dfi_p1_wrdata_en;
        main_sdram_master_p1_wrdata_mask <= main_sdram_csr_dfi_p1_wrdata_mask;
        main_sdram_master_p1_rddata_en <= main_sdram_csr_dfi_p1_rddata_en;
        main_sdram_csr_dfi_p1_rddata <= main_sdram_master_p1_rddata;
        main_sdram_csr_dfi_p1_rddata_valid <= main_sdram_master_p1_rddata_valid;
        main_sdram_master_p2_address <= main_sdram_csr_dfi_p2_address;
        main_sdram_master_p2_bank <= main_sdram_csr_dfi_p2_bank;
        main_sdram_master_p2_cas_n <= main_sdram_csr_dfi_p2_cas_n;
        main_sdram_master_p2_cs_n <= main_sdram_csr_dfi_p2_cs_n;
        main_sdram_master_p2_ras_n <= main_sdram_csr_dfi_p2_ras_n;
        main_sdram_master_p2_we_n <= main_sdram_csr_dfi_p2_we_n;
        main_sdram_master_p2_cke <= main_sdram_csr_dfi_p2_cke;
        main_sdram_master_p2_odt <= main_sdram_csr_dfi_p2_odt;
        main_sdram_master_p2_reset_n <= main_sdram_csr_dfi_p2_reset_n;
        main_sdram_master_p2_act_n <= main_sdram_csr_dfi_p2_act_n;
        main_sdram_master_p2_wrdata <= main_sdram_csr_dfi_p2_wrdata;
        main_sdram_master_p2_wrdata_en <= main_sdram_csr_dfi_p2_wrdata_en;
        main_sdram_master_p2_wrdata_mask <= main_sdram_csr_dfi_p2_wrdata_mask;
        main_sdram_master_p2_rddata_en <= main_sdram_csr_dfi_p2_rddata_en;
        main_sdram_csr_dfi_p2_rddata <= main_sdram_master_p2_rddata;
        main_sdram_csr_dfi_p2_rddata_valid <= main_sdram_master_p2_rddata_valid;
        main_sdram_master_p3_address <= main_sdram_csr_dfi_p3_address;
        main_sdram_master_p3_bank <= main_sdram_csr_dfi_p3_bank;
        main_sdram_master_p3_cas_n <= main_sdram_csr_dfi_p3_cas_n;
        main_sdram_master_p3_cs_n <= main_sdram_csr_dfi_p3_cs_n;
        main_sdram_master_p3_ras_n <= main_sdram_csr_dfi_p3_ras_n;
        main_sdram_master_p3_we_n <= main_sdram_csr_dfi_p3_we_n;
        main_sdram_master_p3_cke <= main_sdram_csr_dfi_p3_cke;
        main_sdram_master_p3_odt <= main_sdram_csr_dfi_p3_odt;
        main_sdram_master_p3_reset_n <= main_sdram_csr_dfi_p3_reset_n;
        main_sdram_master_p3_act_n <= main_sdram_csr_dfi_p3_act_n;
        main_sdram_master_p3_wrdata <= main_sdram_csr_dfi_p3_wrdata;
        main_sdram_master_p3_wrdata_en <= main_sdram_csr_dfi_p3_wrdata_en;
        main_sdram_master_p3_wrdata_mask <= main_sdram_csr_dfi_p3_wrdata_mask;
        main_sdram_master_p3_rddata_en <= main_sdram_csr_dfi_p3_rddata_en;
        main_sdram_csr_dfi_p3_rddata <= main_sdram_master_p3_rddata;
        main_sdram_csr_dfi_p3_rddata_valid <= main_sdram_master_p3_rddata_valid;
    end
end
assign main_sdram_csr_dfi_p0_cke = main_sdram_cke;
assign main_sdram_csr_dfi_p1_cke = main_sdram_cke;
assign main_sdram_csr_dfi_p2_cke = main_sdram_cke;
assign main_sdram_csr_dfi_p3_cke = main_sdram_cke;
assign main_sdram_csr_dfi_p0_odt = main_sdram_odt;
assign main_sdram_csr_dfi_p1_odt = main_sdram_odt;
assign main_sdram_csr_dfi_p2_odt = main_sdram_odt;
assign main_sdram_csr_dfi_p3_odt = main_sdram_odt;
assign main_sdram_csr_dfi_p0_reset_n = main_sdram_reset_n;
assign main_sdram_csr_dfi_p1_reset_n = main_sdram_reset_n;
assign main_sdram_csr_dfi_p2_reset_n = main_sdram_reset_n;
assign main_sdram_csr_dfi_p3_reset_n = main_sdram_reset_n;
always @(*) begin
    main_sdram_csr_dfi_p0_ras_n <= 1'd1;
    main_sdram_csr_dfi_p0_we_n <= 1'd1;
    main_sdram_csr_dfi_p0_cas_n <= 1'd1;
    main_sdram_csr_dfi_p0_cs_n <= 1'd1;
    if (main_sdram_phaseinjector0_command_issue_re) begin
        if (main_sdram_phaseinjector0_csrfield_cs_top) begin
            main_sdram_csr_dfi_p0_cs_n <= 2'd2;
        end else begin
            if (main_sdram_phaseinjector0_csrfield_cs_bottom) begin
                main_sdram_csr_dfi_p0_cs_n <= 1'd1;
            end else begin
                main_sdram_csr_dfi_p0_cs_n <= {1{(~main_sdram_phaseinjector0_csrfield_cs)}};
            end
        end
        main_sdram_csr_dfi_p0_we_n <= (~main_sdram_phaseinjector0_csrfield_we);
        main_sdram_csr_dfi_p0_cas_n <= (~main_sdram_phaseinjector0_csrfield_cas);
        main_sdram_csr_dfi_p0_ras_n <= (~main_sdram_phaseinjector0_csrfield_ras);
    end else begin
        main_sdram_csr_dfi_p0_cs_n <= {1{1'd1}};
        main_sdram_csr_dfi_p0_we_n <= 1'd1;
        main_sdram_csr_dfi_p0_cas_n <= 1'd1;
        main_sdram_csr_dfi_p0_ras_n <= 1'd1;
    end
end
assign main_sdram_csr_dfi_p0_address = main_sdram_phaseinjector0_address_storage;
assign main_sdram_csr_dfi_p0_bank = main_sdram_phaseinjector0_baddress_storage;
assign main_sdram_csr_dfi_p0_wrdata_en = (main_sdram_phaseinjector0_command_issue_re & main_sdram_phaseinjector0_csrfield_wren);
assign main_sdram_csr_dfi_p0_rddata_en = (main_sdram_phaseinjector0_command_issue_re & main_sdram_phaseinjector0_csrfield_rden);
assign main_sdram_csr_dfi_p0_wrdata = main_sdram_phaseinjector0_wrdata_storage;
assign main_sdram_csr_dfi_p0_wrdata_mask = 1'd0;
always @(*) begin
    main_sdram_csr_dfi_p1_ras_n <= 1'd1;
    main_sdram_csr_dfi_p1_we_n <= 1'd1;
    main_sdram_csr_dfi_p1_cas_n <= 1'd1;
    main_sdram_csr_dfi_p1_cs_n <= 1'd1;
    if (main_sdram_phaseinjector1_command_issue_re) begin
        if (main_sdram_phaseinjector1_csrfield_cs_top) begin
            main_sdram_csr_dfi_p1_cs_n <= 2'd2;
        end else begin
            if (main_sdram_phaseinjector1_csrfield_cs_bottom) begin
                main_sdram_csr_dfi_p1_cs_n <= 1'd1;
            end else begin
                main_sdram_csr_dfi_p1_cs_n <= {1{(~main_sdram_phaseinjector1_csrfield_cs)}};
            end
        end
        main_sdram_csr_dfi_p1_we_n <= (~main_sdram_phaseinjector1_csrfield_we);
        main_sdram_csr_dfi_p1_cas_n <= (~main_sdram_phaseinjector1_csrfield_cas);
        main_sdram_csr_dfi_p1_ras_n <= (~main_sdram_phaseinjector1_csrfield_ras);
    end else begin
        main_sdram_csr_dfi_p1_cs_n <= {1{1'd1}};
        main_sdram_csr_dfi_p1_we_n <= 1'd1;
        main_sdram_csr_dfi_p1_cas_n <= 1'd1;
        main_sdram_csr_dfi_p1_ras_n <= 1'd1;
    end
end
assign main_sdram_csr_dfi_p1_address = main_sdram_phaseinjector1_address_storage;
assign main_sdram_csr_dfi_p1_bank = main_sdram_phaseinjector1_baddress_storage;
assign main_sdram_csr_dfi_p1_wrdata_en = (main_sdram_phaseinjector1_command_issue_re & main_sdram_phaseinjector1_csrfield_wren);
assign main_sdram_csr_dfi_p1_rddata_en = (main_sdram_phaseinjector1_command_issue_re & main_sdram_phaseinjector1_csrfield_rden);
assign main_sdram_csr_dfi_p1_wrdata = main_sdram_phaseinjector1_wrdata_storage;
assign main_sdram_csr_dfi_p1_wrdata_mask = 1'd0;
always @(*) begin
    main_sdram_csr_dfi_p2_ras_n <= 1'd1;
    main_sdram_csr_dfi_p2_we_n <= 1'd1;
    main_sdram_csr_dfi_p2_cas_n <= 1'd1;
    main_sdram_csr_dfi_p2_cs_n <= 1'd1;
    if (main_sdram_phaseinjector2_command_issue_re) begin
        if (main_sdram_phaseinjector2_csrfield_cs_top) begin
            main_sdram_csr_dfi_p2_cs_n <= 2'd2;
        end else begin
            if (main_sdram_phaseinjector2_csrfield_cs_bottom) begin
                main_sdram_csr_dfi_p2_cs_n <= 1'd1;
            end else begin
                main_sdram_csr_dfi_p2_cs_n <= {1{(~main_sdram_phaseinjector2_csrfield_cs)}};
            end
        end
        main_sdram_csr_dfi_p2_we_n <= (~main_sdram_phaseinjector2_csrfield_we);
        main_sdram_csr_dfi_p2_cas_n <= (~main_sdram_phaseinjector2_csrfield_cas);
        main_sdram_csr_dfi_p2_ras_n <= (~main_sdram_phaseinjector2_csrfield_ras);
    end else begin
        main_sdram_csr_dfi_p2_cs_n <= {1{1'd1}};
        main_sdram_csr_dfi_p2_we_n <= 1'd1;
        main_sdram_csr_dfi_p2_cas_n <= 1'd1;
        main_sdram_csr_dfi_p2_ras_n <= 1'd1;
    end
end
assign main_sdram_csr_dfi_p2_address = main_sdram_phaseinjector2_address_storage;
assign main_sdram_csr_dfi_p2_bank = main_sdram_phaseinjector2_baddress_storage;
assign main_sdram_csr_dfi_p2_wrdata_en = (main_sdram_phaseinjector2_command_issue_re & main_sdram_phaseinjector2_csrfield_wren);
assign main_sdram_csr_dfi_p2_rddata_en = (main_sdram_phaseinjector2_command_issue_re & main_sdram_phaseinjector2_csrfield_rden);
assign main_sdram_csr_dfi_p2_wrdata = main_sdram_phaseinjector2_wrdata_storage;
assign main_sdram_csr_dfi_p2_wrdata_mask = 1'd0;
always @(*) begin
    main_sdram_csr_dfi_p3_ras_n <= 1'd1;
    main_sdram_csr_dfi_p3_we_n <= 1'd1;
    main_sdram_csr_dfi_p3_cas_n <= 1'd1;
    main_sdram_csr_dfi_p3_cs_n <= 1'd1;
    if (main_sdram_phaseinjector3_command_issue_re) begin
        if (main_sdram_phaseinjector3_csrfield_cs_top) begin
            main_sdram_csr_dfi_p3_cs_n <= 2'd2;
        end else begin
            if (main_sdram_phaseinjector3_csrfield_cs_bottom) begin
                main_sdram_csr_dfi_p3_cs_n <= 1'd1;
            end else begin
                main_sdram_csr_dfi_p3_cs_n <= {1{(~main_sdram_phaseinjector3_csrfield_cs)}};
            end
        end
        main_sdram_csr_dfi_p3_we_n <= (~main_sdram_phaseinjector3_csrfield_we);
        main_sdram_csr_dfi_p3_cas_n <= (~main_sdram_phaseinjector3_csrfield_cas);
        main_sdram_csr_dfi_p3_ras_n <= (~main_sdram_phaseinjector3_csrfield_ras);
    end else begin
        main_sdram_csr_dfi_p3_cs_n <= {1{1'd1}};
        main_sdram_csr_dfi_p3_we_n <= 1'd1;
        main_sdram_csr_dfi_p3_cas_n <= 1'd1;
        main_sdram_csr_dfi_p3_ras_n <= 1'd1;
    end
end
assign main_sdram_csr_dfi_p3_address = main_sdram_phaseinjector3_address_storage;
assign main_sdram_csr_dfi_p3_bank = main_sdram_phaseinjector3_baddress_storage;
assign main_sdram_csr_dfi_p3_wrdata_en = (main_sdram_phaseinjector3_command_issue_re & main_sdram_phaseinjector3_csrfield_wren);
assign main_sdram_csr_dfi_p3_rddata_en = (main_sdram_phaseinjector3_command_issue_re & main_sdram_phaseinjector3_csrfield_rden);
assign main_sdram_csr_dfi_p3_wrdata = main_sdram_phaseinjector3_wrdata_storage;
assign main_sdram_csr_dfi_p3_wrdata_mask = 1'd0;
assign main_sdram_bankmachine0_req_valid = main_sdram_interface_bank0_valid;
assign main_sdram_interface_bank0_ready = main_sdram_bankmachine0_req_ready;
assign main_sdram_bankmachine0_req_we = main_sdram_interface_bank0_we;
assign main_sdram_bankmachine0_req_addr = main_sdram_interface_bank0_addr;
assign main_sdram_interface_bank0_lock = main_sdram_bankmachine0_req_lock;
assign main_sdram_interface_bank0_wdata_ready = main_sdram_bankmachine0_req_wdata_ready;
assign main_sdram_interface_bank0_rdata_valid = main_sdram_bankmachine0_req_rdata_valid;
assign main_sdram_bankmachine1_req_valid = main_sdram_interface_bank1_valid;
assign main_sdram_interface_bank1_ready = main_sdram_bankmachine1_req_ready;
assign main_sdram_bankmachine1_req_we = main_sdram_interface_bank1_we;
assign main_sdram_bankmachine1_req_addr = main_sdram_interface_bank1_addr;
assign main_sdram_interface_bank1_lock = main_sdram_bankmachine1_req_lock;
assign main_sdram_interface_bank1_wdata_ready = main_sdram_bankmachine1_req_wdata_ready;
assign main_sdram_interface_bank1_rdata_valid = main_sdram_bankmachine1_req_rdata_valid;
assign main_sdram_bankmachine2_req_valid = main_sdram_interface_bank2_valid;
assign main_sdram_interface_bank2_ready = main_sdram_bankmachine2_req_ready;
assign main_sdram_bankmachine2_req_we = main_sdram_interface_bank2_we;
assign main_sdram_bankmachine2_req_addr = main_sdram_interface_bank2_addr;
assign main_sdram_interface_bank2_lock = main_sdram_bankmachine2_req_lock;
assign main_sdram_interface_bank2_wdata_ready = main_sdram_bankmachine2_req_wdata_ready;
assign main_sdram_interface_bank2_rdata_valid = main_sdram_bankmachine2_req_rdata_valid;
assign main_sdram_bankmachine3_req_valid = main_sdram_interface_bank3_valid;
assign main_sdram_interface_bank3_ready = main_sdram_bankmachine3_req_ready;
assign main_sdram_bankmachine3_req_we = main_sdram_interface_bank3_we;
assign main_sdram_bankmachine3_req_addr = main_sdram_interface_bank3_addr;
assign main_sdram_interface_bank3_lock = main_sdram_bankmachine3_req_lock;
assign main_sdram_interface_bank3_wdata_ready = main_sdram_bankmachine3_req_wdata_ready;
assign main_sdram_interface_bank3_rdata_valid = main_sdram_bankmachine3_req_rdata_valid;
assign main_sdram_bankmachine4_req_valid = main_sdram_interface_bank4_valid;
assign main_sdram_interface_bank4_ready = main_sdram_bankmachine4_req_ready;
assign main_sdram_bankmachine4_req_we = main_sdram_interface_bank4_we;
assign main_sdram_bankmachine4_req_addr = main_sdram_interface_bank4_addr;
assign main_sdram_interface_bank4_lock = main_sdram_bankmachine4_req_lock;
assign main_sdram_interface_bank4_wdata_ready = main_sdram_bankmachine4_req_wdata_ready;
assign main_sdram_interface_bank4_rdata_valid = main_sdram_bankmachine4_req_rdata_valid;
assign main_sdram_bankmachine5_req_valid = main_sdram_interface_bank5_valid;
assign main_sdram_interface_bank5_ready = main_sdram_bankmachine5_req_ready;
assign main_sdram_bankmachine5_req_we = main_sdram_interface_bank5_we;
assign main_sdram_bankmachine5_req_addr = main_sdram_interface_bank5_addr;
assign main_sdram_interface_bank5_lock = main_sdram_bankmachine5_req_lock;
assign main_sdram_interface_bank5_wdata_ready = main_sdram_bankmachine5_req_wdata_ready;
assign main_sdram_interface_bank5_rdata_valid = main_sdram_bankmachine5_req_rdata_valid;
assign main_sdram_bankmachine6_req_valid = main_sdram_interface_bank6_valid;
assign main_sdram_interface_bank6_ready = main_sdram_bankmachine6_req_ready;
assign main_sdram_bankmachine6_req_we = main_sdram_interface_bank6_we;
assign main_sdram_bankmachine6_req_addr = main_sdram_interface_bank6_addr;
assign main_sdram_interface_bank6_lock = main_sdram_bankmachine6_req_lock;
assign main_sdram_interface_bank6_wdata_ready = main_sdram_bankmachine6_req_wdata_ready;
assign main_sdram_interface_bank6_rdata_valid = main_sdram_bankmachine6_req_rdata_valid;
assign main_sdram_bankmachine7_req_valid = main_sdram_interface_bank7_valid;
assign main_sdram_interface_bank7_ready = main_sdram_bankmachine7_req_ready;
assign main_sdram_bankmachine7_req_we = main_sdram_interface_bank7_we;
assign main_sdram_bankmachine7_req_addr = main_sdram_interface_bank7_addr;
assign main_sdram_interface_bank7_lock = main_sdram_bankmachine7_req_lock;
assign main_sdram_interface_bank7_wdata_ready = main_sdram_bankmachine7_req_wdata_ready;
assign main_sdram_interface_bank7_rdata_valid = main_sdram_bankmachine7_req_rdata_valid;
assign main_sdram_timer_wait = (~main_sdram_timer_done0);
assign main_sdram_postponer_req_i = main_sdram_timer_done0;
assign main_sdram_wants_refresh = main_sdram_postponer_req_o;
assign main_sdram_wants_zqcs = main_sdram_zqcs_timer_done0;
assign main_sdram_zqcs_timer_wait = (~main_sdram_zqcs_executer_done);
assign main_sdram_timer_done1 = (main_sdram_timer_count1 == 1'd0);
assign main_sdram_timer_done0 = main_sdram_timer_done1;
assign main_sdram_timer_count0 = main_sdram_timer_count1;
assign main_sdram_sequencer_start1 = (main_sdram_sequencer_start0 | (main_sdram_sequencer_count != 1'd0));
assign main_sdram_sequencer_done0 = (main_sdram_sequencer_done1 & (main_sdram_sequencer_count == 1'd0));
assign main_sdram_zqcs_timer_done1 = (main_sdram_zqcs_timer_count1 == 1'd0);
assign main_sdram_zqcs_timer_done0 = main_sdram_zqcs_timer_done1;
assign main_sdram_zqcs_timer_count0 = main_sdram_zqcs_timer_count1;
always @(*) begin
    main_sdram_cmd_valid <= 1'd0;
    builder_soclinux_refresher_next_state <= 2'd0;
    main_sdram_zqcs_executer_start <= 1'd0;
    main_sdram_cmd_last <= 1'd0;
    main_sdram_sequencer_start0 <= 1'd0;
    builder_soclinux_refresher_next_state <= builder_soclinux_refresher_state;
    case (builder_soclinux_refresher_state)
        1'd1: begin
            main_sdram_cmd_valid <= 1'd1;
            if (main_sdram_cmd_ready) begin
                main_sdram_sequencer_start0 <= 1'd1;
                builder_soclinux_refresher_next_state <= 2'd2;
            end
        end
        2'd2: begin
            main_sdram_cmd_valid <= 1'd1;
            if (main_sdram_sequencer_done0) begin
                if (main_sdram_wants_zqcs) begin
                    main_sdram_zqcs_executer_start <= 1'd1;
                    builder_soclinux_refresher_next_state <= 2'd3;
                end else begin
                    main_sdram_cmd_valid <= 1'd0;
                    main_sdram_cmd_last <= 1'd1;
                    builder_soclinux_refresher_next_state <= 1'd0;
                end
            end
        end
        2'd3: begin
            main_sdram_cmd_valid <= 1'd1;
            if (main_sdram_zqcs_executer_done) begin
                main_sdram_cmd_valid <= 1'd0;
                main_sdram_cmd_last <= 1'd1;
                builder_soclinux_refresher_next_state <= 1'd0;
            end
        end
        default: begin
            if (1'd1) begin
                if (main_sdram_wants_refresh) begin
                    builder_soclinux_refresher_next_state <= 1'd1;
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine0_sink_valid = main_sdram_bankmachine0_req_valid;
assign main_sdram_bankmachine0_req_ready = main_sdram_bankmachine0_sink_ready;
assign main_sdram_bankmachine0_sink_payload_we = main_sdram_bankmachine0_req_we;
assign main_sdram_bankmachine0_sink_payload_addr = main_sdram_bankmachine0_req_addr;
assign main_sdram_bankmachine0_sink_sink_valid = main_sdram_bankmachine0_source_valid;
assign main_sdram_bankmachine0_source_ready = main_sdram_bankmachine0_sink_sink_ready;
assign main_sdram_bankmachine0_sink_sink_first = main_sdram_bankmachine0_source_first;
assign main_sdram_bankmachine0_sink_sink_last = main_sdram_bankmachine0_source_last;
assign main_sdram_bankmachine0_sink_sink_payload_we = main_sdram_bankmachine0_source_payload_we;
assign main_sdram_bankmachine0_sink_sink_payload_addr = main_sdram_bankmachine0_source_payload_addr;
assign main_sdram_bankmachine0_source_source_ready = (main_sdram_bankmachine0_req_wdata_ready | main_sdram_bankmachine0_req_rdata_valid);
assign main_sdram_bankmachine0_req_lock = (main_sdram_bankmachine0_source_valid | main_sdram_bankmachine0_source_source_valid);
assign main_sdram_bankmachine0_row_hit = (main_sdram_bankmachine0_row == main_sdram_bankmachine0_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine0_cmd_payload_ba = 1'd0;
always @(*) begin
    main_sdram_bankmachine0_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine0_row_col_n_addr_sel) begin
        main_sdram_bankmachine0_cmd_payload_a <= main_sdram_bankmachine0_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine0_cmd_payload_a <= ((main_sdram_bankmachine0_auto_precharge <<< 4'd10) | {main_sdram_bankmachine0_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine0_twtpcon_valid = ((main_sdram_bankmachine0_cmd_valid & main_sdram_bankmachine0_cmd_ready) & main_sdram_bankmachine0_cmd_payload_is_write);
assign main_sdram_bankmachine0_trccon_valid = ((main_sdram_bankmachine0_cmd_valid & main_sdram_bankmachine0_cmd_ready) & main_sdram_bankmachine0_row_open);
assign main_sdram_bankmachine0_trascon_valid = ((main_sdram_bankmachine0_cmd_valid & main_sdram_bankmachine0_cmd_ready) & main_sdram_bankmachine0_row_open);
always @(*) begin
    main_sdram_bankmachine0_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine0_source_valid & main_sdram_bankmachine0_source_source_valid)) begin
        if ((main_sdram_bankmachine0_source_payload_addr[21:7] != main_sdram_bankmachine0_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine0_auto_precharge <= (main_sdram_bankmachine0_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine0_syncfifo0_din = {main_sdram_bankmachine0_fifo_in_last, main_sdram_bankmachine0_fifo_in_first, main_sdram_bankmachine0_fifo_in_payload_addr, main_sdram_bankmachine0_fifo_in_payload_we};
assign {main_sdram_bankmachine0_fifo_out_last, main_sdram_bankmachine0_fifo_out_first, main_sdram_bankmachine0_fifo_out_payload_addr, main_sdram_bankmachine0_fifo_out_payload_we} = main_sdram_bankmachine0_syncfifo0_dout;
assign main_sdram_bankmachine0_sink_ready = main_sdram_bankmachine0_syncfifo0_writable;
assign main_sdram_bankmachine0_syncfifo0_we = main_sdram_bankmachine0_sink_valid;
assign main_sdram_bankmachine0_fifo_in_first = main_sdram_bankmachine0_sink_first;
assign main_sdram_bankmachine0_fifo_in_last = main_sdram_bankmachine0_sink_last;
assign main_sdram_bankmachine0_fifo_in_payload_we = main_sdram_bankmachine0_sink_payload_we;
assign main_sdram_bankmachine0_fifo_in_payload_addr = main_sdram_bankmachine0_sink_payload_addr;
assign main_sdram_bankmachine0_source_valid = main_sdram_bankmachine0_syncfifo0_readable;
assign main_sdram_bankmachine0_source_first = main_sdram_bankmachine0_fifo_out_first;
assign main_sdram_bankmachine0_source_last = main_sdram_bankmachine0_fifo_out_last;
assign main_sdram_bankmachine0_source_payload_we = main_sdram_bankmachine0_fifo_out_payload_we;
assign main_sdram_bankmachine0_source_payload_addr = main_sdram_bankmachine0_fifo_out_payload_addr;
assign main_sdram_bankmachine0_syncfifo0_re = main_sdram_bankmachine0_source_ready;
always @(*) begin
    main_sdram_bankmachine0_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine0_replace) begin
        main_sdram_bankmachine0_wrport_adr <= (main_sdram_bankmachine0_produce - 1'd1);
    end else begin
        main_sdram_bankmachine0_wrport_adr <= main_sdram_bankmachine0_produce;
    end
end
assign main_sdram_bankmachine0_wrport_dat_w = main_sdram_bankmachine0_syncfifo0_din;
assign main_sdram_bankmachine0_wrport_we = (main_sdram_bankmachine0_syncfifo0_we & (main_sdram_bankmachine0_syncfifo0_writable | main_sdram_bankmachine0_replace));
assign main_sdram_bankmachine0_do_read = (main_sdram_bankmachine0_syncfifo0_readable & main_sdram_bankmachine0_syncfifo0_re);
assign main_sdram_bankmachine0_rdport_adr = main_sdram_bankmachine0_consume;
assign main_sdram_bankmachine0_syncfifo0_dout = main_sdram_bankmachine0_rdport_dat_r;
assign main_sdram_bankmachine0_syncfifo0_writable = (main_sdram_bankmachine0_level != 4'd8);
assign main_sdram_bankmachine0_syncfifo0_readable = (main_sdram_bankmachine0_level != 1'd0);
assign main_sdram_bankmachine0_pipe_valid_sink_ready = ((~main_sdram_bankmachine0_pipe_valid_source_valid) | main_sdram_bankmachine0_pipe_valid_source_ready);
assign main_sdram_bankmachine0_pipe_valid_sink_valid = main_sdram_bankmachine0_sink_sink_valid;
assign main_sdram_bankmachine0_sink_sink_ready = main_sdram_bankmachine0_pipe_valid_sink_ready;
assign main_sdram_bankmachine0_pipe_valid_sink_first = main_sdram_bankmachine0_sink_sink_first;
assign main_sdram_bankmachine0_pipe_valid_sink_last = main_sdram_bankmachine0_sink_sink_last;
assign main_sdram_bankmachine0_pipe_valid_sink_payload_we = main_sdram_bankmachine0_sink_sink_payload_we;
assign main_sdram_bankmachine0_pipe_valid_sink_payload_addr = main_sdram_bankmachine0_sink_sink_payload_addr;
assign main_sdram_bankmachine0_source_source_valid = main_sdram_bankmachine0_pipe_valid_source_valid;
assign main_sdram_bankmachine0_pipe_valid_source_ready = main_sdram_bankmachine0_source_source_ready;
assign main_sdram_bankmachine0_source_source_first = main_sdram_bankmachine0_pipe_valid_source_first;
assign main_sdram_bankmachine0_source_source_last = main_sdram_bankmachine0_pipe_valid_source_last;
assign main_sdram_bankmachine0_source_source_payload_we = main_sdram_bankmachine0_pipe_valid_source_payload_we;
assign main_sdram_bankmachine0_source_source_payload_addr = main_sdram_bankmachine0_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine0_row_col_n_addr_sel <= 1'd0;
    main_sdram_bankmachine0_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine0_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine0_cmd_payload_we <= 1'd0;
    main_sdram_bankmachine0_cmd_payload_is_cmd <= 1'd0;
    main_sdram_bankmachine0_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine0_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine0_req_wdata_ready <= 1'd0;
    builder_soclinux_bankmachine0_next_state <= 4'd0;
    main_sdram_bankmachine0_req_rdata_valid <= 1'd0;
    main_sdram_bankmachine0_refresh_gnt <= 1'd0;
    main_sdram_bankmachine0_row_open <= 1'd0;
    main_sdram_bankmachine0_cmd_valid <= 1'd0;
    main_sdram_bankmachine0_row_close <= 1'd0;
    builder_soclinux_bankmachine0_next_state <= builder_soclinux_bankmachine0_state;
    case (builder_soclinux_bankmachine0_state)
        1'd1: begin
            if ((main_sdram_bankmachine0_twtpcon_ready & main_sdram_bankmachine0_trascon_ready)) begin
                main_sdram_bankmachine0_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine0_cmd_ready) begin
                    builder_soclinux_bankmachine0_next_state <= 3'd5;
                end
                main_sdram_bankmachine0_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine0_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine0_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine0_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine0_twtpcon_ready & main_sdram_bankmachine0_trascon_ready)) begin
                builder_soclinux_bankmachine0_next_state <= 3'd5;
            end
            main_sdram_bankmachine0_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine0_trccon_ready) begin
                main_sdram_bankmachine0_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine0_row_open <= 1'd1;
                main_sdram_bankmachine0_cmd_valid <= 1'd1;
                main_sdram_bankmachine0_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine0_cmd_ready) begin
                    builder_soclinux_bankmachine0_next_state <= 3'd7;
                end
                main_sdram_bankmachine0_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine0_twtpcon_ready) begin
                main_sdram_bankmachine0_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine0_row_close <= 1'd1;
            main_sdram_bankmachine0_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine0_refresh_req)) begin
                builder_soclinux_bankmachine0_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine0_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine0_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine0_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine0_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine0_refresh_req) begin
                builder_soclinux_bankmachine0_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine0_source_source_valid) begin
                    if (main_sdram_bankmachine0_row_opened) begin
                        if (main_sdram_bankmachine0_row_hit) begin
                            main_sdram_bankmachine0_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine0_source_source_payload_we) begin
                                main_sdram_bankmachine0_req_wdata_ready <= main_sdram_bankmachine0_cmd_ready;
                                main_sdram_bankmachine0_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine0_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine0_req_rdata_valid <= main_sdram_bankmachine0_cmd_ready;
                                main_sdram_bankmachine0_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine0_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine0_cmd_ready & main_sdram_bankmachine0_auto_precharge)) begin
                                builder_soclinux_bankmachine0_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine0_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine0_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine1_sink_valid = main_sdram_bankmachine1_req_valid;
assign main_sdram_bankmachine1_req_ready = main_sdram_bankmachine1_sink_ready;
assign main_sdram_bankmachine1_sink_payload_we = main_sdram_bankmachine1_req_we;
assign main_sdram_bankmachine1_sink_payload_addr = main_sdram_bankmachine1_req_addr;
assign main_sdram_bankmachine1_sink_sink_valid = main_sdram_bankmachine1_source_valid;
assign main_sdram_bankmachine1_source_ready = main_sdram_bankmachine1_sink_sink_ready;
assign main_sdram_bankmachine1_sink_sink_first = main_sdram_bankmachine1_source_first;
assign main_sdram_bankmachine1_sink_sink_last = main_sdram_bankmachine1_source_last;
assign main_sdram_bankmachine1_sink_sink_payload_we = main_sdram_bankmachine1_source_payload_we;
assign main_sdram_bankmachine1_sink_sink_payload_addr = main_sdram_bankmachine1_source_payload_addr;
assign main_sdram_bankmachine1_source_source_ready = (main_sdram_bankmachine1_req_wdata_ready | main_sdram_bankmachine1_req_rdata_valid);
assign main_sdram_bankmachine1_req_lock = (main_sdram_bankmachine1_source_valid | main_sdram_bankmachine1_source_source_valid);
assign main_sdram_bankmachine1_row_hit = (main_sdram_bankmachine1_row == main_sdram_bankmachine1_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine1_cmd_payload_ba = 1'd1;
always @(*) begin
    main_sdram_bankmachine1_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine1_row_col_n_addr_sel) begin
        main_sdram_bankmachine1_cmd_payload_a <= main_sdram_bankmachine1_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine1_cmd_payload_a <= ((main_sdram_bankmachine1_auto_precharge <<< 4'd10) | {main_sdram_bankmachine1_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine1_twtpcon_valid = ((main_sdram_bankmachine1_cmd_valid & main_sdram_bankmachine1_cmd_ready) & main_sdram_bankmachine1_cmd_payload_is_write);
assign main_sdram_bankmachine1_trccon_valid = ((main_sdram_bankmachine1_cmd_valid & main_sdram_bankmachine1_cmd_ready) & main_sdram_bankmachine1_row_open);
assign main_sdram_bankmachine1_trascon_valid = ((main_sdram_bankmachine1_cmd_valid & main_sdram_bankmachine1_cmd_ready) & main_sdram_bankmachine1_row_open);
always @(*) begin
    main_sdram_bankmachine1_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine1_source_valid & main_sdram_bankmachine1_source_source_valid)) begin
        if ((main_sdram_bankmachine1_source_payload_addr[21:7] != main_sdram_bankmachine1_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine1_auto_precharge <= (main_sdram_bankmachine1_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine1_syncfifo1_din = {main_sdram_bankmachine1_fifo_in_last, main_sdram_bankmachine1_fifo_in_first, main_sdram_bankmachine1_fifo_in_payload_addr, main_sdram_bankmachine1_fifo_in_payload_we};
assign {main_sdram_bankmachine1_fifo_out_last, main_sdram_bankmachine1_fifo_out_first, main_sdram_bankmachine1_fifo_out_payload_addr, main_sdram_bankmachine1_fifo_out_payload_we} = main_sdram_bankmachine1_syncfifo1_dout;
assign main_sdram_bankmachine1_sink_ready = main_sdram_bankmachine1_syncfifo1_writable;
assign main_sdram_bankmachine1_syncfifo1_we = main_sdram_bankmachine1_sink_valid;
assign main_sdram_bankmachine1_fifo_in_first = main_sdram_bankmachine1_sink_first;
assign main_sdram_bankmachine1_fifo_in_last = main_sdram_bankmachine1_sink_last;
assign main_sdram_bankmachine1_fifo_in_payload_we = main_sdram_bankmachine1_sink_payload_we;
assign main_sdram_bankmachine1_fifo_in_payload_addr = main_sdram_bankmachine1_sink_payload_addr;
assign main_sdram_bankmachine1_source_valid = main_sdram_bankmachine1_syncfifo1_readable;
assign main_sdram_bankmachine1_source_first = main_sdram_bankmachine1_fifo_out_first;
assign main_sdram_bankmachine1_source_last = main_sdram_bankmachine1_fifo_out_last;
assign main_sdram_bankmachine1_source_payload_we = main_sdram_bankmachine1_fifo_out_payload_we;
assign main_sdram_bankmachine1_source_payload_addr = main_sdram_bankmachine1_fifo_out_payload_addr;
assign main_sdram_bankmachine1_syncfifo1_re = main_sdram_bankmachine1_source_ready;
always @(*) begin
    main_sdram_bankmachine1_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine1_replace) begin
        main_sdram_bankmachine1_wrport_adr <= (main_sdram_bankmachine1_produce - 1'd1);
    end else begin
        main_sdram_bankmachine1_wrport_adr <= main_sdram_bankmachine1_produce;
    end
end
assign main_sdram_bankmachine1_wrport_dat_w = main_sdram_bankmachine1_syncfifo1_din;
assign main_sdram_bankmachine1_wrport_we = (main_sdram_bankmachine1_syncfifo1_we & (main_sdram_bankmachine1_syncfifo1_writable | main_sdram_bankmachine1_replace));
assign main_sdram_bankmachine1_do_read = (main_sdram_bankmachine1_syncfifo1_readable & main_sdram_bankmachine1_syncfifo1_re);
assign main_sdram_bankmachine1_rdport_adr = main_sdram_bankmachine1_consume;
assign main_sdram_bankmachine1_syncfifo1_dout = main_sdram_bankmachine1_rdport_dat_r;
assign main_sdram_bankmachine1_syncfifo1_writable = (main_sdram_bankmachine1_level != 4'd8);
assign main_sdram_bankmachine1_syncfifo1_readable = (main_sdram_bankmachine1_level != 1'd0);
assign main_sdram_bankmachine1_pipe_valid_sink_ready = ((~main_sdram_bankmachine1_pipe_valid_source_valid) | main_sdram_bankmachine1_pipe_valid_source_ready);
assign main_sdram_bankmachine1_pipe_valid_sink_valid = main_sdram_bankmachine1_sink_sink_valid;
assign main_sdram_bankmachine1_sink_sink_ready = main_sdram_bankmachine1_pipe_valid_sink_ready;
assign main_sdram_bankmachine1_pipe_valid_sink_first = main_sdram_bankmachine1_sink_sink_first;
assign main_sdram_bankmachine1_pipe_valid_sink_last = main_sdram_bankmachine1_sink_sink_last;
assign main_sdram_bankmachine1_pipe_valid_sink_payload_we = main_sdram_bankmachine1_sink_sink_payload_we;
assign main_sdram_bankmachine1_pipe_valid_sink_payload_addr = main_sdram_bankmachine1_sink_sink_payload_addr;
assign main_sdram_bankmachine1_source_source_valid = main_sdram_bankmachine1_pipe_valid_source_valid;
assign main_sdram_bankmachine1_pipe_valid_source_ready = main_sdram_bankmachine1_source_source_ready;
assign main_sdram_bankmachine1_source_source_first = main_sdram_bankmachine1_pipe_valid_source_first;
assign main_sdram_bankmachine1_source_source_last = main_sdram_bankmachine1_pipe_valid_source_last;
assign main_sdram_bankmachine1_source_source_payload_we = main_sdram_bankmachine1_pipe_valid_source_payload_we;
assign main_sdram_bankmachine1_source_source_payload_addr = main_sdram_bankmachine1_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine1_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine1_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine1_cmd_payload_we <= 1'd0;
    main_sdram_bankmachine1_cmd_payload_is_cmd <= 1'd0;
    main_sdram_bankmachine1_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine1_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine1_req_wdata_ready <= 1'd0;
    main_sdram_bankmachine1_req_rdata_valid <= 1'd0;
    main_sdram_bankmachine1_refresh_gnt <= 1'd0;
    main_sdram_bankmachine1_row_open <= 1'd0;
    main_sdram_bankmachine1_cmd_valid <= 1'd0;
    main_sdram_bankmachine1_row_close <= 1'd0;
    builder_soclinux_bankmachine1_next_state <= 4'd0;
    main_sdram_bankmachine1_row_col_n_addr_sel <= 1'd0;
    builder_soclinux_bankmachine1_next_state <= builder_soclinux_bankmachine1_state;
    case (builder_soclinux_bankmachine1_state)
        1'd1: begin
            if ((main_sdram_bankmachine1_twtpcon_ready & main_sdram_bankmachine1_trascon_ready)) begin
                main_sdram_bankmachine1_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine1_cmd_ready) begin
                    builder_soclinux_bankmachine1_next_state <= 3'd5;
                end
                main_sdram_bankmachine1_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine1_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine1_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine1_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine1_twtpcon_ready & main_sdram_bankmachine1_trascon_ready)) begin
                builder_soclinux_bankmachine1_next_state <= 3'd5;
            end
            main_sdram_bankmachine1_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine1_trccon_ready) begin
                main_sdram_bankmachine1_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine1_row_open <= 1'd1;
                main_sdram_bankmachine1_cmd_valid <= 1'd1;
                main_sdram_bankmachine1_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine1_cmd_ready) begin
                    builder_soclinux_bankmachine1_next_state <= 3'd7;
                end
                main_sdram_bankmachine1_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine1_twtpcon_ready) begin
                main_sdram_bankmachine1_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine1_row_close <= 1'd1;
            main_sdram_bankmachine1_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine1_refresh_req)) begin
                builder_soclinux_bankmachine1_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine1_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine1_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine1_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine1_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine1_refresh_req) begin
                builder_soclinux_bankmachine1_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine1_source_source_valid) begin
                    if (main_sdram_bankmachine1_row_opened) begin
                        if (main_sdram_bankmachine1_row_hit) begin
                            main_sdram_bankmachine1_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine1_source_source_payload_we) begin
                                main_sdram_bankmachine1_req_wdata_ready <= main_sdram_bankmachine1_cmd_ready;
                                main_sdram_bankmachine1_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine1_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine1_req_rdata_valid <= main_sdram_bankmachine1_cmd_ready;
                                main_sdram_bankmachine1_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine1_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine1_cmd_ready & main_sdram_bankmachine1_auto_precharge)) begin
                                builder_soclinux_bankmachine1_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine1_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine1_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine2_sink_valid = main_sdram_bankmachine2_req_valid;
assign main_sdram_bankmachine2_req_ready = main_sdram_bankmachine2_sink_ready;
assign main_sdram_bankmachine2_sink_payload_we = main_sdram_bankmachine2_req_we;
assign main_sdram_bankmachine2_sink_payload_addr = main_sdram_bankmachine2_req_addr;
assign main_sdram_bankmachine2_sink_sink_valid = main_sdram_bankmachine2_source_valid;
assign main_sdram_bankmachine2_source_ready = main_sdram_bankmachine2_sink_sink_ready;
assign main_sdram_bankmachine2_sink_sink_first = main_sdram_bankmachine2_source_first;
assign main_sdram_bankmachine2_sink_sink_last = main_sdram_bankmachine2_source_last;
assign main_sdram_bankmachine2_sink_sink_payload_we = main_sdram_bankmachine2_source_payload_we;
assign main_sdram_bankmachine2_sink_sink_payload_addr = main_sdram_bankmachine2_source_payload_addr;
assign main_sdram_bankmachine2_source_source_ready = (main_sdram_bankmachine2_req_wdata_ready | main_sdram_bankmachine2_req_rdata_valid);
assign main_sdram_bankmachine2_req_lock = (main_sdram_bankmachine2_source_valid | main_sdram_bankmachine2_source_source_valid);
assign main_sdram_bankmachine2_row_hit = (main_sdram_bankmachine2_row == main_sdram_bankmachine2_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine2_cmd_payload_ba = 2'd2;
always @(*) begin
    main_sdram_bankmachine2_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine2_row_col_n_addr_sel) begin
        main_sdram_bankmachine2_cmd_payload_a <= main_sdram_bankmachine2_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine2_cmd_payload_a <= ((main_sdram_bankmachine2_auto_precharge <<< 4'd10) | {main_sdram_bankmachine2_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine2_twtpcon_valid = ((main_sdram_bankmachine2_cmd_valid & main_sdram_bankmachine2_cmd_ready) & main_sdram_bankmachine2_cmd_payload_is_write);
assign main_sdram_bankmachine2_trccon_valid = ((main_sdram_bankmachine2_cmd_valid & main_sdram_bankmachine2_cmd_ready) & main_sdram_bankmachine2_row_open);
assign main_sdram_bankmachine2_trascon_valid = ((main_sdram_bankmachine2_cmd_valid & main_sdram_bankmachine2_cmd_ready) & main_sdram_bankmachine2_row_open);
always @(*) begin
    main_sdram_bankmachine2_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine2_source_valid & main_sdram_bankmachine2_source_source_valid)) begin
        if ((main_sdram_bankmachine2_source_payload_addr[21:7] != main_sdram_bankmachine2_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine2_auto_precharge <= (main_sdram_bankmachine2_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine2_syncfifo2_din = {main_sdram_bankmachine2_fifo_in_last, main_sdram_bankmachine2_fifo_in_first, main_sdram_bankmachine2_fifo_in_payload_addr, main_sdram_bankmachine2_fifo_in_payload_we};
assign {main_sdram_bankmachine2_fifo_out_last, main_sdram_bankmachine2_fifo_out_first, main_sdram_bankmachine2_fifo_out_payload_addr, main_sdram_bankmachine2_fifo_out_payload_we} = main_sdram_bankmachine2_syncfifo2_dout;
assign main_sdram_bankmachine2_sink_ready = main_sdram_bankmachine2_syncfifo2_writable;
assign main_sdram_bankmachine2_syncfifo2_we = main_sdram_bankmachine2_sink_valid;
assign main_sdram_bankmachine2_fifo_in_first = main_sdram_bankmachine2_sink_first;
assign main_sdram_bankmachine2_fifo_in_last = main_sdram_bankmachine2_sink_last;
assign main_sdram_bankmachine2_fifo_in_payload_we = main_sdram_bankmachine2_sink_payload_we;
assign main_sdram_bankmachine2_fifo_in_payload_addr = main_sdram_bankmachine2_sink_payload_addr;
assign main_sdram_bankmachine2_source_valid = main_sdram_bankmachine2_syncfifo2_readable;
assign main_sdram_bankmachine2_source_first = main_sdram_bankmachine2_fifo_out_first;
assign main_sdram_bankmachine2_source_last = main_sdram_bankmachine2_fifo_out_last;
assign main_sdram_bankmachine2_source_payload_we = main_sdram_bankmachine2_fifo_out_payload_we;
assign main_sdram_bankmachine2_source_payload_addr = main_sdram_bankmachine2_fifo_out_payload_addr;
assign main_sdram_bankmachine2_syncfifo2_re = main_sdram_bankmachine2_source_ready;
always @(*) begin
    main_sdram_bankmachine2_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine2_replace) begin
        main_sdram_bankmachine2_wrport_adr <= (main_sdram_bankmachine2_produce - 1'd1);
    end else begin
        main_sdram_bankmachine2_wrport_adr <= main_sdram_bankmachine2_produce;
    end
end
assign main_sdram_bankmachine2_wrport_dat_w = main_sdram_bankmachine2_syncfifo2_din;
assign main_sdram_bankmachine2_wrport_we = (main_sdram_bankmachine2_syncfifo2_we & (main_sdram_bankmachine2_syncfifo2_writable | main_sdram_bankmachine2_replace));
assign main_sdram_bankmachine2_do_read = (main_sdram_bankmachine2_syncfifo2_readable & main_sdram_bankmachine2_syncfifo2_re);
assign main_sdram_bankmachine2_rdport_adr = main_sdram_bankmachine2_consume;
assign main_sdram_bankmachine2_syncfifo2_dout = main_sdram_bankmachine2_rdport_dat_r;
assign main_sdram_bankmachine2_syncfifo2_writable = (main_sdram_bankmachine2_level != 4'd8);
assign main_sdram_bankmachine2_syncfifo2_readable = (main_sdram_bankmachine2_level != 1'd0);
assign main_sdram_bankmachine2_pipe_valid_sink_ready = ((~main_sdram_bankmachine2_pipe_valid_source_valid) | main_sdram_bankmachine2_pipe_valid_source_ready);
assign main_sdram_bankmachine2_pipe_valid_sink_valid = main_sdram_bankmachine2_sink_sink_valid;
assign main_sdram_bankmachine2_sink_sink_ready = main_sdram_bankmachine2_pipe_valid_sink_ready;
assign main_sdram_bankmachine2_pipe_valid_sink_first = main_sdram_bankmachine2_sink_sink_first;
assign main_sdram_bankmachine2_pipe_valid_sink_last = main_sdram_bankmachine2_sink_sink_last;
assign main_sdram_bankmachine2_pipe_valid_sink_payload_we = main_sdram_bankmachine2_sink_sink_payload_we;
assign main_sdram_bankmachine2_pipe_valid_sink_payload_addr = main_sdram_bankmachine2_sink_sink_payload_addr;
assign main_sdram_bankmachine2_source_source_valid = main_sdram_bankmachine2_pipe_valid_source_valid;
assign main_sdram_bankmachine2_pipe_valid_source_ready = main_sdram_bankmachine2_source_source_ready;
assign main_sdram_bankmachine2_source_source_first = main_sdram_bankmachine2_pipe_valid_source_first;
assign main_sdram_bankmachine2_source_source_last = main_sdram_bankmachine2_pipe_valid_source_last;
assign main_sdram_bankmachine2_source_source_payload_we = main_sdram_bankmachine2_pipe_valid_source_payload_we;
assign main_sdram_bankmachine2_source_source_payload_addr = main_sdram_bankmachine2_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine2_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine2_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine2_req_wdata_ready <= 1'd0;
    main_sdram_bankmachine2_req_rdata_valid <= 1'd0;
    main_sdram_bankmachine2_refresh_gnt <= 1'd0;
    main_sdram_bankmachine2_row_open <= 1'd0;
    main_sdram_bankmachine2_cmd_valid <= 1'd0;
    main_sdram_bankmachine2_row_close <= 1'd0;
    main_sdram_bankmachine2_row_col_n_addr_sel <= 1'd0;
    builder_soclinux_bankmachine2_next_state <= 4'd0;
    main_sdram_bankmachine2_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine2_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine2_cmd_payload_we <= 1'd0;
    main_sdram_bankmachine2_cmd_payload_is_cmd <= 1'd0;
    builder_soclinux_bankmachine2_next_state <= builder_soclinux_bankmachine2_state;
    case (builder_soclinux_bankmachine2_state)
        1'd1: begin
            if ((main_sdram_bankmachine2_twtpcon_ready & main_sdram_bankmachine2_trascon_ready)) begin
                main_sdram_bankmachine2_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine2_cmd_ready) begin
                    builder_soclinux_bankmachine2_next_state <= 3'd5;
                end
                main_sdram_bankmachine2_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine2_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine2_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine2_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine2_twtpcon_ready & main_sdram_bankmachine2_trascon_ready)) begin
                builder_soclinux_bankmachine2_next_state <= 3'd5;
            end
            main_sdram_bankmachine2_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine2_trccon_ready) begin
                main_sdram_bankmachine2_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine2_row_open <= 1'd1;
                main_sdram_bankmachine2_cmd_valid <= 1'd1;
                main_sdram_bankmachine2_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine2_cmd_ready) begin
                    builder_soclinux_bankmachine2_next_state <= 3'd7;
                end
                main_sdram_bankmachine2_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine2_twtpcon_ready) begin
                main_sdram_bankmachine2_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine2_row_close <= 1'd1;
            main_sdram_bankmachine2_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine2_refresh_req)) begin
                builder_soclinux_bankmachine2_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine2_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine2_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine2_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine2_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine2_refresh_req) begin
                builder_soclinux_bankmachine2_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine2_source_source_valid) begin
                    if (main_sdram_bankmachine2_row_opened) begin
                        if (main_sdram_bankmachine2_row_hit) begin
                            main_sdram_bankmachine2_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine2_source_source_payload_we) begin
                                main_sdram_bankmachine2_req_wdata_ready <= main_sdram_bankmachine2_cmd_ready;
                                main_sdram_bankmachine2_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine2_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine2_req_rdata_valid <= main_sdram_bankmachine2_cmd_ready;
                                main_sdram_bankmachine2_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine2_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine2_cmd_ready & main_sdram_bankmachine2_auto_precharge)) begin
                                builder_soclinux_bankmachine2_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine2_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine2_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine3_sink_valid = main_sdram_bankmachine3_req_valid;
assign main_sdram_bankmachine3_req_ready = main_sdram_bankmachine3_sink_ready;
assign main_sdram_bankmachine3_sink_payload_we = main_sdram_bankmachine3_req_we;
assign main_sdram_bankmachine3_sink_payload_addr = main_sdram_bankmachine3_req_addr;
assign main_sdram_bankmachine3_sink_sink_valid = main_sdram_bankmachine3_source_valid;
assign main_sdram_bankmachine3_source_ready = main_sdram_bankmachine3_sink_sink_ready;
assign main_sdram_bankmachine3_sink_sink_first = main_sdram_bankmachine3_source_first;
assign main_sdram_bankmachine3_sink_sink_last = main_sdram_bankmachine3_source_last;
assign main_sdram_bankmachine3_sink_sink_payload_we = main_sdram_bankmachine3_source_payload_we;
assign main_sdram_bankmachine3_sink_sink_payload_addr = main_sdram_bankmachine3_source_payload_addr;
assign main_sdram_bankmachine3_source_source_ready = (main_sdram_bankmachine3_req_wdata_ready | main_sdram_bankmachine3_req_rdata_valid);
assign main_sdram_bankmachine3_req_lock = (main_sdram_bankmachine3_source_valid | main_sdram_bankmachine3_source_source_valid);
assign main_sdram_bankmachine3_row_hit = (main_sdram_bankmachine3_row == main_sdram_bankmachine3_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine3_cmd_payload_ba = 2'd3;
always @(*) begin
    main_sdram_bankmachine3_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine3_row_col_n_addr_sel) begin
        main_sdram_bankmachine3_cmd_payload_a <= main_sdram_bankmachine3_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine3_cmd_payload_a <= ((main_sdram_bankmachine3_auto_precharge <<< 4'd10) | {main_sdram_bankmachine3_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine3_twtpcon_valid = ((main_sdram_bankmachine3_cmd_valid & main_sdram_bankmachine3_cmd_ready) & main_sdram_bankmachine3_cmd_payload_is_write);
assign main_sdram_bankmachine3_trccon_valid = ((main_sdram_bankmachine3_cmd_valid & main_sdram_bankmachine3_cmd_ready) & main_sdram_bankmachine3_row_open);
assign main_sdram_bankmachine3_trascon_valid = ((main_sdram_bankmachine3_cmd_valid & main_sdram_bankmachine3_cmd_ready) & main_sdram_bankmachine3_row_open);
always @(*) begin
    main_sdram_bankmachine3_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine3_source_valid & main_sdram_bankmachine3_source_source_valid)) begin
        if ((main_sdram_bankmachine3_source_payload_addr[21:7] != main_sdram_bankmachine3_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine3_auto_precharge <= (main_sdram_bankmachine3_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine3_syncfifo3_din = {main_sdram_bankmachine3_fifo_in_last, main_sdram_bankmachine3_fifo_in_first, main_sdram_bankmachine3_fifo_in_payload_addr, main_sdram_bankmachine3_fifo_in_payload_we};
assign {main_sdram_bankmachine3_fifo_out_last, main_sdram_bankmachine3_fifo_out_first, main_sdram_bankmachine3_fifo_out_payload_addr, main_sdram_bankmachine3_fifo_out_payload_we} = main_sdram_bankmachine3_syncfifo3_dout;
assign main_sdram_bankmachine3_sink_ready = main_sdram_bankmachine3_syncfifo3_writable;
assign main_sdram_bankmachine3_syncfifo3_we = main_sdram_bankmachine3_sink_valid;
assign main_sdram_bankmachine3_fifo_in_first = main_sdram_bankmachine3_sink_first;
assign main_sdram_bankmachine3_fifo_in_last = main_sdram_bankmachine3_sink_last;
assign main_sdram_bankmachine3_fifo_in_payload_we = main_sdram_bankmachine3_sink_payload_we;
assign main_sdram_bankmachine3_fifo_in_payload_addr = main_sdram_bankmachine3_sink_payload_addr;
assign main_sdram_bankmachine3_source_valid = main_sdram_bankmachine3_syncfifo3_readable;
assign main_sdram_bankmachine3_source_first = main_sdram_bankmachine3_fifo_out_first;
assign main_sdram_bankmachine3_source_last = main_sdram_bankmachine3_fifo_out_last;
assign main_sdram_bankmachine3_source_payload_we = main_sdram_bankmachine3_fifo_out_payload_we;
assign main_sdram_bankmachine3_source_payload_addr = main_sdram_bankmachine3_fifo_out_payload_addr;
assign main_sdram_bankmachine3_syncfifo3_re = main_sdram_bankmachine3_source_ready;
always @(*) begin
    main_sdram_bankmachine3_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine3_replace) begin
        main_sdram_bankmachine3_wrport_adr <= (main_sdram_bankmachine3_produce - 1'd1);
    end else begin
        main_sdram_bankmachine3_wrport_adr <= main_sdram_bankmachine3_produce;
    end
end
assign main_sdram_bankmachine3_wrport_dat_w = main_sdram_bankmachine3_syncfifo3_din;
assign main_sdram_bankmachine3_wrport_we = (main_sdram_bankmachine3_syncfifo3_we & (main_sdram_bankmachine3_syncfifo3_writable | main_sdram_bankmachine3_replace));
assign main_sdram_bankmachine3_do_read = (main_sdram_bankmachine3_syncfifo3_readable & main_sdram_bankmachine3_syncfifo3_re);
assign main_sdram_bankmachine3_rdport_adr = main_sdram_bankmachine3_consume;
assign main_sdram_bankmachine3_syncfifo3_dout = main_sdram_bankmachine3_rdport_dat_r;
assign main_sdram_bankmachine3_syncfifo3_writable = (main_sdram_bankmachine3_level != 4'd8);
assign main_sdram_bankmachine3_syncfifo3_readable = (main_sdram_bankmachine3_level != 1'd0);
assign main_sdram_bankmachine3_pipe_valid_sink_ready = ((~main_sdram_bankmachine3_pipe_valid_source_valid) | main_sdram_bankmachine3_pipe_valid_source_ready);
assign main_sdram_bankmachine3_pipe_valid_sink_valid = main_sdram_bankmachine3_sink_sink_valid;
assign main_sdram_bankmachine3_sink_sink_ready = main_sdram_bankmachine3_pipe_valid_sink_ready;
assign main_sdram_bankmachine3_pipe_valid_sink_first = main_sdram_bankmachine3_sink_sink_first;
assign main_sdram_bankmachine3_pipe_valid_sink_last = main_sdram_bankmachine3_sink_sink_last;
assign main_sdram_bankmachine3_pipe_valid_sink_payload_we = main_sdram_bankmachine3_sink_sink_payload_we;
assign main_sdram_bankmachine3_pipe_valid_sink_payload_addr = main_sdram_bankmachine3_sink_sink_payload_addr;
assign main_sdram_bankmachine3_source_source_valid = main_sdram_bankmachine3_pipe_valid_source_valid;
assign main_sdram_bankmachine3_pipe_valid_source_ready = main_sdram_bankmachine3_source_source_ready;
assign main_sdram_bankmachine3_source_source_first = main_sdram_bankmachine3_pipe_valid_source_first;
assign main_sdram_bankmachine3_source_source_last = main_sdram_bankmachine3_pipe_valid_source_last;
assign main_sdram_bankmachine3_source_source_payload_we = main_sdram_bankmachine3_pipe_valid_source_payload_we;
assign main_sdram_bankmachine3_source_source_payload_addr = main_sdram_bankmachine3_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine3_refresh_gnt <= 1'd0;
    main_sdram_bankmachine3_row_open <= 1'd0;
    main_sdram_bankmachine3_cmd_valid <= 1'd0;
    main_sdram_bankmachine3_row_close <= 1'd0;
    main_sdram_bankmachine3_row_col_n_addr_sel <= 1'd0;
    main_sdram_bankmachine3_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine3_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine3_cmd_payload_we <= 1'd0;
    main_sdram_bankmachine3_cmd_payload_is_cmd <= 1'd0;
    builder_soclinux_bankmachine3_next_state <= 4'd0;
    main_sdram_bankmachine3_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine3_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine3_req_wdata_ready <= 1'd0;
    main_sdram_bankmachine3_req_rdata_valid <= 1'd0;
    builder_soclinux_bankmachine3_next_state <= builder_soclinux_bankmachine3_state;
    case (builder_soclinux_bankmachine3_state)
        1'd1: begin
            if ((main_sdram_bankmachine3_twtpcon_ready & main_sdram_bankmachine3_trascon_ready)) begin
                main_sdram_bankmachine3_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine3_cmd_ready) begin
                    builder_soclinux_bankmachine3_next_state <= 3'd5;
                end
                main_sdram_bankmachine3_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine3_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine3_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine3_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine3_twtpcon_ready & main_sdram_bankmachine3_trascon_ready)) begin
                builder_soclinux_bankmachine3_next_state <= 3'd5;
            end
            main_sdram_bankmachine3_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine3_trccon_ready) begin
                main_sdram_bankmachine3_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine3_row_open <= 1'd1;
                main_sdram_bankmachine3_cmd_valid <= 1'd1;
                main_sdram_bankmachine3_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine3_cmd_ready) begin
                    builder_soclinux_bankmachine3_next_state <= 3'd7;
                end
                main_sdram_bankmachine3_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine3_twtpcon_ready) begin
                main_sdram_bankmachine3_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine3_row_close <= 1'd1;
            main_sdram_bankmachine3_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine3_refresh_req)) begin
                builder_soclinux_bankmachine3_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine3_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine3_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine3_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine3_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine3_refresh_req) begin
                builder_soclinux_bankmachine3_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine3_source_source_valid) begin
                    if (main_sdram_bankmachine3_row_opened) begin
                        if (main_sdram_bankmachine3_row_hit) begin
                            main_sdram_bankmachine3_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine3_source_source_payload_we) begin
                                main_sdram_bankmachine3_req_wdata_ready <= main_sdram_bankmachine3_cmd_ready;
                                main_sdram_bankmachine3_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine3_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine3_req_rdata_valid <= main_sdram_bankmachine3_cmd_ready;
                                main_sdram_bankmachine3_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine3_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine3_cmd_ready & main_sdram_bankmachine3_auto_precharge)) begin
                                builder_soclinux_bankmachine3_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine3_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine3_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine4_sink_valid = main_sdram_bankmachine4_req_valid;
assign main_sdram_bankmachine4_req_ready = main_sdram_bankmachine4_sink_ready;
assign main_sdram_bankmachine4_sink_payload_we = main_sdram_bankmachine4_req_we;
assign main_sdram_bankmachine4_sink_payload_addr = main_sdram_bankmachine4_req_addr;
assign main_sdram_bankmachine4_sink_sink_valid = main_sdram_bankmachine4_source_valid;
assign main_sdram_bankmachine4_source_ready = main_sdram_bankmachine4_sink_sink_ready;
assign main_sdram_bankmachine4_sink_sink_first = main_sdram_bankmachine4_source_first;
assign main_sdram_bankmachine4_sink_sink_last = main_sdram_bankmachine4_source_last;
assign main_sdram_bankmachine4_sink_sink_payload_we = main_sdram_bankmachine4_source_payload_we;
assign main_sdram_bankmachine4_sink_sink_payload_addr = main_sdram_bankmachine4_source_payload_addr;
assign main_sdram_bankmachine4_source_source_ready = (main_sdram_bankmachine4_req_wdata_ready | main_sdram_bankmachine4_req_rdata_valid);
assign main_sdram_bankmachine4_req_lock = (main_sdram_bankmachine4_source_valid | main_sdram_bankmachine4_source_source_valid);
assign main_sdram_bankmachine4_row_hit = (main_sdram_bankmachine4_row == main_sdram_bankmachine4_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine4_cmd_payload_ba = 3'd4;
always @(*) begin
    main_sdram_bankmachine4_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine4_row_col_n_addr_sel) begin
        main_sdram_bankmachine4_cmd_payload_a <= main_sdram_bankmachine4_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine4_cmd_payload_a <= ((main_sdram_bankmachine4_auto_precharge <<< 4'd10) | {main_sdram_bankmachine4_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine4_twtpcon_valid = ((main_sdram_bankmachine4_cmd_valid & main_sdram_bankmachine4_cmd_ready) & main_sdram_bankmachine4_cmd_payload_is_write);
assign main_sdram_bankmachine4_trccon_valid = ((main_sdram_bankmachine4_cmd_valid & main_sdram_bankmachine4_cmd_ready) & main_sdram_bankmachine4_row_open);
assign main_sdram_bankmachine4_trascon_valid = ((main_sdram_bankmachine4_cmd_valid & main_sdram_bankmachine4_cmd_ready) & main_sdram_bankmachine4_row_open);
always @(*) begin
    main_sdram_bankmachine4_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine4_source_valid & main_sdram_bankmachine4_source_source_valid)) begin
        if ((main_sdram_bankmachine4_source_payload_addr[21:7] != main_sdram_bankmachine4_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine4_auto_precharge <= (main_sdram_bankmachine4_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine4_syncfifo4_din = {main_sdram_bankmachine4_fifo_in_last, main_sdram_bankmachine4_fifo_in_first, main_sdram_bankmachine4_fifo_in_payload_addr, main_sdram_bankmachine4_fifo_in_payload_we};
assign {main_sdram_bankmachine4_fifo_out_last, main_sdram_bankmachine4_fifo_out_first, main_sdram_bankmachine4_fifo_out_payload_addr, main_sdram_bankmachine4_fifo_out_payload_we} = main_sdram_bankmachine4_syncfifo4_dout;
assign main_sdram_bankmachine4_sink_ready = main_sdram_bankmachine4_syncfifo4_writable;
assign main_sdram_bankmachine4_syncfifo4_we = main_sdram_bankmachine4_sink_valid;
assign main_sdram_bankmachine4_fifo_in_first = main_sdram_bankmachine4_sink_first;
assign main_sdram_bankmachine4_fifo_in_last = main_sdram_bankmachine4_sink_last;
assign main_sdram_bankmachine4_fifo_in_payload_we = main_sdram_bankmachine4_sink_payload_we;
assign main_sdram_bankmachine4_fifo_in_payload_addr = main_sdram_bankmachine4_sink_payload_addr;
assign main_sdram_bankmachine4_source_valid = main_sdram_bankmachine4_syncfifo4_readable;
assign main_sdram_bankmachine4_source_first = main_sdram_bankmachine4_fifo_out_first;
assign main_sdram_bankmachine4_source_last = main_sdram_bankmachine4_fifo_out_last;
assign main_sdram_bankmachine4_source_payload_we = main_sdram_bankmachine4_fifo_out_payload_we;
assign main_sdram_bankmachine4_source_payload_addr = main_sdram_bankmachine4_fifo_out_payload_addr;
assign main_sdram_bankmachine4_syncfifo4_re = main_sdram_bankmachine4_source_ready;
always @(*) begin
    main_sdram_bankmachine4_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine4_replace) begin
        main_sdram_bankmachine4_wrport_adr <= (main_sdram_bankmachine4_produce - 1'd1);
    end else begin
        main_sdram_bankmachine4_wrport_adr <= main_sdram_bankmachine4_produce;
    end
end
assign main_sdram_bankmachine4_wrport_dat_w = main_sdram_bankmachine4_syncfifo4_din;
assign main_sdram_bankmachine4_wrport_we = (main_sdram_bankmachine4_syncfifo4_we & (main_sdram_bankmachine4_syncfifo4_writable | main_sdram_bankmachine4_replace));
assign main_sdram_bankmachine4_do_read = (main_sdram_bankmachine4_syncfifo4_readable & main_sdram_bankmachine4_syncfifo4_re);
assign main_sdram_bankmachine4_rdport_adr = main_sdram_bankmachine4_consume;
assign main_sdram_bankmachine4_syncfifo4_dout = main_sdram_bankmachine4_rdport_dat_r;
assign main_sdram_bankmachine4_syncfifo4_writable = (main_sdram_bankmachine4_level != 4'd8);
assign main_sdram_bankmachine4_syncfifo4_readable = (main_sdram_bankmachine4_level != 1'd0);
assign main_sdram_bankmachine4_pipe_valid_sink_ready = ((~main_sdram_bankmachine4_pipe_valid_source_valid) | main_sdram_bankmachine4_pipe_valid_source_ready);
assign main_sdram_bankmachine4_pipe_valid_sink_valid = main_sdram_bankmachine4_sink_sink_valid;
assign main_sdram_bankmachine4_sink_sink_ready = main_sdram_bankmachine4_pipe_valid_sink_ready;
assign main_sdram_bankmachine4_pipe_valid_sink_first = main_sdram_bankmachine4_sink_sink_first;
assign main_sdram_bankmachine4_pipe_valid_sink_last = main_sdram_bankmachine4_sink_sink_last;
assign main_sdram_bankmachine4_pipe_valid_sink_payload_we = main_sdram_bankmachine4_sink_sink_payload_we;
assign main_sdram_bankmachine4_pipe_valid_sink_payload_addr = main_sdram_bankmachine4_sink_sink_payload_addr;
assign main_sdram_bankmachine4_source_source_valid = main_sdram_bankmachine4_pipe_valid_source_valid;
assign main_sdram_bankmachine4_pipe_valid_source_ready = main_sdram_bankmachine4_source_source_ready;
assign main_sdram_bankmachine4_source_source_first = main_sdram_bankmachine4_pipe_valid_source_first;
assign main_sdram_bankmachine4_source_source_last = main_sdram_bankmachine4_pipe_valid_source_last;
assign main_sdram_bankmachine4_source_source_payload_we = main_sdram_bankmachine4_pipe_valid_source_payload_we;
assign main_sdram_bankmachine4_source_source_payload_addr = main_sdram_bankmachine4_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine4_row_col_n_addr_sel <= 1'd0;
    main_sdram_bankmachine4_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine4_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine4_cmd_payload_we <= 1'd0;
    main_sdram_bankmachine4_cmd_payload_is_cmd <= 1'd0;
    main_sdram_bankmachine4_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine4_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine4_req_wdata_ready <= 1'd0;
    builder_soclinux_bankmachine4_next_state <= 4'd0;
    main_sdram_bankmachine4_refresh_gnt <= 1'd0;
    main_sdram_bankmachine4_row_open <= 1'd0;
    main_sdram_bankmachine4_cmd_valid <= 1'd0;
    main_sdram_bankmachine4_row_close <= 1'd0;
    main_sdram_bankmachine4_req_rdata_valid <= 1'd0;
    builder_soclinux_bankmachine4_next_state <= builder_soclinux_bankmachine4_state;
    case (builder_soclinux_bankmachine4_state)
        1'd1: begin
            if ((main_sdram_bankmachine4_twtpcon_ready & main_sdram_bankmachine4_trascon_ready)) begin
                main_sdram_bankmachine4_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine4_cmd_ready) begin
                    builder_soclinux_bankmachine4_next_state <= 3'd5;
                end
                main_sdram_bankmachine4_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine4_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine4_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine4_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine4_twtpcon_ready & main_sdram_bankmachine4_trascon_ready)) begin
                builder_soclinux_bankmachine4_next_state <= 3'd5;
            end
            main_sdram_bankmachine4_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine4_trccon_ready) begin
                main_sdram_bankmachine4_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine4_row_open <= 1'd1;
                main_sdram_bankmachine4_cmd_valid <= 1'd1;
                main_sdram_bankmachine4_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine4_cmd_ready) begin
                    builder_soclinux_bankmachine4_next_state <= 3'd7;
                end
                main_sdram_bankmachine4_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine4_twtpcon_ready) begin
                main_sdram_bankmachine4_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine4_row_close <= 1'd1;
            main_sdram_bankmachine4_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine4_refresh_req)) begin
                builder_soclinux_bankmachine4_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine4_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine4_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine4_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine4_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine4_refresh_req) begin
                builder_soclinux_bankmachine4_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine4_source_source_valid) begin
                    if (main_sdram_bankmachine4_row_opened) begin
                        if (main_sdram_bankmachine4_row_hit) begin
                            main_sdram_bankmachine4_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine4_source_source_payload_we) begin
                                main_sdram_bankmachine4_req_wdata_ready <= main_sdram_bankmachine4_cmd_ready;
                                main_sdram_bankmachine4_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine4_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine4_req_rdata_valid <= main_sdram_bankmachine4_cmd_ready;
                                main_sdram_bankmachine4_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine4_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine4_cmd_ready & main_sdram_bankmachine4_auto_precharge)) begin
                                builder_soclinux_bankmachine4_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine4_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine4_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine5_sink_valid = main_sdram_bankmachine5_req_valid;
assign main_sdram_bankmachine5_req_ready = main_sdram_bankmachine5_sink_ready;
assign main_sdram_bankmachine5_sink_payload_we = main_sdram_bankmachine5_req_we;
assign main_sdram_bankmachine5_sink_payload_addr = main_sdram_bankmachine5_req_addr;
assign main_sdram_bankmachine5_sink_sink_valid = main_sdram_bankmachine5_source_valid;
assign main_sdram_bankmachine5_source_ready = main_sdram_bankmachine5_sink_sink_ready;
assign main_sdram_bankmachine5_sink_sink_first = main_sdram_bankmachine5_source_first;
assign main_sdram_bankmachine5_sink_sink_last = main_sdram_bankmachine5_source_last;
assign main_sdram_bankmachine5_sink_sink_payload_we = main_sdram_bankmachine5_source_payload_we;
assign main_sdram_bankmachine5_sink_sink_payload_addr = main_sdram_bankmachine5_source_payload_addr;
assign main_sdram_bankmachine5_source_source_ready = (main_sdram_bankmachine5_req_wdata_ready | main_sdram_bankmachine5_req_rdata_valid);
assign main_sdram_bankmachine5_req_lock = (main_sdram_bankmachine5_source_valid | main_sdram_bankmachine5_source_source_valid);
assign main_sdram_bankmachine5_row_hit = (main_sdram_bankmachine5_row == main_sdram_bankmachine5_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine5_cmd_payload_ba = 3'd5;
always @(*) begin
    main_sdram_bankmachine5_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine5_row_col_n_addr_sel) begin
        main_sdram_bankmachine5_cmd_payload_a <= main_sdram_bankmachine5_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine5_cmd_payload_a <= ((main_sdram_bankmachine5_auto_precharge <<< 4'd10) | {main_sdram_bankmachine5_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine5_twtpcon_valid = ((main_sdram_bankmachine5_cmd_valid & main_sdram_bankmachine5_cmd_ready) & main_sdram_bankmachine5_cmd_payload_is_write);
assign main_sdram_bankmachine5_trccon_valid = ((main_sdram_bankmachine5_cmd_valid & main_sdram_bankmachine5_cmd_ready) & main_sdram_bankmachine5_row_open);
assign main_sdram_bankmachine5_trascon_valid = ((main_sdram_bankmachine5_cmd_valid & main_sdram_bankmachine5_cmd_ready) & main_sdram_bankmachine5_row_open);
always @(*) begin
    main_sdram_bankmachine5_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine5_source_valid & main_sdram_bankmachine5_source_source_valid)) begin
        if ((main_sdram_bankmachine5_source_payload_addr[21:7] != main_sdram_bankmachine5_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine5_auto_precharge <= (main_sdram_bankmachine5_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine5_syncfifo5_din = {main_sdram_bankmachine5_fifo_in_last, main_sdram_bankmachine5_fifo_in_first, main_sdram_bankmachine5_fifo_in_payload_addr, main_sdram_bankmachine5_fifo_in_payload_we};
assign {main_sdram_bankmachine5_fifo_out_last, main_sdram_bankmachine5_fifo_out_first, main_sdram_bankmachine5_fifo_out_payload_addr, main_sdram_bankmachine5_fifo_out_payload_we} = main_sdram_bankmachine5_syncfifo5_dout;
assign main_sdram_bankmachine5_sink_ready = main_sdram_bankmachine5_syncfifo5_writable;
assign main_sdram_bankmachine5_syncfifo5_we = main_sdram_bankmachine5_sink_valid;
assign main_sdram_bankmachine5_fifo_in_first = main_sdram_bankmachine5_sink_first;
assign main_sdram_bankmachine5_fifo_in_last = main_sdram_bankmachine5_sink_last;
assign main_sdram_bankmachine5_fifo_in_payload_we = main_sdram_bankmachine5_sink_payload_we;
assign main_sdram_bankmachine5_fifo_in_payload_addr = main_sdram_bankmachine5_sink_payload_addr;
assign main_sdram_bankmachine5_source_valid = main_sdram_bankmachine5_syncfifo5_readable;
assign main_sdram_bankmachine5_source_first = main_sdram_bankmachine5_fifo_out_first;
assign main_sdram_bankmachine5_source_last = main_sdram_bankmachine5_fifo_out_last;
assign main_sdram_bankmachine5_source_payload_we = main_sdram_bankmachine5_fifo_out_payload_we;
assign main_sdram_bankmachine5_source_payload_addr = main_sdram_bankmachine5_fifo_out_payload_addr;
assign main_sdram_bankmachine5_syncfifo5_re = main_sdram_bankmachine5_source_ready;
always @(*) begin
    main_sdram_bankmachine5_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine5_replace) begin
        main_sdram_bankmachine5_wrport_adr <= (main_sdram_bankmachine5_produce - 1'd1);
    end else begin
        main_sdram_bankmachine5_wrport_adr <= main_sdram_bankmachine5_produce;
    end
end
assign main_sdram_bankmachine5_wrport_dat_w = main_sdram_bankmachine5_syncfifo5_din;
assign main_sdram_bankmachine5_wrport_we = (main_sdram_bankmachine5_syncfifo5_we & (main_sdram_bankmachine5_syncfifo5_writable | main_sdram_bankmachine5_replace));
assign main_sdram_bankmachine5_do_read = (main_sdram_bankmachine5_syncfifo5_readable & main_sdram_bankmachine5_syncfifo5_re);
assign main_sdram_bankmachine5_rdport_adr = main_sdram_bankmachine5_consume;
assign main_sdram_bankmachine5_syncfifo5_dout = main_sdram_bankmachine5_rdport_dat_r;
assign main_sdram_bankmachine5_syncfifo5_writable = (main_sdram_bankmachine5_level != 4'd8);
assign main_sdram_bankmachine5_syncfifo5_readable = (main_sdram_bankmachine5_level != 1'd0);
assign main_sdram_bankmachine5_pipe_valid_sink_ready = ((~main_sdram_bankmachine5_pipe_valid_source_valid) | main_sdram_bankmachine5_pipe_valid_source_ready);
assign main_sdram_bankmachine5_pipe_valid_sink_valid = main_sdram_bankmachine5_sink_sink_valid;
assign main_sdram_bankmachine5_sink_sink_ready = main_sdram_bankmachine5_pipe_valid_sink_ready;
assign main_sdram_bankmachine5_pipe_valid_sink_first = main_sdram_bankmachine5_sink_sink_first;
assign main_sdram_bankmachine5_pipe_valid_sink_last = main_sdram_bankmachine5_sink_sink_last;
assign main_sdram_bankmachine5_pipe_valid_sink_payload_we = main_sdram_bankmachine5_sink_sink_payload_we;
assign main_sdram_bankmachine5_pipe_valid_sink_payload_addr = main_sdram_bankmachine5_sink_sink_payload_addr;
assign main_sdram_bankmachine5_source_source_valid = main_sdram_bankmachine5_pipe_valid_source_valid;
assign main_sdram_bankmachine5_pipe_valid_source_ready = main_sdram_bankmachine5_source_source_ready;
assign main_sdram_bankmachine5_source_source_first = main_sdram_bankmachine5_pipe_valid_source_first;
assign main_sdram_bankmachine5_source_source_last = main_sdram_bankmachine5_pipe_valid_source_last;
assign main_sdram_bankmachine5_source_source_payload_we = main_sdram_bankmachine5_pipe_valid_source_payload_we;
assign main_sdram_bankmachine5_source_source_payload_addr = main_sdram_bankmachine5_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine5_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine5_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine5_cmd_payload_we <= 1'd0;
    main_sdram_bankmachine5_cmd_payload_is_cmd <= 1'd0;
    main_sdram_bankmachine5_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine5_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine5_req_wdata_ready <= 1'd0;
    main_sdram_bankmachine5_req_rdata_valid <= 1'd0;
    main_sdram_bankmachine5_refresh_gnt <= 1'd0;
    main_sdram_bankmachine5_row_open <= 1'd0;
    main_sdram_bankmachine5_cmd_valid <= 1'd0;
    main_sdram_bankmachine5_row_close <= 1'd0;
    builder_soclinux_bankmachine5_next_state <= 4'd0;
    main_sdram_bankmachine5_row_col_n_addr_sel <= 1'd0;
    builder_soclinux_bankmachine5_next_state <= builder_soclinux_bankmachine5_state;
    case (builder_soclinux_bankmachine5_state)
        1'd1: begin
            if ((main_sdram_bankmachine5_twtpcon_ready & main_sdram_bankmachine5_trascon_ready)) begin
                main_sdram_bankmachine5_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine5_cmd_ready) begin
                    builder_soclinux_bankmachine5_next_state <= 3'd5;
                end
                main_sdram_bankmachine5_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine5_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine5_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine5_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine5_twtpcon_ready & main_sdram_bankmachine5_trascon_ready)) begin
                builder_soclinux_bankmachine5_next_state <= 3'd5;
            end
            main_sdram_bankmachine5_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine5_trccon_ready) begin
                main_sdram_bankmachine5_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine5_row_open <= 1'd1;
                main_sdram_bankmachine5_cmd_valid <= 1'd1;
                main_sdram_bankmachine5_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine5_cmd_ready) begin
                    builder_soclinux_bankmachine5_next_state <= 3'd7;
                end
                main_sdram_bankmachine5_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine5_twtpcon_ready) begin
                main_sdram_bankmachine5_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine5_row_close <= 1'd1;
            main_sdram_bankmachine5_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine5_refresh_req)) begin
                builder_soclinux_bankmachine5_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine5_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine5_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine5_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine5_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine5_refresh_req) begin
                builder_soclinux_bankmachine5_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine5_source_source_valid) begin
                    if (main_sdram_bankmachine5_row_opened) begin
                        if (main_sdram_bankmachine5_row_hit) begin
                            main_sdram_bankmachine5_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine5_source_source_payload_we) begin
                                main_sdram_bankmachine5_req_wdata_ready <= main_sdram_bankmachine5_cmd_ready;
                                main_sdram_bankmachine5_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine5_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine5_req_rdata_valid <= main_sdram_bankmachine5_cmd_ready;
                                main_sdram_bankmachine5_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine5_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine5_cmd_ready & main_sdram_bankmachine5_auto_precharge)) begin
                                builder_soclinux_bankmachine5_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine5_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine5_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine6_sink_valid = main_sdram_bankmachine6_req_valid;
assign main_sdram_bankmachine6_req_ready = main_sdram_bankmachine6_sink_ready;
assign main_sdram_bankmachine6_sink_payload_we = main_sdram_bankmachine6_req_we;
assign main_sdram_bankmachine6_sink_payload_addr = main_sdram_bankmachine6_req_addr;
assign main_sdram_bankmachine6_sink_sink_valid = main_sdram_bankmachine6_source_valid;
assign main_sdram_bankmachine6_source_ready = main_sdram_bankmachine6_sink_sink_ready;
assign main_sdram_bankmachine6_sink_sink_first = main_sdram_bankmachine6_source_first;
assign main_sdram_bankmachine6_sink_sink_last = main_sdram_bankmachine6_source_last;
assign main_sdram_bankmachine6_sink_sink_payload_we = main_sdram_bankmachine6_source_payload_we;
assign main_sdram_bankmachine6_sink_sink_payload_addr = main_sdram_bankmachine6_source_payload_addr;
assign main_sdram_bankmachine6_source_source_ready = (main_sdram_bankmachine6_req_wdata_ready | main_sdram_bankmachine6_req_rdata_valid);
assign main_sdram_bankmachine6_req_lock = (main_sdram_bankmachine6_source_valid | main_sdram_bankmachine6_source_source_valid);
assign main_sdram_bankmachine6_row_hit = (main_sdram_bankmachine6_row == main_sdram_bankmachine6_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine6_cmd_payload_ba = 3'd6;
always @(*) begin
    main_sdram_bankmachine6_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine6_row_col_n_addr_sel) begin
        main_sdram_bankmachine6_cmd_payload_a <= main_sdram_bankmachine6_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine6_cmd_payload_a <= ((main_sdram_bankmachine6_auto_precharge <<< 4'd10) | {main_sdram_bankmachine6_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine6_twtpcon_valid = ((main_sdram_bankmachine6_cmd_valid & main_sdram_bankmachine6_cmd_ready) & main_sdram_bankmachine6_cmd_payload_is_write);
assign main_sdram_bankmachine6_trccon_valid = ((main_sdram_bankmachine6_cmd_valid & main_sdram_bankmachine6_cmd_ready) & main_sdram_bankmachine6_row_open);
assign main_sdram_bankmachine6_trascon_valid = ((main_sdram_bankmachine6_cmd_valid & main_sdram_bankmachine6_cmd_ready) & main_sdram_bankmachine6_row_open);
always @(*) begin
    main_sdram_bankmachine6_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine6_source_valid & main_sdram_bankmachine6_source_source_valid)) begin
        if ((main_sdram_bankmachine6_source_payload_addr[21:7] != main_sdram_bankmachine6_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine6_auto_precharge <= (main_sdram_bankmachine6_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine6_syncfifo6_din = {main_sdram_bankmachine6_fifo_in_last, main_sdram_bankmachine6_fifo_in_first, main_sdram_bankmachine6_fifo_in_payload_addr, main_sdram_bankmachine6_fifo_in_payload_we};
assign {main_sdram_bankmachine6_fifo_out_last, main_sdram_bankmachine6_fifo_out_first, main_sdram_bankmachine6_fifo_out_payload_addr, main_sdram_bankmachine6_fifo_out_payload_we} = main_sdram_bankmachine6_syncfifo6_dout;
assign main_sdram_bankmachine6_sink_ready = main_sdram_bankmachine6_syncfifo6_writable;
assign main_sdram_bankmachine6_syncfifo6_we = main_sdram_bankmachine6_sink_valid;
assign main_sdram_bankmachine6_fifo_in_first = main_sdram_bankmachine6_sink_first;
assign main_sdram_bankmachine6_fifo_in_last = main_sdram_bankmachine6_sink_last;
assign main_sdram_bankmachine6_fifo_in_payload_we = main_sdram_bankmachine6_sink_payload_we;
assign main_sdram_bankmachine6_fifo_in_payload_addr = main_sdram_bankmachine6_sink_payload_addr;
assign main_sdram_bankmachine6_source_valid = main_sdram_bankmachine6_syncfifo6_readable;
assign main_sdram_bankmachine6_source_first = main_sdram_bankmachine6_fifo_out_first;
assign main_sdram_bankmachine6_source_last = main_sdram_bankmachine6_fifo_out_last;
assign main_sdram_bankmachine6_source_payload_we = main_sdram_bankmachine6_fifo_out_payload_we;
assign main_sdram_bankmachine6_source_payload_addr = main_sdram_bankmachine6_fifo_out_payload_addr;
assign main_sdram_bankmachine6_syncfifo6_re = main_sdram_bankmachine6_source_ready;
always @(*) begin
    main_sdram_bankmachine6_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine6_replace) begin
        main_sdram_bankmachine6_wrport_adr <= (main_sdram_bankmachine6_produce - 1'd1);
    end else begin
        main_sdram_bankmachine6_wrport_adr <= main_sdram_bankmachine6_produce;
    end
end
assign main_sdram_bankmachine6_wrport_dat_w = main_sdram_bankmachine6_syncfifo6_din;
assign main_sdram_bankmachine6_wrport_we = (main_sdram_bankmachine6_syncfifo6_we & (main_sdram_bankmachine6_syncfifo6_writable | main_sdram_bankmachine6_replace));
assign main_sdram_bankmachine6_do_read = (main_sdram_bankmachine6_syncfifo6_readable & main_sdram_bankmachine6_syncfifo6_re);
assign main_sdram_bankmachine6_rdport_adr = main_sdram_bankmachine6_consume;
assign main_sdram_bankmachine6_syncfifo6_dout = main_sdram_bankmachine6_rdport_dat_r;
assign main_sdram_bankmachine6_syncfifo6_writable = (main_sdram_bankmachine6_level != 4'd8);
assign main_sdram_bankmachine6_syncfifo6_readable = (main_sdram_bankmachine6_level != 1'd0);
assign main_sdram_bankmachine6_pipe_valid_sink_ready = ((~main_sdram_bankmachine6_pipe_valid_source_valid) | main_sdram_bankmachine6_pipe_valid_source_ready);
assign main_sdram_bankmachine6_pipe_valid_sink_valid = main_sdram_bankmachine6_sink_sink_valid;
assign main_sdram_bankmachine6_sink_sink_ready = main_sdram_bankmachine6_pipe_valid_sink_ready;
assign main_sdram_bankmachine6_pipe_valid_sink_first = main_sdram_bankmachine6_sink_sink_first;
assign main_sdram_bankmachine6_pipe_valid_sink_last = main_sdram_bankmachine6_sink_sink_last;
assign main_sdram_bankmachine6_pipe_valid_sink_payload_we = main_sdram_bankmachine6_sink_sink_payload_we;
assign main_sdram_bankmachine6_pipe_valid_sink_payload_addr = main_sdram_bankmachine6_sink_sink_payload_addr;
assign main_sdram_bankmachine6_source_source_valid = main_sdram_bankmachine6_pipe_valid_source_valid;
assign main_sdram_bankmachine6_pipe_valid_source_ready = main_sdram_bankmachine6_source_source_ready;
assign main_sdram_bankmachine6_source_source_first = main_sdram_bankmachine6_pipe_valid_source_first;
assign main_sdram_bankmachine6_source_source_last = main_sdram_bankmachine6_pipe_valid_source_last;
assign main_sdram_bankmachine6_source_source_payload_we = main_sdram_bankmachine6_pipe_valid_source_payload_we;
assign main_sdram_bankmachine6_source_source_payload_addr = main_sdram_bankmachine6_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine6_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine6_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine6_req_wdata_ready <= 1'd0;
    main_sdram_bankmachine6_req_rdata_valid <= 1'd0;
    main_sdram_bankmachine6_refresh_gnt <= 1'd0;
    main_sdram_bankmachine6_row_open <= 1'd0;
    main_sdram_bankmachine6_cmd_valid <= 1'd0;
    main_sdram_bankmachine6_row_close <= 1'd0;
    main_sdram_bankmachine6_row_col_n_addr_sel <= 1'd0;
    builder_soclinux_bankmachine6_next_state <= 4'd0;
    main_sdram_bankmachine6_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine6_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine6_cmd_payload_we <= 1'd0;
    main_sdram_bankmachine6_cmd_payload_is_cmd <= 1'd0;
    builder_soclinux_bankmachine6_next_state <= builder_soclinux_bankmachine6_state;
    case (builder_soclinux_bankmachine6_state)
        1'd1: begin
            if ((main_sdram_bankmachine6_twtpcon_ready & main_sdram_bankmachine6_trascon_ready)) begin
                main_sdram_bankmachine6_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine6_cmd_ready) begin
                    builder_soclinux_bankmachine6_next_state <= 3'd5;
                end
                main_sdram_bankmachine6_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine6_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine6_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine6_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine6_twtpcon_ready & main_sdram_bankmachine6_trascon_ready)) begin
                builder_soclinux_bankmachine6_next_state <= 3'd5;
            end
            main_sdram_bankmachine6_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine6_trccon_ready) begin
                main_sdram_bankmachine6_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine6_row_open <= 1'd1;
                main_sdram_bankmachine6_cmd_valid <= 1'd1;
                main_sdram_bankmachine6_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine6_cmd_ready) begin
                    builder_soclinux_bankmachine6_next_state <= 3'd7;
                end
                main_sdram_bankmachine6_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine6_twtpcon_ready) begin
                main_sdram_bankmachine6_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine6_row_close <= 1'd1;
            main_sdram_bankmachine6_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine6_refresh_req)) begin
                builder_soclinux_bankmachine6_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine6_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine6_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine6_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine6_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine6_refresh_req) begin
                builder_soclinux_bankmachine6_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine6_source_source_valid) begin
                    if (main_sdram_bankmachine6_row_opened) begin
                        if (main_sdram_bankmachine6_row_hit) begin
                            main_sdram_bankmachine6_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine6_source_source_payload_we) begin
                                main_sdram_bankmachine6_req_wdata_ready <= main_sdram_bankmachine6_cmd_ready;
                                main_sdram_bankmachine6_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine6_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine6_req_rdata_valid <= main_sdram_bankmachine6_cmd_ready;
                                main_sdram_bankmachine6_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine6_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine6_cmd_ready & main_sdram_bankmachine6_auto_precharge)) begin
                                builder_soclinux_bankmachine6_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine6_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine6_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_bankmachine7_sink_valid = main_sdram_bankmachine7_req_valid;
assign main_sdram_bankmachine7_req_ready = main_sdram_bankmachine7_sink_ready;
assign main_sdram_bankmachine7_sink_payload_we = main_sdram_bankmachine7_req_we;
assign main_sdram_bankmachine7_sink_payload_addr = main_sdram_bankmachine7_req_addr;
assign main_sdram_bankmachine7_sink_sink_valid = main_sdram_bankmachine7_source_valid;
assign main_sdram_bankmachine7_source_ready = main_sdram_bankmachine7_sink_sink_ready;
assign main_sdram_bankmachine7_sink_sink_first = main_sdram_bankmachine7_source_first;
assign main_sdram_bankmachine7_sink_sink_last = main_sdram_bankmachine7_source_last;
assign main_sdram_bankmachine7_sink_sink_payload_we = main_sdram_bankmachine7_source_payload_we;
assign main_sdram_bankmachine7_sink_sink_payload_addr = main_sdram_bankmachine7_source_payload_addr;
assign main_sdram_bankmachine7_source_source_ready = (main_sdram_bankmachine7_req_wdata_ready | main_sdram_bankmachine7_req_rdata_valid);
assign main_sdram_bankmachine7_req_lock = (main_sdram_bankmachine7_source_valid | main_sdram_bankmachine7_source_source_valid);
assign main_sdram_bankmachine7_row_hit = (main_sdram_bankmachine7_row == main_sdram_bankmachine7_source_source_payload_addr[21:7]);
assign main_sdram_bankmachine7_cmd_payload_ba = 3'd7;
always @(*) begin
    main_sdram_bankmachine7_cmd_payload_a <= 15'd0;
    if (main_sdram_bankmachine7_row_col_n_addr_sel) begin
        main_sdram_bankmachine7_cmd_payload_a <= main_sdram_bankmachine7_source_source_payload_addr[21:7];
    end else begin
        main_sdram_bankmachine7_cmd_payload_a <= ((main_sdram_bankmachine7_auto_precharge <<< 4'd10) | {main_sdram_bankmachine7_source_source_payload_addr[6:0], {3{1'd0}}});
    end
end
assign main_sdram_bankmachine7_twtpcon_valid = ((main_sdram_bankmachine7_cmd_valid & main_sdram_bankmachine7_cmd_ready) & main_sdram_bankmachine7_cmd_payload_is_write);
assign main_sdram_bankmachine7_trccon_valid = ((main_sdram_bankmachine7_cmd_valid & main_sdram_bankmachine7_cmd_ready) & main_sdram_bankmachine7_row_open);
assign main_sdram_bankmachine7_trascon_valid = ((main_sdram_bankmachine7_cmd_valid & main_sdram_bankmachine7_cmd_ready) & main_sdram_bankmachine7_row_open);
always @(*) begin
    main_sdram_bankmachine7_auto_precharge <= 1'd0;
    if ((main_sdram_bankmachine7_source_valid & main_sdram_bankmachine7_source_source_valid)) begin
        if ((main_sdram_bankmachine7_source_payload_addr[21:7] != main_sdram_bankmachine7_source_source_payload_addr[21:7])) begin
            main_sdram_bankmachine7_auto_precharge <= (main_sdram_bankmachine7_row_close == 1'd0);
        end
    end
end
assign main_sdram_bankmachine7_syncfifo7_din = {main_sdram_bankmachine7_fifo_in_last, main_sdram_bankmachine7_fifo_in_first, main_sdram_bankmachine7_fifo_in_payload_addr, main_sdram_bankmachine7_fifo_in_payload_we};
assign {main_sdram_bankmachine7_fifo_out_last, main_sdram_bankmachine7_fifo_out_first, main_sdram_bankmachine7_fifo_out_payload_addr, main_sdram_bankmachine7_fifo_out_payload_we} = main_sdram_bankmachine7_syncfifo7_dout;
assign main_sdram_bankmachine7_sink_ready = main_sdram_bankmachine7_syncfifo7_writable;
assign main_sdram_bankmachine7_syncfifo7_we = main_sdram_bankmachine7_sink_valid;
assign main_sdram_bankmachine7_fifo_in_first = main_sdram_bankmachine7_sink_first;
assign main_sdram_bankmachine7_fifo_in_last = main_sdram_bankmachine7_sink_last;
assign main_sdram_bankmachine7_fifo_in_payload_we = main_sdram_bankmachine7_sink_payload_we;
assign main_sdram_bankmachine7_fifo_in_payload_addr = main_sdram_bankmachine7_sink_payload_addr;
assign main_sdram_bankmachine7_source_valid = main_sdram_bankmachine7_syncfifo7_readable;
assign main_sdram_bankmachine7_source_first = main_sdram_bankmachine7_fifo_out_first;
assign main_sdram_bankmachine7_source_last = main_sdram_bankmachine7_fifo_out_last;
assign main_sdram_bankmachine7_source_payload_we = main_sdram_bankmachine7_fifo_out_payload_we;
assign main_sdram_bankmachine7_source_payload_addr = main_sdram_bankmachine7_fifo_out_payload_addr;
assign main_sdram_bankmachine7_syncfifo7_re = main_sdram_bankmachine7_source_ready;
always @(*) begin
    main_sdram_bankmachine7_wrport_adr <= 3'd0;
    if (main_sdram_bankmachine7_replace) begin
        main_sdram_bankmachine7_wrport_adr <= (main_sdram_bankmachine7_produce - 1'd1);
    end else begin
        main_sdram_bankmachine7_wrport_adr <= main_sdram_bankmachine7_produce;
    end
end
assign main_sdram_bankmachine7_wrport_dat_w = main_sdram_bankmachine7_syncfifo7_din;
assign main_sdram_bankmachine7_wrport_we = (main_sdram_bankmachine7_syncfifo7_we & (main_sdram_bankmachine7_syncfifo7_writable | main_sdram_bankmachine7_replace));
assign main_sdram_bankmachine7_do_read = (main_sdram_bankmachine7_syncfifo7_readable & main_sdram_bankmachine7_syncfifo7_re);
assign main_sdram_bankmachine7_rdport_adr = main_sdram_bankmachine7_consume;
assign main_sdram_bankmachine7_syncfifo7_dout = main_sdram_bankmachine7_rdport_dat_r;
assign main_sdram_bankmachine7_syncfifo7_writable = (main_sdram_bankmachine7_level != 4'd8);
assign main_sdram_bankmachine7_syncfifo7_readable = (main_sdram_bankmachine7_level != 1'd0);
assign main_sdram_bankmachine7_pipe_valid_sink_ready = ((~main_sdram_bankmachine7_pipe_valid_source_valid) | main_sdram_bankmachine7_pipe_valid_source_ready);
assign main_sdram_bankmachine7_pipe_valid_sink_valid = main_sdram_bankmachine7_sink_sink_valid;
assign main_sdram_bankmachine7_sink_sink_ready = main_sdram_bankmachine7_pipe_valid_sink_ready;
assign main_sdram_bankmachine7_pipe_valid_sink_first = main_sdram_bankmachine7_sink_sink_first;
assign main_sdram_bankmachine7_pipe_valid_sink_last = main_sdram_bankmachine7_sink_sink_last;
assign main_sdram_bankmachine7_pipe_valid_sink_payload_we = main_sdram_bankmachine7_sink_sink_payload_we;
assign main_sdram_bankmachine7_pipe_valid_sink_payload_addr = main_sdram_bankmachine7_sink_sink_payload_addr;
assign main_sdram_bankmachine7_source_source_valid = main_sdram_bankmachine7_pipe_valid_source_valid;
assign main_sdram_bankmachine7_pipe_valid_source_ready = main_sdram_bankmachine7_source_source_ready;
assign main_sdram_bankmachine7_source_source_first = main_sdram_bankmachine7_pipe_valid_source_first;
assign main_sdram_bankmachine7_source_source_last = main_sdram_bankmachine7_pipe_valid_source_last;
assign main_sdram_bankmachine7_source_source_payload_we = main_sdram_bankmachine7_pipe_valid_source_payload_we;
assign main_sdram_bankmachine7_source_source_payload_addr = main_sdram_bankmachine7_pipe_valid_source_payload_addr;
always @(*) begin
    main_sdram_bankmachine7_refresh_gnt <= 1'd0;
    main_sdram_bankmachine7_row_open <= 1'd0;
    main_sdram_bankmachine7_cmd_valid <= 1'd0;
    main_sdram_bankmachine7_cmd_payload_is_cmd <= 1'd0;
    main_sdram_bankmachine7_row_close <= 1'd0;
    main_sdram_bankmachine7_row_col_n_addr_sel <= 1'd0;
    main_sdram_bankmachine7_cmd_payload_cas <= 1'd0;
    main_sdram_bankmachine7_cmd_payload_ras <= 1'd0;
    main_sdram_bankmachine7_cmd_payload_we <= 1'd0;
    builder_soclinux_bankmachine7_next_state <= 4'd0;
    main_sdram_bankmachine7_cmd_payload_is_read <= 1'd0;
    main_sdram_bankmachine7_cmd_payload_is_write <= 1'd0;
    main_sdram_bankmachine7_req_wdata_ready <= 1'd0;
    main_sdram_bankmachine7_req_rdata_valid <= 1'd0;
    builder_soclinux_bankmachine7_next_state <= builder_soclinux_bankmachine7_state;
    case (builder_soclinux_bankmachine7_state)
        1'd1: begin
            if ((main_sdram_bankmachine7_twtpcon_ready & main_sdram_bankmachine7_trascon_ready)) begin
                main_sdram_bankmachine7_cmd_valid <= 1'd1;
                if (main_sdram_bankmachine7_cmd_ready) begin
                    builder_soclinux_bankmachine7_next_state <= 3'd5;
                end
                main_sdram_bankmachine7_cmd_payload_ras <= 1'd1;
                main_sdram_bankmachine7_cmd_payload_we <= 1'd1;
                main_sdram_bankmachine7_cmd_payload_is_cmd <= 1'd1;
            end
            main_sdram_bankmachine7_row_close <= 1'd1;
        end
        2'd2: begin
            if ((main_sdram_bankmachine7_twtpcon_ready & main_sdram_bankmachine7_trascon_ready)) begin
                builder_soclinux_bankmachine7_next_state <= 3'd5;
            end
            main_sdram_bankmachine7_row_close <= 1'd1;
        end
        2'd3: begin
            if (main_sdram_bankmachine7_trccon_ready) begin
                main_sdram_bankmachine7_row_col_n_addr_sel <= 1'd1;
                main_sdram_bankmachine7_row_open <= 1'd1;
                main_sdram_bankmachine7_cmd_valid <= 1'd1;
                main_sdram_bankmachine7_cmd_payload_is_cmd <= 1'd1;
                if (main_sdram_bankmachine7_cmd_ready) begin
                    builder_soclinux_bankmachine7_next_state <= 3'd7;
                end
                main_sdram_bankmachine7_cmd_payload_ras <= 1'd1;
            end
        end
        3'd4: begin
            if (main_sdram_bankmachine7_twtpcon_ready) begin
                main_sdram_bankmachine7_refresh_gnt <= 1'd1;
            end
            main_sdram_bankmachine7_row_close <= 1'd1;
            main_sdram_bankmachine7_cmd_payload_is_cmd <= 1'd1;
            if ((~main_sdram_bankmachine7_refresh_req)) begin
                builder_soclinux_bankmachine7_next_state <= 1'd0;
            end
        end
        3'd5: begin
            builder_soclinux_bankmachine7_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_bankmachine7_next_state <= 2'd3;
        end
        3'd7: begin
            builder_soclinux_bankmachine7_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_bankmachine7_next_state <= 1'd0;
        end
        default: begin
            if (main_sdram_bankmachine7_refresh_req) begin
                builder_soclinux_bankmachine7_next_state <= 3'd4;
            end else begin
                if (main_sdram_bankmachine7_source_source_valid) begin
                    if (main_sdram_bankmachine7_row_opened) begin
                        if (main_sdram_bankmachine7_row_hit) begin
                            main_sdram_bankmachine7_cmd_valid <= 1'd1;
                            if (main_sdram_bankmachine7_source_source_payload_we) begin
                                main_sdram_bankmachine7_req_wdata_ready <= main_sdram_bankmachine7_cmd_ready;
                                main_sdram_bankmachine7_cmd_payload_is_write <= 1'd1;
                                main_sdram_bankmachine7_cmd_payload_we <= 1'd1;
                            end else begin
                                main_sdram_bankmachine7_req_rdata_valid <= main_sdram_bankmachine7_cmd_ready;
                                main_sdram_bankmachine7_cmd_payload_is_read <= 1'd1;
                            end
                            main_sdram_bankmachine7_cmd_payload_cas <= 1'd1;
                            if ((main_sdram_bankmachine7_cmd_ready & main_sdram_bankmachine7_auto_precharge)) begin
                                builder_soclinux_bankmachine7_next_state <= 2'd2;
                            end
                        end else begin
                            builder_soclinux_bankmachine7_next_state <= 1'd1;
                        end
                    end else begin
                        builder_soclinux_bankmachine7_next_state <= 2'd3;
                    end
                end
            end
        end
    endcase
end
assign main_sdram_rdcmdphase = (main_usddrphy_rdphase_storage - 1'd1);
assign main_sdram_wrcmdphase = (main_usddrphy_wrphase_storage - 1'd1);
assign main_sdram_trrdcon_valid = ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & ((main_sdram_choose_cmd_cmd_payload_ras & (~main_sdram_choose_cmd_cmd_payload_cas)) & (~main_sdram_choose_cmd_cmd_payload_we)));
assign main_sdram_tfawcon_valid = ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & ((main_sdram_choose_cmd_cmd_payload_ras & (~main_sdram_choose_cmd_cmd_payload_cas)) & (~main_sdram_choose_cmd_cmd_payload_we)));
assign main_sdram_ras_allowed = (main_sdram_trrdcon_ready & main_sdram_tfawcon_ready);
assign main_sdram_tccdcon_valid = ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_cmd_payload_is_write | main_sdram_choose_req_cmd_payload_is_read));
assign main_sdram_cas_allowed = main_sdram_tccdcon_ready;
assign main_sdram_twtrcon_valid = ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_write);
assign main_sdram_read_available = ((((((((main_sdram_bankmachine0_cmd_valid & main_sdram_bankmachine0_cmd_payload_is_read) | (main_sdram_bankmachine1_cmd_valid & main_sdram_bankmachine1_cmd_payload_is_read)) | (main_sdram_bankmachine2_cmd_valid & main_sdram_bankmachine2_cmd_payload_is_read)) | (main_sdram_bankmachine3_cmd_valid & main_sdram_bankmachine3_cmd_payload_is_read)) | (main_sdram_bankmachine4_cmd_valid & main_sdram_bankmachine4_cmd_payload_is_read)) | (main_sdram_bankmachine5_cmd_valid & main_sdram_bankmachine5_cmd_payload_is_read)) | (main_sdram_bankmachine6_cmd_valid & main_sdram_bankmachine6_cmd_payload_is_read)) | (main_sdram_bankmachine7_cmd_valid & main_sdram_bankmachine7_cmd_payload_is_read));
assign main_sdram_write_available = ((((((((main_sdram_bankmachine0_cmd_valid & main_sdram_bankmachine0_cmd_payload_is_write) | (main_sdram_bankmachine1_cmd_valid & main_sdram_bankmachine1_cmd_payload_is_write)) | (main_sdram_bankmachine2_cmd_valid & main_sdram_bankmachine2_cmd_payload_is_write)) | (main_sdram_bankmachine3_cmd_valid & main_sdram_bankmachine3_cmd_payload_is_write)) | (main_sdram_bankmachine4_cmd_valid & main_sdram_bankmachine4_cmd_payload_is_write)) | (main_sdram_bankmachine5_cmd_valid & main_sdram_bankmachine5_cmd_payload_is_write)) | (main_sdram_bankmachine6_cmd_valid & main_sdram_bankmachine6_cmd_payload_is_write)) | (main_sdram_bankmachine7_cmd_valid & main_sdram_bankmachine7_cmd_payload_is_write));
assign main_sdram_max_time0 = (main_sdram_time0 == 1'd0);
assign main_sdram_max_time1 = (main_sdram_time1 == 1'd0);
assign main_sdram_bankmachine0_refresh_req = main_sdram_cmd_valid;
assign main_sdram_bankmachine1_refresh_req = main_sdram_cmd_valid;
assign main_sdram_bankmachine2_refresh_req = main_sdram_cmd_valid;
assign main_sdram_bankmachine3_refresh_req = main_sdram_cmd_valid;
assign main_sdram_bankmachine4_refresh_req = main_sdram_cmd_valid;
assign main_sdram_bankmachine5_refresh_req = main_sdram_cmd_valid;
assign main_sdram_bankmachine6_refresh_req = main_sdram_cmd_valid;
assign main_sdram_bankmachine7_refresh_req = main_sdram_cmd_valid;
assign main_sdram_go_to_refresh = (((((((main_sdram_bankmachine0_refresh_gnt & main_sdram_bankmachine1_refresh_gnt) & main_sdram_bankmachine2_refresh_gnt) & main_sdram_bankmachine3_refresh_gnt) & main_sdram_bankmachine4_refresh_gnt) & main_sdram_bankmachine5_refresh_gnt) & main_sdram_bankmachine6_refresh_gnt) & main_sdram_bankmachine7_refresh_gnt);
assign main_sdram_interface_rdata = {main_sdram_dfi_p3_rddata, main_sdram_dfi_p2_rddata, main_sdram_dfi_p1_rddata, main_sdram_dfi_p0_rddata};
assign {main_sdram_dfi_p3_wrdata, main_sdram_dfi_p2_wrdata, main_sdram_dfi_p1_wrdata, main_sdram_dfi_p0_wrdata} = main_sdram_interface_wdata;
assign {main_sdram_dfi_p3_wrdata_mask, main_sdram_dfi_p2_wrdata_mask, main_sdram_dfi_p1_wrdata_mask, main_sdram_dfi_p0_wrdata_mask} = (~main_sdram_interface_wdata_we);
always @(*) begin
    main_sdram_choose_cmd_valids <= 8'd0;
    main_sdram_choose_cmd_valids[0] <= (main_sdram_bankmachine0_cmd_valid & (((main_sdram_bankmachine0_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine0_cmd_payload_ras & (~main_sdram_bankmachine0_cmd_payload_cas)) & (~main_sdram_bankmachine0_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine0_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine0_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
    main_sdram_choose_cmd_valids[1] <= (main_sdram_bankmachine1_cmd_valid & (((main_sdram_bankmachine1_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine1_cmd_payload_ras & (~main_sdram_bankmachine1_cmd_payload_cas)) & (~main_sdram_bankmachine1_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine1_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine1_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
    main_sdram_choose_cmd_valids[2] <= (main_sdram_bankmachine2_cmd_valid & (((main_sdram_bankmachine2_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine2_cmd_payload_ras & (~main_sdram_bankmachine2_cmd_payload_cas)) & (~main_sdram_bankmachine2_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine2_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine2_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
    main_sdram_choose_cmd_valids[3] <= (main_sdram_bankmachine3_cmd_valid & (((main_sdram_bankmachine3_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine3_cmd_payload_ras & (~main_sdram_bankmachine3_cmd_payload_cas)) & (~main_sdram_bankmachine3_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine3_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine3_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
    main_sdram_choose_cmd_valids[4] <= (main_sdram_bankmachine4_cmd_valid & (((main_sdram_bankmachine4_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine4_cmd_payload_ras & (~main_sdram_bankmachine4_cmd_payload_cas)) & (~main_sdram_bankmachine4_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine4_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine4_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
    main_sdram_choose_cmd_valids[5] <= (main_sdram_bankmachine5_cmd_valid & (((main_sdram_bankmachine5_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine5_cmd_payload_ras & (~main_sdram_bankmachine5_cmd_payload_cas)) & (~main_sdram_bankmachine5_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine5_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine5_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
    main_sdram_choose_cmd_valids[6] <= (main_sdram_bankmachine6_cmd_valid & (((main_sdram_bankmachine6_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine6_cmd_payload_ras & (~main_sdram_bankmachine6_cmd_payload_cas)) & (~main_sdram_bankmachine6_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine6_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine6_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
    main_sdram_choose_cmd_valids[7] <= (main_sdram_bankmachine7_cmd_valid & (((main_sdram_bankmachine7_cmd_payload_is_cmd & main_sdram_choose_cmd_want_cmds) & ((~((main_sdram_bankmachine7_cmd_payload_ras & (~main_sdram_bankmachine7_cmd_payload_cas)) & (~main_sdram_bankmachine7_cmd_payload_we))) | main_sdram_choose_cmd_want_activates)) | ((main_sdram_bankmachine7_cmd_payload_is_read == main_sdram_choose_cmd_want_reads) & (main_sdram_bankmachine7_cmd_payload_is_write == main_sdram_choose_cmd_want_writes))));
end
assign main_sdram_choose_cmd_request = main_sdram_choose_cmd_valids;
assign main_sdram_choose_cmd_cmd_valid = builder_comb_rhs_array_muxed16;
assign main_sdram_choose_cmd_cmd_payload_a = builder_comb_rhs_array_muxed17;
assign main_sdram_choose_cmd_cmd_payload_ba = builder_comb_rhs_array_muxed18;
assign main_sdram_choose_cmd_cmd_payload_is_read = builder_comb_rhs_array_muxed19;
assign main_sdram_choose_cmd_cmd_payload_is_write = builder_comb_rhs_array_muxed20;
assign main_sdram_choose_cmd_cmd_payload_is_cmd = builder_comb_rhs_array_muxed21;
always @(*) begin
    main_sdram_choose_cmd_cmd_payload_cas <= 1'd0;
    if (main_sdram_choose_cmd_cmd_valid) begin
        main_sdram_choose_cmd_cmd_payload_cas <= builder_comb_t_array_muxed0;
    end
end
always @(*) begin
    main_sdram_choose_cmd_cmd_payload_ras <= 1'd0;
    if (main_sdram_choose_cmd_cmd_valid) begin
        main_sdram_choose_cmd_cmd_payload_ras <= builder_comb_t_array_muxed1;
    end
end
always @(*) begin
    main_sdram_choose_cmd_cmd_payload_we <= 1'd0;
    if (main_sdram_choose_cmd_cmd_valid) begin
        main_sdram_choose_cmd_cmd_payload_we <= builder_comb_t_array_muxed2;
    end
end
assign main_sdram_choose_cmd_ce = (main_sdram_choose_cmd_cmd_ready | (~main_sdram_choose_cmd_cmd_valid));
always @(*) begin
    main_sdram_choose_req_valids <= 8'd0;
    main_sdram_choose_req_valids[0] <= (main_sdram_bankmachine0_cmd_valid & (((main_sdram_bankmachine0_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine0_cmd_payload_ras & (~main_sdram_bankmachine0_cmd_payload_cas)) & (~main_sdram_bankmachine0_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine0_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine0_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
    main_sdram_choose_req_valids[1] <= (main_sdram_bankmachine1_cmd_valid & (((main_sdram_bankmachine1_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine1_cmd_payload_ras & (~main_sdram_bankmachine1_cmd_payload_cas)) & (~main_sdram_bankmachine1_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine1_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine1_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
    main_sdram_choose_req_valids[2] <= (main_sdram_bankmachine2_cmd_valid & (((main_sdram_bankmachine2_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine2_cmd_payload_ras & (~main_sdram_bankmachine2_cmd_payload_cas)) & (~main_sdram_bankmachine2_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine2_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine2_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
    main_sdram_choose_req_valids[3] <= (main_sdram_bankmachine3_cmd_valid & (((main_sdram_bankmachine3_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine3_cmd_payload_ras & (~main_sdram_bankmachine3_cmd_payload_cas)) & (~main_sdram_bankmachine3_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine3_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine3_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
    main_sdram_choose_req_valids[4] <= (main_sdram_bankmachine4_cmd_valid & (((main_sdram_bankmachine4_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine4_cmd_payload_ras & (~main_sdram_bankmachine4_cmd_payload_cas)) & (~main_sdram_bankmachine4_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine4_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine4_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
    main_sdram_choose_req_valids[5] <= (main_sdram_bankmachine5_cmd_valid & (((main_sdram_bankmachine5_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine5_cmd_payload_ras & (~main_sdram_bankmachine5_cmd_payload_cas)) & (~main_sdram_bankmachine5_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine5_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine5_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
    main_sdram_choose_req_valids[6] <= (main_sdram_bankmachine6_cmd_valid & (((main_sdram_bankmachine6_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine6_cmd_payload_ras & (~main_sdram_bankmachine6_cmd_payload_cas)) & (~main_sdram_bankmachine6_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine6_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine6_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
    main_sdram_choose_req_valids[7] <= (main_sdram_bankmachine7_cmd_valid & (((main_sdram_bankmachine7_cmd_payload_is_cmd & main_sdram_choose_req_want_cmds) & ((~((main_sdram_bankmachine7_cmd_payload_ras & (~main_sdram_bankmachine7_cmd_payload_cas)) & (~main_sdram_bankmachine7_cmd_payload_we))) | main_sdram_choose_req_want_activates)) | ((main_sdram_bankmachine7_cmd_payload_is_read == main_sdram_choose_req_want_reads) & (main_sdram_bankmachine7_cmd_payload_is_write == main_sdram_choose_req_want_writes))));
end
assign main_sdram_choose_req_request = main_sdram_choose_req_valids;
assign main_sdram_choose_req_cmd_valid = builder_comb_rhs_array_muxed22;
assign main_sdram_choose_req_cmd_payload_a = builder_comb_rhs_array_muxed23;
assign main_sdram_choose_req_cmd_payload_ba = builder_comb_rhs_array_muxed24;
assign main_sdram_choose_req_cmd_payload_is_read = builder_comb_rhs_array_muxed25;
assign main_sdram_choose_req_cmd_payload_is_write = builder_comb_rhs_array_muxed26;
assign main_sdram_choose_req_cmd_payload_is_cmd = builder_comb_rhs_array_muxed27;
always @(*) begin
    main_sdram_choose_req_cmd_payload_cas <= 1'd0;
    if (main_sdram_choose_req_cmd_valid) begin
        main_sdram_choose_req_cmd_payload_cas <= builder_comb_t_array_muxed3;
    end
end
always @(*) begin
    main_sdram_choose_req_cmd_payload_ras <= 1'd0;
    if (main_sdram_choose_req_cmd_valid) begin
        main_sdram_choose_req_cmd_payload_ras <= builder_comb_t_array_muxed4;
    end
end
always @(*) begin
    main_sdram_choose_req_cmd_payload_we <= 1'd0;
    if (main_sdram_choose_req_cmd_valid) begin
        main_sdram_choose_req_cmd_payload_we <= builder_comb_t_array_muxed5;
    end
end
always @(*) begin
    main_sdram_bankmachine0_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 1'd0))) begin
        main_sdram_bankmachine0_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 1'd0))) begin
        main_sdram_bankmachine0_cmd_ready <= 1'd1;
    end
end
always @(*) begin
    main_sdram_bankmachine1_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 1'd1))) begin
        main_sdram_bankmachine1_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 1'd1))) begin
        main_sdram_bankmachine1_cmd_ready <= 1'd1;
    end
end
always @(*) begin
    main_sdram_bankmachine2_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 2'd2))) begin
        main_sdram_bankmachine2_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 2'd2))) begin
        main_sdram_bankmachine2_cmd_ready <= 1'd1;
    end
end
always @(*) begin
    main_sdram_bankmachine3_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 2'd3))) begin
        main_sdram_bankmachine3_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 2'd3))) begin
        main_sdram_bankmachine3_cmd_ready <= 1'd1;
    end
end
always @(*) begin
    main_sdram_bankmachine4_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 3'd4))) begin
        main_sdram_bankmachine4_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 3'd4))) begin
        main_sdram_bankmachine4_cmd_ready <= 1'd1;
    end
end
always @(*) begin
    main_sdram_bankmachine5_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 3'd5))) begin
        main_sdram_bankmachine5_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 3'd5))) begin
        main_sdram_bankmachine5_cmd_ready <= 1'd1;
    end
end
always @(*) begin
    main_sdram_bankmachine6_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 3'd6))) begin
        main_sdram_bankmachine6_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 3'd6))) begin
        main_sdram_bankmachine6_cmd_ready <= 1'd1;
    end
end
always @(*) begin
    main_sdram_bankmachine7_cmd_ready <= 1'd0;
    if (((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & (main_sdram_choose_cmd_grant == 3'd7))) begin
        main_sdram_bankmachine7_cmd_ready <= 1'd1;
    end
    if (((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & (main_sdram_choose_req_grant == 3'd7))) begin
        main_sdram_bankmachine7_cmd_ready <= 1'd1;
    end
end
assign main_sdram_choose_req_ce = (main_sdram_choose_req_cmd_ready | (~main_sdram_choose_req_cmd_valid));
assign main_sdram_dfi_p0_reset_n = 1'd1;
assign main_sdram_dfi_p0_cke = {1{main_sdram_steerer0}};
assign main_sdram_dfi_p0_odt = {1{main_sdram_steerer1}};
assign main_sdram_dfi_p1_reset_n = 1'd1;
assign main_sdram_dfi_p1_cke = {1{main_sdram_steerer2}};
assign main_sdram_dfi_p1_odt = {1{main_sdram_steerer3}};
assign main_sdram_dfi_p2_reset_n = 1'd1;
assign main_sdram_dfi_p2_cke = {1{main_sdram_steerer4}};
assign main_sdram_dfi_p2_odt = {1{main_sdram_steerer5}};
assign main_sdram_dfi_p3_reset_n = 1'd1;
assign main_sdram_dfi_p3_cke = {1{main_sdram_steerer6}};
assign main_sdram_dfi_p3_odt = {1{main_sdram_steerer7}};
assign main_sdram_tfawcon_count = ((((((main_sdram_tfawcon_window[0] + main_sdram_tfawcon_window[1]) + main_sdram_tfawcon_window[2]) + main_sdram_tfawcon_window[3]) + main_sdram_tfawcon_window[4]) + main_sdram_tfawcon_window[5]) + main_sdram_tfawcon_window[6]);
always @(*) begin
    main_sdram_choose_cmd_cmd_ready <= 1'd0;
    main_sdram_choose_req_want_reads <= 1'd0;
    main_sdram_en0 <= 1'd0;
    main_sdram_choose_req_want_writes <= 1'd0;
    main_sdram_choose_req_cmd_ready <= 1'd0;
    main_sdram_en1 <= 1'd0;
    main_sdram_steerer_sel3 <= 2'd0;
    builder_soclinux_multiplexer_next_state <= 4'd0;
    main_sdram_steerer_sel0 <= 2'd0;
    main_sdram_cmd_ready <= 1'd0;
    main_sdram_steerer_sel1 <= 2'd0;
    main_sdram_steerer_sel2 <= 2'd0;
    main_sdram_choose_cmd_want_activates <= 1'd0;
    builder_soclinux_multiplexer_next_state <= builder_soclinux_multiplexer_state;
    case (builder_soclinux_multiplexer_state)
        1'd1: begin
            main_sdram_en1 <= 1'd1;
            main_sdram_choose_req_want_writes <= 1'd1;
            if (1'd0) begin
                main_sdram_choose_req_cmd_ready <= (main_sdram_cas_allowed & ((~((main_sdram_choose_req_cmd_payload_ras & (~main_sdram_choose_req_cmd_payload_cas)) & (~main_sdram_choose_req_cmd_payload_we))) | main_sdram_ras_allowed));
            end else begin
                main_sdram_choose_cmd_want_activates <= main_sdram_ras_allowed;
                main_sdram_choose_cmd_cmd_ready <= ((~((main_sdram_choose_cmd_cmd_payload_ras & (~main_sdram_choose_cmd_cmd_payload_cas)) & (~main_sdram_choose_cmd_cmd_payload_we))) | main_sdram_ras_allowed);
                main_sdram_choose_req_cmd_ready <= main_sdram_cas_allowed;
            end
            main_sdram_steerer_sel0 <= 1'd0;
            if ((main_usddrphy_wrphase_storage == 1'd0)) begin
                main_sdram_steerer_sel0 <= 2'd2;
            end
            if ((main_sdram_wrcmdphase == 1'd0)) begin
                main_sdram_steerer_sel0 <= 1'd1;
            end
            main_sdram_steerer_sel1 <= 1'd0;
            if ((main_usddrphy_wrphase_storage == 1'd1)) begin
                main_sdram_steerer_sel1 <= 2'd2;
            end
            if ((main_sdram_wrcmdphase == 1'd1)) begin
                main_sdram_steerer_sel1 <= 1'd1;
            end
            main_sdram_steerer_sel2 <= 1'd0;
            if ((main_usddrphy_wrphase_storage == 2'd2)) begin
                main_sdram_steerer_sel2 <= 2'd2;
            end
            if ((main_sdram_wrcmdphase == 2'd2)) begin
                main_sdram_steerer_sel2 <= 1'd1;
            end
            main_sdram_steerer_sel3 <= 1'd0;
            if ((main_usddrphy_wrphase_storage == 2'd3)) begin
                main_sdram_steerer_sel3 <= 2'd2;
            end
            if ((main_sdram_wrcmdphase == 2'd3)) begin
                main_sdram_steerer_sel3 <= 1'd1;
            end
            if (main_sdram_read_available) begin
                if (((~main_sdram_write_available) | main_sdram_max_time1)) begin
                    builder_soclinux_multiplexer_next_state <= 2'd3;
                end
            end
            if (main_sdram_go_to_refresh) begin
                builder_soclinux_multiplexer_next_state <= 2'd2;
            end
        end
        2'd2: begin
            main_sdram_steerer_sel0 <= 2'd3;
            main_sdram_cmd_ready <= 1'd1;
            if (main_sdram_cmd_last) begin
                builder_soclinux_multiplexer_next_state <= 1'd0;
            end
        end
        2'd3: begin
            if (main_sdram_twtrcon_ready) begin
                builder_soclinux_multiplexer_next_state <= 1'd0;
            end
        end
        3'd4: begin
            builder_soclinux_multiplexer_next_state <= 3'd5;
        end
        3'd5: begin
            builder_soclinux_multiplexer_next_state <= 3'd6;
        end
        3'd6: begin
            builder_soclinux_multiplexer_next_state <= 3'd7;
        end
        3'd7: begin
            builder_soclinux_multiplexer_next_state <= 4'd8;
        end
        4'd8: begin
            builder_soclinux_multiplexer_next_state <= 4'd9;
        end
        4'd9: begin
            builder_soclinux_multiplexer_next_state <= 4'd10;
        end
        4'd10: begin
            builder_soclinux_multiplexer_next_state <= 1'd1;
        end
        default: begin
            main_sdram_en0 <= 1'd1;
            main_sdram_choose_req_want_reads <= 1'd1;
            if (1'd0) begin
                main_sdram_choose_req_cmd_ready <= (main_sdram_cas_allowed & ((~((main_sdram_choose_req_cmd_payload_ras & (~main_sdram_choose_req_cmd_payload_cas)) & (~main_sdram_choose_req_cmd_payload_we))) | main_sdram_ras_allowed));
            end else begin
                main_sdram_choose_cmd_want_activates <= main_sdram_ras_allowed;
                main_sdram_choose_cmd_cmd_ready <= ((~((main_sdram_choose_cmd_cmd_payload_ras & (~main_sdram_choose_cmd_cmd_payload_cas)) & (~main_sdram_choose_cmd_cmd_payload_we))) | main_sdram_ras_allowed);
                main_sdram_choose_req_cmd_ready <= main_sdram_cas_allowed;
            end
            main_sdram_steerer_sel0 <= 1'd0;
            if ((main_usddrphy_rdphase_storage == 1'd0)) begin
                main_sdram_steerer_sel0 <= 2'd2;
            end
            if ((main_sdram_rdcmdphase == 1'd0)) begin
                main_sdram_steerer_sel0 <= 1'd1;
            end
            main_sdram_steerer_sel1 <= 1'd0;
            if ((main_usddrphy_rdphase_storage == 1'd1)) begin
                main_sdram_steerer_sel1 <= 2'd2;
            end
            if ((main_sdram_rdcmdphase == 1'd1)) begin
                main_sdram_steerer_sel1 <= 1'd1;
            end
            main_sdram_steerer_sel2 <= 1'd0;
            if ((main_usddrphy_rdphase_storage == 2'd2)) begin
                main_sdram_steerer_sel2 <= 2'd2;
            end
            if ((main_sdram_rdcmdphase == 2'd2)) begin
                main_sdram_steerer_sel2 <= 1'd1;
            end
            main_sdram_steerer_sel3 <= 1'd0;
            if ((main_usddrphy_rdphase_storage == 2'd3)) begin
                main_sdram_steerer_sel3 <= 2'd2;
            end
            if ((main_sdram_rdcmdphase == 2'd3)) begin
                main_sdram_steerer_sel3 <= 1'd1;
            end
            if (main_sdram_write_available) begin
                if (((~main_sdram_read_available) | main_sdram_max_time0)) begin
                    builder_soclinux_multiplexer_next_state <= 3'd4;
                end
            end
            if (main_sdram_go_to_refresh) begin
                builder_soclinux_multiplexer_next_state <= 2'd2;
            end
        end
    endcase
end
assign builder_soclinux_roundrobin0_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 1'd0) & (~(((((((builder_soclinux_locked1 | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 1'd0) & (~(((((((builder_soclinux_locked0 | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin0_ce = ((~main_sdram_interface_bank0_valid) & (~main_sdram_interface_bank0_lock));
assign main_sdram_interface_bank0_addr = builder_comb_rhs_array_muxed28;
assign main_sdram_interface_bank0_we = builder_comb_rhs_array_muxed29;
assign main_sdram_interface_bank0_valid = builder_comb_rhs_array_muxed30;
assign builder_soclinux_roundrobin1_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 1'd1) & (~(((((((builder_soclinux_locked3 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 1'd1) & (~(((((((builder_soclinux_locked2 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin1_ce = ((~main_sdram_interface_bank1_valid) & (~main_sdram_interface_bank1_lock));
assign main_sdram_interface_bank1_addr = builder_comb_rhs_array_muxed31;
assign main_sdram_interface_bank1_we = builder_comb_rhs_array_muxed32;
assign main_sdram_interface_bank1_valid = builder_comb_rhs_array_muxed33;
assign builder_soclinux_roundrobin2_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 2'd2) & (~(((((((builder_soclinux_locked5 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 2'd2) & (~(((((((builder_soclinux_locked4 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin2_ce = ((~main_sdram_interface_bank2_valid) & (~main_sdram_interface_bank2_lock));
assign main_sdram_interface_bank2_addr = builder_comb_rhs_array_muxed34;
assign main_sdram_interface_bank2_we = builder_comb_rhs_array_muxed35;
assign main_sdram_interface_bank2_valid = builder_comb_rhs_array_muxed36;
assign builder_soclinux_roundrobin3_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 2'd3) & (~(((((((builder_soclinux_locked7 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 2'd3) & (~(((((((builder_soclinux_locked6 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin3_ce = ((~main_sdram_interface_bank3_valid) & (~main_sdram_interface_bank3_lock));
assign main_sdram_interface_bank3_addr = builder_comb_rhs_array_muxed37;
assign main_sdram_interface_bank3_we = builder_comb_rhs_array_muxed38;
assign main_sdram_interface_bank3_valid = builder_comb_rhs_array_muxed39;
assign builder_soclinux_roundrobin4_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd4) & (~(((((((builder_soclinux_locked9 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd4) & (~(((((((builder_soclinux_locked8 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin4_ce = ((~main_sdram_interface_bank4_valid) & (~main_sdram_interface_bank4_lock));
assign main_sdram_interface_bank4_addr = builder_comb_rhs_array_muxed40;
assign main_sdram_interface_bank4_we = builder_comb_rhs_array_muxed41;
assign main_sdram_interface_bank4_valid = builder_comb_rhs_array_muxed42;
assign builder_soclinux_roundrobin5_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd5) & (~(((((((builder_soclinux_locked11 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd5) & (~(((((((builder_soclinux_locked10 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin5_ce = ((~main_sdram_interface_bank5_valid) & (~main_sdram_interface_bank5_lock));
assign main_sdram_interface_bank5_addr = builder_comb_rhs_array_muxed43;
assign main_sdram_interface_bank5_we = builder_comb_rhs_array_muxed44;
assign main_sdram_interface_bank5_valid = builder_comb_rhs_array_muxed45;
assign builder_soclinux_roundrobin6_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd6) & (~(((((((builder_soclinux_locked13 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd6) & (~(((((((builder_soclinux_locked12 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin6_ce = ((~main_sdram_interface_bank6_valid) & (~main_sdram_interface_bank6_lock));
assign main_sdram_interface_bank6_addr = builder_comb_rhs_array_muxed46;
assign main_sdram_interface_bank6_we = builder_comb_rhs_array_muxed47;
assign main_sdram_interface_bank6_valid = builder_comb_rhs_array_muxed48;
assign builder_soclinux_roundrobin7_request = {(((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd7) & (~(((((((builder_soclinux_locked15 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid), (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd7) & (~(((((((builder_soclinux_locked14 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid)};
assign builder_soclinux_roundrobin7_ce = ((~main_sdram_interface_bank7_valid) & (~main_sdram_interface_bank7_lock));
assign main_sdram_interface_bank7_addr = builder_comb_rhs_array_muxed49;
assign main_sdram_interface_bank7_we = builder_comb_rhs_array_muxed50;
assign main_sdram_interface_bank7_valid = builder_comb_rhs_array_muxed51;
assign main_litedramnativeport0_cmd_ready = ((((((((1'd0 | (((builder_soclinux_roundrobin0_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 1'd0) & (~(((((((builder_soclinux_locked0 | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0)))))) & main_sdram_interface_bank0_ready)) | (((builder_soclinux_roundrobin1_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 1'd1) & (~(((((((builder_soclinux_locked2 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0)))))) & main_sdram_interface_bank1_ready)) | (((builder_soclinux_roundrobin2_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 2'd2) & (~(((((((builder_soclinux_locked4 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0)))))) & main_sdram_interface_bank2_ready)) | (((builder_soclinux_roundrobin3_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 2'd3) & (~(((((((builder_soclinux_locked6 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0)))))) & main_sdram_interface_bank3_ready)) | (((builder_soclinux_roundrobin4_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd4) & (~(((((((builder_soclinux_locked8 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0)))))) & main_sdram_interface_bank4_ready)) | (((builder_soclinux_roundrobin5_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd5) & (~(((((((builder_soclinux_locked10 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0)))))) & main_sdram_interface_bank5_ready)) | (((builder_soclinux_roundrobin6_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd6) & (~(((((((builder_soclinux_locked12 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0)))))) & main_sdram_interface_bank6_ready)) | (((builder_soclinux_roundrobin7_grant == 1'd0) & ((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd7) & (~(((((((builder_soclinux_locked14 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0)))))) & main_sdram_interface_bank7_ready));
assign main_litedramnativeport1_cmd_ready = ((((((((1'd0 | (((builder_soclinux_roundrobin0_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 1'd0) & (~(((((((builder_soclinux_locked1 | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1)))))) & main_sdram_interface_bank0_ready)) | (((builder_soclinux_roundrobin1_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 1'd1) & (~(((((((builder_soclinux_locked3 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1)))))) & main_sdram_interface_bank1_ready)) | (((builder_soclinux_roundrobin2_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 2'd2) & (~(((((((builder_soclinux_locked5 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1)))))) & main_sdram_interface_bank2_ready)) | (((builder_soclinux_roundrobin3_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 2'd3) & (~(((((((builder_soclinux_locked7 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1)))))) & main_sdram_interface_bank3_ready)) | (((builder_soclinux_roundrobin4_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd4) & (~(((((((builder_soclinux_locked9 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1)))))) & main_sdram_interface_bank4_ready)) | (((builder_soclinux_roundrobin5_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd5) & (~(((((((builder_soclinux_locked11 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1)))))) & main_sdram_interface_bank5_ready)) | (((builder_soclinux_roundrobin6_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd6) & (~(((((((builder_soclinux_locked13 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1)))))) & main_sdram_interface_bank6_ready)) | (((builder_soclinux_roundrobin7_grant == 1'd1) & ((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd7) & (~(((((((builder_soclinux_locked15 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1)))))) & main_sdram_interface_bank7_ready));
assign main_litedramnativeport0_wdata_ready = builder_soclinux_new_master_wdata_ready2;
assign main_litedramnativeport1_wdata_ready = builder_soclinux_new_master_wdata_ready5;
assign main_litedramnativeport0_rdata_valid = builder_soclinux_new_master_rdata_valid8;
assign main_litedramnativeport1_rdata_valid = builder_soclinux_new_master_rdata_valid17;
always @(*) begin
    main_sdram_interface_wdata <= 512'd0;
    main_sdram_interface_wdata_we <= 64'd0;
    case ({builder_soclinux_new_master_wdata_ready5, builder_soclinux_new_master_wdata_ready2})
        1'd1: begin
            main_sdram_interface_wdata <= main_litedramnativeport0_wdata_payload_data;
            main_sdram_interface_wdata_we <= main_litedramnativeport0_wdata_payload_we;
        end
        2'd2: begin
            main_sdram_interface_wdata <= main_litedramnativeport1_wdata_payload_data;
            main_sdram_interface_wdata_we <= main_litedramnativeport1_wdata_payload_we;
        end
        default: begin
            main_sdram_interface_wdata <= 1'd0;
            main_sdram_interface_wdata_we <= 1'd0;
        end
    endcase
end
assign main_litedramnativeport0_rdata_payload_data = main_sdram_interface_rdata;
assign main_litedramnativeport1_rdata_payload_data = main_sdram_interface_rdata;
assign main_ku_1000basex_crg_reset = main_ku_1000basex_storage;
assign main_ku_1000basex_tx_reset = ((main_ku_1000basex_pll_reset | (~main_ku_1000basex_pll_locked)) | main_ku_1000basex_crg_reset);
assign main_ku_1000basex_rx_reset = (((main_ku_1000basex_pll_reset | (~main_ku_1000basex_pll_locked)) | main_ku_1000basex_restart) | main_ku_1000basex_crg_reset);
assign main_ku_1000basex_tx_data0 = main_ku_1000basex_tx_data_half;
assign main_ku_1000basex_rx_data_half = main_ku_1000basex_rx_data0;
assign main_ku_1000basex_tx_data1 = main_ku_1000basex_pcstx_output0;
assign main_ku_1000basex_pcsrx_input = main_ku_1000basex_rx_data1;
assign main_ku_1000basex_pcstx_tx_valid = main_ku_1000basex_sink_valid;
assign main_ku_1000basex_sink_ready = main_ku_1000basex_pcstx_tx_ready;
assign main_ku_1000basex_pcstx_tx_data = main_ku_1000basex_sink_payload_data;
assign main_ku_1000basex_source_last = ((~main_ku_1000basex_pcsrx_rx_en) & main_ku_1000basex_rx_en_d);
assign main_ku_1000basex_seen_valid_ci_i = main_ku_1000basex_pcsrx_seen_valid_ci;
assign main_ku_1000basex_is_sgmii = main_ku_1000basex_lp_abi_o[0];
assign main_ku_1000basex_linkdown = ((main_ku_1000basex_lp_abi_o[0] & (~main_ku_1000basex_lp_abi_o[15])) | (main_ku_1000basex_lp_abi_o == 1'd0));
assign main_ku_1000basex_pcstx_sgmii_speed = (main_ku_1000basex_lp_abi_o[0] ? main_ku_1000basex_lp_abi_o[11:10] : 2'd2);
assign main_ku_1000basex_pcsrx_sgmii_speed = (main_ku_1000basex_lp_abi_i[0] ? main_ku_1000basex_lp_abi_i[11:10] : 2'd2);
assign main_ku_1000basex_pcstx_config_reg = (main_ku_1000basex_tx_config_empty ? 1'd0 : (((((main_ku_1000basex_is_sgmii | ((~main_ku_1000basex_is_sgmii) <<< 3'd5)) | ((main_ku_1000basex_lp_abi_o[0] ? main_ku_1000basex_lp_abi_o[11:10] : 1'd0) <<< 4'd10)) | (main_ku_1000basex_is_sgmii <<< 4'd12)) | (main_ku_1000basex_autoneg_ack <<< 4'd14)) | (main_ku_1000basex_is_sgmii & main_ku_1000basex_link_up)));
assign main_ku_1000basex_pcstx_ce1 = main_ku_1000basex_pcstx_ce0;
assign main_ku_1000basex_pcstx_d1 = main_ku_1000basex_pcstx_d0;
assign main_ku_1000basex_pcstx_k1 = main_ku_1000basex_pcstx_k0;
assign main_ku_1000basex_pcstx_disp_inter = (main_ku_1000basex_pcstx_disp_in ^ main_ku_1000basex_pcstx_code6b_unbalanced);
always @(*) begin
    main_ku_1000basex_pcstx_output_6b <= 6'd0;
    if (((~main_ku_1000basex_pcstx_disp_in) & main_ku_1000basex_pcstx_code6b_flip)) begin
        main_ku_1000basex_pcstx_output_6b <= (~main_ku_1000basex_pcstx_code6b);
    end else begin
        main_ku_1000basex_pcstx_output_6b <= main_ku_1000basex_pcstx_code6b;
    end
end
always @(*) begin
    main_ku_1000basex_pcstx_disp_out <= 1'd0;
    main_ku_1000basex_pcstx_output_4b <= 4'd0;
    if (((~main_ku_1000basex_pcstx_disp_inter) & main_ku_1000basex_pcstx_alt7_rd0)) begin
        main_ku_1000basex_pcstx_disp_out <= (~main_ku_1000basex_pcstx_disp_inter);
        main_ku_1000basex_pcstx_output_4b <= 3'd7;
    end else begin
        if ((main_ku_1000basex_pcstx_disp_inter & main_ku_1000basex_pcstx_alt7_rd1)) begin
            main_ku_1000basex_pcstx_disp_out <= (~main_ku_1000basex_pcstx_disp_inter);
            main_ku_1000basex_pcstx_output_4b <= 4'd8;
        end else begin
            main_ku_1000basex_pcstx_disp_out <= (main_ku_1000basex_pcstx_disp_inter ^ main_ku_1000basex_pcstx_code4b_unbalanced);
            if (((~main_ku_1000basex_pcstx_disp_inter) & main_ku_1000basex_pcstx_code4b_flip)) begin
                main_ku_1000basex_pcstx_output_4b <= (~main_ku_1000basex_pcstx_code4b);
            end else begin
                main_ku_1000basex_pcstx_output_4b <= main_ku_1000basex_pcstx_code4b;
            end
        end
    end
end
assign main_ku_1000basex_pcstx_output_msb_first = {main_ku_1000basex_pcstx_output_6b, main_ku_1000basex_pcstx_output_4b};
always @(*) begin
    main_ku_1000basex_pcstx_output1 <= 10'd0;
    main_ku_1000basex_pcstx_output1[0] <= main_ku_1000basex_pcstx_output_msb_first[9];
    main_ku_1000basex_pcstx_output1[1] <= main_ku_1000basex_pcstx_output_msb_first[8];
    main_ku_1000basex_pcstx_output1[2] <= main_ku_1000basex_pcstx_output_msb_first[7];
    main_ku_1000basex_pcstx_output1[3] <= main_ku_1000basex_pcstx_output_msb_first[6];
    main_ku_1000basex_pcstx_output1[4] <= main_ku_1000basex_pcstx_output_msb_first[5];
    main_ku_1000basex_pcstx_output1[5] <= main_ku_1000basex_pcstx_output_msb_first[4];
    main_ku_1000basex_pcstx_output1[6] <= main_ku_1000basex_pcstx_output_msb_first[3];
    main_ku_1000basex_pcstx_output1[7] <= main_ku_1000basex_pcstx_output_msb_first[2];
    main_ku_1000basex_pcstx_output1[8] <= main_ku_1000basex_pcstx_output_msb_first[1];
    main_ku_1000basex_pcstx_output1[9] <= main_ku_1000basex_pcstx_output_msb_first[0];
end
always @(*) begin
    main_ku_1000basex_pcstx_load_config_reg_buffer <= 1'd0;
    main_ku_1000basex_pcstx_tx_ready <= 1'd0;
    builder_soclinux_ku_1000basex_pcstx_next_state <= 3'd0;
    main_ku_1000basex_pcstx_timer_en <= 1'd0;
    main_ku_1000basex_pcstx_d0 <= 8'd0;
    main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value <= 1'd0;
    main_ku_1000basex_pcstx_k0 <= 1'd0;
    main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value_ce <= 1'd0;
    builder_soclinux_ku_1000basex_pcstx_next_state <= builder_soclinux_ku_1000basex_pcstx_state;
    case (builder_soclinux_ku_1000basex_pcstx_state)
        1'd1: begin
            if (main_ku_1000basex_pcstx_c_type) begin
                main_ku_1000basex_pcstx_d0 <= 7'd66;
            end else begin
                main_ku_1000basex_pcstx_d0 <= 8'd181;
            end
            main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value <= (~main_ku_1000basex_pcstx_c_type);
            main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value_ce <= 1'd1;
            builder_soclinux_ku_1000basex_pcstx_next_state <= 2'd2;
        end
        2'd2: begin
            main_ku_1000basex_pcstx_d0 <= main_ku_1000basex_pcstx_config_reg_buffer[7:0];
            builder_soclinux_ku_1000basex_pcstx_next_state <= 2'd3;
        end
        2'd3: begin
            main_ku_1000basex_pcstx_d0 <= main_ku_1000basex_pcstx_config_reg_buffer[15:8];
            builder_soclinux_ku_1000basex_pcstx_next_state <= 1'd0;
        end
        3'd4: begin
            if (main_ku_1000basex_pcstx_disparity) begin
                main_ku_1000basex_pcstx_d0 <= 8'd197;
            end else begin
                main_ku_1000basex_pcstx_d0 <= 7'd80;
            end
            builder_soclinux_ku_1000basex_pcstx_next_state <= 1'd0;
        end
        3'd5: begin
            if (main_ku_1000basex_pcstx_tx_valid) begin
                main_ku_1000basex_pcstx_tx_ready <= (main_ku_1000basex_pcstx_timer == 1'd0);
                main_ku_1000basex_pcstx_timer_en <= 1'd1;
                main_ku_1000basex_pcstx_d0 <= main_ku_1000basex_pcstx_tx_data;
            end else begin
                main_ku_1000basex_pcstx_tx_ready <= 1'd1;
                main_ku_1000basex_pcstx_k0 <= 1'd1;
                main_ku_1000basex_pcstx_d0 <= 8'd253;
                builder_soclinux_ku_1000basex_pcstx_next_state <= 3'd6;
            end
        end
        3'd6: begin
            main_ku_1000basex_pcstx_k0 <= 1'd1;
            main_ku_1000basex_pcstx_d0 <= 8'd247;
            if (main_ku_1000basex_pcstx_parity) begin
                builder_soclinux_ku_1000basex_pcstx_next_state <= 1'd0;
            end else begin
                builder_soclinux_ku_1000basex_pcstx_next_state <= 3'd7;
            end
        end
        3'd7: begin
            main_ku_1000basex_pcstx_k0 <= 1'd1;
            main_ku_1000basex_pcstx_d0 <= 8'd247;
            builder_soclinux_ku_1000basex_pcstx_next_state <= 1'd0;
        end
        default: begin
            if (main_ku_1000basex_pcstx_config_valid) begin
                main_ku_1000basex_pcstx_tx_ready <= 1'd1;
                main_ku_1000basex_pcstx_load_config_reg_buffer <= 1'd1;
                main_ku_1000basex_pcstx_k0 <= 1'd1;
                main_ku_1000basex_pcstx_d0 <= 8'd188;
                builder_soclinux_ku_1000basex_pcstx_next_state <= 1'd1;
            end else begin
                if (main_ku_1000basex_pcstx_tx_valid) begin
                    main_ku_1000basex_pcstx_tx_ready <= (main_ku_1000basex_pcstx_timer == 1'd0);
                    main_ku_1000basex_pcstx_timer_en <= 1'd1;
                    main_ku_1000basex_pcstx_k0 <= 1'd1;
                    main_ku_1000basex_pcstx_d0 <= 8'd251;
                    builder_soclinux_ku_1000basex_pcstx_next_state <= 3'd5;
                end else begin
                    main_ku_1000basex_pcstx_tx_ready <= 1'd1;
                    main_ku_1000basex_pcstx_k0 <= 1'd1;
                    main_ku_1000basex_pcstx_d0 <= 8'd188;
                    builder_soclinux_ku_1000basex_pcstx_next_state <= 3'd4;
                end
            end
        end
    endcase
end
assign main_ku_1000basex_pcsrx_rx_data = (main_ku_1000basex_pcsrx_first_preamble_byte ? 7'd85 : main_ku_1000basex_pcsrx_d);
assign main_ku_1000basex_pcsrx_sample_en = (main_ku_1000basex_pcsrx_rx_en & (main_ku_1000basex_pcsrx_timer == 1'd0));
always @(*) begin
    main_ku_1000basex_pcsrx_input_msb_first <= 10'd0;
    main_ku_1000basex_pcsrx_input_msb_first[0] <= main_ku_1000basex_pcsrx_input[9];
    main_ku_1000basex_pcsrx_input_msb_first[1] <= main_ku_1000basex_pcsrx_input[8];
    main_ku_1000basex_pcsrx_input_msb_first[2] <= main_ku_1000basex_pcsrx_input[7];
    main_ku_1000basex_pcsrx_input_msb_first[3] <= main_ku_1000basex_pcsrx_input[6];
    main_ku_1000basex_pcsrx_input_msb_first[4] <= main_ku_1000basex_pcsrx_input[5];
    main_ku_1000basex_pcsrx_input_msb_first[5] <= main_ku_1000basex_pcsrx_input[4];
    main_ku_1000basex_pcsrx_input_msb_first[6] <= main_ku_1000basex_pcsrx_input[3];
    main_ku_1000basex_pcsrx_input_msb_first[7] <= main_ku_1000basex_pcsrx_input[2];
    main_ku_1000basex_pcsrx_input_msb_first[8] <= main_ku_1000basex_pcsrx_input[1];
    main_ku_1000basex_pcsrx_input_msb_first[9] <= main_ku_1000basex_pcsrx_input[0];
end
assign main_ku_1000basex_pcsrx_adr = main_ku_1000basex_pcsrx_input_msb_first[9:4];
assign main_ku_1000basex_pcsrx_re = main_ku_1000basex_pcsrx_ce;
assign main_ku_1000basex_pcsrx_code5b = main_ku_1000basex_pcsrx_dat_r;
assign main_ku_1000basex_pcsrx_d = {main_ku_1000basex_pcsrx_code3b, main_ku_1000basex_pcsrx_code5b};
assign main_ku_1000basex_pcsrx_invalid = (((main_ku_1000basex_pcsrx_ones != 3'd4) & (main_ku_1000basex_pcsrx_ones != 3'd5)) & (main_ku_1000basex_pcsrx_ones != 3'd6));
always @(*) begin
    main_ku_1000basex_pcsrx_seen_valid_ci <= 1'd0;
    builder_soclinux_ku_1000basex_pcsrx_next_state <= 3'd0;
    main_ku_1000basex_pcsrx_first_preamble_byte <= 1'd0;
    main_ku_1000basex_pcsrx_rx_en <= 1'd0;
    main_ku_1000basex_pcsrx_timer_en <= 1'd0;
    main_ku_1000basex_pcsrx_load_config_reg_lsb <= 1'd0;
    main_ku_1000basex_pcsrx_load_config_reg_msb <= 1'd0;
    builder_soclinux_ku_1000basex_pcsrx_next_state <= builder_soclinux_ku_1000basex_pcsrx_state;
    case (builder_soclinux_ku_1000basex_pcsrx_state)
        1'd1: begin
            builder_soclinux_ku_1000basex_pcsrx_next_state <= 1'd0;
            if ((~main_ku_1000basex_pcsrx_k)) begin
                if (((main_ku_1000basex_pcsrx_d == 8'd181) | (main_ku_1000basex_pcsrx_d == 7'd66))) begin
                    main_ku_1000basex_pcsrx_seen_valid_ci <= 1'd1;
                    builder_soclinux_ku_1000basex_pcsrx_next_state <= 2'd2;
                end
                if (((main_ku_1000basex_pcsrx_d == 8'd197) | (main_ku_1000basex_pcsrx_d == 7'd80))) begin
                    main_ku_1000basex_pcsrx_seen_valid_ci <= 1'd1;
                    builder_soclinux_ku_1000basex_pcsrx_next_state <= 1'd0;
                end
            end
        end
        2'd2: begin
            if (main_ku_1000basex_pcsrx_k) begin
                if ((main_ku_1000basex_pcsrx_d == 8'd251)) begin
                    main_ku_1000basex_pcsrx_rx_en <= 1'd1;
                    main_ku_1000basex_pcsrx_timer_en <= 1'd1;
                    main_ku_1000basex_pcsrx_first_preamble_byte <= 1'd1;
                    builder_soclinux_ku_1000basex_pcsrx_next_state <= 3'd4;
                end else begin
                    builder_soclinux_ku_1000basex_pcsrx_next_state <= 1'd0;
                end
            end else begin
                main_ku_1000basex_pcsrx_load_config_reg_lsb <= 1'd1;
                builder_soclinux_ku_1000basex_pcsrx_next_state <= 2'd3;
            end
        end
        2'd3: begin
            if ((~main_ku_1000basex_pcsrx_k)) begin
                main_ku_1000basex_pcsrx_load_config_reg_msb <= 1'd1;
            end
            builder_soclinux_ku_1000basex_pcsrx_next_state <= 1'd0;
        end
        3'd4: begin
            if (main_ku_1000basex_pcsrx_k) begin
                builder_soclinux_ku_1000basex_pcsrx_next_state <= 1'd0;
            end else begin
                main_ku_1000basex_pcsrx_rx_en <= 1'd1;
                main_ku_1000basex_pcsrx_timer_en <= 1'd1;
            end
        end
        default: begin
            if (main_ku_1000basex_pcsrx_k) begin
                if ((main_ku_1000basex_pcsrx_d == 8'd188)) begin
                    builder_soclinux_ku_1000basex_pcsrx_next_state <= 1'd1;
                end
                if ((main_ku_1000basex_pcsrx_d == 8'd251)) begin
                    main_ku_1000basex_pcsrx_rx_en <= 1'd1;
                    main_ku_1000basex_pcsrx_timer_en <= 1'd1;
                    main_ku_1000basex_pcsrx_first_preamble_byte <= 1'd1;
                    builder_soclinux_ku_1000basex_pcsrx_next_state <= 3'd4;
                end
            end
        end
    endcase
end
assign main_ku_1000basex_lp_abi_wait = (~main_ku_1000basex_lp_abi_ping_i);
assign main_ku_1000basex_lp_abi_ping_i = ((main_ku_1000basex_lp_abi_starter | main_ku_1000basex_lp_abi_pong_o) | main_ku_1000basex_lp_abi_done);
assign main_ku_1000basex_lp_abi_pong_i = main_ku_1000basex_lp_abi_ping_o1;
assign main_ku_1000basex_lp_abi_ping_o0 = (main_ku_1000basex_lp_abi_ping_toggle_o ^ main_ku_1000basex_lp_abi_ping_toggle_o_r);
assign main_ku_1000basex_lp_abi_pong_o = (main_ku_1000basex_lp_abi_pong_toggle_o ^ main_ku_1000basex_lp_abi_pong_toggle_o_r);
assign main_ku_1000basex_lp_abi_done = (main_ku_1000basex_lp_abi_count == 1'd0);
assign main_ku_1000basex_seen_valid_ci_o = (main_ku_1000basex_seen_valid_ci_toggle_o ^ main_ku_1000basex_seen_valid_ci_toggle_o_r);
assign main_ku_1000basex_rx_config_reg_abi_o = (main_ku_1000basex_rx_config_reg_abi_toggle_o ^ main_ku_1000basex_rx_config_reg_abi_toggle_o_r);
assign main_ku_1000basex_rx_config_reg_ack_o = (main_ku_1000basex_rx_config_reg_ack_toggle_o ^ main_ku_1000basex_rx_config_reg_ack_toggle_o_r);
assign main_ku_1000basex_waittimer0_done = (main_ku_1000basex_waittimer0_count == 1'd0);
assign main_ku_1000basex_waittimer1_done = (main_ku_1000basex_waittimer1_count == 1'd0);
always @(*) begin
    main_ku_1000basex_tx_config_empty <= 1'd0;
    main_ku_1000basex_link_up <= 1'd0;
    main_ku_1000basex_pcstx_config_valid <= 1'd0;
    main_ku_1000basex_waittimer0_wait <= 1'd0;
    main_ku_1000basex_restart <= 1'd0;
    builder_soclinux_ku_1000basex_fsm_next_state <= 3'd0;
    main_ku_1000basex_waittimer1_wait <= 1'd0;
    main_ku_1000basex_autoneg_ack <= 1'd0;
    builder_soclinux_ku_1000basex_fsm_next_state <= builder_soclinux_ku_1000basex_fsm_state;
    case (builder_soclinux_ku_1000basex_fsm_state)
        1'd1: begin
            main_ku_1000basex_pcstx_config_valid <= 1'd1;
            if (main_ku_1000basex_rx_config_reg_abi_o) begin
                builder_soclinux_ku_1000basex_fsm_next_state <= 2'd2;
            end
            if ((main_ku_1000basex_checker_tick & (~main_ku_1000basex_checker_ok))) begin
                main_ku_1000basex_restart <= 1'd1;
                builder_soclinux_ku_1000basex_fsm_next_state <= 1'd0;
            end
        end
        2'd2: begin
            main_ku_1000basex_pcstx_config_valid <= 1'd1;
            main_ku_1000basex_autoneg_ack <= 1'd1;
            if (main_ku_1000basex_rx_config_reg_ack_o) begin
                builder_soclinux_ku_1000basex_fsm_next_state <= 2'd3;
            end
            if ((main_ku_1000basex_checker_tick & (~main_ku_1000basex_checker_ok))) begin
                main_ku_1000basex_restart <= 1'd1;
                builder_soclinux_ku_1000basex_fsm_next_state <= 1'd0;
            end
        end
        2'd3: begin
            main_ku_1000basex_pcstx_config_valid <= 1'd1;
            main_ku_1000basex_autoneg_ack <= 1'd1;
            main_ku_1000basex_waittimer0_wait <= (~main_ku_1000basex_is_sgmii);
            main_ku_1000basex_waittimer1_wait <= main_ku_1000basex_is_sgmii;
            if (((main_ku_1000basex_is_sgmii & main_ku_1000basex_waittimer1_done) | ((~main_ku_1000basex_is_sgmii) & main_ku_1000basex_waittimer0_done))) begin
                builder_soclinux_ku_1000basex_fsm_next_state <= 3'd4;
            end
            if ((main_ku_1000basex_checker_tick & (~main_ku_1000basex_checker_ok))) begin
                main_ku_1000basex_restart <= 1'd1;
                builder_soclinux_ku_1000basex_fsm_next_state <= 1'd0;
            end
        end
        3'd4: begin
            main_ku_1000basex_link_up <= 1'd1;
            if (((main_ku_1000basex_checker_tick & (~main_ku_1000basex_checker_ok)) | main_ku_1000basex_linkdown)) begin
                main_ku_1000basex_restart <= 1'd1;
                builder_soclinux_ku_1000basex_fsm_next_state <= 1'd0;
            end
        end
        default: begin
            main_ku_1000basex_pcstx_config_valid <= 1'd1;
            main_ku_1000basex_tx_config_empty <= 1'd1;
            main_ku_1000basex_waittimer0_wait <= 1'd1;
            if (main_ku_1000basex_waittimer0_done) begin
                builder_soclinux_ku_1000basex_fsm_next_state <= 1'd1;
            end
        end
    endcase
end
assign builder_csr_bankarray_csrbank3_crg_reset0_w = main_ku_1000basex_storage;
assign main_ethmac_sink_valid = main_ethmac_source_source_valid;
assign main_ethmac_source_source_ready = main_ethmac_sink_ready;
assign main_ethmac_sink_first = main_ethmac_source_source_first;
assign main_ethmac_sink_last = main_ethmac_source_source_last;
assign main_ethmac_sink_payload_data = main_ethmac_source_source_payload_data;
assign main_ethmac_sink_payload_last_be = main_ethmac_source_source_payload_last_be;
assign main_ethmac_sink_payload_error = main_ethmac_source_source_payload_error;
assign main_ethmac_sink_sink_valid = main_ethmac_source_valid;
assign main_ethmac_source_ready = main_ethmac_sink_sink_ready;
assign main_ethmac_sink_sink_first = main_ethmac_source_first;
assign main_ethmac_sink_sink_last = main_ethmac_source_last;
assign main_ethmac_sink_sink_payload_data = main_ethmac_source_payload_data;
assign main_ethmac_sink_sink_payload_last_be = main_ethmac_source_payload_last_be;
assign main_ethmac_sink_sink_payload_error = main_ethmac_source_payload_error;
assign main_ethmac_tx_cdc_cdc_sink_valid = main_ethmac_tx_cdc_sink_sink_valid;
assign main_ethmac_tx_cdc_sink_sink_ready = main_ethmac_tx_cdc_cdc_sink_ready;
assign main_ethmac_tx_cdc_cdc_sink_first = main_ethmac_tx_cdc_sink_sink_first;
assign main_ethmac_tx_cdc_cdc_sink_last = main_ethmac_tx_cdc_sink_sink_last;
assign main_ethmac_tx_cdc_cdc_sink_payload_data = main_ethmac_tx_cdc_sink_sink_payload_data;
assign main_ethmac_tx_cdc_cdc_sink_payload_last_be = main_ethmac_tx_cdc_sink_sink_payload_last_be;
assign main_ethmac_tx_cdc_cdc_sink_payload_error = main_ethmac_tx_cdc_sink_sink_payload_error;
assign main_ethmac_tx_cdc_source_source_valid = main_ethmac_tx_cdc_cdc_source_valid;
assign main_ethmac_tx_cdc_cdc_source_ready = main_ethmac_tx_cdc_source_source_ready;
assign main_ethmac_tx_cdc_source_source_first = main_ethmac_tx_cdc_cdc_source_first;
assign main_ethmac_tx_cdc_source_source_last = main_ethmac_tx_cdc_cdc_source_last;
assign main_ethmac_tx_cdc_source_source_payload_data = main_ethmac_tx_cdc_cdc_source_payload_data;
assign main_ethmac_tx_cdc_source_source_payload_last_be = main_ethmac_tx_cdc_cdc_source_payload_last_be;
assign main_ethmac_tx_cdc_source_source_payload_error = main_ethmac_tx_cdc_cdc_source_payload_error;
assign main_ethmac_tx_cdc_cdc_asyncfifo_din = {main_ethmac_tx_cdc_cdc_fifo_in_last, main_ethmac_tx_cdc_cdc_fifo_in_first, main_ethmac_tx_cdc_cdc_fifo_in_payload_error, main_ethmac_tx_cdc_cdc_fifo_in_payload_last_be, main_ethmac_tx_cdc_cdc_fifo_in_payload_data};
assign {main_ethmac_tx_cdc_cdc_fifo_out_last, main_ethmac_tx_cdc_cdc_fifo_out_first, main_ethmac_tx_cdc_cdc_fifo_out_payload_error, main_ethmac_tx_cdc_cdc_fifo_out_payload_last_be, main_ethmac_tx_cdc_cdc_fifo_out_payload_data} = main_ethmac_tx_cdc_cdc_asyncfifo_dout;
assign main_ethmac_tx_cdc_cdc_sink_ready = main_ethmac_tx_cdc_cdc_asyncfifo_writable;
assign main_ethmac_tx_cdc_cdc_asyncfifo_we = main_ethmac_tx_cdc_cdc_sink_valid;
assign main_ethmac_tx_cdc_cdc_fifo_in_first = main_ethmac_tx_cdc_cdc_sink_first;
assign main_ethmac_tx_cdc_cdc_fifo_in_last = main_ethmac_tx_cdc_cdc_sink_last;
assign main_ethmac_tx_cdc_cdc_fifo_in_payload_data = main_ethmac_tx_cdc_cdc_sink_payload_data;
assign main_ethmac_tx_cdc_cdc_fifo_in_payload_last_be = main_ethmac_tx_cdc_cdc_sink_payload_last_be;
assign main_ethmac_tx_cdc_cdc_fifo_in_payload_error = main_ethmac_tx_cdc_cdc_sink_payload_error;
assign main_ethmac_tx_cdc_cdc_source_valid = main_ethmac_tx_cdc_cdc_asyncfifo_readable;
assign main_ethmac_tx_cdc_cdc_source_first = main_ethmac_tx_cdc_cdc_fifo_out_first;
assign main_ethmac_tx_cdc_cdc_source_last = main_ethmac_tx_cdc_cdc_fifo_out_last;
assign main_ethmac_tx_cdc_cdc_source_payload_data = main_ethmac_tx_cdc_cdc_fifo_out_payload_data;
assign main_ethmac_tx_cdc_cdc_source_payload_last_be = main_ethmac_tx_cdc_cdc_fifo_out_payload_last_be;
assign main_ethmac_tx_cdc_cdc_source_payload_error = main_ethmac_tx_cdc_cdc_fifo_out_payload_error;
assign main_ethmac_tx_cdc_cdc_asyncfifo_re = main_ethmac_tx_cdc_cdc_source_ready;
assign main_ethmac_tx_cdc_cdc_graycounter0_ce = (main_ethmac_tx_cdc_cdc_asyncfifo_writable & main_ethmac_tx_cdc_cdc_asyncfifo_we);
assign main_ethmac_tx_cdc_cdc_graycounter1_ce = (main_ethmac_tx_cdc_cdc_asyncfifo_readable & main_ethmac_tx_cdc_cdc_asyncfifo_re);
assign main_ethmac_tx_cdc_cdc_asyncfifo_writable = (((main_ethmac_tx_cdc_cdc_graycounter0_q[5] == main_ethmac_tx_cdc_cdc_consume_wdomain[5]) | (main_ethmac_tx_cdc_cdc_graycounter0_q[4] == main_ethmac_tx_cdc_cdc_consume_wdomain[4])) | (main_ethmac_tx_cdc_cdc_graycounter0_q[3:0] != main_ethmac_tx_cdc_cdc_consume_wdomain[3:0]));
assign main_ethmac_tx_cdc_cdc_asyncfifo_readable = (main_ethmac_tx_cdc_cdc_graycounter1_q != main_ethmac_tx_cdc_cdc_produce_rdomain);
assign main_ethmac_tx_cdc_cdc_wrport_adr = main_ethmac_tx_cdc_cdc_graycounter0_q_binary[4:0];
assign main_ethmac_tx_cdc_cdc_wrport_dat_w = main_ethmac_tx_cdc_cdc_asyncfifo_din;
assign main_ethmac_tx_cdc_cdc_wrport_we = main_ethmac_tx_cdc_cdc_graycounter0_ce;
assign main_ethmac_tx_cdc_cdc_rdport_adr = main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary[4:0];
assign main_ethmac_tx_cdc_cdc_asyncfifo_dout = main_ethmac_tx_cdc_cdc_rdport_dat_r;
always @(*) begin
    main_ethmac_tx_cdc_cdc_graycounter0_q_next_binary <= 6'd0;
    if (main_ethmac_tx_cdc_cdc_graycounter0_ce) begin
        main_ethmac_tx_cdc_cdc_graycounter0_q_next_binary <= (main_ethmac_tx_cdc_cdc_graycounter0_q_binary + 1'd1);
    end else begin
        main_ethmac_tx_cdc_cdc_graycounter0_q_next_binary <= main_ethmac_tx_cdc_cdc_graycounter0_q_binary;
    end
end
assign main_ethmac_tx_cdc_cdc_graycounter0_q_next = (main_ethmac_tx_cdc_cdc_graycounter0_q_next_binary ^ main_ethmac_tx_cdc_cdc_graycounter0_q_next_binary[5:1]);
always @(*) begin
    main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary <= 6'd0;
    if (main_ethmac_tx_cdc_cdc_graycounter1_ce) begin
        main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary <= (main_ethmac_tx_cdc_cdc_graycounter1_q_binary + 1'd1);
    end else begin
        main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary <= main_ethmac_tx_cdc_cdc_graycounter1_q_binary;
    end
end
assign main_ethmac_tx_cdc_cdc_graycounter1_q_next = (main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary ^ main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary[5:1]);
assign main_ethmac_tx_converter_converter_sink_valid = main_ethmac_tx_converter_sink_valid;
assign main_ethmac_tx_converter_converter_sink_first = main_ethmac_tx_converter_sink_first;
assign main_ethmac_tx_converter_converter_sink_last = main_ethmac_tx_converter_sink_last;
assign main_ethmac_tx_converter_sink_ready = main_ethmac_tx_converter_converter_sink_ready;
always @(*) begin
    main_ethmac_tx_converter_converter_sink_payload_data <= 40'd0;
    main_ethmac_tx_converter_converter_sink_payload_data[7:0] <= main_ethmac_tx_converter_sink_payload_data[7:0];
    main_ethmac_tx_converter_converter_sink_payload_data[8] <= main_ethmac_tx_converter_sink_payload_last_be[0];
    main_ethmac_tx_converter_converter_sink_payload_data[9] <= main_ethmac_tx_converter_sink_payload_error[0];
    main_ethmac_tx_converter_converter_sink_payload_data[17:10] <= main_ethmac_tx_converter_sink_payload_data[15:8];
    main_ethmac_tx_converter_converter_sink_payload_data[18] <= main_ethmac_tx_converter_sink_payload_last_be[1];
    main_ethmac_tx_converter_converter_sink_payload_data[19] <= main_ethmac_tx_converter_sink_payload_error[1];
    main_ethmac_tx_converter_converter_sink_payload_data[27:20] <= main_ethmac_tx_converter_sink_payload_data[23:16];
    main_ethmac_tx_converter_converter_sink_payload_data[28] <= main_ethmac_tx_converter_sink_payload_last_be[2];
    main_ethmac_tx_converter_converter_sink_payload_data[29] <= main_ethmac_tx_converter_sink_payload_error[2];
    main_ethmac_tx_converter_converter_sink_payload_data[37:30] <= main_ethmac_tx_converter_sink_payload_data[31:24];
    main_ethmac_tx_converter_converter_sink_payload_data[38] <= main_ethmac_tx_converter_sink_payload_last_be[3];
    main_ethmac_tx_converter_converter_sink_payload_data[39] <= main_ethmac_tx_converter_sink_payload_error[3];
end
assign main_ethmac_tx_converter_source_valid = main_ethmac_tx_converter_source_source_valid;
assign main_ethmac_tx_converter_source_first = main_ethmac_tx_converter_source_source_first;
assign main_ethmac_tx_converter_source_last = main_ethmac_tx_converter_source_source_last;
assign main_ethmac_tx_converter_source_source_ready = main_ethmac_tx_converter_source_ready;
assign {main_ethmac_tx_converter_source_payload_error, main_ethmac_tx_converter_source_payload_last_be, main_ethmac_tx_converter_source_payload_data} = main_ethmac_tx_converter_source_source_payload_data;
assign main_ethmac_tx_converter_source_source_valid = main_ethmac_tx_converter_converter_source_valid;
assign main_ethmac_tx_converter_converter_source_ready = main_ethmac_tx_converter_source_source_ready;
assign main_ethmac_tx_converter_source_source_first = main_ethmac_tx_converter_converter_source_first;
assign main_ethmac_tx_converter_source_source_last = main_ethmac_tx_converter_converter_source_last;
assign main_ethmac_tx_converter_source_source_payload_data = main_ethmac_tx_converter_converter_source_payload_data;
assign main_ethmac_tx_converter_converter_first = (main_ethmac_tx_converter_converter_mux == 1'd0);
assign main_ethmac_tx_converter_converter_last = (main_ethmac_tx_converter_converter_mux == 2'd3);
assign main_ethmac_tx_converter_converter_source_valid = main_ethmac_tx_converter_converter_sink_valid;
assign main_ethmac_tx_converter_converter_source_first = (main_ethmac_tx_converter_converter_sink_first & main_ethmac_tx_converter_converter_first);
assign main_ethmac_tx_converter_converter_source_last = (main_ethmac_tx_converter_converter_sink_last & main_ethmac_tx_converter_converter_last);
assign main_ethmac_tx_converter_converter_sink_ready = (main_ethmac_tx_converter_converter_last & main_ethmac_tx_converter_converter_source_ready);
always @(*) begin
    main_ethmac_tx_converter_converter_source_payload_data <= 10'd0;
    case (main_ethmac_tx_converter_converter_mux)
        1'd0: begin
            main_ethmac_tx_converter_converter_source_payload_data <= main_ethmac_tx_converter_converter_sink_payload_data[9:0];
        end
        1'd1: begin
            main_ethmac_tx_converter_converter_source_payload_data <= main_ethmac_tx_converter_converter_sink_payload_data[19:10];
        end
        2'd2: begin
            main_ethmac_tx_converter_converter_source_payload_data <= main_ethmac_tx_converter_converter_sink_payload_data[29:20];
        end
        default: begin
            main_ethmac_tx_converter_converter_source_payload_data <= main_ethmac_tx_converter_converter_sink_payload_data[39:30];
        end
    endcase
end
assign main_ethmac_tx_converter_converter_source_payload_valid_token_count = main_ethmac_tx_converter_converter_last;
always @(*) begin
    main_ethmac_tx_last_be_source_valid <= 1'd0;
    main_ethmac_tx_last_be_source_first <= 1'd0;
    main_ethmac_tx_last_be_source_last <= 1'd0;
    main_ethmac_tx_last_be_source_payload_data <= 8'd0;
    main_ethmac_tx_last_be_source_payload_last_be <= 1'd0;
    main_ethmac_tx_last_be_source_payload_error <= 1'd0;
    builder_soclinux_txdatapath_liteethmactxlastbe_next_state <= 1'd0;
    main_ethmac_tx_last_be_sink_ready <= 1'd0;
    builder_soclinux_txdatapath_liteethmactxlastbe_next_state <= builder_soclinux_txdatapath_liteethmactxlastbe_state;
    case (builder_soclinux_txdatapath_liteethmactxlastbe_state)
        1'd1: begin
            main_ethmac_tx_last_be_sink_ready <= 1'd1;
            if ((main_ethmac_tx_last_be_sink_valid & main_ethmac_tx_last_be_sink_last)) begin
                builder_soclinux_txdatapath_liteethmactxlastbe_next_state <= 1'd0;
            end
        end
        default: begin
            main_ethmac_tx_last_be_source_valid <= main_ethmac_tx_last_be_sink_valid;
            main_ethmac_tx_last_be_sink_ready <= main_ethmac_tx_last_be_source_ready;
            main_ethmac_tx_last_be_source_first <= main_ethmac_tx_last_be_sink_first;
            main_ethmac_tx_last_be_source_last <= main_ethmac_tx_last_be_sink_last;
            main_ethmac_tx_last_be_source_payload_data <= main_ethmac_tx_last_be_sink_payload_data;
            main_ethmac_tx_last_be_source_payload_last_be <= main_ethmac_tx_last_be_sink_payload_last_be;
            main_ethmac_tx_last_be_source_payload_error <= main_ethmac_tx_last_be_sink_payload_error;
            main_ethmac_tx_last_be_source_last <= (main_ethmac_tx_last_be_sink_payload_last_be != 1'd0);
            if ((main_ethmac_tx_last_be_sink_valid & main_ethmac_tx_last_be_sink_ready)) begin
                if ((main_ethmac_tx_last_be_source_last & (~main_ethmac_tx_last_be_sink_last))) begin
                    builder_soclinux_txdatapath_liteethmactxlastbe_next_state <= 1'd1;
                end
            end
        end
    endcase
end
assign main_ethmac_tx_padding_counter_done = (main_ethmac_tx_padding_counter >= 6'd59);
always @(*) begin
    builder_soclinux_txdatapath_liteethmacpaddinginserter_next_state <= 1'd0;
    main_ethmac_tx_padding_source_valid <= 1'd0;
    main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value <= 16'd0;
    main_ethmac_tx_padding_source_first <= 1'd0;
    main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value_ce <= 1'd0;
    main_ethmac_tx_padding_source_last <= 1'd0;
    main_ethmac_tx_padding_source_payload_data <= 8'd0;
    main_ethmac_tx_padding_source_payload_last_be <= 1'd0;
    main_ethmac_tx_padding_source_payload_error <= 1'd0;
    main_ethmac_tx_padding_sink_ready <= 1'd0;
    builder_soclinux_txdatapath_liteethmacpaddinginserter_next_state <= builder_soclinux_txdatapath_liteethmacpaddinginserter_state;
    case (builder_soclinux_txdatapath_liteethmacpaddinginserter_state)
        1'd1: begin
            main_ethmac_tx_padding_source_valid <= 1'd1;
            if (main_ethmac_tx_padding_counter_done) begin
                main_ethmac_tx_padding_source_payload_last_be <= 1'd1;
                main_ethmac_tx_padding_source_last <= 1'd1;
            end
            main_ethmac_tx_padding_source_payload_data <= 1'd0;
            if ((main_ethmac_tx_padding_source_valid & main_ethmac_tx_padding_source_ready)) begin
                main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value <= (main_ethmac_tx_padding_counter + 1'd1);
                main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value_ce <= 1'd1;
                if (main_ethmac_tx_padding_counter_done) begin
                    main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value <= 1'd0;
                    main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value_ce <= 1'd1;
                    builder_soclinux_txdatapath_liteethmacpaddinginserter_next_state <= 1'd0;
                end
            end
        end
        default: begin
            main_ethmac_tx_padding_source_valid <= main_ethmac_tx_padding_sink_valid;
            main_ethmac_tx_padding_sink_ready <= main_ethmac_tx_padding_source_ready;
            main_ethmac_tx_padding_source_first <= main_ethmac_tx_padding_sink_first;
            main_ethmac_tx_padding_source_last <= main_ethmac_tx_padding_sink_last;
            main_ethmac_tx_padding_source_payload_data <= main_ethmac_tx_padding_sink_payload_data;
            main_ethmac_tx_padding_source_payload_last_be <= main_ethmac_tx_padding_sink_payload_last_be;
            main_ethmac_tx_padding_source_payload_error <= main_ethmac_tx_padding_sink_payload_error;
            if ((main_ethmac_tx_padding_source_valid & main_ethmac_tx_padding_source_ready)) begin
                main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value <= (main_ethmac_tx_padding_counter + 1'd1);
                main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value_ce <= 1'd1;
                if (main_ethmac_tx_padding_sink_last) begin
                    if ((~main_ethmac_tx_padding_counter_done)) begin
                        main_ethmac_tx_padding_source_last <= 1'd0;
                        main_ethmac_tx_padding_source_payload_last_be <= 1'd0;
                        builder_soclinux_txdatapath_liteethmacpaddinginserter_next_state <= 1'd1;
                    end else begin
                        if (((main_ethmac_tx_padding_counter == 6'd59) & (main_ethmac_tx_padding_sink_payload_last_be < 1'd1))) begin
                            main_ethmac_tx_padding_source_payload_last_be <= 1'd1;
                        end else begin
                            main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value <= 1'd0;
                            main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value_ce <= 1'd1;
                        end
                    end
                end
            end
        end
    endcase
end
assign main_ethmac_tx_crc_cnt_done = (main_ethmac_tx_crc_cnt == 1'd0);
assign main_ethmac_tx_crc_sink_valid = main_ethmac_tx_crc_source_source_valid;
assign main_ethmac_tx_crc_source_source_ready = main_ethmac_tx_crc_sink_ready;
assign main_ethmac_tx_crc_sink_first = main_ethmac_tx_crc_source_source_first;
assign main_ethmac_tx_crc_sink_last = main_ethmac_tx_crc_source_source_last;
assign main_ethmac_tx_crc_sink_payload_data = main_ethmac_tx_crc_source_source_payload_data;
assign main_ethmac_tx_crc_sink_payload_last_be = main_ethmac_tx_crc_source_source_payload_last_be;
assign main_ethmac_tx_crc_sink_payload_error = main_ethmac_tx_crc_source_source_payload_error;
always @(*) begin
    main_ethmac_tx_crc_last_be1 <= 1'd0;
    if ((main_ethmac_tx_crc_last_be0 != 1'd0)) begin
        main_ethmac_tx_crc_last_be1 <= main_ethmac_tx_crc_last_be0;
    end else begin
        main_ethmac_tx_crc_last_be1 <= 1'd1;
    end
end
assign main_ethmac_tx_crc_data1 = main_ethmac_tx_crc_data0[7:0];
assign main_ethmac_tx_crc_last = main_ethmac_tx_crc_reg;
always @(*) begin
    main_ethmac_tx_crc_value <= 32'd0;
    main_ethmac_tx_crc_error <= 1'd0;
    if (main_ethmac_tx_crc_last_be1) begin
        main_ethmac_tx_crc_value <= {builder_t_slice_proxy31[0], builder_t_slice_proxy30[1], builder_t_slice_proxy29[2], builder_t_slice_proxy28[3], builder_t_slice_proxy27[4], builder_t_slice_proxy26[5], builder_t_slice_proxy25[6], builder_t_slice_proxy24[7], builder_t_slice_proxy23[8], builder_t_slice_proxy22[9], builder_t_slice_proxy21[10], builder_t_slice_proxy20[11], builder_t_slice_proxy19[12], builder_t_slice_proxy18[13], builder_t_slice_proxy17[14], builder_t_slice_proxy16[15], builder_t_slice_proxy15[16], builder_t_slice_proxy14[17], builder_t_slice_proxy13[18], builder_t_slice_proxy12[19], builder_t_slice_proxy11[20], builder_t_slice_proxy10[21], builder_t_slice_proxy9[22], builder_t_slice_proxy8[23], builder_t_slice_proxy7[24], builder_t_slice_proxy6[25], builder_t_slice_proxy5[26], builder_t_slice_proxy4[27], builder_t_slice_proxy3[28], builder_t_slice_proxy2[29], builder_t_slice_proxy1[30], builder_t_slice_proxy0[31]};
        main_ethmac_tx_crc_error <= (main_ethmac_tx_crc_next != 32'd3338984827);
    end
end
always @(*) begin
    main_ethmac_tx_crc_next <= 32'd0;
    main_ethmac_tx_crc_next[0] <= (((main_ethmac_tx_crc_last[24] ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[1] <= (((((((main_ethmac_tx_crc_last[25] ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[2] <= (((((((((main_ethmac_tx_crc_last[26] ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[3] <= (((((((main_ethmac_tx_crc_last[27] ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]);
    main_ethmac_tx_crc_next[4] <= (((((((((main_ethmac_tx_crc_last[28] ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[5] <= (((((((((((((main_ethmac_tx_crc_last[29] ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[6] <= (((((((((((main_ethmac_tx_crc_last[30] ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]);
    main_ethmac_tx_crc_next[7] <= (((((((((main_ethmac_tx_crc_last[31] ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[8] <= ((((((((main_ethmac_tx_crc_last[0] ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_data1[6]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[9] <= ((((((((main_ethmac_tx_crc_last[1] ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_data1[6]);
    main_ethmac_tx_crc_next[10] <= ((((((((main_ethmac_tx_crc_last[2] ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[11] <= ((((((((main_ethmac_tx_crc_last[3] ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_data1[6]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[12] <= ((((((((((((main_ethmac_tx_crc_last[4] ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_data1[6]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[13] <= ((((((((((((main_ethmac_tx_crc_last[5] ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]);
    main_ethmac_tx_crc_next[14] <= ((((((((((main_ethmac_tx_crc_last[6] ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]);
    main_ethmac_tx_crc_next[15] <= ((((((((main_ethmac_tx_crc_last[7] ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]);
    main_ethmac_tx_crc_next[16] <= ((((((main_ethmac_tx_crc_last[8] ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[17] <= ((((((main_ethmac_tx_crc_last[9] ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_data1[6]);
    main_ethmac_tx_crc_next[18] <= ((((((main_ethmac_tx_crc_last[10] ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]);
    main_ethmac_tx_crc_next[19] <= ((((main_ethmac_tx_crc_last[11] ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]);
    main_ethmac_tx_crc_next[20] <= ((main_ethmac_tx_crc_last[12] ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]);
    main_ethmac_tx_crc_next[21] <= ((main_ethmac_tx_crc_last[13] ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]);
    main_ethmac_tx_crc_next[22] <= ((main_ethmac_tx_crc_last[14] ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[23] <= ((((((main_ethmac_tx_crc_last[15] ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_data1[6]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[24] <= ((((((main_ethmac_tx_crc_last[16] ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]);
    main_ethmac_tx_crc_next[25] <= ((((main_ethmac_tx_crc_last[17] ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]);
    main_ethmac_tx_crc_next[26] <= ((((((((main_ethmac_tx_crc_last[18] ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]) ^ main_ethmac_tx_crc_last[24]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_data1[7]);
    main_ethmac_tx_crc_next[27] <= ((((((((main_ethmac_tx_crc_last[19] ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]) ^ main_ethmac_tx_crc_last[25]) ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_data1[6]);
    main_ethmac_tx_crc_next[28] <= ((((((main_ethmac_tx_crc_last[20] ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]) ^ main_ethmac_tx_crc_last[26]) ^ main_ethmac_tx_crc_data1[5]);
    main_ethmac_tx_crc_next[29] <= ((((((main_ethmac_tx_crc_last[21] ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_last[30]) ^ main_ethmac_tx_crc_data1[1]) ^ main_ethmac_tx_crc_last[27]) ^ main_ethmac_tx_crc_data1[4]);
    main_ethmac_tx_crc_next[30] <= ((((main_ethmac_tx_crc_last[22] ^ main_ethmac_tx_crc_last[31]) ^ main_ethmac_tx_crc_data1[0]) ^ main_ethmac_tx_crc_last[28]) ^ main_ethmac_tx_crc_data1[3]);
    main_ethmac_tx_crc_next[31] <= ((main_ethmac_tx_crc_last[23] ^ main_ethmac_tx_crc_last[29]) ^ main_ethmac_tx_crc_data1[2]);
end
always @(*) begin
    builder_soclinux_txdatapath_bufferizeendpoints_next_state <= 2'd0;
    main_ethmac_tx_crc_sink_ready <= 1'd0;
    main_ethmac_tx_crc_is_ongoing0 <= 1'd0;
    main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value0 <= 32'd0;
    main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce0 <= 1'd0;
    main_ethmac_tx_crc_is_ongoing1 <= 1'd0;
    main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value1 <= 1'd0;
    main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce1 <= 1'd0;
    main_ethmac_tx_crc_source_valid <= 1'd0;
    main_ethmac_tx_crc_ce <= 1'd0;
    main_ethmac_tx_crc_reset <= 1'd0;
    main_ethmac_tx_crc_source_first <= 1'd0;
    main_ethmac_tx_crc_source_last <= 1'd0;
    main_ethmac_tx_crc_source_payload_data <= 8'd0;
    main_ethmac_tx_crc_source_payload_last_be <= 1'd0;
    main_ethmac_tx_crc_source_payload_error <= 1'd0;
    main_ethmac_tx_crc_data0 <= 8'd0;
    main_ethmac_tx_crc_last_be0 <= 1'd0;
    builder_soclinux_txdatapath_bufferizeendpoints_next_state <= builder_soclinux_txdatapath_bufferizeendpoints_state;
    case (builder_soclinux_txdatapath_bufferizeendpoints_state)
        1'd1: begin
            main_ethmac_tx_crc_ce <= (main_ethmac_tx_crc_sink_valid & main_ethmac_tx_crc_source_ready);
            main_ethmac_tx_crc_data0 <= main_ethmac_tx_crc_sink_payload_data;
            main_ethmac_tx_crc_last_be0 <= main_ethmac_tx_crc_sink_payload_last_be;
            main_ethmac_tx_crc_source_valid <= main_ethmac_tx_crc_sink_valid;
            main_ethmac_tx_crc_sink_ready <= main_ethmac_tx_crc_source_ready;
            main_ethmac_tx_crc_source_first <= main_ethmac_tx_crc_sink_first;
            main_ethmac_tx_crc_source_last <= main_ethmac_tx_crc_sink_last;
            main_ethmac_tx_crc_source_payload_data <= main_ethmac_tx_crc_sink_payload_data;
            main_ethmac_tx_crc_source_payload_last_be <= main_ethmac_tx_crc_sink_payload_last_be;
            main_ethmac_tx_crc_source_payload_error <= main_ethmac_tx_crc_sink_payload_error;
            main_ethmac_tx_crc_source_last <= 1'd0;
            main_ethmac_tx_crc_source_payload_last_be <= 1'd0;
            if (main_ethmac_tx_crc_sink_last) begin
                if (main_ethmac_tx_crc_sink_payload_last_be) begin
                    main_ethmac_tx_crc_source_payload_data <= builder_cases_slice_proxy[7:0];
                end
                if ((1'd0 & (main_ethmac_tx_crc_sink_payload_last_be <= 4'd15))) begin
                    main_ethmac_tx_crc_source_last <= 1'd1;
                    main_ethmac_tx_crc_source_payload_last_be <= (main_ethmac_tx_crc_sink_payload_last_be <<< -3'd3);
                end
            end else begin
                main_ethmac_tx_crc_ce <= (main_ethmac_tx_crc_sink_valid & main_ethmac_tx_crc_source_ready);
            end
            if (((main_ethmac_tx_crc_sink_valid & main_ethmac_tx_crc_sink_last) & main_ethmac_tx_crc_source_ready)) begin
                if ((1'd0 & (main_ethmac_tx_crc_sink_payload_last_be <= 4'd15))) begin
                    builder_soclinux_txdatapath_bufferizeendpoints_next_state <= 1'd0;
                end else begin
                    main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value0 <= main_ethmac_tx_crc_value;
                    main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce0 <= 1'd1;
                    if (1'd0) begin
                        main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value1 <= (main_ethmac_tx_crc_sink_payload_last_be >>> 3'd4);
                        main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce1 <= 1'd1;
                    end else begin
                        main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value1 <= main_ethmac_tx_crc_sink_payload_last_be;
                        main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce1 <= 1'd1;
                    end
                    builder_soclinux_txdatapath_bufferizeendpoints_next_state <= 2'd2;
                end
            end
        end
        2'd2: begin
            main_ethmac_tx_crc_source_valid <= 1'd1;
            case (main_ethmac_tx_crc_cnt)
                1'd0: begin
                    main_ethmac_tx_crc_source_payload_data <= main_ethmac_tx_crc_crc_packet[31:24];
                end
                1'd1: begin
                    main_ethmac_tx_crc_source_payload_data <= main_ethmac_tx_crc_crc_packet[23:16];
                end
                2'd2: begin
                    main_ethmac_tx_crc_source_payload_data <= main_ethmac_tx_crc_crc_packet[15:8];
                end
                default: begin
                    main_ethmac_tx_crc_source_payload_data <= main_ethmac_tx_crc_crc_packet[7:0];
                end
            endcase
            if (main_ethmac_tx_crc_cnt_done) begin
                main_ethmac_tx_crc_source_last <= 1'd1;
                if (main_ethmac_tx_crc_source_ready) begin
                    builder_soclinux_txdatapath_bufferizeendpoints_next_state <= 1'd0;
                end
            end
            main_ethmac_tx_crc_is_ongoing1 <= 1'd1;
        end
        default: begin
            main_ethmac_tx_crc_reset <= 1'd1;
            main_ethmac_tx_crc_sink_ready <= 1'd1;
            if (main_ethmac_tx_crc_sink_valid) begin
                main_ethmac_tx_crc_sink_ready <= 1'd0;
                builder_soclinux_txdatapath_bufferizeendpoints_next_state <= 1'd1;
            end
            main_ethmac_tx_crc_is_ongoing0 <= 1'd1;
        end
    endcase
end
assign main_ethmac_tx_crc_pipe_valid_sink_ready = ((~main_ethmac_tx_crc_pipe_valid_source_valid) | main_ethmac_tx_crc_pipe_valid_source_ready);
assign main_ethmac_tx_crc_pipe_valid_sink_valid = main_ethmac_tx_crc_sink_sink_valid;
assign main_ethmac_tx_crc_sink_sink_ready = main_ethmac_tx_crc_pipe_valid_sink_ready;
assign main_ethmac_tx_crc_pipe_valid_sink_first = main_ethmac_tx_crc_sink_sink_first;
assign main_ethmac_tx_crc_pipe_valid_sink_last = main_ethmac_tx_crc_sink_sink_last;
assign main_ethmac_tx_crc_pipe_valid_sink_payload_data = main_ethmac_tx_crc_sink_sink_payload_data;
assign main_ethmac_tx_crc_pipe_valid_sink_payload_last_be = main_ethmac_tx_crc_sink_sink_payload_last_be;
assign main_ethmac_tx_crc_pipe_valid_sink_payload_error = main_ethmac_tx_crc_sink_sink_payload_error;
assign main_ethmac_tx_crc_source_source_valid = main_ethmac_tx_crc_pipe_valid_source_valid;
assign main_ethmac_tx_crc_pipe_valid_source_ready = main_ethmac_tx_crc_source_source_ready;
assign main_ethmac_tx_crc_source_source_first = main_ethmac_tx_crc_pipe_valid_source_first;
assign main_ethmac_tx_crc_source_source_last = main_ethmac_tx_crc_pipe_valid_source_last;
assign main_ethmac_tx_crc_source_source_payload_data = main_ethmac_tx_crc_pipe_valid_source_payload_data;
assign main_ethmac_tx_crc_source_source_payload_last_be = main_ethmac_tx_crc_pipe_valid_source_payload_last_be;
assign main_ethmac_tx_crc_source_source_payload_error = main_ethmac_tx_crc_pipe_valid_source_payload_error;
assign main_ethmac_tx_preamble_source_payload_last_be = main_ethmac_tx_preamble_sink_payload_last_be;
always @(*) begin
    main_ethmac_tx_preamble_source_valid <= 1'd0;
    main_ethmac_tx_preamble_source_first <= 1'd0;
    builder_soclinux_txdatapath_liteethmacpreambleinserter_next_state <= 2'd0;
    main_ethmac_tx_preamble_source_last <= 1'd0;
    main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value <= 3'd0;
    main_ethmac_tx_preamble_source_payload_data <= 8'd0;
    main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value_ce <= 1'd0;
    main_ethmac_tx_preamble_source_payload_error <= 1'd0;
    main_ethmac_tx_preamble_sink_ready <= 1'd0;
    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_sink_payload_data;
    builder_soclinux_txdatapath_liteethmacpreambleinserter_next_state <= builder_soclinux_txdatapath_liteethmacpreambleinserter_state;
    case (builder_soclinux_txdatapath_liteethmacpreambleinserter_state)
        1'd1: begin
            main_ethmac_tx_preamble_source_valid <= 1'd1;
            case (main_ethmac_tx_preamble_count)
                1'd0: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[7:0];
                end
                1'd1: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[15:8];
                end
                2'd2: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[23:16];
                end
                2'd3: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[31:24];
                end
                3'd4: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[39:32];
                end
                3'd5: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[47:40];
                end
                3'd6: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[55:48];
                end
                default: begin
                    main_ethmac_tx_preamble_source_payload_data <= main_ethmac_tx_preamble_preamble[63:56];
                end
            endcase
            if (main_ethmac_tx_preamble_source_ready) begin
                if ((main_ethmac_tx_preamble_count == 3'd7)) begin
                    builder_soclinux_txdatapath_liteethmacpreambleinserter_next_state <= 2'd2;
                end else begin
                    main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value <= (main_ethmac_tx_preamble_count + 1'd1);
                    main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value_ce <= 1'd1;
                end
            end
        end
        2'd2: begin
            main_ethmac_tx_preamble_source_valid <= main_ethmac_tx_preamble_sink_valid;
            main_ethmac_tx_preamble_sink_ready <= main_ethmac_tx_preamble_source_ready;
            main_ethmac_tx_preamble_source_first <= main_ethmac_tx_preamble_sink_first;
            main_ethmac_tx_preamble_source_last <= main_ethmac_tx_preamble_sink_last;
            main_ethmac_tx_preamble_source_payload_error <= main_ethmac_tx_preamble_sink_payload_error;
            if (((main_ethmac_tx_preamble_sink_valid & main_ethmac_tx_preamble_sink_last) & main_ethmac_tx_preamble_source_ready)) begin
                builder_soclinux_txdatapath_liteethmacpreambleinserter_next_state <= 1'd0;
            end
        end
        default: begin
            main_ethmac_tx_preamble_sink_ready <= 1'd1;
            main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value <= 1'd0;
            main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value_ce <= 1'd1;
            if (main_ethmac_tx_preamble_sink_valid) begin
                main_ethmac_tx_preamble_sink_ready <= 1'd0;
                builder_soclinux_txdatapath_liteethmacpreambleinserter_next_state <= 1'd1;
            end
        end
    endcase
end
always @(*) begin
    main_ethmac_tx_gap_source_first <= 1'd0;
    main_ethmac_tx_gap_source_last <= 1'd0;
    main_ethmac_tx_gap_source_payload_data <= 8'd0;
    main_ethmac_tx_gap_source_payload_last_be <= 1'd0;
    main_ethmac_tx_gap_source_payload_error <= 1'd0;
    builder_soclinux_txdatapath_liteethmacgap_next_state <= 1'd0;
    main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value <= 4'd0;
    main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value_ce <= 1'd0;
    main_ethmac_tx_gap_sink_ready <= 1'd0;
    main_ethmac_tx_gap_source_valid <= 1'd0;
    builder_soclinux_txdatapath_liteethmacgap_next_state <= builder_soclinux_txdatapath_liteethmacgap_state;
    case (builder_soclinux_txdatapath_liteethmacgap_state)
        1'd1: begin
            main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value <= (main_ethmac_tx_gap_counter + 1'd1);
            main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value_ce <= 1'd1;
            if ((main_ethmac_tx_gap_counter == 4'd11)) begin
                builder_soclinux_txdatapath_liteethmacgap_next_state <= 1'd0;
            end
        end
        default: begin
            main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value <= 1'd0;
            main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value_ce <= 1'd1;
            main_ethmac_tx_gap_source_valid <= main_ethmac_tx_gap_sink_valid;
            main_ethmac_tx_gap_sink_ready <= main_ethmac_tx_gap_source_ready;
            main_ethmac_tx_gap_source_first <= main_ethmac_tx_gap_sink_first;
            main_ethmac_tx_gap_source_last <= main_ethmac_tx_gap_sink_last;
            main_ethmac_tx_gap_source_payload_data <= main_ethmac_tx_gap_sink_payload_data;
            main_ethmac_tx_gap_source_payload_last_be <= main_ethmac_tx_gap_sink_payload_last_be;
            main_ethmac_tx_gap_source_payload_error <= main_ethmac_tx_gap_sink_payload_error;
            if (((main_ethmac_tx_gap_sink_valid & main_ethmac_tx_gap_sink_last) & main_ethmac_tx_gap_sink_ready)) begin
                builder_soclinux_txdatapath_liteethmacgap_next_state <= 1'd1;
            end
        end
    endcase
end
assign main_ethmac_tx_cdc_sink_sink_valid = main_ethmac_sink_valid;
assign main_ethmac_sink_ready = main_ethmac_tx_cdc_sink_sink_ready;
assign main_ethmac_tx_cdc_sink_sink_first = main_ethmac_sink_first;
assign main_ethmac_tx_cdc_sink_sink_last = main_ethmac_sink_last;
assign main_ethmac_tx_cdc_sink_sink_payload_data = main_ethmac_sink_payload_data;
assign main_ethmac_tx_cdc_sink_sink_payload_last_be = main_ethmac_sink_payload_last_be;
assign main_ethmac_tx_cdc_sink_sink_payload_error = main_ethmac_sink_payload_error;
assign main_ethmac_tx_converter_sink_valid = main_ethmac_tx_cdc_source_source_valid;
assign main_ethmac_tx_cdc_source_source_ready = main_ethmac_tx_converter_sink_ready;
assign main_ethmac_tx_converter_sink_first = main_ethmac_tx_cdc_source_source_first;
assign main_ethmac_tx_converter_sink_last = main_ethmac_tx_cdc_source_source_last;
assign main_ethmac_tx_converter_sink_payload_data = main_ethmac_tx_cdc_source_source_payload_data;
assign main_ethmac_tx_converter_sink_payload_last_be = main_ethmac_tx_cdc_source_source_payload_last_be;
assign main_ethmac_tx_converter_sink_payload_error = main_ethmac_tx_cdc_source_source_payload_error;
assign main_ethmac_tx_last_be_sink_valid = main_ethmac_tx_converter_source_valid;
assign main_ethmac_tx_converter_source_ready = main_ethmac_tx_last_be_sink_ready;
assign main_ethmac_tx_last_be_sink_first = main_ethmac_tx_converter_source_first;
assign main_ethmac_tx_last_be_sink_last = main_ethmac_tx_converter_source_last;
assign main_ethmac_tx_last_be_sink_payload_data = main_ethmac_tx_converter_source_payload_data;
assign main_ethmac_tx_last_be_sink_payload_last_be = main_ethmac_tx_converter_source_payload_last_be;
assign main_ethmac_tx_last_be_sink_payload_error = main_ethmac_tx_converter_source_payload_error;
assign main_ethmac_tx_padding_sink_valid = main_ethmac_tx_last_be_source_valid;
assign main_ethmac_tx_last_be_source_ready = main_ethmac_tx_padding_sink_ready;
assign main_ethmac_tx_padding_sink_first = main_ethmac_tx_last_be_source_first;
assign main_ethmac_tx_padding_sink_last = main_ethmac_tx_last_be_source_last;
assign main_ethmac_tx_padding_sink_payload_data = main_ethmac_tx_last_be_source_payload_data;
assign main_ethmac_tx_padding_sink_payload_last_be = main_ethmac_tx_last_be_source_payload_last_be;
assign main_ethmac_tx_padding_sink_payload_error = main_ethmac_tx_last_be_source_payload_error;
assign main_ethmac_tx_crc_sink_sink_valid = main_ethmac_tx_padding_source_valid;
assign main_ethmac_tx_padding_source_ready = main_ethmac_tx_crc_sink_sink_ready;
assign main_ethmac_tx_crc_sink_sink_first = main_ethmac_tx_padding_source_first;
assign main_ethmac_tx_crc_sink_sink_last = main_ethmac_tx_padding_source_last;
assign main_ethmac_tx_crc_sink_sink_payload_data = main_ethmac_tx_padding_source_payload_data;
assign main_ethmac_tx_crc_sink_sink_payload_last_be = main_ethmac_tx_padding_source_payload_last_be;
assign main_ethmac_tx_crc_sink_sink_payload_error = main_ethmac_tx_padding_source_payload_error;
assign main_ethmac_tx_preamble_sink_valid = main_ethmac_tx_crc_source_valid;
assign main_ethmac_tx_crc_source_ready = main_ethmac_tx_preamble_sink_ready;
assign main_ethmac_tx_preamble_sink_first = main_ethmac_tx_crc_source_first;
assign main_ethmac_tx_preamble_sink_last = main_ethmac_tx_crc_source_last;
assign main_ethmac_tx_preamble_sink_payload_data = main_ethmac_tx_crc_source_payload_data;
assign main_ethmac_tx_preamble_sink_payload_last_be = main_ethmac_tx_crc_source_payload_last_be;
assign main_ethmac_tx_preamble_sink_payload_error = main_ethmac_tx_crc_source_payload_error;
assign main_ethmac_tx_gap_sink_valid = main_ethmac_tx_preamble_source_valid;
assign main_ethmac_tx_preamble_source_ready = main_ethmac_tx_gap_sink_ready;
assign main_ethmac_tx_gap_sink_first = main_ethmac_tx_preamble_source_first;
assign main_ethmac_tx_gap_sink_last = main_ethmac_tx_preamble_source_last;
assign main_ethmac_tx_gap_sink_payload_data = main_ethmac_tx_preamble_source_payload_data;
assign main_ethmac_tx_gap_sink_payload_last_be = main_ethmac_tx_preamble_source_payload_last_be;
assign main_ethmac_tx_gap_sink_payload_error = main_ethmac_tx_preamble_source_payload_error;
assign main_ku_1000basex_sink_valid = main_ethmac_tx_gap_source_valid;
assign main_ethmac_tx_gap_source_ready = main_ku_1000basex_sink_ready;
assign main_ku_1000basex_sink_first = main_ethmac_tx_gap_source_first;
assign main_ku_1000basex_sink_last = main_ethmac_tx_gap_source_last;
assign main_ku_1000basex_sink_payload_data = main_ethmac_tx_gap_source_payload_data;
assign main_ku_1000basex_sink_payload_last_be = main_ethmac_tx_gap_source_payload_last_be;
assign main_ku_1000basex_sink_payload_error = main_ethmac_tx_gap_source_payload_error;
assign main_ethmac_pulsesynchronizer0_i = main_ethmac_rx_preamble_error;
assign main_ethmac_pulsesynchronizer1_i = main_ethmac_liteethmaccrc32checker_error;
assign main_ethmac_rx_preamble_source_payload_data = main_ethmac_rx_preamble_sink_payload_data;
assign main_ethmac_rx_preamble_source_payload_last_be = main_ethmac_rx_preamble_sink_payload_last_be;
always @(*) begin
    main_ethmac_rx_preamble_sink_ready <= 1'd0;
    main_ethmac_rx_preamble_source_first <= 1'd0;
    main_ethmac_rx_preamble_source_last <= 1'd0;
    main_ethmac_rx_preamble_source_payload_error <= 1'd0;
    main_ethmac_rx_preamble_error <= 1'd0;
    builder_soclinux_rxdatapath_liteethmacpreamblechecker_next_state <= 1'd0;
    main_ethmac_rx_preamble_source_valid <= 1'd0;
    builder_soclinux_rxdatapath_liteethmacpreamblechecker_next_state <= builder_soclinux_rxdatapath_liteethmacpreamblechecker_state;
    case (builder_soclinux_rxdatapath_liteethmacpreamblechecker_state)
        1'd1: begin
            main_ethmac_rx_preamble_source_valid <= main_ethmac_rx_preamble_sink_valid;
            main_ethmac_rx_preamble_sink_ready <= main_ethmac_rx_preamble_source_ready;
            main_ethmac_rx_preamble_source_first <= main_ethmac_rx_preamble_sink_first;
            main_ethmac_rx_preamble_source_last <= main_ethmac_rx_preamble_sink_last;
            main_ethmac_rx_preamble_source_payload_error <= main_ethmac_rx_preamble_sink_payload_error;
            if (((main_ethmac_rx_preamble_source_valid & main_ethmac_rx_preamble_source_last) & main_ethmac_rx_preamble_source_ready)) begin
                builder_soclinux_rxdatapath_liteethmacpreamblechecker_next_state <= 1'd0;
            end
        end
        default: begin
            main_ethmac_rx_preamble_sink_ready <= 1'd1;
            if (((main_ethmac_rx_preamble_sink_valid & (~main_ethmac_rx_preamble_sink_last)) & (main_ethmac_rx_preamble_sink_payload_data == main_ethmac_rx_preamble_preamble[63:56]))) begin
                builder_soclinux_rxdatapath_liteethmacpreamblechecker_next_state <= 1'd1;
            end
            if ((main_ethmac_rx_preamble_sink_valid & main_ethmac_rx_preamble_sink_last)) begin
                main_ethmac_rx_preamble_error <= 1'd1;
            end
        end
    endcase
end
assign main_ethmac_pulsesynchronizer0_o = (main_ethmac_pulsesynchronizer0_toggle_o ^ main_ethmac_pulsesynchronizer0_toggle_o_r);
assign main_ethmac_liteethmaccrc32checker_fifo_full = (main_ethmac_liteethmaccrc32checker_syncfifo_level == 3'd4);
assign main_ethmac_liteethmaccrc32checker_fifo_in = (main_ethmac_liteethmaccrc32checker_sink_sink_valid & ((~main_ethmac_liteethmaccrc32checker_fifo_full) | main_ethmac_liteethmaccrc32checker_fifo_out));
assign main_ethmac_liteethmaccrc32checker_fifo_out = (main_ethmac_liteethmaccrc32checker_source_source_valid & main_ethmac_liteethmaccrc32checker_source_source_ready);
assign main_ethmac_liteethmaccrc32checker_syncfifo_sink_first = main_ethmac_liteethmaccrc32checker_sink_sink_first;
assign main_ethmac_liteethmaccrc32checker_syncfifo_sink_last = main_ethmac_liteethmaccrc32checker_sink_sink_last;
assign main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_data = main_ethmac_liteethmaccrc32checker_sink_sink_payload_data;
assign main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_last_be = main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be;
assign main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_error = main_ethmac_liteethmaccrc32checker_sink_sink_payload_error;
always @(*) begin
    main_ethmac_liteethmaccrc32checker_syncfifo_sink_valid <= 1'd0;
    main_ethmac_liteethmaccrc32checker_syncfifo_sink_valid <= main_ethmac_liteethmaccrc32checker_sink_sink_valid;
    main_ethmac_liteethmaccrc32checker_syncfifo_sink_valid <= main_ethmac_liteethmaccrc32checker_fifo_in;
end
always @(*) begin
    main_ethmac_liteethmaccrc32checker_sink_sink_ready <= 1'd0;
    main_ethmac_liteethmaccrc32checker_sink_sink_ready <= main_ethmac_liteethmaccrc32checker_syncfifo_sink_ready;
    main_ethmac_liteethmaccrc32checker_sink_sink_ready <= main_ethmac_liteethmaccrc32checker_fifo_in;
end
assign main_ethmac_liteethmaccrc32checker_crc_data0 = main_ethmac_liteethmaccrc32checker_sink_sink_payload_data;
assign main_ethmac_liteethmaccrc32checker_crc_last_be0 = main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be;
assign main_ethmac_liteethmaccrc32checker_sink_sink_valid = main_ethmac_bufferizeendpoints_source_source_valid;
assign main_ethmac_bufferizeendpoints_source_source_ready = main_ethmac_liteethmaccrc32checker_sink_sink_ready;
assign main_ethmac_liteethmaccrc32checker_sink_sink_first = main_ethmac_bufferizeendpoints_source_source_first;
assign main_ethmac_liteethmaccrc32checker_sink_sink_last = main_ethmac_bufferizeendpoints_source_source_last;
assign main_ethmac_liteethmaccrc32checker_sink_sink_payload_data = main_ethmac_bufferizeendpoints_source_source_payload_data;
assign main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be = main_ethmac_bufferizeendpoints_source_source_payload_last_be;
assign main_ethmac_liteethmaccrc32checker_sink_sink_payload_error = main_ethmac_bufferizeendpoints_source_source_payload_error;
always @(*) begin
    main_ethmac_liteethmaccrc32checker_crc_last_be1 <= 1'd0;
    if ((main_ethmac_liteethmaccrc32checker_crc_last_be0 != 1'd0)) begin
        main_ethmac_liteethmaccrc32checker_crc_last_be1 <= main_ethmac_liteethmaccrc32checker_crc_last_be0;
    end else begin
        main_ethmac_liteethmaccrc32checker_crc_last_be1 <= 1'd1;
    end
end
assign main_ethmac_liteethmaccrc32checker_crc_data1 = main_ethmac_liteethmaccrc32checker_crc_data0[7:0];
assign main_ethmac_liteethmaccrc32checker_crc_last = main_ethmac_liteethmaccrc32checker_crc_reg;
always @(*) begin
    main_ethmac_liteethmaccrc32checker_crc_value <= 32'd0;
    main_ethmac_liteethmaccrc32checker_crc_error0 <= 1'd0;
    if (main_ethmac_liteethmaccrc32checker_crc_last_be1) begin
        main_ethmac_liteethmaccrc32checker_crc_value <= {builder_t_slice_proxy63[0], builder_t_slice_proxy62[1], builder_t_slice_proxy61[2], builder_t_slice_proxy60[3], builder_t_slice_proxy59[4], builder_t_slice_proxy58[5], builder_t_slice_proxy57[6], builder_t_slice_proxy56[7], builder_t_slice_proxy55[8], builder_t_slice_proxy54[9], builder_t_slice_proxy53[10], builder_t_slice_proxy52[11], builder_t_slice_proxy51[12], builder_t_slice_proxy50[13], builder_t_slice_proxy49[14], builder_t_slice_proxy48[15], builder_t_slice_proxy47[16], builder_t_slice_proxy46[17], builder_t_slice_proxy45[18], builder_t_slice_proxy44[19], builder_t_slice_proxy43[20], builder_t_slice_proxy42[21], builder_t_slice_proxy41[22], builder_t_slice_proxy40[23], builder_t_slice_proxy39[24], builder_t_slice_proxy38[25], builder_t_slice_proxy37[26], builder_t_slice_proxy36[27], builder_t_slice_proxy35[28], builder_t_slice_proxy34[29], builder_t_slice_proxy33[30], builder_t_slice_proxy32[31]};
        main_ethmac_liteethmaccrc32checker_crc_error0 <= (main_ethmac_liteethmaccrc32checker_crc_next != 32'd3338984827);
    end
end
always @(*) begin
    main_ethmac_liteethmaccrc32checker_crc_next <= 32'd0;
    main_ethmac_liteethmaccrc32checker_crc_next[0] <= (((main_ethmac_liteethmaccrc32checker_crc_last[24] ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[1] <= (((((((main_ethmac_liteethmaccrc32checker_crc_last[25] ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[2] <= (((((((((main_ethmac_liteethmaccrc32checker_crc_last[26] ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[3] <= (((((((main_ethmac_liteethmaccrc32checker_crc_last[27] ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]);
    main_ethmac_liteethmaccrc32checker_crc_next[4] <= (((((((((main_ethmac_liteethmaccrc32checker_crc_last[28] ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[5] <= (((((((((((((main_ethmac_liteethmaccrc32checker_crc_last[29] ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[6] <= (((((((((((main_ethmac_liteethmaccrc32checker_crc_last[30] ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]);
    main_ethmac_liteethmaccrc32checker_crc_next[7] <= (((((((((main_ethmac_liteethmaccrc32checker_crc_last[31] ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[8] <= ((((((((main_ethmac_liteethmaccrc32checker_crc_last[0] ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[9] <= ((((((((main_ethmac_liteethmaccrc32checker_crc_last[1] ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]);
    main_ethmac_liteethmaccrc32checker_crc_next[10] <= ((((((((main_ethmac_liteethmaccrc32checker_crc_last[2] ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[11] <= ((((((((main_ethmac_liteethmaccrc32checker_crc_last[3] ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[12] <= ((((((((((((main_ethmac_liteethmaccrc32checker_crc_last[4] ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[13] <= ((((((((((((main_ethmac_liteethmaccrc32checker_crc_last[5] ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]);
    main_ethmac_liteethmaccrc32checker_crc_next[14] <= ((((((((((main_ethmac_liteethmaccrc32checker_crc_last[6] ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]);
    main_ethmac_liteethmaccrc32checker_crc_next[15] <= ((((((((main_ethmac_liteethmaccrc32checker_crc_last[7] ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]);
    main_ethmac_liteethmaccrc32checker_crc_next[16] <= ((((((main_ethmac_liteethmaccrc32checker_crc_last[8] ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[17] <= ((((((main_ethmac_liteethmaccrc32checker_crc_last[9] ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]);
    main_ethmac_liteethmaccrc32checker_crc_next[18] <= ((((((main_ethmac_liteethmaccrc32checker_crc_last[10] ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]);
    main_ethmac_liteethmaccrc32checker_crc_next[19] <= ((((main_ethmac_liteethmaccrc32checker_crc_last[11] ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]);
    main_ethmac_liteethmaccrc32checker_crc_next[20] <= ((main_ethmac_liteethmaccrc32checker_crc_last[12] ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]);
    main_ethmac_liteethmaccrc32checker_crc_next[21] <= ((main_ethmac_liteethmaccrc32checker_crc_last[13] ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]);
    main_ethmac_liteethmaccrc32checker_crc_next[22] <= ((main_ethmac_liteethmaccrc32checker_crc_last[14] ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[23] <= ((((((main_ethmac_liteethmaccrc32checker_crc_last[15] ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[24] <= ((((((main_ethmac_liteethmaccrc32checker_crc_last[16] ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]);
    main_ethmac_liteethmaccrc32checker_crc_next[25] <= ((((main_ethmac_liteethmaccrc32checker_crc_last[17] ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]);
    main_ethmac_liteethmaccrc32checker_crc_next[26] <= ((((((((main_ethmac_liteethmaccrc32checker_crc_last[18] ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]) ^ main_ethmac_liteethmaccrc32checker_crc_last[24]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[7]);
    main_ethmac_liteethmaccrc32checker_crc_next[27] <= ((((((((main_ethmac_liteethmaccrc32checker_crc_last[19] ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]) ^ main_ethmac_liteethmaccrc32checker_crc_last[25]) ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[6]);
    main_ethmac_liteethmaccrc32checker_crc_next[28] <= ((((((main_ethmac_liteethmaccrc32checker_crc_last[20] ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]) ^ main_ethmac_liteethmaccrc32checker_crc_last[26]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[5]);
    main_ethmac_liteethmaccrc32checker_crc_next[29] <= ((((((main_ethmac_liteethmaccrc32checker_crc_last[21] ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_last[30]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[1]) ^ main_ethmac_liteethmaccrc32checker_crc_last[27]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[4]);
    main_ethmac_liteethmaccrc32checker_crc_next[30] <= ((((main_ethmac_liteethmaccrc32checker_crc_last[22] ^ main_ethmac_liteethmaccrc32checker_crc_last[31]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[0]) ^ main_ethmac_liteethmaccrc32checker_crc_last[28]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[3]);
    main_ethmac_liteethmaccrc32checker_crc_next[31] <= ((main_ethmac_liteethmaccrc32checker_crc_last[23] ^ main_ethmac_liteethmaccrc32checker_crc_last[29]) ^ main_ethmac_liteethmaccrc32checker_crc_data1[2]);
end
assign main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_din = {main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_last, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_first, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_error, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_last_be, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_data};
assign {main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_last, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_first, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_error, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_last_be, main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_data} = main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_dout;
assign main_ethmac_liteethmaccrc32checker_syncfifo_sink_ready = main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_writable;
assign main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_we = main_ethmac_liteethmaccrc32checker_syncfifo_sink_valid;
assign main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_first = main_ethmac_liteethmaccrc32checker_syncfifo_sink_first;
assign main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_last = main_ethmac_liteethmaccrc32checker_syncfifo_sink_last;
assign main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_data = main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_data;
assign main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_last_be = main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_last_be;
assign main_ethmac_liteethmaccrc32checker_syncfifo_fifo_in_payload_error = main_ethmac_liteethmaccrc32checker_syncfifo_sink_payload_error;
assign main_ethmac_liteethmaccrc32checker_syncfifo_source_valid = main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_readable;
assign main_ethmac_liteethmaccrc32checker_syncfifo_source_first = main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_first;
assign main_ethmac_liteethmaccrc32checker_syncfifo_source_last = main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_last;
assign main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_data = main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_data;
assign main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_last_be = main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_last_be;
assign main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_error = main_ethmac_liteethmaccrc32checker_syncfifo_fifo_out_payload_error;
assign main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_re = main_ethmac_liteethmaccrc32checker_syncfifo_source_ready;
always @(*) begin
    main_ethmac_liteethmaccrc32checker_syncfifo_wrport_adr <= 3'd0;
    if (main_ethmac_liteethmaccrc32checker_syncfifo_replace) begin
        main_ethmac_liteethmaccrc32checker_syncfifo_wrport_adr <= (main_ethmac_liteethmaccrc32checker_syncfifo_produce - 1'd1);
    end else begin
        main_ethmac_liteethmaccrc32checker_syncfifo_wrport_adr <= main_ethmac_liteethmaccrc32checker_syncfifo_produce;
    end
end
assign main_ethmac_liteethmaccrc32checker_syncfifo_wrport_dat_w = main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_din;
assign main_ethmac_liteethmaccrc32checker_syncfifo_wrport_we = (main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_we & (main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_writable | main_ethmac_liteethmaccrc32checker_syncfifo_replace));
assign main_ethmac_liteethmaccrc32checker_syncfifo_do_read = (main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_readable & main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_re);
assign main_ethmac_liteethmaccrc32checker_syncfifo_rdport_adr = main_ethmac_liteethmaccrc32checker_syncfifo_consume;
assign main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_dout = main_ethmac_liteethmaccrc32checker_syncfifo_rdport_dat_r;
assign main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_writable = (main_ethmac_liteethmaccrc32checker_syncfifo_level != 3'd5);
assign main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_readable = (main_ethmac_liteethmaccrc32checker_syncfifo_level != 1'd0);
always @(*) begin
    main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value_ce1 <= 1'd0;
    main_ethmac_liteethmaccrc32checker_fifo_reset <= 1'd0;
    main_ethmac_liteethmaccrc32checker_source_source_valid <= 1'd0;
    main_ethmac_liteethmaccrc32checker_crc_ce <= 1'd0;
    main_ethmac_liteethmaccrc32checker_source_source_first <= 1'd0;
    main_ethmac_liteethmaccrc32checker_crc_reset <= 1'd0;
    main_ethmac_liteethmaccrc32checker_source_source_last <= 1'd0;
    main_ethmac_liteethmaccrc32checker_source_source_payload_data <= 8'd0;
    main_ethmac_liteethmaccrc32checker_source_source_payload_last_be <= 1'd0;
    main_ethmac_liteethmaccrc32checker_source_source_payload_error <= 1'd0;
    main_ethmac_liteethmaccrc32checker_error <= 1'd0;
    main_ethmac_liteethmaccrc32checker_syncfifo_source_ready <= 1'd0;
    builder_soclinux_rxdatapath_bufferizeendpoints_next_state <= 2'd0;
    main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value0 <= 1'd0;
    main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value_ce0 <= 1'd0;
    main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value1 <= 1'd0;
    builder_soclinux_rxdatapath_bufferizeendpoints_next_state <= builder_soclinux_rxdatapath_bufferizeendpoints_state;
    case (builder_soclinux_rxdatapath_bufferizeendpoints_state)
        1'd1: begin
            if ((main_ethmac_liteethmaccrc32checker_sink_sink_valid & main_ethmac_liteethmaccrc32checker_sink_sink_ready)) begin
                main_ethmac_liteethmaccrc32checker_crc_ce <= 1'd1;
                builder_soclinux_rxdatapath_bufferizeendpoints_next_state <= 2'd2;
            end
        end
        2'd2: begin
            main_ethmac_liteethmaccrc32checker_syncfifo_source_ready <= main_ethmac_liteethmaccrc32checker_fifo_out;
            main_ethmac_liteethmaccrc32checker_source_source_valid <= (main_ethmac_liteethmaccrc32checker_sink_sink_valid & main_ethmac_liteethmaccrc32checker_fifo_full);
            main_ethmac_liteethmaccrc32checker_source_source_payload_data <= main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_data;
            main_ethmac_liteethmaccrc32checker_source_source_payload_last_be <= main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_last_be;
            main_ethmac_liteethmaccrc32checker_source_source_payload_error <= main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_error;
            if (1'd1) begin
                main_ethmac_liteethmaccrc32checker_source_source_last <= main_ethmac_liteethmaccrc32checker_sink_sink_last;
                main_ethmac_liteethmaccrc32checker_source_source_payload_last_be <= main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be;
            end else begin
                if ((main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be & 4'd15)) begin
                    main_ethmac_liteethmaccrc32checker_source_source_last <= main_ethmac_liteethmaccrc32checker_sink_sink_last;
                    main_ethmac_liteethmaccrc32checker_source_source_payload_last_be <= (main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be <<< -3'd3);
                end else begin
                    main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value0 <= (main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be >>> 3'd4);
                    main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value_ce0 <= 1'd1;
                    main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value1 <= main_ethmac_liteethmaccrc32checker_crc_error0;
                    main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value_ce1 <= 1'd1;
                end
            end
            main_ethmac_liteethmaccrc32checker_source_source_payload_error <= (main_ethmac_liteethmaccrc32checker_sink_sink_payload_error | {1{(main_ethmac_liteethmaccrc32checker_crc_error0 & main_ethmac_liteethmaccrc32checker_sink_sink_last)}});
            main_ethmac_liteethmaccrc32checker_error <= ((main_ethmac_liteethmaccrc32checker_sink_sink_valid & main_ethmac_liteethmaccrc32checker_sink_sink_last) & main_ethmac_liteethmaccrc32checker_crc_error0);
            if ((main_ethmac_liteethmaccrc32checker_sink_sink_valid & main_ethmac_liteethmaccrc32checker_sink_sink_ready)) begin
                main_ethmac_liteethmaccrc32checker_crc_ce <= 1'd1;
                if ((main_ethmac_liteethmaccrc32checker_sink_sink_last & (main_ethmac_liteethmaccrc32checker_sink_sink_payload_last_be > 4'd15))) begin
                    builder_soclinux_rxdatapath_bufferizeendpoints_next_state <= 2'd3;
                end else begin
                    if (main_ethmac_liteethmaccrc32checker_sink_sink_last) begin
                        builder_soclinux_rxdatapath_bufferizeendpoints_next_state <= 1'd0;
                    end
                end
            end
        end
        2'd3: begin
            main_ethmac_liteethmaccrc32checker_source_source_valid <= main_ethmac_liteethmaccrc32checker_syncfifo_source_valid;
            main_ethmac_liteethmaccrc32checker_syncfifo_source_ready <= main_ethmac_liteethmaccrc32checker_source_source_ready;
            main_ethmac_liteethmaccrc32checker_source_source_first <= main_ethmac_liteethmaccrc32checker_syncfifo_source_first;
            main_ethmac_liteethmaccrc32checker_source_source_last <= main_ethmac_liteethmaccrc32checker_syncfifo_source_last;
            main_ethmac_liteethmaccrc32checker_source_source_payload_data <= main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_data;
            main_ethmac_liteethmaccrc32checker_source_source_payload_last_be <= main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_last_be;
            main_ethmac_liteethmaccrc32checker_source_source_payload_error <= main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_error;
            main_ethmac_liteethmaccrc32checker_source_source_payload_error <= (main_ethmac_liteethmaccrc32checker_syncfifo_source_payload_error | {1{main_ethmac_liteethmaccrc32checker_crc_error1}});
            main_ethmac_liteethmaccrc32checker_source_source_payload_last_be <= main_ethmac_liteethmaccrc32checker_last_be;
            if ((main_ethmac_liteethmaccrc32checker_source_source_valid & main_ethmac_liteethmaccrc32checker_source_source_ready)) begin
                builder_soclinux_rxdatapath_bufferizeendpoints_next_state <= 1'd0;
            end
        end
        default: begin
            main_ethmac_liteethmaccrc32checker_crc_reset <= 1'd1;
            main_ethmac_liteethmaccrc32checker_fifo_reset <= 1'd1;
            builder_soclinux_rxdatapath_bufferizeendpoints_next_state <= 1'd1;
        end
    endcase
end
assign main_ethmac_bufferizeendpoints_pipe_valid_sink_ready = ((~main_ethmac_bufferizeendpoints_pipe_valid_source_valid) | main_ethmac_bufferizeendpoints_pipe_valid_source_ready);
assign main_ethmac_bufferizeendpoints_pipe_valid_sink_valid = main_ethmac_bufferizeendpoints_sink_sink_valid;
assign main_ethmac_bufferizeendpoints_sink_sink_ready = main_ethmac_bufferizeendpoints_pipe_valid_sink_ready;
assign main_ethmac_bufferizeendpoints_pipe_valid_sink_first = main_ethmac_bufferizeendpoints_sink_sink_first;
assign main_ethmac_bufferizeendpoints_pipe_valid_sink_last = main_ethmac_bufferizeendpoints_sink_sink_last;
assign main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_data = main_ethmac_bufferizeendpoints_sink_sink_payload_data;
assign main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_last_be = main_ethmac_bufferizeendpoints_sink_sink_payload_last_be;
assign main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_error = main_ethmac_bufferizeendpoints_sink_sink_payload_error;
assign main_ethmac_bufferizeendpoints_source_source_valid = main_ethmac_bufferizeendpoints_pipe_valid_source_valid;
assign main_ethmac_bufferizeendpoints_pipe_valid_source_ready = main_ethmac_bufferizeendpoints_source_source_ready;
assign main_ethmac_bufferizeendpoints_source_source_first = main_ethmac_bufferizeendpoints_pipe_valid_source_first;
assign main_ethmac_bufferizeendpoints_source_source_last = main_ethmac_bufferizeendpoints_pipe_valid_source_last;
assign main_ethmac_bufferizeendpoints_source_source_payload_data = main_ethmac_bufferizeendpoints_pipe_valid_source_payload_data;
assign main_ethmac_bufferizeendpoints_source_source_payload_last_be = main_ethmac_bufferizeendpoints_pipe_valid_source_payload_last_be;
assign main_ethmac_bufferizeendpoints_source_source_payload_error = main_ethmac_bufferizeendpoints_pipe_valid_source_payload_error;
assign main_ethmac_pulsesynchronizer1_o = (main_ethmac_pulsesynchronizer1_toggle_o ^ main_ethmac_pulsesynchronizer1_toggle_o_r);
assign main_ethmac_rx_padding_source_valid = main_ethmac_rx_padding_sink_valid;
assign main_ethmac_rx_padding_sink_ready = main_ethmac_rx_padding_source_ready;
assign main_ethmac_rx_padding_source_first = main_ethmac_rx_padding_sink_first;
assign main_ethmac_rx_padding_source_last = main_ethmac_rx_padding_sink_last;
assign main_ethmac_rx_padding_source_payload_data = main_ethmac_rx_padding_sink_payload_data;
assign main_ethmac_rx_padding_source_payload_last_be = main_ethmac_rx_padding_sink_payload_last_be;
assign main_ethmac_rx_padding_source_payload_error = main_ethmac_rx_padding_sink_payload_error;
assign main_ethmac_rx_last_be_source_valid = main_ethmac_rx_last_be_sink_valid;
assign main_ethmac_rx_last_be_sink_ready = main_ethmac_rx_last_be_source_ready;
assign main_ethmac_rx_last_be_source_first = main_ethmac_rx_last_be_sink_first;
assign main_ethmac_rx_last_be_source_last = main_ethmac_rx_last_be_sink_last;
assign main_ethmac_rx_last_be_source_payload_data = main_ethmac_rx_last_be_sink_payload_data;
assign main_ethmac_rx_last_be_source_payload_error = main_ethmac_rx_last_be_sink_payload_error;
always @(*) begin
    main_ethmac_rx_last_be_source_payload_last_be <= 1'd0;
    main_ethmac_rx_last_be_source_payload_last_be <= main_ethmac_rx_last_be_sink_payload_last_be;
    if (1'd1) begin
        main_ethmac_rx_last_be_source_payload_last_be <= main_ethmac_rx_last_be_sink_last;
    end
end
assign main_ethmac_rx_converter_converter_sink_valid = main_ethmac_rx_converter_sink_valid;
assign main_ethmac_rx_converter_converter_sink_first = main_ethmac_rx_converter_sink_first;
assign main_ethmac_rx_converter_converter_sink_last = main_ethmac_rx_converter_sink_last;
assign main_ethmac_rx_converter_sink_ready = main_ethmac_rx_converter_converter_sink_ready;
assign main_ethmac_rx_converter_converter_sink_payload_data = {main_ethmac_rx_converter_sink_payload_error, main_ethmac_rx_converter_sink_payload_last_be, main_ethmac_rx_converter_sink_payload_data};
assign main_ethmac_rx_converter_source_valid = main_ethmac_rx_converter_source_source_valid;
assign main_ethmac_rx_converter_source_first = main_ethmac_rx_converter_source_source_first;
assign main_ethmac_rx_converter_source_last = main_ethmac_rx_converter_source_source_last;
assign main_ethmac_rx_converter_source_source_ready = main_ethmac_rx_converter_source_ready;
always @(*) begin
    main_ethmac_rx_converter_source_payload_data <= 32'd0;
    main_ethmac_rx_converter_source_payload_data[7:0] <= main_ethmac_rx_converter_source_source_payload_data[7:0];
    main_ethmac_rx_converter_source_payload_data[15:8] <= main_ethmac_rx_converter_source_source_payload_data[17:10];
    main_ethmac_rx_converter_source_payload_data[23:16] <= main_ethmac_rx_converter_source_source_payload_data[27:20];
    main_ethmac_rx_converter_source_payload_data[31:24] <= main_ethmac_rx_converter_source_source_payload_data[37:30];
end
always @(*) begin
    main_ethmac_rx_converter_source_payload_last_be <= 4'd0;
    main_ethmac_rx_converter_source_payload_last_be[0] <= main_ethmac_rx_converter_source_source_payload_data[8];
    main_ethmac_rx_converter_source_payload_last_be[1] <= main_ethmac_rx_converter_source_source_payload_data[18];
    main_ethmac_rx_converter_source_payload_last_be[2] <= main_ethmac_rx_converter_source_source_payload_data[28];
    main_ethmac_rx_converter_source_payload_last_be[3] <= main_ethmac_rx_converter_source_source_payload_data[38];
end
always @(*) begin
    main_ethmac_rx_converter_source_payload_error <= 4'd0;
    main_ethmac_rx_converter_source_payload_error[0] <= main_ethmac_rx_converter_source_source_payload_data[9];
    main_ethmac_rx_converter_source_payload_error[1] <= main_ethmac_rx_converter_source_source_payload_data[19];
    main_ethmac_rx_converter_source_payload_error[2] <= main_ethmac_rx_converter_source_source_payload_data[29];
    main_ethmac_rx_converter_source_payload_error[3] <= main_ethmac_rx_converter_source_source_payload_data[39];
end
assign main_ethmac_rx_converter_source_source_valid = main_ethmac_rx_converter_converter_source_valid;
assign main_ethmac_rx_converter_converter_source_ready = main_ethmac_rx_converter_source_source_ready;
assign main_ethmac_rx_converter_source_source_first = main_ethmac_rx_converter_converter_source_first;
assign main_ethmac_rx_converter_source_source_last = main_ethmac_rx_converter_converter_source_last;
assign main_ethmac_rx_converter_source_source_payload_data = main_ethmac_rx_converter_converter_source_payload_data;
assign main_ethmac_rx_converter_converter_sink_ready = ((~main_ethmac_rx_converter_converter_strobe_all) | main_ethmac_rx_converter_converter_source_ready);
assign main_ethmac_rx_converter_converter_source_valid = main_ethmac_rx_converter_converter_strobe_all;
assign main_ethmac_rx_converter_converter_load_part = (main_ethmac_rx_converter_converter_sink_valid & main_ethmac_rx_converter_converter_sink_ready);
assign main_ethmac_rx_cdc_cdc_sink_valid = main_ethmac_rx_cdc_sink_sink_valid;
assign main_ethmac_rx_cdc_sink_sink_ready = main_ethmac_rx_cdc_cdc_sink_ready;
assign main_ethmac_rx_cdc_cdc_sink_first = main_ethmac_rx_cdc_sink_sink_first;
assign main_ethmac_rx_cdc_cdc_sink_last = main_ethmac_rx_cdc_sink_sink_last;
assign main_ethmac_rx_cdc_cdc_sink_payload_data = main_ethmac_rx_cdc_sink_sink_payload_data;
assign main_ethmac_rx_cdc_cdc_sink_payload_last_be = main_ethmac_rx_cdc_sink_sink_payload_last_be;
assign main_ethmac_rx_cdc_cdc_sink_payload_error = main_ethmac_rx_cdc_sink_sink_payload_error;
assign main_ethmac_rx_cdc_source_source_valid = main_ethmac_rx_cdc_cdc_source_valid;
assign main_ethmac_rx_cdc_cdc_source_ready = main_ethmac_rx_cdc_source_source_ready;
assign main_ethmac_rx_cdc_source_source_first = main_ethmac_rx_cdc_cdc_source_first;
assign main_ethmac_rx_cdc_source_source_last = main_ethmac_rx_cdc_cdc_source_last;
assign main_ethmac_rx_cdc_source_source_payload_data = main_ethmac_rx_cdc_cdc_source_payload_data;
assign main_ethmac_rx_cdc_source_source_payload_last_be = main_ethmac_rx_cdc_cdc_source_payload_last_be;
assign main_ethmac_rx_cdc_source_source_payload_error = main_ethmac_rx_cdc_cdc_source_payload_error;
assign main_ethmac_rx_cdc_cdc_asyncfifo_din = {main_ethmac_rx_cdc_cdc_fifo_in_last, main_ethmac_rx_cdc_cdc_fifo_in_first, main_ethmac_rx_cdc_cdc_fifo_in_payload_error, main_ethmac_rx_cdc_cdc_fifo_in_payload_last_be, main_ethmac_rx_cdc_cdc_fifo_in_payload_data};
assign {main_ethmac_rx_cdc_cdc_fifo_out_last, main_ethmac_rx_cdc_cdc_fifo_out_first, main_ethmac_rx_cdc_cdc_fifo_out_payload_error, main_ethmac_rx_cdc_cdc_fifo_out_payload_last_be, main_ethmac_rx_cdc_cdc_fifo_out_payload_data} = main_ethmac_rx_cdc_cdc_asyncfifo_dout;
assign main_ethmac_rx_cdc_cdc_sink_ready = main_ethmac_rx_cdc_cdc_asyncfifo_writable;
assign main_ethmac_rx_cdc_cdc_asyncfifo_we = main_ethmac_rx_cdc_cdc_sink_valid;
assign main_ethmac_rx_cdc_cdc_fifo_in_first = main_ethmac_rx_cdc_cdc_sink_first;
assign main_ethmac_rx_cdc_cdc_fifo_in_last = main_ethmac_rx_cdc_cdc_sink_last;
assign main_ethmac_rx_cdc_cdc_fifo_in_payload_data = main_ethmac_rx_cdc_cdc_sink_payload_data;
assign main_ethmac_rx_cdc_cdc_fifo_in_payload_last_be = main_ethmac_rx_cdc_cdc_sink_payload_last_be;
assign main_ethmac_rx_cdc_cdc_fifo_in_payload_error = main_ethmac_rx_cdc_cdc_sink_payload_error;
assign main_ethmac_rx_cdc_cdc_source_valid = main_ethmac_rx_cdc_cdc_asyncfifo_readable;
assign main_ethmac_rx_cdc_cdc_source_first = main_ethmac_rx_cdc_cdc_fifo_out_first;
assign main_ethmac_rx_cdc_cdc_source_last = main_ethmac_rx_cdc_cdc_fifo_out_last;
assign main_ethmac_rx_cdc_cdc_source_payload_data = main_ethmac_rx_cdc_cdc_fifo_out_payload_data;
assign main_ethmac_rx_cdc_cdc_source_payload_last_be = main_ethmac_rx_cdc_cdc_fifo_out_payload_last_be;
assign main_ethmac_rx_cdc_cdc_source_payload_error = main_ethmac_rx_cdc_cdc_fifo_out_payload_error;
assign main_ethmac_rx_cdc_cdc_asyncfifo_re = main_ethmac_rx_cdc_cdc_source_ready;
assign main_ethmac_rx_cdc_cdc_graycounter0_ce = (main_ethmac_rx_cdc_cdc_asyncfifo_writable & main_ethmac_rx_cdc_cdc_asyncfifo_we);
assign main_ethmac_rx_cdc_cdc_graycounter1_ce = (main_ethmac_rx_cdc_cdc_asyncfifo_readable & main_ethmac_rx_cdc_cdc_asyncfifo_re);
assign main_ethmac_rx_cdc_cdc_asyncfifo_writable = (((main_ethmac_rx_cdc_cdc_graycounter0_q[5] == main_ethmac_rx_cdc_cdc_consume_wdomain[5]) | (main_ethmac_rx_cdc_cdc_graycounter0_q[4] == main_ethmac_rx_cdc_cdc_consume_wdomain[4])) | (main_ethmac_rx_cdc_cdc_graycounter0_q[3:0] != main_ethmac_rx_cdc_cdc_consume_wdomain[3:0]));
assign main_ethmac_rx_cdc_cdc_asyncfifo_readable = (main_ethmac_rx_cdc_cdc_graycounter1_q != main_ethmac_rx_cdc_cdc_produce_rdomain);
assign main_ethmac_rx_cdc_cdc_wrport_adr = main_ethmac_rx_cdc_cdc_graycounter0_q_binary[4:0];
assign main_ethmac_rx_cdc_cdc_wrport_dat_w = main_ethmac_rx_cdc_cdc_asyncfifo_din;
assign main_ethmac_rx_cdc_cdc_wrport_we = main_ethmac_rx_cdc_cdc_graycounter0_ce;
assign main_ethmac_rx_cdc_cdc_rdport_adr = main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary[4:0];
assign main_ethmac_rx_cdc_cdc_asyncfifo_dout = main_ethmac_rx_cdc_cdc_rdport_dat_r;
always @(*) begin
    main_ethmac_rx_cdc_cdc_graycounter0_q_next_binary <= 6'd0;
    if (main_ethmac_rx_cdc_cdc_graycounter0_ce) begin
        main_ethmac_rx_cdc_cdc_graycounter0_q_next_binary <= (main_ethmac_rx_cdc_cdc_graycounter0_q_binary + 1'd1);
    end else begin
        main_ethmac_rx_cdc_cdc_graycounter0_q_next_binary <= main_ethmac_rx_cdc_cdc_graycounter0_q_binary;
    end
end
assign main_ethmac_rx_cdc_cdc_graycounter0_q_next = (main_ethmac_rx_cdc_cdc_graycounter0_q_next_binary ^ main_ethmac_rx_cdc_cdc_graycounter0_q_next_binary[5:1]);
always @(*) begin
    main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary <= 6'd0;
    if (main_ethmac_rx_cdc_cdc_graycounter1_ce) begin
        main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary <= (main_ethmac_rx_cdc_cdc_graycounter1_q_binary + 1'd1);
    end else begin
        main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary <= main_ethmac_rx_cdc_cdc_graycounter1_q_binary;
    end
end
assign main_ethmac_rx_cdc_cdc_graycounter1_q_next = (main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary ^ main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary[5:1]);
assign main_ethmac_rx_preamble_sink_valid = main_ku_1000basex_source_valid;
assign main_ku_1000basex_source_ready = main_ethmac_rx_preamble_sink_ready;
assign main_ethmac_rx_preamble_sink_first = main_ku_1000basex_source_first;
assign main_ethmac_rx_preamble_sink_last = main_ku_1000basex_source_last;
assign main_ethmac_rx_preamble_sink_payload_data = main_ku_1000basex_source_payload_data;
assign main_ethmac_rx_preamble_sink_payload_last_be = main_ku_1000basex_source_payload_last_be;
assign main_ethmac_rx_preamble_sink_payload_error = main_ku_1000basex_source_payload_error;
assign main_ethmac_bufferizeendpoints_sink_sink_valid = main_ethmac_rx_preamble_source_valid;
assign main_ethmac_rx_preamble_source_ready = main_ethmac_bufferizeendpoints_sink_sink_ready;
assign main_ethmac_bufferizeendpoints_sink_sink_first = main_ethmac_rx_preamble_source_first;
assign main_ethmac_bufferizeendpoints_sink_sink_last = main_ethmac_rx_preamble_source_last;
assign main_ethmac_bufferizeendpoints_sink_sink_payload_data = main_ethmac_rx_preamble_source_payload_data;
assign main_ethmac_bufferizeendpoints_sink_sink_payload_last_be = main_ethmac_rx_preamble_source_payload_last_be;
assign main_ethmac_bufferizeendpoints_sink_sink_payload_error = main_ethmac_rx_preamble_source_payload_error;
assign main_ethmac_rx_padding_sink_valid = main_ethmac_liteethmaccrc32checker_source_source_valid;
assign main_ethmac_liteethmaccrc32checker_source_source_ready = main_ethmac_rx_padding_sink_ready;
assign main_ethmac_rx_padding_sink_first = main_ethmac_liteethmaccrc32checker_source_source_first;
assign main_ethmac_rx_padding_sink_last = main_ethmac_liteethmaccrc32checker_source_source_last;
assign main_ethmac_rx_padding_sink_payload_data = main_ethmac_liteethmaccrc32checker_source_source_payload_data;
assign main_ethmac_rx_padding_sink_payload_last_be = main_ethmac_liteethmaccrc32checker_source_source_payload_last_be;
assign main_ethmac_rx_padding_sink_payload_error = main_ethmac_liteethmaccrc32checker_source_source_payload_error;
assign main_ethmac_rx_last_be_sink_valid = main_ethmac_rx_padding_source_valid;
assign main_ethmac_rx_padding_source_ready = main_ethmac_rx_last_be_sink_ready;
assign main_ethmac_rx_last_be_sink_first = main_ethmac_rx_padding_source_first;
assign main_ethmac_rx_last_be_sink_last = main_ethmac_rx_padding_source_last;
assign main_ethmac_rx_last_be_sink_payload_data = main_ethmac_rx_padding_source_payload_data;
assign main_ethmac_rx_last_be_sink_payload_last_be = main_ethmac_rx_padding_source_payload_last_be;
assign main_ethmac_rx_last_be_sink_payload_error = main_ethmac_rx_padding_source_payload_error;
assign main_ethmac_rx_converter_sink_valid = main_ethmac_rx_last_be_source_valid;
assign main_ethmac_rx_last_be_source_ready = main_ethmac_rx_converter_sink_ready;
assign main_ethmac_rx_converter_sink_first = main_ethmac_rx_last_be_source_first;
assign main_ethmac_rx_converter_sink_last = main_ethmac_rx_last_be_source_last;
assign main_ethmac_rx_converter_sink_payload_data = main_ethmac_rx_last_be_source_payload_data;
assign main_ethmac_rx_converter_sink_payload_last_be = main_ethmac_rx_last_be_source_payload_last_be;
assign main_ethmac_rx_converter_sink_payload_error = main_ethmac_rx_last_be_source_payload_error;
assign main_ethmac_rx_cdc_sink_sink_valid = main_ethmac_rx_converter_source_valid;
assign main_ethmac_rx_converter_source_ready = main_ethmac_rx_cdc_sink_sink_ready;
assign main_ethmac_rx_cdc_sink_sink_first = main_ethmac_rx_converter_source_first;
assign main_ethmac_rx_cdc_sink_sink_last = main_ethmac_rx_converter_source_last;
assign main_ethmac_rx_cdc_sink_sink_payload_data = main_ethmac_rx_converter_source_payload_data;
assign main_ethmac_rx_cdc_sink_sink_payload_last_be = main_ethmac_rx_converter_source_payload_last_be;
assign main_ethmac_rx_cdc_sink_sink_payload_error = main_ethmac_rx_converter_source_payload_error;
assign main_ethmac_source_valid = main_ethmac_rx_cdc_source_source_valid;
assign main_ethmac_rx_cdc_source_source_ready = main_ethmac_source_ready;
assign main_ethmac_source_first = main_ethmac_rx_cdc_source_source_first;
assign main_ethmac_source_last = main_ethmac_rx_cdc_source_source_last;
assign main_ethmac_source_payload_data = main_ethmac_rx_cdc_source_source_payload_data;
assign main_ethmac_source_payload_last_be = main_ethmac_rx_cdc_source_source_payload_last_be;
assign main_ethmac_source_payload_error = main_ethmac_rx_cdc_source_source_payload_error;
assign main_ethmac_sram0_sink_valid = main_ethmac_sink_sink_valid;
assign main_ethmac_sink_sink_ready = main_ethmac_sram1_sink_ready;
assign main_ethmac_sram2_sink_first = main_ethmac_sink_sink_first;
assign main_ethmac_sram3_sink_last = main_ethmac_sink_sink_last;
assign main_ethmac_sram4_sink_payload_data = main_ethmac_sink_sink_payload_data;
assign main_ethmac_sram5_sink_payload_last_be = main_ethmac_sink_sink_payload_last_be;
assign main_ethmac_sram6_sink_payload_error = main_ethmac_sink_sink_payload_error;
assign main_ethmac_source_source_valid = main_ethmac_sram83_source_valid;
assign main_ethmac_sram84_source_ready = main_ethmac_source_source_ready;
assign main_ethmac_source_source_first = main_ethmac_sram85_source_first;
assign main_ethmac_source_source_last = main_ethmac_sram86_source_last;
assign main_ethmac_source_source_payload_data = main_ethmac_sram87_source_payload_data;
assign main_ethmac_source_source_payload_last_be = main_ethmac_sram88_source_payload_last_be;
assign main_ethmac_source_source_payload_error = main_ethmac_sram89_source_payload_error;
always @(*) begin
    main_ethmac_length_inc <= 4'd0;
    case (main_ethmac_sram5_sink_payload_last_be)
        1'd1: begin
            main_ethmac_length_inc <= 1'd1;
        end
        2'd2: begin
            main_ethmac_length_inc <= 2'd2;
        end
        3'd4: begin
            main_ethmac_length_inc <= 2'd3;
        end
        4'd8: begin
            main_ethmac_length_inc <= 3'd4;
        end
        5'd16: begin
            main_ethmac_length_inc <= 3'd5;
        end
        6'd32: begin
            main_ethmac_length_inc <= 3'd6;
        end
        7'd64: begin
            main_ethmac_length_inc <= 3'd7;
        end
        default: begin
            main_ethmac_length_inc <= 3'd4;
        end
    endcase
end
assign main_ethmac_sram44_source_ready = main_ethmac_sram20_clear;
assign main_ethmac_sram19_trigger = main_ethmac_sram43_source_valid;
assign main_ethmac_sram7_status = main_ethmac_sram47_source_payload_slot;
assign main_ethmac_sram10_status = main_ethmac_sram48_source_payload_length;
assign main_ethmac_wr_data = main_ethmac_sram4_sink_payload_data;
always @(*) begin
    main_ethmac_sram81_we <= 1'd0;
    main_ethmac_sram75_adr <= 9'd0;
    main_ethmac_sram82_dat_w <= 32'd0;
    main_ethmac_sram77_we <= 1'd0;
    main_ethmac_sram78_dat_w <= 32'd0;
    main_ethmac_sram79_adr <= 9'd0;
    case (main_ethmac_slot)
        1'd0: begin
            main_ethmac_sram75_adr <= main_ethmac_sram35_length[10:2];
            main_ethmac_sram78_dat_w <= main_ethmac_wr_data;
            if ((main_ethmac_sram0_sink_valid & main_ethmac_write)) begin
                main_ethmac_sram77_we <= 1'd1;
            end
        end
        1'd1: begin
            main_ethmac_sram79_adr <= main_ethmac_sram35_length[10:2];
            main_ethmac_sram82_dat_w <= main_ethmac_wr_data;
            if ((main_ethmac_sram0_sink_valid & main_ethmac_write)) begin
                main_ethmac_sram81_we <= 1'd1;
            end
        end
    endcase
end
assign main_ethmac_sram21_available = main_ethmac_sram17_status;
assign main_ethmac_sram25_available = main_ethmac_sram18_pending;
always @(*) begin
    main_ethmac_sram20_clear <= 1'd0;
    if ((main_ethmac_sram28_re & main_ethmac_sram29_r)) begin
        main_ethmac_sram20_clear <= 1'd1;
    end
end
assign main_ethmac_sram16_irq = (main_ethmac_sram26_status & main_ethmac_sram31_storage);
assign main_ethmac_sram17_status = main_ethmac_sram19_trigger;
assign main_ethmac_sram18_pending = main_ethmac_sram19_trigger;
assign main_ethmac_sram53_din = {main_ethmac_sram69_fifo_in_last, main_ethmac_sram68_fifo_in_first, main_ethmac_sram67_fifo_in_payload_length, main_ethmac_sram66_fifo_in_payload_slot};
assign {main_ethmac_sram73_fifo_out_last, main_ethmac_sram72_fifo_out_first, main_ethmac_sram71_fifo_out_payload_length, main_ethmac_sram70_fifo_out_payload_slot} = main_ethmac_sram54_dout;
assign main_ethmac_sram38_sink_ready = main_ethmac_sram50_writable;
assign main_ethmac_sram49_we = main_ethmac_sram37_sink_valid;
assign main_ethmac_sram68_fifo_in_first = main_ethmac_sram39_sink_first;
assign main_ethmac_sram69_fifo_in_last = main_ethmac_sram40_sink_last;
assign main_ethmac_sram66_fifo_in_payload_slot = main_ethmac_sram41_sink_payload_slot;
assign main_ethmac_sram67_fifo_in_payload_length = main_ethmac_sram42_sink_payload_length;
assign main_ethmac_sram43_source_valid = main_ethmac_sram52_readable;
assign main_ethmac_sram45_source_first = main_ethmac_sram72_fifo_out_first;
assign main_ethmac_sram46_source_last = main_ethmac_sram73_fifo_out_last;
assign main_ethmac_sram47_source_payload_slot = main_ethmac_sram70_fifo_out_payload_slot;
assign main_ethmac_sram48_source_payload_length = main_ethmac_sram71_fifo_out_payload_length;
assign main_ethmac_sram51_re = main_ethmac_sram44_source_ready;
always @(*) begin
    main_ethmac_sram59_adr <= 1'd0;
    if (main_ethmac_sram56_replace) begin
        main_ethmac_sram59_adr <= (main_ethmac_sram57_produce - 1'd1);
    end else begin
        main_ethmac_sram59_adr <= main_ethmac_sram57_produce;
    end
end
assign main_ethmac_sram62_dat_w = main_ethmac_sram53_din;
assign main_ethmac_sram61_we = (main_ethmac_sram49_we & (main_ethmac_sram50_writable | main_ethmac_sram56_replace));
assign main_ethmac_sram63_do_read = (main_ethmac_sram52_readable & main_ethmac_sram51_re);
assign main_ethmac_sram64_adr = main_ethmac_sram58_consume;
assign main_ethmac_sram54_dout = main_ethmac_sram65_dat_r;
assign main_ethmac_sram50_writable = (main_ethmac_sram55_level != 2'd2);
assign main_ethmac_sram52_readable = (main_ethmac_sram55_level != 1'd0);
always @(*) begin
    main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value <= 32'd0;
    main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value_ce <= 1'd0;
    main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value_ce <= 1'd0;
    main_ethmac_sram37_sink_valid <= 1'd0;
    main_ethmac_write <= 1'd0;
    builder_soclinux_liteethmacsramwriter_next_state <= 3'd0;
    main_ethmac_sram42_sink_payload_length <= 11'd0;
    main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value <= 11'd0;
    main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value <= 1'd0;
    main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value_ce <= 1'd0;
    main_ethmac_sram41_sink_payload_slot <= 1'd0;
    builder_soclinux_liteethmacsramwriter_next_state <= builder_soclinux_liteethmacsramwriter_state;
    case (builder_soclinux_liteethmacsramwriter_state)
        1'd1: begin
            if ((main_ethmac_sram0_sink_valid & main_ethmac_sram3_sink_last)) begin
                if (((main_ethmac_sram6_sink_payload_error & main_ethmac_sram5_sink_payload_last_be) != 1'd0)) begin
                    builder_soclinux_liteethmacsramwriter_next_state <= 2'd3;
                end else begin
                    builder_soclinux_liteethmacsramwriter_next_state <= 3'd4;
                end
            end
        end
        2'd2: begin
            if ((main_ethmac_sram0_sink_valid & main_ethmac_sram3_sink_last)) begin
                if ((main_ethmac_sram5_sink_payload_last_be != 1'd0)) begin
                    builder_soclinux_liteethmacsramwriter_next_state <= 2'd3;
                end else begin
                    main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value <= 1'd0;
                    main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value_ce <= 1'd1;
                    builder_soclinux_liteethmacsramwriter_next_state <= 1'd0;
                end
            end
        end
        2'd3: begin
            main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value <= 1'd0;
            main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value_ce <= 1'd1;
            builder_soclinux_liteethmacsramwriter_next_state <= 1'd0;
        end
        3'd4: begin
            main_ethmac_sram37_sink_valid <= 1'd1;
            main_ethmac_sram41_sink_payload_slot <= main_ethmac_slot;
            main_ethmac_sram42_sink_payload_length <= main_ethmac_sram35_length;
            main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value <= 1'd0;
            main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value_ce <= 1'd1;
            main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value <= (main_ethmac_slot + 1'd1);
            main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value_ce <= 1'd1;
            builder_soclinux_liteethmacsramwriter_next_state <= 1'd0;
        end
        default: begin
            if (main_ethmac_sram0_sink_valid) begin
                if (main_ethmac_sram38_sink_ready) begin
                    main_ethmac_write <= 1'd1;
                    main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value <= (main_ethmac_sram35_length + main_ethmac_length_inc);
                    main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value_ce <= 1'd1;
                    if ((main_ethmac_sram35_length >= 11'd1530)) begin
                        builder_soclinux_liteethmacsramwriter_next_state <= 1'd1;
                    end
                    if (main_ethmac_sram3_sink_last) begin
                        if (((main_ethmac_sram6_sink_payload_error & main_ethmac_sram5_sink_payload_last_be) != 1'd0)) begin
                            builder_soclinux_liteethmacsramwriter_next_state <= 2'd3;
                        end else begin
                            builder_soclinux_liteethmacsramwriter_next_state <= 3'd4;
                        end
                    end
                end else begin
                    main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value <= (main_ethmac_sram13_status + 1'd1);
                    main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value_ce <= 1'd1;
                    builder_soclinux_liteethmacsramwriter_next_state <= 2'd2;
                end
            end
        end
    endcase
end
assign main_ethmac_sram123_sink_valid = main_ethmac_start_re;
assign main_ethmac_sram127_sink_payload_slot = main_ethmac_sram100_storage;
assign main_ethmac_sram128_sink_payload_length = main_ethmac_sram102_storage;
assign main_ethmac_sram94_status = main_ethmac_sram124_sink_ready;
assign main_ethmac_sram97_status = main_ethmac_sram141_level;
always @(*) begin
    main_ethmac_sram88_source_payload_last_be <= 4'd0;
    if (main_ethmac_sram86_source_last) begin
        case (main_ethmac_sram134_source_payload_length[1:0])
            1'd1: begin
                main_ethmac_sram88_source_payload_last_be <= 1'd1;
            end
            2'd2: begin
                main_ethmac_sram88_source_payload_last_be <= 2'd2;
            end
            2'd3: begin
                main_ethmac_sram88_source_payload_last_be <= 3'd4;
            end
            3'd4: begin
                main_ethmac_sram88_source_payload_last_be <= 4'd8;
            end
            3'd5: begin
                main_ethmac_sram88_source_payload_last_be <= 5'd16;
            end
            3'd6: begin
                main_ethmac_sram88_source_payload_last_be <= 6'd32;
            end
            3'd7: begin
                main_ethmac_sram88_source_payload_last_be <= 7'd64;
            end
            default: begin
                main_ethmac_sram88_source_payload_last_be <= 4'd8;
            end
        endcase
    end
end
assign main_ethmac_sram163_re = main_ethmac_read;
assign main_ethmac_sram161_adr = main_ethmac_sram122_length[10:2];
assign main_ethmac_sram166_re = main_ethmac_read;
assign main_ethmac_sram164_adr = main_ethmac_sram122_length[10:2];
always @(*) begin
    main_ethmac_rd_data <= 32'd0;
    case (main_ethmac_sram133_source_payload_slot)
        1'd0: begin
            main_ethmac_rd_data <= main_ethmac_sram162_dat_r;
        end
        1'd1: begin
            main_ethmac_rd_data <= main_ethmac_sram165_dat_r;
        end
    endcase
end
assign main_ethmac_sram87_source_payload_data = main_ethmac_rd_data;
assign main_ethmac_sram109_event0 = main_ethmac_sram105_status;
assign main_ethmac_sram113_event0 = main_ethmac_sram106_pending;
always @(*) begin
    main_ethmac_sram108_clear <= 1'd0;
    if ((main_ethmac_sram116_re & main_ethmac_sram117_r)) begin
        main_ethmac_sram108_clear <= 1'd1;
    end
end
assign main_ethmac_sram104_irq = (main_ethmac_sram114_status & main_ethmac_sram119_storage);
assign main_ethmac_sram105_status = 1'd0;
assign main_ethmac_sram139_din = {main_ethmac_sram155_fifo_in_last, main_ethmac_sram154_fifo_in_first, main_ethmac_sram153_fifo_in_payload_length, main_ethmac_sram152_fifo_in_payload_slot};
assign {main_ethmac_sram159_fifo_out_last, main_ethmac_sram158_fifo_out_first, main_ethmac_sram157_fifo_out_payload_length, main_ethmac_sram156_fifo_out_payload_slot} = main_ethmac_sram140_dout;
assign main_ethmac_sram124_sink_ready = main_ethmac_sram136_writable;
assign main_ethmac_sram135_we = main_ethmac_sram123_sink_valid;
assign main_ethmac_sram154_fifo_in_first = main_ethmac_sram125_sink_first;
assign main_ethmac_sram155_fifo_in_last = main_ethmac_sram126_sink_last;
assign main_ethmac_sram152_fifo_in_payload_slot = main_ethmac_sram127_sink_payload_slot;
assign main_ethmac_sram153_fifo_in_payload_length = main_ethmac_sram128_sink_payload_length;
assign main_ethmac_sram129_source_valid = main_ethmac_sram138_readable;
assign main_ethmac_sram131_source_first = main_ethmac_sram158_fifo_out_first;
assign main_ethmac_sram132_source_last = main_ethmac_sram159_fifo_out_last;
assign main_ethmac_sram133_source_payload_slot = main_ethmac_sram156_fifo_out_payload_slot;
assign main_ethmac_sram134_source_payload_length = main_ethmac_sram157_fifo_out_payload_length;
assign main_ethmac_sram137_re = main_ethmac_sram130_source_ready;
always @(*) begin
    main_ethmac_sram145_adr <= 1'd0;
    if (main_ethmac_sram142_replace) begin
        main_ethmac_sram145_adr <= (main_ethmac_sram143_produce - 1'd1);
    end else begin
        main_ethmac_sram145_adr <= main_ethmac_sram143_produce;
    end
end
assign main_ethmac_sram148_dat_w = main_ethmac_sram139_din;
assign main_ethmac_sram147_we = (main_ethmac_sram135_we & (main_ethmac_sram136_writable | main_ethmac_sram142_replace));
assign main_ethmac_sram149_do_read = (main_ethmac_sram138_readable & main_ethmac_sram137_re);
assign main_ethmac_sram150_adr = main_ethmac_sram144_consume;
assign main_ethmac_sram140_dout = main_ethmac_sram151_dat_r;
assign main_ethmac_sram136_writable = (main_ethmac_sram141_level != 2'd2);
assign main_ethmac_sram138_readable = (main_ethmac_sram141_level != 1'd0);
always @(*) begin
    main_ethmac_sram130_source_ready <= 1'd0;
    main_ethmac_sram107_trigger <= 1'd0;
    builder_soclinux_liteethmacsramreader_next_state <= 2'd0;
    main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value <= 11'd0;
    main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value_ce <= 1'd0;
    main_ethmac_read <= 1'd0;
    main_ethmac_sram83_source_valid <= 1'd0;
    main_ethmac_sram86_source_last <= 1'd0;
    builder_soclinux_liteethmacsramreader_next_state <= builder_soclinux_liteethmacsramreader_state;
    case (builder_soclinux_liteethmacsramreader_state)
        1'd1: begin
            main_ethmac_sram83_source_valid <= 1'd1;
            main_ethmac_sram86_source_last <= (main_ethmac_sram122_length >= main_ethmac_sram134_source_payload_length);
            if (main_ethmac_sram84_source_ready) begin
                main_ethmac_read <= 1'd1;
                main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value <= (main_ethmac_sram122_length + 3'd4);
                main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value_ce <= 1'd1;
                if (main_ethmac_sram86_source_last) begin
                    builder_soclinux_liteethmacsramreader_next_state <= 2'd2;
                end
            end
        end
        2'd2: begin
            main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value <= 1'd0;
            main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value_ce <= 1'd1;
            main_ethmac_sram107_trigger <= 1'd1;
            main_ethmac_sram130_source_ready <= 1'd1;
            builder_soclinux_liteethmacsramreader_next_state <= 1'd0;
        end
        default: begin
            if (main_ethmac_sram129_source_valid) begin
                main_ethmac_read <= 1'd1;
                main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value <= 3'd4;
                main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value_ce <= 1'd1;
                builder_soclinux_liteethmacsramreader_next_state <= 1'd1;
            end
        end
    endcase
end
assign main_ethmac_sram167_irq = (main_ethmac_sram16_irq | main_ethmac_sram104_irq);
assign main_ethmac_sram2_adr = main_ethmac_interface0_adr[8:0];
assign main_ethmac_interface0_dat_r = main_ethmac_sram2_dat_r;
assign main_ethmac_sram3_adr = main_ethmac_interface1_adr[8:0];
assign main_ethmac_interface1_dat_r = main_ethmac_sram3_dat_r;
always @(*) begin
    main_ethmac_sram4_we <= 4'd0;
    main_ethmac_sram4_we[0] <= (((main_ethmac_interface2_cyc & main_ethmac_interface2_stb) & main_ethmac_interface2_we) & main_ethmac_interface2_sel[0]);
    main_ethmac_sram4_we[1] <= (((main_ethmac_interface2_cyc & main_ethmac_interface2_stb) & main_ethmac_interface2_we) & main_ethmac_interface2_sel[1]);
    main_ethmac_sram4_we[2] <= (((main_ethmac_interface2_cyc & main_ethmac_interface2_stb) & main_ethmac_interface2_we) & main_ethmac_interface2_sel[2]);
    main_ethmac_sram4_we[3] <= (((main_ethmac_interface2_cyc & main_ethmac_interface2_stb) & main_ethmac_interface2_we) & main_ethmac_interface2_sel[3]);
end
assign main_ethmac_sram4_adr = main_ethmac_interface2_adr[8:0];
assign main_ethmac_interface2_dat_r = main_ethmac_sram4_dat_r;
assign main_ethmac_sram4_dat_w = main_ethmac_interface2_dat_w;
always @(*) begin
    main_ethmac_sram5_we <= 4'd0;
    main_ethmac_sram5_we[0] <= (((main_ethmac_interface3_cyc & main_ethmac_interface3_stb) & main_ethmac_interface3_we) & main_ethmac_interface3_sel[0]);
    main_ethmac_sram5_we[1] <= (((main_ethmac_interface3_cyc & main_ethmac_interface3_stb) & main_ethmac_interface3_we) & main_ethmac_interface3_sel[1]);
    main_ethmac_sram5_we[2] <= (((main_ethmac_interface3_cyc & main_ethmac_interface3_stb) & main_ethmac_interface3_we) & main_ethmac_interface3_sel[2]);
    main_ethmac_sram5_we[3] <= (((main_ethmac_interface3_cyc & main_ethmac_interface3_stb) & main_ethmac_interface3_we) & main_ethmac_interface3_sel[3]);
end
assign main_ethmac_sram5_adr = main_ethmac_interface3_adr[8:0];
assign main_ethmac_interface3_dat_r = main_ethmac_sram5_dat_r;
assign main_ethmac_sram5_dat_w = main_ethmac_interface3_dat_w;
always @(*) begin
    main_ethmac_slave_sel <= 4'd0;
    main_ethmac_slave_sel[0] <= (main_ethmac_bus_adr[10:9] == 1'd0);
    main_ethmac_slave_sel[1] <= (main_ethmac_bus_adr[10:9] == 1'd1);
    main_ethmac_slave_sel[2] <= (main_ethmac_bus_adr[10:9] == 2'd2);
    main_ethmac_slave_sel[3] <= (main_ethmac_bus_adr[10:9] == 2'd3);
end
assign main_ethmac_interface0_adr = main_ethmac_bus_adr;
assign main_ethmac_interface0_dat_w = main_ethmac_bus_dat_w;
assign main_ethmac_interface0_sel = main_ethmac_bus_sel;
assign main_ethmac_interface0_stb = main_ethmac_bus_stb;
assign main_ethmac_interface0_we = main_ethmac_bus_we;
assign main_ethmac_interface0_cti = main_ethmac_bus_cti;
assign main_ethmac_interface0_bte = main_ethmac_bus_bte;
assign main_ethmac_interface1_adr = main_ethmac_bus_adr;
assign main_ethmac_interface1_dat_w = main_ethmac_bus_dat_w;
assign main_ethmac_interface1_sel = main_ethmac_bus_sel;
assign main_ethmac_interface1_stb = main_ethmac_bus_stb;
assign main_ethmac_interface1_we = main_ethmac_bus_we;
assign main_ethmac_interface1_cti = main_ethmac_bus_cti;
assign main_ethmac_interface1_bte = main_ethmac_bus_bte;
assign main_ethmac_interface2_adr = main_ethmac_bus_adr;
assign main_ethmac_interface2_dat_w = main_ethmac_bus_dat_w;
assign main_ethmac_interface2_sel = main_ethmac_bus_sel;
assign main_ethmac_interface2_stb = main_ethmac_bus_stb;
assign main_ethmac_interface2_we = main_ethmac_bus_we;
assign main_ethmac_interface2_cti = main_ethmac_bus_cti;
assign main_ethmac_interface2_bte = main_ethmac_bus_bte;
assign main_ethmac_interface3_adr = main_ethmac_bus_adr;
assign main_ethmac_interface3_dat_w = main_ethmac_bus_dat_w;
assign main_ethmac_interface3_sel = main_ethmac_bus_sel;
assign main_ethmac_interface3_stb = main_ethmac_bus_stb;
assign main_ethmac_interface3_we = main_ethmac_bus_we;
assign main_ethmac_interface3_cti = main_ethmac_bus_cti;
assign main_ethmac_interface3_bte = main_ethmac_bus_bte;
assign main_ethmac_interface0_cyc = (main_ethmac_bus_cyc & main_ethmac_slave_sel[0]);
assign main_ethmac_interface1_cyc = (main_ethmac_bus_cyc & main_ethmac_slave_sel[1]);
assign main_ethmac_interface2_cyc = (main_ethmac_bus_cyc & main_ethmac_slave_sel[2]);
assign main_ethmac_interface3_cyc = (main_ethmac_bus_cyc & main_ethmac_slave_sel[3]);
assign main_ethmac_bus_ack = (((main_ethmac_interface0_ack | main_ethmac_interface1_ack) | main_ethmac_interface2_ack) | main_ethmac_interface3_ack);
assign main_ethmac_bus_err = (((main_ethmac_interface0_err | main_ethmac_interface1_err) | main_ethmac_interface2_err) | main_ethmac_interface3_err);
assign main_ethmac_bus_dat_r = (((({32{main_ethmac_slave_sel_r[0]}} & main_ethmac_interface0_dat_r) | ({32{main_ethmac_slave_sel_r[1]}} & main_ethmac_interface1_dat_r)) | ({32{main_ethmac_slave_sel_r[2]}} & main_ethmac_interface2_dat_r)) | ({32{main_ethmac_slave_sel_r[3]}} & main_ethmac_interface3_dat_r));
assign main_wait = (~main_done);
always @(*) begin
    main_leds <= 8'd0;
    if ((main_mode == 1'd1)) begin
        main_leds <= main_storage;
    end else begin
        main_leds <= main_chaser;
    end
end
assign {user_led7, user_led6, user_led5, user_led4, user_led3, user_led2, user_led1, user_led0} = (main_leds ^ 1'd0);
assign main_done = (main_count == 1'd0);
assign card_detect_status0 = 1'd0;
assign sdpads_clk = ((((init_pads_out_payload_clk | cmdw_pads_out_payload_clk) | cmdr_pads_out_payload_clk) | dataw_pads_out_payload_clk) | datar_pads_out_payload_clk);
assign sdpads_cmd_oe = ((((init_pads_out_payload_cmd_oe | cmdw_pads_out_payload_cmd_oe) | cmdr_pads_out_payload_cmd_oe) | dataw_pads_out_payload_cmd_oe) | datar_pads_out_payload_cmd_oe);
assign sdpads_cmd_o = ((((init_pads_out_payload_cmd_o | cmdw_pads_out_payload_cmd_o) | cmdr_pads_out_payload_cmd_o) | dataw_pads_out_payload_cmd_o) | datar_pads_out_payload_cmd_o);
assign sdpads_data_oe = ((((init_pads_out_payload_data_oe | cmdw_pads_out_payload_data_oe) | cmdr_pads_out_payload_data_oe) | dataw_pads_out_payload_data_oe) | datar_pads_out_payload_data_oe);
assign sdpads_data_o = ((((init_pads_out_payload_data_o | cmdw_pads_out_payload_data_o) | cmdr_pads_out_payload_data_o) | dataw_pads_out_payload_data_o) | datar_pads_out_payload_data_o);
assign init_pads_out_ready = clocker_ce;
assign cmdw_pads_out_ready = clocker_ce;
assign cmdr_pads_out_ready = clocker_ce;
assign dataw_pads_out_ready = clocker_ce;
assign datar_pads_out_ready = clocker_ce;
assign clocker_clk_en = sdpads_clk;
assign init_pads_in_valid = sdpads_data_i_ce;
assign init_pads_in_payload_cmd_i = sdpads_cmd_i;
assign init_pads_in_payload_data_i = sdpads_data_i;
assign cmdw_pads_in_valid = sdpads_data_i_ce;
assign cmdw_pads_in_payload_cmd_i = sdpads_cmd_i;
assign cmdw_pads_in_payload_data_i = sdpads_data_i;
assign cmdr_pads_in_pads_in_valid = sdpads_data_i_ce;
assign cmdr_pads_in_pads_in_payload_cmd_i = sdpads_cmd_i;
assign cmdr_pads_in_pads_in_payload_data_i = sdpads_data_i;
assign dataw_pads_in_pads_in_valid = sdpads_data_i_ce;
assign dataw_pads_in_pads_in_payload_cmd_i = sdpads_cmd_i;
assign dataw_pads_in_pads_in_payload_data_i = sdpads_data_i;
assign datar_pads_in_pads_in_valid = sdpads_data_i_ce;
assign datar_pads_in_pads_in_payload_cmd_i = sdpads_cmd_i;
assign datar_pads_in_pads_in_payload_data_i = sdpads_data_i;
assign clocker_stop = (dataw_stop | datar_stop);
always @(*) begin
    clocker_clk1 <= 1'd0;
    case (clocker_storage)
        3'd4: begin
            clocker_clk1 <= clocker_clks[1];
        end
        4'd8: begin
            clocker_clk1 <= clocker_clks[2];
        end
        5'd16: begin
            clocker_clk1 <= clocker_clks[3];
        end
        6'd32: begin
            clocker_clk1 <= clocker_clks[4];
        end
        7'd64: begin
            clocker_clk1 <= clocker_clks[5];
        end
        8'd128: begin
            clocker_clk1 <= clocker_clks[6];
        end
        9'd256: begin
            clocker_clk1 <= clocker_clks[7];
        end
        default: begin
            clocker_clk1 <= clocker_clks[0];
        end
    endcase
end
assign clocker_ce = (clocker_clk1 & (~clocker_clk_d));
always @(*) begin
    clocker_ce_latched <= 1'd0;
    if (clocker_clk_d) begin
        clocker_ce_latched <= clocker_clk_en;
    end else begin
        clocker_ce_latched <= clocker_ce_delayed;
    end
end
assign clocker_clk0 = ((~clocker_clk1) & clocker_ce_latched);
always @(*) begin
    init_pads_out_payload_clk <= 1'd0;
    builder_soclinux_sdphyinit_next_state <= 1'd0;
    init_count_sdphyinit_next_value <= 8'd0;
    init_pads_out_payload_cmd_o <= 1'd0;
    init_count_sdphyinit_next_value_ce <= 1'd0;
    init_pads_out_payload_cmd_oe <= 1'd0;
    init_pads_out_payload_data_o <= 4'd0;
    init_pads_out_payload_data_oe <= 1'd0;
    builder_soclinux_sdphyinit_next_state <= builder_soclinux_sdphyinit_state;
    case (builder_soclinux_sdphyinit_state)
        1'd1: begin
            init_pads_out_payload_clk <= 1'd1;
            init_pads_out_payload_cmd_oe <= 1'd1;
            init_pads_out_payload_cmd_o <= 1'd1;
            init_pads_out_payload_data_oe <= 1'd1;
            init_pads_out_payload_data_o <= 4'd15;
            if (init_pads_out_ready) begin
                init_count_sdphyinit_next_value <= (init_count + 1'd1);
                init_count_sdphyinit_next_value_ce <= 1'd1;
                if ((init_count == 7'd79)) begin
                    builder_soclinux_sdphyinit_next_state <= 1'd0;
                end
            end
        end
        default: begin
            init_count_sdphyinit_next_value <= 1'd0;
            init_count_sdphyinit_next_value_ce <= 1'd1;
            if (init_initialize_re) begin
                builder_soclinux_sdphyinit_next_state <= 1'd1;
            end
        end
    endcase
end
always @(*) begin
    cmdw_pads_out_payload_cmd_o <= 1'd0;
    builder_soclinux_sdphycmdw_next_state <= 2'd0;
    cmdw_pads_out_payload_cmd_oe <= 1'd0;
    cmdw_sink_ready <= 1'd0;
    cmdw_count_sdphycmdw_next_value_ce <= 1'd0;
    cmdw_count_sdphycmdw_next_value <= 8'd0;
    cmdw_done <= 1'd0;
    cmdw_pads_out_payload_clk <= 1'd0;
    builder_soclinux_sdphycmdw_next_state <= builder_soclinux_sdphycmdw_state;
    case (builder_soclinux_sdphycmdw_state)
        1'd1: begin
            cmdw_pads_out_payload_clk <= 1'd1;
            cmdw_pads_out_payload_cmd_oe <= 1'd1;
            case (cmdw_count)
                1'd0: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[7];
                end
                1'd1: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[6];
                end
                2'd2: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[5];
                end
                2'd3: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[4];
                end
                3'd4: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[3];
                end
                3'd5: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[2];
                end
                3'd6: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[1];
                end
                3'd7: begin
                    cmdw_pads_out_payload_cmd_o <= cmdw_sink_payload_data[0];
                end
            endcase
            if (cmdw_pads_out_ready) begin
                cmdw_count_sdphycmdw_next_value <= (cmdw_count + 1'd1);
                cmdw_count_sdphycmdw_next_value_ce <= 1'd1;
                if ((cmdw_count == 3'd7)) begin
                    if ((cmdw_sink_last & (cmdw_sink_payload_cmd_type == 1'd0))) begin
                        builder_soclinux_sdphycmdw_next_state <= 2'd2;
                    end else begin
                        cmdw_sink_ready <= 1'd1;
                        builder_soclinux_sdphycmdw_next_state <= 1'd0;
                    end
                end
            end
        end
        2'd2: begin
            cmdw_pads_out_payload_clk <= 1'd1;
            cmdw_pads_out_payload_cmd_oe <= 1'd1;
            cmdw_pads_out_payload_cmd_o <= 1'd1;
            if (cmdw_pads_out_ready) begin
                cmdw_count_sdphycmdw_next_value <= (cmdw_count + 1'd1);
                cmdw_count_sdphycmdw_next_value_ce <= 1'd1;
                if ((cmdw_count == 3'd7)) begin
                    cmdw_sink_ready <= 1'd1;
                    builder_soclinux_sdphycmdw_next_state <= 1'd0;
                end
            end
        end
        default: begin
            cmdw_count_sdphycmdw_next_value <= 1'd0;
            cmdw_count_sdphycmdw_next_value_ce <= 1'd1;
            if ((cmdw_sink_valid & cmdw_pads_out_ready)) begin
                builder_soclinux_sdphycmdw_next_state <= 1'd1;
            end else begin
                cmdw_done <= 1'd1;
            end
        end
    endcase
end
assign cmdr_cmdr_pads_in_valid = cmdr_pads_in_pads_in_valid;
assign cmdr_pads_in_pads_in_ready = cmdr_cmdr_pads_in_ready;
assign cmdr_cmdr_pads_in_first = cmdr_pads_in_pads_in_first;
assign cmdr_cmdr_pads_in_last = cmdr_pads_in_pads_in_last;
assign cmdr_cmdr_pads_in_payload_clk = cmdr_pads_in_pads_in_payload_clk;
assign cmdr_cmdr_pads_in_payload_cmd_i = cmdr_pads_in_pads_in_payload_cmd_i;
assign cmdr_cmdr_pads_in_payload_cmd_o = cmdr_pads_in_pads_in_payload_cmd_o;
assign cmdr_cmdr_pads_in_payload_cmd_oe = cmdr_pads_in_pads_in_payload_cmd_oe;
assign cmdr_cmdr_pads_in_payload_data_i = cmdr_pads_in_pads_in_payload_data_i;
assign cmdr_cmdr_pads_in_payload_data_o = cmdr_pads_in_pads_in_payload_data_o;
assign cmdr_cmdr_pads_in_payload_data_oe = cmdr_pads_in_pads_in_payload_data_oe;
assign cmdr_cmdr_pads_in_payload_data_i_ce = cmdr_pads_in_pads_in_payload_data_i_ce;
assign cmdr_cmdr_start = (cmdr_cmdr_pads_in_payload_cmd_i == 1'd0);
assign cmdr_cmdr_converter_converter_sink_valid = (cmdr_cmdr_pads_in_valid & (cmdr_cmdr_start | cmdr_cmdr_run));
assign cmdr_cmdr_converter_converter_sink_payload_data = cmdr_cmdr_pads_in_payload_cmd_i;
assign cmdr_cmdr_buf_sink_sink_valid = cmdr_cmdr_converter_source_source_valid;
assign cmdr_cmdr_converter_source_source_ready = cmdr_cmdr_buf_sink_sink_ready;
assign cmdr_cmdr_buf_sink_sink_first = cmdr_cmdr_converter_source_source_first;
assign cmdr_cmdr_buf_sink_sink_last = cmdr_cmdr_converter_source_source_last;
assign cmdr_cmdr_buf_sink_sink_payload_data = cmdr_cmdr_converter_source_source_payload_data;
assign cmdr_cmdr_source_valid = cmdr_cmdr_buf_source_source_valid;
assign cmdr_cmdr_buf_source_source_ready = cmdr_cmdr_source_ready;
assign cmdr_cmdr_source_first = cmdr_cmdr_buf_source_source_first;
assign cmdr_cmdr_source_last = cmdr_cmdr_buf_source_source_last;
assign cmdr_cmdr_source_payload_data = cmdr_cmdr_buf_source_source_payload_data;
assign cmdr_cmdr_converter_source_source_valid = cmdr_cmdr_converter_converter_source_valid;
assign cmdr_cmdr_converter_converter_source_ready = cmdr_cmdr_converter_source_source_ready;
assign cmdr_cmdr_converter_source_source_first = cmdr_cmdr_converter_converter_source_first;
assign cmdr_cmdr_converter_source_source_last = cmdr_cmdr_converter_converter_source_last;
assign cmdr_cmdr_converter_source_source_payload_data = cmdr_cmdr_converter_converter_source_payload_data;
assign cmdr_cmdr_converter_converter_sink_ready = ((~cmdr_cmdr_converter_converter_strobe_all) | cmdr_cmdr_converter_converter_source_ready);
assign cmdr_cmdr_converter_converter_source_valid = cmdr_cmdr_converter_converter_strobe_all;
assign cmdr_cmdr_converter_converter_load_part = (cmdr_cmdr_converter_converter_sink_valid & cmdr_cmdr_converter_converter_sink_ready);
assign cmdr_cmdr_buf_pipe_valid_sink_ready = ((~cmdr_cmdr_buf_pipe_valid_source_valid) | cmdr_cmdr_buf_pipe_valid_source_ready);
assign cmdr_cmdr_buf_pipe_valid_sink_valid = cmdr_cmdr_buf_sink_sink_valid;
assign cmdr_cmdr_buf_sink_sink_ready = cmdr_cmdr_buf_pipe_valid_sink_ready;
assign cmdr_cmdr_buf_pipe_valid_sink_first = cmdr_cmdr_buf_sink_sink_first;
assign cmdr_cmdr_buf_pipe_valid_sink_last = cmdr_cmdr_buf_sink_sink_last;
assign cmdr_cmdr_buf_pipe_valid_sink_payload_data = cmdr_cmdr_buf_sink_sink_payload_data;
assign cmdr_cmdr_buf_source_source_valid = cmdr_cmdr_buf_pipe_valid_source_valid;
assign cmdr_cmdr_buf_pipe_valid_source_ready = cmdr_cmdr_buf_source_source_ready;
assign cmdr_cmdr_buf_source_source_first = cmdr_cmdr_buf_pipe_valid_source_first;
assign cmdr_cmdr_buf_source_source_last = cmdr_cmdr_buf_pipe_valid_source_last;
assign cmdr_cmdr_buf_source_source_payload_data = cmdr_cmdr_buf_pipe_valid_source_payload_data;
always @(*) begin
    cmdr_pads_out_payload_clk <= 1'd0;
    cmdr_pads_out_payload_cmd_o <= 1'd0;
    cmdr_pads_out_payload_cmd_oe <= 1'd0;
    cmdr_cmdr_source_ready <= 1'd0;
    cmdr_sink_ready <= 1'd0;
    builder_soclinux_sdphycmdr_next_state <= 3'd0;
    cmdr_timeout_sdphycmdr_next_value0 <= 32'd0;
    cmdr_timeout_sdphycmdr_next_value_ce0 <= 1'd0;
    cmdr_source_source_valid <= 1'd0;
    cmdr_count_sdphycmdr_next_value1 <= 8'd0;
    cmdr_count_sdphycmdr_next_value_ce1 <= 1'd0;
    cmdr_source_source_last <= 1'd0;
    cmdr_source_source_payload_data <= 8'd0;
    cmdr_busy_sdphycmdr_next_value2 <= 1'd0;
    cmdr_source_source_payload_status <= 3'd0;
    cmdr_busy_sdphycmdr_next_value_ce2 <= 1'd0;
    cmdr_cmdr_reset_sdphycmdr_next_value3 <= 1'd0;
    cmdr_cmdr_reset_sdphycmdr_next_value_ce3 <= 1'd0;
    builder_soclinux_sdphycmdr_next_state <= builder_soclinux_sdphycmdr_state;
    case (builder_soclinux_sdphycmdr_state)
        1'd1: begin
            cmdr_pads_out_payload_clk <= 1'd1;
            cmdr_cmdr_reset_sdphycmdr_next_value3 <= 1'd0;
            cmdr_cmdr_reset_sdphycmdr_next_value_ce3 <= 1'd1;
            if (cmdr_cmdr_source_valid) begin
                builder_soclinux_sdphycmdr_next_state <= 2'd2;
            end
            cmdr_timeout_sdphycmdr_next_value0 <= (cmdr_timeout - 1'd1);
            cmdr_timeout_sdphycmdr_next_value_ce0 <= 1'd1;
            if ((cmdr_timeout == 1'd0)) begin
                builder_soclinux_sdphycmdr_next_state <= 3'd5;
            end
        end
        2'd2: begin
            cmdr_pads_out_payload_clk <= 1'd1;
            cmdr_source_source_valid <= cmdr_cmdr_source_valid;
            cmdr_source_source_payload_status <= 1'd0;
            cmdr_source_source_last <= (cmdr_count == (cmdr_sink_payload_length - 1'd1));
            cmdr_source_source_payload_data <= cmdr_cmdr_source_payload_data;
            if ((cmdr_cmdr_source_valid & cmdr_source_source_ready)) begin
                cmdr_cmdr_source_ready <= 1'd1;
                cmdr_count_sdphycmdr_next_value1 <= (cmdr_count + 1'd1);
                cmdr_count_sdphycmdr_next_value_ce1 <= 1'd1;
                if (cmdr_source_source_last) begin
                    cmdr_sink_ready <= 1'd1;
                    if ((cmdr_sink_payload_cmd_type == 2'd3)) begin
                        cmdr_source_source_valid <= 1'd0;
                        cmdr_timeout_sdphycmdr_next_value0 <= 27'd125000000;
                        cmdr_timeout_sdphycmdr_next_value_ce0 <= 1'd1;
                        builder_soclinux_sdphycmdr_next_state <= 2'd3;
                    end else begin
                        if ((cmdr_sink_payload_data_type == 1'd0)) begin
                            cmdr_count_sdphycmdr_next_value1 <= 1'd0;
                            cmdr_count_sdphycmdr_next_value_ce1 <= 1'd1;
                            builder_soclinux_sdphycmdr_next_state <= 3'd4;
                        end else begin
                            builder_soclinux_sdphycmdr_next_state <= 1'd0;
                        end
                    end
                end
            end
            cmdr_timeout_sdphycmdr_next_value0 <= (cmdr_timeout - 1'd1);
            cmdr_timeout_sdphycmdr_next_value_ce0 <= 1'd1;
            if ((cmdr_timeout == 1'd0)) begin
                builder_soclinux_sdphycmdr_next_state <= 3'd5;
            end
        end
        2'd3: begin
            cmdr_pads_out_payload_clk <= 1'd1;
            if ((cmdr_pads_in_pads_in_valid & cmdr_pads_in_pads_in_payload_data_i[0])) begin
                cmdr_busy_sdphycmdr_next_value2 <= 1'd0;
                cmdr_busy_sdphycmdr_next_value_ce2 <= 1'd1;
            end
            if ((~cmdr_busy)) begin
                cmdr_source_source_valid <= 1'd1;
                cmdr_source_source_last <= 1'd1;
                cmdr_source_source_payload_status <= 1'd0;
                if (cmdr_source_source_ready) begin
                    cmdr_count_sdphycmdr_next_value1 <= 1'd0;
                    cmdr_count_sdphycmdr_next_value_ce1 <= 1'd1;
                    builder_soclinux_sdphycmdr_next_state <= 3'd4;
                end
            end
            cmdr_timeout_sdphycmdr_next_value0 <= (cmdr_timeout - 1'd1);
            cmdr_timeout_sdphycmdr_next_value_ce0 <= 1'd1;
            if ((cmdr_timeout == 1'd0)) begin
                builder_soclinux_sdphycmdr_next_state <= 3'd5;
            end
        end
        3'd4: begin
            cmdr_pads_out_payload_clk <= 1'd1;
            cmdr_pads_out_payload_cmd_oe <= 1'd1;
            cmdr_pads_out_payload_cmd_o <= 1'd1;
            if (cmdr_pads_out_ready) begin
                cmdr_count_sdphycmdr_next_value1 <= (cmdr_count + 1'd1);
                cmdr_count_sdphycmdr_next_value_ce1 <= 1'd1;
                if ((cmdr_count == 3'd7)) begin
                    builder_soclinux_sdphycmdr_next_state <= 1'd0;
                end
            end
        end
        3'd5: begin
            cmdr_sink_ready <= 1'd1;
            cmdr_source_source_valid <= 1'd1;
            cmdr_source_source_last <= 1'd1;
            cmdr_source_source_payload_status <= 1'd1;
            if (cmdr_source_source_ready) begin
                builder_soclinux_sdphycmdr_next_state <= 1'd0;
            end
        end
        default: begin
            cmdr_timeout_sdphycmdr_next_value0 <= 27'd125000000;
            cmdr_timeout_sdphycmdr_next_value_ce0 <= 1'd1;
            cmdr_count_sdphycmdr_next_value1 <= 1'd0;
            cmdr_count_sdphycmdr_next_value_ce1 <= 1'd1;
            cmdr_busy_sdphycmdr_next_value2 <= 1'd1;
            cmdr_busy_sdphycmdr_next_value_ce2 <= 1'd1;
            if (((cmdr_sink_valid & cmdr_pads_out_ready) & cmdw_done)) begin
                cmdr_cmdr_reset_sdphycmdr_next_value3 <= 1'd1;
                cmdr_cmdr_reset_sdphycmdr_next_value_ce3 <= 1'd1;
                builder_soclinux_sdphycmdr_next_state <= 1'd1;
            end
        end
    endcase
end
assign dataw_accepted0 = dataw_accepted1;
assign dataw_crc_error0 = dataw_crc_error1;
assign dataw_write_error0 = dataw_write_error1;
assign dataw_crc_pads_in_valid = dataw_pads_in_pads_in_valid;
assign dataw_crc_pads_in_ready = dataw_pads_in_pads_in_ready;
assign dataw_crc_pads_in_first = dataw_pads_in_pads_in_first;
assign dataw_crc_pads_in_last = dataw_pads_in_pads_in_last;
assign dataw_crc_pads_in_payload_clk = dataw_pads_in_pads_in_payload_clk;
assign dataw_crc_pads_in_payload_cmd_i = dataw_pads_in_pads_in_payload_cmd_i;
assign dataw_crc_pads_in_payload_cmd_o = dataw_pads_in_pads_in_payload_cmd_o;
assign dataw_crc_pads_in_payload_cmd_oe = dataw_pads_in_pads_in_payload_cmd_oe;
assign dataw_crc_pads_in_payload_data_i = dataw_pads_in_pads_in_payload_data_i;
assign dataw_crc_pads_in_payload_data_o = dataw_pads_in_pads_in_payload_data_o;
assign dataw_crc_pads_in_payload_data_oe = dataw_pads_in_pads_in_payload_data_oe;
assign dataw_crc_pads_in_payload_data_i_ce = dataw_pads_in_pads_in_payload_data_i_ce;
assign dataw_crc_start = (dataw_crc_pads_in_payload_data_i[0] == 1'd0);
assign dataw_crc_converter_converter_sink_valid = (dataw_crc_pads_in_valid & dataw_crc_run);
assign dataw_crc_converter_converter_sink_payload_data = dataw_crc_pads_in_payload_data_i[0];
assign dataw_crc_buf_sink_sink_valid = dataw_crc_converter_source_source_valid;
assign dataw_crc_converter_source_source_ready = dataw_crc_buf_sink_sink_ready;
assign dataw_crc_buf_sink_sink_first = dataw_crc_converter_source_source_first;
assign dataw_crc_buf_sink_sink_last = dataw_crc_converter_source_source_last;
assign dataw_crc_buf_sink_sink_payload_data = dataw_crc_converter_source_source_payload_data;
assign dataw_crc_source_valid = dataw_crc_buf_source_source_valid;
assign dataw_crc_buf_source_source_ready = dataw_crc_source_ready;
assign dataw_crc_source_first = dataw_crc_buf_source_source_first;
assign dataw_crc_source_last = dataw_crc_buf_source_source_last;
assign dataw_crc_source_payload_data = dataw_crc_buf_source_source_payload_data;
assign dataw_crc_converter_source_source_valid = dataw_crc_converter_converter_source_valid;
assign dataw_crc_converter_converter_source_ready = dataw_crc_converter_source_source_ready;
assign dataw_crc_converter_source_source_first = dataw_crc_converter_converter_source_first;
assign dataw_crc_converter_source_source_last = dataw_crc_converter_converter_source_last;
assign dataw_crc_converter_source_source_payload_data = dataw_crc_converter_converter_source_payload_data;
assign dataw_crc_converter_converter_sink_ready = ((~dataw_crc_converter_converter_strobe_all) | dataw_crc_converter_converter_source_ready);
assign dataw_crc_converter_converter_source_valid = dataw_crc_converter_converter_strobe_all;
assign dataw_crc_converter_converter_load_part = (dataw_crc_converter_converter_sink_valid & dataw_crc_converter_converter_sink_ready);
assign dataw_crc_buf_pipe_valid_sink_ready = ((~dataw_crc_buf_pipe_valid_source_valid) | dataw_crc_buf_pipe_valid_source_ready);
assign dataw_crc_buf_pipe_valid_sink_valid = dataw_crc_buf_sink_sink_valid;
assign dataw_crc_buf_sink_sink_ready = dataw_crc_buf_pipe_valid_sink_ready;
assign dataw_crc_buf_pipe_valid_sink_first = dataw_crc_buf_sink_sink_first;
assign dataw_crc_buf_pipe_valid_sink_last = dataw_crc_buf_sink_sink_last;
assign dataw_crc_buf_pipe_valid_sink_payload_data = dataw_crc_buf_sink_sink_payload_data;
assign dataw_crc_buf_source_source_valid = dataw_crc_buf_pipe_valid_source_valid;
assign dataw_crc_buf_pipe_valid_source_ready = dataw_crc_buf_source_source_ready;
assign dataw_crc_buf_source_source_first = dataw_crc_buf_pipe_valid_source_first;
assign dataw_crc_buf_source_source_last = dataw_crc_buf_pipe_valid_source_last;
assign dataw_crc_buf_source_source_payload_data = dataw_crc_buf_pipe_valid_source_payload_data;
always @(*) begin
    dataw_pads_out_payload_clk <= 1'd0;
    builder_soclinux_sdphydataw_next_state <= 3'd0;
    dataw_write_error1_sdphydataw_next_value_ce2 <= 1'd0;
    dataw_accepted1_sdphydataw_next_value0 <= 1'd0;
    dataw_pads_out_payload_cmd_o <= 1'd0;
    dataw_accepted1_sdphydataw_next_value_ce0 <= 1'd0;
    dataw_pads_out_payload_cmd_oe <= 1'd0;
    dataw_crc_error1_sdphydataw_next_value1 <= 1'd0;
    dataw_pads_out_payload_data_o <= 4'd0;
    dataw_crc_error1_sdphydataw_next_value_ce1 <= 1'd0;
    dataw_pads_out_payload_data_oe <= 1'd0;
    dataw_write_error1_sdphydataw_next_value2 <= 1'd0;
    dataw_sink_ready <= 1'd0;
    dataw_crc_reset <= 1'd0;
    dataw_count_sdphydataw_next_value3 <= 8'd0;
    dataw_count_sdphydataw_next_value_ce3 <= 1'd0;
    dataw_stop <= 1'd0;
    builder_soclinux_sdphydataw_next_state <= builder_soclinux_sdphydataw_state;
    case (builder_soclinux_sdphydataw_state)
        1'd1: begin
            dataw_pads_out_payload_clk <= 1'd1;
            dataw_pads_out_payload_cmd_oe <= 1'd1;
            dataw_pads_out_payload_cmd_o <= 1'd1;
            if (dataw_pads_out_ready) begin
                dataw_count_sdphydataw_next_value3 <= (dataw_count + 1'd1);
                dataw_count_sdphydataw_next_value_ce3 <= 1'd1;
                if ((dataw_count == 3'd7)) begin
                    dataw_count_sdphydataw_next_value3 <= 1'd0;
                    dataw_count_sdphydataw_next_value_ce3 <= 1'd1;
                    builder_soclinux_sdphydataw_next_state <= 2'd2;
                end
            end
        end
        2'd2: begin
            dataw_pads_out_payload_clk <= 1'd1;
            dataw_pads_out_payload_data_oe <= 1'd1;
            dataw_pads_out_payload_data_o <= 1'd0;
            if (dataw_pads_out_ready) begin
                builder_soclinux_sdphydataw_next_state <= 2'd3;
            end
        end
        2'd3: begin
            dataw_stop <= (~dataw_sink_valid);
            dataw_pads_out_payload_clk <= 1'd1;
            dataw_pads_out_payload_data_oe <= 1'd1;
            case (dataw_count)
                1'd0: begin
                    dataw_pads_out_payload_data_o <= dataw_sink_payload_data[7:4];
                end
                1'd1: begin
                    dataw_pads_out_payload_data_o <= dataw_sink_payload_data[3:0];
                end
            endcase
            if (dataw_pads_out_ready) begin
                dataw_count_sdphydataw_next_value3 <= (dataw_count + 1'd1);
                dataw_count_sdphydataw_next_value_ce3 <= 1'd1;
                if ((dataw_count == 1'd1)) begin
                    dataw_count_sdphydataw_next_value3 <= 1'd0;
                    dataw_count_sdphydataw_next_value_ce3 <= 1'd1;
                    if (dataw_sink_last) begin
                        builder_soclinux_sdphydataw_next_state <= 3'd4;
                    end else begin
                        dataw_sink_ready <= 1'd1;
                    end
                end
            end
        end
        3'd4: begin
            dataw_pads_out_payload_clk <= 1'd1;
            dataw_pads_out_payload_data_oe <= 1'd1;
            dataw_pads_out_payload_data_o <= 4'd15;
            if (dataw_pads_out_ready) begin
                dataw_crc_reset <= 1'd1;
                builder_soclinux_sdphydataw_next_state <= 3'd5;
            end
        end
        3'd5: begin
            dataw_pads_out_payload_clk <= 1'd1;
            if (dataw_crc_source_valid) begin
                dataw_accepted1_sdphydataw_next_value0 <= (dataw_crc_source_payload_data[7:5] == 2'd2);
                dataw_accepted1_sdphydataw_next_value_ce0 <= 1'd1;
                dataw_crc_error1_sdphydataw_next_value1 <= (dataw_crc_source_payload_data[7:5] == 3'd5);
                dataw_crc_error1_sdphydataw_next_value_ce1 <= 1'd1;
                dataw_write_error1_sdphydataw_next_value2 <= (dataw_crc_source_payload_data[7:5] == 3'd6);
                dataw_write_error1_sdphydataw_next_value_ce2 <= 1'd1;
                builder_soclinux_sdphydataw_next_state <= 3'd6;
            end
        end
        3'd6: begin
            dataw_pads_out_payload_clk <= 1'd1;
            if ((dataw_pads_in_pads_in_valid & dataw_pads_in_pads_in_payload_data_i[0])) begin
                dataw_sink_ready <= 1'd1;
                builder_soclinux_sdphydataw_next_state <= 1'd0;
            end
        end
        default: begin
            dataw_accepted1_sdphydataw_next_value0 <= 1'd0;
            dataw_accepted1_sdphydataw_next_value_ce0 <= 1'd1;
            dataw_crc_error1_sdphydataw_next_value1 <= 1'd0;
            dataw_crc_error1_sdphydataw_next_value_ce1 <= 1'd1;
            dataw_write_error1_sdphydataw_next_value2 <= 1'd0;
            dataw_write_error1_sdphydataw_next_value_ce2 <= 1'd1;
            dataw_count_sdphydataw_next_value3 <= 1'd0;
            dataw_count_sdphydataw_next_value_ce3 <= 1'd1;
            if ((dataw_sink_valid & dataw_pads_out_ready)) begin
                builder_soclinux_sdphydataw_next_state <= 1'd1;
            end
        end
    endcase
end
assign datar_datar_pads_in_valid = datar_pads_in_pads_in_valid;
assign datar_pads_in_pads_in_ready = datar_datar_pads_in_ready;
assign datar_datar_pads_in_first = datar_pads_in_pads_in_first;
assign datar_datar_pads_in_last = datar_pads_in_pads_in_last;
assign datar_datar_pads_in_payload_clk = datar_pads_in_pads_in_payload_clk;
assign datar_datar_pads_in_payload_cmd_i = datar_pads_in_pads_in_payload_cmd_i;
assign datar_datar_pads_in_payload_cmd_o = datar_pads_in_pads_in_payload_cmd_o;
assign datar_datar_pads_in_payload_cmd_oe = datar_pads_in_pads_in_payload_cmd_oe;
assign datar_datar_pads_in_payload_data_i = datar_pads_in_pads_in_payload_data_i;
assign datar_datar_pads_in_payload_data_o = datar_pads_in_pads_in_payload_data_o;
assign datar_datar_pads_in_payload_data_oe = datar_pads_in_pads_in_payload_data_oe;
assign datar_datar_pads_in_payload_data_i_ce = datar_pads_in_pads_in_payload_data_i_ce;
assign datar_datar_start = (datar_datar_pads_in_payload_data_i[3:0] == 1'd0);
assign datar_datar_converter_converter_sink_valid = (datar_datar_pads_in_valid & datar_datar_run);
assign datar_datar_converter_converter_sink_payload_data = datar_datar_pads_in_payload_data_i[3:0];
assign datar_datar_buf_sink_sink_valid = datar_datar_converter_source_source_valid;
assign datar_datar_converter_source_source_ready = datar_datar_buf_sink_sink_ready;
assign datar_datar_buf_sink_sink_first = datar_datar_converter_source_source_first;
assign datar_datar_buf_sink_sink_last = datar_datar_converter_source_source_last;
assign datar_datar_buf_sink_sink_payload_data = datar_datar_converter_source_source_payload_data;
assign datar_datar_source_valid = datar_datar_buf_source_source_valid;
assign datar_datar_buf_source_source_ready = datar_datar_source_ready;
assign datar_datar_source_first = datar_datar_buf_source_source_first;
assign datar_datar_source_last = datar_datar_buf_source_source_last;
assign datar_datar_source_payload_data = datar_datar_buf_source_source_payload_data;
assign datar_datar_converter_source_source_valid = datar_datar_converter_converter_source_valid;
assign datar_datar_converter_converter_source_ready = datar_datar_converter_source_source_ready;
assign datar_datar_converter_source_source_first = datar_datar_converter_converter_source_first;
assign datar_datar_converter_source_source_last = datar_datar_converter_converter_source_last;
assign datar_datar_converter_source_source_payload_data = datar_datar_converter_converter_source_payload_data;
assign datar_datar_converter_converter_sink_ready = ((~datar_datar_converter_converter_strobe_all) | datar_datar_converter_converter_source_ready);
assign datar_datar_converter_converter_source_valid = datar_datar_converter_converter_strobe_all;
assign datar_datar_converter_converter_load_part = (datar_datar_converter_converter_sink_valid & datar_datar_converter_converter_sink_ready);
assign datar_datar_buf_pipe_valid_sink_ready = ((~datar_datar_buf_pipe_valid_source_valid) | datar_datar_buf_pipe_valid_source_ready);
assign datar_datar_buf_pipe_valid_sink_valid = datar_datar_buf_sink_sink_valid;
assign datar_datar_buf_sink_sink_ready = datar_datar_buf_pipe_valid_sink_ready;
assign datar_datar_buf_pipe_valid_sink_first = datar_datar_buf_sink_sink_first;
assign datar_datar_buf_pipe_valid_sink_last = datar_datar_buf_sink_sink_last;
assign datar_datar_buf_pipe_valid_sink_payload_data = datar_datar_buf_sink_sink_payload_data;
assign datar_datar_buf_source_source_valid = datar_datar_buf_pipe_valid_source_valid;
assign datar_datar_buf_pipe_valid_source_ready = datar_datar_buf_source_source_ready;
assign datar_datar_buf_source_source_first = datar_datar_buf_pipe_valid_source_first;
assign datar_datar_buf_source_source_last = datar_datar_buf_pipe_valid_source_last;
assign datar_datar_buf_source_source_payload_data = datar_datar_buf_pipe_valid_source_payload_data;
always @(*) begin
    datar_pads_out_payload_clk <= 1'd0;
    datar_datar_source_ready <= 1'd0;
    datar_sink_ready <= 1'd0;
    datar_source_source_valid <= 1'd0;
    datar_source_source_first <= 1'd0;
    builder_soclinux_sdphydatar_next_state <= 3'd0;
    datar_source_source_last <= 1'd0;
    datar_count_sdphydatar_next_value0 <= 10'd0;
    datar_source_source_payload_data <= 8'd0;
    datar_count_sdphydatar_next_value_ce0 <= 1'd0;
    datar_source_source_payload_status <= 3'd0;
    datar_stop <= 1'd0;
    datar_timeout_sdphydatar_next_value1 <= 32'd0;
    datar_timeout_sdphydatar_next_value_ce1 <= 1'd0;
    datar_datar_reset_sdphydatar_next_value2 <= 1'd0;
    datar_datar_reset_sdphydatar_next_value_ce2 <= 1'd0;
    builder_soclinux_sdphydatar_next_state <= builder_soclinux_sdphydatar_state;
    case (builder_soclinux_sdphydatar_state)
        1'd1: begin
            datar_pads_out_payload_clk <= 1'd1;
            datar_datar_reset_sdphydatar_next_value2 <= 1'd0;
            datar_datar_reset_sdphydatar_next_value_ce2 <= 1'd1;
            datar_timeout_sdphydatar_next_value1 <= (datar_timeout - 1'd1);
            datar_timeout_sdphydatar_next_value_ce1 <= 1'd1;
            if (datar_datar_source_valid) begin
                builder_soclinux_sdphydatar_next_state <= 2'd2;
            end
            datar_timeout_sdphydatar_next_value1 <= (datar_timeout - 1'd1);
            datar_timeout_sdphydatar_next_value_ce1 <= 1'd1;
            if ((datar_timeout == 1'd0)) begin
                datar_sink_ready <= 1'd1;
                builder_soclinux_sdphydatar_next_state <= 3'd4;
            end
        end
        2'd2: begin
            datar_pads_out_payload_clk <= 1'd1;
            datar_source_source_valid <= datar_datar_source_valid;
            datar_source_source_payload_status <= 1'd0;
            datar_source_source_first <= (datar_count == 1'd0);
            datar_source_source_last <= (datar_count == ((datar_sink_payload_block_length + 4'd8) - 1'd1));
            datar_source_source_payload_data <= datar_datar_source_payload_data;
            if (datar_source_source_valid) begin
                if (datar_source_source_ready) begin
                    datar_datar_source_ready <= 1'd1;
                    datar_count_sdphydatar_next_value0 <= (datar_count + 1'd1);
                    datar_count_sdphydatar_next_value_ce0 <= 1'd1;
                    if (datar_source_source_last) begin
                        datar_sink_ready <= 1'd1;
                        if (datar_sink_last) begin
                            datar_count_sdphydatar_next_value0 <= 1'd0;
                            datar_count_sdphydatar_next_value_ce0 <= 1'd1;
                            builder_soclinux_sdphydatar_next_state <= 2'd3;
                        end else begin
                            builder_soclinux_sdphydatar_next_state <= 1'd0;
                        end
                    end
                end else begin
                    datar_stop <= 1'd1;
                end
            end
            datar_timeout_sdphydatar_next_value1 <= (datar_timeout - 1'd1);
            datar_timeout_sdphydatar_next_value_ce1 <= 1'd1;
            if ((datar_timeout == 1'd0)) begin
                datar_sink_ready <= 1'd1;
                builder_soclinux_sdphydatar_next_state <= 3'd4;
            end
        end
        2'd3: begin
            datar_pads_out_payload_clk <= 1'd1;
            if (datar_pads_out_ready) begin
                datar_count_sdphydatar_next_value0 <= (datar_count + 1'd1);
                datar_count_sdphydatar_next_value_ce0 <= 1'd1;
                if ((datar_count == 6'd39)) begin
                    builder_soclinux_sdphydatar_next_state <= 1'd0;
                end
            end
        end
        3'd4: begin
            datar_source_source_valid <= 1'd1;
            datar_source_source_payload_status <= 1'd1;
            datar_source_source_last <= 1'd1;
            if (datar_source_source_ready) begin
                builder_soclinux_sdphydatar_next_state <= 1'd0;
            end
        end
        default: begin
            datar_count_sdphydatar_next_value0 <= 1'd0;
            datar_count_sdphydatar_next_value_ce0 <= 1'd1;
            if ((datar_sink_valid & datar_pads_out_ready)) begin
                datar_pads_out_payload_clk <= 1'd1;
                datar_timeout_sdphydatar_next_value1 <= 32'd125000000;
                datar_timeout_sdphydatar_next_value_ce1 <= 1'd1;
                datar_count_sdphydatar_next_value0 <= 1'd0;
                datar_count_sdphydatar_next_value_ce0 <= 1'd1;
                datar_datar_reset_sdphydatar_next_value2 <= 1'd1;
                datar_datar_reset_sdphydatar_next_value_ce2 <= 1'd1;
                builder_soclinux_sdphydatar_next_state <= 1'd1;
            end
        end
    endcase
end
assign sdcore_crc16_inserter_sink_valid = sdcore_sink_sink_valid0;
assign sdcore_sink_sink_ready0 = sdcore_crc16_inserter_sink_ready;
assign sdcore_crc16_inserter_sink_first = sdcore_sink_sink_first0;
assign sdcore_crc16_inserter_sink_last = sdcore_sink_sink_last0;
assign sdcore_crc16_inserter_sink_payload_data = sdcore_sink_sink_payload_data0;
assign sdcore_source_source_valid0 = sdcore_source_source_valid1;
assign sdcore_source_source_ready1 = sdcore_source_source_ready0;
assign sdcore_source_source_first0 = sdcore_source_source_first1;
assign sdcore_source_source_last0 = sdcore_source_source_last1;
assign sdcore_source_source_payload_data0 = sdcore_source_source_payload_data1;
assign sdcore_cmd_type = sdcore_csrfield_cmd_type;
assign sdcore_data_type = sdcore_csrfield_data_type;
assign sdcore_cmd = sdcore_csrfield_cmd;
assign sdcore_csrfield_done0 = sdcore_cmd_done;
assign sdcore_csrfield_error0 = sdcore_cmd_error;
assign sdcore_csrfield_timeout0 = sdcore_cmd_timeout;
assign sdcore_csrfield_crc0 = 1'd0;
assign sdcore_csrfield_done1 = sdcore_data_done;
assign sdcore_csrfield_error1 = sdcore_data_error;
assign sdcore_csrfield_timeout1 = sdcore_data_timeout;
assign sdcore_csrfield_crc1 = 1'd0;
assign sdcore_crc7_inserter_din = {1'd0, 1'd1, sdcore_cmd, sdcore_cmd_argument_storage};
assign sdcore_crc7_inserter_reset = 1'd1;
assign sdcore_crc7_inserter_enable = 1'd1;
assign sdcore_crc7_inserter_reg1 = {sdcore_crc7_inserter_reg0[5], sdcore_crc7_inserter_reg0[4], sdcore_crc7_inserter_reg0[3], (sdcore_crc7_inserter_reg0[2] ^ (sdcore_crc7_inserter_din[39] ^ sdcore_crc7_inserter_reg0[6])), sdcore_crc7_inserter_reg0[1], sdcore_crc7_inserter_reg0[0], (sdcore_crc7_inserter_din[39] ^ sdcore_crc7_inserter_reg0[6])};
assign sdcore_crc7_inserter_reg2 = {sdcore_crc7_inserter_reg1[5], sdcore_crc7_inserter_reg1[4], sdcore_crc7_inserter_reg1[3], (sdcore_crc7_inserter_reg1[2] ^ (sdcore_crc7_inserter_din[38] ^ sdcore_crc7_inserter_reg1[6])), sdcore_crc7_inserter_reg1[1], sdcore_crc7_inserter_reg1[0], (sdcore_crc7_inserter_din[38] ^ sdcore_crc7_inserter_reg1[6])};
assign sdcore_crc7_inserter_reg3 = {sdcore_crc7_inserter_reg2[5], sdcore_crc7_inserter_reg2[4], sdcore_crc7_inserter_reg2[3], (sdcore_crc7_inserter_reg2[2] ^ (sdcore_crc7_inserter_din[37] ^ sdcore_crc7_inserter_reg2[6])), sdcore_crc7_inserter_reg2[1], sdcore_crc7_inserter_reg2[0], (sdcore_crc7_inserter_din[37] ^ sdcore_crc7_inserter_reg2[6])};
assign sdcore_crc7_inserter_reg4 = {sdcore_crc7_inserter_reg3[5], sdcore_crc7_inserter_reg3[4], sdcore_crc7_inserter_reg3[3], (sdcore_crc7_inserter_reg3[2] ^ (sdcore_crc7_inserter_din[36] ^ sdcore_crc7_inserter_reg3[6])), sdcore_crc7_inserter_reg3[1], sdcore_crc7_inserter_reg3[0], (sdcore_crc7_inserter_din[36] ^ sdcore_crc7_inserter_reg3[6])};
assign sdcore_crc7_inserter_reg5 = {sdcore_crc7_inserter_reg4[5], sdcore_crc7_inserter_reg4[4], sdcore_crc7_inserter_reg4[3], (sdcore_crc7_inserter_reg4[2] ^ (sdcore_crc7_inserter_din[35] ^ sdcore_crc7_inserter_reg4[6])), sdcore_crc7_inserter_reg4[1], sdcore_crc7_inserter_reg4[0], (sdcore_crc7_inserter_din[35] ^ sdcore_crc7_inserter_reg4[6])};
assign sdcore_crc7_inserter_reg6 = {sdcore_crc7_inserter_reg5[5], sdcore_crc7_inserter_reg5[4], sdcore_crc7_inserter_reg5[3], (sdcore_crc7_inserter_reg5[2] ^ (sdcore_crc7_inserter_din[34] ^ sdcore_crc7_inserter_reg5[6])), sdcore_crc7_inserter_reg5[1], sdcore_crc7_inserter_reg5[0], (sdcore_crc7_inserter_din[34] ^ sdcore_crc7_inserter_reg5[6])};
assign sdcore_crc7_inserter_reg7 = {sdcore_crc7_inserter_reg6[5], sdcore_crc7_inserter_reg6[4], sdcore_crc7_inserter_reg6[3], (sdcore_crc7_inserter_reg6[2] ^ (sdcore_crc7_inserter_din[33] ^ sdcore_crc7_inserter_reg6[6])), sdcore_crc7_inserter_reg6[1], sdcore_crc7_inserter_reg6[0], (sdcore_crc7_inserter_din[33] ^ sdcore_crc7_inserter_reg6[6])};
assign sdcore_crc7_inserter_reg8 = {sdcore_crc7_inserter_reg7[5], sdcore_crc7_inserter_reg7[4], sdcore_crc7_inserter_reg7[3], (sdcore_crc7_inserter_reg7[2] ^ (sdcore_crc7_inserter_din[32] ^ sdcore_crc7_inserter_reg7[6])), sdcore_crc7_inserter_reg7[1], sdcore_crc7_inserter_reg7[0], (sdcore_crc7_inserter_din[32] ^ sdcore_crc7_inserter_reg7[6])};
assign sdcore_crc7_inserter_reg9 = {sdcore_crc7_inserter_reg8[5], sdcore_crc7_inserter_reg8[4], sdcore_crc7_inserter_reg8[3], (sdcore_crc7_inserter_reg8[2] ^ (sdcore_crc7_inserter_din[31] ^ sdcore_crc7_inserter_reg8[6])), sdcore_crc7_inserter_reg8[1], sdcore_crc7_inserter_reg8[0], (sdcore_crc7_inserter_din[31] ^ sdcore_crc7_inserter_reg8[6])};
assign sdcore_crc7_inserter_reg10 = {sdcore_crc7_inserter_reg9[5], sdcore_crc7_inserter_reg9[4], sdcore_crc7_inserter_reg9[3], (sdcore_crc7_inserter_reg9[2] ^ (sdcore_crc7_inserter_din[30] ^ sdcore_crc7_inserter_reg9[6])), sdcore_crc7_inserter_reg9[1], sdcore_crc7_inserter_reg9[0], (sdcore_crc7_inserter_din[30] ^ sdcore_crc7_inserter_reg9[6])};
assign sdcore_crc7_inserter_reg11 = {sdcore_crc7_inserter_reg10[5], sdcore_crc7_inserter_reg10[4], sdcore_crc7_inserter_reg10[3], (sdcore_crc7_inserter_reg10[2] ^ (sdcore_crc7_inserter_din[29] ^ sdcore_crc7_inserter_reg10[6])), sdcore_crc7_inserter_reg10[1], sdcore_crc7_inserter_reg10[0], (sdcore_crc7_inserter_din[29] ^ sdcore_crc7_inserter_reg10[6])};
assign sdcore_crc7_inserter_reg12 = {sdcore_crc7_inserter_reg11[5], sdcore_crc7_inserter_reg11[4], sdcore_crc7_inserter_reg11[3], (sdcore_crc7_inserter_reg11[2] ^ (sdcore_crc7_inserter_din[28] ^ sdcore_crc7_inserter_reg11[6])), sdcore_crc7_inserter_reg11[1], sdcore_crc7_inserter_reg11[0], (sdcore_crc7_inserter_din[28] ^ sdcore_crc7_inserter_reg11[6])};
assign sdcore_crc7_inserter_reg13 = {sdcore_crc7_inserter_reg12[5], sdcore_crc7_inserter_reg12[4], sdcore_crc7_inserter_reg12[3], (sdcore_crc7_inserter_reg12[2] ^ (sdcore_crc7_inserter_din[27] ^ sdcore_crc7_inserter_reg12[6])), sdcore_crc7_inserter_reg12[1], sdcore_crc7_inserter_reg12[0], (sdcore_crc7_inserter_din[27] ^ sdcore_crc7_inserter_reg12[6])};
assign sdcore_crc7_inserter_reg14 = {sdcore_crc7_inserter_reg13[5], sdcore_crc7_inserter_reg13[4], sdcore_crc7_inserter_reg13[3], (sdcore_crc7_inserter_reg13[2] ^ (sdcore_crc7_inserter_din[26] ^ sdcore_crc7_inserter_reg13[6])), sdcore_crc7_inserter_reg13[1], sdcore_crc7_inserter_reg13[0], (sdcore_crc7_inserter_din[26] ^ sdcore_crc7_inserter_reg13[6])};
assign sdcore_crc7_inserter_reg15 = {sdcore_crc7_inserter_reg14[5], sdcore_crc7_inserter_reg14[4], sdcore_crc7_inserter_reg14[3], (sdcore_crc7_inserter_reg14[2] ^ (sdcore_crc7_inserter_din[25] ^ sdcore_crc7_inserter_reg14[6])), sdcore_crc7_inserter_reg14[1], sdcore_crc7_inserter_reg14[0], (sdcore_crc7_inserter_din[25] ^ sdcore_crc7_inserter_reg14[6])};
assign sdcore_crc7_inserter_reg16 = {sdcore_crc7_inserter_reg15[5], sdcore_crc7_inserter_reg15[4], sdcore_crc7_inserter_reg15[3], (sdcore_crc7_inserter_reg15[2] ^ (sdcore_crc7_inserter_din[24] ^ sdcore_crc7_inserter_reg15[6])), sdcore_crc7_inserter_reg15[1], sdcore_crc7_inserter_reg15[0], (sdcore_crc7_inserter_din[24] ^ sdcore_crc7_inserter_reg15[6])};
assign sdcore_crc7_inserter_reg17 = {sdcore_crc7_inserter_reg16[5], sdcore_crc7_inserter_reg16[4], sdcore_crc7_inserter_reg16[3], (sdcore_crc7_inserter_reg16[2] ^ (sdcore_crc7_inserter_din[23] ^ sdcore_crc7_inserter_reg16[6])), sdcore_crc7_inserter_reg16[1], sdcore_crc7_inserter_reg16[0], (sdcore_crc7_inserter_din[23] ^ sdcore_crc7_inserter_reg16[6])};
assign sdcore_crc7_inserter_reg18 = {sdcore_crc7_inserter_reg17[5], sdcore_crc7_inserter_reg17[4], sdcore_crc7_inserter_reg17[3], (sdcore_crc7_inserter_reg17[2] ^ (sdcore_crc7_inserter_din[22] ^ sdcore_crc7_inserter_reg17[6])), sdcore_crc7_inserter_reg17[1], sdcore_crc7_inserter_reg17[0], (sdcore_crc7_inserter_din[22] ^ sdcore_crc7_inserter_reg17[6])};
assign sdcore_crc7_inserter_reg19 = {sdcore_crc7_inserter_reg18[5], sdcore_crc7_inserter_reg18[4], sdcore_crc7_inserter_reg18[3], (sdcore_crc7_inserter_reg18[2] ^ (sdcore_crc7_inserter_din[21] ^ sdcore_crc7_inserter_reg18[6])), sdcore_crc7_inserter_reg18[1], sdcore_crc7_inserter_reg18[0], (sdcore_crc7_inserter_din[21] ^ sdcore_crc7_inserter_reg18[6])};
assign sdcore_crc7_inserter_reg20 = {sdcore_crc7_inserter_reg19[5], sdcore_crc7_inserter_reg19[4], sdcore_crc7_inserter_reg19[3], (sdcore_crc7_inserter_reg19[2] ^ (sdcore_crc7_inserter_din[20] ^ sdcore_crc7_inserter_reg19[6])), sdcore_crc7_inserter_reg19[1], sdcore_crc7_inserter_reg19[0], (sdcore_crc7_inserter_din[20] ^ sdcore_crc7_inserter_reg19[6])};
assign sdcore_crc7_inserter_reg21 = {sdcore_crc7_inserter_reg20[5], sdcore_crc7_inserter_reg20[4], sdcore_crc7_inserter_reg20[3], (sdcore_crc7_inserter_reg20[2] ^ (sdcore_crc7_inserter_din[19] ^ sdcore_crc7_inserter_reg20[6])), sdcore_crc7_inserter_reg20[1], sdcore_crc7_inserter_reg20[0], (sdcore_crc7_inserter_din[19] ^ sdcore_crc7_inserter_reg20[6])};
assign sdcore_crc7_inserter_reg22 = {sdcore_crc7_inserter_reg21[5], sdcore_crc7_inserter_reg21[4], sdcore_crc7_inserter_reg21[3], (sdcore_crc7_inserter_reg21[2] ^ (sdcore_crc7_inserter_din[18] ^ sdcore_crc7_inserter_reg21[6])), sdcore_crc7_inserter_reg21[1], sdcore_crc7_inserter_reg21[0], (sdcore_crc7_inserter_din[18] ^ sdcore_crc7_inserter_reg21[6])};
assign sdcore_crc7_inserter_reg23 = {sdcore_crc7_inserter_reg22[5], sdcore_crc7_inserter_reg22[4], sdcore_crc7_inserter_reg22[3], (sdcore_crc7_inserter_reg22[2] ^ (sdcore_crc7_inserter_din[17] ^ sdcore_crc7_inserter_reg22[6])), sdcore_crc7_inserter_reg22[1], sdcore_crc7_inserter_reg22[0], (sdcore_crc7_inserter_din[17] ^ sdcore_crc7_inserter_reg22[6])};
assign sdcore_crc7_inserter_reg24 = {sdcore_crc7_inserter_reg23[5], sdcore_crc7_inserter_reg23[4], sdcore_crc7_inserter_reg23[3], (sdcore_crc7_inserter_reg23[2] ^ (sdcore_crc7_inserter_din[16] ^ sdcore_crc7_inserter_reg23[6])), sdcore_crc7_inserter_reg23[1], sdcore_crc7_inserter_reg23[0], (sdcore_crc7_inserter_din[16] ^ sdcore_crc7_inserter_reg23[6])};
assign sdcore_crc7_inserter_reg25 = {sdcore_crc7_inserter_reg24[5], sdcore_crc7_inserter_reg24[4], sdcore_crc7_inserter_reg24[3], (sdcore_crc7_inserter_reg24[2] ^ (sdcore_crc7_inserter_din[15] ^ sdcore_crc7_inserter_reg24[6])), sdcore_crc7_inserter_reg24[1], sdcore_crc7_inserter_reg24[0], (sdcore_crc7_inserter_din[15] ^ sdcore_crc7_inserter_reg24[6])};
assign sdcore_crc7_inserter_reg26 = {sdcore_crc7_inserter_reg25[5], sdcore_crc7_inserter_reg25[4], sdcore_crc7_inserter_reg25[3], (sdcore_crc7_inserter_reg25[2] ^ (sdcore_crc7_inserter_din[14] ^ sdcore_crc7_inserter_reg25[6])), sdcore_crc7_inserter_reg25[1], sdcore_crc7_inserter_reg25[0], (sdcore_crc7_inserter_din[14] ^ sdcore_crc7_inserter_reg25[6])};
assign sdcore_crc7_inserter_reg27 = {sdcore_crc7_inserter_reg26[5], sdcore_crc7_inserter_reg26[4], sdcore_crc7_inserter_reg26[3], (sdcore_crc7_inserter_reg26[2] ^ (sdcore_crc7_inserter_din[13] ^ sdcore_crc7_inserter_reg26[6])), sdcore_crc7_inserter_reg26[1], sdcore_crc7_inserter_reg26[0], (sdcore_crc7_inserter_din[13] ^ sdcore_crc7_inserter_reg26[6])};
assign sdcore_crc7_inserter_reg28 = {sdcore_crc7_inserter_reg27[5], sdcore_crc7_inserter_reg27[4], sdcore_crc7_inserter_reg27[3], (sdcore_crc7_inserter_reg27[2] ^ (sdcore_crc7_inserter_din[12] ^ sdcore_crc7_inserter_reg27[6])), sdcore_crc7_inserter_reg27[1], sdcore_crc7_inserter_reg27[0], (sdcore_crc7_inserter_din[12] ^ sdcore_crc7_inserter_reg27[6])};
assign sdcore_crc7_inserter_reg29 = {sdcore_crc7_inserter_reg28[5], sdcore_crc7_inserter_reg28[4], sdcore_crc7_inserter_reg28[3], (sdcore_crc7_inserter_reg28[2] ^ (sdcore_crc7_inserter_din[11] ^ sdcore_crc7_inserter_reg28[6])), sdcore_crc7_inserter_reg28[1], sdcore_crc7_inserter_reg28[0], (sdcore_crc7_inserter_din[11] ^ sdcore_crc7_inserter_reg28[6])};
assign sdcore_crc7_inserter_reg30 = {sdcore_crc7_inserter_reg29[5], sdcore_crc7_inserter_reg29[4], sdcore_crc7_inserter_reg29[3], (sdcore_crc7_inserter_reg29[2] ^ (sdcore_crc7_inserter_din[10] ^ sdcore_crc7_inserter_reg29[6])), sdcore_crc7_inserter_reg29[1], sdcore_crc7_inserter_reg29[0], (sdcore_crc7_inserter_din[10] ^ sdcore_crc7_inserter_reg29[6])};
assign sdcore_crc7_inserter_reg31 = {sdcore_crc7_inserter_reg30[5], sdcore_crc7_inserter_reg30[4], sdcore_crc7_inserter_reg30[3], (sdcore_crc7_inserter_reg30[2] ^ (sdcore_crc7_inserter_din[9] ^ sdcore_crc7_inserter_reg30[6])), sdcore_crc7_inserter_reg30[1], sdcore_crc7_inserter_reg30[0], (sdcore_crc7_inserter_din[9] ^ sdcore_crc7_inserter_reg30[6])};
assign sdcore_crc7_inserter_reg32 = {sdcore_crc7_inserter_reg31[5], sdcore_crc7_inserter_reg31[4], sdcore_crc7_inserter_reg31[3], (sdcore_crc7_inserter_reg31[2] ^ (sdcore_crc7_inserter_din[8] ^ sdcore_crc7_inserter_reg31[6])), sdcore_crc7_inserter_reg31[1], sdcore_crc7_inserter_reg31[0], (sdcore_crc7_inserter_din[8] ^ sdcore_crc7_inserter_reg31[6])};
assign sdcore_crc7_inserter_reg33 = {sdcore_crc7_inserter_reg32[5], sdcore_crc7_inserter_reg32[4], sdcore_crc7_inserter_reg32[3], (sdcore_crc7_inserter_reg32[2] ^ (sdcore_crc7_inserter_din[7] ^ sdcore_crc7_inserter_reg32[6])), sdcore_crc7_inserter_reg32[1], sdcore_crc7_inserter_reg32[0], (sdcore_crc7_inserter_din[7] ^ sdcore_crc7_inserter_reg32[6])};
assign sdcore_crc7_inserter_reg34 = {sdcore_crc7_inserter_reg33[5], sdcore_crc7_inserter_reg33[4], sdcore_crc7_inserter_reg33[3], (sdcore_crc7_inserter_reg33[2] ^ (sdcore_crc7_inserter_din[6] ^ sdcore_crc7_inserter_reg33[6])), sdcore_crc7_inserter_reg33[1], sdcore_crc7_inserter_reg33[0], (sdcore_crc7_inserter_din[6] ^ sdcore_crc7_inserter_reg33[6])};
assign sdcore_crc7_inserter_reg35 = {sdcore_crc7_inserter_reg34[5], sdcore_crc7_inserter_reg34[4], sdcore_crc7_inserter_reg34[3], (sdcore_crc7_inserter_reg34[2] ^ (sdcore_crc7_inserter_din[5] ^ sdcore_crc7_inserter_reg34[6])), sdcore_crc7_inserter_reg34[1], sdcore_crc7_inserter_reg34[0], (sdcore_crc7_inserter_din[5] ^ sdcore_crc7_inserter_reg34[6])};
assign sdcore_crc7_inserter_reg36 = {sdcore_crc7_inserter_reg35[5], sdcore_crc7_inserter_reg35[4], sdcore_crc7_inserter_reg35[3], (sdcore_crc7_inserter_reg35[2] ^ (sdcore_crc7_inserter_din[4] ^ sdcore_crc7_inserter_reg35[6])), sdcore_crc7_inserter_reg35[1], sdcore_crc7_inserter_reg35[0], (sdcore_crc7_inserter_din[4] ^ sdcore_crc7_inserter_reg35[6])};
assign sdcore_crc7_inserter_reg37 = {sdcore_crc7_inserter_reg36[5], sdcore_crc7_inserter_reg36[4], sdcore_crc7_inserter_reg36[3], (sdcore_crc7_inserter_reg36[2] ^ (sdcore_crc7_inserter_din[3] ^ sdcore_crc7_inserter_reg36[6])), sdcore_crc7_inserter_reg36[1], sdcore_crc7_inserter_reg36[0], (sdcore_crc7_inserter_din[3] ^ sdcore_crc7_inserter_reg36[6])};
assign sdcore_crc7_inserter_reg38 = {sdcore_crc7_inserter_reg37[5], sdcore_crc7_inserter_reg37[4], sdcore_crc7_inserter_reg37[3], (sdcore_crc7_inserter_reg37[2] ^ (sdcore_crc7_inserter_din[2] ^ sdcore_crc7_inserter_reg37[6])), sdcore_crc7_inserter_reg37[1], sdcore_crc7_inserter_reg37[0], (sdcore_crc7_inserter_din[2] ^ sdcore_crc7_inserter_reg37[6])};
assign sdcore_crc7_inserter_reg39 = {sdcore_crc7_inserter_reg38[5], sdcore_crc7_inserter_reg38[4], sdcore_crc7_inserter_reg38[3], (sdcore_crc7_inserter_reg38[2] ^ (sdcore_crc7_inserter_din[1] ^ sdcore_crc7_inserter_reg38[6])), sdcore_crc7_inserter_reg38[1], sdcore_crc7_inserter_reg38[0], (sdcore_crc7_inserter_din[1] ^ sdcore_crc7_inserter_reg38[6])};
assign sdcore_crc7_inserter_reg40 = {sdcore_crc7_inserter_reg39[5], sdcore_crc7_inserter_reg39[4], sdcore_crc7_inserter_reg39[3], (sdcore_crc7_inserter_reg39[2] ^ (sdcore_crc7_inserter_din[0] ^ sdcore_crc7_inserter_reg39[6])), sdcore_crc7_inserter_reg39[1], sdcore_crc7_inserter_reg39[0], (sdcore_crc7_inserter_din[0] ^ sdcore_crc7_inserter_reg39[6])};
always @(*) begin
    sdcore_crc7_inserter_crc <= 7'd0;
    if (sdcore_crc7_inserter_enable) begin
        sdcore_crc7_inserter_crc <= sdcore_crc7_inserter_reg40;
    end else begin
        sdcore_crc7_inserter_crc <= sdcore_crc7_inserter_reg0;
    end
end
assign sdcore_crc16_inserter_crc0_reset = ((sdcore_crc16_inserter_source_valid & sdcore_crc16_inserter_source_ready) & sdcore_crc16_inserter_source_last);
assign sdcore_crc16_inserter_crc0_enable = (sdcore_crc16_inserter_sink_valid & sdcore_crc16_inserter_sink_ready);
always @(*) begin
    sdcore_crc16_inserter_crc0_din <= 2'd0;
    sdcore_crc16_inserter_crc0_din[0] <= sdcore_crc16_inserter_sink_payload_data[0];
    sdcore_crc16_inserter_crc0_din[1] <= sdcore_crc16_inserter_sink_payload_data[4];
end
assign sdcore_crc16_inserter_crc1_reset = ((sdcore_crc16_inserter_source_valid & sdcore_crc16_inserter_source_ready) & sdcore_crc16_inserter_source_last);
assign sdcore_crc16_inserter_crc1_enable = (sdcore_crc16_inserter_sink_valid & sdcore_crc16_inserter_sink_ready);
always @(*) begin
    sdcore_crc16_inserter_crc1_din <= 2'd0;
    sdcore_crc16_inserter_crc1_din[0] <= sdcore_crc16_inserter_sink_payload_data[1];
    sdcore_crc16_inserter_crc1_din[1] <= sdcore_crc16_inserter_sink_payload_data[5];
end
assign sdcore_crc16_inserter_crc2_reset = ((sdcore_crc16_inserter_source_valid & sdcore_crc16_inserter_source_ready) & sdcore_crc16_inserter_source_last);
assign sdcore_crc16_inserter_crc2_enable = (sdcore_crc16_inserter_sink_valid & sdcore_crc16_inserter_sink_ready);
always @(*) begin
    sdcore_crc16_inserter_crc2_din <= 2'd0;
    sdcore_crc16_inserter_crc2_din[0] <= sdcore_crc16_inserter_sink_payload_data[2];
    sdcore_crc16_inserter_crc2_din[1] <= sdcore_crc16_inserter_sink_payload_data[6];
end
assign sdcore_crc16_inserter_crc3_reset = ((sdcore_crc16_inserter_source_valid & sdcore_crc16_inserter_source_ready) & sdcore_crc16_inserter_source_last);
assign sdcore_crc16_inserter_crc3_enable = (sdcore_crc16_inserter_sink_valid & sdcore_crc16_inserter_sink_ready);
always @(*) begin
    sdcore_crc16_inserter_crc3_din <= 2'd0;
    sdcore_crc16_inserter_crc3_din[0] <= sdcore_crc16_inserter_sink_payload_data[3];
    sdcore_crc16_inserter_crc3_din[1] <= sdcore_crc16_inserter_sink_payload_data[7];
end
assign sdcore_crc16_inserter_crc0_reg1 = {sdcore_crc16_inserter_crc0_reg0[14], sdcore_crc16_inserter_crc0_reg0[13], sdcore_crc16_inserter_crc0_reg0[12], (sdcore_crc16_inserter_crc0_reg0[11] ^ (sdcore_crc16_inserter_crc0_din[1] ^ sdcore_crc16_inserter_crc0_reg0[15])), sdcore_crc16_inserter_crc0_reg0[10], sdcore_crc16_inserter_crc0_reg0[9], sdcore_crc16_inserter_crc0_reg0[8], sdcore_crc16_inserter_crc0_reg0[7], sdcore_crc16_inserter_crc0_reg0[6], sdcore_crc16_inserter_crc0_reg0[5], (sdcore_crc16_inserter_crc0_reg0[4] ^ (sdcore_crc16_inserter_crc0_din[1] ^ sdcore_crc16_inserter_crc0_reg0[15])), sdcore_crc16_inserter_crc0_reg0[3], sdcore_crc16_inserter_crc0_reg0[2], sdcore_crc16_inserter_crc0_reg0[1], sdcore_crc16_inserter_crc0_reg0[0], (sdcore_crc16_inserter_crc0_din[1] ^ sdcore_crc16_inserter_crc0_reg0[15])};
assign sdcore_crc16_inserter_crc0_reg2 = {sdcore_crc16_inserter_crc0_reg1[14], sdcore_crc16_inserter_crc0_reg1[13], sdcore_crc16_inserter_crc0_reg1[12], (sdcore_crc16_inserter_crc0_reg1[11] ^ (sdcore_crc16_inserter_crc0_din[0] ^ sdcore_crc16_inserter_crc0_reg1[15])), sdcore_crc16_inserter_crc0_reg1[10], sdcore_crc16_inserter_crc0_reg1[9], sdcore_crc16_inserter_crc0_reg1[8], sdcore_crc16_inserter_crc0_reg1[7], sdcore_crc16_inserter_crc0_reg1[6], sdcore_crc16_inserter_crc0_reg1[5], (sdcore_crc16_inserter_crc0_reg1[4] ^ (sdcore_crc16_inserter_crc0_din[0] ^ sdcore_crc16_inserter_crc0_reg1[15])), sdcore_crc16_inserter_crc0_reg1[3], sdcore_crc16_inserter_crc0_reg1[2], sdcore_crc16_inserter_crc0_reg1[1], sdcore_crc16_inserter_crc0_reg1[0], (sdcore_crc16_inserter_crc0_din[0] ^ sdcore_crc16_inserter_crc0_reg1[15])};
always @(*) begin
    sdcore_crc16_inserter_crc0_crc <= 16'd0;
    if (sdcore_crc16_inserter_crc0_enable) begin
        sdcore_crc16_inserter_crc0_crc <= sdcore_crc16_inserter_crc0_reg2;
    end else begin
        sdcore_crc16_inserter_crc0_crc <= sdcore_crc16_inserter_crc0_reg0;
    end
end
assign sdcore_crc16_inserter_crc1_reg1 = {sdcore_crc16_inserter_crc1_reg0[14], sdcore_crc16_inserter_crc1_reg0[13], sdcore_crc16_inserter_crc1_reg0[12], (sdcore_crc16_inserter_crc1_reg0[11] ^ (sdcore_crc16_inserter_crc1_din[1] ^ sdcore_crc16_inserter_crc1_reg0[15])), sdcore_crc16_inserter_crc1_reg0[10], sdcore_crc16_inserter_crc1_reg0[9], sdcore_crc16_inserter_crc1_reg0[8], sdcore_crc16_inserter_crc1_reg0[7], sdcore_crc16_inserter_crc1_reg0[6], sdcore_crc16_inserter_crc1_reg0[5], (sdcore_crc16_inserter_crc1_reg0[4] ^ (sdcore_crc16_inserter_crc1_din[1] ^ sdcore_crc16_inserter_crc1_reg0[15])), sdcore_crc16_inserter_crc1_reg0[3], sdcore_crc16_inserter_crc1_reg0[2], sdcore_crc16_inserter_crc1_reg0[1], sdcore_crc16_inserter_crc1_reg0[0], (sdcore_crc16_inserter_crc1_din[1] ^ sdcore_crc16_inserter_crc1_reg0[15])};
assign sdcore_crc16_inserter_crc1_reg2 = {sdcore_crc16_inserter_crc1_reg1[14], sdcore_crc16_inserter_crc1_reg1[13], sdcore_crc16_inserter_crc1_reg1[12], (sdcore_crc16_inserter_crc1_reg1[11] ^ (sdcore_crc16_inserter_crc1_din[0] ^ sdcore_crc16_inserter_crc1_reg1[15])), sdcore_crc16_inserter_crc1_reg1[10], sdcore_crc16_inserter_crc1_reg1[9], sdcore_crc16_inserter_crc1_reg1[8], sdcore_crc16_inserter_crc1_reg1[7], sdcore_crc16_inserter_crc1_reg1[6], sdcore_crc16_inserter_crc1_reg1[5], (sdcore_crc16_inserter_crc1_reg1[4] ^ (sdcore_crc16_inserter_crc1_din[0] ^ sdcore_crc16_inserter_crc1_reg1[15])), sdcore_crc16_inserter_crc1_reg1[3], sdcore_crc16_inserter_crc1_reg1[2], sdcore_crc16_inserter_crc1_reg1[1], sdcore_crc16_inserter_crc1_reg1[0], (sdcore_crc16_inserter_crc1_din[0] ^ sdcore_crc16_inserter_crc1_reg1[15])};
always @(*) begin
    sdcore_crc16_inserter_crc1_crc <= 16'd0;
    if (sdcore_crc16_inserter_crc1_enable) begin
        sdcore_crc16_inserter_crc1_crc <= sdcore_crc16_inserter_crc1_reg2;
    end else begin
        sdcore_crc16_inserter_crc1_crc <= sdcore_crc16_inserter_crc1_reg0;
    end
end
assign sdcore_crc16_inserter_crc2_reg1 = {sdcore_crc16_inserter_crc2_reg0[14], sdcore_crc16_inserter_crc2_reg0[13], sdcore_crc16_inserter_crc2_reg0[12], (sdcore_crc16_inserter_crc2_reg0[11] ^ (sdcore_crc16_inserter_crc2_din[1] ^ sdcore_crc16_inserter_crc2_reg0[15])), sdcore_crc16_inserter_crc2_reg0[10], sdcore_crc16_inserter_crc2_reg0[9], sdcore_crc16_inserter_crc2_reg0[8], sdcore_crc16_inserter_crc2_reg0[7], sdcore_crc16_inserter_crc2_reg0[6], sdcore_crc16_inserter_crc2_reg0[5], (sdcore_crc16_inserter_crc2_reg0[4] ^ (sdcore_crc16_inserter_crc2_din[1] ^ sdcore_crc16_inserter_crc2_reg0[15])), sdcore_crc16_inserter_crc2_reg0[3], sdcore_crc16_inserter_crc2_reg0[2], sdcore_crc16_inserter_crc2_reg0[1], sdcore_crc16_inserter_crc2_reg0[0], (sdcore_crc16_inserter_crc2_din[1] ^ sdcore_crc16_inserter_crc2_reg0[15])};
assign sdcore_crc16_inserter_crc2_reg2 = {sdcore_crc16_inserter_crc2_reg1[14], sdcore_crc16_inserter_crc2_reg1[13], sdcore_crc16_inserter_crc2_reg1[12], (sdcore_crc16_inserter_crc2_reg1[11] ^ (sdcore_crc16_inserter_crc2_din[0] ^ sdcore_crc16_inserter_crc2_reg1[15])), sdcore_crc16_inserter_crc2_reg1[10], sdcore_crc16_inserter_crc2_reg1[9], sdcore_crc16_inserter_crc2_reg1[8], sdcore_crc16_inserter_crc2_reg1[7], sdcore_crc16_inserter_crc2_reg1[6], sdcore_crc16_inserter_crc2_reg1[5], (sdcore_crc16_inserter_crc2_reg1[4] ^ (sdcore_crc16_inserter_crc2_din[0] ^ sdcore_crc16_inserter_crc2_reg1[15])), sdcore_crc16_inserter_crc2_reg1[3], sdcore_crc16_inserter_crc2_reg1[2], sdcore_crc16_inserter_crc2_reg1[1], sdcore_crc16_inserter_crc2_reg1[0], (sdcore_crc16_inserter_crc2_din[0] ^ sdcore_crc16_inserter_crc2_reg1[15])};
always @(*) begin
    sdcore_crc16_inserter_crc2_crc <= 16'd0;
    if (sdcore_crc16_inserter_crc2_enable) begin
        sdcore_crc16_inserter_crc2_crc <= sdcore_crc16_inserter_crc2_reg2;
    end else begin
        sdcore_crc16_inserter_crc2_crc <= sdcore_crc16_inserter_crc2_reg0;
    end
end
assign sdcore_crc16_inserter_crc3_reg1 = {sdcore_crc16_inserter_crc3_reg0[14], sdcore_crc16_inserter_crc3_reg0[13], sdcore_crc16_inserter_crc3_reg0[12], (sdcore_crc16_inserter_crc3_reg0[11] ^ (sdcore_crc16_inserter_crc3_din[1] ^ sdcore_crc16_inserter_crc3_reg0[15])), sdcore_crc16_inserter_crc3_reg0[10], sdcore_crc16_inserter_crc3_reg0[9], sdcore_crc16_inserter_crc3_reg0[8], sdcore_crc16_inserter_crc3_reg0[7], sdcore_crc16_inserter_crc3_reg0[6], sdcore_crc16_inserter_crc3_reg0[5], (sdcore_crc16_inserter_crc3_reg0[4] ^ (sdcore_crc16_inserter_crc3_din[1] ^ sdcore_crc16_inserter_crc3_reg0[15])), sdcore_crc16_inserter_crc3_reg0[3], sdcore_crc16_inserter_crc3_reg0[2], sdcore_crc16_inserter_crc3_reg0[1], sdcore_crc16_inserter_crc3_reg0[0], (sdcore_crc16_inserter_crc3_din[1] ^ sdcore_crc16_inserter_crc3_reg0[15])};
assign sdcore_crc16_inserter_crc3_reg2 = {sdcore_crc16_inserter_crc3_reg1[14], sdcore_crc16_inserter_crc3_reg1[13], sdcore_crc16_inserter_crc3_reg1[12], (sdcore_crc16_inserter_crc3_reg1[11] ^ (sdcore_crc16_inserter_crc3_din[0] ^ sdcore_crc16_inserter_crc3_reg1[15])), sdcore_crc16_inserter_crc3_reg1[10], sdcore_crc16_inserter_crc3_reg1[9], sdcore_crc16_inserter_crc3_reg1[8], sdcore_crc16_inserter_crc3_reg1[7], sdcore_crc16_inserter_crc3_reg1[6], sdcore_crc16_inserter_crc3_reg1[5], (sdcore_crc16_inserter_crc3_reg1[4] ^ (sdcore_crc16_inserter_crc3_din[0] ^ sdcore_crc16_inserter_crc3_reg1[15])), sdcore_crc16_inserter_crc3_reg1[3], sdcore_crc16_inserter_crc3_reg1[2], sdcore_crc16_inserter_crc3_reg1[1], sdcore_crc16_inserter_crc3_reg1[0], (sdcore_crc16_inserter_crc3_din[0] ^ sdcore_crc16_inserter_crc3_reg1[15])};
always @(*) begin
    sdcore_crc16_inserter_crc3_crc <= 16'd0;
    if (sdcore_crc16_inserter_crc3_enable) begin
        sdcore_crc16_inserter_crc3_crc <= sdcore_crc16_inserter_crc3_reg2;
    end else begin
        sdcore_crc16_inserter_crc3_crc <= sdcore_crc16_inserter_crc3_reg0;
    end
end
always @(*) begin
    sdcore_crc16_inserter_count_crc16inserter_next_value_ce <= 1'd0;
    builder_soclinux_sdcore_crc16inserter_next_state <= 1'd0;
    sdcore_crc16_inserter_source_payload_data <= 8'd0;
    sdcore_crc16_inserter_sink_ready <= 1'd0;
    sdcore_crc16_inserter_source_valid <= 1'd0;
    sdcore_crc16_inserter_source_first <= 1'd0;
    sdcore_crc16_inserter_source_last <= 1'd0;
    sdcore_crc16_inserter_count_crc16inserter_next_value <= 3'd0;
    builder_soclinux_sdcore_crc16inserter_next_state <= builder_soclinux_sdcore_crc16inserter_state;
    case (builder_soclinux_sdcore_crc16inserter_state)
        1'd1: begin
            sdcore_crc16_inserter_source_valid <= 1'd1;
            sdcore_crc16_inserter_source_last <= (sdcore_crc16_inserter_count == 3'd7);
            case (sdcore_crc16_inserter_count)
                1'd0: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[14];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[14];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[14];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[14];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[15];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[15];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[15];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[15];
                end
                1'd1: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[12];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[12];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[12];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[12];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[13];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[13];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[13];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[13];
                end
                2'd2: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[10];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[10];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[10];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[10];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[11];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[11];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[11];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[11];
                end
                2'd3: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[8];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[8];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[8];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[8];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[9];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[9];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[9];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[9];
                end
                3'd4: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[6];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[6];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[6];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[6];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[7];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[7];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[7];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[7];
                end
                3'd5: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[4];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[4];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[4];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[4];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[5];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[5];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[5];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[5];
                end
                3'd6: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[2];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[2];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[2];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[2];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[3];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[3];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[3];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[3];
                end
                3'd7: begin
                    sdcore_crc16_inserter_source_payload_data[0] <= sdcore_crc16_inserter_crc0_crc[0];
                    sdcore_crc16_inserter_source_payload_data[1] <= sdcore_crc16_inserter_crc1_crc[0];
                    sdcore_crc16_inserter_source_payload_data[2] <= sdcore_crc16_inserter_crc2_crc[0];
                    sdcore_crc16_inserter_source_payload_data[3] <= sdcore_crc16_inserter_crc3_crc[0];
                    sdcore_crc16_inserter_source_payload_data[4] <= sdcore_crc16_inserter_crc0_crc[1];
                    sdcore_crc16_inserter_source_payload_data[5] <= sdcore_crc16_inserter_crc1_crc[1];
                    sdcore_crc16_inserter_source_payload_data[6] <= sdcore_crc16_inserter_crc2_crc[1];
                    sdcore_crc16_inserter_source_payload_data[7] <= sdcore_crc16_inserter_crc3_crc[1];
                end
            endcase
            if ((sdcore_crc16_inserter_source_valid & sdcore_crc16_inserter_source_ready)) begin
                sdcore_crc16_inserter_count_crc16inserter_next_value <= (sdcore_crc16_inserter_count + 1'd1);
                sdcore_crc16_inserter_count_crc16inserter_next_value_ce <= 1'd1;
                if (sdcore_crc16_inserter_source_last) begin
                    builder_soclinux_sdcore_crc16inserter_next_state <= 1'd0;
                end
            end
        end
        default: begin
            sdcore_crc16_inserter_count_crc16inserter_next_value <= 1'd0;
            sdcore_crc16_inserter_count_crc16inserter_next_value_ce <= 1'd1;
            sdcore_crc16_inserter_source_valid <= sdcore_crc16_inserter_sink_valid;
            sdcore_crc16_inserter_sink_ready <= sdcore_crc16_inserter_source_ready;
            sdcore_crc16_inserter_source_first <= sdcore_crc16_inserter_sink_first;
            sdcore_crc16_inserter_source_payload_data <= sdcore_crc16_inserter_sink_payload_data;
            sdcore_crc16_inserter_source_last <= 1'd0;
            if ((sdcore_crc16_inserter_sink_valid & sdcore_crc16_inserter_sink_ready)) begin
                if (sdcore_crc16_inserter_sink_last) begin
                    builder_soclinux_sdcore_crc16inserter_next_state <= 1'd1;
                end
            end
        end
    endcase
end
assign sdcore_fifo_sink_valid = sdcore_sink_sink_valid1;
assign sdcore_sink_sink_ready1 = sdcore_fifo_sink_ready;
assign sdcore_fifo_sink_first = sdcore_sink_sink_first1;
assign sdcore_fifo_sink_last = sdcore_sink_sink_last1;
assign sdcore_fifo_sink_payload_data = sdcore_sink_sink_payload_data1;
assign sdcore_source_source_first1 = sdcore_fifo_source_first;
assign sdcore_source_source_last1 = sdcore_fifo_source_last;
assign sdcore_source_source_payload_data1 = sdcore_fifo_source_payload_data;
assign sdcore_source_source_valid1 = (sdcore_fifo_level >= 4'd8);
assign sdcore_fifo_source_ready = (sdcore_source_source_valid1 & sdcore_source_source_ready1);
assign sdcore_fifo_reset = ((sdcore_sink_sink_valid1 & sdcore_sink_sink_ready1) & sdcore_sink_sink_last1);
assign sdcore_fifo_syncfifo_din = {sdcore_fifo_fifo_in_last, sdcore_fifo_fifo_in_first, sdcore_fifo_fifo_in_payload_data};
assign {sdcore_fifo_fifo_out_last, sdcore_fifo_fifo_out_first, sdcore_fifo_fifo_out_payload_data} = sdcore_fifo_syncfifo_dout;
assign sdcore_fifo_sink_ready = sdcore_fifo_syncfifo_writable;
assign sdcore_fifo_syncfifo_we = sdcore_fifo_sink_valid;
assign sdcore_fifo_fifo_in_first = sdcore_fifo_sink_first;
assign sdcore_fifo_fifo_in_last = sdcore_fifo_sink_last;
assign sdcore_fifo_fifo_in_payload_data = sdcore_fifo_sink_payload_data;
assign sdcore_fifo_source_valid = sdcore_fifo_syncfifo_readable;
assign sdcore_fifo_source_first = sdcore_fifo_fifo_out_first;
assign sdcore_fifo_source_last = sdcore_fifo_fifo_out_last;
assign sdcore_fifo_source_payload_data = sdcore_fifo_fifo_out_payload_data;
assign sdcore_fifo_syncfifo_re = sdcore_fifo_source_ready;
always @(*) begin
    sdcore_fifo_wrport_adr <= 3'd0;
    if (sdcore_fifo_replace) begin
        sdcore_fifo_wrport_adr <= (sdcore_fifo_produce - 1'd1);
    end else begin
        sdcore_fifo_wrport_adr <= sdcore_fifo_produce;
    end
end
assign sdcore_fifo_wrport_dat_w = sdcore_fifo_syncfifo_din;
assign sdcore_fifo_wrport_we = (sdcore_fifo_syncfifo_we & (sdcore_fifo_syncfifo_writable | sdcore_fifo_replace));
assign sdcore_fifo_do_read = (sdcore_fifo_syncfifo_readable & sdcore_fifo_syncfifo_re);
assign sdcore_fifo_rdport_adr = sdcore_fifo_consume;
assign sdcore_fifo_syncfifo_dout = sdcore_fifo_rdport_dat_r;
assign sdcore_fifo_syncfifo_writable = (sdcore_fifo_level != 4'd8);
assign sdcore_fifo_syncfifo_readable = (sdcore_fifo_level != 1'd0);
always @(*) begin
    sdcore_cmd_count_fsm_next_value2 <= 3'd0;
    sdcore_cmd_count_fsm_next_value_ce2 <= 1'd0;
    sdcore_data_count_fsm_next_value3 <= 32'd0;
    sdcore_data_count_fsm_next_value_ce3 <= 1'd0;
    sdcore_cmd_error_fsm_next_value4 <= 1'd0;
    sdcore_cmd_error_fsm_next_value_ce4 <= 1'd0;
    cmdr_sink_valid <= 1'd0;
    sdcore_sink_sink_valid1 <= 1'd0;
    sdcore_cmd_timeout_fsm_next_value5 <= 1'd0;
    sdcore_cmd_timeout_fsm_next_value_ce5 <= 1'd0;
    sdcore_sink_sink_first1 <= 1'd0;
    cmdr_sink_payload_cmd_type <= 2'd0;
    sdcore_sink_sink_last1 <= 1'd0;
    cmdr_sink_payload_data_type <= 2'd0;
    sdcore_data_error_fsm_next_value6 <= 1'd0;
    cmdr_sink_payload_length <= 8'd0;
    sdcore_data_error_fsm_next_value_ce6 <= 1'd0;
    sdcore_sink_sink_payload_data1 <= 8'd0;
    cmdr_source_source_ready <= 1'd0;
    sdcore_data_timeout_fsm_next_value7 <= 1'd0;
    sdcore_data_timeout_fsm_next_value_ce7 <= 1'd0;
    cmdw_sink_valid <= 1'd0;
    cmdw_sink_last <= 1'd0;
    cmdw_sink_payload_data <= 8'd0;
    dataw_sink_valid <= 1'd0;
    cmdw_sink_payload_cmd_type <= 2'd0;
    dataw_sink_first <= 1'd0;
    dataw_sink_last <= 1'd0;
    dataw_sink_payload_data <= 8'd0;
    sdcore_cmd_response_status_fsm_next_value8 <= 128'd0;
    sdcore_cmd_response_status_fsm_next_value_ce8 <= 1'd0;
    datar_sink_valid <= 1'd0;
    datar_sink_last <= 1'd0;
    datar_sink_payload_block_length <= 10'd0;
    datar_source_source_ready <= 1'd0;
    builder_soclinux_sdcore_fsm_next_state <= 3'd0;
    sdcore_cmd_done_fsm_next_value0 <= 1'd0;
    sdcore_cmd_done_fsm_next_value_ce0 <= 1'd0;
    sdcore_crc16_inserter_source_ready <= 1'd0;
    sdcore_data_done_fsm_next_value1 <= 1'd0;
    sdcore_data_done_fsm_next_value_ce1 <= 1'd0;
    builder_soclinux_sdcore_fsm_next_state <= builder_soclinux_sdcore_fsm_state;
    case (builder_soclinux_sdcore_fsm_state)
        1'd1: begin
            cmdw_sink_valid <= 1'd1;
            cmdw_sink_last <= (sdcore_cmd_count == 3'd5);
            cmdw_sink_payload_cmd_type <= sdcore_cmd_type;
            case (sdcore_cmd_count)
                1'd0: begin
                    cmdw_sink_payload_data <= {1'd0, 1'd1, sdcore_cmd};
                end
                1'd1: begin
                    cmdw_sink_payload_data <= sdcore_cmd_argument_storage[31:24];
                end
                2'd2: begin
                    cmdw_sink_payload_data <= sdcore_cmd_argument_storage[23:16];
                end
                2'd3: begin
                    cmdw_sink_payload_data <= sdcore_cmd_argument_storage[15:8];
                end
                3'd4: begin
                    cmdw_sink_payload_data <= sdcore_cmd_argument_storage[7:0];
                end
                3'd5: begin
                    cmdw_sink_payload_data <= {sdcore_crc7_inserter_crc, 1'd1};
                end
            endcase
            if (cmdw_sink_ready) begin
                sdcore_cmd_count_fsm_next_value2 <= (sdcore_cmd_count + 1'd1);
                sdcore_cmd_count_fsm_next_value_ce2 <= 1'd1;
                if (cmdw_sink_last) begin
                    if ((sdcore_cmd_type == 1'd0)) begin
                        builder_soclinux_sdcore_fsm_next_state <= 1'd0;
                    end else begin
                        builder_soclinux_sdcore_fsm_next_state <= 2'd2;
                    end
                end
            end
        end
        2'd2: begin
            cmdr_sink_valid <= 1'd1;
            cmdr_sink_payload_cmd_type <= sdcore_cmd_type;
            cmdr_sink_payload_data_type <= sdcore_data_type;
            if ((sdcore_cmd_type == 2'd2)) begin
                cmdr_sink_payload_length <= 5'd18;
            end else begin
                cmdr_sink_payload_length <= 3'd6;
            end
            cmdr_source_source_ready <= 1'd1;
            if (cmdr_source_source_valid) begin
                if ((cmdr_source_source_payload_status == 1'd1)) begin
                    sdcore_cmd_timeout_fsm_next_value5 <= 1'd1;
                    sdcore_cmd_timeout_fsm_next_value_ce5 <= 1'd1;
                    builder_soclinux_sdcore_fsm_next_state <= 1'd0;
                end else begin
                    if (cmdr_source_source_last) begin
                        if ((sdcore_data_type == 2'd2)) begin
                            builder_soclinux_sdcore_fsm_next_state <= 2'd3;
                        end else begin
                            if ((sdcore_data_type == 1'd1)) begin
                                builder_soclinux_sdcore_fsm_next_state <= 3'd4;
                            end else begin
                                builder_soclinux_sdcore_fsm_next_state <= 1'd0;
                            end
                        end
                    end else begin
                        sdcore_cmd_response_status_fsm_next_value8 <= {sdcore_cmd_response_status, cmdr_source_source_payload_data};
                        sdcore_cmd_response_status_fsm_next_value_ce8 <= 1'd1;
                    end
                end
            end
        end
        2'd3: begin
            dataw_sink_valid <= sdcore_crc16_inserter_source_valid;
            sdcore_crc16_inserter_source_ready <= dataw_sink_ready;
            dataw_sink_first <= sdcore_crc16_inserter_source_first;
            dataw_sink_last <= sdcore_crc16_inserter_source_last;
            dataw_sink_payload_data <= sdcore_crc16_inserter_source_payload_data;
            if (((dataw_sink_valid & dataw_sink_ready) & dataw_sink_last)) begin
                sdcore_data_count_fsm_next_value3 <= (sdcore_data_count + 1'd1);
                sdcore_data_count_fsm_next_value_ce3 <= 1'd1;
                if ((sdcore_data_count == (sdcore_block_count_storage - 1'd1))) begin
                    builder_soclinux_sdcore_fsm_next_state <= 1'd0;
                end
            end
            datar_source_source_ready <= 1'd1;
            if (datar_source_source_valid) begin
                if ((datar_source_source_payload_status != 2'd2)) begin
                    sdcore_data_error_fsm_next_value6 <= 1'd1;
                    sdcore_data_error_fsm_next_value_ce6 <= 1'd1;
                end
            end
        end
        3'd4: begin
            datar_sink_valid <= 1'd1;
            datar_sink_payload_block_length <= sdcore_block_length_storage;
            datar_sink_last <= (sdcore_data_count == (sdcore_block_count_storage - 1'd1));
            if (datar_source_source_valid) begin
                if ((datar_source_source_payload_status == 1'd0)) begin
                    sdcore_sink_sink_valid1 <= datar_source_source_valid;
                    datar_source_source_ready <= sdcore_sink_sink_ready1;
                    sdcore_sink_sink_first1 <= datar_source_source_first;
                    sdcore_sink_sink_last1 <= datar_source_source_last;
                    sdcore_sink_sink_payload_data1 <= datar_source_source_payload_data;
                    if ((datar_source_source_last & datar_source_source_ready)) begin
                        sdcore_data_count_fsm_next_value3 <= (sdcore_data_count + 1'd1);
                        sdcore_data_count_fsm_next_value_ce3 <= 1'd1;
                        if ((sdcore_data_count == (sdcore_block_count_storage - 1'd1))) begin
                            builder_soclinux_sdcore_fsm_next_state <= 1'd0;
                        end
                    end
                end else begin
                    if ((datar_source_source_payload_status == 1'd1)) begin
                        sdcore_data_timeout_fsm_next_value7 <= 1'd1;
                        sdcore_data_timeout_fsm_next_value_ce7 <= 1'd1;
                        datar_source_source_ready <= 1'd1;
                        builder_soclinux_sdcore_fsm_next_state <= 1'd0;
                    end
                end
            end
        end
        default: begin
            sdcore_cmd_done_fsm_next_value0 <= 1'd1;
            sdcore_cmd_done_fsm_next_value_ce0 <= 1'd1;
            sdcore_data_done_fsm_next_value1 <= 1'd1;
            sdcore_data_done_fsm_next_value_ce1 <= 1'd1;
            sdcore_cmd_count_fsm_next_value2 <= 1'd0;
            sdcore_cmd_count_fsm_next_value_ce2 <= 1'd1;
            sdcore_data_count_fsm_next_value3 <= 1'd0;
            sdcore_data_count_fsm_next_value_ce3 <= 1'd1;
            if (sdcore_cmd_send_re) begin
                sdcore_cmd_done_fsm_next_value0 <= 1'd0;
                sdcore_cmd_done_fsm_next_value_ce0 <= 1'd1;
                sdcore_cmd_error_fsm_next_value4 <= 1'd0;
                sdcore_cmd_error_fsm_next_value_ce4 <= 1'd1;
                sdcore_cmd_timeout_fsm_next_value5 <= 1'd0;
                sdcore_cmd_timeout_fsm_next_value_ce5 <= 1'd1;
                sdcore_data_done_fsm_next_value1 <= 1'd0;
                sdcore_data_done_fsm_next_value_ce1 <= 1'd1;
                sdcore_data_error_fsm_next_value6 <= 1'd0;
                sdcore_data_error_fsm_next_value_ce6 <= 1'd1;
                sdcore_data_timeout_fsm_next_value7 <= 1'd0;
                sdcore_data_timeout_fsm_next_value_ce7 <= 1'd1;
                builder_soclinux_sdcore_fsm_next_state <= 1'd1;
            end
        end
    endcase
end
assign sdblock2mem_start = (sdblock2mem_sink_sink_valid0 & sdblock2mem_sink_sink_first);
always @(*) begin
    sdblock2mem_sink_sink_ready0 <= 1'd0;
    sdblock2mem_fifo_sink_last <= 1'd0;
    sdblock2mem_fifo_sink_payload_data <= 8'd0;
    sdblock2mem_fifo_sink_valid <= 1'd0;
    sdblock2mem_fifo_sink_first <= 1'd0;
    if ((sdblock2mem_wishbonedmawriter_enable_storage & (sdblock2mem_start | sdblock2mem_connect))) begin
        sdblock2mem_fifo_sink_valid <= sdblock2mem_sink_sink_valid0;
        sdblock2mem_sink_sink_ready0 <= sdblock2mem_fifo_sink_ready;
        sdblock2mem_fifo_sink_first <= sdblock2mem_sink_sink_first;
        sdblock2mem_fifo_sink_last <= sdblock2mem_sink_sink_last0;
        sdblock2mem_fifo_sink_payload_data <= sdblock2mem_sink_sink_payload_data0;
    end else begin
        sdblock2mem_sink_sink_ready0 <= 1'd1;
    end
end
assign sdblock2mem_converter_sink_valid = sdblock2mem_fifo_source_valid;
assign sdblock2mem_fifo_source_ready = sdblock2mem_converter_sink_ready;
assign sdblock2mem_converter_sink_first = sdblock2mem_fifo_source_first;
assign sdblock2mem_converter_sink_last = sdblock2mem_fifo_source_last;
assign sdblock2mem_converter_sink_payload_data = sdblock2mem_fifo_source_payload_data;
assign sdblock2mem_wishbonedmawriter_sink_valid = sdblock2mem_source_source_valid;
assign sdblock2mem_source_source_ready = sdblock2mem_wishbonedmawriter_sink_ready;
assign sdblock2mem_wishbonedmawriter_sink_first = sdblock2mem_source_source_first;
assign sdblock2mem_wishbonedmawriter_sink_last = sdblock2mem_source_source_last;
assign sdblock2mem_wishbonedmawriter_sink_payload_data = sdblock2mem_source_source_payload_data;
assign sdblock2mem_fifo_syncfifo_din = {sdblock2mem_fifo_fifo_in_last, sdblock2mem_fifo_fifo_in_first, sdblock2mem_fifo_fifo_in_payload_data};
assign {sdblock2mem_fifo_fifo_out_last, sdblock2mem_fifo_fifo_out_first, sdblock2mem_fifo_fifo_out_payload_data} = sdblock2mem_fifo_syncfifo_dout;
assign sdblock2mem_fifo_sink_ready = sdblock2mem_fifo_syncfifo_writable;
assign sdblock2mem_fifo_syncfifo_we = sdblock2mem_fifo_sink_valid;
assign sdblock2mem_fifo_fifo_in_first = sdblock2mem_fifo_sink_first;
assign sdblock2mem_fifo_fifo_in_last = sdblock2mem_fifo_sink_last;
assign sdblock2mem_fifo_fifo_in_payload_data = sdblock2mem_fifo_sink_payload_data;
assign sdblock2mem_fifo_source_valid = sdblock2mem_fifo_readable;
assign sdblock2mem_fifo_source_first = sdblock2mem_fifo_fifo_out_first;
assign sdblock2mem_fifo_source_last = sdblock2mem_fifo_fifo_out_last;
assign sdblock2mem_fifo_source_payload_data = sdblock2mem_fifo_fifo_out_payload_data;
assign sdblock2mem_fifo_re = sdblock2mem_fifo_source_ready;
assign sdblock2mem_fifo_syncfifo_re = (sdblock2mem_fifo_syncfifo_readable & ((~sdblock2mem_fifo_readable) | sdblock2mem_fifo_re));
assign sdblock2mem_fifo_level1 = (sdblock2mem_fifo_level0 + sdblock2mem_fifo_readable);
always @(*) begin
    sdblock2mem_fifo_wrport_adr <= 9'd0;
    if (sdblock2mem_fifo_replace) begin
        sdblock2mem_fifo_wrport_adr <= (sdblock2mem_fifo_produce - 1'd1);
    end else begin
        sdblock2mem_fifo_wrport_adr <= sdblock2mem_fifo_produce;
    end
end
assign sdblock2mem_fifo_wrport_dat_w = sdblock2mem_fifo_syncfifo_din;
assign sdblock2mem_fifo_wrport_we = (sdblock2mem_fifo_syncfifo_we & (sdblock2mem_fifo_syncfifo_writable | sdblock2mem_fifo_replace));
assign sdblock2mem_fifo_do_read = (sdblock2mem_fifo_syncfifo_readable & sdblock2mem_fifo_syncfifo_re);
assign sdblock2mem_fifo_rdport_adr = sdblock2mem_fifo_consume;
assign sdblock2mem_fifo_syncfifo_dout = sdblock2mem_fifo_rdport_dat_r;
assign sdblock2mem_fifo_rdport_re = sdblock2mem_fifo_do_read;
assign sdblock2mem_fifo_syncfifo_writable = (sdblock2mem_fifo_level0 != 10'd512);
assign sdblock2mem_fifo_syncfifo_readable = (sdblock2mem_fifo_level0 != 1'd0);
assign sdblock2mem_source_source_valid = sdblock2mem_converter_source_valid;
assign sdblock2mem_converter_source_ready = sdblock2mem_source_source_ready;
assign sdblock2mem_source_source_first = sdblock2mem_converter_source_first;
assign sdblock2mem_source_source_last = sdblock2mem_converter_source_last;
assign sdblock2mem_source_source_payload_data = sdblock2mem_converter_source_payload_data;
assign sdblock2mem_converter_sink_ready = ((~sdblock2mem_converter_strobe_all) | sdblock2mem_converter_source_ready);
assign sdblock2mem_converter_source_valid = sdblock2mem_converter_strobe_all;
assign sdblock2mem_converter_load_part = (sdblock2mem_converter_sink_valid & sdblock2mem_converter_sink_ready);
assign interface0_bus_stb = sdblock2mem_sink_sink_valid1;
assign interface0_bus_cyc = sdblock2mem_sink_sink_valid1;
assign interface0_bus_we = 1'd1;
assign interface0_bus_sel = 4'd15;
assign interface0_bus_adr = sdblock2mem_sink_sink_payload_address;
assign interface0_bus_dat_w = {sdblock2mem_sink_sink_payload_data1[7:0], sdblock2mem_sink_sink_payload_data1[15:8], sdblock2mem_sink_sink_payload_data1[23:16], sdblock2mem_sink_sink_payload_data1[31:24]};
assign sdblock2mem_sink_sink_ready1 = interface0_bus_ack;
assign sdblock2mem_wishbonedmawriter_base = sdblock2mem_wishbonedmawriter_base_storage[63:2];
assign sdblock2mem_wishbonedmawriter_length = sdblock2mem_wishbonedmawriter_length_storage[31:2];
assign sdblock2mem_wishbonedmawriter_offset_status = sdblock2mem_wishbonedmawriter_offset;
assign sdblock2mem_wishbonedmawriter_reset = (~sdblock2mem_wishbonedmawriter_enable_storage);
always @(*) begin
    builder_soclinux_sdblock2memdma_next_state <= 2'd0;
    sdblock2mem_sink_sink_valid1 <= 1'd0;
    sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value <= 32'd0;
    sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value_ce <= 1'd0;
    sdblock2mem_sink_sink_last1 <= 1'd0;
    sdblock2mem_sink_sink_payload_address <= 32'd0;
    sdblock2mem_sink_sink_payload_data1 <= 32'd0;
    sdblock2mem_wishbonedmawriter_done_status <= 1'd0;
    sdblock2mem_wishbonedmawriter_sink_ready <= 1'd0;
    builder_soclinux_sdblock2memdma_next_state <= builder_soclinux_sdblock2memdma_state;
    case (builder_soclinux_sdblock2memdma_state)
        1'd1: begin
            sdblock2mem_sink_sink_valid1 <= sdblock2mem_wishbonedmawriter_sink_valid;
            sdblock2mem_sink_sink_last1 <= (sdblock2mem_wishbonedmawriter_sink_last | ((sdblock2mem_wishbonedmawriter_offset + 1'd1) == sdblock2mem_wishbonedmawriter_length));
            sdblock2mem_sink_sink_payload_address <= (sdblock2mem_wishbonedmawriter_base + sdblock2mem_wishbonedmawriter_offset);
            sdblock2mem_sink_sink_payload_data1 <= sdblock2mem_wishbonedmawriter_sink_payload_data;
            sdblock2mem_wishbonedmawriter_sink_ready <= sdblock2mem_sink_sink_ready1;
            if ((sdblock2mem_wishbonedmawriter_sink_valid & sdblock2mem_wishbonedmawriter_sink_ready)) begin
                sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value <= (sdblock2mem_wishbonedmawriter_offset + 1'd1);
                sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value_ce <= 1'd1;
                if (sdblock2mem_sink_sink_last1) begin
                    if (sdblock2mem_wishbonedmawriter_loop_storage) begin
                        sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value <= 1'd0;
                        sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value_ce <= 1'd1;
                    end else begin
                        builder_soclinux_sdblock2memdma_next_state <= 2'd2;
                    end
                end
            end
        end
        2'd2: begin
            sdblock2mem_wishbonedmawriter_done_status <= 1'd1;
        end
        default: begin
            sdblock2mem_wishbonedmawriter_sink_ready <= 1'd1;
            sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value <= 1'd0;
            sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value_ce <= 1'd1;
            builder_soclinux_sdblock2memdma_next_state <= 1'd1;
        end
    endcase
end
assign sdmem2block_converter_converter_sink_valid = sdmem2block_dma_source_source_valid;
assign sdmem2block_dma_source_source_ready = sdmem2block_converter_converter_sink_ready;
assign sdmem2block_converter_converter_sink_first = sdmem2block_dma_source_source_first;
assign sdmem2block_converter_converter_sink_last = sdmem2block_dma_source_source_last;
assign sdmem2block_converter_converter_sink_payload_data = sdmem2block_dma_source_source_payload_data;
assign sdmem2block_fifo_sink_valid = sdmem2block_converter_source_source_valid;
assign sdmem2block_converter_source_source_ready = sdmem2block_fifo_sink_ready;
assign sdmem2block_fifo_sink_first = sdmem2block_converter_source_source_first;
assign sdmem2block_fifo_sink_last = sdmem2block_converter_source_source_last;
assign sdmem2block_fifo_sink_payload_data = sdmem2block_converter_source_source_payload_data;
assign sdmem2block_source_source_valid = sdmem2block_fifo_source_valid;
assign sdmem2block_fifo_source_ready = sdmem2block_source_source_ready;
assign sdmem2block_source_source_first = sdmem2block_fifo_source_first;
assign sdmem2block_source_source_payload_data = sdmem2block_fifo_source_payload_data;
always @(*) begin
    sdmem2block_source_source_last <= 1'd0;
    sdmem2block_source_source_last <= sdmem2block_fifo_source_last;
    if ((sdmem2block_count == 9'd511)) begin
        sdmem2block_source_source_last <= 1'd1;
    end
end
assign interface1_bus_stb = (sdmem2block_dma_sink_sink_valid & sdmem2block_dma_fifo_sink_ready);
assign interface1_bus_cyc = (sdmem2block_dma_sink_sink_valid & sdmem2block_dma_fifo_sink_ready);
assign interface1_bus_we = 1'd0;
assign interface1_bus_sel = 4'd15;
assign interface1_bus_adr = sdmem2block_dma_sink_sink_payload_address;
assign sdmem2block_dma_fifo_sink_last = sdmem2block_dma_sink_sink_last;
assign sdmem2block_dma_fifo_sink_payload_data = {interface1_bus_dat_r[7:0], interface1_bus_dat_r[15:8], interface1_bus_dat_r[23:16], interface1_bus_dat_r[31:24]};
always @(*) begin
    sdmem2block_dma_sink_sink_ready <= 1'd0;
    sdmem2block_dma_fifo_sink_valid <= 1'd0;
    if ((interface1_bus_stb & interface1_bus_ack)) begin
        sdmem2block_dma_sink_sink_ready <= 1'd1;
        sdmem2block_dma_fifo_sink_valid <= 1'd1;
    end
end
assign sdmem2block_dma_source_source_valid = sdmem2block_dma_fifo_source_valid;
assign sdmem2block_dma_fifo_source_ready = sdmem2block_dma_source_source_ready;
assign sdmem2block_dma_source_source_first = sdmem2block_dma_fifo_source_first;
assign sdmem2block_dma_source_source_last = sdmem2block_dma_fifo_source_last;
assign sdmem2block_dma_source_source_payload_data = sdmem2block_dma_fifo_source_payload_data;
assign sdmem2block_dma_base = sdmem2block_dma_base_storage[63:2];
assign sdmem2block_dma_length = sdmem2block_dma_length_storage[31:2];
assign sdmem2block_dma_offset_status = sdmem2block_dma_offset;
assign sdmem2block_dma_reset = (~sdmem2block_dma_enable_storage);
assign sdmem2block_dma_fifo_syncfifo_din = {sdmem2block_dma_fifo_fifo_in_last, sdmem2block_dma_fifo_fifo_in_first, sdmem2block_dma_fifo_fifo_in_payload_data};
assign {sdmem2block_dma_fifo_fifo_out_last, sdmem2block_dma_fifo_fifo_out_first, sdmem2block_dma_fifo_fifo_out_payload_data} = sdmem2block_dma_fifo_syncfifo_dout;
assign sdmem2block_dma_fifo_sink_ready = sdmem2block_dma_fifo_syncfifo_writable;
assign sdmem2block_dma_fifo_syncfifo_we = sdmem2block_dma_fifo_sink_valid;
assign sdmem2block_dma_fifo_fifo_in_first = sdmem2block_dma_fifo_sink_first;
assign sdmem2block_dma_fifo_fifo_in_last = sdmem2block_dma_fifo_sink_last;
assign sdmem2block_dma_fifo_fifo_in_payload_data = sdmem2block_dma_fifo_sink_payload_data;
assign sdmem2block_dma_fifo_source_valid = sdmem2block_dma_fifo_syncfifo_readable;
assign sdmem2block_dma_fifo_source_first = sdmem2block_dma_fifo_fifo_out_first;
assign sdmem2block_dma_fifo_source_last = sdmem2block_dma_fifo_fifo_out_last;
assign sdmem2block_dma_fifo_source_payload_data = sdmem2block_dma_fifo_fifo_out_payload_data;
assign sdmem2block_dma_fifo_syncfifo_re = sdmem2block_dma_fifo_source_ready;
always @(*) begin
    sdmem2block_dma_fifo_wrport_adr <= 4'd0;
    if (sdmem2block_dma_fifo_replace) begin
        sdmem2block_dma_fifo_wrport_adr <= (sdmem2block_dma_fifo_produce - 1'd1);
    end else begin
        sdmem2block_dma_fifo_wrport_adr <= sdmem2block_dma_fifo_produce;
    end
end
assign sdmem2block_dma_fifo_wrport_dat_w = sdmem2block_dma_fifo_syncfifo_din;
assign sdmem2block_dma_fifo_wrport_we = (sdmem2block_dma_fifo_syncfifo_we & (sdmem2block_dma_fifo_syncfifo_writable | sdmem2block_dma_fifo_replace));
assign sdmem2block_dma_fifo_do_read = (sdmem2block_dma_fifo_syncfifo_readable & sdmem2block_dma_fifo_syncfifo_re);
assign sdmem2block_dma_fifo_rdport_adr = sdmem2block_dma_fifo_consume;
assign sdmem2block_dma_fifo_syncfifo_dout = sdmem2block_dma_fifo_rdport_dat_r;
assign sdmem2block_dma_fifo_syncfifo_writable = (sdmem2block_dma_fifo_level != 5'd16);
assign sdmem2block_dma_fifo_syncfifo_readable = (sdmem2block_dma_fifo_level != 1'd0);
always @(*) begin
    sdmem2block_dma_offset_sdmem2blockdma_next_value_ce <= 1'd0;
    sdmem2block_dma_sink_sink_last <= 1'd0;
    sdmem2block_dma_sink_sink_payload_address <= 32'd0;
    sdmem2block_dma_sink_sink_valid <= 1'd0;
    sdmem2block_dma_done_status <= 1'd0;
    builder_soclinux_sdmem2blockdma_next_state <= 2'd0;
    sdmem2block_dma_offset_sdmem2blockdma_next_value <= 32'd0;
    builder_soclinux_sdmem2blockdma_next_state <= builder_soclinux_sdmem2blockdma_state;
    case (builder_soclinux_sdmem2blockdma_state)
        1'd1: begin
            sdmem2block_dma_sink_sink_valid <= 1'd1;
            sdmem2block_dma_sink_sink_last <= (sdmem2block_dma_offset == (sdmem2block_dma_length - 1'd1));
            sdmem2block_dma_sink_sink_payload_address <= (sdmem2block_dma_base + sdmem2block_dma_offset);
            if (sdmem2block_dma_sink_sink_ready) begin
                sdmem2block_dma_offset_sdmem2blockdma_next_value <= (sdmem2block_dma_offset + 1'd1);
                sdmem2block_dma_offset_sdmem2blockdma_next_value_ce <= 1'd1;
                if (sdmem2block_dma_sink_sink_last) begin
                    if (sdmem2block_dma_loop_storage) begin
                        sdmem2block_dma_offset_sdmem2blockdma_next_value <= 1'd0;
                        sdmem2block_dma_offset_sdmem2blockdma_next_value_ce <= 1'd1;
                    end else begin
                        builder_soclinux_sdmem2blockdma_next_state <= 2'd2;
                    end
                end
            end
        end
        2'd2: begin
            sdmem2block_dma_done_status <= 1'd1;
        end
        default: begin
            sdmem2block_dma_offset_sdmem2blockdma_next_value <= 1'd0;
            sdmem2block_dma_offset_sdmem2blockdma_next_value_ce <= 1'd1;
            builder_soclinux_sdmem2blockdma_next_state <= 1'd1;
        end
    endcase
end
assign sdmem2block_converter_source_source_valid = sdmem2block_converter_converter_source_valid;
assign sdmem2block_converter_converter_source_ready = sdmem2block_converter_source_source_ready;
assign sdmem2block_converter_source_source_first = sdmem2block_converter_converter_source_first;
assign sdmem2block_converter_source_source_last = sdmem2block_converter_converter_source_last;
assign sdmem2block_converter_source_source_payload_data = sdmem2block_converter_converter_source_payload_data;
assign sdmem2block_converter_converter_first = (sdmem2block_converter_converter_mux == 1'd0);
assign sdmem2block_converter_converter_last = (sdmem2block_converter_converter_mux == 2'd3);
assign sdmem2block_converter_converter_source_valid = sdmem2block_converter_converter_sink_valid;
assign sdmem2block_converter_converter_source_first = (sdmem2block_converter_converter_sink_first & sdmem2block_converter_converter_first);
assign sdmem2block_converter_converter_source_last = (sdmem2block_converter_converter_sink_last & sdmem2block_converter_converter_last);
assign sdmem2block_converter_converter_sink_ready = (sdmem2block_converter_converter_last & sdmem2block_converter_converter_source_ready);
always @(*) begin
    sdmem2block_converter_converter_source_payload_data <= 8'd0;
    case (sdmem2block_converter_converter_mux)
        1'd0: begin
            sdmem2block_converter_converter_source_payload_data <= sdmem2block_converter_converter_sink_payload_data[31:24];
        end
        1'd1: begin
            sdmem2block_converter_converter_source_payload_data <= sdmem2block_converter_converter_sink_payload_data[23:16];
        end
        2'd2: begin
            sdmem2block_converter_converter_source_payload_data <= sdmem2block_converter_converter_sink_payload_data[15:8];
        end
        default: begin
            sdmem2block_converter_converter_source_payload_data <= sdmem2block_converter_converter_sink_payload_data[7:0];
        end
    endcase
end
assign sdmem2block_converter_converter_source_payload_valid_token_count = sdmem2block_converter_converter_last;
assign sdmem2block_fifo_syncfifo_din = {sdmem2block_fifo_fifo_in_last, sdmem2block_fifo_fifo_in_first, sdmem2block_fifo_fifo_in_payload_data};
assign {sdmem2block_fifo_fifo_out_last, sdmem2block_fifo_fifo_out_first, sdmem2block_fifo_fifo_out_payload_data} = sdmem2block_fifo_syncfifo_dout;
assign sdmem2block_fifo_sink_ready = sdmem2block_fifo_syncfifo_writable;
assign sdmem2block_fifo_syncfifo_we = sdmem2block_fifo_sink_valid;
assign sdmem2block_fifo_fifo_in_first = sdmem2block_fifo_sink_first;
assign sdmem2block_fifo_fifo_in_last = sdmem2block_fifo_sink_last;
assign sdmem2block_fifo_fifo_in_payload_data = sdmem2block_fifo_sink_payload_data;
assign sdmem2block_fifo_source_valid = sdmem2block_fifo_readable;
assign sdmem2block_fifo_source_first = sdmem2block_fifo_fifo_out_first;
assign sdmem2block_fifo_source_last = sdmem2block_fifo_fifo_out_last;
assign sdmem2block_fifo_source_payload_data = sdmem2block_fifo_fifo_out_payload_data;
assign sdmem2block_fifo_re = sdmem2block_fifo_source_ready;
assign sdmem2block_fifo_syncfifo_re = (sdmem2block_fifo_syncfifo_readable & ((~sdmem2block_fifo_readable) | sdmem2block_fifo_re));
assign sdmem2block_fifo_level1 = (sdmem2block_fifo_level0 + sdmem2block_fifo_readable);
always @(*) begin
    sdmem2block_fifo_wrport_adr <= 9'd0;
    if (sdmem2block_fifo_replace) begin
        sdmem2block_fifo_wrport_adr <= (sdmem2block_fifo_produce - 1'd1);
    end else begin
        sdmem2block_fifo_wrport_adr <= sdmem2block_fifo_produce;
    end
end
assign sdmem2block_fifo_wrport_dat_w = sdmem2block_fifo_syncfifo_din;
assign sdmem2block_fifo_wrport_we = (sdmem2block_fifo_syncfifo_we & (sdmem2block_fifo_syncfifo_writable | sdmem2block_fifo_replace));
assign sdmem2block_fifo_do_read = (sdmem2block_fifo_syncfifo_readable & sdmem2block_fifo_syncfifo_re);
assign sdmem2block_fifo_rdport_adr = sdmem2block_fifo_consume;
assign sdmem2block_fifo_syncfifo_dout = sdmem2block_fifo_rdport_dat_r;
assign sdmem2block_fifo_rdport_re = sdmem2block_fifo_do_read;
assign sdmem2block_fifo_syncfifo_writable = (sdmem2block_fifo_level0 != 10'd512);
assign sdmem2block_fifo_syncfifo_readable = (sdmem2block_fifo_level0 != 1'd0);
assign eventmanager_card_detect0 = card_detect_status1;
assign eventmanager_card_detect1 = card_detect_pending;
always @(*) begin
    card_detect_clear <= 1'd0;
    if ((eventmanager_pending_re & eventmanager_pending_r[0])) begin
        card_detect_clear <= 1'd1;
    end
end
assign eventmanager_block2mem_dma0 = block2mem_dma_status;
assign eventmanager_block2mem_dma1 = block2mem_dma_pending;
always @(*) begin
    block2mem_dma_clear <= 1'd0;
    if ((eventmanager_pending_re & eventmanager_pending_r[1])) begin
        block2mem_dma_clear <= 1'd1;
    end
end
assign eventmanager_mem2block_dma0 = mem2block_dma_status;
assign eventmanager_mem2block_dma1 = mem2block_dma_pending;
always @(*) begin
    mem2block_dma_clear <= 1'd0;
    if ((eventmanager_pending_re & eventmanager_pending_r[2])) begin
        mem2block_dma_clear <= 1'd1;
    end
end
assign eventmanager_cmd_done0 = cmd_done_status;
assign eventmanager_cmd_done1 = cmd_done_pending;
always @(*) begin
    cmd_done_clear <= 1'd0;
    if ((eventmanager_pending_re & eventmanager_pending_r[3])) begin
        cmd_done_clear <= 1'd1;
    end
end
assign sdirq_irq = ((((eventmanager_pending_status[0] & eventmanager_enable_storage[0]) | (eventmanager_pending_status[1] & eventmanager_enable_storage[1])) | (eventmanager_pending_status[2] & eventmanager_enable_storage[2])) | (eventmanager_pending_status[3] & eventmanager_enable_storage[3]));
assign card_detect_status1 = 1'd0;
assign block2mem_dma_status = 1'd0;
assign mem2block_dma_status = 1'd0;
assign cmd_done_status = cmd_done_trigger;
assign cmd_done_pending = cmd_done_trigger;
always @(*) begin
    builder_soclinux_we_wishbone2csr_next_value2 <= 1'd0;
    builder_soclinux_we_wishbone2csr_next_value_ce2 <= 1'd0;
    builder_soclinux_wishbone_dat_r <= 32'd0;
    builder_soclinux_wishbone2csr_next_state <= 2'd0;
    builder_soclinux_dat_w_wishbone2csr_next_value0 <= 32'd0;
    builder_soclinux_dat_w_wishbone2csr_next_value_ce0 <= 1'd0;
    builder_soclinux_wishbone_ack <= 1'd0;
    builder_soclinux_adr_wishbone2csr_next_value1 <= 14'd0;
    builder_soclinux_adr_wishbone2csr_next_value_ce1 <= 1'd0;
    builder_soclinux_wishbone2csr_next_state <= builder_soclinux_wishbone2csr_state;
    case (builder_soclinux_wishbone2csr_state)
        1'd1: begin
            builder_soclinux_adr_wishbone2csr_next_value1 <= 1'd0;
            builder_soclinux_adr_wishbone2csr_next_value_ce1 <= 1'd1;
            builder_soclinux_we_wishbone2csr_next_value2 <= 1'd0;
            builder_soclinux_we_wishbone2csr_next_value_ce2 <= 1'd1;
            builder_soclinux_wishbone2csr_next_state <= 2'd2;
        end
        2'd2: begin
            builder_soclinux_wishbone_ack <= 1'd1;
            builder_soclinux_wishbone_dat_r <= builder_soclinux_dat_r;
            builder_soclinux_wishbone2csr_next_state <= 1'd0;
        end
        default: begin
            builder_soclinux_dat_w_wishbone2csr_next_value0 <= builder_soclinux_wishbone_dat_w;
            builder_soclinux_dat_w_wishbone2csr_next_value_ce0 <= 1'd1;
            if ((builder_soclinux_wishbone_cyc & builder_soclinux_wishbone_stb)) begin
                builder_soclinux_adr_wishbone2csr_next_value1 <= builder_soclinux_wishbone_adr;
                builder_soclinux_adr_wishbone2csr_next_value_ce1 <= 1'd1;
                builder_soclinux_we_wishbone2csr_next_value2 <= (builder_soclinux_wishbone_we & (builder_soclinux_wishbone_sel != 1'd0));
                builder_soclinux_we_wishbone2csr_next_value_ce2 <= 1'd1;
                builder_soclinux_wishbone2csr_next_state <= 1'd1;
            end
        end
    endcase
end
assign builder_csr_bankarray_csrbank0_sel = (builder_csr_bankarray_interface0_bank_bus_adr[13:9] == 1'd0);
assign builder_csr_bankarray_csrbank0_reset0_r = builder_csr_bankarray_interface0_bank_bus_dat_w[1:0];
always @(*) begin
    builder_csr_bankarray_csrbank0_reset0_we <= 1'd0;
    builder_csr_bankarray_csrbank0_reset0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank0_sel & (builder_csr_bankarray_interface0_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank0_reset0_re <= builder_csr_bankarray_interface0_bank_bus_we;
        builder_csr_bankarray_csrbank0_reset0_we <= (~builder_csr_bankarray_interface0_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank0_scratch0_r = builder_csr_bankarray_interface0_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank0_scratch0_re <= 1'd0;
    builder_csr_bankarray_csrbank0_scratch0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank0_sel & (builder_csr_bankarray_interface0_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank0_scratch0_re <= builder_csr_bankarray_interface0_bank_bus_we;
        builder_csr_bankarray_csrbank0_scratch0_we <= (~builder_csr_bankarray_interface0_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank0_bus_errors_r = builder_csr_bankarray_interface0_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank0_bus_errors_we <= 1'd0;
    builder_csr_bankarray_csrbank0_bus_errors_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank0_sel & (builder_csr_bankarray_interface0_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank0_bus_errors_re <= builder_csr_bankarray_interface0_bank_bus_we;
        builder_csr_bankarray_csrbank0_bus_errors_we <= (~builder_csr_bankarray_interface0_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_sel = (builder_csr_bankarray_interface1_bank_bus_adr[13:9] == 1'd1);
assign builder_csr_bankarray_csrbank1_rst0_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank1_rst0_re <= 1'd0;
    builder_csr_bankarray_csrbank1_rst0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank1_rst0_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_rst0_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_en_vtc0_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank1_en_vtc0_we <= 1'd0;
    builder_csr_bankarray_csrbank1_en_vtc0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank1_en_vtc0_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_en_vtc0_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_half_sys8x_taps_r = builder_csr_bankarray_interface1_bank_bus_dat_w[8:0];
always @(*) begin
    builder_csr_bankarray_csrbank1_half_sys8x_taps_re <= 1'd0;
    builder_csr_bankarray_csrbank1_half_sys8x_taps_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank1_half_sys8x_taps_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_half_sys8x_taps_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_wlevel_en0_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank1_wlevel_en0_re <= 1'd0;
    builder_csr_bankarray_csrbank1_wlevel_en0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank1_wlevel_en0_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_wlevel_en0_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_wlevel_strobe_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_wlevel_strobe_re <= 1'd0;
    main_usddrphy_wlevel_strobe_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 3'd4))) begin
        main_usddrphy_wlevel_strobe_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_wlevel_strobe_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_cdly_rst_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_cdly_rst_re <= 1'd0;
    main_usddrphy_cdly_rst_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 3'd5))) begin
        main_usddrphy_cdly_rst_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_cdly_rst_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_cdly_inc_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_cdly_inc_we <= 1'd0;
    main_usddrphy_cdly_inc_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 3'd6))) begin
        main_usddrphy_cdly_inc_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_cdly_inc_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_cdly_value_r = builder_csr_bankarray_interface1_bank_bus_dat_w[8:0];
always @(*) begin
    builder_csr_bankarray_csrbank1_cdly_value_we <= 1'd0;
    builder_csr_bankarray_csrbank1_cdly_value_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 3'd7))) begin
        builder_csr_bankarray_csrbank1_cdly_value_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_cdly_value_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_dly_sel0_r = builder_csr_bankarray_interface1_bank_bus_dat_w[7:0];
always @(*) begin
    builder_csr_bankarray_csrbank1_dly_sel0_we <= 1'd0;
    builder_csr_bankarray_csrbank1_dly_sel0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd8))) begin
        builder_csr_bankarray_csrbank1_dly_sel0_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_dly_sel0_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_rdly_dq_rst_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_rdly_dq_rst_re <= 1'd0;
    main_usddrphy_rdly_dq_rst_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd9))) begin
        main_usddrphy_rdly_dq_rst_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_rdly_dq_rst_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_rdly_dq_inc_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_rdly_dq_inc_re <= 1'd0;
    main_usddrphy_rdly_dq_inc_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd10))) begin
        main_usddrphy_rdly_dq_inc_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_rdly_dq_inc_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_rdly_dq_bitslip_rst_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_rdly_dq_bitslip_rst_re <= 1'd0;
    main_usddrphy_rdly_dq_bitslip_rst_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd11))) begin
        main_usddrphy_rdly_dq_bitslip_rst_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_rdly_dq_bitslip_rst_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_rdly_dq_bitslip_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_rdly_dq_bitslip_we <= 1'd0;
    main_usddrphy_rdly_dq_bitslip_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd12))) begin
        main_usddrphy_rdly_dq_bitslip_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_rdly_dq_bitslip_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_wdly_dq_rst_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_wdly_dq_rst_we <= 1'd0;
    main_usddrphy_wdly_dq_rst_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd13))) begin
        main_usddrphy_wdly_dq_rst_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_wdly_dq_rst_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_wdly_dq_inc_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_wdly_dq_inc_we <= 1'd0;
    main_usddrphy_wdly_dq_inc_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd14))) begin
        main_usddrphy_wdly_dq_inc_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_wdly_dq_inc_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_wdly_dqs_rst_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_wdly_dqs_rst_we <= 1'd0;
    main_usddrphy_wdly_dqs_rst_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 4'd15))) begin
        main_usddrphy_wdly_dqs_rst_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_wdly_dqs_rst_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_wdly_dqs_inc_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_wdly_dqs_inc_re <= 1'd0;
    main_usddrphy_wdly_dqs_inc_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 5'd16))) begin
        main_usddrphy_wdly_dqs_inc_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_wdly_dqs_inc_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_r = builder_csr_bankarray_interface1_bank_bus_dat_w[8:0];
always @(*) begin
    builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_re <= 1'd0;
    builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 5'd17))) begin
        builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_wdly_dq_bitslip_rst_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_wdly_dq_bitslip_rst_re <= 1'd0;
    main_usddrphy_wdly_dq_bitslip_rst_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 5'd18))) begin
        main_usddrphy_wdly_dq_bitslip_rst_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_wdly_dq_bitslip_rst_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign main_usddrphy_wdly_dq_bitslip_r = builder_csr_bankarray_interface1_bank_bus_dat_w[0];
always @(*) begin
    main_usddrphy_wdly_dq_bitslip_re <= 1'd0;
    main_usddrphy_wdly_dq_bitslip_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 5'd19))) begin
        main_usddrphy_wdly_dq_bitslip_re <= builder_csr_bankarray_interface1_bank_bus_we;
        main_usddrphy_wdly_dq_bitslip_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_rdphase0_r = builder_csr_bankarray_interface1_bank_bus_dat_w[1:0];
always @(*) begin
    builder_csr_bankarray_csrbank1_rdphase0_we <= 1'd0;
    builder_csr_bankarray_csrbank1_rdphase0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 5'd20))) begin
        builder_csr_bankarray_csrbank1_rdphase0_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_rdphase0_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_wrphase0_r = builder_csr_bankarray_interface1_bank_bus_dat_w[1:0];
always @(*) begin
    builder_csr_bankarray_csrbank1_wrphase0_we <= 1'd0;
    builder_csr_bankarray_csrbank1_wrphase0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank1_sel & (builder_csr_bankarray_interface1_bank_bus_adr[8:0] == 5'd21))) begin
        builder_csr_bankarray_csrbank1_wrphase0_re <= builder_csr_bankarray_interface1_bank_bus_we;
        builder_csr_bankarray_csrbank1_wrphase0_we <= (~builder_csr_bankarray_interface1_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank1_rst0_w = main_usddrphy_rst_storage;
assign builder_csr_bankarray_csrbank1_en_vtc0_w = main_usddrphy_en_vtc_storage;
assign builder_csr_bankarray_csrbank1_half_sys8x_taps_w = main_usddrphy_half_sys8x_taps_status[8:0];
assign main_usddrphy_half_sys8x_taps_we = builder_csr_bankarray_csrbank1_half_sys8x_taps_we;
assign builder_csr_bankarray_csrbank1_wlevel_en0_w = main_usddrphy_wlevel_en_storage;
assign builder_csr_bankarray_csrbank1_cdly_value_w = main_usddrphy_cdly_value_status[8:0];
assign main_usddrphy_cdly_value_we = builder_csr_bankarray_csrbank1_cdly_value_we;
assign builder_csr_bankarray_csrbank1_dly_sel0_w = main_usddrphy_dly_sel_storage[7:0];
assign builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_w = main_usddrphy_wdly_dqs_inc_count_status[8:0];
assign main_usddrphy_wdly_dqs_inc_count_we = builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_we;
assign builder_csr_bankarray_csrbank1_rdphase0_w = main_usddrphy_rdphase_storage[1:0];
assign builder_csr_bankarray_csrbank1_wrphase0_w = main_usddrphy_wrphase_storage[1:0];
assign builder_csr_bankarray_csrbank2_sel = (builder_csr_bankarray_interface2_bank_bus_adr[13:9] == 3'd4);
assign builder_csr_bankarray_csrbank2_sram_writer_slot_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_writer_slot_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_writer_slot_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank2_sram_writer_slot_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_writer_slot_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_writer_length_r = builder_csr_bankarray_interface2_bank_bus_dat_w[10:0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_writer_length_we <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_writer_length_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank2_sram_writer_length_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_writer_length_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_writer_errors_r = builder_csr_bankarray_interface2_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_writer_errors_we <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_writer_errors_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank2_sram_writer_errors_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_writer_errors_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_writer_ev_status_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_writer_ev_status_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_writer_ev_status_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank2_sram_writer_ev_status_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_writer_ev_status_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_writer_ev_pending_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_writer_ev_pending_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_writer_ev_pending_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 3'd4))) begin
        builder_csr_bankarray_csrbank2_sram_writer_ev_pending_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_writer_ev_pending_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_we <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 3'd5))) begin
        builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign main_ethmac_start_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    main_ethmac_start_re <= 1'd0;
    main_ethmac_start_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 3'd6))) begin
        main_ethmac_start_re <= builder_csr_bankarray_interface2_bank_bus_we;
        main_ethmac_start_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_reader_ready_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_reader_ready_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_reader_ready_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 3'd7))) begin
        builder_csr_bankarray_csrbank2_sram_reader_ready_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_reader_ready_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_reader_level_r = builder_csr_bankarray_interface2_bank_bus_dat_w[1:0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_reader_level_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_reader_level_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd8))) begin
        builder_csr_bankarray_csrbank2_sram_reader_level_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_reader_level_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_reader_slot0_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_reader_slot0_we <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_reader_slot0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd9))) begin
        builder_csr_bankarray_csrbank2_sram_reader_slot0_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_reader_slot0_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_reader_length0_r = builder_csr_bankarray_interface2_bank_bus_dat_w[10:0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_reader_length0_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_reader_length0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd10))) begin
        builder_csr_bankarray_csrbank2_sram_reader_length0_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_reader_length0_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_reader_ev_status_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_reader_ev_status_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_reader_ev_status_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd11))) begin
        builder_csr_bankarray_csrbank2_sram_reader_ev_status_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_reader_ev_status_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_reader_ev_pending_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_reader_ev_pending_we <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_reader_ev_pending_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd12))) begin
        builder_csr_bankarray_csrbank2_sram_reader_ev_pending_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_reader_ev_pending_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_re <= 1'd0;
    builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd13))) begin
        builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_preamble_crc_r = builder_csr_bankarray_interface2_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank2_preamble_crc_re <= 1'd0;
    builder_csr_bankarray_csrbank2_preamble_crc_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd14))) begin
        builder_csr_bankarray_csrbank2_preamble_crc_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_preamble_crc_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_r = builder_csr_bankarray_interface2_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_we <= 1'd0;
    builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 4'd15))) begin
        builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_r = builder_csr_bankarray_interface2_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_we <= 1'd0;
    builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank2_sel & (builder_csr_bankarray_interface2_bank_bus_adr[8:0] == 5'd16))) begin
        builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_re <= builder_csr_bankarray_interface2_bank_bus_we;
        builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_we <= (~builder_csr_bankarray_interface2_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank2_sram_writer_slot_w = main_ethmac_sram7_status;
assign main_ethmac_sram8_we = builder_csr_bankarray_csrbank2_sram_writer_slot_we;
assign builder_csr_bankarray_csrbank2_sram_writer_length_w = main_ethmac_sram10_status[10:0];
assign main_ethmac_sram11_we = builder_csr_bankarray_csrbank2_sram_writer_length_we;
assign builder_csr_bankarray_csrbank2_sram_writer_errors_w = main_ethmac_sram13_status[31:0];
assign main_ethmac_sram14_we = builder_csr_bankarray_csrbank2_sram_writer_errors_we;
assign main_ethmac_sram22_status = main_ethmac_sram21_available;
assign builder_csr_bankarray_csrbank2_sram_writer_ev_status_w = main_ethmac_sram22_status;
assign main_ethmac_sram23_we = builder_csr_bankarray_csrbank2_sram_writer_ev_status_we;
assign main_ethmac_sram26_status = main_ethmac_sram25_available;
assign builder_csr_bankarray_csrbank2_sram_writer_ev_pending_w = main_ethmac_sram26_status;
assign main_ethmac_sram27_we = builder_csr_bankarray_csrbank2_sram_writer_ev_pending_we;
assign main_ethmac_sram30_available = main_ethmac_sram31_storage;
assign builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_w = main_ethmac_sram31_storage;
assign builder_csr_bankarray_csrbank2_sram_reader_ready_w = main_ethmac_sram94_status;
assign main_ethmac_sram95_we = builder_csr_bankarray_csrbank2_sram_reader_ready_we;
assign builder_csr_bankarray_csrbank2_sram_reader_level_w = main_ethmac_sram97_status[1:0];
assign main_ethmac_sram98_we = builder_csr_bankarray_csrbank2_sram_reader_level_we;
assign builder_csr_bankarray_csrbank2_sram_reader_slot0_w = main_ethmac_sram100_storage;
assign builder_csr_bankarray_csrbank2_sram_reader_length0_w = main_ethmac_sram102_storage[10:0];
assign main_ethmac_sram110_status = main_ethmac_sram109_event0;
assign builder_csr_bankarray_csrbank2_sram_reader_ev_status_w = main_ethmac_sram110_status;
assign main_ethmac_sram111_we = builder_csr_bankarray_csrbank2_sram_reader_ev_status_we;
assign main_ethmac_sram114_status = main_ethmac_sram113_event0;
assign builder_csr_bankarray_csrbank2_sram_reader_ev_pending_w = main_ethmac_sram114_status;
assign main_ethmac_sram115_we = builder_csr_bankarray_csrbank2_sram_reader_ev_pending_we;
assign main_ethmac_sram118_event0 = main_ethmac_sram119_storage;
assign builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_w = main_ethmac_sram119_storage;
assign builder_csr_bankarray_csrbank2_preamble_crc_w = main_ethmac_status;
assign main_ethmac_we = builder_csr_bankarray_csrbank2_preamble_crc_we;
assign builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_w = main_ethmac_preamble_errors_status[31:0];
assign main_ethmac_preamble_errors_we = builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_we;
assign builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_w = main_ethmac_crc_errors_status[31:0];
assign main_ethmac_crc_errors_we = builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_we;
assign builder_csr_bankarray_csrbank3_sel = (builder_csr_bankarray_interface3_bank_bus_adr[13:9] == 3'd5);
assign builder_csr_bankarray_csrbank3_crg_reset0_r = builder_csr_bankarray_interface3_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank3_crg_reset0_we <= 1'd0;
    builder_csr_bankarray_csrbank3_crg_reset0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank3_sel & (builder_csr_bankarray_interface3_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank3_crg_reset0_re <= builder_csr_bankarray_interface3_bank_bus_we;
        builder_csr_bankarray_csrbank3_crg_reset0_we <= (~builder_csr_bankarray_interface3_bank_bus_we);
    end
end
assign builder_csr_bankarray_sel = (builder_csr_bankarray_sram_bus_adr[13:9] == 3'd6);
always @(*) begin
    builder_csr_bankarray_sram_bus_dat_r <= 32'd0;
    if (builder_csr_bankarray_sel_r) begin
        builder_csr_bankarray_sram_bus_dat_r <= builder_csr_bankarray_dat_r;
    end
end
assign builder_csr_bankarray_adr = builder_csr_bankarray_sram_bus_adr[4:0];
assign builder_csr_bankarray_csrbank4_sel = (builder_csr_bankarray_interface4_bank_bus_adr[13:9] == 3'd7);
assign builder_csr_bankarray_csrbank4_out0_r = builder_csr_bankarray_interface4_bank_bus_dat_w[7:0];
always @(*) begin
    builder_csr_bankarray_csrbank4_out0_we <= 1'd0;
    builder_csr_bankarray_csrbank4_out0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank4_sel & (builder_csr_bankarray_interface4_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank4_out0_re <= builder_csr_bankarray_interface4_bank_bus_we;
        builder_csr_bankarray_csrbank4_out0_we <= (~builder_csr_bankarray_interface4_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank4_out0_w = main_storage[7:0];
assign builder_csr_bankarray_csrbank5_sel = (builder_csr_bankarray_interface5_bank_bus_adr[13:9] == 4'd8);
assign builder_csr_bankarray_csrbank5_dma_base1_r = builder_csr_bankarray_interface5_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank5_dma_base1_we <= 1'd0;
    builder_csr_bankarray_csrbank5_dma_base1_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank5_sel & (builder_csr_bankarray_interface5_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank5_dma_base1_re <= builder_csr_bankarray_interface5_bank_bus_we;
        builder_csr_bankarray_csrbank5_dma_base1_we <= (~builder_csr_bankarray_interface5_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank5_dma_base0_r = builder_csr_bankarray_interface5_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank5_dma_base0_re <= 1'd0;
    builder_csr_bankarray_csrbank5_dma_base0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank5_sel & (builder_csr_bankarray_interface5_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank5_dma_base0_re <= builder_csr_bankarray_interface5_bank_bus_we;
        builder_csr_bankarray_csrbank5_dma_base0_we <= (~builder_csr_bankarray_interface5_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank5_dma_length0_r = builder_csr_bankarray_interface5_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank5_dma_length0_we <= 1'd0;
    builder_csr_bankarray_csrbank5_dma_length0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank5_sel & (builder_csr_bankarray_interface5_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank5_dma_length0_re <= builder_csr_bankarray_interface5_bank_bus_we;
        builder_csr_bankarray_csrbank5_dma_length0_we <= (~builder_csr_bankarray_interface5_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank5_dma_enable0_r = builder_csr_bankarray_interface5_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank5_dma_enable0_re <= 1'd0;
    builder_csr_bankarray_csrbank5_dma_enable0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank5_sel & (builder_csr_bankarray_interface5_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank5_dma_enable0_re <= builder_csr_bankarray_interface5_bank_bus_we;
        builder_csr_bankarray_csrbank5_dma_enable0_we <= (~builder_csr_bankarray_interface5_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank5_dma_done_r = builder_csr_bankarray_interface5_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank5_dma_done_re <= 1'd0;
    builder_csr_bankarray_csrbank5_dma_done_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank5_sel & (builder_csr_bankarray_interface5_bank_bus_adr[8:0] == 3'd4))) begin
        builder_csr_bankarray_csrbank5_dma_done_re <= builder_csr_bankarray_interface5_bank_bus_we;
        builder_csr_bankarray_csrbank5_dma_done_we <= (~builder_csr_bankarray_interface5_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank5_dma_loop0_r = builder_csr_bankarray_interface5_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank5_dma_loop0_we <= 1'd0;
    builder_csr_bankarray_csrbank5_dma_loop0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank5_sel & (builder_csr_bankarray_interface5_bank_bus_adr[8:0] == 3'd5))) begin
        builder_csr_bankarray_csrbank5_dma_loop0_re <= builder_csr_bankarray_interface5_bank_bus_we;
        builder_csr_bankarray_csrbank5_dma_loop0_we <= (~builder_csr_bankarray_interface5_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank5_dma_offset_r = builder_csr_bankarray_interface5_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank5_dma_offset_re <= 1'd0;
    builder_csr_bankarray_csrbank5_dma_offset_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank5_sel & (builder_csr_bankarray_interface5_bank_bus_adr[8:0] == 3'd6))) begin
        builder_csr_bankarray_csrbank5_dma_offset_re <= builder_csr_bankarray_interface5_bank_bus_we;
        builder_csr_bankarray_csrbank5_dma_offset_we <= (~builder_csr_bankarray_interface5_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank5_dma_base1_w = sdblock2mem_wishbonedmawriter_base_storage[63:32];
assign builder_csr_bankarray_csrbank5_dma_base0_w = sdblock2mem_wishbonedmawriter_base_storage[31:0];
assign builder_csr_bankarray_csrbank5_dma_length0_w = sdblock2mem_wishbonedmawriter_length_storage[31:0];
assign builder_csr_bankarray_csrbank5_dma_enable0_w = sdblock2mem_wishbonedmawriter_enable_storage;
assign builder_csr_bankarray_csrbank5_dma_done_w = sdblock2mem_wishbonedmawriter_done_status;
assign sdblock2mem_wishbonedmawriter_done_we = builder_csr_bankarray_csrbank5_dma_done_we;
assign builder_csr_bankarray_csrbank5_dma_loop0_w = sdblock2mem_wishbonedmawriter_loop_storage;
assign builder_csr_bankarray_csrbank5_dma_offset_w = sdblock2mem_wishbonedmawriter_offset_status[31:0];
assign sdblock2mem_wishbonedmawriter_offset_we = builder_csr_bankarray_csrbank5_dma_offset_we;
assign builder_csr_bankarray_csrbank6_sel = (builder_csr_bankarray_interface6_bank_bus_adr[13:9] == 4'd9);
assign builder_csr_bankarray_csrbank6_cmd_argument0_r = builder_csr_bankarray_interface6_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_argument0_re <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_argument0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank6_cmd_argument0_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_argument0_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_command0_r = builder_csr_bankarray_interface6_bank_bus_dat_w[13:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_command0_we <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_command0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank6_cmd_command0_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_command0_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_send0_r = builder_csr_bankarray_interface6_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_send0_re <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_send0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank6_cmd_send0_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_send0_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_response3_r = builder_csr_bankarray_interface6_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_response3_re <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_response3_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank6_cmd_response3_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_response3_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_response2_r = builder_csr_bankarray_interface6_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_response2_we <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_response2_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 3'd4))) begin
        builder_csr_bankarray_csrbank6_cmd_response2_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_response2_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_response1_r = builder_csr_bankarray_interface6_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_response1_we <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_response1_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 3'd5))) begin
        builder_csr_bankarray_csrbank6_cmd_response1_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_response1_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_response0_r = builder_csr_bankarray_interface6_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_response0_re <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_response0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 3'd6))) begin
        builder_csr_bankarray_csrbank6_cmd_response0_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_response0_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_event_r = builder_csr_bankarray_interface6_bank_bus_dat_w[3:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_cmd_event_re <= 1'd0;
    builder_csr_bankarray_csrbank6_cmd_event_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 3'd7))) begin
        builder_csr_bankarray_csrbank6_cmd_event_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_cmd_event_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_data_event_r = builder_csr_bankarray_interface6_bank_bus_dat_w[3:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_data_event_we <= 1'd0;
    builder_csr_bankarray_csrbank6_data_event_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 4'd8))) begin
        builder_csr_bankarray_csrbank6_data_event_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_data_event_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_block_length0_r = builder_csr_bankarray_interface6_bank_bus_dat_w[9:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_block_length0_we <= 1'd0;
    builder_csr_bankarray_csrbank6_block_length0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 4'd9))) begin
        builder_csr_bankarray_csrbank6_block_length0_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_block_length0_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_block_count0_r = builder_csr_bankarray_interface6_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank6_block_count0_re <= 1'd0;
    builder_csr_bankarray_csrbank6_block_count0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank6_sel & (builder_csr_bankarray_interface6_bank_bus_adr[8:0] == 4'd10))) begin
        builder_csr_bankarray_csrbank6_block_count0_re <= builder_csr_bankarray_interface6_bank_bus_we;
        builder_csr_bankarray_csrbank6_block_count0_we <= (~builder_csr_bankarray_interface6_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank6_cmd_argument0_w = sdcore_cmd_argument_storage[31:0];
assign sdcore_csrfield_cmd_type = sdcore_cmd_command_storage[1:0];
assign sdcore_csrfield_data_type = sdcore_cmd_command_storage[6:5];
assign sdcore_csrfield_cmd = sdcore_cmd_command_storage[13:8];
assign builder_csr_bankarray_csrbank6_cmd_command0_w = sdcore_cmd_command_storage[13:0];
assign builder_csr_bankarray_csrbank6_cmd_send0_w = sdcore_cmd_send_storage;
assign builder_csr_bankarray_csrbank6_cmd_response3_w = sdcore_cmd_response_status[127:96];
assign builder_csr_bankarray_csrbank6_cmd_response2_w = sdcore_cmd_response_status[95:64];
assign builder_csr_bankarray_csrbank6_cmd_response1_w = sdcore_cmd_response_status[63:32];
assign builder_csr_bankarray_csrbank6_cmd_response0_w = sdcore_cmd_response_status[31:0];
assign sdcore_cmd_response_we = builder_csr_bankarray_csrbank6_cmd_response0_we;
always @(*) begin
    sdcore_cmd_event_status <= 4'd0;
    sdcore_cmd_event_status[0] <= sdcore_csrfield_done0;
    sdcore_cmd_event_status[1] <= sdcore_csrfield_error0;
    sdcore_cmd_event_status[2] <= sdcore_csrfield_timeout0;
    sdcore_cmd_event_status[3] <= sdcore_csrfield_crc0;
end
assign builder_csr_bankarray_csrbank6_cmd_event_w = sdcore_cmd_event_status[3:0];
assign sdcore_cmd_event_we = builder_csr_bankarray_csrbank6_cmd_event_we;
always @(*) begin
    sdcore_data_event_status <= 4'd0;
    sdcore_data_event_status[0] <= sdcore_csrfield_done1;
    sdcore_data_event_status[1] <= sdcore_csrfield_error1;
    sdcore_data_event_status[2] <= sdcore_csrfield_timeout1;
    sdcore_data_event_status[3] <= sdcore_csrfield_crc1;
end
assign builder_csr_bankarray_csrbank6_data_event_w = sdcore_data_event_status[3:0];
assign sdcore_data_event_we = builder_csr_bankarray_csrbank6_data_event_we;
assign builder_csr_bankarray_csrbank6_block_length0_w = sdcore_block_length_storage[9:0];
assign builder_csr_bankarray_csrbank6_block_count0_w = sdcore_block_count_storage[31:0];
assign builder_csr_bankarray_csrbank7_sel = (builder_csr_bankarray_interface7_bank_bus_adr[13:9] == 4'd10);
assign builder_csr_bankarray_csrbank7_status_r = builder_csr_bankarray_interface7_bank_bus_dat_w[3:0];
always @(*) begin
    builder_csr_bankarray_csrbank7_status_re <= 1'd0;
    builder_csr_bankarray_csrbank7_status_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank7_sel & (builder_csr_bankarray_interface7_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank7_status_re <= builder_csr_bankarray_interface7_bank_bus_we;
        builder_csr_bankarray_csrbank7_status_we <= (~builder_csr_bankarray_interface7_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank7_pending_r = builder_csr_bankarray_interface7_bank_bus_dat_w[3:0];
always @(*) begin
    builder_csr_bankarray_csrbank7_pending_re <= 1'd0;
    builder_csr_bankarray_csrbank7_pending_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank7_sel & (builder_csr_bankarray_interface7_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank7_pending_re <= builder_csr_bankarray_interface7_bank_bus_we;
        builder_csr_bankarray_csrbank7_pending_we <= (~builder_csr_bankarray_interface7_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank7_enable0_r = builder_csr_bankarray_interface7_bank_bus_dat_w[3:0];
always @(*) begin
    builder_csr_bankarray_csrbank7_enable0_we <= 1'd0;
    builder_csr_bankarray_csrbank7_enable0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank7_sel & (builder_csr_bankarray_interface7_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank7_enable0_re <= builder_csr_bankarray_interface7_bank_bus_we;
        builder_csr_bankarray_csrbank7_enable0_we <= (~builder_csr_bankarray_interface7_bank_bus_we);
    end
end
always @(*) begin
    eventmanager_status_status <= 4'd0;
    eventmanager_status_status[0] <= eventmanager_card_detect0;
    eventmanager_status_status[1] <= eventmanager_block2mem_dma0;
    eventmanager_status_status[2] <= eventmanager_mem2block_dma0;
    eventmanager_status_status[3] <= eventmanager_cmd_done0;
end
assign builder_csr_bankarray_csrbank7_status_w = eventmanager_status_status[3:0];
assign eventmanager_status_we = builder_csr_bankarray_csrbank7_status_we;
always @(*) begin
    eventmanager_pending_status <= 4'd0;
    eventmanager_pending_status[0] <= eventmanager_card_detect1;
    eventmanager_pending_status[1] <= eventmanager_block2mem_dma1;
    eventmanager_pending_status[2] <= eventmanager_mem2block_dma1;
    eventmanager_pending_status[3] <= eventmanager_cmd_done1;
end
assign builder_csr_bankarray_csrbank7_pending_w = eventmanager_pending_status[3:0];
assign eventmanager_pending_we = builder_csr_bankarray_csrbank7_pending_we;
assign eventmanager_card_detect2 = eventmanager_enable_storage[0];
assign eventmanager_block2mem_dma2 = eventmanager_enable_storage[1];
assign eventmanager_mem2block_dma2 = eventmanager_enable_storage[2];
assign eventmanager_cmd_done2 = eventmanager_enable_storage[3];
assign builder_csr_bankarray_csrbank7_enable0_w = eventmanager_enable_storage[3:0];
assign builder_csr_bankarray_csrbank8_sel = (builder_csr_bankarray_interface8_bank_bus_adr[13:9] == 4'd11);
assign builder_csr_bankarray_csrbank8_dma_base1_r = builder_csr_bankarray_interface8_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank8_dma_base1_we <= 1'd0;
    builder_csr_bankarray_csrbank8_dma_base1_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank8_sel & (builder_csr_bankarray_interface8_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank8_dma_base1_re <= builder_csr_bankarray_interface8_bank_bus_we;
        builder_csr_bankarray_csrbank8_dma_base1_we <= (~builder_csr_bankarray_interface8_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank8_dma_base0_r = builder_csr_bankarray_interface8_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank8_dma_base0_re <= 1'd0;
    builder_csr_bankarray_csrbank8_dma_base0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank8_sel & (builder_csr_bankarray_interface8_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank8_dma_base0_re <= builder_csr_bankarray_interface8_bank_bus_we;
        builder_csr_bankarray_csrbank8_dma_base0_we <= (~builder_csr_bankarray_interface8_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank8_dma_length0_r = builder_csr_bankarray_interface8_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank8_dma_length0_re <= 1'd0;
    builder_csr_bankarray_csrbank8_dma_length0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank8_sel & (builder_csr_bankarray_interface8_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank8_dma_length0_re <= builder_csr_bankarray_interface8_bank_bus_we;
        builder_csr_bankarray_csrbank8_dma_length0_we <= (~builder_csr_bankarray_interface8_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank8_dma_enable0_r = builder_csr_bankarray_interface8_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank8_dma_enable0_we <= 1'd0;
    builder_csr_bankarray_csrbank8_dma_enable0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank8_sel & (builder_csr_bankarray_interface8_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank8_dma_enable0_re <= builder_csr_bankarray_interface8_bank_bus_we;
        builder_csr_bankarray_csrbank8_dma_enable0_we <= (~builder_csr_bankarray_interface8_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank8_dma_done_r = builder_csr_bankarray_interface8_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank8_dma_done_re <= 1'd0;
    builder_csr_bankarray_csrbank8_dma_done_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank8_sel & (builder_csr_bankarray_interface8_bank_bus_adr[8:0] == 3'd4))) begin
        builder_csr_bankarray_csrbank8_dma_done_re <= builder_csr_bankarray_interface8_bank_bus_we;
        builder_csr_bankarray_csrbank8_dma_done_we <= (~builder_csr_bankarray_interface8_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank8_dma_loop0_r = builder_csr_bankarray_interface8_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank8_dma_loop0_re <= 1'd0;
    builder_csr_bankarray_csrbank8_dma_loop0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank8_sel & (builder_csr_bankarray_interface8_bank_bus_adr[8:0] == 3'd5))) begin
        builder_csr_bankarray_csrbank8_dma_loop0_re <= builder_csr_bankarray_interface8_bank_bus_we;
        builder_csr_bankarray_csrbank8_dma_loop0_we <= (~builder_csr_bankarray_interface8_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank8_dma_offset_r = builder_csr_bankarray_interface8_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank8_dma_offset_we <= 1'd0;
    builder_csr_bankarray_csrbank8_dma_offset_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank8_sel & (builder_csr_bankarray_interface8_bank_bus_adr[8:0] == 3'd6))) begin
        builder_csr_bankarray_csrbank8_dma_offset_re <= builder_csr_bankarray_interface8_bank_bus_we;
        builder_csr_bankarray_csrbank8_dma_offset_we <= (~builder_csr_bankarray_interface8_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank8_dma_base1_w = sdmem2block_dma_base_storage[63:32];
assign builder_csr_bankarray_csrbank8_dma_base0_w = sdmem2block_dma_base_storage[31:0];
assign builder_csr_bankarray_csrbank8_dma_length0_w = sdmem2block_dma_length_storage[31:0];
assign builder_csr_bankarray_csrbank8_dma_enable0_w = sdmem2block_dma_enable_storage;
assign builder_csr_bankarray_csrbank8_dma_done_w = sdmem2block_dma_done_status;
assign sdmem2block_dma_done_we = builder_csr_bankarray_csrbank8_dma_done_we;
assign builder_csr_bankarray_csrbank8_dma_loop0_w = sdmem2block_dma_loop_storage;
assign builder_csr_bankarray_csrbank8_dma_offset_w = sdmem2block_dma_offset_status[31:0];
assign sdmem2block_dma_offset_we = builder_csr_bankarray_csrbank8_dma_offset_we;
assign builder_csr_bankarray_csrbank9_sel = (builder_csr_bankarray_interface9_bank_bus_adr[13:9] == 4'd12);
assign builder_csr_bankarray_csrbank9_card_detect_r = builder_csr_bankarray_interface9_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank9_card_detect_re <= 1'd0;
    builder_csr_bankarray_csrbank9_card_detect_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank9_sel & (builder_csr_bankarray_interface9_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank9_card_detect_re <= builder_csr_bankarray_interface9_bank_bus_we;
        builder_csr_bankarray_csrbank9_card_detect_we <= (~builder_csr_bankarray_interface9_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank9_clocker_divider0_r = builder_csr_bankarray_interface9_bank_bus_dat_w[8:0];
always @(*) begin
    builder_csr_bankarray_csrbank9_clocker_divider0_re <= 1'd0;
    builder_csr_bankarray_csrbank9_clocker_divider0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank9_sel & (builder_csr_bankarray_interface9_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank9_clocker_divider0_re <= builder_csr_bankarray_interface9_bank_bus_we;
        builder_csr_bankarray_csrbank9_clocker_divider0_we <= (~builder_csr_bankarray_interface9_bank_bus_we);
    end
end
assign init_initialize_r = builder_csr_bankarray_interface9_bank_bus_dat_w[0];
always @(*) begin
    init_initialize_re <= 1'd0;
    init_initialize_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank9_sel & (builder_csr_bankarray_interface9_bank_bus_adr[8:0] == 2'd2))) begin
        init_initialize_re <= builder_csr_bankarray_interface9_bank_bus_we;
        init_initialize_we <= (~builder_csr_bankarray_interface9_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank9_dataw_status_r = builder_csr_bankarray_interface9_bank_bus_dat_w[2:0];
always @(*) begin
    builder_csr_bankarray_csrbank9_dataw_status_we <= 1'd0;
    builder_csr_bankarray_csrbank9_dataw_status_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank9_sel & (builder_csr_bankarray_interface9_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank9_dataw_status_re <= builder_csr_bankarray_interface9_bank_bus_we;
        builder_csr_bankarray_csrbank9_dataw_status_we <= (~builder_csr_bankarray_interface9_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank9_card_detect_w = card_detect_status0;
assign card_detect_we = builder_csr_bankarray_csrbank9_card_detect_we;
assign builder_csr_bankarray_csrbank9_clocker_divider0_w = clocker_storage[8:0];
always @(*) begin
    dataw_status <= 3'd0;
    dataw_status[0] <= dataw_accepted0;
    dataw_status[1] <= dataw_crc_error0;
    dataw_status[2] <= dataw_write_error0;
end
assign builder_csr_bankarray_csrbank9_dataw_status_w = dataw_status[2:0];
assign dataw_we = builder_csr_bankarray_csrbank9_dataw_status_we;
assign builder_csr_bankarray_csrbank10_sel = (builder_csr_bankarray_interface10_bank_bus_adr[13:9] == 4'd13);
assign builder_csr_bankarray_csrbank10_dfii_control0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[3:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_control0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_control0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank10_dfii_control0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_control0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_command0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[7:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_command0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_command0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_command0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_command0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign main_sdram_phaseinjector0_command_issue_r = builder_csr_bankarray_interface10_bank_bus_dat_w[0];
always @(*) begin
    main_sdram_phaseinjector0_command_issue_re <= 1'd0;
    main_sdram_phaseinjector0_command_issue_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 2'd2))) begin
        main_sdram_phaseinjector0_command_issue_re <= builder_csr_bankarray_interface10_bank_bus_we;
        main_sdram_phaseinjector0_command_issue_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_address0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[14:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_address0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_address0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_address0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_address0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[2:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 3'd4))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 3'd5))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 3'd6))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 3'd7))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd8))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd9))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd10))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd11))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd12))) begin
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_command0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[7:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_command0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_command0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd13))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_command0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_command0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign main_sdram_phaseinjector1_command_issue_r = builder_csr_bankarray_interface10_bank_bus_dat_w[0];
always @(*) begin
    main_sdram_phaseinjector1_command_issue_we <= 1'd0;
    main_sdram_phaseinjector1_command_issue_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd14))) begin
        main_sdram_phaseinjector1_command_issue_re <= builder_csr_bankarray_interface10_bank_bus_we;
        main_sdram_phaseinjector1_command_issue_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_address0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[14:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_address0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_address0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 4'd15))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_address0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_address0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[2:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd16))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd17))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd18))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd19))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd20))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd21))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd22))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd23))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd24))) begin
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_command0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[7:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_command0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_command0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd25))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_command0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_command0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign main_sdram_phaseinjector2_command_issue_r = builder_csr_bankarray_interface10_bank_bus_dat_w[0];
always @(*) begin
    main_sdram_phaseinjector2_command_issue_we <= 1'd0;
    main_sdram_phaseinjector2_command_issue_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd26))) begin
        main_sdram_phaseinjector2_command_issue_re <= builder_csr_bankarray_interface10_bank_bus_we;
        main_sdram_phaseinjector2_command_issue_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_address0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[14:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_address0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_address0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd27))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_address0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_address0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[2:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd28))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd29))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd30))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 5'd31))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd32))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd33))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd34))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd35))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd36))) begin
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_command0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[7:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_command0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_command0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd37))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_command0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_command0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign main_sdram_phaseinjector3_command_issue_r = builder_csr_bankarray_interface10_bank_bus_dat_w[0];
always @(*) begin
    main_sdram_phaseinjector3_command_issue_re <= 1'd0;
    main_sdram_phaseinjector3_command_issue_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd38))) begin
        main_sdram_phaseinjector3_command_issue_re <= builder_csr_bankarray_interface10_bank_bus_we;
        main_sdram_phaseinjector3_command_issue_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_address0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[14:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_address0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_address0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd39))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_address0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_address0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[2:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd40))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd41))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd42))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd43))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd44))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd45))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_re <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd46))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd47))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_r = builder_csr_bankarray_interface10_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_we <= 1'd0;
    builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank10_sel & (builder_csr_bankarray_interface10_bank_bus_adr[8:0] == 6'd48))) begin
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_re <= builder_csr_bankarray_interface10_bank_bus_we;
        builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_we <= (~builder_csr_bankarray_interface10_bank_bus_we);
    end
end
assign main_sdram_sel = main_sdram_storage[0];
assign main_sdram_cke = main_sdram_storage[1];
assign main_sdram_odt = main_sdram_storage[2];
assign main_sdram_reset_n = main_sdram_storage[3];
assign builder_csr_bankarray_csrbank10_dfii_control0_w = main_sdram_storage[3:0];
assign main_sdram_phaseinjector0_csrfield_cs = main_sdram_phaseinjector0_command_storage[0];
assign main_sdram_phaseinjector0_csrfield_we = main_sdram_phaseinjector0_command_storage[1];
assign main_sdram_phaseinjector0_csrfield_cas = main_sdram_phaseinjector0_command_storage[2];
assign main_sdram_phaseinjector0_csrfield_ras = main_sdram_phaseinjector0_command_storage[3];
assign main_sdram_phaseinjector0_csrfield_wren = main_sdram_phaseinjector0_command_storage[4];
assign main_sdram_phaseinjector0_csrfield_rden = main_sdram_phaseinjector0_command_storage[5];
assign main_sdram_phaseinjector0_csrfield_cs_top = main_sdram_phaseinjector0_command_storage[6];
assign main_sdram_phaseinjector0_csrfield_cs_bottom = main_sdram_phaseinjector0_command_storage[7];
assign builder_csr_bankarray_csrbank10_dfii_pi0_command0_w = main_sdram_phaseinjector0_command_storage[7:0];
assign builder_csr_bankarray_csrbank10_dfii_pi0_address0_w = main_sdram_phaseinjector0_address_storage[14:0];
assign builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_w = main_sdram_phaseinjector0_baddress_storage[2:0];
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_w = main_sdram_phaseinjector0_wrdata_storage[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_w = main_sdram_phaseinjector0_wrdata_storage[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_w = main_sdram_phaseinjector0_wrdata_storage[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_w = main_sdram_phaseinjector0_wrdata_storage[31:0];
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_w = main_sdram_phaseinjector0_rddata_status[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_w = main_sdram_phaseinjector0_rddata_status[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_w = main_sdram_phaseinjector0_rddata_status[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_w = main_sdram_phaseinjector0_rddata_status[31:0];
assign main_sdram_phaseinjector0_rddata_we = builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_we;
assign main_sdram_phaseinjector1_csrfield_cs = main_sdram_phaseinjector1_command_storage[0];
assign main_sdram_phaseinjector1_csrfield_we = main_sdram_phaseinjector1_command_storage[1];
assign main_sdram_phaseinjector1_csrfield_cas = main_sdram_phaseinjector1_command_storage[2];
assign main_sdram_phaseinjector1_csrfield_ras = main_sdram_phaseinjector1_command_storage[3];
assign main_sdram_phaseinjector1_csrfield_wren = main_sdram_phaseinjector1_command_storage[4];
assign main_sdram_phaseinjector1_csrfield_rden = main_sdram_phaseinjector1_command_storage[5];
assign main_sdram_phaseinjector1_csrfield_cs_top = main_sdram_phaseinjector1_command_storage[6];
assign main_sdram_phaseinjector1_csrfield_cs_bottom = main_sdram_phaseinjector1_command_storage[7];
assign builder_csr_bankarray_csrbank10_dfii_pi1_command0_w = main_sdram_phaseinjector1_command_storage[7:0];
assign builder_csr_bankarray_csrbank10_dfii_pi1_address0_w = main_sdram_phaseinjector1_address_storage[14:0];
assign builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_w = main_sdram_phaseinjector1_baddress_storage[2:0];
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_w = main_sdram_phaseinjector1_wrdata_storage[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_w = main_sdram_phaseinjector1_wrdata_storage[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_w = main_sdram_phaseinjector1_wrdata_storage[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_w = main_sdram_phaseinjector1_wrdata_storage[31:0];
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_w = main_sdram_phaseinjector1_rddata_status[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_w = main_sdram_phaseinjector1_rddata_status[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_w = main_sdram_phaseinjector1_rddata_status[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_w = main_sdram_phaseinjector1_rddata_status[31:0];
assign main_sdram_phaseinjector1_rddata_we = builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_we;
assign main_sdram_phaseinjector2_csrfield_cs = main_sdram_phaseinjector2_command_storage[0];
assign main_sdram_phaseinjector2_csrfield_we = main_sdram_phaseinjector2_command_storage[1];
assign main_sdram_phaseinjector2_csrfield_cas = main_sdram_phaseinjector2_command_storage[2];
assign main_sdram_phaseinjector2_csrfield_ras = main_sdram_phaseinjector2_command_storage[3];
assign main_sdram_phaseinjector2_csrfield_wren = main_sdram_phaseinjector2_command_storage[4];
assign main_sdram_phaseinjector2_csrfield_rden = main_sdram_phaseinjector2_command_storage[5];
assign main_sdram_phaseinjector2_csrfield_cs_top = main_sdram_phaseinjector2_command_storage[6];
assign main_sdram_phaseinjector2_csrfield_cs_bottom = main_sdram_phaseinjector2_command_storage[7];
assign builder_csr_bankarray_csrbank10_dfii_pi2_command0_w = main_sdram_phaseinjector2_command_storage[7:0];
assign builder_csr_bankarray_csrbank10_dfii_pi2_address0_w = main_sdram_phaseinjector2_address_storage[14:0];
assign builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_w = main_sdram_phaseinjector2_baddress_storage[2:0];
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_w = main_sdram_phaseinjector2_wrdata_storage[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_w = main_sdram_phaseinjector2_wrdata_storage[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_w = main_sdram_phaseinjector2_wrdata_storage[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_w = main_sdram_phaseinjector2_wrdata_storage[31:0];
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_w = main_sdram_phaseinjector2_rddata_status[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_w = main_sdram_phaseinjector2_rddata_status[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_w = main_sdram_phaseinjector2_rddata_status[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_w = main_sdram_phaseinjector2_rddata_status[31:0];
assign main_sdram_phaseinjector2_rddata_we = builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_we;
assign main_sdram_phaseinjector3_csrfield_cs = main_sdram_phaseinjector3_command_storage[0];
assign main_sdram_phaseinjector3_csrfield_we = main_sdram_phaseinjector3_command_storage[1];
assign main_sdram_phaseinjector3_csrfield_cas = main_sdram_phaseinjector3_command_storage[2];
assign main_sdram_phaseinjector3_csrfield_ras = main_sdram_phaseinjector3_command_storage[3];
assign main_sdram_phaseinjector3_csrfield_wren = main_sdram_phaseinjector3_command_storage[4];
assign main_sdram_phaseinjector3_csrfield_rden = main_sdram_phaseinjector3_command_storage[5];
assign main_sdram_phaseinjector3_csrfield_cs_top = main_sdram_phaseinjector3_command_storage[6];
assign main_sdram_phaseinjector3_csrfield_cs_bottom = main_sdram_phaseinjector3_command_storage[7];
assign builder_csr_bankarray_csrbank10_dfii_pi3_command0_w = main_sdram_phaseinjector3_command_storage[7:0];
assign builder_csr_bankarray_csrbank10_dfii_pi3_address0_w = main_sdram_phaseinjector3_address_storage[14:0];
assign builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_w = main_sdram_phaseinjector3_baddress_storage[2:0];
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_w = main_sdram_phaseinjector3_wrdata_storage[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_w = main_sdram_phaseinjector3_wrdata_storage[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_w = main_sdram_phaseinjector3_wrdata_storage[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_w = main_sdram_phaseinjector3_wrdata_storage[31:0];
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_w = main_sdram_phaseinjector3_rddata_status[127:96];
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_w = main_sdram_phaseinjector3_rddata_status[95:64];
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_w = main_sdram_phaseinjector3_rddata_status[63:32];
assign builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_w = main_sdram_phaseinjector3_rddata_status[31:0];
assign main_sdram_phaseinjector3_rddata_we = builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_we;
assign builder_csr_bankarray_csrbank11_sel = (builder_csr_bankarray_interface11_bank_bus_adr[13:9] == 2'd3);
assign builder_csr_bankarray_csrbank11_load0_r = builder_csr_bankarray_interface11_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank11_load0_we <= 1'd0;
    builder_csr_bankarray_csrbank11_load0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 1'd0))) begin
        builder_csr_bankarray_csrbank11_load0_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_load0_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_reload0_r = builder_csr_bankarray_interface11_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank11_reload0_re <= 1'd0;
    builder_csr_bankarray_csrbank11_reload0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank11_reload0_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_reload0_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_en0_r = builder_csr_bankarray_interface11_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank11_en0_we <= 1'd0;
    builder_csr_bankarray_csrbank11_en0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank11_en0_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_en0_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_update_value0_r = builder_csr_bankarray_interface11_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank11_update_value0_re <= 1'd0;
    builder_csr_bankarray_csrbank11_update_value0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank11_update_value0_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_update_value0_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_value_r = builder_csr_bankarray_interface11_bank_bus_dat_w[31:0];
always @(*) begin
    builder_csr_bankarray_csrbank11_value_re <= 1'd0;
    builder_csr_bankarray_csrbank11_value_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 3'd4))) begin
        builder_csr_bankarray_csrbank11_value_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_value_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_ev_status_r = builder_csr_bankarray_interface11_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank11_ev_status_we <= 1'd0;
    builder_csr_bankarray_csrbank11_ev_status_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 3'd5))) begin
        builder_csr_bankarray_csrbank11_ev_status_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_ev_status_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_ev_pending_r = builder_csr_bankarray_interface11_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank11_ev_pending_we <= 1'd0;
    builder_csr_bankarray_csrbank11_ev_pending_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 3'd6))) begin
        builder_csr_bankarray_csrbank11_ev_pending_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_ev_pending_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_ev_enable0_r = builder_csr_bankarray_interface11_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank11_ev_enable0_re <= 1'd0;
    builder_csr_bankarray_csrbank11_ev_enable0_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank11_sel & (builder_csr_bankarray_interface11_bank_bus_adr[8:0] == 3'd7))) begin
        builder_csr_bankarray_csrbank11_ev_enable0_re <= builder_csr_bankarray_interface11_bank_bus_we;
        builder_csr_bankarray_csrbank11_ev_enable0_we <= (~builder_csr_bankarray_interface11_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank11_load0_w = main_timer_load_storage[31:0];
assign builder_csr_bankarray_csrbank11_reload0_w = main_timer_reload_storage[31:0];
assign builder_csr_bankarray_csrbank11_en0_w = main_timer_en_storage;
assign builder_csr_bankarray_csrbank11_update_value0_w = main_timer_update_value_storage;
assign builder_csr_bankarray_csrbank11_value_w = main_timer_value_status[31:0];
assign main_timer_value_we = builder_csr_bankarray_csrbank11_value_we;
assign main_timer_status_status = main_timer_zero0;
assign builder_csr_bankarray_csrbank11_ev_status_w = main_timer_status_status;
assign main_timer_status_we = builder_csr_bankarray_csrbank11_ev_status_we;
assign main_timer_pending_status = main_timer_zero1;
assign builder_csr_bankarray_csrbank11_ev_pending_w = main_timer_pending_status;
assign main_timer_pending_we = builder_csr_bankarray_csrbank11_ev_pending_we;
assign main_timer_zero2 = main_timer_enable_storage;
assign builder_csr_bankarray_csrbank11_ev_enable0_w = main_timer_enable_storage;
assign builder_csr_bankarray_csrbank12_sel = (builder_csr_bankarray_interface12_bank_bus_adr[13:9] == 2'd2);
assign main_uart_rxtx_r = builder_csr_bankarray_interface12_bank_bus_dat_w[7:0];
always @(*) begin
    main_uart_rxtx_re <= 1'd0;
    main_uart_rxtx_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 1'd0))) begin
        main_uart_rxtx_re <= builder_csr_bankarray_interface12_bank_bus_we;
        main_uart_rxtx_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_txfull_r = builder_csr_bankarray_interface12_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank12_txfull_we <= 1'd0;
    builder_csr_bankarray_csrbank12_txfull_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 1'd1))) begin
        builder_csr_bankarray_csrbank12_txfull_re <= builder_csr_bankarray_interface12_bank_bus_we;
        builder_csr_bankarray_csrbank12_txfull_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_rxempty_r = builder_csr_bankarray_interface12_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank12_rxempty_we <= 1'd0;
    builder_csr_bankarray_csrbank12_rxempty_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 2'd2))) begin
        builder_csr_bankarray_csrbank12_rxempty_re <= builder_csr_bankarray_interface12_bank_bus_we;
        builder_csr_bankarray_csrbank12_rxempty_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_ev_status_r = builder_csr_bankarray_interface12_bank_bus_dat_w[1:0];
always @(*) begin
    builder_csr_bankarray_csrbank12_ev_status_re <= 1'd0;
    builder_csr_bankarray_csrbank12_ev_status_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 2'd3))) begin
        builder_csr_bankarray_csrbank12_ev_status_re <= builder_csr_bankarray_interface12_bank_bus_we;
        builder_csr_bankarray_csrbank12_ev_status_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_ev_pending_r = builder_csr_bankarray_interface12_bank_bus_dat_w[1:0];
always @(*) begin
    builder_csr_bankarray_csrbank12_ev_pending_re <= 1'd0;
    builder_csr_bankarray_csrbank12_ev_pending_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 3'd4))) begin
        builder_csr_bankarray_csrbank12_ev_pending_re <= builder_csr_bankarray_interface12_bank_bus_we;
        builder_csr_bankarray_csrbank12_ev_pending_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_ev_enable0_r = builder_csr_bankarray_interface12_bank_bus_dat_w[1:0];
always @(*) begin
    builder_csr_bankarray_csrbank12_ev_enable0_we <= 1'd0;
    builder_csr_bankarray_csrbank12_ev_enable0_re <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 3'd5))) begin
        builder_csr_bankarray_csrbank12_ev_enable0_re <= builder_csr_bankarray_interface12_bank_bus_we;
        builder_csr_bankarray_csrbank12_ev_enable0_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_txempty_r = builder_csr_bankarray_interface12_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank12_txempty_re <= 1'd0;
    builder_csr_bankarray_csrbank12_txempty_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 3'd6))) begin
        builder_csr_bankarray_csrbank12_txempty_re <= builder_csr_bankarray_interface12_bank_bus_we;
        builder_csr_bankarray_csrbank12_txempty_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_rxfull_r = builder_csr_bankarray_interface12_bank_bus_dat_w[0];
always @(*) begin
    builder_csr_bankarray_csrbank12_rxfull_re <= 1'd0;
    builder_csr_bankarray_csrbank12_rxfull_we <= 1'd0;
    if ((builder_csr_bankarray_csrbank12_sel & (builder_csr_bankarray_interface12_bank_bus_adr[8:0] == 3'd7))) begin
        builder_csr_bankarray_csrbank12_rxfull_re <= builder_csr_bankarray_interface12_bank_bus_we;
        builder_csr_bankarray_csrbank12_rxfull_we <= (~builder_csr_bankarray_interface12_bank_bus_we);
    end
end
assign builder_csr_bankarray_csrbank12_txfull_w = main_uart_txfull_status;
assign main_uart_txfull_we = builder_csr_bankarray_csrbank12_txfull_we;
assign builder_csr_bankarray_csrbank12_rxempty_w = main_uart_rxempty_status;
assign main_uart_rxempty_we = builder_csr_bankarray_csrbank12_rxempty_we;
always @(*) begin
    main_uart_status_status <= 2'd0;
    main_uart_status_status[0] <= main_uart_tx0;
    main_uart_status_status[1] <= main_uart_rx0;
end
assign builder_csr_bankarray_csrbank12_ev_status_w = main_uart_status_status[1:0];
assign main_uart_status_we = builder_csr_bankarray_csrbank12_ev_status_we;
always @(*) begin
    main_uart_pending_status <= 2'd0;
    main_uart_pending_status[0] <= main_uart_tx1;
    main_uart_pending_status[1] <= main_uart_rx1;
end
assign builder_csr_bankarray_csrbank12_ev_pending_w = main_uart_pending_status[1:0];
assign main_uart_pending_we = builder_csr_bankarray_csrbank12_ev_pending_we;
assign main_uart_tx2 = main_uart_enable_storage[0];
assign main_uart_rx2 = main_uart_enable_storage[1];
assign builder_csr_bankarray_csrbank12_ev_enable0_w = main_uart_enable_storage[1:0];
assign builder_csr_bankarray_csrbank12_txempty_w = main_uart_txempty_status;
assign main_uart_txempty_we = builder_csr_bankarray_csrbank12_txempty_we;
assign builder_csr_bankarray_csrbank12_rxfull_w = main_uart_rxfull_status;
assign main_uart_rxfull_we = builder_csr_bankarray_csrbank12_rxfull_we;
assign builder_csr_interconnect_adr = builder_soclinux_adr;
assign builder_csr_interconnect_we = builder_soclinux_we;
assign builder_csr_interconnect_dat_w = builder_soclinux_dat_w;
assign builder_soclinux_dat_r = builder_csr_interconnect_dat_r;
assign builder_csr_bankarray_interface0_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface1_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface2_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface3_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface4_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface5_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface6_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface7_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface8_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface9_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface10_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface11_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface12_bank_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_sram_bus_adr = builder_csr_interconnect_adr;
assign builder_csr_bankarray_interface0_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface1_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface2_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface3_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface4_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface5_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface6_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface7_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface8_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface9_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface10_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface11_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface12_bank_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_sram_bus_we = builder_csr_interconnect_we;
assign builder_csr_bankarray_interface0_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface1_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface2_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface3_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface4_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface5_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface6_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface7_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface8_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface9_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface10_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface11_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_interface12_bank_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_bankarray_sram_bus_dat_w = builder_csr_interconnect_dat_w;
assign builder_csr_interconnect_dat_r = (((((((((((((builder_csr_bankarray_interface0_bank_bus_dat_r | builder_csr_bankarray_interface1_bank_bus_dat_r) | builder_csr_bankarray_interface2_bank_bus_dat_r) | builder_csr_bankarray_interface3_bank_bus_dat_r) | builder_csr_bankarray_interface4_bank_bus_dat_r) | builder_csr_bankarray_interface5_bank_bus_dat_r) | builder_csr_bankarray_interface6_bank_bus_dat_r) | builder_csr_bankarray_interface7_bank_bus_dat_r) | builder_csr_bankarray_interface8_bank_bus_dat_r) | builder_csr_bankarray_interface9_bank_bus_dat_r) | builder_csr_bankarray_interface10_bank_bus_dat_r) | builder_csr_bankarray_interface11_bank_bus_dat_r) | builder_csr_bankarray_interface12_bank_bus_dat_r) | builder_csr_bankarray_sram_bus_dat_r);
assign builder_t_slice_proxy0 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy1 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy2 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy3 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy4 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy5 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy6 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy7 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy8 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy9 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy10 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy11 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy12 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy13 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy14 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy15 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy16 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy17 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy18 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy19 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy20 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy21 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy22 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy23 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy24 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy25 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy26 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy27 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy28 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy29 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy30 = (~main_ethmac_tx_crc_next);
assign builder_t_slice_proxy31 = (~main_ethmac_tx_crc_next);
assign builder_cases_slice_proxy = {main_ethmac_tx_crc_value, main_ethmac_tx_crc_sink_payload_data[7:0]};
assign builder_t_slice_proxy32 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy33 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy34 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy35 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy36 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy37 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy38 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy39 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy40 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy41 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy42 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy43 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy44 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy45 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy46 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy47 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy48 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy49 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy50 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy51 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy52 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy53 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy54 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy55 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy56 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy57 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy58 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy59 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy60 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy61 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy62 = (~main_ethmac_liteethmaccrc32checker_crc_next);
assign builder_t_slice_proxy63 = (~main_ethmac_liteethmaccrc32checker_crc_next);
always @(*) begin
    builder_comb_rhs_array_muxed0 <= 30'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed0 <= main_cpu_pbus_adr;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed1 <= 32'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed1 <= main_cpu_pbus_dat_w;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed2 <= 4'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed2 <= main_cpu_pbus_sel;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed3 <= 1'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed3 <= main_cpu_pbus_cyc;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed4 <= 1'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed4 <= main_cpu_pbus_stb;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed5 <= 1'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed5 <= main_cpu_pbus_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed6 <= 3'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed6 <= main_cpu_pbus_cti;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed7 <= 2'd0;
    case (builder_socbushandler0_grant)
        default: begin
            builder_comb_rhs_array_muxed7 <= main_cpu_pbus_bte;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed8 <= 32'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed8 <= interface0_bus_adr;
        end
        default: begin
            builder_comb_rhs_array_muxed8 <= interface1_bus_adr;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed9 <= 32'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed9 <= interface0_bus_dat_w;
        end
        default: begin
            builder_comb_rhs_array_muxed9 <= interface1_bus_dat_w;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed10 <= 4'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed10 <= interface0_bus_sel;
        end
        default: begin
            builder_comb_rhs_array_muxed10 <= interface1_bus_sel;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed11 <= 1'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed11 <= interface0_bus_cyc;
        end
        default: begin
            builder_comb_rhs_array_muxed11 <= interface1_bus_cyc;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed12 <= 1'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed12 <= interface0_bus_stb;
        end
        default: begin
            builder_comb_rhs_array_muxed12 <= interface1_bus_stb;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed13 <= 1'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed13 <= interface0_bus_we;
        end
        default: begin
            builder_comb_rhs_array_muxed13 <= interface1_bus_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed14 <= 3'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed14 <= interface0_bus_cti;
        end
        default: begin
            builder_comb_rhs_array_muxed14 <= interface1_bus_cti;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed15 <= 2'd0;
    case (builder_socbushandler1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed15 <= interface0_bus_bte;
        end
        default: begin
            builder_comb_rhs_array_muxed15 <= interface1_bus_bte;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed16 <= 1'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[0];
        end
        1'd1: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[1];
        end
        2'd2: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[2];
        end
        2'd3: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[3];
        end
        3'd4: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[4];
        end
        3'd5: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[5];
        end
        3'd6: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[6];
        end
        default: begin
            builder_comb_rhs_array_muxed16 <= main_sdram_choose_cmd_valids[7];
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed17 <= 15'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine0_cmd_payload_a;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine1_cmd_payload_a;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine2_cmd_payload_a;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine3_cmd_payload_a;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine4_cmd_payload_a;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine5_cmd_payload_a;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine6_cmd_payload_a;
        end
        default: begin
            builder_comb_rhs_array_muxed17 <= main_sdram_bankmachine7_cmd_payload_a;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed18 <= 3'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine0_cmd_payload_ba;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine1_cmd_payload_ba;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine2_cmd_payload_ba;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine3_cmd_payload_ba;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine4_cmd_payload_ba;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine5_cmd_payload_ba;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine6_cmd_payload_ba;
        end
        default: begin
            builder_comb_rhs_array_muxed18 <= main_sdram_bankmachine7_cmd_payload_ba;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed19 <= 1'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine0_cmd_payload_is_read;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine1_cmd_payload_is_read;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine2_cmd_payload_is_read;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine3_cmd_payload_is_read;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine4_cmd_payload_is_read;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine5_cmd_payload_is_read;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine6_cmd_payload_is_read;
        end
        default: begin
            builder_comb_rhs_array_muxed19 <= main_sdram_bankmachine7_cmd_payload_is_read;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed20 <= 1'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine0_cmd_payload_is_write;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine1_cmd_payload_is_write;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine2_cmd_payload_is_write;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine3_cmd_payload_is_write;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine4_cmd_payload_is_write;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine5_cmd_payload_is_write;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine6_cmd_payload_is_write;
        end
        default: begin
            builder_comb_rhs_array_muxed20 <= main_sdram_bankmachine7_cmd_payload_is_write;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed21 <= 1'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine0_cmd_payload_is_cmd;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine1_cmd_payload_is_cmd;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine2_cmd_payload_is_cmd;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine3_cmd_payload_is_cmd;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine4_cmd_payload_is_cmd;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine5_cmd_payload_is_cmd;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine6_cmd_payload_is_cmd;
        end
        default: begin
            builder_comb_rhs_array_muxed21 <= main_sdram_bankmachine7_cmd_payload_is_cmd;
        end
    endcase
end
always @(*) begin
    builder_comb_t_array_muxed0 <= 1'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine0_cmd_payload_cas;
        end
        1'd1: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine1_cmd_payload_cas;
        end
        2'd2: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine2_cmd_payload_cas;
        end
        2'd3: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine3_cmd_payload_cas;
        end
        3'd4: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine4_cmd_payload_cas;
        end
        3'd5: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine5_cmd_payload_cas;
        end
        3'd6: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine6_cmd_payload_cas;
        end
        default: begin
            builder_comb_t_array_muxed0 <= main_sdram_bankmachine7_cmd_payload_cas;
        end
    endcase
end
always @(*) begin
    builder_comb_t_array_muxed1 <= 1'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine0_cmd_payload_ras;
        end
        1'd1: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine1_cmd_payload_ras;
        end
        2'd2: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine2_cmd_payload_ras;
        end
        2'd3: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine3_cmd_payload_ras;
        end
        3'd4: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine4_cmd_payload_ras;
        end
        3'd5: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine5_cmd_payload_ras;
        end
        3'd6: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine6_cmd_payload_ras;
        end
        default: begin
            builder_comb_t_array_muxed1 <= main_sdram_bankmachine7_cmd_payload_ras;
        end
    endcase
end
always @(*) begin
    builder_comb_t_array_muxed2 <= 1'd0;
    case (main_sdram_choose_cmd_grant)
        1'd0: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine0_cmd_payload_we;
        end
        1'd1: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine1_cmd_payload_we;
        end
        2'd2: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine2_cmd_payload_we;
        end
        2'd3: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine3_cmd_payload_we;
        end
        3'd4: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine4_cmd_payload_we;
        end
        3'd5: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine5_cmd_payload_we;
        end
        3'd6: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine6_cmd_payload_we;
        end
        default: begin
            builder_comb_t_array_muxed2 <= main_sdram_bankmachine7_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed22 <= 1'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[0];
        end
        1'd1: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[1];
        end
        2'd2: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[2];
        end
        2'd3: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[3];
        end
        3'd4: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[4];
        end
        3'd5: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[5];
        end
        3'd6: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[6];
        end
        default: begin
            builder_comb_rhs_array_muxed22 <= main_sdram_choose_req_valids[7];
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed23 <= 15'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine0_cmd_payload_a;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine1_cmd_payload_a;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine2_cmd_payload_a;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine3_cmd_payload_a;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine4_cmd_payload_a;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine5_cmd_payload_a;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine6_cmd_payload_a;
        end
        default: begin
            builder_comb_rhs_array_muxed23 <= main_sdram_bankmachine7_cmd_payload_a;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed24 <= 3'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine0_cmd_payload_ba;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine1_cmd_payload_ba;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine2_cmd_payload_ba;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine3_cmd_payload_ba;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine4_cmd_payload_ba;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine5_cmd_payload_ba;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine6_cmd_payload_ba;
        end
        default: begin
            builder_comb_rhs_array_muxed24 <= main_sdram_bankmachine7_cmd_payload_ba;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed25 <= 1'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine0_cmd_payload_is_read;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine1_cmd_payload_is_read;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine2_cmd_payload_is_read;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine3_cmd_payload_is_read;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine4_cmd_payload_is_read;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine5_cmd_payload_is_read;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine6_cmd_payload_is_read;
        end
        default: begin
            builder_comb_rhs_array_muxed25 <= main_sdram_bankmachine7_cmd_payload_is_read;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed26 <= 1'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine0_cmd_payload_is_write;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine1_cmd_payload_is_write;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine2_cmd_payload_is_write;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine3_cmd_payload_is_write;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine4_cmd_payload_is_write;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine5_cmd_payload_is_write;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine6_cmd_payload_is_write;
        end
        default: begin
            builder_comb_rhs_array_muxed26 <= main_sdram_bankmachine7_cmd_payload_is_write;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed27 <= 1'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine0_cmd_payload_is_cmd;
        end
        1'd1: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine1_cmd_payload_is_cmd;
        end
        2'd2: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine2_cmd_payload_is_cmd;
        end
        2'd3: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine3_cmd_payload_is_cmd;
        end
        3'd4: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine4_cmd_payload_is_cmd;
        end
        3'd5: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine5_cmd_payload_is_cmd;
        end
        3'd6: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine6_cmd_payload_is_cmd;
        end
        default: begin
            builder_comb_rhs_array_muxed27 <= main_sdram_bankmachine7_cmd_payload_is_cmd;
        end
    endcase
end
always @(*) begin
    builder_comb_t_array_muxed3 <= 1'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine0_cmd_payload_cas;
        end
        1'd1: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine1_cmd_payload_cas;
        end
        2'd2: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine2_cmd_payload_cas;
        end
        2'd3: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine3_cmd_payload_cas;
        end
        3'd4: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine4_cmd_payload_cas;
        end
        3'd5: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine5_cmd_payload_cas;
        end
        3'd6: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine6_cmd_payload_cas;
        end
        default: begin
            builder_comb_t_array_muxed3 <= main_sdram_bankmachine7_cmd_payload_cas;
        end
    endcase
end
always @(*) begin
    builder_comb_t_array_muxed4 <= 1'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine0_cmd_payload_ras;
        end
        1'd1: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine1_cmd_payload_ras;
        end
        2'd2: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine2_cmd_payload_ras;
        end
        2'd3: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine3_cmd_payload_ras;
        end
        3'd4: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine4_cmd_payload_ras;
        end
        3'd5: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine5_cmd_payload_ras;
        end
        3'd6: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine6_cmd_payload_ras;
        end
        default: begin
            builder_comb_t_array_muxed4 <= main_sdram_bankmachine7_cmd_payload_ras;
        end
    endcase
end
always @(*) begin
    builder_comb_t_array_muxed5 <= 1'd0;
    case (main_sdram_choose_req_grant)
        1'd0: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine0_cmd_payload_we;
        end
        1'd1: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine1_cmd_payload_we;
        end
        2'd2: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine2_cmd_payload_we;
        end
        2'd3: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine3_cmd_payload_we;
        end
        3'd4: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine4_cmd_payload_we;
        end
        3'd5: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine5_cmd_payload_we;
        end
        3'd6: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine6_cmd_payload_we;
        end
        default: begin
            builder_comb_t_array_muxed5 <= main_sdram_bankmachine7_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed28 <= 22'd0;
    case (builder_soclinux_roundrobin0_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed28 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed28 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed29 <= 1'd0;
    case (builder_soclinux_roundrobin0_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed29 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed29 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed30 <= 1'd0;
    case (builder_soclinux_roundrobin0_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed30 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 1'd0) & (~(((((((builder_soclinux_locked0 | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed30 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 1'd0) & (~(((((((builder_soclinux_locked1 | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed31 <= 22'd0;
    case (builder_soclinux_roundrobin1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed31 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed31 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed32 <= 1'd0;
    case (builder_soclinux_roundrobin1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed32 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed32 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed33 <= 1'd0;
    case (builder_soclinux_roundrobin1_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed33 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 1'd1) & (~(((((((builder_soclinux_locked2 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed33 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 1'd1) & (~(((((((builder_soclinux_locked3 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed34 <= 22'd0;
    case (builder_soclinux_roundrobin2_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed34 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed34 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed35 <= 1'd0;
    case (builder_soclinux_roundrobin2_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed35 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed35 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed36 <= 1'd0;
    case (builder_soclinux_roundrobin2_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed36 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 2'd2) & (~(((((((builder_soclinux_locked4 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed36 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 2'd2) & (~(((((((builder_soclinux_locked5 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed37 <= 22'd0;
    case (builder_soclinux_roundrobin3_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed37 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed37 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed38 <= 1'd0;
    case (builder_soclinux_roundrobin3_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed38 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed38 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed39 <= 1'd0;
    case (builder_soclinux_roundrobin3_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed39 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 2'd3) & (~(((((((builder_soclinux_locked6 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed39 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 2'd3) & (~(((((((builder_soclinux_locked7 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed40 <= 22'd0;
    case (builder_soclinux_roundrobin4_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed40 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed40 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed41 <= 1'd0;
    case (builder_soclinux_roundrobin4_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed41 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed41 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed42 <= 1'd0;
    case (builder_soclinux_roundrobin4_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed42 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd4) & (~(((((((builder_soclinux_locked8 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed42 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd4) & (~(((((((builder_soclinux_locked9 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed43 <= 22'd0;
    case (builder_soclinux_roundrobin5_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed43 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed43 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed44 <= 1'd0;
    case (builder_soclinux_roundrobin5_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed44 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed44 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed45 <= 1'd0;
    case (builder_soclinux_roundrobin5_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed45 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd5) & (~(((((((builder_soclinux_locked10 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed45 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd5) & (~(((((((builder_soclinux_locked11 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed46 <= 22'd0;
    case (builder_soclinux_roundrobin6_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed46 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed46 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed47 <= 1'd0;
    case (builder_soclinux_roundrobin6_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed47 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed47 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed48 <= 1'd0;
    case (builder_soclinux_roundrobin6_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed48 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd6) & (~(((((((builder_soclinux_locked12 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed48 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd6) & (~(((((((builder_soclinux_locked13 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank7_lock & (builder_soclinux_roundrobin7_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed49 <= 22'd0;
    case (builder_soclinux_roundrobin7_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed49 <= {main_litedramnativeport0_cmd_payload_addr[24:10], main_litedramnativeport0_cmd_payload_addr[6:0]};
        end
        default: begin
            builder_comb_rhs_array_muxed49 <= {main_litedramnativeport1_cmd_payload_addr[24:10], main_litedramnativeport1_cmd_payload_addr[6:0]};
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed50 <= 1'd0;
    case (builder_soclinux_roundrobin7_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed50 <= main_litedramnativeport0_cmd_payload_we;
        end
        default: begin
            builder_comb_rhs_array_muxed50 <= main_litedramnativeport1_cmd_payload_we;
        end
    endcase
end
always @(*) begin
    builder_comb_rhs_array_muxed51 <= 1'd0;
    case (builder_soclinux_roundrobin7_grant)
        1'd0: begin
            builder_comb_rhs_array_muxed51 <= (((main_litedramnativeport0_cmd_payload_addr[9:7] == 3'd7) & (~(((((((builder_soclinux_locked14 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd0))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd0))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd0))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd0))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd0))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd0))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd0))))) & main_litedramnativeport0_cmd_valid);
        end
        default: begin
            builder_comb_rhs_array_muxed51 <= (((main_litedramnativeport1_cmd_payload_addr[9:7] == 3'd7) & (~(((((((builder_soclinux_locked15 | (main_sdram_interface_bank0_lock & (builder_soclinux_roundrobin0_grant == 1'd1))) | (main_sdram_interface_bank1_lock & (builder_soclinux_roundrobin1_grant == 1'd1))) | (main_sdram_interface_bank2_lock & (builder_soclinux_roundrobin2_grant == 1'd1))) | (main_sdram_interface_bank3_lock & (builder_soclinux_roundrobin3_grant == 1'd1))) | (main_sdram_interface_bank4_lock & (builder_soclinux_roundrobin4_grant == 1'd1))) | (main_sdram_interface_bank5_lock & (builder_soclinux_roundrobin5_grant == 1'd1))) | (main_sdram_interface_bank6_lock & (builder_soclinux_roundrobin6_grant == 1'd1))))) & main_litedramnativeport1_cmd_valid);
        end
    endcase
end
always @(*) begin
    builder_sync_t_array_muxed0 <= 3'd0;
    case (main_ku_1000basex_pcsrx_input_msb_first[3:0])
        1'd0: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        1'd1: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        2'd2: begin
            builder_sync_t_array_muxed0 <= 3'd4;
        end
        2'd3: begin
            builder_sync_t_array_muxed0 <= 2'd3;
        end
        3'd4: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        3'd5: begin
            builder_sync_t_array_muxed0 <= 2'd2;
        end
        3'd6: begin
            builder_sync_t_array_muxed0 <= 3'd6;
        end
        3'd7: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        4'd8: begin
            builder_sync_t_array_muxed0 <= 3'd7;
        end
        4'd9: begin
            builder_sync_t_array_muxed0 <= 1'd1;
        end
        4'd10: begin
            builder_sync_t_array_muxed0 <= 3'd5;
        end
        4'd11: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        4'd12: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        4'd13: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        4'd14: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
        default: begin
            builder_sync_t_array_muxed0 <= 1'd0;
        end
    endcase
end
always @(*) begin
    builder_sync_t_array_muxed1 <= 3'd0;
    case (main_ku_1000basex_pcsrx_input_msb_first[3:0])
        1'd0: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        1'd1: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        2'd2: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        2'd3: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        3'd4: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        3'd5: begin
            builder_sync_t_array_muxed1 <= 3'd5;
        end
        3'd6: begin
            builder_sync_t_array_muxed1 <= 1'd1;
        end
        3'd7: begin
            builder_sync_t_array_muxed1 <= 3'd7;
        end
        4'd8: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        4'd9: begin
            builder_sync_t_array_muxed1 <= 3'd6;
        end
        4'd10: begin
            builder_sync_t_array_muxed1 <= 2'd2;
        end
        4'd11: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        4'd12: begin
            builder_sync_t_array_muxed1 <= 2'd3;
        end
        4'd13: begin
            builder_sync_t_array_muxed1 <= 3'd4;
        end
        4'd14: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
        default: begin
            builder_sync_t_array_muxed1 <= 1'd0;
        end
    endcase
end
always @(*) begin
    builder_sync_f_array_muxed <= 3'd0;
    case (main_ku_1000basex_pcsrx_input_msb_first[3:0])
        1'd0: begin
            builder_sync_f_array_muxed <= 1'd0;
        end
        1'd1: begin
            builder_sync_f_array_muxed <= 3'd7;
        end
        2'd2: begin
            builder_sync_f_array_muxed <= 3'd4;
        end
        2'd3: begin
            builder_sync_f_array_muxed <= 2'd3;
        end
        3'd4: begin
            builder_sync_f_array_muxed <= 1'd0;
        end
        3'd5: begin
            builder_sync_f_array_muxed <= 2'd2;
        end
        3'd6: begin
            builder_sync_f_array_muxed <= 3'd6;
        end
        3'd7: begin
            builder_sync_f_array_muxed <= 3'd7;
        end
        4'd8: begin
            builder_sync_f_array_muxed <= 3'd7;
        end
        4'd9: begin
            builder_sync_f_array_muxed <= 1'd1;
        end
        4'd10: begin
            builder_sync_f_array_muxed <= 3'd5;
        end
        4'd11: begin
            builder_sync_f_array_muxed <= 1'd0;
        end
        4'd12: begin
            builder_sync_f_array_muxed <= 2'd3;
        end
        4'd13: begin
            builder_sync_f_array_muxed <= 3'd4;
        end
        4'd14: begin
            builder_sync_f_array_muxed <= 3'd7;
        end
        default: begin
            builder_sync_f_array_muxed <= 1'd0;
        end
    endcase
end
always @(*) begin
    builder_sync_rhs_array_muxed0 <= 6'd0;
    case (main_ku_1000basex_pcstx_d1[4:0])
        1'd0: begin
            builder_sync_rhs_array_muxed0 <= 5'd24;
        end
        1'd1: begin
            builder_sync_rhs_array_muxed0 <= 6'd34;
        end
        2'd2: begin
            builder_sync_rhs_array_muxed0 <= 5'd18;
        end
        2'd3: begin
            builder_sync_rhs_array_muxed0 <= 6'd49;
        end
        3'd4: begin
            builder_sync_rhs_array_muxed0 <= 4'd10;
        end
        3'd5: begin
            builder_sync_rhs_array_muxed0 <= 6'd41;
        end
        3'd6: begin
            builder_sync_rhs_array_muxed0 <= 5'd25;
        end
        3'd7: begin
            builder_sync_rhs_array_muxed0 <= 3'd7;
        end
        4'd8: begin
            builder_sync_rhs_array_muxed0 <= 3'd6;
        end
        4'd9: begin
            builder_sync_rhs_array_muxed0 <= 6'd37;
        end
        4'd10: begin
            builder_sync_rhs_array_muxed0 <= 5'd21;
        end
        4'd11: begin
            builder_sync_rhs_array_muxed0 <= 6'd52;
        end
        4'd12: begin
            builder_sync_rhs_array_muxed0 <= 4'd13;
        end
        4'd13: begin
            builder_sync_rhs_array_muxed0 <= 6'd44;
        end
        4'd14: begin
            builder_sync_rhs_array_muxed0 <= 5'd28;
        end
        4'd15: begin
            builder_sync_rhs_array_muxed0 <= 6'd40;
        end
        5'd16: begin
            builder_sync_rhs_array_muxed0 <= 6'd36;
        end
        5'd17: begin
            builder_sync_rhs_array_muxed0 <= 6'd35;
        end
        5'd18: begin
            builder_sync_rhs_array_muxed0 <= 5'd19;
        end
        5'd19: begin
            builder_sync_rhs_array_muxed0 <= 6'd50;
        end
        5'd20: begin
            builder_sync_rhs_array_muxed0 <= 4'd11;
        end
        5'd21: begin
            builder_sync_rhs_array_muxed0 <= 6'd42;
        end
        5'd22: begin
            builder_sync_rhs_array_muxed0 <= 5'd26;
        end
        5'd23: begin
            builder_sync_rhs_array_muxed0 <= 3'd5;
        end
        5'd24: begin
            builder_sync_rhs_array_muxed0 <= 4'd12;
        end
        5'd25: begin
            builder_sync_rhs_array_muxed0 <= 6'd38;
        end
        5'd26: begin
            builder_sync_rhs_array_muxed0 <= 5'd22;
        end
        5'd27: begin
            builder_sync_rhs_array_muxed0 <= 4'd9;
        end
        5'd28: begin
            builder_sync_rhs_array_muxed0 <= 4'd14;
        end
        5'd29: begin
            builder_sync_rhs_array_muxed0 <= 5'd17;
        end
        5'd30: begin
            builder_sync_rhs_array_muxed0 <= 6'd33;
        end
        default: begin
            builder_sync_rhs_array_muxed0 <= 5'd20;
        end
    endcase
end
always @(*) begin
    builder_sync_rhs_array_muxed1 <= 1'd0;
    case (main_ku_1000basex_pcstx_d1[4:0])
        1'd0: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        1'd1: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        2'd2: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        2'd3: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        3'd4: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        3'd5: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        3'd6: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        3'd7: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        4'd8: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        4'd9: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        4'd10: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        4'd11: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        4'd12: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        4'd13: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        4'd14: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        4'd15: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        5'd16: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        5'd17: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd18: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd19: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd20: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd21: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd22: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd23: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        5'd24: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        5'd25: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd26: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd27: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        5'd28: begin
            builder_sync_rhs_array_muxed1 <= 1'd0;
        end
        5'd29: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        5'd30: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
        default: begin
            builder_sync_rhs_array_muxed1 <= 1'd1;
        end
    endcase
end
always @(*) begin
    builder_sync_rhs_array_muxed2 <= 1'd0;
    case (main_ku_1000basex_pcstx_d1[4:0])
        1'd0: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        1'd1: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        2'd2: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        2'd3: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        3'd4: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        3'd5: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        3'd6: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        3'd7: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        4'd8: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        4'd9: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        4'd10: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        4'd11: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        4'd12: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        4'd13: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        4'd14: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        4'd15: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        5'd16: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        5'd17: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd18: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd19: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd20: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd21: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd22: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd23: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        5'd24: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        5'd25: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd26: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd27: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        5'd28: begin
            builder_sync_rhs_array_muxed2 <= 1'd0;
        end
        5'd29: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        5'd30: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
        default: begin
            builder_sync_rhs_array_muxed2 <= 1'd1;
        end
    endcase
end
always @(*) begin
    builder_sync_rhs_array_muxed3 <= 4'd0;
    case (main_ku_1000basex_pcstx_d1[7:5])
        1'd0: begin
            builder_sync_rhs_array_muxed3 <= 3'd4;
        end
        1'd1: begin
            builder_sync_rhs_array_muxed3 <= 4'd9;
        end
        2'd2: begin
            builder_sync_rhs_array_muxed3 <= 3'd5;
        end
        2'd3: begin
            builder_sync_rhs_array_muxed3 <= 2'd3;
        end
        3'd4: begin
            builder_sync_rhs_array_muxed3 <= 2'd2;
        end
        3'd5: begin
            builder_sync_rhs_array_muxed3 <= 4'd10;
        end
        3'd6: begin
            builder_sync_rhs_array_muxed3 <= 3'd6;
        end
        default: begin
            builder_sync_rhs_array_muxed3 <= 1'd1;
        end
    endcase
end
always @(*) begin
    builder_sync_rhs_array_muxed4 <= 1'd0;
    case (main_ku_1000basex_pcstx_d1[7:5])
        1'd0: begin
            builder_sync_rhs_array_muxed4 <= 1'd1;
        end
        1'd1: begin
            builder_sync_rhs_array_muxed4 <= 1'd0;
        end
        2'd2: begin
            builder_sync_rhs_array_muxed4 <= 1'd0;
        end
        2'd3: begin
            builder_sync_rhs_array_muxed4 <= 1'd0;
        end
        3'd4: begin
            builder_sync_rhs_array_muxed4 <= 1'd1;
        end
        3'd5: begin
            builder_sync_rhs_array_muxed4 <= 1'd0;
        end
        3'd6: begin
            builder_sync_rhs_array_muxed4 <= 1'd0;
        end
        default: begin
            builder_sync_rhs_array_muxed4 <= 1'd1;
        end
    endcase
end
always @(*) begin
    builder_sync_rhs_array_muxed5 <= 1'd0;
    case (main_ku_1000basex_pcstx_d1[7:5])
        1'd0: begin
            builder_sync_rhs_array_muxed5 <= 1'd1;
        end
        1'd1: begin
            builder_sync_rhs_array_muxed5 <= 1'd0;
        end
        2'd2: begin
            builder_sync_rhs_array_muxed5 <= 1'd0;
        end
        2'd3: begin
            builder_sync_rhs_array_muxed5 <= 1'd1;
        end
        3'd4: begin
            builder_sync_rhs_array_muxed5 <= 1'd1;
        end
        3'd5: begin
            builder_sync_rhs_array_muxed5 <= 1'd0;
        end
        3'd6: begin
            builder_sync_rhs_array_muxed5 <= 1'd0;
        end
        default: begin
            builder_sync_rhs_array_muxed5 <= 1'd1;
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed0 <= 3'd0;
    case (main_sdram_steerer_sel0)
        1'd0: begin
            builder_sync_array_muxed0 <= main_sdram_nop_ba[2:0];
        end
        1'd1: begin
            builder_sync_array_muxed0 <= main_sdram_choose_cmd_cmd_payload_ba[2:0];
        end
        2'd2: begin
            builder_sync_array_muxed0 <= main_sdram_choose_req_cmd_payload_ba[2:0];
        end
        default: begin
            builder_sync_array_muxed0 <= main_sdram_cmd_payload_ba[2:0];
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed1 <= 15'd0;
    case (main_sdram_steerer_sel0)
        1'd0: begin
            builder_sync_array_muxed1 <= main_sdram_nop_a;
        end
        1'd1: begin
            builder_sync_array_muxed1 <= main_sdram_choose_cmd_cmd_payload_a;
        end
        2'd2: begin
            builder_sync_array_muxed1 <= main_sdram_choose_req_cmd_payload_a;
        end
        default: begin
            builder_sync_array_muxed1 <= main_sdram_cmd_payload_a;
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed2 <= 1'd0;
    case (main_sdram_steerer_sel0)
        1'd0: begin
            builder_sync_array_muxed2 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed2 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_cas);
        end
        2'd2: begin
            builder_sync_array_muxed2 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_cas);
        end
        default: begin
            builder_sync_array_muxed2 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_cas);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed3 <= 1'd0;
    case (main_sdram_steerer_sel0)
        1'd0: begin
            builder_sync_array_muxed3 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed3 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_ras);
        end
        2'd2: begin
            builder_sync_array_muxed3 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_ras);
        end
        default: begin
            builder_sync_array_muxed3 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_ras);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed4 <= 1'd0;
    case (main_sdram_steerer_sel0)
        1'd0: begin
            builder_sync_array_muxed4 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed4 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_we);
        end
        2'd2: begin
            builder_sync_array_muxed4 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_we);
        end
        default: begin
            builder_sync_array_muxed4 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_we);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed5 <= 1'd0;
    case (main_sdram_steerer_sel0)
        1'd0: begin
            builder_sync_array_muxed5 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed5 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_read);
        end
        2'd2: begin
            builder_sync_array_muxed5 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_read);
        end
        default: begin
            builder_sync_array_muxed5 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_read);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed6 <= 1'd0;
    case (main_sdram_steerer_sel0)
        1'd0: begin
            builder_sync_array_muxed6 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed6 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_write);
        end
        2'd2: begin
            builder_sync_array_muxed6 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_write);
        end
        default: begin
            builder_sync_array_muxed6 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_write);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed7 <= 3'd0;
    case (main_sdram_steerer_sel1)
        1'd0: begin
            builder_sync_array_muxed7 <= main_sdram_nop_ba[2:0];
        end
        1'd1: begin
            builder_sync_array_muxed7 <= main_sdram_choose_cmd_cmd_payload_ba[2:0];
        end
        2'd2: begin
            builder_sync_array_muxed7 <= main_sdram_choose_req_cmd_payload_ba[2:0];
        end
        default: begin
            builder_sync_array_muxed7 <= main_sdram_cmd_payload_ba[2:0];
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed8 <= 15'd0;
    case (main_sdram_steerer_sel1)
        1'd0: begin
            builder_sync_array_muxed8 <= main_sdram_nop_a;
        end
        1'd1: begin
            builder_sync_array_muxed8 <= main_sdram_choose_cmd_cmd_payload_a;
        end
        2'd2: begin
            builder_sync_array_muxed8 <= main_sdram_choose_req_cmd_payload_a;
        end
        default: begin
            builder_sync_array_muxed8 <= main_sdram_cmd_payload_a;
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed9 <= 1'd0;
    case (main_sdram_steerer_sel1)
        1'd0: begin
            builder_sync_array_muxed9 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed9 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_cas);
        end
        2'd2: begin
            builder_sync_array_muxed9 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_cas);
        end
        default: begin
            builder_sync_array_muxed9 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_cas);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed10 <= 1'd0;
    case (main_sdram_steerer_sel1)
        1'd0: begin
            builder_sync_array_muxed10 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed10 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_ras);
        end
        2'd2: begin
            builder_sync_array_muxed10 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_ras);
        end
        default: begin
            builder_sync_array_muxed10 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_ras);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed11 <= 1'd0;
    case (main_sdram_steerer_sel1)
        1'd0: begin
            builder_sync_array_muxed11 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed11 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_we);
        end
        2'd2: begin
            builder_sync_array_muxed11 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_we);
        end
        default: begin
            builder_sync_array_muxed11 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_we);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed12 <= 1'd0;
    case (main_sdram_steerer_sel1)
        1'd0: begin
            builder_sync_array_muxed12 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed12 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_read);
        end
        2'd2: begin
            builder_sync_array_muxed12 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_read);
        end
        default: begin
            builder_sync_array_muxed12 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_read);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed13 <= 1'd0;
    case (main_sdram_steerer_sel1)
        1'd0: begin
            builder_sync_array_muxed13 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed13 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_write);
        end
        2'd2: begin
            builder_sync_array_muxed13 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_write);
        end
        default: begin
            builder_sync_array_muxed13 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_write);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed14 <= 3'd0;
    case (main_sdram_steerer_sel2)
        1'd0: begin
            builder_sync_array_muxed14 <= main_sdram_nop_ba[2:0];
        end
        1'd1: begin
            builder_sync_array_muxed14 <= main_sdram_choose_cmd_cmd_payload_ba[2:0];
        end
        2'd2: begin
            builder_sync_array_muxed14 <= main_sdram_choose_req_cmd_payload_ba[2:0];
        end
        default: begin
            builder_sync_array_muxed14 <= main_sdram_cmd_payload_ba[2:0];
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed15 <= 15'd0;
    case (main_sdram_steerer_sel2)
        1'd0: begin
            builder_sync_array_muxed15 <= main_sdram_nop_a;
        end
        1'd1: begin
            builder_sync_array_muxed15 <= main_sdram_choose_cmd_cmd_payload_a;
        end
        2'd2: begin
            builder_sync_array_muxed15 <= main_sdram_choose_req_cmd_payload_a;
        end
        default: begin
            builder_sync_array_muxed15 <= main_sdram_cmd_payload_a;
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed16 <= 1'd0;
    case (main_sdram_steerer_sel2)
        1'd0: begin
            builder_sync_array_muxed16 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed16 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_cas);
        end
        2'd2: begin
            builder_sync_array_muxed16 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_cas);
        end
        default: begin
            builder_sync_array_muxed16 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_cas);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed17 <= 1'd0;
    case (main_sdram_steerer_sel2)
        1'd0: begin
            builder_sync_array_muxed17 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed17 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_ras);
        end
        2'd2: begin
            builder_sync_array_muxed17 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_ras);
        end
        default: begin
            builder_sync_array_muxed17 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_ras);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed18 <= 1'd0;
    case (main_sdram_steerer_sel2)
        1'd0: begin
            builder_sync_array_muxed18 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed18 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_we);
        end
        2'd2: begin
            builder_sync_array_muxed18 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_we);
        end
        default: begin
            builder_sync_array_muxed18 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_we);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed19 <= 1'd0;
    case (main_sdram_steerer_sel2)
        1'd0: begin
            builder_sync_array_muxed19 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed19 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_read);
        end
        2'd2: begin
            builder_sync_array_muxed19 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_read);
        end
        default: begin
            builder_sync_array_muxed19 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_read);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed20 <= 1'd0;
    case (main_sdram_steerer_sel2)
        1'd0: begin
            builder_sync_array_muxed20 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed20 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_write);
        end
        2'd2: begin
            builder_sync_array_muxed20 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_write);
        end
        default: begin
            builder_sync_array_muxed20 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_write);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed21 <= 3'd0;
    case (main_sdram_steerer_sel3)
        1'd0: begin
            builder_sync_array_muxed21 <= main_sdram_nop_ba[2:0];
        end
        1'd1: begin
            builder_sync_array_muxed21 <= main_sdram_choose_cmd_cmd_payload_ba[2:0];
        end
        2'd2: begin
            builder_sync_array_muxed21 <= main_sdram_choose_req_cmd_payload_ba[2:0];
        end
        default: begin
            builder_sync_array_muxed21 <= main_sdram_cmd_payload_ba[2:0];
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed22 <= 15'd0;
    case (main_sdram_steerer_sel3)
        1'd0: begin
            builder_sync_array_muxed22 <= main_sdram_nop_a;
        end
        1'd1: begin
            builder_sync_array_muxed22 <= main_sdram_choose_cmd_cmd_payload_a;
        end
        2'd2: begin
            builder_sync_array_muxed22 <= main_sdram_choose_req_cmd_payload_a;
        end
        default: begin
            builder_sync_array_muxed22 <= main_sdram_cmd_payload_a;
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed23 <= 1'd0;
    case (main_sdram_steerer_sel3)
        1'd0: begin
            builder_sync_array_muxed23 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed23 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_cas);
        end
        2'd2: begin
            builder_sync_array_muxed23 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_cas);
        end
        default: begin
            builder_sync_array_muxed23 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_cas);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed24 <= 1'd0;
    case (main_sdram_steerer_sel3)
        1'd0: begin
            builder_sync_array_muxed24 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed24 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_ras);
        end
        2'd2: begin
            builder_sync_array_muxed24 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_ras);
        end
        default: begin
            builder_sync_array_muxed24 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_ras);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed25 <= 1'd0;
    case (main_sdram_steerer_sel3)
        1'd0: begin
            builder_sync_array_muxed25 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed25 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_we);
        end
        2'd2: begin
            builder_sync_array_muxed25 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_we);
        end
        default: begin
            builder_sync_array_muxed25 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_we);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed26 <= 1'd0;
    case (main_sdram_steerer_sel3)
        1'd0: begin
            builder_sync_array_muxed26 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed26 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_read);
        end
        2'd2: begin
            builder_sync_array_muxed26 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_read);
        end
        default: begin
            builder_sync_array_muxed26 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_read);
        end
    endcase
end
always @(*) begin
    builder_sync_array_muxed27 <= 1'd0;
    case (main_sdram_steerer_sel3)
        1'd0: begin
            builder_sync_array_muxed27 <= 1'd0;
        end
        1'd1: begin
            builder_sync_array_muxed27 <= ((main_sdram_choose_cmd_cmd_valid & main_sdram_choose_cmd_cmd_ready) & main_sdram_choose_cmd_cmd_payload_is_write);
        end
        2'd2: begin
            builder_sync_array_muxed27 <= ((main_sdram_choose_req_cmd_valid & main_sdram_choose_req_cmd_ready) & main_sdram_choose_req_cmd_payload_is_write);
        end
        default: begin
            builder_sync_array_muxed27 <= ((main_sdram_cmd_valid & main_sdram_cmd_ready) & main_sdram_cmd_payload_is_write);
        end
    endcase
end
assign builder_xilinxasyncresetsynchronizerimpl0 = (~main_crg_locked);
assign builder_xilinxasyncresetsynchronizerimpl1 = (~main_crg_locked);
assign main_rx_rx = builder_xilinxmultiregimpl0_regs1;
assign main_ku_1000basex_lp_abi_ping_toggle_o = builder_xilinxmultiregimpl1_regs1;
assign main_ku_1000basex_lp_abi_pong_toggle_o = builder_xilinxmultiregimpl2_regs1;
assign main_ku_1000basex_lp_abi_obuffer = builder_xilinxmultiregimpl3_regs1;
assign main_ku_1000basex_seen_valid_ci_toggle_o = builder_xilinxmultiregimpl4_regs1;
assign main_ku_1000basex_rx_config_reg_abi_toggle_o = builder_xilinxmultiregimpl5_regs1;
assign main_ku_1000basex_rx_config_reg_ack_toggle_o = builder_xilinxmultiregimpl6_regs1;
assign builder_xilinxasyncresetsynchronizerimpl3 = (~main_ku_1000basex_tx_reset_done);
assign builder_xilinxasyncresetsynchronizerimpl4 = (~main_ku_1000basex_rx_reset_done);
assign main_ethmac_tx_cdc_cdc_produce_rdomain = builder_xilinxmultiregimpl7_regs1;
assign main_ethmac_tx_cdc_cdc_consume_wdomain = builder_xilinxmultiregimpl8_regs1;
assign main_ethmac_pulsesynchronizer0_toggle_o = builder_xilinxmultiregimpl9_regs1;
assign main_ethmac_pulsesynchronizer1_toggle_o = builder_xilinxmultiregimpl10_regs1;
assign main_ethmac_rx_cdc_cdc_produce_rdomain = builder_xilinxmultiregimpl11_regs1;
assign main_ethmac_rx_cdc_cdc_consume_wdomain = builder_xilinxmultiregimpl12_regs1;


//------------------------------------------------------------------------------
// Synchronous Logic
//------------------------------------------------------------------------------

always @(posedge eth_rx_clk) begin
    main_ku_1000basex_rx_en_d <= main_ku_1000basex_pcsrx_rx_en;
    main_ku_1000basex_source_valid <= main_ku_1000basex_pcsrx_sample_en;
    main_ku_1000basex_source_payload_data <= main_ku_1000basex_pcsrx_rx_data;
    if (main_ku_1000basex_pcsrx_seen_config_reg) begin
        main_ku_1000basex_c_counter <= 3'd4;
    end else begin
        if ((main_ku_1000basex_c_counter != 1'd0)) begin
            main_ku_1000basex_c_counter <= (main_ku_1000basex_c_counter - 1'd1);
        end
    end
    main_ku_1000basex_rx_config_reg_abi_i <= 1'd0;
    main_ku_1000basex_rx_config_reg_ack_i <= 1'd0;
    if (main_ku_1000basex_pcsrx_seen_config_reg) begin
        main_ku_1000basex_prev_config_reg <= main_ku_1000basex_pcsrx_config_reg;
        if (((main_ku_1000basex_c_counter == 1'd1) & ((main_ku_1000basex_prev_config_reg & 16'd49151) == (main_ku_1000basex_pcsrx_config_reg & 16'd49151)))) begin
            if ((main_ku_1000basex_prev_config_reg[14] & main_ku_1000basex_pcsrx_config_reg[14])) begin
                main_ku_1000basex_rx_config_reg_ack_i <= 1'd1;
            end else begin
                main_ku_1000basex_rx_config_reg_abi_i <= 1'd1;
            end
        end
        main_ku_1000basex_lp_abi_i <= main_ku_1000basex_pcsrx_config_reg;
    end
    main_ku_1000basex_pcsrx_seen_config_reg <= 1'd0;
    if (main_ku_1000basex_pcsrx_load_config_reg_lsb) begin
        main_ku_1000basex_pcsrx_config_reg_lsb <= main_ku_1000basex_pcsrx_d;
    end
    if (main_ku_1000basex_pcsrx_load_config_reg_msb) begin
        main_ku_1000basex_pcsrx_config_reg <= {main_ku_1000basex_pcsrx_d, main_ku_1000basex_pcsrx_config_reg_lsb};
        main_ku_1000basex_pcsrx_seen_config_reg <= 1'd1;
    end
    if (((~main_ku_1000basex_pcsrx_timer_en) | (main_ku_1000basex_pcsrx_timer == 1'd0))) begin
        if ((main_ku_1000basex_pcsrx_sgmii_speed == 1'd0)) begin
            main_ku_1000basex_pcsrx_timer <= 7'd99;
        end else begin
            if ((main_ku_1000basex_pcsrx_sgmii_speed == 1'd1)) begin
                main_ku_1000basex_pcsrx_timer <= 4'd9;
            end else begin
                if ((main_ku_1000basex_pcsrx_sgmii_speed == 2'd2)) begin
                    main_ku_1000basex_pcsrx_timer <= 1'd0;
                end
            end
        end
    end else begin
        if (main_ku_1000basex_pcsrx_timer_en) begin
            main_ku_1000basex_pcsrx_timer <= (main_ku_1000basex_pcsrx_timer - 1'd1);
        end
    end
    if (main_ku_1000basex_pcsrx_ce) begin
        main_ku_1000basex_pcsrx_k <= 1'd0;
        if ((main_ku_1000basex_pcsrx_input_msb_first[9:4] == 4'd15)) begin
            main_ku_1000basex_pcsrx_k <= 1'd1;
            main_ku_1000basex_pcsrx_code3b <= builder_sync_t_array_muxed0;
        end else begin
            if ((main_ku_1000basex_pcsrx_input_msb_first[9:4] == 6'd48)) begin
                main_ku_1000basex_pcsrx_k <= 1'd1;
                main_ku_1000basex_pcsrx_code3b <= builder_sync_t_array_muxed1;
            end else begin
                if (((main_ku_1000basex_pcsrx_input_msb_first[3:0] == 3'd7) | (main_ku_1000basex_pcsrx_input_msb_first[3:0] == 4'd8))) begin
                    if (((((((main_ku_1000basex_pcsrx_input_msb_first[9:4] != 6'd35) & (main_ku_1000basex_pcsrx_input_msb_first[9:4] != 5'd19)) & (main_ku_1000basex_pcsrx_input_msb_first[9:4] != 4'd11)) & (main_ku_1000basex_pcsrx_input_msb_first[9:4] != 6'd52)) & (main_ku_1000basex_pcsrx_input_msb_first[9:4] != 6'd44)) & (main_ku_1000basex_pcsrx_input_msb_first[9:4] != 5'd28))) begin
                        main_ku_1000basex_pcsrx_k <= 1'd1;
                    end
                end
                main_ku_1000basex_pcsrx_code3b <= builder_sync_f_array_muxed;
            end
        end
    end
    if (main_ku_1000basex_pcsrx_ce) begin
        main_ku_1000basex_pcsrx_ones <= (((((((((main_ku_1000basex_pcsrx_input[0] + main_ku_1000basex_pcsrx_input[1]) + main_ku_1000basex_pcsrx_input[2]) + main_ku_1000basex_pcsrx_input[3]) + main_ku_1000basex_pcsrx_input[4]) + main_ku_1000basex_pcsrx_input[5]) + main_ku_1000basex_pcsrx_input[6]) + main_ku_1000basex_pcsrx_input[7]) + main_ku_1000basex_pcsrx_input[8]) + main_ku_1000basex_pcsrx_input[9]);
    end
    builder_soclinux_ku_1000basex_pcsrx_state <= builder_soclinux_ku_1000basex_pcsrx_next_state;
    main_ku_1000basex_lp_abi_starter <= 1'd0;
    if (main_ku_1000basex_lp_abi_pong_o) begin
        main_ku_1000basex_lp_abi_ibuffer <= main_ku_1000basex_lp_abi_i;
    end
    if (main_ku_1000basex_lp_abi_ping_i) begin
        main_ku_1000basex_lp_abi_ping_toggle_i <= (~main_ku_1000basex_lp_abi_ping_toggle_i);
    end
    main_ku_1000basex_lp_abi_pong_toggle_o_r <= main_ku_1000basex_lp_abi_pong_toggle_o;
    if (main_ku_1000basex_lp_abi_wait) begin
        if ((~main_ku_1000basex_lp_abi_done)) begin
            main_ku_1000basex_lp_abi_count <= (main_ku_1000basex_lp_abi_count - 1'd1);
        end
    end else begin
        main_ku_1000basex_lp_abi_count <= 8'd128;
    end
    if (main_ku_1000basex_seen_valid_ci_i) begin
        main_ku_1000basex_seen_valid_ci_toggle_i <= (~main_ku_1000basex_seen_valid_ci_toggle_i);
    end
    if (main_ku_1000basex_rx_config_reg_abi_i) begin
        main_ku_1000basex_rx_config_reg_abi_toggle_i <= (~main_ku_1000basex_rx_config_reg_abi_toggle_i);
    end
    if (main_ku_1000basex_rx_config_reg_ack_i) begin
        main_ku_1000basex_rx_config_reg_ack_toggle_i <= (~main_ku_1000basex_rx_config_reg_ack_toggle_i);
    end
    if ((main_ku_1000basex_phase_half == main_ku_1000basex_phase_half_rereg)) begin
        main_ku_1000basex_rx_data1 <= main_ku_1000basex_rx_data_half[19:10];
    end else begin
        main_ku_1000basex_rx_data1 <= main_ku_1000basex_rx_data_half[9:0];
    end
    main_ku_1000basex_phase_half <= (~main_ku_1000basex_phase_half);
    builder_soclinux_rxdatapath_liteethmacpreamblechecker_state <= builder_soclinux_rxdatapath_liteethmacpreamblechecker_next_state;
    if (main_ethmac_pulsesynchronizer0_i) begin
        main_ethmac_pulsesynchronizer0_toggle_i <= (~main_ethmac_pulsesynchronizer0_toggle_i);
    end
    if (main_ethmac_liteethmaccrc32checker_crc_ce) begin
        main_ethmac_liteethmaccrc32checker_crc_reg <= main_ethmac_liteethmaccrc32checker_crc_next;
    end
    if (main_ethmac_liteethmaccrc32checker_crc_reset) begin
        main_ethmac_liteethmaccrc32checker_crc_reg <= 32'd4294967295;
    end
    if (((main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_we & main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_writable) & (~main_ethmac_liteethmaccrc32checker_syncfifo_replace))) begin
        if ((main_ethmac_liteethmaccrc32checker_syncfifo_produce == 3'd4)) begin
            main_ethmac_liteethmaccrc32checker_syncfifo_produce <= 1'd0;
        end else begin
            main_ethmac_liteethmaccrc32checker_syncfifo_produce <= (main_ethmac_liteethmaccrc32checker_syncfifo_produce + 1'd1);
        end
    end
    if (main_ethmac_liteethmaccrc32checker_syncfifo_do_read) begin
        if ((main_ethmac_liteethmaccrc32checker_syncfifo_consume == 3'd4)) begin
            main_ethmac_liteethmaccrc32checker_syncfifo_consume <= 1'd0;
        end else begin
            main_ethmac_liteethmaccrc32checker_syncfifo_consume <= (main_ethmac_liteethmaccrc32checker_syncfifo_consume + 1'd1);
        end
    end
    if (((main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_we & main_ethmac_liteethmaccrc32checker_syncfifo_syncfifo_writable) & (~main_ethmac_liteethmaccrc32checker_syncfifo_replace))) begin
        if ((~main_ethmac_liteethmaccrc32checker_syncfifo_do_read)) begin
            main_ethmac_liteethmaccrc32checker_syncfifo_level <= (main_ethmac_liteethmaccrc32checker_syncfifo_level + 1'd1);
        end
    end else begin
        if (main_ethmac_liteethmaccrc32checker_syncfifo_do_read) begin
            main_ethmac_liteethmaccrc32checker_syncfifo_level <= (main_ethmac_liteethmaccrc32checker_syncfifo_level - 1'd1);
        end
    end
    if (main_ethmac_liteethmaccrc32checker_fifo_reset) begin
        main_ethmac_liteethmaccrc32checker_syncfifo_level <= 3'd0;
        main_ethmac_liteethmaccrc32checker_syncfifo_produce <= 3'd0;
        main_ethmac_liteethmaccrc32checker_syncfifo_consume <= 3'd0;
    end
    builder_soclinux_rxdatapath_bufferizeendpoints_state <= builder_soclinux_rxdatapath_bufferizeendpoints_next_state;
    if (main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value_ce0) begin
        main_ethmac_liteethmaccrc32checker_last_be <= main_ethmac_liteethmaccrc32checker_last_be_clockdomainsrenamer_next_value0;
    end
    if (main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value_ce1) begin
        main_ethmac_liteethmaccrc32checker_crc_error1 <= main_ethmac_liteethmaccrc32checker_crc_error1_clockdomainsrenamer_next_value1;
    end
    if (((~main_ethmac_bufferizeendpoints_pipe_valid_source_valid) | main_ethmac_bufferizeendpoints_pipe_valid_source_ready)) begin
        main_ethmac_bufferizeendpoints_pipe_valid_source_valid <= main_ethmac_bufferizeendpoints_pipe_valid_sink_valid;
        main_ethmac_bufferizeendpoints_pipe_valid_source_first <= main_ethmac_bufferizeendpoints_pipe_valid_sink_first;
        main_ethmac_bufferizeendpoints_pipe_valid_source_last <= main_ethmac_bufferizeendpoints_pipe_valid_sink_last;
        main_ethmac_bufferizeendpoints_pipe_valid_source_payload_data <= main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_data;
        main_ethmac_bufferizeendpoints_pipe_valid_source_payload_last_be <= main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_last_be;
        main_ethmac_bufferizeendpoints_pipe_valid_source_payload_error <= main_ethmac_bufferizeendpoints_pipe_valid_sink_payload_error;
    end
    if (main_ethmac_pulsesynchronizer1_i) begin
        main_ethmac_pulsesynchronizer1_toggle_i <= (~main_ethmac_pulsesynchronizer1_toggle_i);
    end
    if (main_ethmac_rx_converter_converter_source_ready) begin
        main_ethmac_rx_converter_converter_strobe_all <= 1'd0;
    end
    if (main_ethmac_rx_converter_converter_load_part) begin
        if (((main_ethmac_rx_converter_converter_demux == 2'd3) | main_ethmac_rx_converter_converter_sink_last)) begin
            main_ethmac_rx_converter_converter_demux <= 1'd0;
            main_ethmac_rx_converter_converter_strobe_all <= 1'd1;
        end else begin
            main_ethmac_rx_converter_converter_demux <= (main_ethmac_rx_converter_converter_demux + 1'd1);
        end
    end
    if ((main_ethmac_rx_converter_converter_source_valid & main_ethmac_rx_converter_converter_source_ready)) begin
        if ((main_ethmac_rx_converter_converter_sink_valid & main_ethmac_rx_converter_converter_sink_ready)) begin
            main_ethmac_rx_converter_converter_source_first <= main_ethmac_rx_converter_converter_sink_first;
            main_ethmac_rx_converter_converter_source_last <= main_ethmac_rx_converter_converter_sink_last;
        end else begin
            main_ethmac_rx_converter_converter_source_first <= 1'd0;
            main_ethmac_rx_converter_converter_source_last <= 1'd0;
        end
    end else begin
        if ((main_ethmac_rx_converter_converter_sink_valid & main_ethmac_rx_converter_converter_sink_ready)) begin
            main_ethmac_rx_converter_converter_source_first <= (main_ethmac_rx_converter_converter_sink_first | main_ethmac_rx_converter_converter_source_first);
            main_ethmac_rx_converter_converter_source_last <= (main_ethmac_rx_converter_converter_sink_last | main_ethmac_rx_converter_converter_source_last);
        end
    end
    if (main_ethmac_rx_converter_converter_load_part) begin
        case (main_ethmac_rx_converter_converter_demux)
            1'd0: begin
                main_ethmac_rx_converter_converter_source_payload_data[9:0] <= main_ethmac_rx_converter_converter_sink_payload_data;
            end
            1'd1: begin
                main_ethmac_rx_converter_converter_source_payload_data[19:10] <= main_ethmac_rx_converter_converter_sink_payload_data;
            end
            2'd2: begin
                main_ethmac_rx_converter_converter_source_payload_data[29:20] <= main_ethmac_rx_converter_converter_sink_payload_data;
            end
            2'd3: begin
                main_ethmac_rx_converter_converter_source_payload_data[39:30] <= main_ethmac_rx_converter_converter_sink_payload_data;
            end
        endcase
    end
    if (main_ethmac_rx_converter_converter_load_part) begin
        main_ethmac_rx_converter_converter_source_payload_valid_token_count <= (main_ethmac_rx_converter_converter_demux + 1'd1);
    end
    main_ethmac_rx_cdc_cdc_graycounter0_q_binary <= main_ethmac_rx_cdc_cdc_graycounter0_q_next_binary;
    main_ethmac_rx_cdc_cdc_graycounter0_q <= main_ethmac_rx_cdc_cdc_graycounter0_q_next;
    if (eth_rx_rst) begin
        main_ku_1000basex_pcsrx_seen_config_reg <= 1'd0;
        main_ku_1000basex_pcsrx_config_reg <= 16'd0;
        main_ku_1000basex_pcsrx_k <= 1'd0;
        main_ku_1000basex_pcsrx_config_reg_lsb <= 8'd0;
        main_ku_1000basex_pcsrx_timer <= 10'd0;
        main_ku_1000basex_source_valid <= 1'd0;
        main_ku_1000basex_source_payload_data <= 8'd0;
        main_ku_1000basex_lp_abi_i <= 16'd0;
        main_ku_1000basex_lp_abi_starter <= 1'd1;
        main_ku_1000basex_lp_abi_count <= 8'd128;
        main_ku_1000basex_rx_en_d <= 1'd0;
        main_ku_1000basex_rx_config_reg_abi_i <= 1'd0;
        main_ku_1000basex_rx_config_reg_ack_i <= 1'd0;
        main_ku_1000basex_c_counter <= 3'd0;
        main_ku_1000basex_prev_config_reg <= 16'd0;
        main_ku_1000basex_rx_data1 <= 10'd0;
        main_ku_1000basex_phase_half <= 1'd0;
        main_ethmac_liteethmaccrc32checker_crc_reg <= 32'd4294967295;
        main_ethmac_liteethmaccrc32checker_syncfifo_level <= 3'd0;
        main_ethmac_liteethmaccrc32checker_syncfifo_produce <= 3'd0;
        main_ethmac_liteethmaccrc32checker_syncfifo_consume <= 3'd0;
        main_ethmac_liteethmaccrc32checker_last_be <= 1'd0;
        main_ethmac_liteethmaccrc32checker_crc_error1 <= 1'd0;
        main_ethmac_bufferizeendpoints_pipe_valid_source_valid <= 1'd0;
        main_ethmac_bufferizeendpoints_pipe_valid_source_payload_data <= 8'd0;
        main_ethmac_bufferizeendpoints_pipe_valid_source_payload_last_be <= 1'd0;
        main_ethmac_bufferizeendpoints_pipe_valid_source_payload_error <= 1'd0;
        main_ethmac_rx_converter_converter_source_payload_data <= 40'd0;
        main_ethmac_rx_converter_converter_source_payload_valid_token_count <= 3'd0;
        main_ethmac_rx_converter_converter_demux <= 2'd0;
        main_ethmac_rx_converter_converter_strobe_all <= 1'd0;
        main_ethmac_rx_cdc_cdc_graycounter0_q <= 6'd0;
        main_ethmac_rx_cdc_cdc_graycounter0_q_binary <= 6'd0;
        builder_soclinux_ku_1000basex_pcsrx_state <= 3'd0;
        builder_soclinux_rxdatapath_liteethmacpreamblechecker_state <= 1'd0;
        builder_soclinux_rxdatapath_bufferizeendpoints_state <= 2'd0;
    end
    builder_xilinxmultiregimpl2_regs0 <= main_ku_1000basex_lp_abi_pong_toggle_i;
    builder_xilinxmultiregimpl2_regs1 <= builder_xilinxmultiregimpl2_regs0;
    builder_xilinxmultiregimpl12_regs0 <= main_ethmac_rx_cdc_cdc_graycounter1_q;
    builder_xilinxmultiregimpl12_regs1 <= builder_xilinxmultiregimpl12_regs0;
end

always @(posedge eth_rx_half_clk) begin
    main_ku_1000basex_phase_half_rereg <= main_ku_1000basex_phase_half;
end

always @(posedge eth_tx_clk) begin
    main_ku_1000basex_checker_tick <= 1'd0;
    if ((main_ku_1000basex_checker_counter == 1'd0)) begin
        main_ku_1000basex_checker_tick <= 1'd1;
        main_ku_1000basex_checker_counter <= 20'd750000;
    end else begin
        main_ku_1000basex_checker_counter <= (main_ku_1000basex_checker_counter - 1'd1);
    end
    if (main_ku_1000basex_seen_valid_ci_o) begin
        main_ku_1000basex_checker_ok <= 1'd1;
    end
    if (main_ku_1000basex_checker_tick) begin
        main_ku_1000basex_checker_ok <= 1'd0;
    end
    main_ku_1000basex_pcstx_parity <= (~main_ku_1000basex_pcstx_parity);
    if (main_ku_1000basex_pcstx_load_config_reg_buffer) begin
        main_ku_1000basex_pcstx_config_reg_buffer <= main_ku_1000basex_pcstx_config_reg;
    end
    if (((~main_ku_1000basex_pcstx_timer_en) | (main_ku_1000basex_pcstx_timer == 1'd0))) begin
        if ((main_ku_1000basex_pcstx_sgmii_speed == 1'd0)) begin
            main_ku_1000basex_pcstx_timer <= 7'd99;
        end else begin
            if ((main_ku_1000basex_pcstx_sgmii_speed == 1'd1)) begin
                main_ku_1000basex_pcstx_timer <= 4'd9;
            end else begin
                if ((main_ku_1000basex_pcstx_sgmii_speed == 2'd2)) begin
                    main_ku_1000basex_pcstx_timer <= 1'd0;
                end
            end
        end
    end else begin
        if (main_ku_1000basex_pcstx_timer_en) begin
            main_ku_1000basex_pcstx_timer <= (main_ku_1000basex_pcstx_timer - 1'd1);
        end
    end
    if (main_ku_1000basex_pcstx_ce0) begin
        main_ku_1000basex_pcstx_disp_in <= main_ku_1000basex_pcstx_disp_out;
    end
    if (main_ku_1000basex_pcstx_ce0) begin
        main_ku_1000basex_pcstx_output0 <= main_ku_1000basex_pcstx_output1;
        main_ku_1000basex_pcstx_disparity <= main_ku_1000basex_pcstx_disp_out;
    end
    if (main_ku_1000basex_pcstx_ce1) begin
        if ((main_ku_1000basex_pcstx_k1 & (main_ku_1000basex_pcstx_d1[4:0] == 5'd28))) begin
            main_ku_1000basex_pcstx_code6b <= 6'd48;
            main_ku_1000basex_pcstx_code6b_unbalanced <= 1'd1;
            main_ku_1000basex_pcstx_code6b_flip <= 1'd1;
        end else begin
            main_ku_1000basex_pcstx_code6b <= builder_sync_rhs_array_muxed0;
            main_ku_1000basex_pcstx_code6b_unbalanced <= builder_sync_rhs_array_muxed1;
            main_ku_1000basex_pcstx_code6b_flip <= builder_sync_rhs_array_muxed2;
        end
        main_ku_1000basex_pcstx_code4b <= builder_sync_rhs_array_muxed3;
        main_ku_1000basex_pcstx_code4b_unbalanced <= builder_sync_rhs_array_muxed4;
        if (main_ku_1000basex_pcstx_k1) begin
            main_ku_1000basex_pcstx_code4b_flip <= 1'd1;
        end else begin
            main_ku_1000basex_pcstx_code4b_flip <= builder_sync_rhs_array_muxed5;
        end
        main_ku_1000basex_pcstx_alt7_rd0 <= 1'd0;
        main_ku_1000basex_pcstx_alt7_rd1 <= 1'd0;
        if ((main_ku_1000basex_pcstx_d1[7:5] == 3'd7)) begin
            if ((((main_ku_1000basex_pcstx_d1[4:0] == 5'd17) | (main_ku_1000basex_pcstx_d1[4:0] == 5'd18)) | (main_ku_1000basex_pcstx_d1[4:0] == 5'd20))) begin
                main_ku_1000basex_pcstx_alt7_rd0 <= 1'd1;
            end
            if ((((main_ku_1000basex_pcstx_d1[4:0] == 4'd11) | (main_ku_1000basex_pcstx_d1[4:0] == 4'd13)) | (main_ku_1000basex_pcstx_d1[4:0] == 4'd14))) begin
                main_ku_1000basex_pcstx_alt7_rd1 <= 1'd1;
            end
            if (main_ku_1000basex_pcstx_k1) begin
                main_ku_1000basex_pcstx_alt7_rd0 <= 1'd1;
                main_ku_1000basex_pcstx_alt7_rd1 <= 1'd1;
            end
        end
    end
    builder_soclinux_ku_1000basex_pcstx_state <= builder_soclinux_ku_1000basex_pcstx_next_state;
    if (main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value_ce) begin
        main_ku_1000basex_pcstx_c_type <= main_ku_1000basex_pcstx_c_type_ku_1000basex_next_value;
    end
    main_ku_1000basex_lp_abi_ping_o1 <= main_ku_1000basex_lp_abi_ping_o0;
    if (main_ku_1000basex_lp_abi_ping_o1) begin
        main_ku_1000basex_lp_abi_o <= main_ku_1000basex_lp_abi_obuffer;
    end
    main_ku_1000basex_lp_abi_ping_toggle_o_r <= main_ku_1000basex_lp_abi_ping_toggle_o;
    if (main_ku_1000basex_lp_abi_pong_i) begin
        main_ku_1000basex_lp_abi_pong_toggle_i <= (~main_ku_1000basex_lp_abi_pong_toggle_i);
    end
    main_ku_1000basex_seen_valid_ci_toggle_o_r <= main_ku_1000basex_seen_valid_ci_toggle_o;
    main_ku_1000basex_rx_config_reg_abi_toggle_o_r <= main_ku_1000basex_rx_config_reg_abi_toggle_o;
    main_ku_1000basex_rx_config_reg_ack_toggle_o_r <= main_ku_1000basex_rx_config_reg_ack_toggle_o;
    if (main_ku_1000basex_waittimer0_wait) begin
        if ((~main_ku_1000basex_waittimer0_done)) begin
            main_ku_1000basex_waittimer0_count <= (main_ku_1000basex_waittimer0_count - 1'd1);
        end
    end else begin
        main_ku_1000basex_waittimer0_count <= 21'd1250000;
    end
    if (main_ku_1000basex_waittimer1_wait) begin
        if ((~main_ku_1000basex_waittimer1_done)) begin
            main_ku_1000basex_waittimer1_count <= (main_ku_1000basex_waittimer1_count - 1'd1);
        end
    end else begin
        main_ku_1000basex_waittimer1_count <= 18'd200000;
    end
    builder_soclinux_ku_1000basex_fsm_state <= builder_soclinux_ku_1000basex_fsm_next_state;
    main_ku_1000basex_buf <= {main_ku_1000basex_tx_data1, main_ku_1000basex_buf[19:10]};
    main_ethmac_tx_cdc_cdc_graycounter1_q_binary <= main_ethmac_tx_cdc_cdc_graycounter1_q_next_binary;
    main_ethmac_tx_cdc_cdc_graycounter1_q <= main_ethmac_tx_cdc_cdc_graycounter1_q_next;
    if ((main_ethmac_tx_converter_converter_source_valid & main_ethmac_tx_converter_converter_source_ready)) begin
        if (main_ethmac_tx_converter_converter_last) begin
            main_ethmac_tx_converter_converter_mux <= 1'd0;
        end else begin
            main_ethmac_tx_converter_converter_mux <= (main_ethmac_tx_converter_converter_mux + 1'd1);
        end
    end
    builder_soclinux_txdatapath_liteethmactxlastbe_state <= builder_soclinux_txdatapath_liteethmactxlastbe_next_state;
    builder_soclinux_txdatapath_liteethmacpaddinginserter_state <= builder_soclinux_txdatapath_liteethmacpaddinginserter_next_state;
    if (main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value_ce) begin
        main_ethmac_tx_padding_counter <= main_ethmac_tx_padding_counter_clockdomainsrenamer_clockdomainsrenamer0_next_value;
    end
    if (main_ethmac_tx_crc_is_ongoing0) begin
        main_ethmac_tx_crc_cnt <= 2'd3;
    end else begin
        if ((main_ethmac_tx_crc_is_ongoing1 & (~main_ethmac_tx_crc_cnt_done))) begin
            main_ethmac_tx_crc_cnt <= (main_ethmac_tx_crc_cnt - main_ethmac_tx_crc_source_ready);
        end
    end
    if (main_ethmac_tx_crc_ce) begin
        main_ethmac_tx_crc_reg <= main_ethmac_tx_crc_next;
    end
    if (main_ethmac_tx_crc_reset) begin
        main_ethmac_tx_crc_reg <= 32'd4294967295;
    end
    builder_soclinux_txdatapath_bufferizeendpoints_state <= builder_soclinux_txdatapath_bufferizeendpoints_next_state;
    if (main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce0) begin
        main_ethmac_tx_crc_crc_packet <= main_ethmac_tx_crc_crc_packet_clockdomainsrenamer_clockdomainsrenamer1_next_value0;
    end
    if (main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value_ce1) begin
        main_ethmac_tx_crc_last_be2 <= main_ethmac_tx_crc_last_be2_clockdomainsrenamer_clockdomainsrenamer1_next_value1;
    end
    if (((~main_ethmac_tx_crc_pipe_valid_source_valid) | main_ethmac_tx_crc_pipe_valid_source_ready)) begin
        main_ethmac_tx_crc_pipe_valid_source_valid <= main_ethmac_tx_crc_pipe_valid_sink_valid;
        main_ethmac_tx_crc_pipe_valid_source_first <= main_ethmac_tx_crc_pipe_valid_sink_first;
        main_ethmac_tx_crc_pipe_valid_source_last <= main_ethmac_tx_crc_pipe_valid_sink_last;
        main_ethmac_tx_crc_pipe_valid_source_payload_data <= main_ethmac_tx_crc_pipe_valid_sink_payload_data;
        main_ethmac_tx_crc_pipe_valid_source_payload_last_be <= main_ethmac_tx_crc_pipe_valid_sink_payload_last_be;
        main_ethmac_tx_crc_pipe_valid_source_payload_error <= main_ethmac_tx_crc_pipe_valid_sink_payload_error;
    end
    builder_soclinux_txdatapath_liteethmacpreambleinserter_state <= builder_soclinux_txdatapath_liteethmacpreambleinserter_next_state;
    if (main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value_ce) begin
        main_ethmac_tx_preamble_count <= main_ethmac_tx_preamble_count_clockdomainsrenamer_clockdomainsrenamer2_next_value;
    end
    builder_soclinux_txdatapath_liteethmacgap_state <= builder_soclinux_txdatapath_liteethmacgap_next_state;
    if (main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value_ce) begin
        main_ethmac_tx_gap_counter <= main_ethmac_tx_gap_counter_clockdomainsrenamer_clockdomainsrenamer3_next_value;
    end
    if (eth_tx_rst) begin
        main_ku_1000basex_pcstx_disparity <= 1'd0;
        main_ku_1000basex_pcstx_disp_in <= 1'd0;
        main_ku_1000basex_pcstx_code6b_flip <= 1'd0;
        main_ku_1000basex_pcstx_code4b_flip <= 1'd0;
        main_ku_1000basex_pcstx_parity <= 1'd0;
        main_ku_1000basex_pcstx_c_type <= 1'd0;
        main_ku_1000basex_pcstx_config_reg_buffer <= 16'd0;
        main_ku_1000basex_pcstx_timer <= 10'd0;
        main_ku_1000basex_lp_abi_ping_o1 <= 1'd0;
        main_ku_1000basex_checker_counter <= 20'd0;
        main_ku_1000basex_checker_tick <= 1'd0;
        main_ku_1000basex_checker_ok <= 1'd0;
        main_ku_1000basex_waittimer0_count <= 21'd1250000;
        main_ku_1000basex_waittimer1_count <= 18'd200000;
        main_ku_1000basex_buf <= 20'd0;
        main_ethmac_tx_cdc_cdc_graycounter1_q <= 6'd0;
        main_ethmac_tx_cdc_cdc_graycounter1_q_binary <= 6'd0;
        main_ethmac_tx_converter_converter_mux <= 2'd0;
        main_ethmac_tx_padding_counter <= 16'd0;
        main_ethmac_tx_crc_reg <= 32'd4294967295;
        main_ethmac_tx_crc_crc_packet <= 32'd0;
        main_ethmac_tx_crc_last_be2 <= 1'd0;
        main_ethmac_tx_crc_cnt <= 2'd3;
        main_ethmac_tx_crc_pipe_valid_source_valid <= 1'd0;
        main_ethmac_tx_crc_pipe_valid_source_payload_data <= 8'd0;
        main_ethmac_tx_crc_pipe_valid_source_payload_last_be <= 1'd0;
        main_ethmac_tx_crc_pipe_valid_source_payload_error <= 1'd0;
        builder_soclinux_ku_1000basex_pcstx_state <= 3'd0;
        builder_soclinux_ku_1000basex_fsm_state <= 3'd0;
        builder_soclinux_txdatapath_liteethmactxlastbe_state <= 1'd0;
        builder_soclinux_txdatapath_liteethmacpaddinginserter_state <= 1'd0;
        builder_soclinux_txdatapath_bufferizeendpoints_state <= 2'd0;
        builder_soclinux_txdatapath_liteethmacpreambleinserter_state <= 2'd0;
        builder_soclinux_txdatapath_liteethmacgap_state <= 1'd0;
    end
    builder_xilinxmultiregimpl1_regs0 <= main_ku_1000basex_lp_abi_ping_toggle_i;
    builder_xilinxmultiregimpl1_regs1 <= builder_xilinxmultiregimpl1_regs0;
    builder_xilinxmultiregimpl3_regs0 <= main_ku_1000basex_lp_abi_ibuffer;
    builder_xilinxmultiregimpl3_regs1 <= builder_xilinxmultiregimpl3_regs0;
    builder_xilinxmultiregimpl4_regs0 <= main_ku_1000basex_seen_valid_ci_toggle_i;
    builder_xilinxmultiregimpl4_regs1 <= builder_xilinxmultiregimpl4_regs0;
    builder_xilinxmultiregimpl5_regs0 <= main_ku_1000basex_rx_config_reg_abi_toggle_i;
    builder_xilinxmultiregimpl5_regs1 <= builder_xilinxmultiregimpl5_regs0;
    builder_xilinxmultiregimpl6_regs0 <= main_ku_1000basex_rx_config_reg_ack_toggle_i;
    builder_xilinxmultiregimpl6_regs1 <= builder_xilinxmultiregimpl6_regs0;
    builder_xilinxmultiregimpl7_regs0 <= main_ethmac_tx_cdc_cdc_graycounter0_q;
    builder_xilinxmultiregimpl7_regs1 <= builder_xilinxmultiregimpl7_regs0;
end

always @(posedge eth_tx_half_clk) begin
    main_ku_1000basex_tx_data_half <= main_ku_1000basex_buf;
end

always @(posedge ic_clk) begin
    sys_rst <= 1'd1;
    if (main_crg_idelayctrl_ic_ready) begin
        if ((main_crg_idelayctrl_ic_ready_counter != 1'd0)) begin
            main_crg_idelayctrl_ic_ready_counter <= (main_crg_idelayctrl_ic_ready_counter - 1'd1);
        end else begin
            sys_rst <= 1'd0;
        end
    end
    if (ic_rst) begin
        sys_rst <= 1'd0;
        main_crg_idelayctrl_ic_ready_counter <= 6'd63;
    end
end

always @(posedge idelay_clk) begin
    if ((main_crg_idelayctrl_ic_reset_counter != 1'd0)) begin
        main_crg_idelayctrl_ic_reset_counter <= (main_crg_idelayctrl_ic_reset_counter - 1'd1);
    end else begin
        main_crg_idelayctrl_ic_reset <= 1'd0;
    end
    if (idelay_rst) begin
        main_crg_idelayctrl_ic_reset_counter <= 6'd63;
        main_crg_idelayctrl_ic_reset <= 1'd1;
    end
end

always @(posedge sys_clk) begin
    builder_socbushandler0_slave_sel_r <= builder_socbushandler0_slave_sel;
    if (builder_socbushandler0_wait) begin
        if ((~builder_socbushandler0_done)) begin
            builder_socbushandler0_count <= (builder_socbushandler0_count - 1'd1);
        end
    end else begin
        builder_socbushandler0_count <= 20'd1000000;
    end
    if ((main_bus_errors != 32'd4294967295)) begin
        if (main_bus_error) begin
            main_bus_errors <= (main_bus_errors + 1'd1);
        end
    end
    if (builder_csr_bankarray_csrbank0_reset0_re) begin
        main_reset_storage[1:0] <= builder_csr_bankarray_csrbank0_reset0_r;
    end
    main_reset_re <= builder_csr_bankarray_csrbank0_reset0_re;
    if (builder_csr_bankarray_csrbank0_scratch0_re) begin
        main_scratch_storage[31:0] <= builder_csr_bankarray_csrbank0_scratch0_r;
    end
    main_scratch_re <= builder_csr_bankarray_csrbank0_scratch0_re;
    main_bus_errors_re <= builder_csr_bankarray_csrbank0_bus_errors_re;
    if (((main_cpu_dma_bus_stb & main_cpu_dma_bus_cyc) & (~main_cpu_dma_bus_stall))) begin
        main_cpu_dma_bus_inhibit <= 1'd1;
    end
    if (main_cpu_dma_bus_ack) begin
        main_cpu_dma_bus_inhibit <= 1'd0;
    end
    case (builder_socbushandler1_grant)
        1'd0: begin
            if ((~builder_socbushandler1_request[0])) begin
                if (builder_socbushandler1_request[1]) begin
                    builder_socbushandler1_grant <= 1'd1;
                end
            end
        end
        1'd1: begin
            if ((~builder_socbushandler1_request[1])) begin
                if (builder_socbushandler1_request[0]) begin
                    builder_socbushandler1_grant <= 1'd0;
                end
            end
        end
    endcase
    builder_socbushandler1_slave_sel_r <= builder_socbushandler1_slave_sel;
    if (builder_socbushandler1_wait) begin
        if ((~builder_socbushandler1_done)) begin
            builder_socbushandler1_count <= (builder_socbushandler1_count - 1'd1);
        end
    end else begin
        builder_socbushandler1_count <= 20'd1000000;
    end
    main_soclinux_ram_bus_ack <= 1'd0;
    if (((main_soclinux_ram_bus_cyc & main_soclinux_ram_bus_stb) & ((~main_soclinux_ram_bus_ack) | main_soclinux_adr_burst))) begin
        main_soclinux_ram_bus_ack <= 1'd1;
    end
    main_ram_bus_ram_bus_ack <= 1'd0;
    if (((main_ram_bus_ram_bus_cyc & main_ram_bus_ram_bus_stb) & ((~main_ram_bus_ram_bus_ack) | main_ram_adr_burst))) begin
        main_ram_bus_ram_bus_ack <= 1'd1;
    end
    {main_tx_tick, main_tx_phase} <= 22'd3958241;
    if (main_tx_enable) begin
        {main_tx_tick, main_tx_phase} <= (main_tx_phase + 22'd3958241);
    end
    builder_soclinux_rs232phytx_state <= builder_soclinux_rs232phytx_next_state;
    if (main_tx_count_rs232phytx_next_value_ce0) begin
        main_tx_count <= main_tx_count_rs232phytx_next_value0;
    end
    if (main_serial_tx_rs232phytx_next_value_ce1) begin
        serial_tx <= main_serial_tx_rs232phytx_next_value1;
    end
    if (main_tx_data_rs232phytx_next_value_ce2) begin
        main_tx_data <= main_tx_data_rs232phytx_next_value2;
    end
    main_rx_rx_d <= main_rx_rx;
    {main_rx_tick, main_rx_phase} <= 32'd2147483648;
    if (main_rx_enable) begin
        {main_rx_tick, main_rx_phase} <= (main_rx_phase + 22'd3958241);
    end
    builder_soclinux_rs232phyrx_state <= builder_soclinux_rs232phyrx_next_state;
    if (main_rx_count_rs232phyrx_next_value_ce0) begin
        main_rx_count <= main_rx_count_rs232phyrx_next_value0;
    end
    if (main_rx_data_rs232phyrx_next_value_ce1) begin
        main_rx_data <= main_rx_data_rs232phyrx_next_value1;
    end
    if (main_uart_tx_clear) begin
        main_uart_tx_pending <= 1'd0;
    end
    main_uart_tx_trigger_d <= main_uart_tx_trigger;
    if ((main_uart_tx_trigger & (~main_uart_tx_trigger_d))) begin
        main_uart_tx_pending <= 1'd1;
    end
    if (main_uart_rx_clear) begin
        main_uart_rx_pending <= 1'd0;
    end
    main_uart_rx_trigger_d <= main_uart_rx_trigger;
    if ((main_uart_rx_trigger & (~main_uart_rx_trigger_d))) begin
        main_uart_rx_pending <= 1'd1;
    end
    if (main_uart_tx_fifo_syncfifo_re) begin
        main_uart_tx_fifo_readable <= 1'd1;
    end else begin
        if (main_uart_tx_fifo_re) begin
            main_uart_tx_fifo_readable <= 1'd0;
        end
    end
    if (((main_uart_tx_fifo_syncfifo_we & main_uart_tx_fifo_syncfifo_writable) & (~main_uart_tx_fifo_replace))) begin
        main_uart_tx_fifo_produce <= (main_uart_tx_fifo_produce + 1'd1);
    end
    if (main_uart_tx_fifo_do_read) begin
        main_uart_tx_fifo_consume <= (main_uart_tx_fifo_consume + 1'd1);
    end
    if (((main_uart_tx_fifo_syncfifo_we & main_uart_tx_fifo_syncfifo_writable) & (~main_uart_tx_fifo_replace))) begin
        if ((~main_uart_tx_fifo_do_read)) begin
            main_uart_tx_fifo_level0 <= (main_uart_tx_fifo_level0 + 1'd1);
        end
    end else begin
        if (main_uart_tx_fifo_do_read) begin
            main_uart_tx_fifo_level0 <= (main_uart_tx_fifo_level0 - 1'd1);
        end
    end
    if (main_uart_rx_fifo_syncfifo_re) begin
        main_uart_rx_fifo_readable <= 1'd1;
    end else begin
        if (main_uart_rx_fifo_re) begin
            main_uart_rx_fifo_readable <= 1'd0;
        end
    end
    if (((main_uart_rx_fifo_syncfifo_we & main_uart_rx_fifo_syncfifo_writable) & (~main_uart_rx_fifo_replace))) begin
        main_uart_rx_fifo_produce <= (main_uart_rx_fifo_produce + 1'd1);
    end
    if (main_uart_rx_fifo_do_read) begin
        main_uart_rx_fifo_consume <= (main_uart_rx_fifo_consume + 1'd1);
    end
    if (((main_uart_rx_fifo_syncfifo_we & main_uart_rx_fifo_syncfifo_writable) & (~main_uart_rx_fifo_replace))) begin
        if ((~main_uart_rx_fifo_do_read)) begin
            main_uart_rx_fifo_level0 <= (main_uart_rx_fifo_level0 + 1'd1);
        end
    end else begin
        if (main_uart_rx_fifo_do_read) begin
            main_uart_rx_fifo_level0 <= (main_uart_rx_fifo_level0 - 1'd1);
        end
    end
    if (main_timer_en_storage) begin
        if ((main_timer_value == 1'd0)) begin
            main_timer_value <= main_timer_reload_storage;
        end else begin
            main_timer_value <= (main_timer_value - 1'd1);
        end
    end else begin
        main_timer_value <= main_timer_load_storage;
    end
    if (main_timer_update_value_re) begin
        main_timer_value_status <= main_timer_value;
    end
    if (main_timer_zero_clear) begin
        main_timer_zero_pending <= 1'd0;
    end
    main_timer_zero_trigger_d <= main_timer_zero_trigger;
    if ((main_timer_zero_trigger & (~main_timer_zero_trigger_d))) begin
        main_timer_zero_pending <= 1'd1;
    end
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count0 <= (main_usddrphy_wdly_dqs_inc_count0 + 1'd1);
    end
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count1 <= (main_usddrphy_wdly_dqs_inc_count1 + 1'd1);
    end
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count2 <= (main_usddrphy_wdly_dqs_inc_count2 + 1'd1);
    end
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count3 <= (main_usddrphy_wdly_dqs_inc_count3 + 1'd1);
    end
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count4 <= (main_usddrphy_wdly_dqs_inc_count4 + 1'd1);
    end
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count5 <= (main_usddrphy_wdly_dqs_inc_count5 + 1'd1);
    end
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count6 <= (main_usddrphy_wdly_dqs_inc_count6 + 1'd1);
    end
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dqs_inc_re)) begin
        main_usddrphy_wdly_dqs_inc_count7 <= (main_usddrphy_wdly_dqs_inc_count7 + 1'd1);
    end
    main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline <= main_usddrphy_dqs_oe_delay_tappeddelayline;
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip0_value0 <= (main_usddrphy_bitslip0_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip0_value0 <= 3'd7;
    end
    main_usddrphy_bitslip0_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip0_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip1_value0 <= (main_usddrphy_bitslip1_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip1_value0 <= 3'd7;
    end
    main_usddrphy_bitslip1_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip1_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip2_value0 <= (main_usddrphy_bitslip2_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip2_value0 <= 3'd7;
    end
    main_usddrphy_bitslip2_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip2_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip3_value0 <= (main_usddrphy_bitslip3_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip3_value0 <= 3'd7;
    end
    main_usddrphy_bitslip3_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip3_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip4_value0 <= (main_usddrphy_bitslip4_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip4_value0 <= 3'd7;
    end
    main_usddrphy_bitslip4_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip4_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip5_value0 <= (main_usddrphy_bitslip5_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip5_value0 <= 3'd7;
    end
    main_usddrphy_bitslip5_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip5_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip6_value0 <= (main_usddrphy_bitslip6_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip6_value0 <= 3'd7;
    end
    main_usddrphy_bitslip6_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip6_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip7_value0 <= (main_usddrphy_bitslip7_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip7_value0 <= 3'd7;
    end
    main_usddrphy_bitslip7_r0 <= {main_usddrphy_dqspattern_o, main_usddrphy_bitslip7_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip0_value1 <= (main_usddrphy_bitslip0_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip0_value1 <= 3'd7;
    end
    main_usddrphy_bitslip0_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[8], main_usddrphy_interface1_dfi_p3_wrdata_mask[0], main_usddrphy_interface1_dfi_p2_wrdata_mask[8], main_usddrphy_interface1_dfi_p2_wrdata_mask[0], main_usddrphy_interface1_dfi_p1_wrdata_mask[8], main_usddrphy_interface1_dfi_p1_wrdata_mask[0], main_usddrphy_interface1_dfi_p0_wrdata_mask[8], main_usddrphy_interface1_dfi_p0_wrdata_mask[0]}), main_usddrphy_bitslip0_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip1_value1 <= (main_usddrphy_bitslip1_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip1_value1 <= 3'd7;
    end
    main_usddrphy_bitslip1_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[9], main_usddrphy_interface1_dfi_p3_wrdata_mask[1], main_usddrphy_interface1_dfi_p2_wrdata_mask[9], main_usddrphy_interface1_dfi_p2_wrdata_mask[1], main_usddrphy_interface1_dfi_p1_wrdata_mask[9], main_usddrphy_interface1_dfi_p1_wrdata_mask[1], main_usddrphy_interface1_dfi_p0_wrdata_mask[9], main_usddrphy_interface1_dfi_p0_wrdata_mask[1]}), main_usddrphy_bitslip1_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip2_value1 <= (main_usddrphy_bitslip2_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip2_value1 <= 3'd7;
    end
    main_usddrphy_bitslip2_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[10], main_usddrphy_interface1_dfi_p3_wrdata_mask[2], main_usddrphy_interface1_dfi_p2_wrdata_mask[10], main_usddrphy_interface1_dfi_p2_wrdata_mask[2], main_usddrphy_interface1_dfi_p1_wrdata_mask[10], main_usddrphy_interface1_dfi_p1_wrdata_mask[2], main_usddrphy_interface1_dfi_p0_wrdata_mask[10], main_usddrphy_interface1_dfi_p0_wrdata_mask[2]}), main_usddrphy_bitslip2_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip3_value1 <= (main_usddrphy_bitslip3_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip3_value1 <= 3'd7;
    end
    main_usddrphy_bitslip3_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[11], main_usddrphy_interface1_dfi_p3_wrdata_mask[3], main_usddrphy_interface1_dfi_p2_wrdata_mask[11], main_usddrphy_interface1_dfi_p2_wrdata_mask[3], main_usddrphy_interface1_dfi_p1_wrdata_mask[11], main_usddrphy_interface1_dfi_p1_wrdata_mask[3], main_usddrphy_interface1_dfi_p0_wrdata_mask[11], main_usddrphy_interface1_dfi_p0_wrdata_mask[3]}), main_usddrphy_bitslip3_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip4_value1 <= (main_usddrphy_bitslip4_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip4_value1 <= 3'd7;
    end
    main_usddrphy_bitslip4_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[12], main_usddrphy_interface1_dfi_p3_wrdata_mask[4], main_usddrphy_interface1_dfi_p2_wrdata_mask[12], main_usddrphy_interface1_dfi_p2_wrdata_mask[4], main_usddrphy_interface1_dfi_p1_wrdata_mask[12], main_usddrphy_interface1_dfi_p1_wrdata_mask[4], main_usddrphy_interface1_dfi_p0_wrdata_mask[12], main_usddrphy_interface1_dfi_p0_wrdata_mask[4]}), main_usddrphy_bitslip4_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip5_value1 <= (main_usddrphy_bitslip5_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip5_value1 <= 3'd7;
    end
    main_usddrphy_bitslip5_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[13], main_usddrphy_interface1_dfi_p3_wrdata_mask[5], main_usddrphy_interface1_dfi_p2_wrdata_mask[13], main_usddrphy_interface1_dfi_p2_wrdata_mask[5], main_usddrphy_interface1_dfi_p1_wrdata_mask[13], main_usddrphy_interface1_dfi_p1_wrdata_mask[5], main_usddrphy_interface1_dfi_p0_wrdata_mask[13], main_usddrphy_interface1_dfi_p0_wrdata_mask[5]}), main_usddrphy_bitslip5_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip6_value1 <= (main_usddrphy_bitslip6_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip6_value1 <= 3'd7;
    end
    main_usddrphy_bitslip6_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[14], main_usddrphy_interface1_dfi_p3_wrdata_mask[6], main_usddrphy_interface1_dfi_p2_wrdata_mask[14], main_usddrphy_interface1_dfi_p2_wrdata_mask[6], main_usddrphy_interface1_dfi_p1_wrdata_mask[14], main_usddrphy_interface1_dfi_p1_wrdata_mask[6], main_usddrphy_interface1_dfi_p0_wrdata_mask[14], main_usddrphy_interface1_dfi_p0_wrdata_mask[6]}), main_usddrphy_bitslip6_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip7_value1 <= (main_usddrphy_bitslip7_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip7_value1 <= 3'd7;
    end
    main_usddrphy_bitslip7_r1 <= {(~{main_usddrphy_interface1_dfi_p3_wrdata_mask[15], main_usddrphy_interface1_dfi_p3_wrdata_mask[7], main_usddrphy_interface1_dfi_p2_wrdata_mask[15], main_usddrphy_interface1_dfi_p2_wrdata_mask[7], main_usddrphy_interface1_dfi_p1_wrdata_mask[15], main_usddrphy_interface1_dfi_p1_wrdata_mask[7], main_usddrphy_interface1_dfi_p0_wrdata_mask[15], main_usddrphy_interface1_dfi_p0_wrdata_mask[7]}), main_usddrphy_bitslip7_r1[15:8]};
    main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline <= main_usddrphy_dq_oe_delay_tappeddelayline;
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip0_value2 <= (main_usddrphy_bitslip0_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip0_value2 <= 3'd7;
    end
    main_usddrphy_bitslip0_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[64], main_usddrphy_interface1_dfi_p3_wrdata[0], main_usddrphy_interface1_dfi_p2_wrdata[64], main_usddrphy_interface1_dfi_p2_wrdata[0], main_usddrphy_interface1_dfi_p1_wrdata[64], main_usddrphy_interface1_dfi_p1_wrdata[0], main_usddrphy_interface1_dfi_p0_wrdata[64], main_usddrphy_interface1_dfi_p0_wrdata[0]}, main_usddrphy_bitslip0_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip0_value3 <= (main_usddrphy_bitslip0_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip0_value3 <= 3'd7;
    end
    main_usddrphy_bitslip0_r3 <= {main_usddrphy_bitslip03, main_usddrphy_bitslip0_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip1_value2 <= (main_usddrphy_bitslip1_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip1_value2 <= 3'd7;
    end
    main_usddrphy_bitslip1_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[65], main_usddrphy_interface1_dfi_p3_wrdata[1], main_usddrphy_interface1_dfi_p2_wrdata[65], main_usddrphy_interface1_dfi_p2_wrdata[1], main_usddrphy_interface1_dfi_p1_wrdata[65], main_usddrphy_interface1_dfi_p1_wrdata[1], main_usddrphy_interface1_dfi_p0_wrdata[65], main_usddrphy_interface1_dfi_p0_wrdata[1]}, main_usddrphy_bitslip1_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip1_value3 <= (main_usddrphy_bitslip1_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip1_value3 <= 3'd7;
    end
    main_usddrphy_bitslip1_r3 <= {main_usddrphy_bitslip13, main_usddrphy_bitslip1_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip2_value2 <= (main_usddrphy_bitslip2_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip2_value2 <= 3'd7;
    end
    main_usddrphy_bitslip2_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[66], main_usddrphy_interface1_dfi_p3_wrdata[2], main_usddrphy_interface1_dfi_p2_wrdata[66], main_usddrphy_interface1_dfi_p2_wrdata[2], main_usddrphy_interface1_dfi_p1_wrdata[66], main_usddrphy_interface1_dfi_p1_wrdata[2], main_usddrphy_interface1_dfi_p0_wrdata[66], main_usddrphy_interface1_dfi_p0_wrdata[2]}, main_usddrphy_bitslip2_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip2_value3 <= (main_usddrphy_bitslip2_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip2_value3 <= 3'd7;
    end
    main_usddrphy_bitslip2_r3 <= {main_usddrphy_bitslip23, main_usddrphy_bitslip2_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip3_value2 <= (main_usddrphy_bitslip3_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip3_value2 <= 3'd7;
    end
    main_usddrphy_bitslip3_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[67], main_usddrphy_interface1_dfi_p3_wrdata[3], main_usddrphy_interface1_dfi_p2_wrdata[67], main_usddrphy_interface1_dfi_p2_wrdata[3], main_usddrphy_interface1_dfi_p1_wrdata[67], main_usddrphy_interface1_dfi_p1_wrdata[3], main_usddrphy_interface1_dfi_p0_wrdata[67], main_usddrphy_interface1_dfi_p0_wrdata[3]}, main_usddrphy_bitslip3_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip3_value3 <= (main_usddrphy_bitslip3_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip3_value3 <= 3'd7;
    end
    main_usddrphy_bitslip3_r3 <= {main_usddrphy_bitslip33, main_usddrphy_bitslip3_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip4_value2 <= (main_usddrphy_bitslip4_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip4_value2 <= 3'd7;
    end
    main_usddrphy_bitslip4_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[68], main_usddrphy_interface1_dfi_p3_wrdata[4], main_usddrphy_interface1_dfi_p2_wrdata[68], main_usddrphy_interface1_dfi_p2_wrdata[4], main_usddrphy_interface1_dfi_p1_wrdata[68], main_usddrphy_interface1_dfi_p1_wrdata[4], main_usddrphy_interface1_dfi_p0_wrdata[68], main_usddrphy_interface1_dfi_p0_wrdata[4]}, main_usddrphy_bitslip4_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip4_value3 <= (main_usddrphy_bitslip4_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip4_value3 <= 3'd7;
    end
    main_usddrphy_bitslip4_r3 <= {main_usddrphy_bitslip43, main_usddrphy_bitslip4_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip5_value2 <= (main_usddrphy_bitslip5_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip5_value2 <= 3'd7;
    end
    main_usddrphy_bitslip5_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[69], main_usddrphy_interface1_dfi_p3_wrdata[5], main_usddrphy_interface1_dfi_p2_wrdata[69], main_usddrphy_interface1_dfi_p2_wrdata[5], main_usddrphy_interface1_dfi_p1_wrdata[69], main_usddrphy_interface1_dfi_p1_wrdata[5], main_usddrphy_interface1_dfi_p0_wrdata[69], main_usddrphy_interface1_dfi_p0_wrdata[5]}, main_usddrphy_bitslip5_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip5_value3 <= (main_usddrphy_bitslip5_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip5_value3 <= 3'd7;
    end
    main_usddrphy_bitslip5_r3 <= {main_usddrphy_bitslip53, main_usddrphy_bitslip5_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip6_value2 <= (main_usddrphy_bitslip6_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip6_value2 <= 3'd7;
    end
    main_usddrphy_bitslip6_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[70], main_usddrphy_interface1_dfi_p3_wrdata[6], main_usddrphy_interface1_dfi_p2_wrdata[70], main_usddrphy_interface1_dfi_p2_wrdata[6], main_usddrphy_interface1_dfi_p1_wrdata[70], main_usddrphy_interface1_dfi_p1_wrdata[6], main_usddrphy_interface1_dfi_p0_wrdata[70], main_usddrphy_interface1_dfi_p0_wrdata[6]}, main_usddrphy_bitslip6_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip6_value3 <= (main_usddrphy_bitslip6_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip6_value3 <= 3'd7;
    end
    main_usddrphy_bitslip6_r3 <= {main_usddrphy_bitslip63, main_usddrphy_bitslip6_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip7_value2 <= (main_usddrphy_bitslip7_value2 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip7_value2 <= 3'd7;
    end
    main_usddrphy_bitslip7_r2 <= {{main_usddrphy_interface1_dfi_p3_wrdata[71], main_usddrphy_interface1_dfi_p3_wrdata[7], main_usddrphy_interface1_dfi_p2_wrdata[71], main_usddrphy_interface1_dfi_p2_wrdata[7], main_usddrphy_interface1_dfi_p1_wrdata[71], main_usddrphy_interface1_dfi_p1_wrdata[7], main_usddrphy_interface1_dfi_p0_wrdata[71], main_usddrphy_interface1_dfi_p0_wrdata[7]}, main_usddrphy_bitslip7_r2[15:8]};
    if ((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip7_value3 <= (main_usddrphy_bitslip7_value3 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip7_value3 <= 3'd7;
    end
    main_usddrphy_bitslip7_r3 <= {main_usddrphy_bitslip73, main_usddrphy_bitslip7_r3[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip8_value0 <= (main_usddrphy_bitslip8_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip8_value0 <= 3'd7;
    end
    main_usddrphy_bitslip8_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[72], main_usddrphy_interface1_dfi_p3_wrdata[8], main_usddrphy_interface1_dfi_p2_wrdata[72], main_usddrphy_interface1_dfi_p2_wrdata[8], main_usddrphy_interface1_dfi_p1_wrdata[72], main_usddrphy_interface1_dfi_p1_wrdata[8], main_usddrphy_interface1_dfi_p0_wrdata[72], main_usddrphy_interface1_dfi_p0_wrdata[8]}, main_usddrphy_bitslip8_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip8_value1 <= (main_usddrphy_bitslip8_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip8_value1 <= 3'd7;
    end
    main_usddrphy_bitslip8_r1 <= {main_usddrphy_bitslip81, main_usddrphy_bitslip8_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip9_value0 <= (main_usddrphy_bitslip9_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip9_value0 <= 3'd7;
    end
    main_usddrphy_bitslip9_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[73], main_usddrphy_interface1_dfi_p3_wrdata[9], main_usddrphy_interface1_dfi_p2_wrdata[73], main_usddrphy_interface1_dfi_p2_wrdata[9], main_usddrphy_interface1_dfi_p1_wrdata[73], main_usddrphy_interface1_dfi_p1_wrdata[9], main_usddrphy_interface1_dfi_p0_wrdata[73], main_usddrphy_interface1_dfi_p0_wrdata[9]}, main_usddrphy_bitslip9_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip9_value1 <= (main_usddrphy_bitslip9_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip9_value1 <= 3'd7;
    end
    main_usddrphy_bitslip9_r1 <= {main_usddrphy_bitslip91, main_usddrphy_bitslip9_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip10_value0 <= (main_usddrphy_bitslip10_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip10_value0 <= 3'd7;
    end
    main_usddrphy_bitslip10_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[74], main_usddrphy_interface1_dfi_p3_wrdata[10], main_usddrphy_interface1_dfi_p2_wrdata[74], main_usddrphy_interface1_dfi_p2_wrdata[10], main_usddrphy_interface1_dfi_p1_wrdata[74], main_usddrphy_interface1_dfi_p1_wrdata[10], main_usddrphy_interface1_dfi_p0_wrdata[74], main_usddrphy_interface1_dfi_p0_wrdata[10]}, main_usddrphy_bitslip10_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip10_value1 <= (main_usddrphy_bitslip10_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip10_value1 <= 3'd7;
    end
    main_usddrphy_bitslip10_r1 <= {main_usddrphy_bitslip101, main_usddrphy_bitslip10_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip11_value0 <= (main_usddrphy_bitslip11_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip11_value0 <= 3'd7;
    end
    main_usddrphy_bitslip11_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[75], main_usddrphy_interface1_dfi_p3_wrdata[11], main_usddrphy_interface1_dfi_p2_wrdata[75], main_usddrphy_interface1_dfi_p2_wrdata[11], main_usddrphy_interface1_dfi_p1_wrdata[75], main_usddrphy_interface1_dfi_p1_wrdata[11], main_usddrphy_interface1_dfi_p0_wrdata[75], main_usddrphy_interface1_dfi_p0_wrdata[11]}, main_usddrphy_bitslip11_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip11_value1 <= (main_usddrphy_bitslip11_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip11_value1 <= 3'd7;
    end
    main_usddrphy_bitslip11_r1 <= {main_usddrphy_bitslip111, main_usddrphy_bitslip11_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip12_value0 <= (main_usddrphy_bitslip12_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip12_value0 <= 3'd7;
    end
    main_usddrphy_bitslip12_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[76], main_usddrphy_interface1_dfi_p3_wrdata[12], main_usddrphy_interface1_dfi_p2_wrdata[76], main_usddrphy_interface1_dfi_p2_wrdata[12], main_usddrphy_interface1_dfi_p1_wrdata[76], main_usddrphy_interface1_dfi_p1_wrdata[12], main_usddrphy_interface1_dfi_p0_wrdata[76], main_usddrphy_interface1_dfi_p0_wrdata[12]}, main_usddrphy_bitslip12_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip12_value1 <= (main_usddrphy_bitslip12_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip12_value1 <= 3'd7;
    end
    main_usddrphy_bitslip12_r1 <= {main_usddrphy_bitslip121, main_usddrphy_bitslip12_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip13_value0 <= (main_usddrphy_bitslip13_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip13_value0 <= 3'd7;
    end
    main_usddrphy_bitslip13_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[77], main_usddrphy_interface1_dfi_p3_wrdata[13], main_usddrphy_interface1_dfi_p2_wrdata[77], main_usddrphy_interface1_dfi_p2_wrdata[13], main_usddrphy_interface1_dfi_p1_wrdata[77], main_usddrphy_interface1_dfi_p1_wrdata[13], main_usddrphy_interface1_dfi_p0_wrdata[77], main_usddrphy_interface1_dfi_p0_wrdata[13]}, main_usddrphy_bitslip13_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip13_value1 <= (main_usddrphy_bitslip13_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip13_value1 <= 3'd7;
    end
    main_usddrphy_bitslip13_r1 <= {main_usddrphy_bitslip131, main_usddrphy_bitslip13_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip14_value0 <= (main_usddrphy_bitslip14_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip14_value0 <= 3'd7;
    end
    main_usddrphy_bitslip14_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[78], main_usddrphy_interface1_dfi_p3_wrdata[14], main_usddrphy_interface1_dfi_p2_wrdata[78], main_usddrphy_interface1_dfi_p2_wrdata[14], main_usddrphy_interface1_dfi_p1_wrdata[78], main_usddrphy_interface1_dfi_p1_wrdata[14], main_usddrphy_interface1_dfi_p0_wrdata[78], main_usddrphy_interface1_dfi_p0_wrdata[14]}, main_usddrphy_bitslip14_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip14_value1 <= (main_usddrphy_bitslip14_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip14_value1 <= 3'd7;
    end
    main_usddrphy_bitslip14_r1 <= {main_usddrphy_bitslip141, main_usddrphy_bitslip14_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip15_value0 <= (main_usddrphy_bitslip15_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip15_value0 <= 3'd7;
    end
    main_usddrphy_bitslip15_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[79], main_usddrphy_interface1_dfi_p3_wrdata[15], main_usddrphy_interface1_dfi_p2_wrdata[79], main_usddrphy_interface1_dfi_p2_wrdata[15], main_usddrphy_interface1_dfi_p1_wrdata[79], main_usddrphy_interface1_dfi_p1_wrdata[15], main_usddrphy_interface1_dfi_p0_wrdata[79], main_usddrphy_interface1_dfi_p0_wrdata[15]}, main_usddrphy_bitslip15_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip15_value1 <= (main_usddrphy_bitslip15_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip15_value1 <= 3'd7;
    end
    main_usddrphy_bitslip15_r1 <= {main_usddrphy_bitslip151, main_usddrphy_bitslip15_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip16_value0 <= (main_usddrphy_bitslip16_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip16_value0 <= 3'd7;
    end
    main_usddrphy_bitslip16_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[80], main_usddrphy_interface1_dfi_p3_wrdata[16], main_usddrphy_interface1_dfi_p2_wrdata[80], main_usddrphy_interface1_dfi_p2_wrdata[16], main_usddrphy_interface1_dfi_p1_wrdata[80], main_usddrphy_interface1_dfi_p1_wrdata[16], main_usddrphy_interface1_dfi_p0_wrdata[80], main_usddrphy_interface1_dfi_p0_wrdata[16]}, main_usddrphy_bitslip16_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip16_value1 <= (main_usddrphy_bitslip16_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip16_value1 <= 3'd7;
    end
    main_usddrphy_bitslip16_r1 <= {main_usddrphy_bitslip161, main_usddrphy_bitslip16_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip17_value0 <= (main_usddrphy_bitslip17_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip17_value0 <= 3'd7;
    end
    main_usddrphy_bitslip17_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[81], main_usddrphy_interface1_dfi_p3_wrdata[17], main_usddrphy_interface1_dfi_p2_wrdata[81], main_usddrphy_interface1_dfi_p2_wrdata[17], main_usddrphy_interface1_dfi_p1_wrdata[81], main_usddrphy_interface1_dfi_p1_wrdata[17], main_usddrphy_interface1_dfi_p0_wrdata[81], main_usddrphy_interface1_dfi_p0_wrdata[17]}, main_usddrphy_bitslip17_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip17_value1 <= (main_usddrphy_bitslip17_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip17_value1 <= 3'd7;
    end
    main_usddrphy_bitslip17_r1 <= {main_usddrphy_bitslip171, main_usddrphy_bitslip17_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip18_value0 <= (main_usddrphy_bitslip18_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip18_value0 <= 3'd7;
    end
    main_usddrphy_bitslip18_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[82], main_usddrphy_interface1_dfi_p3_wrdata[18], main_usddrphy_interface1_dfi_p2_wrdata[82], main_usddrphy_interface1_dfi_p2_wrdata[18], main_usddrphy_interface1_dfi_p1_wrdata[82], main_usddrphy_interface1_dfi_p1_wrdata[18], main_usddrphy_interface1_dfi_p0_wrdata[82], main_usddrphy_interface1_dfi_p0_wrdata[18]}, main_usddrphy_bitslip18_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip18_value1 <= (main_usddrphy_bitslip18_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip18_value1 <= 3'd7;
    end
    main_usddrphy_bitslip18_r1 <= {main_usddrphy_bitslip181, main_usddrphy_bitslip18_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip19_value0 <= (main_usddrphy_bitslip19_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip19_value0 <= 3'd7;
    end
    main_usddrphy_bitslip19_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[83], main_usddrphy_interface1_dfi_p3_wrdata[19], main_usddrphy_interface1_dfi_p2_wrdata[83], main_usddrphy_interface1_dfi_p2_wrdata[19], main_usddrphy_interface1_dfi_p1_wrdata[83], main_usddrphy_interface1_dfi_p1_wrdata[19], main_usddrphy_interface1_dfi_p0_wrdata[83], main_usddrphy_interface1_dfi_p0_wrdata[19]}, main_usddrphy_bitslip19_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip19_value1 <= (main_usddrphy_bitslip19_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip19_value1 <= 3'd7;
    end
    main_usddrphy_bitslip19_r1 <= {main_usddrphy_bitslip191, main_usddrphy_bitslip19_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip20_value0 <= (main_usddrphy_bitslip20_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip20_value0 <= 3'd7;
    end
    main_usddrphy_bitslip20_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[84], main_usddrphy_interface1_dfi_p3_wrdata[20], main_usddrphy_interface1_dfi_p2_wrdata[84], main_usddrphy_interface1_dfi_p2_wrdata[20], main_usddrphy_interface1_dfi_p1_wrdata[84], main_usddrphy_interface1_dfi_p1_wrdata[20], main_usddrphy_interface1_dfi_p0_wrdata[84], main_usddrphy_interface1_dfi_p0_wrdata[20]}, main_usddrphy_bitslip20_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip20_value1 <= (main_usddrphy_bitslip20_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip20_value1 <= 3'd7;
    end
    main_usddrphy_bitslip20_r1 <= {main_usddrphy_bitslip201, main_usddrphy_bitslip20_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip21_value0 <= (main_usddrphy_bitslip21_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip21_value0 <= 3'd7;
    end
    main_usddrphy_bitslip21_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[85], main_usddrphy_interface1_dfi_p3_wrdata[21], main_usddrphy_interface1_dfi_p2_wrdata[85], main_usddrphy_interface1_dfi_p2_wrdata[21], main_usddrphy_interface1_dfi_p1_wrdata[85], main_usddrphy_interface1_dfi_p1_wrdata[21], main_usddrphy_interface1_dfi_p0_wrdata[85], main_usddrphy_interface1_dfi_p0_wrdata[21]}, main_usddrphy_bitslip21_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip21_value1 <= (main_usddrphy_bitslip21_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip21_value1 <= 3'd7;
    end
    main_usddrphy_bitslip21_r1 <= {main_usddrphy_bitslip211, main_usddrphy_bitslip21_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip22_value0 <= (main_usddrphy_bitslip22_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip22_value0 <= 3'd7;
    end
    main_usddrphy_bitslip22_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[86], main_usddrphy_interface1_dfi_p3_wrdata[22], main_usddrphy_interface1_dfi_p2_wrdata[86], main_usddrphy_interface1_dfi_p2_wrdata[22], main_usddrphy_interface1_dfi_p1_wrdata[86], main_usddrphy_interface1_dfi_p1_wrdata[22], main_usddrphy_interface1_dfi_p0_wrdata[86], main_usddrphy_interface1_dfi_p0_wrdata[22]}, main_usddrphy_bitslip22_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip22_value1 <= (main_usddrphy_bitslip22_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip22_value1 <= 3'd7;
    end
    main_usddrphy_bitslip22_r1 <= {main_usddrphy_bitslip221, main_usddrphy_bitslip22_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip23_value0 <= (main_usddrphy_bitslip23_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip23_value0 <= 3'd7;
    end
    main_usddrphy_bitslip23_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[87], main_usddrphy_interface1_dfi_p3_wrdata[23], main_usddrphy_interface1_dfi_p2_wrdata[87], main_usddrphy_interface1_dfi_p2_wrdata[23], main_usddrphy_interface1_dfi_p1_wrdata[87], main_usddrphy_interface1_dfi_p1_wrdata[23], main_usddrphy_interface1_dfi_p0_wrdata[87], main_usddrphy_interface1_dfi_p0_wrdata[23]}, main_usddrphy_bitslip23_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip23_value1 <= (main_usddrphy_bitslip23_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip23_value1 <= 3'd7;
    end
    main_usddrphy_bitslip23_r1 <= {main_usddrphy_bitslip231, main_usddrphy_bitslip23_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip24_value0 <= (main_usddrphy_bitslip24_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip24_value0 <= 3'd7;
    end
    main_usddrphy_bitslip24_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[88], main_usddrphy_interface1_dfi_p3_wrdata[24], main_usddrphy_interface1_dfi_p2_wrdata[88], main_usddrphy_interface1_dfi_p2_wrdata[24], main_usddrphy_interface1_dfi_p1_wrdata[88], main_usddrphy_interface1_dfi_p1_wrdata[24], main_usddrphy_interface1_dfi_p0_wrdata[88], main_usddrphy_interface1_dfi_p0_wrdata[24]}, main_usddrphy_bitslip24_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip24_value1 <= (main_usddrphy_bitslip24_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip24_value1 <= 3'd7;
    end
    main_usddrphy_bitslip24_r1 <= {main_usddrphy_bitslip241, main_usddrphy_bitslip24_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip25_value0 <= (main_usddrphy_bitslip25_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip25_value0 <= 3'd7;
    end
    main_usddrphy_bitslip25_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[89], main_usddrphy_interface1_dfi_p3_wrdata[25], main_usddrphy_interface1_dfi_p2_wrdata[89], main_usddrphy_interface1_dfi_p2_wrdata[25], main_usddrphy_interface1_dfi_p1_wrdata[89], main_usddrphy_interface1_dfi_p1_wrdata[25], main_usddrphy_interface1_dfi_p0_wrdata[89], main_usddrphy_interface1_dfi_p0_wrdata[25]}, main_usddrphy_bitslip25_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip25_value1 <= (main_usddrphy_bitslip25_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip25_value1 <= 3'd7;
    end
    main_usddrphy_bitslip25_r1 <= {main_usddrphy_bitslip251, main_usddrphy_bitslip25_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip26_value0 <= (main_usddrphy_bitslip26_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip26_value0 <= 3'd7;
    end
    main_usddrphy_bitslip26_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[90], main_usddrphy_interface1_dfi_p3_wrdata[26], main_usddrphy_interface1_dfi_p2_wrdata[90], main_usddrphy_interface1_dfi_p2_wrdata[26], main_usddrphy_interface1_dfi_p1_wrdata[90], main_usddrphy_interface1_dfi_p1_wrdata[26], main_usddrphy_interface1_dfi_p0_wrdata[90], main_usddrphy_interface1_dfi_p0_wrdata[26]}, main_usddrphy_bitslip26_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip26_value1 <= (main_usddrphy_bitslip26_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip26_value1 <= 3'd7;
    end
    main_usddrphy_bitslip26_r1 <= {main_usddrphy_bitslip261, main_usddrphy_bitslip26_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip27_value0 <= (main_usddrphy_bitslip27_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip27_value0 <= 3'd7;
    end
    main_usddrphy_bitslip27_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[91], main_usddrphy_interface1_dfi_p3_wrdata[27], main_usddrphy_interface1_dfi_p2_wrdata[91], main_usddrphy_interface1_dfi_p2_wrdata[27], main_usddrphy_interface1_dfi_p1_wrdata[91], main_usddrphy_interface1_dfi_p1_wrdata[27], main_usddrphy_interface1_dfi_p0_wrdata[91], main_usddrphy_interface1_dfi_p0_wrdata[27]}, main_usddrphy_bitslip27_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip27_value1 <= (main_usddrphy_bitslip27_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip27_value1 <= 3'd7;
    end
    main_usddrphy_bitslip27_r1 <= {main_usddrphy_bitslip271, main_usddrphy_bitslip27_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip28_value0 <= (main_usddrphy_bitslip28_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip28_value0 <= 3'd7;
    end
    main_usddrphy_bitslip28_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[92], main_usddrphy_interface1_dfi_p3_wrdata[28], main_usddrphy_interface1_dfi_p2_wrdata[92], main_usddrphy_interface1_dfi_p2_wrdata[28], main_usddrphy_interface1_dfi_p1_wrdata[92], main_usddrphy_interface1_dfi_p1_wrdata[28], main_usddrphy_interface1_dfi_p0_wrdata[92], main_usddrphy_interface1_dfi_p0_wrdata[28]}, main_usddrphy_bitslip28_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip28_value1 <= (main_usddrphy_bitslip28_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip28_value1 <= 3'd7;
    end
    main_usddrphy_bitslip28_r1 <= {main_usddrphy_bitslip281, main_usddrphy_bitslip28_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip29_value0 <= (main_usddrphy_bitslip29_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip29_value0 <= 3'd7;
    end
    main_usddrphy_bitslip29_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[93], main_usddrphy_interface1_dfi_p3_wrdata[29], main_usddrphy_interface1_dfi_p2_wrdata[93], main_usddrphy_interface1_dfi_p2_wrdata[29], main_usddrphy_interface1_dfi_p1_wrdata[93], main_usddrphy_interface1_dfi_p1_wrdata[29], main_usddrphy_interface1_dfi_p0_wrdata[93], main_usddrphy_interface1_dfi_p0_wrdata[29]}, main_usddrphy_bitslip29_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip29_value1 <= (main_usddrphy_bitslip29_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip29_value1 <= 3'd7;
    end
    main_usddrphy_bitslip29_r1 <= {main_usddrphy_bitslip291, main_usddrphy_bitslip29_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip30_value0 <= (main_usddrphy_bitslip30_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip30_value0 <= 3'd7;
    end
    main_usddrphy_bitslip30_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[94], main_usddrphy_interface1_dfi_p3_wrdata[30], main_usddrphy_interface1_dfi_p2_wrdata[94], main_usddrphy_interface1_dfi_p2_wrdata[30], main_usddrphy_interface1_dfi_p1_wrdata[94], main_usddrphy_interface1_dfi_p1_wrdata[30], main_usddrphy_interface1_dfi_p0_wrdata[94], main_usddrphy_interface1_dfi_p0_wrdata[30]}, main_usddrphy_bitslip30_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip30_value1 <= (main_usddrphy_bitslip30_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip30_value1 <= 3'd7;
    end
    main_usddrphy_bitslip30_r1 <= {main_usddrphy_bitslip301, main_usddrphy_bitslip30_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip31_value0 <= (main_usddrphy_bitslip31_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip31_value0 <= 3'd7;
    end
    main_usddrphy_bitslip31_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[95], main_usddrphy_interface1_dfi_p3_wrdata[31], main_usddrphy_interface1_dfi_p2_wrdata[95], main_usddrphy_interface1_dfi_p2_wrdata[31], main_usddrphy_interface1_dfi_p1_wrdata[95], main_usddrphy_interface1_dfi_p1_wrdata[31], main_usddrphy_interface1_dfi_p0_wrdata[95], main_usddrphy_interface1_dfi_p0_wrdata[31]}, main_usddrphy_bitslip31_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip31_value1 <= (main_usddrphy_bitslip31_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip31_value1 <= 3'd7;
    end
    main_usddrphy_bitslip31_r1 <= {main_usddrphy_bitslip311, main_usddrphy_bitslip31_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip32_value0 <= (main_usddrphy_bitslip32_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip32_value0 <= 3'd7;
    end
    main_usddrphy_bitslip32_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[96], main_usddrphy_interface1_dfi_p3_wrdata[32], main_usddrphy_interface1_dfi_p2_wrdata[96], main_usddrphy_interface1_dfi_p2_wrdata[32], main_usddrphy_interface1_dfi_p1_wrdata[96], main_usddrphy_interface1_dfi_p1_wrdata[32], main_usddrphy_interface1_dfi_p0_wrdata[96], main_usddrphy_interface1_dfi_p0_wrdata[32]}, main_usddrphy_bitslip32_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip32_value1 <= (main_usddrphy_bitslip32_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip32_value1 <= 3'd7;
    end
    main_usddrphy_bitslip32_r1 <= {main_usddrphy_bitslip321, main_usddrphy_bitslip32_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip33_value0 <= (main_usddrphy_bitslip33_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip33_value0 <= 3'd7;
    end
    main_usddrphy_bitslip33_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[97], main_usddrphy_interface1_dfi_p3_wrdata[33], main_usddrphy_interface1_dfi_p2_wrdata[97], main_usddrphy_interface1_dfi_p2_wrdata[33], main_usddrphy_interface1_dfi_p1_wrdata[97], main_usddrphy_interface1_dfi_p1_wrdata[33], main_usddrphy_interface1_dfi_p0_wrdata[97], main_usddrphy_interface1_dfi_p0_wrdata[33]}, main_usddrphy_bitslip33_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip33_value1 <= (main_usddrphy_bitslip33_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip33_value1 <= 3'd7;
    end
    main_usddrphy_bitslip33_r1 <= {main_usddrphy_bitslip331, main_usddrphy_bitslip33_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip34_value0 <= (main_usddrphy_bitslip34_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip34_value0 <= 3'd7;
    end
    main_usddrphy_bitslip34_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[98], main_usddrphy_interface1_dfi_p3_wrdata[34], main_usddrphy_interface1_dfi_p2_wrdata[98], main_usddrphy_interface1_dfi_p2_wrdata[34], main_usddrphy_interface1_dfi_p1_wrdata[98], main_usddrphy_interface1_dfi_p1_wrdata[34], main_usddrphy_interface1_dfi_p0_wrdata[98], main_usddrphy_interface1_dfi_p0_wrdata[34]}, main_usddrphy_bitslip34_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip34_value1 <= (main_usddrphy_bitslip34_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip34_value1 <= 3'd7;
    end
    main_usddrphy_bitslip34_r1 <= {main_usddrphy_bitslip341, main_usddrphy_bitslip34_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip35_value0 <= (main_usddrphy_bitslip35_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip35_value0 <= 3'd7;
    end
    main_usddrphy_bitslip35_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[99], main_usddrphy_interface1_dfi_p3_wrdata[35], main_usddrphy_interface1_dfi_p2_wrdata[99], main_usddrphy_interface1_dfi_p2_wrdata[35], main_usddrphy_interface1_dfi_p1_wrdata[99], main_usddrphy_interface1_dfi_p1_wrdata[35], main_usddrphy_interface1_dfi_p0_wrdata[99], main_usddrphy_interface1_dfi_p0_wrdata[35]}, main_usddrphy_bitslip35_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip35_value1 <= (main_usddrphy_bitslip35_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip35_value1 <= 3'd7;
    end
    main_usddrphy_bitslip35_r1 <= {main_usddrphy_bitslip351, main_usddrphy_bitslip35_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip36_value0 <= (main_usddrphy_bitslip36_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip36_value0 <= 3'd7;
    end
    main_usddrphy_bitslip36_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[100], main_usddrphy_interface1_dfi_p3_wrdata[36], main_usddrphy_interface1_dfi_p2_wrdata[100], main_usddrphy_interface1_dfi_p2_wrdata[36], main_usddrphy_interface1_dfi_p1_wrdata[100], main_usddrphy_interface1_dfi_p1_wrdata[36], main_usddrphy_interface1_dfi_p0_wrdata[100], main_usddrphy_interface1_dfi_p0_wrdata[36]}, main_usddrphy_bitslip36_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip36_value1 <= (main_usddrphy_bitslip36_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip36_value1 <= 3'd7;
    end
    main_usddrphy_bitslip36_r1 <= {main_usddrphy_bitslip361, main_usddrphy_bitslip36_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip37_value0 <= (main_usddrphy_bitslip37_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip37_value0 <= 3'd7;
    end
    main_usddrphy_bitslip37_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[101], main_usddrphy_interface1_dfi_p3_wrdata[37], main_usddrphy_interface1_dfi_p2_wrdata[101], main_usddrphy_interface1_dfi_p2_wrdata[37], main_usddrphy_interface1_dfi_p1_wrdata[101], main_usddrphy_interface1_dfi_p1_wrdata[37], main_usddrphy_interface1_dfi_p0_wrdata[101], main_usddrphy_interface1_dfi_p0_wrdata[37]}, main_usddrphy_bitslip37_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip37_value1 <= (main_usddrphy_bitslip37_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip37_value1 <= 3'd7;
    end
    main_usddrphy_bitslip37_r1 <= {main_usddrphy_bitslip371, main_usddrphy_bitslip37_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip38_value0 <= (main_usddrphy_bitslip38_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip38_value0 <= 3'd7;
    end
    main_usddrphy_bitslip38_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[102], main_usddrphy_interface1_dfi_p3_wrdata[38], main_usddrphy_interface1_dfi_p2_wrdata[102], main_usddrphy_interface1_dfi_p2_wrdata[38], main_usddrphy_interface1_dfi_p1_wrdata[102], main_usddrphy_interface1_dfi_p1_wrdata[38], main_usddrphy_interface1_dfi_p0_wrdata[102], main_usddrphy_interface1_dfi_p0_wrdata[38]}, main_usddrphy_bitslip38_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip38_value1 <= (main_usddrphy_bitslip38_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip38_value1 <= 3'd7;
    end
    main_usddrphy_bitslip38_r1 <= {main_usddrphy_bitslip381, main_usddrphy_bitslip38_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip39_value0 <= (main_usddrphy_bitslip39_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip39_value0 <= 3'd7;
    end
    main_usddrphy_bitslip39_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[103], main_usddrphy_interface1_dfi_p3_wrdata[39], main_usddrphy_interface1_dfi_p2_wrdata[103], main_usddrphy_interface1_dfi_p2_wrdata[39], main_usddrphy_interface1_dfi_p1_wrdata[103], main_usddrphy_interface1_dfi_p1_wrdata[39], main_usddrphy_interface1_dfi_p0_wrdata[103], main_usddrphy_interface1_dfi_p0_wrdata[39]}, main_usddrphy_bitslip39_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip39_value1 <= (main_usddrphy_bitslip39_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip39_value1 <= 3'd7;
    end
    main_usddrphy_bitslip39_r1 <= {main_usddrphy_bitslip391, main_usddrphy_bitslip39_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip40_value0 <= (main_usddrphy_bitslip40_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip40_value0 <= 3'd7;
    end
    main_usddrphy_bitslip40_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[104], main_usddrphy_interface1_dfi_p3_wrdata[40], main_usddrphy_interface1_dfi_p2_wrdata[104], main_usddrphy_interface1_dfi_p2_wrdata[40], main_usddrphy_interface1_dfi_p1_wrdata[104], main_usddrphy_interface1_dfi_p1_wrdata[40], main_usddrphy_interface1_dfi_p0_wrdata[104], main_usddrphy_interface1_dfi_p0_wrdata[40]}, main_usddrphy_bitslip40_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip40_value1 <= (main_usddrphy_bitslip40_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip40_value1 <= 3'd7;
    end
    main_usddrphy_bitslip40_r1 <= {main_usddrphy_bitslip401, main_usddrphy_bitslip40_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip41_value0 <= (main_usddrphy_bitslip41_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip41_value0 <= 3'd7;
    end
    main_usddrphy_bitslip41_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[105], main_usddrphy_interface1_dfi_p3_wrdata[41], main_usddrphy_interface1_dfi_p2_wrdata[105], main_usddrphy_interface1_dfi_p2_wrdata[41], main_usddrphy_interface1_dfi_p1_wrdata[105], main_usddrphy_interface1_dfi_p1_wrdata[41], main_usddrphy_interface1_dfi_p0_wrdata[105], main_usddrphy_interface1_dfi_p0_wrdata[41]}, main_usddrphy_bitslip41_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip41_value1 <= (main_usddrphy_bitslip41_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip41_value1 <= 3'd7;
    end
    main_usddrphy_bitslip41_r1 <= {main_usddrphy_bitslip411, main_usddrphy_bitslip41_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip42_value0 <= (main_usddrphy_bitslip42_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip42_value0 <= 3'd7;
    end
    main_usddrphy_bitslip42_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[106], main_usddrphy_interface1_dfi_p3_wrdata[42], main_usddrphy_interface1_dfi_p2_wrdata[106], main_usddrphy_interface1_dfi_p2_wrdata[42], main_usddrphy_interface1_dfi_p1_wrdata[106], main_usddrphy_interface1_dfi_p1_wrdata[42], main_usddrphy_interface1_dfi_p0_wrdata[106], main_usddrphy_interface1_dfi_p0_wrdata[42]}, main_usddrphy_bitslip42_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip42_value1 <= (main_usddrphy_bitslip42_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip42_value1 <= 3'd7;
    end
    main_usddrphy_bitslip42_r1 <= {main_usddrphy_bitslip421, main_usddrphy_bitslip42_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip43_value0 <= (main_usddrphy_bitslip43_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip43_value0 <= 3'd7;
    end
    main_usddrphy_bitslip43_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[107], main_usddrphy_interface1_dfi_p3_wrdata[43], main_usddrphy_interface1_dfi_p2_wrdata[107], main_usddrphy_interface1_dfi_p2_wrdata[43], main_usddrphy_interface1_dfi_p1_wrdata[107], main_usddrphy_interface1_dfi_p1_wrdata[43], main_usddrphy_interface1_dfi_p0_wrdata[107], main_usddrphy_interface1_dfi_p0_wrdata[43]}, main_usddrphy_bitslip43_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip43_value1 <= (main_usddrphy_bitslip43_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip43_value1 <= 3'd7;
    end
    main_usddrphy_bitslip43_r1 <= {main_usddrphy_bitslip431, main_usddrphy_bitslip43_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip44_value0 <= (main_usddrphy_bitslip44_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip44_value0 <= 3'd7;
    end
    main_usddrphy_bitslip44_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[108], main_usddrphy_interface1_dfi_p3_wrdata[44], main_usddrphy_interface1_dfi_p2_wrdata[108], main_usddrphy_interface1_dfi_p2_wrdata[44], main_usddrphy_interface1_dfi_p1_wrdata[108], main_usddrphy_interface1_dfi_p1_wrdata[44], main_usddrphy_interface1_dfi_p0_wrdata[108], main_usddrphy_interface1_dfi_p0_wrdata[44]}, main_usddrphy_bitslip44_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip44_value1 <= (main_usddrphy_bitslip44_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip44_value1 <= 3'd7;
    end
    main_usddrphy_bitslip44_r1 <= {main_usddrphy_bitslip441, main_usddrphy_bitslip44_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip45_value0 <= (main_usddrphy_bitslip45_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip45_value0 <= 3'd7;
    end
    main_usddrphy_bitslip45_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[109], main_usddrphy_interface1_dfi_p3_wrdata[45], main_usddrphy_interface1_dfi_p2_wrdata[109], main_usddrphy_interface1_dfi_p2_wrdata[45], main_usddrphy_interface1_dfi_p1_wrdata[109], main_usddrphy_interface1_dfi_p1_wrdata[45], main_usddrphy_interface1_dfi_p0_wrdata[109], main_usddrphy_interface1_dfi_p0_wrdata[45]}, main_usddrphy_bitslip45_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip45_value1 <= (main_usddrphy_bitslip45_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip45_value1 <= 3'd7;
    end
    main_usddrphy_bitslip45_r1 <= {main_usddrphy_bitslip451, main_usddrphy_bitslip45_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip46_value0 <= (main_usddrphy_bitslip46_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip46_value0 <= 3'd7;
    end
    main_usddrphy_bitslip46_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[110], main_usddrphy_interface1_dfi_p3_wrdata[46], main_usddrphy_interface1_dfi_p2_wrdata[110], main_usddrphy_interface1_dfi_p2_wrdata[46], main_usddrphy_interface1_dfi_p1_wrdata[110], main_usddrphy_interface1_dfi_p1_wrdata[46], main_usddrphy_interface1_dfi_p0_wrdata[110], main_usddrphy_interface1_dfi_p0_wrdata[46]}, main_usddrphy_bitslip46_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip46_value1 <= (main_usddrphy_bitslip46_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip46_value1 <= 3'd7;
    end
    main_usddrphy_bitslip46_r1 <= {main_usddrphy_bitslip461, main_usddrphy_bitslip46_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip47_value0 <= (main_usddrphy_bitslip47_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip47_value0 <= 3'd7;
    end
    main_usddrphy_bitslip47_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[111], main_usddrphy_interface1_dfi_p3_wrdata[47], main_usddrphy_interface1_dfi_p2_wrdata[111], main_usddrphy_interface1_dfi_p2_wrdata[47], main_usddrphy_interface1_dfi_p1_wrdata[111], main_usddrphy_interface1_dfi_p1_wrdata[47], main_usddrphy_interface1_dfi_p0_wrdata[111], main_usddrphy_interface1_dfi_p0_wrdata[47]}, main_usddrphy_bitslip47_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip47_value1 <= (main_usddrphy_bitslip47_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip47_value1 <= 3'd7;
    end
    main_usddrphy_bitslip47_r1 <= {main_usddrphy_bitslip471, main_usddrphy_bitslip47_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip48_value0 <= (main_usddrphy_bitslip48_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip48_value0 <= 3'd7;
    end
    main_usddrphy_bitslip48_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[112], main_usddrphy_interface1_dfi_p3_wrdata[48], main_usddrphy_interface1_dfi_p2_wrdata[112], main_usddrphy_interface1_dfi_p2_wrdata[48], main_usddrphy_interface1_dfi_p1_wrdata[112], main_usddrphy_interface1_dfi_p1_wrdata[48], main_usddrphy_interface1_dfi_p0_wrdata[112], main_usddrphy_interface1_dfi_p0_wrdata[48]}, main_usddrphy_bitslip48_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip48_value1 <= (main_usddrphy_bitslip48_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip48_value1 <= 3'd7;
    end
    main_usddrphy_bitslip48_r1 <= {main_usddrphy_bitslip481, main_usddrphy_bitslip48_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip49_value0 <= (main_usddrphy_bitslip49_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip49_value0 <= 3'd7;
    end
    main_usddrphy_bitslip49_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[113], main_usddrphy_interface1_dfi_p3_wrdata[49], main_usddrphy_interface1_dfi_p2_wrdata[113], main_usddrphy_interface1_dfi_p2_wrdata[49], main_usddrphy_interface1_dfi_p1_wrdata[113], main_usddrphy_interface1_dfi_p1_wrdata[49], main_usddrphy_interface1_dfi_p0_wrdata[113], main_usddrphy_interface1_dfi_p0_wrdata[49]}, main_usddrphy_bitslip49_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip49_value1 <= (main_usddrphy_bitslip49_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip49_value1 <= 3'd7;
    end
    main_usddrphy_bitslip49_r1 <= {main_usddrphy_bitslip491, main_usddrphy_bitslip49_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip50_value0 <= (main_usddrphy_bitslip50_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip50_value0 <= 3'd7;
    end
    main_usddrphy_bitslip50_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[114], main_usddrphy_interface1_dfi_p3_wrdata[50], main_usddrphy_interface1_dfi_p2_wrdata[114], main_usddrphy_interface1_dfi_p2_wrdata[50], main_usddrphy_interface1_dfi_p1_wrdata[114], main_usddrphy_interface1_dfi_p1_wrdata[50], main_usddrphy_interface1_dfi_p0_wrdata[114], main_usddrphy_interface1_dfi_p0_wrdata[50]}, main_usddrphy_bitslip50_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip50_value1 <= (main_usddrphy_bitslip50_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip50_value1 <= 3'd7;
    end
    main_usddrphy_bitslip50_r1 <= {main_usddrphy_bitslip501, main_usddrphy_bitslip50_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip51_value0 <= (main_usddrphy_bitslip51_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip51_value0 <= 3'd7;
    end
    main_usddrphy_bitslip51_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[115], main_usddrphy_interface1_dfi_p3_wrdata[51], main_usddrphy_interface1_dfi_p2_wrdata[115], main_usddrphy_interface1_dfi_p2_wrdata[51], main_usddrphy_interface1_dfi_p1_wrdata[115], main_usddrphy_interface1_dfi_p1_wrdata[51], main_usddrphy_interface1_dfi_p0_wrdata[115], main_usddrphy_interface1_dfi_p0_wrdata[51]}, main_usddrphy_bitslip51_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip51_value1 <= (main_usddrphy_bitslip51_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip51_value1 <= 3'd7;
    end
    main_usddrphy_bitslip51_r1 <= {main_usddrphy_bitslip511, main_usddrphy_bitslip51_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip52_value0 <= (main_usddrphy_bitslip52_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip52_value0 <= 3'd7;
    end
    main_usddrphy_bitslip52_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[116], main_usddrphy_interface1_dfi_p3_wrdata[52], main_usddrphy_interface1_dfi_p2_wrdata[116], main_usddrphy_interface1_dfi_p2_wrdata[52], main_usddrphy_interface1_dfi_p1_wrdata[116], main_usddrphy_interface1_dfi_p1_wrdata[52], main_usddrphy_interface1_dfi_p0_wrdata[116], main_usddrphy_interface1_dfi_p0_wrdata[52]}, main_usddrphy_bitslip52_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip52_value1 <= (main_usddrphy_bitslip52_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip52_value1 <= 3'd7;
    end
    main_usddrphy_bitslip52_r1 <= {main_usddrphy_bitslip521, main_usddrphy_bitslip52_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip53_value0 <= (main_usddrphy_bitslip53_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip53_value0 <= 3'd7;
    end
    main_usddrphy_bitslip53_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[117], main_usddrphy_interface1_dfi_p3_wrdata[53], main_usddrphy_interface1_dfi_p2_wrdata[117], main_usddrphy_interface1_dfi_p2_wrdata[53], main_usddrphy_interface1_dfi_p1_wrdata[117], main_usddrphy_interface1_dfi_p1_wrdata[53], main_usddrphy_interface1_dfi_p0_wrdata[117], main_usddrphy_interface1_dfi_p0_wrdata[53]}, main_usddrphy_bitslip53_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip53_value1 <= (main_usddrphy_bitslip53_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip53_value1 <= 3'd7;
    end
    main_usddrphy_bitslip53_r1 <= {main_usddrphy_bitslip531, main_usddrphy_bitslip53_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip54_value0 <= (main_usddrphy_bitslip54_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip54_value0 <= 3'd7;
    end
    main_usddrphy_bitslip54_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[118], main_usddrphy_interface1_dfi_p3_wrdata[54], main_usddrphy_interface1_dfi_p2_wrdata[118], main_usddrphy_interface1_dfi_p2_wrdata[54], main_usddrphy_interface1_dfi_p1_wrdata[118], main_usddrphy_interface1_dfi_p1_wrdata[54], main_usddrphy_interface1_dfi_p0_wrdata[118], main_usddrphy_interface1_dfi_p0_wrdata[54]}, main_usddrphy_bitslip54_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip54_value1 <= (main_usddrphy_bitslip54_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip54_value1 <= 3'd7;
    end
    main_usddrphy_bitslip54_r1 <= {main_usddrphy_bitslip541, main_usddrphy_bitslip54_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip55_value0 <= (main_usddrphy_bitslip55_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip55_value0 <= 3'd7;
    end
    main_usddrphy_bitslip55_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[119], main_usddrphy_interface1_dfi_p3_wrdata[55], main_usddrphy_interface1_dfi_p2_wrdata[119], main_usddrphy_interface1_dfi_p2_wrdata[55], main_usddrphy_interface1_dfi_p1_wrdata[119], main_usddrphy_interface1_dfi_p1_wrdata[55], main_usddrphy_interface1_dfi_p0_wrdata[119], main_usddrphy_interface1_dfi_p0_wrdata[55]}, main_usddrphy_bitslip55_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip55_value1 <= (main_usddrphy_bitslip55_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip55_value1 <= 3'd7;
    end
    main_usddrphy_bitslip55_r1 <= {main_usddrphy_bitslip551, main_usddrphy_bitslip55_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip56_value0 <= (main_usddrphy_bitslip56_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip56_value0 <= 3'd7;
    end
    main_usddrphy_bitslip56_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[120], main_usddrphy_interface1_dfi_p3_wrdata[56], main_usddrphy_interface1_dfi_p2_wrdata[120], main_usddrphy_interface1_dfi_p2_wrdata[56], main_usddrphy_interface1_dfi_p1_wrdata[120], main_usddrphy_interface1_dfi_p1_wrdata[56], main_usddrphy_interface1_dfi_p0_wrdata[120], main_usddrphy_interface1_dfi_p0_wrdata[56]}, main_usddrphy_bitslip56_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip56_value1 <= (main_usddrphy_bitslip56_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip56_value1 <= 3'd7;
    end
    main_usddrphy_bitslip56_r1 <= {main_usddrphy_bitslip561, main_usddrphy_bitslip56_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip57_value0 <= (main_usddrphy_bitslip57_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip57_value0 <= 3'd7;
    end
    main_usddrphy_bitslip57_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[121], main_usddrphy_interface1_dfi_p3_wrdata[57], main_usddrphy_interface1_dfi_p2_wrdata[121], main_usddrphy_interface1_dfi_p2_wrdata[57], main_usddrphy_interface1_dfi_p1_wrdata[121], main_usddrphy_interface1_dfi_p1_wrdata[57], main_usddrphy_interface1_dfi_p0_wrdata[121], main_usddrphy_interface1_dfi_p0_wrdata[57]}, main_usddrphy_bitslip57_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip57_value1 <= (main_usddrphy_bitslip57_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip57_value1 <= 3'd7;
    end
    main_usddrphy_bitslip57_r1 <= {main_usddrphy_bitslip571, main_usddrphy_bitslip57_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip58_value0 <= (main_usddrphy_bitslip58_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip58_value0 <= 3'd7;
    end
    main_usddrphy_bitslip58_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[122], main_usddrphy_interface1_dfi_p3_wrdata[58], main_usddrphy_interface1_dfi_p2_wrdata[122], main_usddrphy_interface1_dfi_p2_wrdata[58], main_usddrphy_interface1_dfi_p1_wrdata[122], main_usddrphy_interface1_dfi_p1_wrdata[58], main_usddrphy_interface1_dfi_p0_wrdata[122], main_usddrphy_interface1_dfi_p0_wrdata[58]}, main_usddrphy_bitslip58_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip58_value1 <= (main_usddrphy_bitslip58_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip58_value1 <= 3'd7;
    end
    main_usddrphy_bitslip58_r1 <= {main_usddrphy_bitslip581, main_usddrphy_bitslip58_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip59_value0 <= (main_usddrphy_bitslip59_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip59_value0 <= 3'd7;
    end
    main_usddrphy_bitslip59_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[123], main_usddrphy_interface1_dfi_p3_wrdata[59], main_usddrphy_interface1_dfi_p2_wrdata[123], main_usddrphy_interface1_dfi_p2_wrdata[59], main_usddrphy_interface1_dfi_p1_wrdata[123], main_usddrphy_interface1_dfi_p1_wrdata[59], main_usddrphy_interface1_dfi_p0_wrdata[123], main_usddrphy_interface1_dfi_p0_wrdata[59]}, main_usddrphy_bitslip59_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip59_value1 <= (main_usddrphy_bitslip59_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip59_value1 <= 3'd7;
    end
    main_usddrphy_bitslip59_r1 <= {main_usddrphy_bitslip591, main_usddrphy_bitslip59_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip60_value0 <= (main_usddrphy_bitslip60_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip60_value0 <= 3'd7;
    end
    main_usddrphy_bitslip60_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[124], main_usddrphy_interface1_dfi_p3_wrdata[60], main_usddrphy_interface1_dfi_p2_wrdata[124], main_usddrphy_interface1_dfi_p2_wrdata[60], main_usddrphy_interface1_dfi_p1_wrdata[124], main_usddrphy_interface1_dfi_p1_wrdata[60], main_usddrphy_interface1_dfi_p0_wrdata[124], main_usddrphy_interface1_dfi_p0_wrdata[60]}, main_usddrphy_bitslip60_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip60_value1 <= (main_usddrphy_bitslip60_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip60_value1 <= 3'd7;
    end
    main_usddrphy_bitslip60_r1 <= {main_usddrphy_bitslip601, main_usddrphy_bitslip60_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip61_value0 <= (main_usddrphy_bitslip61_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip61_value0 <= 3'd7;
    end
    main_usddrphy_bitslip61_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[125], main_usddrphy_interface1_dfi_p3_wrdata[61], main_usddrphy_interface1_dfi_p2_wrdata[125], main_usddrphy_interface1_dfi_p2_wrdata[61], main_usddrphy_interface1_dfi_p1_wrdata[125], main_usddrphy_interface1_dfi_p1_wrdata[61], main_usddrphy_interface1_dfi_p0_wrdata[125], main_usddrphy_interface1_dfi_p0_wrdata[61]}, main_usddrphy_bitslip61_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip61_value1 <= (main_usddrphy_bitslip61_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip61_value1 <= 3'd7;
    end
    main_usddrphy_bitslip61_r1 <= {main_usddrphy_bitslip611, main_usddrphy_bitslip61_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip62_value0 <= (main_usddrphy_bitslip62_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip62_value0 <= 3'd7;
    end
    main_usddrphy_bitslip62_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[126], main_usddrphy_interface1_dfi_p3_wrdata[62], main_usddrphy_interface1_dfi_p2_wrdata[126], main_usddrphy_interface1_dfi_p2_wrdata[62], main_usddrphy_interface1_dfi_p1_wrdata[126], main_usddrphy_interface1_dfi_p1_wrdata[62], main_usddrphy_interface1_dfi_p0_wrdata[126], main_usddrphy_interface1_dfi_p0_wrdata[62]}, main_usddrphy_bitslip62_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip62_value1 <= (main_usddrphy_bitslip62_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip62_value1 <= 3'd7;
    end
    main_usddrphy_bitslip62_r1 <= {main_usddrphy_bitslip621, main_usddrphy_bitslip62_r1[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip63_value0 <= (main_usddrphy_bitslip63_value0 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip63_value0 <= 3'd7;
    end
    main_usddrphy_bitslip63_r0 <= {{main_usddrphy_interface1_dfi_p3_wrdata[127], main_usddrphy_interface1_dfi_p3_wrdata[63], main_usddrphy_interface1_dfi_p2_wrdata[127], main_usddrphy_interface1_dfi_p2_wrdata[63], main_usddrphy_interface1_dfi_p1_wrdata[127], main_usddrphy_interface1_dfi_p1_wrdata[63], main_usddrphy_interface1_dfi_p0_wrdata[127], main_usddrphy_interface1_dfi_p0_wrdata[63]}, main_usddrphy_bitslip63_r0[15:8]};
    if ((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_re)) begin
        main_usddrphy_bitslip63_value1 <= (main_usddrphy_bitslip63_value1 + 1'd1);
    end
    if (((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_bitslip_rst_re) | main_usddrphy_rst_storage)) begin
        main_usddrphy_bitslip63_value1 <= 3'd7;
    end
    main_usddrphy_bitslip63_r1 <= {main_usddrphy_bitslip631, main_usddrphy_bitslip63_r1[15:8]};
    main_usddrphy_rddata_en_tappeddelayline0 <= (((main_usddrphy_interface1_dfi_p0_rddata_en | main_usddrphy_interface1_dfi_p1_rddata_en) | main_usddrphy_interface1_dfi_p2_rddata_en) | main_usddrphy_interface1_dfi_p3_rddata_en);
    main_usddrphy_rddata_en_tappeddelayline1 <= main_usddrphy_rddata_en_tappeddelayline0;
    main_usddrphy_rddata_en_tappeddelayline2 <= main_usddrphy_rddata_en_tappeddelayline1;
    main_usddrphy_rddata_en_tappeddelayline3 <= main_usddrphy_rddata_en_tappeddelayline2;
    main_usddrphy_rddata_en_tappeddelayline4 <= main_usddrphy_rddata_en_tappeddelayline3;
    main_usddrphy_rddata_en_tappeddelayline5 <= main_usddrphy_rddata_en_tappeddelayline4;
    main_usddrphy_rddata_en_tappeddelayline6 <= main_usddrphy_rddata_en_tappeddelayline5;
    main_usddrphy_rddata_en_tappeddelayline7 <= main_usddrphy_rddata_en_tappeddelayline6;
    main_usddrphy_wrdata_en_tappeddelayline0 <= (((main_usddrphy_interface1_dfi_p0_wrdata_en | main_usddrphy_interface1_dfi_p1_wrdata_en) | main_usddrphy_interface1_dfi_p2_wrdata_en) | main_usddrphy_interface1_dfi_p3_wrdata_en);
    main_usddrphy_wrdata_en_tappeddelayline1 <= main_usddrphy_wrdata_en_tappeddelayline0;
    main_usddrphy_wrdata_en_tappeddelayline2 <= main_usddrphy_wrdata_en_tappeddelayline1;
    main_usddrphy_wrdata_en_tappeddelayline3 <= main_usddrphy_wrdata_en_tappeddelayline2;
    if (main_sdram_csr_dfi_p0_rddata_valid) begin
        main_sdram_phaseinjector0_rddata_status <= main_sdram_csr_dfi_p0_rddata;
    end
    if (main_sdram_csr_dfi_p1_rddata_valid) begin
        main_sdram_phaseinjector1_rddata_status <= main_sdram_csr_dfi_p1_rddata;
    end
    if (main_sdram_csr_dfi_p2_rddata_valid) begin
        main_sdram_phaseinjector2_rddata_status <= main_sdram_csr_dfi_p2_rddata;
    end
    if (main_sdram_csr_dfi_p3_rddata_valid) begin
        main_sdram_phaseinjector3_rddata_status <= main_sdram_csr_dfi_p3_rddata;
    end
    if ((main_sdram_timer_wait & (~main_sdram_timer_done0))) begin
        main_sdram_timer_count1 <= (main_sdram_timer_count1 - 1'd1);
    end else begin
        main_sdram_timer_count1 <= 10'd976;
    end
    main_sdram_postponer_req_o <= 1'd0;
    if (main_sdram_postponer_req_i) begin
        main_sdram_postponer_count <= (main_sdram_postponer_count - 1'd1);
        if ((main_sdram_postponer_count == 1'd0)) begin
            main_sdram_postponer_count <= 1'd0;
            main_sdram_postponer_req_o <= 1'd1;
        end
    end
    if (main_sdram_sequencer_start0) begin
        main_sdram_sequencer_count <= 1'd0;
    end else begin
        if (main_sdram_sequencer_done1) begin
            if ((main_sdram_sequencer_count != 1'd0)) begin
                main_sdram_sequencer_count <= (main_sdram_sequencer_count - 1'd1);
            end
        end
    end
    main_sdram_cmd_payload_a <= 1'd0;
    main_sdram_cmd_payload_ba <= 1'd0;
    main_sdram_cmd_payload_cas <= 1'd0;
    main_sdram_cmd_payload_ras <= 1'd0;
    main_sdram_cmd_payload_we <= 1'd0;
    main_sdram_sequencer_done1 <= 1'd0;
    if ((main_sdram_sequencer_start1 & (main_sdram_sequencer_counter == 1'd0))) begin
        main_sdram_cmd_payload_a <= 11'd1024;
        main_sdram_cmd_payload_ba <= 1'd0;
        main_sdram_cmd_payload_cas <= 1'd0;
        main_sdram_cmd_payload_ras <= 1'd1;
        main_sdram_cmd_payload_we <= 1'd1;
    end
    if ((main_sdram_sequencer_counter == 2'd3)) begin
        main_sdram_cmd_payload_a <= 11'd1024;
        main_sdram_cmd_payload_ba <= 1'd0;
        main_sdram_cmd_payload_cas <= 1'd1;
        main_sdram_cmd_payload_ras <= 1'd1;
        main_sdram_cmd_payload_we <= 1'd0;
    end
    if ((main_sdram_sequencer_counter == 6'd37)) begin
        main_sdram_cmd_payload_a <= 1'd0;
        main_sdram_cmd_payload_ba <= 1'd0;
        main_sdram_cmd_payload_cas <= 1'd0;
        main_sdram_cmd_payload_ras <= 1'd0;
        main_sdram_cmd_payload_we <= 1'd0;
        main_sdram_sequencer_done1 <= 1'd1;
    end
    if ((main_sdram_sequencer_counter == 6'd37)) begin
        main_sdram_sequencer_counter <= 1'd0;
    end else begin
        if ((main_sdram_sequencer_counter != 1'd0)) begin
            main_sdram_sequencer_counter <= (main_sdram_sequencer_counter + 1'd1);
        end else begin
            if (main_sdram_sequencer_start1) begin
                main_sdram_sequencer_counter <= 1'd1;
            end
        end
    end
    if ((main_sdram_zqcs_timer_wait & (~main_sdram_zqcs_timer_done0))) begin
        main_sdram_zqcs_timer_count1 <= (main_sdram_zqcs_timer_count1 - 1'd1);
    end else begin
        main_sdram_zqcs_timer_count1 <= 27'd124999999;
    end
    main_sdram_zqcs_executer_done <= 1'd0;
    if ((main_sdram_zqcs_executer_start & (main_sdram_zqcs_executer_counter == 1'd0))) begin
        main_sdram_cmd_payload_a <= 11'd1024;
        main_sdram_cmd_payload_ba <= 1'd0;
        main_sdram_cmd_payload_cas <= 1'd0;
        main_sdram_cmd_payload_ras <= 1'd1;
        main_sdram_cmd_payload_we <= 1'd1;
    end
    if ((main_sdram_zqcs_executer_counter == 2'd3)) begin
        main_sdram_cmd_payload_a <= 1'd0;
        main_sdram_cmd_payload_ba <= 1'd0;
        main_sdram_cmd_payload_cas <= 1'd0;
        main_sdram_cmd_payload_ras <= 1'd0;
        main_sdram_cmd_payload_we <= 1'd1;
    end
    if ((main_sdram_zqcs_executer_counter == 6'd35)) begin
        main_sdram_cmd_payload_a <= 1'd0;
        main_sdram_cmd_payload_ba <= 1'd0;
        main_sdram_cmd_payload_cas <= 1'd0;
        main_sdram_cmd_payload_ras <= 1'd0;
        main_sdram_cmd_payload_we <= 1'd0;
        main_sdram_zqcs_executer_done <= 1'd1;
    end
    if ((main_sdram_zqcs_executer_counter == 6'd35)) begin
        main_sdram_zqcs_executer_counter <= 1'd0;
    end else begin
        if ((main_sdram_zqcs_executer_counter != 1'd0)) begin
            main_sdram_zqcs_executer_counter <= (main_sdram_zqcs_executer_counter + 1'd1);
        end else begin
            if (main_sdram_zqcs_executer_start) begin
                main_sdram_zqcs_executer_counter <= 1'd1;
            end
        end
    end
    builder_soclinux_refresher_state <= builder_soclinux_refresher_next_state;
    if (main_sdram_bankmachine0_row_close) begin
        main_sdram_bankmachine0_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine0_row_open) begin
            main_sdram_bankmachine0_row_opened <= 1'd1;
            main_sdram_bankmachine0_row <= main_sdram_bankmachine0_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine0_syncfifo0_we & main_sdram_bankmachine0_syncfifo0_writable) & (~main_sdram_bankmachine0_replace))) begin
        main_sdram_bankmachine0_produce <= (main_sdram_bankmachine0_produce + 1'd1);
    end
    if (main_sdram_bankmachine0_do_read) begin
        main_sdram_bankmachine0_consume <= (main_sdram_bankmachine0_consume + 1'd1);
    end
    if (((main_sdram_bankmachine0_syncfifo0_we & main_sdram_bankmachine0_syncfifo0_writable) & (~main_sdram_bankmachine0_replace))) begin
        if ((~main_sdram_bankmachine0_do_read)) begin
            main_sdram_bankmachine0_level <= (main_sdram_bankmachine0_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine0_do_read) begin
            main_sdram_bankmachine0_level <= (main_sdram_bankmachine0_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine0_pipe_valid_source_valid) | main_sdram_bankmachine0_pipe_valid_source_ready)) begin
        main_sdram_bankmachine0_pipe_valid_source_valid <= main_sdram_bankmachine0_pipe_valid_sink_valid;
        main_sdram_bankmachine0_pipe_valid_source_first <= main_sdram_bankmachine0_pipe_valid_sink_first;
        main_sdram_bankmachine0_pipe_valid_source_last <= main_sdram_bankmachine0_pipe_valid_sink_last;
        main_sdram_bankmachine0_pipe_valid_source_payload_we <= main_sdram_bankmachine0_pipe_valid_sink_payload_we;
        main_sdram_bankmachine0_pipe_valid_source_payload_addr <= main_sdram_bankmachine0_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine0_twtpcon_valid) begin
        main_sdram_bankmachine0_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine0_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine0_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine0_twtpcon_ready)) begin
            main_sdram_bankmachine0_twtpcon_count <= (main_sdram_bankmachine0_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine0_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine0_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine0_trccon_valid) begin
        main_sdram_bankmachine0_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine0_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine0_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine0_trccon_ready)) begin
            main_sdram_bankmachine0_trccon_count <= (main_sdram_bankmachine0_trccon_count - 1'd1);
            if ((main_sdram_bankmachine0_trccon_count == 1'd1)) begin
                main_sdram_bankmachine0_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine0_trascon_valid) begin
        main_sdram_bankmachine0_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine0_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine0_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine0_trascon_ready)) begin
            main_sdram_bankmachine0_trascon_count <= (main_sdram_bankmachine0_trascon_count - 1'd1);
            if ((main_sdram_bankmachine0_trascon_count == 1'd1)) begin
                main_sdram_bankmachine0_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine0_state <= builder_soclinux_bankmachine0_next_state;
    if (main_sdram_bankmachine1_row_close) begin
        main_sdram_bankmachine1_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine1_row_open) begin
            main_sdram_bankmachine1_row_opened <= 1'd1;
            main_sdram_bankmachine1_row <= main_sdram_bankmachine1_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine1_syncfifo1_we & main_sdram_bankmachine1_syncfifo1_writable) & (~main_sdram_bankmachine1_replace))) begin
        main_sdram_bankmachine1_produce <= (main_sdram_bankmachine1_produce + 1'd1);
    end
    if (main_sdram_bankmachine1_do_read) begin
        main_sdram_bankmachine1_consume <= (main_sdram_bankmachine1_consume + 1'd1);
    end
    if (((main_sdram_bankmachine1_syncfifo1_we & main_sdram_bankmachine1_syncfifo1_writable) & (~main_sdram_bankmachine1_replace))) begin
        if ((~main_sdram_bankmachine1_do_read)) begin
            main_sdram_bankmachine1_level <= (main_sdram_bankmachine1_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine1_do_read) begin
            main_sdram_bankmachine1_level <= (main_sdram_bankmachine1_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine1_pipe_valid_source_valid) | main_sdram_bankmachine1_pipe_valid_source_ready)) begin
        main_sdram_bankmachine1_pipe_valid_source_valid <= main_sdram_bankmachine1_pipe_valid_sink_valid;
        main_sdram_bankmachine1_pipe_valid_source_first <= main_sdram_bankmachine1_pipe_valid_sink_first;
        main_sdram_bankmachine1_pipe_valid_source_last <= main_sdram_bankmachine1_pipe_valid_sink_last;
        main_sdram_bankmachine1_pipe_valid_source_payload_we <= main_sdram_bankmachine1_pipe_valid_sink_payload_we;
        main_sdram_bankmachine1_pipe_valid_source_payload_addr <= main_sdram_bankmachine1_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine1_twtpcon_valid) begin
        main_sdram_bankmachine1_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine1_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine1_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine1_twtpcon_ready)) begin
            main_sdram_bankmachine1_twtpcon_count <= (main_sdram_bankmachine1_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine1_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine1_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine1_trccon_valid) begin
        main_sdram_bankmachine1_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine1_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine1_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine1_trccon_ready)) begin
            main_sdram_bankmachine1_trccon_count <= (main_sdram_bankmachine1_trccon_count - 1'd1);
            if ((main_sdram_bankmachine1_trccon_count == 1'd1)) begin
                main_sdram_bankmachine1_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine1_trascon_valid) begin
        main_sdram_bankmachine1_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine1_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine1_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine1_trascon_ready)) begin
            main_sdram_bankmachine1_trascon_count <= (main_sdram_bankmachine1_trascon_count - 1'd1);
            if ((main_sdram_bankmachine1_trascon_count == 1'd1)) begin
                main_sdram_bankmachine1_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine1_state <= builder_soclinux_bankmachine1_next_state;
    if (main_sdram_bankmachine2_row_close) begin
        main_sdram_bankmachine2_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine2_row_open) begin
            main_sdram_bankmachine2_row_opened <= 1'd1;
            main_sdram_bankmachine2_row <= main_sdram_bankmachine2_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine2_syncfifo2_we & main_sdram_bankmachine2_syncfifo2_writable) & (~main_sdram_bankmachine2_replace))) begin
        main_sdram_bankmachine2_produce <= (main_sdram_bankmachine2_produce + 1'd1);
    end
    if (main_sdram_bankmachine2_do_read) begin
        main_sdram_bankmachine2_consume <= (main_sdram_bankmachine2_consume + 1'd1);
    end
    if (((main_sdram_bankmachine2_syncfifo2_we & main_sdram_bankmachine2_syncfifo2_writable) & (~main_sdram_bankmachine2_replace))) begin
        if ((~main_sdram_bankmachine2_do_read)) begin
            main_sdram_bankmachine2_level <= (main_sdram_bankmachine2_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine2_do_read) begin
            main_sdram_bankmachine2_level <= (main_sdram_bankmachine2_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine2_pipe_valid_source_valid) | main_sdram_bankmachine2_pipe_valid_source_ready)) begin
        main_sdram_bankmachine2_pipe_valid_source_valid <= main_sdram_bankmachine2_pipe_valid_sink_valid;
        main_sdram_bankmachine2_pipe_valid_source_first <= main_sdram_bankmachine2_pipe_valid_sink_first;
        main_sdram_bankmachine2_pipe_valid_source_last <= main_sdram_bankmachine2_pipe_valid_sink_last;
        main_sdram_bankmachine2_pipe_valid_source_payload_we <= main_sdram_bankmachine2_pipe_valid_sink_payload_we;
        main_sdram_bankmachine2_pipe_valid_source_payload_addr <= main_sdram_bankmachine2_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine2_twtpcon_valid) begin
        main_sdram_bankmachine2_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine2_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine2_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine2_twtpcon_ready)) begin
            main_sdram_bankmachine2_twtpcon_count <= (main_sdram_bankmachine2_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine2_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine2_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine2_trccon_valid) begin
        main_sdram_bankmachine2_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine2_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine2_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine2_trccon_ready)) begin
            main_sdram_bankmachine2_trccon_count <= (main_sdram_bankmachine2_trccon_count - 1'd1);
            if ((main_sdram_bankmachine2_trccon_count == 1'd1)) begin
                main_sdram_bankmachine2_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine2_trascon_valid) begin
        main_sdram_bankmachine2_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine2_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine2_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine2_trascon_ready)) begin
            main_sdram_bankmachine2_trascon_count <= (main_sdram_bankmachine2_trascon_count - 1'd1);
            if ((main_sdram_bankmachine2_trascon_count == 1'd1)) begin
                main_sdram_bankmachine2_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine2_state <= builder_soclinux_bankmachine2_next_state;
    if (main_sdram_bankmachine3_row_close) begin
        main_sdram_bankmachine3_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine3_row_open) begin
            main_sdram_bankmachine3_row_opened <= 1'd1;
            main_sdram_bankmachine3_row <= main_sdram_bankmachine3_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine3_syncfifo3_we & main_sdram_bankmachine3_syncfifo3_writable) & (~main_sdram_bankmachine3_replace))) begin
        main_sdram_bankmachine3_produce <= (main_sdram_bankmachine3_produce + 1'd1);
    end
    if (main_sdram_bankmachine3_do_read) begin
        main_sdram_bankmachine3_consume <= (main_sdram_bankmachine3_consume + 1'd1);
    end
    if (((main_sdram_bankmachine3_syncfifo3_we & main_sdram_bankmachine3_syncfifo3_writable) & (~main_sdram_bankmachine3_replace))) begin
        if ((~main_sdram_bankmachine3_do_read)) begin
            main_sdram_bankmachine3_level <= (main_sdram_bankmachine3_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine3_do_read) begin
            main_sdram_bankmachine3_level <= (main_sdram_bankmachine3_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine3_pipe_valid_source_valid) | main_sdram_bankmachine3_pipe_valid_source_ready)) begin
        main_sdram_bankmachine3_pipe_valid_source_valid <= main_sdram_bankmachine3_pipe_valid_sink_valid;
        main_sdram_bankmachine3_pipe_valid_source_first <= main_sdram_bankmachine3_pipe_valid_sink_first;
        main_sdram_bankmachine3_pipe_valid_source_last <= main_sdram_bankmachine3_pipe_valid_sink_last;
        main_sdram_bankmachine3_pipe_valid_source_payload_we <= main_sdram_bankmachine3_pipe_valid_sink_payload_we;
        main_sdram_bankmachine3_pipe_valid_source_payload_addr <= main_sdram_bankmachine3_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine3_twtpcon_valid) begin
        main_sdram_bankmachine3_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine3_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine3_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine3_twtpcon_ready)) begin
            main_sdram_bankmachine3_twtpcon_count <= (main_sdram_bankmachine3_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine3_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine3_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine3_trccon_valid) begin
        main_sdram_bankmachine3_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine3_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine3_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine3_trccon_ready)) begin
            main_sdram_bankmachine3_trccon_count <= (main_sdram_bankmachine3_trccon_count - 1'd1);
            if ((main_sdram_bankmachine3_trccon_count == 1'd1)) begin
                main_sdram_bankmachine3_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine3_trascon_valid) begin
        main_sdram_bankmachine3_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine3_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine3_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine3_trascon_ready)) begin
            main_sdram_bankmachine3_trascon_count <= (main_sdram_bankmachine3_trascon_count - 1'd1);
            if ((main_sdram_bankmachine3_trascon_count == 1'd1)) begin
                main_sdram_bankmachine3_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine3_state <= builder_soclinux_bankmachine3_next_state;
    if (main_sdram_bankmachine4_row_close) begin
        main_sdram_bankmachine4_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine4_row_open) begin
            main_sdram_bankmachine4_row_opened <= 1'd1;
            main_sdram_bankmachine4_row <= main_sdram_bankmachine4_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine4_syncfifo4_we & main_sdram_bankmachine4_syncfifo4_writable) & (~main_sdram_bankmachine4_replace))) begin
        main_sdram_bankmachine4_produce <= (main_sdram_bankmachine4_produce + 1'd1);
    end
    if (main_sdram_bankmachine4_do_read) begin
        main_sdram_bankmachine4_consume <= (main_sdram_bankmachine4_consume + 1'd1);
    end
    if (((main_sdram_bankmachine4_syncfifo4_we & main_sdram_bankmachine4_syncfifo4_writable) & (~main_sdram_bankmachine4_replace))) begin
        if ((~main_sdram_bankmachine4_do_read)) begin
            main_sdram_bankmachine4_level <= (main_sdram_bankmachine4_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine4_do_read) begin
            main_sdram_bankmachine4_level <= (main_sdram_bankmachine4_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine4_pipe_valid_source_valid) | main_sdram_bankmachine4_pipe_valid_source_ready)) begin
        main_sdram_bankmachine4_pipe_valid_source_valid <= main_sdram_bankmachine4_pipe_valid_sink_valid;
        main_sdram_bankmachine4_pipe_valid_source_first <= main_sdram_bankmachine4_pipe_valid_sink_first;
        main_sdram_bankmachine4_pipe_valid_source_last <= main_sdram_bankmachine4_pipe_valid_sink_last;
        main_sdram_bankmachine4_pipe_valid_source_payload_we <= main_sdram_bankmachine4_pipe_valid_sink_payload_we;
        main_sdram_bankmachine4_pipe_valid_source_payload_addr <= main_sdram_bankmachine4_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine4_twtpcon_valid) begin
        main_sdram_bankmachine4_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine4_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine4_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine4_twtpcon_ready)) begin
            main_sdram_bankmachine4_twtpcon_count <= (main_sdram_bankmachine4_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine4_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine4_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine4_trccon_valid) begin
        main_sdram_bankmachine4_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine4_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine4_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine4_trccon_ready)) begin
            main_sdram_bankmachine4_trccon_count <= (main_sdram_bankmachine4_trccon_count - 1'd1);
            if ((main_sdram_bankmachine4_trccon_count == 1'd1)) begin
                main_sdram_bankmachine4_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine4_trascon_valid) begin
        main_sdram_bankmachine4_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine4_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine4_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine4_trascon_ready)) begin
            main_sdram_bankmachine4_trascon_count <= (main_sdram_bankmachine4_trascon_count - 1'd1);
            if ((main_sdram_bankmachine4_trascon_count == 1'd1)) begin
                main_sdram_bankmachine4_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine4_state <= builder_soclinux_bankmachine4_next_state;
    if (main_sdram_bankmachine5_row_close) begin
        main_sdram_bankmachine5_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine5_row_open) begin
            main_sdram_bankmachine5_row_opened <= 1'd1;
            main_sdram_bankmachine5_row <= main_sdram_bankmachine5_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine5_syncfifo5_we & main_sdram_bankmachine5_syncfifo5_writable) & (~main_sdram_bankmachine5_replace))) begin
        main_sdram_bankmachine5_produce <= (main_sdram_bankmachine5_produce + 1'd1);
    end
    if (main_sdram_bankmachine5_do_read) begin
        main_sdram_bankmachine5_consume <= (main_sdram_bankmachine5_consume + 1'd1);
    end
    if (((main_sdram_bankmachine5_syncfifo5_we & main_sdram_bankmachine5_syncfifo5_writable) & (~main_sdram_bankmachine5_replace))) begin
        if ((~main_sdram_bankmachine5_do_read)) begin
            main_sdram_bankmachine5_level <= (main_sdram_bankmachine5_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine5_do_read) begin
            main_sdram_bankmachine5_level <= (main_sdram_bankmachine5_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine5_pipe_valid_source_valid) | main_sdram_bankmachine5_pipe_valid_source_ready)) begin
        main_sdram_bankmachine5_pipe_valid_source_valid <= main_sdram_bankmachine5_pipe_valid_sink_valid;
        main_sdram_bankmachine5_pipe_valid_source_first <= main_sdram_bankmachine5_pipe_valid_sink_first;
        main_sdram_bankmachine5_pipe_valid_source_last <= main_sdram_bankmachine5_pipe_valid_sink_last;
        main_sdram_bankmachine5_pipe_valid_source_payload_we <= main_sdram_bankmachine5_pipe_valid_sink_payload_we;
        main_sdram_bankmachine5_pipe_valid_source_payload_addr <= main_sdram_bankmachine5_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine5_twtpcon_valid) begin
        main_sdram_bankmachine5_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine5_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine5_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine5_twtpcon_ready)) begin
            main_sdram_bankmachine5_twtpcon_count <= (main_sdram_bankmachine5_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine5_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine5_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine5_trccon_valid) begin
        main_sdram_bankmachine5_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine5_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine5_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine5_trccon_ready)) begin
            main_sdram_bankmachine5_trccon_count <= (main_sdram_bankmachine5_trccon_count - 1'd1);
            if ((main_sdram_bankmachine5_trccon_count == 1'd1)) begin
                main_sdram_bankmachine5_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine5_trascon_valid) begin
        main_sdram_bankmachine5_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine5_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine5_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine5_trascon_ready)) begin
            main_sdram_bankmachine5_trascon_count <= (main_sdram_bankmachine5_trascon_count - 1'd1);
            if ((main_sdram_bankmachine5_trascon_count == 1'd1)) begin
                main_sdram_bankmachine5_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine5_state <= builder_soclinux_bankmachine5_next_state;
    if (main_sdram_bankmachine6_row_close) begin
        main_sdram_bankmachine6_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine6_row_open) begin
            main_sdram_bankmachine6_row_opened <= 1'd1;
            main_sdram_bankmachine6_row <= main_sdram_bankmachine6_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine6_syncfifo6_we & main_sdram_bankmachine6_syncfifo6_writable) & (~main_sdram_bankmachine6_replace))) begin
        main_sdram_bankmachine6_produce <= (main_sdram_bankmachine6_produce + 1'd1);
    end
    if (main_sdram_bankmachine6_do_read) begin
        main_sdram_bankmachine6_consume <= (main_sdram_bankmachine6_consume + 1'd1);
    end
    if (((main_sdram_bankmachine6_syncfifo6_we & main_sdram_bankmachine6_syncfifo6_writable) & (~main_sdram_bankmachine6_replace))) begin
        if ((~main_sdram_bankmachine6_do_read)) begin
            main_sdram_bankmachine6_level <= (main_sdram_bankmachine6_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine6_do_read) begin
            main_sdram_bankmachine6_level <= (main_sdram_bankmachine6_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine6_pipe_valid_source_valid) | main_sdram_bankmachine6_pipe_valid_source_ready)) begin
        main_sdram_bankmachine6_pipe_valid_source_valid <= main_sdram_bankmachine6_pipe_valid_sink_valid;
        main_sdram_bankmachine6_pipe_valid_source_first <= main_sdram_bankmachine6_pipe_valid_sink_first;
        main_sdram_bankmachine6_pipe_valid_source_last <= main_sdram_bankmachine6_pipe_valid_sink_last;
        main_sdram_bankmachine6_pipe_valid_source_payload_we <= main_sdram_bankmachine6_pipe_valid_sink_payload_we;
        main_sdram_bankmachine6_pipe_valid_source_payload_addr <= main_sdram_bankmachine6_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine6_twtpcon_valid) begin
        main_sdram_bankmachine6_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine6_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine6_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine6_twtpcon_ready)) begin
            main_sdram_bankmachine6_twtpcon_count <= (main_sdram_bankmachine6_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine6_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine6_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine6_trccon_valid) begin
        main_sdram_bankmachine6_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine6_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine6_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine6_trccon_ready)) begin
            main_sdram_bankmachine6_trccon_count <= (main_sdram_bankmachine6_trccon_count - 1'd1);
            if ((main_sdram_bankmachine6_trccon_count == 1'd1)) begin
                main_sdram_bankmachine6_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine6_trascon_valid) begin
        main_sdram_bankmachine6_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine6_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine6_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine6_trascon_ready)) begin
            main_sdram_bankmachine6_trascon_count <= (main_sdram_bankmachine6_trascon_count - 1'd1);
            if ((main_sdram_bankmachine6_trascon_count == 1'd1)) begin
                main_sdram_bankmachine6_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine6_state <= builder_soclinux_bankmachine6_next_state;
    if (main_sdram_bankmachine7_row_close) begin
        main_sdram_bankmachine7_row_opened <= 1'd0;
    end else begin
        if (main_sdram_bankmachine7_row_open) begin
            main_sdram_bankmachine7_row_opened <= 1'd1;
            main_sdram_bankmachine7_row <= main_sdram_bankmachine7_source_source_payload_addr[21:7];
        end
    end
    if (((main_sdram_bankmachine7_syncfifo7_we & main_sdram_bankmachine7_syncfifo7_writable) & (~main_sdram_bankmachine7_replace))) begin
        main_sdram_bankmachine7_produce <= (main_sdram_bankmachine7_produce + 1'd1);
    end
    if (main_sdram_bankmachine7_do_read) begin
        main_sdram_bankmachine7_consume <= (main_sdram_bankmachine7_consume + 1'd1);
    end
    if (((main_sdram_bankmachine7_syncfifo7_we & main_sdram_bankmachine7_syncfifo7_writable) & (~main_sdram_bankmachine7_replace))) begin
        if ((~main_sdram_bankmachine7_do_read)) begin
            main_sdram_bankmachine7_level <= (main_sdram_bankmachine7_level + 1'd1);
        end
    end else begin
        if (main_sdram_bankmachine7_do_read) begin
            main_sdram_bankmachine7_level <= (main_sdram_bankmachine7_level - 1'd1);
        end
    end
    if (((~main_sdram_bankmachine7_pipe_valid_source_valid) | main_sdram_bankmachine7_pipe_valid_source_ready)) begin
        main_sdram_bankmachine7_pipe_valid_source_valid <= main_sdram_bankmachine7_pipe_valid_sink_valid;
        main_sdram_bankmachine7_pipe_valid_source_first <= main_sdram_bankmachine7_pipe_valid_sink_first;
        main_sdram_bankmachine7_pipe_valid_source_last <= main_sdram_bankmachine7_pipe_valid_sink_last;
        main_sdram_bankmachine7_pipe_valid_source_payload_we <= main_sdram_bankmachine7_pipe_valid_sink_payload_we;
        main_sdram_bankmachine7_pipe_valid_source_payload_addr <= main_sdram_bankmachine7_pipe_valid_sink_payload_addr;
    end
    if (main_sdram_bankmachine7_twtpcon_valid) begin
        main_sdram_bankmachine7_twtpcon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine7_twtpcon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine7_twtpcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine7_twtpcon_ready)) begin
            main_sdram_bankmachine7_twtpcon_count <= (main_sdram_bankmachine7_twtpcon_count - 1'd1);
            if ((main_sdram_bankmachine7_twtpcon_count == 1'd1)) begin
                main_sdram_bankmachine7_twtpcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine7_trccon_valid) begin
        main_sdram_bankmachine7_trccon_count <= 3'd6;
        if (1'd0) begin
            main_sdram_bankmachine7_trccon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine7_trccon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine7_trccon_ready)) begin
            main_sdram_bankmachine7_trccon_count <= (main_sdram_bankmachine7_trccon_count - 1'd1);
            if ((main_sdram_bankmachine7_trccon_count == 1'd1)) begin
                main_sdram_bankmachine7_trccon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_bankmachine7_trascon_valid) begin
        main_sdram_bankmachine7_trascon_count <= 3'd4;
        if (1'd0) begin
            main_sdram_bankmachine7_trascon_ready <= 1'd1;
        end else begin
            main_sdram_bankmachine7_trascon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_bankmachine7_trascon_ready)) begin
            main_sdram_bankmachine7_trascon_count <= (main_sdram_bankmachine7_trascon_count - 1'd1);
            if ((main_sdram_bankmachine7_trascon_count == 1'd1)) begin
                main_sdram_bankmachine7_trascon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_bankmachine7_state <= builder_soclinux_bankmachine7_next_state;
    if ((~main_sdram_en0)) begin
        main_sdram_time0 <= 5'd31;
    end else begin
        if ((~main_sdram_max_time0)) begin
            main_sdram_time0 <= (main_sdram_time0 - 1'd1);
        end
    end
    if ((~main_sdram_en1)) begin
        main_sdram_time1 <= 4'd15;
    end else begin
        if ((~main_sdram_max_time1)) begin
            main_sdram_time1 <= (main_sdram_time1 - 1'd1);
        end
    end
    if (main_sdram_choose_cmd_ce) begin
        case (main_sdram_choose_cmd_grant)
            1'd0: begin
                if (main_sdram_choose_cmd_request[1]) begin
                    main_sdram_choose_cmd_grant <= 1'd1;
                end else begin
                    if (main_sdram_choose_cmd_request[2]) begin
                        main_sdram_choose_cmd_grant <= 2'd2;
                    end else begin
                        if (main_sdram_choose_cmd_request[3]) begin
                            main_sdram_choose_cmd_grant <= 2'd3;
                        end else begin
                            if (main_sdram_choose_cmd_request[4]) begin
                                main_sdram_choose_cmd_grant <= 3'd4;
                            end else begin
                                if (main_sdram_choose_cmd_request[5]) begin
                                    main_sdram_choose_cmd_grant <= 3'd5;
                                end else begin
                                    if (main_sdram_choose_cmd_request[6]) begin
                                        main_sdram_choose_cmd_grant <= 3'd6;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[7]) begin
                                            main_sdram_choose_cmd_grant <= 3'd7;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            1'd1: begin
                if (main_sdram_choose_cmd_request[2]) begin
                    main_sdram_choose_cmd_grant <= 2'd2;
                end else begin
                    if (main_sdram_choose_cmd_request[3]) begin
                        main_sdram_choose_cmd_grant <= 2'd3;
                    end else begin
                        if (main_sdram_choose_cmd_request[4]) begin
                            main_sdram_choose_cmd_grant <= 3'd4;
                        end else begin
                            if (main_sdram_choose_cmd_request[5]) begin
                                main_sdram_choose_cmd_grant <= 3'd5;
                            end else begin
                                if (main_sdram_choose_cmd_request[6]) begin
                                    main_sdram_choose_cmd_grant <= 3'd6;
                                end else begin
                                    if (main_sdram_choose_cmd_request[7]) begin
                                        main_sdram_choose_cmd_grant <= 3'd7;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[0]) begin
                                            main_sdram_choose_cmd_grant <= 1'd0;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            2'd2: begin
                if (main_sdram_choose_cmd_request[3]) begin
                    main_sdram_choose_cmd_grant <= 2'd3;
                end else begin
                    if (main_sdram_choose_cmd_request[4]) begin
                        main_sdram_choose_cmd_grant <= 3'd4;
                    end else begin
                        if (main_sdram_choose_cmd_request[5]) begin
                            main_sdram_choose_cmd_grant <= 3'd5;
                        end else begin
                            if (main_sdram_choose_cmd_request[6]) begin
                                main_sdram_choose_cmd_grant <= 3'd6;
                            end else begin
                                if (main_sdram_choose_cmd_request[7]) begin
                                    main_sdram_choose_cmd_grant <= 3'd7;
                                end else begin
                                    if (main_sdram_choose_cmd_request[0]) begin
                                        main_sdram_choose_cmd_grant <= 1'd0;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[1]) begin
                                            main_sdram_choose_cmd_grant <= 1'd1;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            2'd3: begin
                if (main_sdram_choose_cmd_request[4]) begin
                    main_sdram_choose_cmd_grant <= 3'd4;
                end else begin
                    if (main_sdram_choose_cmd_request[5]) begin
                        main_sdram_choose_cmd_grant <= 3'd5;
                    end else begin
                        if (main_sdram_choose_cmd_request[6]) begin
                            main_sdram_choose_cmd_grant <= 3'd6;
                        end else begin
                            if (main_sdram_choose_cmd_request[7]) begin
                                main_sdram_choose_cmd_grant <= 3'd7;
                            end else begin
                                if (main_sdram_choose_cmd_request[0]) begin
                                    main_sdram_choose_cmd_grant <= 1'd0;
                                end else begin
                                    if (main_sdram_choose_cmd_request[1]) begin
                                        main_sdram_choose_cmd_grant <= 1'd1;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[2]) begin
                                            main_sdram_choose_cmd_grant <= 2'd2;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd4: begin
                if (main_sdram_choose_cmd_request[5]) begin
                    main_sdram_choose_cmd_grant <= 3'd5;
                end else begin
                    if (main_sdram_choose_cmd_request[6]) begin
                        main_sdram_choose_cmd_grant <= 3'd6;
                    end else begin
                        if (main_sdram_choose_cmd_request[7]) begin
                            main_sdram_choose_cmd_grant <= 3'd7;
                        end else begin
                            if (main_sdram_choose_cmd_request[0]) begin
                                main_sdram_choose_cmd_grant <= 1'd0;
                            end else begin
                                if (main_sdram_choose_cmd_request[1]) begin
                                    main_sdram_choose_cmd_grant <= 1'd1;
                                end else begin
                                    if (main_sdram_choose_cmd_request[2]) begin
                                        main_sdram_choose_cmd_grant <= 2'd2;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[3]) begin
                                            main_sdram_choose_cmd_grant <= 2'd3;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd5: begin
                if (main_sdram_choose_cmd_request[6]) begin
                    main_sdram_choose_cmd_grant <= 3'd6;
                end else begin
                    if (main_sdram_choose_cmd_request[7]) begin
                        main_sdram_choose_cmd_grant <= 3'd7;
                    end else begin
                        if (main_sdram_choose_cmd_request[0]) begin
                            main_sdram_choose_cmd_grant <= 1'd0;
                        end else begin
                            if (main_sdram_choose_cmd_request[1]) begin
                                main_sdram_choose_cmd_grant <= 1'd1;
                            end else begin
                                if (main_sdram_choose_cmd_request[2]) begin
                                    main_sdram_choose_cmd_grant <= 2'd2;
                                end else begin
                                    if (main_sdram_choose_cmd_request[3]) begin
                                        main_sdram_choose_cmd_grant <= 2'd3;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[4]) begin
                                            main_sdram_choose_cmd_grant <= 3'd4;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd6: begin
                if (main_sdram_choose_cmd_request[7]) begin
                    main_sdram_choose_cmd_grant <= 3'd7;
                end else begin
                    if (main_sdram_choose_cmd_request[0]) begin
                        main_sdram_choose_cmd_grant <= 1'd0;
                    end else begin
                        if (main_sdram_choose_cmd_request[1]) begin
                            main_sdram_choose_cmd_grant <= 1'd1;
                        end else begin
                            if (main_sdram_choose_cmd_request[2]) begin
                                main_sdram_choose_cmd_grant <= 2'd2;
                            end else begin
                                if (main_sdram_choose_cmd_request[3]) begin
                                    main_sdram_choose_cmd_grant <= 2'd3;
                                end else begin
                                    if (main_sdram_choose_cmd_request[4]) begin
                                        main_sdram_choose_cmd_grant <= 3'd4;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[5]) begin
                                            main_sdram_choose_cmd_grant <= 3'd5;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd7: begin
                if (main_sdram_choose_cmd_request[0]) begin
                    main_sdram_choose_cmd_grant <= 1'd0;
                end else begin
                    if (main_sdram_choose_cmd_request[1]) begin
                        main_sdram_choose_cmd_grant <= 1'd1;
                    end else begin
                        if (main_sdram_choose_cmd_request[2]) begin
                            main_sdram_choose_cmd_grant <= 2'd2;
                        end else begin
                            if (main_sdram_choose_cmd_request[3]) begin
                                main_sdram_choose_cmd_grant <= 2'd3;
                            end else begin
                                if (main_sdram_choose_cmd_request[4]) begin
                                    main_sdram_choose_cmd_grant <= 3'd4;
                                end else begin
                                    if (main_sdram_choose_cmd_request[5]) begin
                                        main_sdram_choose_cmd_grant <= 3'd5;
                                    end else begin
                                        if (main_sdram_choose_cmd_request[6]) begin
                                            main_sdram_choose_cmd_grant <= 3'd6;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
        endcase
    end
    if (main_sdram_choose_req_ce) begin
        case (main_sdram_choose_req_grant)
            1'd0: begin
                if (main_sdram_choose_req_request[1]) begin
                    main_sdram_choose_req_grant <= 1'd1;
                end else begin
                    if (main_sdram_choose_req_request[2]) begin
                        main_sdram_choose_req_grant <= 2'd2;
                    end else begin
                        if (main_sdram_choose_req_request[3]) begin
                            main_sdram_choose_req_grant <= 2'd3;
                        end else begin
                            if (main_sdram_choose_req_request[4]) begin
                                main_sdram_choose_req_grant <= 3'd4;
                            end else begin
                                if (main_sdram_choose_req_request[5]) begin
                                    main_sdram_choose_req_grant <= 3'd5;
                                end else begin
                                    if (main_sdram_choose_req_request[6]) begin
                                        main_sdram_choose_req_grant <= 3'd6;
                                    end else begin
                                        if (main_sdram_choose_req_request[7]) begin
                                            main_sdram_choose_req_grant <= 3'd7;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            1'd1: begin
                if (main_sdram_choose_req_request[2]) begin
                    main_sdram_choose_req_grant <= 2'd2;
                end else begin
                    if (main_sdram_choose_req_request[3]) begin
                        main_sdram_choose_req_grant <= 2'd3;
                    end else begin
                        if (main_sdram_choose_req_request[4]) begin
                            main_sdram_choose_req_grant <= 3'd4;
                        end else begin
                            if (main_sdram_choose_req_request[5]) begin
                                main_sdram_choose_req_grant <= 3'd5;
                            end else begin
                                if (main_sdram_choose_req_request[6]) begin
                                    main_sdram_choose_req_grant <= 3'd6;
                                end else begin
                                    if (main_sdram_choose_req_request[7]) begin
                                        main_sdram_choose_req_grant <= 3'd7;
                                    end else begin
                                        if (main_sdram_choose_req_request[0]) begin
                                            main_sdram_choose_req_grant <= 1'd0;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            2'd2: begin
                if (main_sdram_choose_req_request[3]) begin
                    main_sdram_choose_req_grant <= 2'd3;
                end else begin
                    if (main_sdram_choose_req_request[4]) begin
                        main_sdram_choose_req_grant <= 3'd4;
                    end else begin
                        if (main_sdram_choose_req_request[5]) begin
                            main_sdram_choose_req_grant <= 3'd5;
                        end else begin
                            if (main_sdram_choose_req_request[6]) begin
                                main_sdram_choose_req_grant <= 3'd6;
                            end else begin
                                if (main_sdram_choose_req_request[7]) begin
                                    main_sdram_choose_req_grant <= 3'd7;
                                end else begin
                                    if (main_sdram_choose_req_request[0]) begin
                                        main_sdram_choose_req_grant <= 1'd0;
                                    end else begin
                                        if (main_sdram_choose_req_request[1]) begin
                                            main_sdram_choose_req_grant <= 1'd1;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            2'd3: begin
                if (main_sdram_choose_req_request[4]) begin
                    main_sdram_choose_req_grant <= 3'd4;
                end else begin
                    if (main_sdram_choose_req_request[5]) begin
                        main_sdram_choose_req_grant <= 3'd5;
                    end else begin
                        if (main_sdram_choose_req_request[6]) begin
                            main_sdram_choose_req_grant <= 3'd6;
                        end else begin
                            if (main_sdram_choose_req_request[7]) begin
                                main_sdram_choose_req_grant <= 3'd7;
                            end else begin
                                if (main_sdram_choose_req_request[0]) begin
                                    main_sdram_choose_req_grant <= 1'd0;
                                end else begin
                                    if (main_sdram_choose_req_request[1]) begin
                                        main_sdram_choose_req_grant <= 1'd1;
                                    end else begin
                                        if (main_sdram_choose_req_request[2]) begin
                                            main_sdram_choose_req_grant <= 2'd2;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd4: begin
                if (main_sdram_choose_req_request[5]) begin
                    main_sdram_choose_req_grant <= 3'd5;
                end else begin
                    if (main_sdram_choose_req_request[6]) begin
                        main_sdram_choose_req_grant <= 3'd6;
                    end else begin
                        if (main_sdram_choose_req_request[7]) begin
                            main_sdram_choose_req_grant <= 3'd7;
                        end else begin
                            if (main_sdram_choose_req_request[0]) begin
                                main_sdram_choose_req_grant <= 1'd0;
                            end else begin
                                if (main_sdram_choose_req_request[1]) begin
                                    main_sdram_choose_req_grant <= 1'd1;
                                end else begin
                                    if (main_sdram_choose_req_request[2]) begin
                                        main_sdram_choose_req_grant <= 2'd2;
                                    end else begin
                                        if (main_sdram_choose_req_request[3]) begin
                                            main_sdram_choose_req_grant <= 2'd3;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd5: begin
                if (main_sdram_choose_req_request[6]) begin
                    main_sdram_choose_req_grant <= 3'd6;
                end else begin
                    if (main_sdram_choose_req_request[7]) begin
                        main_sdram_choose_req_grant <= 3'd7;
                    end else begin
                        if (main_sdram_choose_req_request[0]) begin
                            main_sdram_choose_req_grant <= 1'd0;
                        end else begin
                            if (main_sdram_choose_req_request[1]) begin
                                main_sdram_choose_req_grant <= 1'd1;
                            end else begin
                                if (main_sdram_choose_req_request[2]) begin
                                    main_sdram_choose_req_grant <= 2'd2;
                                end else begin
                                    if (main_sdram_choose_req_request[3]) begin
                                        main_sdram_choose_req_grant <= 2'd3;
                                    end else begin
                                        if (main_sdram_choose_req_request[4]) begin
                                            main_sdram_choose_req_grant <= 3'd4;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd6: begin
                if (main_sdram_choose_req_request[7]) begin
                    main_sdram_choose_req_grant <= 3'd7;
                end else begin
                    if (main_sdram_choose_req_request[0]) begin
                        main_sdram_choose_req_grant <= 1'd0;
                    end else begin
                        if (main_sdram_choose_req_request[1]) begin
                            main_sdram_choose_req_grant <= 1'd1;
                        end else begin
                            if (main_sdram_choose_req_request[2]) begin
                                main_sdram_choose_req_grant <= 2'd2;
                            end else begin
                                if (main_sdram_choose_req_request[3]) begin
                                    main_sdram_choose_req_grant <= 2'd3;
                                end else begin
                                    if (main_sdram_choose_req_request[4]) begin
                                        main_sdram_choose_req_grant <= 3'd4;
                                    end else begin
                                        if (main_sdram_choose_req_request[5]) begin
                                            main_sdram_choose_req_grant <= 3'd5;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
            3'd7: begin
                if (main_sdram_choose_req_request[0]) begin
                    main_sdram_choose_req_grant <= 1'd0;
                end else begin
                    if (main_sdram_choose_req_request[1]) begin
                        main_sdram_choose_req_grant <= 1'd1;
                    end else begin
                        if (main_sdram_choose_req_request[2]) begin
                            main_sdram_choose_req_grant <= 2'd2;
                        end else begin
                            if (main_sdram_choose_req_request[3]) begin
                                main_sdram_choose_req_grant <= 2'd3;
                            end else begin
                                if (main_sdram_choose_req_request[4]) begin
                                    main_sdram_choose_req_grant <= 3'd4;
                                end else begin
                                    if (main_sdram_choose_req_request[5]) begin
                                        main_sdram_choose_req_grant <= 3'd5;
                                    end else begin
                                        if (main_sdram_choose_req_request[6]) begin
                                            main_sdram_choose_req_grant <= 3'd6;
                                        end
                                    end
                                end
                            end
                        end
                    end
                end
            end
        endcase
    end
    main_sdram_dfi_p0_cs_n <= 1'd0;
    main_sdram_dfi_p0_bank <= builder_sync_array_muxed0;
    main_sdram_dfi_p0_address <= builder_sync_array_muxed1;
    main_sdram_dfi_p0_cas_n <= (~builder_sync_array_muxed2);
    main_sdram_dfi_p0_ras_n <= (~builder_sync_array_muxed3);
    main_sdram_dfi_p0_we_n <= (~builder_sync_array_muxed4);
    main_sdram_dfi_p0_rddata_en <= builder_sync_array_muxed5;
    main_sdram_dfi_p0_wrdata_en <= builder_sync_array_muxed6;
    main_sdram_dfi_p1_cs_n <= 1'd0;
    main_sdram_dfi_p1_bank <= builder_sync_array_muxed7;
    main_sdram_dfi_p1_address <= builder_sync_array_muxed8;
    main_sdram_dfi_p1_cas_n <= (~builder_sync_array_muxed9);
    main_sdram_dfi_p1_ras_n <= (~builder_sync_array_muxed10);
    main_sdram_dfi_p1_we_n <= (~builder_sync_array_muxed11);
    main_sdram_dfi_p1_rddata_en <= builder_sync_array_muxed12;
    main_sdram_dfi_p1_wrdata_en <= builder_sync_array_muxed13;
    main_sdram_dfi_p2_cs_n <= 1'd0;
    main_sdram_dfi_p2_bank <= builder_sync_array_muxed14;
    main_sdram_dfi_p2_address <= builder_sync_array_muxed15;
    main_sdram_dfi_p2_cas_n <= (~builder_sync_array_muxed16);
    main_sdram_dfi_p2_ras_n <= (~builder_sync_array_muxed17);
    main_sdram_dfi_p2_we_n <= (~builder_sync_array_muxed18);
    main_sdram_dfi_p2_rddata_en <= builder_sync_array_muxed19;
    main_sdram_dfi_p2_wrdata_en <= builder_sync_array_muxed20;
    main_sdram_dfi_p3_cs_n <= 1'd0;
    main_sdram_dfi_p3_bank <= builder_sync_array_muxed21;
    main_sdram_dfi_p3_address <= builder_sync_array_muxed22;
    main_sdram_dfi_p3_cas_n <= (~builder_sync_array_muxed23);
    main_sdram_dfi_p3_ras_n <= (~builder_sync_array_muxed24);
    main_sdram_dfi_p3_we_n <= (~builder_sync_array_muxed25);
    main_sdram_dfi_p3_rddata_en <= builder_sync_array_muxed26;
    main_sdram_dfi_p3_wrdata_en <= builder_sync_array_muxed27;
    if (main_sdram_trrdcon_valid) begin
        main_sdram_trrdcon_count <= 1'd1;
        if (1'd0) begin
            main_sdram_trrdcon_ready <= 1'd1;
        end else begin
            main_sdram_trrdcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_trrdcon_ready)) begin
            main_sdram_trrdcon_count <= (main_sdram_trrdcon_count - 1'd1);
            if ((main_sdram_trrdcon_count == 1'd1)) begin
                main_sdram_trrdcon_ready <= 1'd1;
            end
        end
    end
    main_sdram_tfawcon_window <= {main_sdram_tfawcon_window, main_sdram_tfawcon_valid};
    if ((main_sdram_tfawcon_count < 3'd4)) begin
        if ((main_sdram_tfawcon_count == 2'd3)) begin
            main_sdram_tfawcon_ready <= (~main_sdram_tfawcon_valid);
        end else begin
            main_sdram_tfawcon_ready <= 1'd1;
        end
    end
    if (main_sdram_tccdcon_valid) begin
        main_sdram_tccdcon_count <= 1'd0;
        if (1'd1) begin
            main_sdram_tccdcon_ready <= 1'd1;
        end else begin
            main_sdram_tccdcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_tccdcon_ready)) begin
            main_sdram_tccdcon_count <= (main_sdram_tccdcon_count - 1'd1);
            if ((main_sdram_tccdcon_count == 1'd1)) begin
                main_sdram_tccdcon_ready <= 1'd1;
            end
        end
    end
    if (main_sdram_twtrcon_valid) begin
        main_sdram_twtrcon_count <= 3'd5;
        if (1'd0) begin
            main_sdram_twtrcon_ready <= 1'd1;
        end else begin
            main_sdram_twtrcon_ready <= 1'd0;
        end
    end else begin
        if ((~main_sdram_twtrcon_ready)) begin
            main_sdram_twtrcon_count <= (main_sdram_twtrcon_count - 1'd1);
            if ((main_sdram_twtrcon_count == 1'd1)) begin
                main_sdram_twtrcon_ready <= 1'd1;
            end
        end
    end
    builder_soclinux_multiplexer_state <= builder_soclinux_multiplexer_next_state;
    builder_soclinux_new_master_wdata_ready0 <= ((((((((1'd0 | ((builder_soclinux_roundrobin0_grant == 1'd0) & main_sdram_interface_bank0_wdata_ready)) | ((builder_soclinux_roundrobin1_grant == 1'd0) & main_sdram_interface_bank1_wdata_ready)) | ((builder_soclinux_roundrobin2_grant == 1'd0) & main_sdram_interface_bank2_wdata_ready)) | ((builder_soclinux_roundrobin3_grant == 1'd0) & main_sdram_interface_bank3_wdata_ready)) | ((builder_soclinux_roundrobin4_grant == 1'd0) & main_sdram_interface_bank4_wdata_ready)) | ((builder_soclinux_roundrobin5_grant == 1'd0) & main_sdram_interface_bank5_wdata_ready)) | ((builder_soclinux_roundrobin6_grant == 1'd0) & main_sdram_interface_bank6_wdata_ready)) | ((builder_soclinux_roundrobin7_grant == 1'd0) & main_sdram_interface_bank7_wdata_ready));
    builder_soclinux_new_master_wdata_ready1 <= builder_soclinux_new_master_wdata_ready0;
    builder_soclinux_new_master_wdata_ready2 <= builder_soclinux_new_master_wdata_ready1;
    builder_soclinux_new_master_wdata_ready3 <= ((((((((1'd0 | ((builder_soclinux_roundrobin0_grant == 1'd1) & main_sdram_interface_bank0_wdata_ready)) | ((builder_soclinux_roundrobin1_grant == 1'd1) & main_sdram_interface_bank1_wdata_ready)) | ((builder_soclinux_roundrobin2_grant == 1'd1) & main_sdram_interface_bank2_wdata_ready)) | ((builder_soclinux_roundrobin3_grant == 1'd1) & main_sdram_interface_bank3_wdata_ready)) | ((builder_soclinux_roundrobin4_grant == 1'd1) & main_sdram_interface_bank4_wdata_ready)) | ((builder_soclinux_roundrobin5_grant == 1'd1) & main_sdram_interface_bank5_wdata_ready)) | ((builder_soclinux_roundrobin6_grant == 1'd1) & main_sdram_interface_bank6_wdata_ready)) | ((builder_soclinux_roundrobin7_grant == 1'd1) & main_sdram_interface_bank7_wdata_ready));
    builder_soclinux_new_master_wdata_ready4 <= builder_soclinux_new_master_wdata_ready3;
    builder_soclinux_new_master_wdata_ready5 <= builder_soclinux_new_master_wdata_ready4;
    builder_soclinux_new_master_rdata_valid0 <= ((((((((1'd0 | ((builder_soclinux_roundrobin0_grant == 1'd0) & main_sdram_interface_bank0_rdata_valid)) | ((builder_soclinux_roundrobin1_grant == 1'd0) & main_sdram_interface_bank1_rdata_valid)) | ((builder_soclinux_roundrobin2_grant == 1'd0) & main_sdram_interface_bank2_rdata_valid)) | ((builder_soclinux_roundrobin3_grant == 1'd0) & main_sdram_interface_bank3_rdata_valid)) | ((builder_soclinux_roundrobin4_grant == 1'd0) & main_sdram_interface_bank4_rdata_valid)) | ((builder_soclinux_roundrobin5_grant == 1'd0) & main_sdram_interface_bank5_rdata_valid)) | ((builder_soclinux_roundrobin6_grant == 1'd0) & main_sdram_interface_bank6_rdata_valid)) | ((builder_soclinux_roundrobin7_grant == 1'd0) & main_sdram_interface_bank7_rdata_valid));
    builder_soclinux_new_master_rdata_valid1 <= builder_soclinux_new_master_rdata_valid0;
    builder_soclinux_new_master_rdata_valid2 <= builder_soclinux_new_master_rdata_valid1;
    builder_soclinux_new_master_rdata_valid3 <= builder_soclinux_new_master_rdata_valid2;
    builder_soclinux_new_master_rdata_valid4 <= builder_soclinux_new_master_rdata_valid3;
    builder_soclinux_new_master_rdata_valid5 <= builder_soclinux_new_master_rdata_valid4;
    builder_soclinux_new_master_rdata_valid6 <= builder_soclinux_new_master_rdata_valid5;
    builder_soclinux_new_master_rdata_valid7 <= builder_soclinux_new_master_rdata_valid6;
    builder_soclinux_new_master_rdata_valid8 <= builder_soclinux_new_master_rdata_valid7;
    builder_soclinux_new_master_rdata_valid9 <= ((((((((1'd0 | ((builder_soclinux_roundrobin0_grant == 1'd1) & main_sdram_interface_bank0_rdata_valid)) | ((builder_soclinux_roundrobin1_grant == 1'd1) & main_sdram_interface_bank1_rdata_valid)) | ((builder_soclinux_roundrobin2_grant == 1'd1) & main_sdram_interface_bank2_rdata_valid)) | ((builder_soclinux_roundrobin3_grant == 1'd1) & main_sdram_interface_bank3_rdata_valid)) | ((builder_soclinux_roundrobin4_grant == 1'd1) & main_sdram_interface_bank4_rdata_valid)) | ((builder_soclinux_roundrobin5_grant == 1'd1) & main_sdram_interface_bank5_rdata_valid)) | ((builder_soclinux_roundrobin6_grant == 1'd1) & main_sdram_interface_bank6_rdata_valid)) | ((builder_soclinux_roundrobin7_grant == 1'd1) & main_sdram_interface_bank7_rdata_valid));
    builder_soclinux_new_master_rdata_valid10 <= builder_soclinux_new_master_rdata_valid9;
    builder_soclinux_new_master_rdata_valid11 <= builder_soclinux_new_master_rdata_valid10;
    builder_soclinux_new_master_rdata_valid12 <= builder_soclinux_new_master_rdata_valid11;
    builder_soclinux_new_master_rdata_valid13 <= builder_soclinux_new_master_rdata_valid12;
    builder_soclinux_new_master_rdata_valid14 <= builder_soclinux_new_master_rdata_valid13;
    builder_soclinux_new_master_rdata_valid15 <= builder_soclinux_new_master_rdata_valid14;
    builder_soclinux_new_master_rdata_valid16 <= builder_soclinux_new_master_rdata_valid15;
    builder_soclinux_new_master_rdata_valid17 <= builder_soclinux_new_master_rdata_valid16;
    if (builder_soclinux_roundrobin0_ce) begin
        case (builder_soclinux_roundrobin0_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin0_request[1]) begin
                    builder_soclinux_roundrobin0_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin0_request[0]) begin
                    builder_soclinux_roundrobin0_grant <= 1'd0;
                end
            end
        endcase
    end
    if (builder_soclinux_roundrobin1_ce) begin
        case (builder_soclinux_roundrobin1_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin1_request[1]) begin
                    builder_soclinux_roundrobin1_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin1_request[0]) begin
                    builder_soclinux_roundrobin1_grant <= 1'd0;
                end
            end
        endcase
    end
    if (builder_soclinux_roundrobin2_ce) begin
        case (builder_soclinux_roundrobin2_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin2_request[1]) begin
                    builder_soclinux_roundrobin2_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin2_request[0]) begin
                    builder_soclinux_roundrobin2_grant <= 1'd0;
                end
            end
        endcase
    end
    if (builder_soclinux_roundrobin3_ce) begin
        case (builder_soclinux_roundrobin3_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin3_request[1]) begin
                    builder_soclinux_roundrobin3_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin3_request[0]) begin
                    builder_soclinux_roundrobin3_grant <= 1'd0;
                end
            end
        endcase
    end
    if (builder_soclinux_roundrobin4_ce) begin
        case (builder_soclinux_roundrobin4_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin4_request[1]) begin
                    builder_soclinux_roundrobin4_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin4_request[0]) begin
                    builder_soclinux_roundrobin4_grant <= 1'd0;
                end
            end
        endcase
    end
    if (builder_soclinux_roundrobin5_ce) begin
        case (builder_soclinux_roundrobin5_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin5_request[1]) begin
                    builder_soclinux_roundrobin5_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin5_request[0]) begin
                    builder_soclinux_roundrobin5_grant <= 1'd0;
                end
            end
        endcase
    end
    if (builder_soclinux_roundrobin6_ce) begin
        case (builder_soclinux_roundrobin6_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin6_request[1]) begin
                    builder_soclinux_roundrobin6_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin6_request[0]) begin
                    builder_soclinux_roundrobin6_grant <= 1'd0;
                end
            end
        endcase
    end
    if (builder_soclinux_roundrobin7_ce) begin
        case (builder_soclinux_roundrobin7_grant)
            1'd0: begin
                if (builder_soclinux_roundrobin7_request[1]) begin
                    builder_soclinux_roundrobin7_grant <= 1'd1;
                end
            end
            1'd1: begin
                if (builder_soclinux_roundrobin7_request[0]) begin
                    builder_soclinux_roundrobin7_grant <= 1'd0;
                end
            end
        endcase
    end
    if ((~main_ku_1000basex_gtpowergood)) begin
        main_ku_1000basex_pll_reset <= 1'd1;
        main_ku_1000basex_reset_counter <= 1'd0;
    end else begin
        if ((main_ku_1000basex_reset_counter == 16'd37500)) begin
            main_ku_1000basex_pll_reset <= 1'd0;
        end else begin
            main_ku_1000basex_reset_counter <= (main_ku_1000basex_reset_counter + 1'd1);
        end
    end
    if (builder_csr_bankarray_csrbank3_crg_reset0_re) begin
        main_ku_1000basex_storage <= builder_csr_bankarray_csrbank3_crg_reset0_r;
    end
    main_ku_1000basex_re <= builder_csr_bankarray_csrbank3_crg_reset0_re;
    main_ethmac_tx_cdc_cdc_graycounter0_q_binary <= main_ethmac_tx_cdc_cdc_graycounter0_q_next_binary;
    main_ethmac_tx_cdc_cdc_graycounter0_q <= main_ethmac_tx_cdc_cdc_graycounter0_q_next;
    if (main_ethmac_pulsesynchronizer0_o) begin
        main_ethmac_preamble_errors_status <= (main_ethmac_preamble_errors_status + 1'd1);
    end
    if (main_ethmac_pulsesynchronizer1_o) begin
        main_ethmac_crc_errors_status <= (main_ethmac_crc_errors_status + 1'd1);
    end
    main_ethmac_pulsesynchronizer0_toggle_o_r <= main_ethmac_pulsesynchronizer0_toggle_o;
    main_ethmac_pulsesynchronizer1_toggle_o_r <= main_ethmac_pulsesynchronizer1_toggle_o;
    main_ethmac_rx_cdc_cdc_graycounter1_q_binary <= main_ethmac_rx_cdc_cdc_graycounter1_q_next_binary;
    main_ethmac_rx_cdc_cdc_graycounter1_q <= main_ethmac_rx_cdc_cdc_graycounter1_q_next;
    if (((main_ethmac_sram49_we & main_ethmac_sram50_writable) & (~main_ethmac_sram56_replace))) begin
        main_ethmac_sram57_produce <= (main_ethmac_sram57_produce + 1'd1);
    end
    if (main_ethmac_sram63_do_read) begin
        main_ethmac_sram58_consume <= (main_ethmac_sram58_consume + 1'd1);
    end
    if (((main_ethmac_sram49_we & main_ethmac_sram50_writable) & (~main_ethmac_sram56_replace))) begin
        if ((~main_ethmac_sram63_do_read)) begin
            main_ethmac_sram55_level <= (main_ethmac_sram55_level + 1'd1);
        end
    end else begin
        if (main_ethmac_sram63_do_read) begin
            main_ethmac_sram55_level <= (main_ethmac_sram55_level - 1'd1);
        end
    end
    builder_soclinux_liteethmacsramwriter_state <= builder_soclinux_liteethmacsramwriter_next_state;
    if (main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value_ce) begin
        main_ethmac_sram35_length <= main_ethmac_sram35_length_clockdomainsrenamer_liteethmacsramwriter_t_next_value;
    end
    if (main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value_ce) begin
        main_ethmac_sram13_status <= main_ethmac_sram13_status_clockdomainsrenamer_liteethmacsramwriter_f_next_value;
    end
    if (main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value_ce) begin
        main_ethmac_slot <= main_ethmac_slot_clockdomainsrenamer_liteethmacsramwriter_next_value;
    end
    if (main_ethmac_sram108_clear) begin
        main_ethmac_sram106_pending <= 1'd0;
    end
    if (main_ethmac_sram107_trigger) begin
        main_ethmac_sram106_pending <= 1'd1;
    end
    if (((main_ethmac_sram135_we & main_ethmac_sram136_writable) & (~main_ethmac_sram142_replace))) begin
        main_ethmac_sram143_produce <= (main_ethmac_sram143_produce + 1'd1);
    end
    if (main_ethmac_sram149_do_read) begin
        main_ethmac_sram144_consume <= (main_ethmac_sram144_consume + 1'd1);
    end
    if (((main_ethmac_sram135_we & main_ethmac_sram136_writable) & (~main_ethmac_sram142_replace))) begin
        if ((~main_ethmac_sram149_do_read)) begin
            main_ethmac_sram141_level <= (main_ethmac_sram141_level + 1'd1);
        end
    end else begin
        if (main_ethmac_sram149_do_read) begin
            main_ethmac_sram141_level <= (main_ethmac_sram141_level - 1'd1);
        end
    end
    builder_soclinux_liteethmacsramreader_state <= builder_soclinux_liteethmacsramreader_next_state;
    if (main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value_ce) begin
        main_ethmac_sram122_length <= main_ethmac_sram122_length_clockdomainsrenamer_liteethmacsramreader_next_value;
    end
    main_ethmac_interface0_ack <= 1'd0;
    if (((main_ethmac_interface0_cyc & main_ethmac_interface0_stb) & ((~main_ethmac_interface0_ack) | main_ethmac_sram2_adr_burst))) begin
        main_ethmac_interface0_ack <= 1'd1;
    end
    main_ethmac_interface1_ack <= 1'd0;
    if (((main_ethmac_interface1_cyc & main_ethmac_interface1_stb) & ((~main_ethmac_interface1_ack) | main_ethmac_sram3_adr_burst))) begin
        main_ethmac_interface1_ack <= 1'd1;
    end
    main_ethmac_interface2_ack <= 1'd0;
    if (((main_ethmac_interface2_cyc & main_ethmac_interface2_stb) & ((~main_ethmac_interface2_ack) | main_ethmac_sram4_adr_burst))) begin
        main_ethmac_interface2_ack <= 1'd1;
    end
    main_ethmac_interface3_ack <= 1'd0;
    if (((main_ethmac_interface3_cyc & main_ethmac_interface3_stb) & ((~main_ethmac_interface3_ack) | main_ethmac_sram5_adr_burst))) begin
        main_ethmac_interface3_ack <= 1'd1;
    end
    main_ethmac_slave_sel_r <= main_ethmac_slave_sel;
    if (main_done) begin
        main_chaser <= {main_chaser, (~main_chaser[7])};
    end
    if (main_re) begin
        main_mode <= 1'd1;
    end
    if (main_wait) begin
        if ((~main_done)) begin
            main_count <= (main_count - 1'd1);
        end
    end else begin
        main_count <= 23'd7812500;
    end
    card_detect_d <= card_detect_status0;
    card_detect_irq <= (card_detect_status0 ^ card_detect_d);
    if ((~clocker_stop)) begin
        clocker_clks <= (clocker_clks + 1'd1);
    end
    clocker_clk_d <= clocker_clk1;
    if (clocker_clk_d) begin
        clocker_ce_delayed <= clocker_clk_en;
    end
    builder_soclinux_sdphyinit_state <= builder_soclinux_sdphyinit_next_state;
    if (init_count_sdphyinit_next_value_ce) begin
        init_count <= init_count_sdphyinit_next_value;
    end
    builder_soclinux_sdphycmdw_state <= builder_soclinux_sdphycmdw_next_state;
    if (cmdw_count_sdphycmdw_next_value_ce) begin
        cmdw_count <= cmdw_count_sdphycmdw_next_value;
    end
    if (cmdr_cmdr_pads_in_valid) begin
        cmdr_cmdr_run <= (cmdr_cmdr_start | cmdr_cmdr_run);
    end
    if (cmdr_cmdr_converter_converter_source_ready) begin
        cmdr_cmdr_converter_converter_strobe_all <= 1'd0;
    end
    if (cmdr_cmdr_converter_converter_load_part) begin
        if (((cmdr_cmdr_converter_converter_demux == 3'd7) | cmdr_cmdr_converter_converter_sink_last)) begin
            cmdr_cmdr_converter_converter_demux <= 1'd0;
            cmdr_cmdr_converter_converter_strobe_all <= 1'd1;
        end else begin
            cmdr_cmdr_converter_converter_demux <= (cmdr_cmdr_converter_converter_demux + 1'd1);
        end
    end
    if ((cmdr_cmdr_converter_converter_source_valid & cmdr_cmdr_converter_converter_source_ready)) begin
        if ((cmdr_cmdr_converter_converter_sink_valid & cmdr_cmdr_converter_converter_sink_ready)) begin
            cmdr_cmdr_converter_converter_source_first <= cmdr_cmdr_converter_converter_sink_first;
            cmdr_cmdr_converter_converter_source_last <= cmdr_cmdr_converter_converter_sink_last;
        end else begin
            cmdr_cmdr_converter_converter_source_first <= 1'd0;
            cmdr_cmdr_converter_converter_source_last <= 1'd0;
        end
    end else begin
        if ((cmdr_cmdr_converter_converter_sink_valid & cmdr_cmdr_converter_converter_sink_ready)) begin
            cmdr_cmdr_converter_converter_source_first <= (cmdr_cmdr_converter_converter_sink_first | cmdr_cmdr_converter_converter_source_first);
            cmdr_cmdr_converter_converter_source_last <= (cmdr_cmdr_converter_converter_sink_last | cmdr_cmdr_converter_converter_source_last);
        end
    end
    if (cmdr_cmdr_converter_converter_load_part) begin
        case (cmdr_cmdr_converter_converter_demux)
            1'd0: begin
                cmdr_cmdr_converter_converter_source_payload_data[7] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
            1'd1: begin
                cmdr_cmdr_converter_converter_source_payload_data[6] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
            2'd2: begin
                cmdr_cmdr_converter_converter_source_payload_data[5] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
            2'd3: begin
                cmdr_cmdr_converter_converter_source_payload_data[4] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
            3'd4: begin
                cmdr_cmdr_converter_converter_source_payload_data[3] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
            3'd5: begin
                cmdr_cmdr_converter_converter_source_payload_data[2] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
            3'd6: begin
                cmdr_cmdr_converter_converter_source_payload_data[1] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
            3'd7: begin
                cmdr_cmdr_converter_converter_source_payload_data[0] <= cmdr_cmdr_converter_converter_sink_payload_data;
            end
        endcase
    end
    if (cmdr_cmdr_converter_converter_load_part) begin
        cmdr_cmdr_converter_converter_source_payload_valid_token_count <= (cmdr_cmdr_converter_converter_demux + 1'd1);
    end
    if (((~cmdr_cmdr_buf_pipe_valid_source_valid) | cmdr_cmdr_buf_pipe_valid_source_ready)) begin
        cmdr_cmdr_buf_pipe_valid_source_valid <= cmdr_cmdr_buf_pipe_valid_sink_valid;
        cmdr_cmdr_buf_pipe_valid_source_first <= cmdr_cmdr_buf_pipe_valid_sink_first;
        cmdr_cmdr_buf_pipe_valid_source_last <= cmdr_cmdr_buf_pipe_valid_sink_last;
        cmdr_cmdr_buf_pipe_valid_source_payload_data <= cmdr_cmdr_buf_pipe_valid_sink_payload_data;
    end
    if (cmdr_cmdr_reset) begin
        cmdr_cmdr_run <= 1'd0;
        cmdr_cmdr_converter_converter_source_payload_data <= 8'd0;
        cmdr_cmdr_converter_converter_source_payload_valid_token_count <= 4'd0;
        cmdr_cmdr_converter_converter_demux <= 3'd0;
        cmdr_cmdr_converter_converter_strobe_all <= 1'd0;
        cmdr_cmdr_buf_pipe_valid_source_valid <= 1'd0;
        cmdr_cmdr_buf_pipe_valid_source_payload_data <= 8'd0;
    end
    builder_soclinux_sdphycmdr_state <= builder_soclinux_sdphycmdr_next_state;
    if (cmdr_timeout_sdphycmdr_next_value_ce0) begin
        cmdr_timeout <= cmdr_timeout_sdphycmdr_next_value0;
    end
    if (cmdr_count_sdphycmdr_next_value_ce1) begin
        cmdr_count <= cmdr_count_sdphycmdr_next_value1;
    end
    if (cmdr_busy_sdphycmdr_next_value_ce2) begin
        cmdr_busy <= cmdr_busy_sdphycmdr_next_value2;
    end
    if (cmdr_cmdr_reset_sdphycmdr_next_value_ce3) begin
        cmdr_cmdr_reset <= cmdr_cmdr_reset_sdphycmdr_next_value3;
    end
    if (dataw_crc_pads_in_valid) begin
        dataw_crc_run <= (dataw_crc_start | dataw_crc_run);
    end
    if (dataw_crc_converter_converter_source_ready) begin
        dataw_crc_converter_converter_strobe_all <= 1'd0;
    end
    if (dataw_crc_converter_converter_load_part) begin
        if (((dataw_crc_converter_converter_demux == 3'd7) | dataw_crc_converter_converter_sink_last)) begin
            dataw_crc_converter_converter_demux <= 1'd0;
            dataw_crc_converter_converter_strobe_all <= 1'd1;
        end else begin
            dataw_crc_converter_converter_demux <= (dataw_crc_converter_converter_demux + 1'd1);
        end
    end
    if ((dataw_crc_converter_converter_source_valid & dataw_crc_converter_converter_source_ready)) begin
        if ((dataw_crc_converter_converter_sink_valid & dataw_crc_converter_converter_sink_ready)) begin
            dataw_crc_converter_converter_source_first <= dataw_crc_converter_converter_sink_first;
            dataw_crc_converter_converter_source_last <= dataw_crc_converter_converter_sink_last;
        end else begin
            dataw_crc_converter_converter_source_first <= 1'd0;
            dataw_crc_converter_converter_source_last <= 1'd0;
        end
    end else begin
        if ((dataw_crc_converter_converter_sink_valid & dataw_crc_converter_converter_sink_ready)) begin
            dataw_crc_converter_converter_source_first <= (dataw_crc_converter_converter_sink_first | dataw_crc_converter_converter_source_first);
            dataw_crc_converter_converter_source_last <= (dataw_crc_converter_converter_sink_last | dataw_crc_converter_converter_source_last);
        end
    end
    if (dataw_crc_converter_converter_load_part) begin
        case (dataw_crc_converter_converter_demux)
            1'd0: begin
                dataw_crc_converter_converter_source_payload_data[7] <= dataw_crc_converter_converter_sink_payload_data;
            end
            1'd1: begin
                dataw_crc_converter_converter_source_payload_data[6] <= dataw_crc_converter_converter_sink_payload_data;
            end
            2'd2: begin
                dataw_crc_converter_converter_source_payload_data[5] <= dataw_crc_converter_converter_sink_payload_data;
            end
            2'd3: begin
                dataw_crc_converter_converter_source_payload_data[4] <= dataw_crc_converter_converter_sink_payload_data;
            end
            3'd4: begin
                dataw_crc_converter_converter_source_payload_data[3] <= dataw_crc_converter_converter_sink_payload_data;
            end
            3'd5: begin
                dataw_crc_converter_converter_source_payload_data[2] <= dataw_crc_converter_converter_sink_payload_data;
            end
            3'd6: begin
                dataw_crc_converter_converter_source_payload_data[1] <= dataw_crc_converter_converter_sink_payload_data;
            end
            3'd7: begin
                dataw_crc_converter_converter_source_payload_data[0] <= dataw_crc_converter_converter_sink_payload_data;
            end
        endcase
    end
    if (dataw_crc_converter_converter_load_part) begin
        dataw_crc_converter_converter_source_payload_valid_token_count <= (dataw_crc_converter_converter_demux + 1'd1);
    end
    if (((~dataw_crc_buf_pipe_valid_source_valid) | dataw_crc_buf_pipe_valid_source_ready)) begin
        dataw_crc_buf_pipe_valid_source_valid <= dataw_crc_buf_pipe_valid_sink_valid;
        dataw_crc_buf_pipe_valid_source_first <= dataw_crc_buf_pipe_valid_sink_first;
        dataw_crc_buf_pipe_valid_source_last <= dataw_crc_buf_pipe_valid_sink_last;
        dataw_crc_buf_pipe_valid_source_payload_data <= dataw_crc_buf_pipe_valid_sink_payload_data;
    end
    if (dataw_crc_reset) begin
        dataw_crc_run <= 1'd0;
        dataw_crc_converter_converter_source_payload_data <= 8'd0;
        dataw_crc_converter_converter_source_payload_valid_token_count <= 4'd0;
        dataw_crc_converter_converter_demux <= 3'd0;
        dataw_crc_converter_converter_strobe_all <= 1'd0;
        dataw_crc_buf_pipe_valid_source_valid <= 1'd0;
        dataw_crc_buf_pipe_valid_source_payload_data <= 8'd0;
    end
    builder_soclinux_sdphydataw_state <= builder_soclinux_sdphydataw_next_state;
    if (dataw_accepted1_sdphydataw_next_value_ce0) begin
        dataw_accepted1 <= dataw_accepted1_sdphydataw_next_value0;
    end
    if (dataw_crc_error1_sdphydataw_next_value_ce1) begin
        dataw_crc_error1 <= dataw_crc_error1_sdphydataw_next_value1;
    end
    if (dataw_write_error1_sdphydataw_next_value_ce2) begin
        dataw_write_error1 <= dataw_write_error1_sdphydataw_next_value2;
    end
    if (dataw_count_sdphydataw_next_value_ce3) begin
        dataw_count <= dataw_count_sdphydataw_next_value3;
    end
    if (datar_datar_pads_in_valid) begin
        datar_datar_run <= (datar_datar_start | datar_datar_run);
    end
    if (datar_datar_converter_converter_source_ready) begin
        datar_datar_converter_converter_strobe_all <= 1'd0;
    end
    if (datar_datar_converter_converter_load_part) begin
        if (((datar_datar_converter_converter_demux == 1'd1) | datar_datar_converter_converter_sink_last)) begin
            datar_datar_converter_converter_demux <= 1'd0;
            datar_datar_converter_converter_strobe_all <= 1'd1;
        end else begin
            datar_datar_converter_converter_demux <= (datar_datar_converter_converter_demux + 1'd1);
        end
    end
    if ((datar_datar_converter_converter_source_valid & datar_datar_converter_converter_source_ready)) begin
        if ((datar_datar_converter_converter_sink_valid & datar_datar_converter_converter_sink_ready)) begin
            datar_datar_converter_converter_source_first <= datar_datar_converter_converter_sink_first;
            datar_datar_converter_converter_source_last <= datar_datar_converter_converter_sink_last;
        end else begin
            datar_datar_converter_converter_source_first <= 1'd0;
            datar_datar_converter_converter_source_last <= 1'd0;
        end
    end else begin
        if ((datar_datar_converter_converter_sink_valid & datar_datar_converter_converter_sink_ready)) begin
            datar_datar_converter_converter_source_first <= (datar_datar_converter_converter_sink_first | datar_datar_converter_converter_source_first);
            datar_datar_converter_converter_source_last <= (datar_datar_converter_converter_sink_last | datar_datar_converter_converter_source_last);
        end
    end
    if (datar_datar_converter_converter_load_part) begin
        case (datar_datar_converter_converter_demux)
            1'd0: begin
                datar_datar_converter_converter_source_payload_data[7:4] <= datar_datar_converter_converter_sink_payload_data;
            end
            1'd1: begin
                datar_datar_converter_converter_source_payload_data[3:0] <= datar_datar_converter_converter_sink_payload_data;
            end
        endcase
    end
    if (datar_datar_converter_converter_load_part) begin
        datar_datar_converter_converter_source_payload_valid_token_count <= (datar_datar_converter_converter_demux + 1'd1);
    end
    if (((~datar_datar_buf_pipe_valid_source_valid) | datar_datar_buf_pipe_valid_source_ready)) begin
        datar_datar_buf_pipe_valid_source_valid <= datar_datar_buf_pipe_valid_sink_valid;
        datar_datar_buf_pipe_valid_source_first <= datar_datar_buf_pipe_valid_sink_first;
        datar_datar_buf_pipe_valid_source_last <= datar_datar_buf_pipe_valid_sink_last;
        datar_datar_buf_pipe_valid_source_payload_data <= datar_datar_buf_pipe_valid_sink_payload_data;
    end
    if (datar_datar_reset) begin
        datar_datar_run <= 1'd0;
        datar_datar_converter_converter_source_payload_data <= 8'd0;
        datar_datar_converter_converter_source_payload_valid_token_count <= 2'd0;
        datar_datar_converter_converter_demux <= 1'd0;
        datar_datar_converter_converter_strobe_all <= 1'd0;
        datar_datar_buf_pipe_valid_source_valid <= 1'd0;
        datar_datar_buf_pipe_valid_source_payload_data <= 8'd0;
    end
    builder_soclinux_sdphydatar_state <= builder_soclinux_sdphydatar_next_state;
    if (datar_count_sdphydatar_next_value_ce0) begin
        datar_count <= datar_count_sdphydatar_next_value0;
    end
    if (datar_timeout_sdphydatar_next_value_ce1) begin
        datar_timeout <= datar_timeout_sdphydatar_next_value1;
    end
    if (datar_datar_reset_sdphydatar_next_value_ce2) begin
        datar_datar_reset <= datar_datar_reset_sdphydatar_next_value2;
    end
    clocker_clk_delay <= {clocker_clk_delay, clocker_clk0};
    sdpads_data_i_ce <= (clocker_clk_delay[1] & (~clocker_clk_delay[0]));
    if (sdcore_crc7_inserter_reset) begin
        sdcore_crc7_inserter_reg0 <= 1'd0;
    end else begin
        if (sdcore_crc7_inserter_enable) begin
            sdcore_crc7_inserter_reg0 <= sdcore_crc7_inserter_reg40;
        end
    end
    if (sdcore_crc16_inserter_crc0_reset) begin
        sdcore_crc16_inserter_crc0_reg0 <= 1'd0;
    end else begin
        if (sdcore_crc16_inserter_crc0_enable) begin
            sdcore_crc16_inserter_crc0_reg0 <= sdcore_crc16_inserter_crc0_reg2;
        end
    end
    if (sdcore_crc16_inserter_crc1_reset) begin
        sdcore_crc16_inserter_crc1_reg0 <= 1'd0;
    end else begin
        if (sdcore_crc16_inserter_crc1_enable) begin
            sdcore_crc16_inserter_crc1_reg0 <= sdcore_crc16_inserter_crc1_reg2;
        end
    end
    if (sdcore_crc16_inserter_crc2_reset) begin
        sdcore_crc16_inserter_crc2_reg0 <= 1'd0;
    end else begin
        if (sdcore_crc16_inserter_crc2_enable) begin
            sdcore_crc16_inserter_crc2_reg0 <= sdcore_crc16_inserter_crc2_reg2;
        end
    end
    if (sdcore_crc16_inserter_crc3_reset) begin
        sdcore_crc16_inserter_crc3_reg0 <= 1'd0;
    end else begin
        if (sdcore_crc16_inserter_crc3_enable) begin
            sdcore_crc16_inserter_crc3_reg0 <= sdcore_crc16_inserter_crc3_reg2;
        end
    end
    builder_soclinux_sdcore_crc16inserter_state <= builder_soclinux_sdcore_crc16inserter_next_state;
    if (sdcore_crc16_inserter_count_crc16inserter_next_value_ce) begin
        sdcore_crc16_inserter_count <= sdcore_crc16_inserter_count_crc16inserter_next_value;
    end
    if (((sdcore_fifo_syncfifo_we & sdcore_fifo_syncfifo_writable) & (~sdcore_fifo_replace))) begin
        sdcore_fifo_produce <= (sdcore_fifo_produce + 1'd1);
    end
    if (sdcore_fifo_do_read) begin
        sdcore_fifo_consume <= (sdcore_fifo_consume + 1'd1);
    end
    if (((sdcore_fifo_syncfifo_we & sdcore_fifo_syncfifo_writable) & (~sdcore_fifo_replace))) begin
        if ((~sdcore_fifo_do_read)) begin
            sdcore_fifo_level <= (sdcore_fifo_level + 1'd1);
        end
    end else begin
        if (sdcore_fifo_do_read) begin
            sdcore_fifo_level <= (sdcore_fifo_level - 1'd1);
        end
    end
    if (sdcore_fifo_reset) begin
        sdcore_fifo_level <= 4'd0;
        sdcore_fifo_produce <= 3'd0;
        sdcore_fifo_consume <= 3'd0;
    end
    builder_soclinux_sdcore_fsm_state <= builder_soclinux_sdcore_fsm_next_state;
    if (sdcore_cmd_done_fsm_next_value_ce0) begin
        sdcore_cmd_done <= sdcore_cmd_done_fsm_next_value0;
    end
    if (sdcore_data_done_fsm_next_value_ce1) begin
        sdcore_data_done <= sdcore_data_done_fsm_next_value1;
    end
    if (sdcore_cmd_count_fsm_next_value_ce2) begin
        sdcore_cmd_count <= sdcore_cmd_count_fsm_next_value2;
    end
    if (sdcore_data_count_fsm_next_value_ce3) begin
        sdcore_data_count <= sdcore_data_count_fsm_next_value3;
    end
    if (sdcore_cmd_error_fsm_next_value_ce4) begin
        sdcore_cmd_error <= sdcore_cmd_error_fsm_next_value4;
    end
    if (sdcore_cmd_timeout_fsm_next_value_ce5) begin
        sdcore_cmd_timeout <= sdcore_cmd_timeout_fsm_next_value5;
    end
    if (sdcore_data_error_fsm_next_value_ce6) begin
        sdcore_data_error <= sdcore_data_error_fsm_next_value6;
    end
    if (sdcore_data_timeout_fsm_next_value_ce7) begin
        sdcore_data_timeout <= sdcore_data_timeout_fsm_next_value7;
    end
    if (sdcore_cmd_response_status_fsm_next_value_ce8) begin
        sdcore_cmd_response_status <= sdcore_cmd_response_status_fsm_next_value8;
    end
    if ((~sdblock2mem_wishbonedmawriter_enable_storage)) begin
        sdblock2mem_connect <= 1'd0;
    end else begin
        if (sdblock2mem_start) begin
            sdblock2mem_connect <= 1'd1;
        end
    end
    sdblock2mem_done_d <= sdblock2mem_wishbonedmawriter_done_status;
    sdblock2mem_irq <= (sdblock2mem_wishbonedmawriter_done_status & (~sdblock2mem_done_d));
    if (sdblock2mem_fifo_syncfifo_re) begin
        sdblock2mem_fifo_readable <= 1'd1;
    end else begin
        if (sdblock2mem_fifo_re) begin
            sdblock2mem_fifo_readable <= 1'd0;
        end
    end
    if (((sdblock2mem_fifo_syncfifo_we & sdblock2mem_fifo_syncfifo_writable) & (~sdblock2mem_fifo_replace))) begin
        sdblock2mem_fifo_produce <= (sdblock2mem_fifo_produce + 1'd1);
    end
    if (sdblock2mem_fifo_do_read) begin
        sdblock2mem_fifo_consume <= (sdblock2mem_fifo_consume + 1'd1);
    end
    if (((sdblock2mem_fifo_syncfifo_we & sdblock2mem_fifo_syncfifo_writable) & (~sdblock2mem_fifo_replace))) begin
        if ((~sdblock2mem_fifo_do_read)) begin
            sdblock2mem_fifo_level0 <= (sdblock2mem_fifo_level0 + 1'd1);
        end
    end else begin
        if (sdblock2mem_fifo_do_read) begin
            sdblock2mem_fifo_level0 <= (sdblock2mem_fifo_level0 - 1'd1);
        end
    end
    if (sdblock2mem_converter_source_ready) begin
        sdblock2mem_converter_strobe_all <= 1'd0;
    end
    if (sdblock2mem_converter_load_part) begin
        if (((sdblock2mem_converter_demux == 2'd3) | sdblock2mem_converter_sink_last)) begin
            sdblock2mem_converter_demux <= 1'd0;
            sdblock2mem_converter_strobe_all <= 1'd1;
        end else begin
            sdblock2mem_converter_demux <= (sdblock2mem_converter_demux + 1'd1);
        end
    end
    if ((sdblock2mem_converter_source_valid & sdblock2mem_converter_source_ready)) begin
        if ((sdblock2mem_converter_sink_valid & sdblock2mem_converter_sink_ready)) begin
            sdblock2mem_converter_source_first <= sdblock2mem_converter_sink_first;
            sdblock2mem_converter_source_last <= sdblock2mem_converter_sink_last;
        end else begin
            sdblock2mem_converter_source_first <= 1'd0;
            sdblock2mem_converter_source_last <= 1'd0;
        end
    end else begin
        if ((sdblock2mem_converter_sink_valid & sdblock2mem_converter_sink_ready)) begin
            sdblock2mem_converter_source_first <= (sdblock2mem_converter_sink_first | sdblock2mem_converter_source_first);
            sdblock2mem_converter_source_last <= (sdblock2mem_converter_sink_last | sdblock2mem_converter_source_last);
        end
    end
    if (sdblock2mem_converter_load_part) begin
        case (sdblock2mem_converter_demux)
            1'd0: begin
                sdblock2mem_converter_source_payload_data[31:24] <= sdblock2mem_converter_sink_payload_data;
            end
            1'd1: begin
                sdblock2mem_converter_source_payload_data[23:16] <= sdblock2mem_converter_sink_payload_data;
            end
            2'd2: begin
                sdblock2mem_converter_source_payload_data[15:8] <= sdblock2mem_converter_sink_payload_data;
            end
            2'd3: begin
                sdblock2mem_converter_source_payload_data[7:0] <= sdblock2mem_converter_sink_payload_data;
            end
        endcase
    end
    if (sdblock2mem_converter_load_part) begin
        sdblock2mem_converter_source_payload_valid_token_count <= (sdblock2mem_converter_demux + 1'd1);
    end
    builder_soclinux_sdblock2memdma_state <= builder_soclinux_sdblock2memdma_next_state;
    if (sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value_ce) begin
        sdblock2mem_wishbonedmawriter_offset <= sdblock2mem_wishbonedmawriter_offset_sdblock2memdma_next_value;
    end
    if (sdblock2mem_wishbonedmawriter_reset) begin
        sdblock2mem_wishbonedmawriter_offset <= 32'd0;
        builder_soclinux_sdblock2memdma_state <= 2'd0;
    end
    if ((sdmem2block_source_source_valid & sdmem2block_source_source_ready)) begin
        sdmem2block_count <= (sdmem2block_count + 1'd1);
        if (sdmem2block_source_source_last) begin
            sdmem2block_count <= 1'd0;
        end
    end
    sdmem2block_done_d <= sdmem2block_dma_done_status;
    sdmem2block_irq <= (sdmem2block_dma_done_status & (~sdmem2block_done_d));
    if (((sdmem2block_dma_fifo_syncfifo_we & sdmem2block_dma_fifo_syncfifo_writable) & (~sdmem2block_dma_fifo_replace))) begin
        sdmem2block_dma_fifo_produce <= (sdmem2block_dma_fifo_produce + 1'd1);
    end
    if (sdmem2block_dma_fifo_do_read) begin
        sdmem2block_dma_fifo_consume <= (sdmem2block_dma_fifo_consume + 1'd1);
    end
    if (((sdmem2block_dma_fifo_syncfifo_we & sdmem2block_dma_fifo_syncfifo_writable) & (~sdmem2block_dma_fifo_replace))) begin
        if ((~sdmem2block_dma_fifo_do_read)) begin
            sdmem2block_dma_fifo_level <= (sdmem2block_dma_fifo_level + 1'd1);
        end
    end else begin
        if (sdmem2block_dma_fifo_do_read) begin
            sdmem2block_dma_fifo_level <= (sdmem2block_dma_fifo_level - 1'd1);
        end
    end
    builder_soclinux_sdmem2blockdma_state <= builder_soclinux_sdmem2blockdma_next_state;
    if (sdmem2block_dma_offset_sdmem2blockdma_next_value_ce) begin
        sdmem2block_dma_offset <= sdmem2block_dma_offset_sdmem2blockdma_next_value;
    end
    if (sdmem2block_dma_reset) begin
        sdmem2block_dma_offset <= 32'd0;
        builder_soclinux_sdmem2blockdma_state <= 2'd0;
    end
    if ((sdmem2block_converter_converter_source_valid & sdmem2block_converter_converter_source_ready)) begin
        if (sdmem2block_converter_converter_last) begin
            sdmem2block_converter_converter_mux <= 1'd0;
        end else begin
            sdmem2block_converter_converter_mux <= (sdmem2block_converter_converter_mux + 1'd1);
        end
    end
    if (sdmem2block_fifo_syncfifo_re) begin
        sdmem2block_fifo_readable <= 1'd1;
    end else begin
        if (sdmem2block_fifo_re) begin
            sdmem2block_fifo_readable <= 1'd0;
        end
    end
    if (((sdmem2block_fifo_syncfifo_we & sdmem2block_fifo_syncfifo_writable) & (~sdmem2block_fifo_replace))) begin
        sdmem2block_fifo_produce <= (sdmem2block_fifo_produce + 1'd1);
    end
    if (sdmem2block_fifo_do_read) begin
        sdmem2block_fifo_consume <= (sdmem2block_fifo_consume + 1'd1);
    end
    if (((sdmem2block_fifo_syncfifo_we & sdmem2block_fifo_syncfifo_writable) & (~sdmem2block_fifo_replace))) begin
        if ((~sdmem2block_fifo_do_read)) begin
            sdmem2block_fifo_level0 <= (sdmem2block_fifo_level0 + 1'd1);
        end
    end else begin
        if (sdmem2block_fifo_do_read) begin
            sdmem2block_fifo_level0 <= (sdmem2block_fifo_level0 - 1'd1);
        end
    end
    if (card_detect_clear) begin
        card_detect_pending <= 1'd0;
    end
    if (card_detect_trigger) begin
        card_detect_pending <= 1'd1;
    end
    if (block2mem_dma_clear) begin
        block2mem_dma_pending <= 1'd0;
    end
    if (block2mem_dma_trigger) begin
        block2mem_dma_pending <= 1'd1;
    end
    if (mem2block_dma_clear) begin
        mem2block_dma_pending <= 1'd0;
    end
    if (mem2block_dma_trigger) begin
        mem2block_dma_pending <= 1'd1;
    end
    builder_soclinux_wishbone2csr_state <= builder_soclinux_wishbone2csr_next_state;
    if (builder_soclinux_dat_w_wishbone2csr_next_value_ce0) begin
        builder_soclinux_dat_w <= builder_soclinux_dat_w_wishbone2csr_next_value0;
    end
    if (builder_soclinux_adr_wishbone2csr_next_value_ce1) begin
        builder_soclinux_adr <= builder_soclinux_adr_wishbone2csr_next_value1;
    end
    if (builder_soclinux_we_wishbone2csr_next_value_ce2) begin
        builder_soclinux_we <= builder_soclinux_we_wishbone2csr_next_value2;
    end
    builder_csr_bankarray_interface0_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank0_sel) begin
        case (builder_csr_bankarray_interface0_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface0_bank_bus_dat_r <= builder_csr_bankarray_csrbank0_reset0_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface0_bank_bus_dat_r <= builder_csr_bankarray_csrbank0_scratch0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface0_bank_bus_dat_r <= builder_csr_bankarray_csrbank0_bus_errors_w;
            end
        endcase
    end
    builder_csr_bankarray_interface1_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank1_sel) begin
        case (builder_csr_bankarray_interface1_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_rst0_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_en_vtc0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_half_sys8x_taps_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_wlevel_en0_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_wlevel_strobe_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_cdly_rst_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_cdly_inc_w;
            end
            3'd7: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_cdly_value_w;
            end
            4'd8: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_dly_sel0_w;
            end
            4'd9: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_rdly_dq_rst_w;
            end
            4'd10: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_rdly_dq_inc_w;
            end
            4'd11: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_rdly_dq_bitslip_rst_w;
            end
            4'd12: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_rdly_dq_bitslip_w;
            end
            4'd13: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_wdly_dq_rst_w;
            end
            4'd14: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_wdly_dq_inc_w;
            end
            4'd15: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_wdly_dqs_rst_w;
            end
            5'd16: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_wdly_dqs_inc_w;
            end
            5'd17: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_w;
            end
            5'd18: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_wdly_dq_bitslip_rst_w;
            end
            5'd19: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= main_usddrphy_wdly_dq_bitslip_w;
            end
            5'd20: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_rdphase0_w;
            end
            5'd21: begin
                builder_csr_bankarray_interface1_bank_bus_dat_r <= builder_csr_bankarray_csrbank1_wrphase0_w;
            end
        endcase
    end
    if (builder_csr_bankarray_csrbank1_rst0_re) begin
        main_usddrphy_rst_storage <= builder_csr_bankarray_csrbank1_rst0_r;
    end
    main_usddrphy_rst_re <= builder_csr_bankarray_csrbank1_rst0_re;
    if (builder_csr_bankarray_csrbank1_en_vtc0_re) begin
        main_usddrphy_en_vtc_storage <= builder_csr_bankarray_csrbank1_en_vtc0_r;
    end
    main_usddrphy_en_vtc_re <= builder_csr_bankarray_csrbank1_en_vtc0_re;
    main_usddrphy_half_sys8x_taps_re <= builder_csr_bankarray_csrbank1_half_sys8x_taps_re;
    if (builder_csr_bankarray_csrbank1_wlevel_en0_re) begin
        main_usddrphy_wlevel_en_storage <= builder_csr_bankarray_csrbank1_wlevel_en0_r;
    end
    main_usddrphy_wlevel_en_re <= builder_csr_bankarray_csrbank1_wlevel_en0_re;
    main_usddrphy_cdly_value_re <= builder_csr_bankarray_csrbank1_cdly_value_re;
    if (builder_csr_bankarray_csrbank1_dly_sel0_re) begin
        main_usddrphy_dly_sel_storage[7:0] <= builder_csr_bankarray_csrbank1_dly_sel0_r;
    end
    main_usddrphy_dly_sel_re <= builder_csr_bankarray_csrbank1_dly_sel0_re;
    main_usddrphy_wdly_dqs_inc_count_re <= builder_csr_bankarray_csrbank1_wdly_dqs_inc_count_re;
    if (builder_csr_bankarray_csrbank1_rdphase0_re) begin
        main_usddrphy_rdphase_storage[1:0] <= builder_csr_bankarray_csrbank1_rdphase0_r;
    end
    main_usddrphy_rdphase_re <= builder_csr_bankarray_csrbank1_rdphase0_re;
    if (builder_csr_bankarray_csrbank1_wrphase0_re) begin
        main_usddrphy_wrphase_storage[1:0] <= builder_csr_bankarray_csrbank1_wrphase0_r;
    end
    main_usddrphy_wrphase_re <= builder_csr_bankarray_csrbank1_wrphase0_re;
    builder_csr_bankarray_interface2_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank2_sel) begin
        case (builder_csr_bankarray_interface2_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_writer_slot_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_writer_length_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_writer_errors_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_writer_ev_status_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_writer_ev_pending_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= main_ethmac_start_w;
            end
            3'd7: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_reader_ready_w;
            end
            4'd8: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_reader_level_w;
            end
            4'd9: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_reader_slot0_w;
            end
            4'd10: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_reader_length0_w;
            end
            4'd11: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_reader_ev_status_w;
            end
            4'd12: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_reader_ev_pending_w;
            end
            4'd13: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_w;
            end
            4'd14: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_preamble_crc_w;
            end
            4'd15: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_w;
            end
            5'd16: begin
                builder_csr_bankarray_interface2_bank_bus_dat_r <= builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_w;
            end
        endcase
    end
    main_ethmac_sram9_re <= builder_csr_bankarray_csrbank2_sram_writer_slot_re;
    main_ethmac_sram12_re <= builder_csr_bankarray_csrbank2_sram_writer_length_re;
    main_ethmac_sram15_re <= builder_csr_bankarray_csrbank2_sram_writer_errors_re;
    main_ethmac_sram24_re <= builder_csr_bankarray_csrbank2_sram_writer_ev_status_re;
    if (builder_csr_bankarray_csrbank2_sram_writer_ev_pending_re) begin
        main_ethmac_sram29_r <= builder_csr_bankarray_csrbank2_sram_writer_ev_pending_r;
    end
    main_ethmac_sram28_re <= builder_csr_bankarray_csrbank2_sram_writer_ev_pending_re;
    if (builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_re) begin
        main_ethmac_sram31_storage <= builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_r;
    end
    main_ethmac_sram32_re <= builder_csr_bankarray_csrbank2_sram_writer_ev_enable0_re;
    main_ethmac_sram96_re <= builder_csr_bankarray_csrbank2_sram_reader_ready_re;
    main_ethmac_sram99_re <= builder_csr_bankarray_csrbank2_sram_reader_level_re;
    if (builder_csr_bankarray_csrbank2_sram_reader_slot0_re) begin
        main_ethmac_sram100_storage <= builder_csr_bankarray_csrbank2_sram_reader_slot0_r;
    end
    main_ethmac_sram101_re <= builder_csr_bankarray_csrbank2_sram_reader_slot0_re;
    if (builder_csr_bankarray_csrbank2_sram_reader_length0_re) begin
        main_ethmac_sram102_storage[10:0] <= builder_csr_bankarray_csrbank2_sram_reader_length0_r;
    end
    main_ethmac_sram103_re <= builder_csr_bankarray_csrbank2_sram_reader_length0_re;
    main_ethmac_sram112_re <= builder_csr_bankarray_csrbank2_sram_reader_ev_status_re;
    if (builder_csr_bankarray_csrbank2_sram_reader_ev_pending_re) begin
        main_ethmac_sram117_r <= builder_csr_bankarray_csrbank2_sram_reader_ev_pending_r;
    end
    main_ethmac_sram116_re <= builder_csr_bankarray_csrbank2_sram_reader_ev_pending_re;
    if (builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_re) begin
        main_ethmac_sram119_storage <= builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_r;
    end
    main_ethmac_sram120_re <= builder_csr_bankarray_csrbank2_sram_reader_ev_enable0_re;
    main_ethmac_re <= builder_csr_bankarray_csrbank2_preamble_crc_re;
    main_ethmac_preamble_errors_re <= builder_csr_bankarray_csrbank2_rx_datapath_preamble_errors_re;
    main_ethmac_crc_errors_re <= builder_csr_bankarray_csrbank2_rx_datapath_crc_errors_re;
    builder_csr_bankarray_interface3_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank3_sel) begin
        case (builder_csr_bankarray_interface3_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface3_bank_bus_dat_r <= builder_csr_bankarray_csrbank3_crg_reset0_w;
            end
        endcase
    end
    builder_csr_bankarray_sel_r <= builder_csr_bankarray_sel;
    builder_csr_bankarray_interface4_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank4_sel) begin
        case (builder_csr_bankarray_interface4_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface4_bank_bus_dat_r <= builder_csr_bankarray_csrbank4_out0_w;
            end
        endcase
    end
    if (builder_csr_bankarray_csrbank4_out0_re) begin
        main_storage[7:0] <= builder_csr_bankarray_csrbank4_out0_r;
    end
    main_re <= builder_csr_bankarray_csrbank4_out0_re;
    builder_csr_bankarray_interface5_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank5_sel) begin
        case (builder_csr_bankarray_interface5_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface5_bank_bus_dat_r <= builder_csr_bankarray_csrbank5_dma_base1_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface5_bank_bus_dat_r <= builder_csr_bankarray_csrbank5_dma_base0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface5_bank_bus_dat_r <= builder_csr_bankarray_csrbank5_dma_length0_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface5_bank_bus_dat_r <= builder_csr_bankarray_csrbank5_dma_enable0_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface5_bank_bus_dat_r <= builder_csr_bankarray_csrbank5_dma_done_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface5_bank_bus_dat_r <= builder_csr_bankarray_csrbank5_dma_loop0_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface5_bank_bus_dat_r <= builder_csr_bankarray_csrbank5_dma_offset_w;
            end
        endcase
    end
    if (builder_csr_bankarray_csrbank5_dma_base1_re) begin
        sdblock2mem_wishbonedmawriter_base_storage[63:32] <= builder_csr_bankarray_csrbank5_dma_base1_r;
    end
    if (builder_csr_bankarray_csrbank5_dma_base0_re) begin
        sdblock2mem_wishbonedmawriter_base_storage[31:0] <= builder_csr_bankarray_csrbank5_dma_base0_r;
    end
    sdblock2mem_wishbonedmawriter_base_re <= builder_csr_bankarray_csrbank5_dma_base0_re;
    if (builder_csr_bankarray_csrbank5_dma_length0_re) begin
        sdblock2mem_wishbonedmawriter_length_storage[31:0] <= builder_csr_bankarray_csrbank5_dma_length0_r;
    end
    sdblock2mem_wishbonedmawriter_length_re <= builder_csr_bankarray_csrbank5_dma_length0_re;
    if (builder_csr_bankarray_csrbank5_dma_enable0_re) begin
        sdblock2mem_wishbonedmawriter_enable_storage <= builder_csr_bankarray_csrbank5_dma_enable0_r;
    end
    sdblock2mem_wishbonedmawriter_enable_re <= builder_csr_bankarray_csrbank5_dma_enable0_re;
    sdblock2mem_wishbonedmawriter_done_re <= builder_csr_bankarray_csrbank5_dma_done_re;
    if (builder_csr_bankarray_csrbank5_dma_loop0_re) begin
        sdblock2mem_wishbonedmawriter_loop_storage <= builder_csr_bankarray_csrbank5_dma_loop0_r;
    end
    sdblock2mem_wishbonedmawriter_loop_re <= builder_csr_bankarray_csrbank5_dma_loop0_re;
    sdblock2mem_wishbonedmawriter_offset_re <= builder_csr_bankarray_csrbank5_dma_offset_re;
    builder_csr_bankarray_interface6_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank6_sel) begin
        case (builder_csr_bankarray_interface6_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_argument0_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_command0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_send0_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_response3_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_response2_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_response1_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_response0_w;
            end
            3'd7: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_cmd_event_w;
            end
            4'd8: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_data_event_w;
            end
            4'd9: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_block_length0_w;
            end
            4'd10: begin
                builder_csr_bankarray_interface6_bank_bus_dat_r <= builder_csr_bankarray_csrbank6_block_count0_w;
            end
        endcase
    end
    if (builder_csr_bankarray_csrbank6_cmd_argument0_re) begin
        sdcore_cmd_argument_storage[31:0] <= builder_csr_bankarray_csrbank6_cmd_argument0_r;
    end
    sdcore_cmd_argument_re <= builder_csr_bankarray_csrbank6_cmd_argument0_re;
    if (builder_csr_bankarray_csrbank6_cmd_command0_re) begin
        sdcore_cmd_command_storage[13:0] <= builder_csr_bankarray_csrbank6_cmd_command0_r;
    end
    sdcore_cmd_command_re <= builder_csr_bankarray_csrbank6_cmd_command0_re;
    if (builder_csr_bankarray_csrbank6_cmd_send0_re) begin
        sdcore_cmd_send_storage <= builder_csr_bankarray_csrbank6_cmd_send0_r;
    end
    sdcore_cmd_send_re <= builder_csr_bankarray_csrbank6_cmd_send0_re;
    sdcore_cmd_response_re <= builder_csr_bankarray_csrbank6_cmd_response0_re;
    sdcore_cmd_event_re <= builder_csr_bankarray_csrbank6_cmd_event_re;
    sdcore_data_event_re <= builder_csr_bankarray_csrbank6_data_event_re;
    if (builder_csr_bankarray_csrbank6_block_length0_re) begin
        sdcore_block_length_storage[9:0] <= builder_csr_bankarray_csrbank6_block_length0_r;
    end
    sdcore_block_length_re <= builder_csr_bankarray_csrbank6_block_length0_re;
    if (builder_csr_bankarray_csrbank6_block_count0_re) begin
        sdcore_block_count_storage[31:0] <= builder_csr_bankarray_csrbank6_block_count0_r;
    end
    sdcore_block_count_re <= builder_csr_bankarray_csrbank6_block_count0_re;
    builder_csr_bankarray_interface7_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank7_sel) begin
        case (builder_csr_bankarray_interface7_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface7_bank_bus_dat_r <= builder_csr_bankarray_csrbank7_status_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface7_bank_bus_dat_r <= builder_csr_bankarray_csrbank7_pending_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface7_bank_bus_dat_r <= builder_csr_bankarray_csrbank7_enable0_w;
            end
        endcase
    end
    eventmanager_status_re <= builder_csr_bankarray_csrbank7_status_re;
    if (builder_csr_bankarray_csrbank7_pending_re) begin
        eventmanager_pending_r[3:0] <= builder_csr_bankarray_csrbank7_pending_r;
    end
    eventmanager_pending_re <= builder_csr_bankarray_csrbank7_pending_re;
    if (builder_csr_bankarray_csrbank7_enable0_re) begin
        eventmanager_enable_storage[3:0] <= builder_csr_bankarray_csrbank7_enable0_r;
    end
    eventmanager_enable_re <= builder_csr_bankarray_csrbank7_enable0_re;
    builder_csr_bankarray_interface8_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank8_sel) begin
        case (builder_csr_bankarray_interface8_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface8_bank_bus_dat_r <= builder_csr_bankarray_csrbank8_dma_base1_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface8_bank_bus_dat_r <= builder_csr_bankarray_csrbank8_dma_base0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface8_bank_bus_dat_r <= builder_csr_bankarray_csrbank8_dma_length0_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface8_bank_bus_dat_r <= builder_csr_bankarray_csrbank8_dma_enable0_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface8_bank_bus_dat_r <= builder_csr_bankarray_csrbank8_dma_done_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface8_bank_bus_dat_r <= builder_csr_bankarray_csrbank8_dma_loop0_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface8_bank_bus_dat_r <= builder_csr_bankarray_csrbank8_dma_offset_w;
            end
        endcase
    end
    if (builder_csr_bankarray_csrbank8_dma_base1_re) begin
        sdmem2block_dma_base_storage[63:32] <= builder_csr_bankarray_csrbank8_dma_base1_r;
    end
    if (builder_csr_bankarray_csrbank8_dma_base0_re) begin
        sdmem2block_dma_base_storage[31:0] <= builder_csr_bankarray_csrbank8_dma_base0_r;
    end
    sdmem2block_dma_base_re <= builder_csr_bankarray_csrbank8_dma_base0_re;
    if (builder_csr_bankarray_csrbank8_dma_length0_re) begin
        sdmem2block_dma_length_storage[31:0] <= builder_csr_bankarray_csrbank8_dma_length0_r;
    end
    sdmem2block_dma_length_re <= builder_csr_bankarray_csrbank8_dma_length0_re;
    if (builder_csr_bankarray_csrbank8_dma_enable0_re) begin
        sdmem2block_dma_enable_storage <= builder_csr_bankarray_csrbank8_dma_enable0_r;
    end
    sdmem2block_dma_enable_re <= builder_csr_bankarray_csrbank8_dma_enable0_re;
    sdmem2block_dma_done_re <= builder_csr_bankarray_csrbank8_dma_done_re;
    if (builder_csr_bankarray_csrbank8_dma_loop0_re) begin
        sdmem2block_dma_loop_storage <= builder_csr_bankarray_csrbank8_dma_loop0_r;
    end
    sdmem2block_dma_loop_re <= builder_csr_bankarray_csrbank8_dma_loop0_re;
    sdmem2block_dma_offset_re <= builder_csr_bankarray_csrbank8_dma_offset_re;
    builder_csr_bankarray_interface9_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank9_sel) begin
        case (builder_csr_bankarray_interface9_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface9_bank_bus_dat_r <= builder_csr_bankarray_csrbank9_card_detect_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface9_bank_bus_dat_r <= builder_csr_bankarray_csrbank9_clocker_divider0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface9_bank_bus_dat_r <= init_initialize_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface9_bank_bus_dat_r <= builder_csr_bankarray_csrbank9_dataw_status_w;
            end
        endcase
    end
    card_detect_re <= builder_csr_bankarray_csrbank9_card_detect_re;
    if (builder_csr_bankarray_csrbank9_clocker_divider0_re) begin
        clocker_storage[8:0] <= builder_csr_bankarray_csrbank9_clocker_divider0_r;
    end
    clocker_re <= builder_csr_bankarray_csrbank9_clocker_divider0_re;
    dataw_re <= builder_csr_bankarray_csrbank9_dataw_status_re;
    builder_csr_bankarray_interface10_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank10_sel) begin
        case (builder_csr_bankarray_interface10_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_control0_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_command0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= main_sdram_phaseinjector0_command_issue_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_address0_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_w;
            end
            3'd7: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_w;
            end
            4'd8: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_w;
            end
            4'd9: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_rddata3_w;
            end
            4'd10: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_rddata2_w;
            end
            4'd11: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_rddata1_w;
            end
            4'd12: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_w;
            end
            4'd13: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_command0_w;
            end
            4'd14: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= main_sdram_phaseinjector1_command_issue_w;
            end
            4'd15: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_address0_w;
            end
            5'd16: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_w;
            end
            5'd17: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_w;
            end
            5'd18: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_w;
            end
            5'd19: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_w;
            end
            5'd20: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_w;
            end
            5'd21: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_rddata3_w;
            end
            5'd22: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_rddata2_w;
            end
            5'd23: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_rddata1_w;
            end
            5'd24: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_w;
            end
            5'd25: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_command0_w;
            end
            5'd26: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= main_sdram_phaseinjector2_command_issue_w;
            end
            5'd27: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_address0_w;
            end
            5'd28: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_w;
            end
            5'd29: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_w;
            end
            5'd30: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_w;
            end
            5'd31: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_w;
            end
            6'd32: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_w;
            end
            6'd33: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_rddata3_w;
            end
            6'd34: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_rddata2_w;
            end
            6'd35: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_rddata1_w;
            end
            6'd36: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_w;
            end
            6'd37: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_command0_w;
            end
            6'd38: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= main_sdram_phaseinjector3_command_issue_w;
            end
            6'd39: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_address0_w;
            end
            6'd40: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_w;
            end
            6'd41: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_w;
            end
            6'd42: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_w;
            end
            6'd43: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_w;
            end
            6'd44: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_w;
            end
            6'd45: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_rddata3_w;
            end
            6'd46: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_rddata2_w;
            end
            6'd47: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_rddata1_w;
            end
            6'd48: begin
                builder_csr_bankarray_interface10_bank_bus_dat_r <= builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_w;
            end
        endcase
    end
    if (builder_csr_bankarray_csrbank10_dfii_control0_re) begin
        main_sdram_storage[3:0] <= builder_csr_bankarray_csrbank10_dfii_control0_r;
    end
    main_sdram_re <= builder_csr_bankarray_csrbank10_dfii_control0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi0_command0_re) begin
        main_sdram_phaseinjector0_command_storage[7:0] <= builder_csr_bankarray_csrbank10_dfii_pi0_command0_r;
    end
    main_sdram_phaseinjector0_command_re <= builder_csr_bankarray_csrbank10_dfii_pi0_command0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi0_address0_re) begin
        main_sdram_phaseinjector0_address_storage[14:0] <= builder_csr_bankarray_csrbank10_dfii_pi0_address0_r;
    end
    main_sdram_phaseinjector0_address_re <= builder_csr_bankarray_csrbank10_dfii_pi0_address0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_re) begin
        main_sdram_phaseinjector0_baddress_storage[2:0] <= builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_r;
    end
    main_sdram_phaseinjector0_baddress_re <= builder_csr_bankarray_csrbank10_dfii_pi0_baddress0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_re) begin
        main_sdram_phaseinjector0_wrdata_storage[127:96] <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata3_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_re) begin
        main_sdram_phaseinjector0_wrdata_storage[95:64] <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata2_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_re) begin
        main_sdram_phaseinjector0_wrdata_storage[63:32] <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata1_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_re) begin
        main_sdram_phaseinjector0_wrdata_storage[31:0] <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_r;
    end
    main_sdram_phaseinjector0_wrdata_re <= builder_csr_bankarray_csrbank10_dfii_pi0_wrdata0_re;
    main_sdram_phaseinjector0_rddata_re <= builder_csr_bankarray_csrbank10_dfii_pi0_rddata0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi1_command0_re) begin
        main_sdram_phaseinjector1_command_storage[7:0] <= builder_csr_bankarray_csrbank10_dfii_pi1_command0_r;
    end
    main_sdram_phaseinjector1_command_re <= builder_csr_bankarray_csrbank10_dfii_pi1_command0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi1_address0_re) begin
        main_sdram_phaseinjector1_address_storage[14:0] <= builder_csr_bankarray_csrbank10_dfii_pi1_address0_r;
    end
    main_sdram_phaseinjector1_address_re <= builder_csr_bankarray_csrbank10_dfii_pi1_address0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_re) begin
        main_sdram_phaseinjector1_baddress_storage[2:0] <= builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_r;
    end
    main_sdram_phaseinjector1_baddress_re <= builder_csr_bankarray_csrbank10_dfii_pi1_baddress0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_re) begin
        main_sdram_phaseinjector1_wrdata_storage[127:96] <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata3_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_re) begin
        main_sdram_phaseinjector1_wrdata_storage[95:64] <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata2_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_re) begin
        main_sdram_phaseinjector1_wrdata_storage[63:32] <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata1_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_re) begin
        main_sdram_phaseinjector1_wrdata_storage[31:0] <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_r;
    end
    main_sdram_phaseinjector1_wrdata_re <= builder_csr_bankarray_csrbank10_dfii_pi1_wrdata0_re;
    main_sdram_phaseinjector1_rddata_re <= builder_csr_bankarray_csrbank10_dfii_pi1_rddata0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi2_command0_re) begin
        main_sdram_phaseinjector2_command_storage[7:0] <= builder_csr_bankarray_csrbank10_dfii_pi2_command0_r;
    end
    main_sdram_phaseinjector2_command_re <= builder_csr_bankarray_csrbank10_dfii_pi2_command0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi2_address0_re) begin
        main_sdram_phaseinjector2_address_storage[14:0] <= builder_csr_bankarray_csrbank10_dfii_pi2_address0_r;
    end
    main_sdram_phaseinjector2_address_re <= builder_csr_bankarray_csrbank10_dfii_pi2_address0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_re) begin
        main_sdram_phaseinjector2_baddress_storage[2:0] <= builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_r;
    end
    main_sdram_phaseinjector2_baddress_re <= builder_csr_bankarray_csrbank10_dfii_pi2_baddress0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_re) begin
        main_sdram_phaseinjector2_wrdata_storage[127:96] <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata3_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_re) begin
        main_sdram_phaseinjector2_wrdata_storage[95:64] <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata2_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_re) begin
        main_sdram_phaseinjector2_wrdata_storage[63:32] <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata1_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_re) begin
        main_sdram_phaseinjector2_wrdata_storage[31:0] <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_r;
    end
    main_sdram_phaseinjector2_wrdata_re <= builder_csr_bankarray_csrbank10_dfii_pi2_wrdata0_re;
    main_sdram_phaseinjector2_rddata_re <= builder_csr_bankarray_csrbank10_dfii_pi2_rddata0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi3_command0_re) begin
        main_sdram_phaseinjector3_command_storage[7:0] <= builder_csr_bankarray_csrbank10_dfii_pi3_command0_r;
    end
    main_sdram_phaseinjector3_command_re <= builder_csr_bankarray_csrbank10_dfii_pi3_command0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi3_address0_re) begin
        main_sdram_phaseinjector3_address_storage[14:0] <= builder_csr_bankarray_csrbank10_dfii_pi3_address0_r;
    end
    main_sdram_phaseinjector3_address_re <= builder_csr_bankarray_csrbank10_dfii_pi3_address0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_re) begin
        main_sdram_phaseinjector3_baddress_storage[2:0] <= builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_r;
    end
    main_sdram_phaseinjector3_baddress_re <= builder_csr_bankarray_csrbank10_dfii_pi3_baddress0_re;
    if (builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_re) begin
        main_sdram_phaseinjector3_wrdata_storage[127:96] <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata3_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_re) begin
        main_sdram_phaseinjector3_wrdata_storage[95:64] <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata2_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_re) begin
        main_sdram_phaseinjector3_wrdata_storage[63:32] <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata1_r;
    end
    if (builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_re) begin
        main_sdram_phaseinjector3_wrdata_storage[31:0] <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_r;
    end
    main_sdram_phaseinjector3_wrdata_re <= builder_csr_bankarray_csrbank10_dfii_pi3_wrdata0_re;
    main_sdram_phaseinjector3_rddata_re <= builder_csr_bankarray_csrbank10_dfii_pi3_rddata0_re;
    builder_csr_bankarray_interface11_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank11_sel) begin
        case (builder_csr_bankarray_interface11_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_load0_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_reload0_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_en0_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_update_value0_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_value_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_ev_status_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_ev_pending_w;
            end
            3'd7: begin
                builder_csr_bankarray_interface11_bank_bus_dat_r <= builder_csr_bankarray_csrbank11_ev_enable0_w;
            end
        endcase
    end
    if (builder_csr_bankarray_csrbank11_load0_re) begin
        main_timer_load_storage[31:0] <= builder_csr_bankarray_csrbank11_load0_r;
    end
    main_timer_load_re <= builder_csr_bankarray_csrbank11_load0_re;
    if (builder_csr_bankarray_csrbank11_reload0_re) begin
        main_timer_reload_storage[31:0] <= builder_csr_bankarray_csrbank11_reload0_r;
    end
    main_timer_reload_re <= builder_csr_bankarray_csrbank11_reload0_re;
    if (builder_csr_bankarray_csrbank11_en0_re) begin
        main_timer_en_storage <= builder_csr_bankarray_csrbank11_en0_r;
    end
    main_timer_en_re <= builder_csr_bankarray_csrbank11_en0_re;
    if (builder_csr_bankarray_csrbank11_update_value0_re) begin
        main_timer_update_value_storage <= builder_csr_bankarray_csrbank11_update_value0_r;
    end
    main_timer_update_value_re <= builder_csr_bankarray_csrbank11_update_value0_re;
    main_timer_value_re <= builder_csr_bankarray_csrbank11_value_re;
    main_timer_status_re <= builder_csr_bankarray_csrbank11_ev_status_re;
    if (builder_csr_bankarray_csrbank11_ev_pending_re) begin
        main_timer_pending_r <= builder_csr_bankarray_csrbank11_ev_pending_r;
    end
    main_timer_pending_re <= builder_csr_bankarray_csrbank11_ev_pending_re;
    if (builder_csr_bankarray_csrbank11_ev_enable0_re) begin
        main_timer_enable_storage <= builder_csr_bankarray_csrbank11_ev_enable0_r;
    end
    main_timer_enable_re <= builder_csr_bankarray_csrbank11_ev_enable0_re;
    builder_csr_bankarray_interface12_bank_bus_dat_r <= 1'd0;
    if (builder_csr_bankarray_csrbank12_sel) begin
        case (builder_csr_bankarray_interface12_bank_bus_adr[8:0])
            1'd0: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= main_uart_rxtx_w;
            end
            1'd1: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= builder_csr_bankarray_csrbank12_txfull_w;
            end
            2'd2: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= builder_csr_bankarray_csrbank12_rxempty_w;
            end
            2'd3: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= builder_csr_bankarray_csrbank12_ev_status_w;
            end
            3'd4: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= builder_csr_bankarray_csrbank12_ev_pending_w;
            end
            3'd5: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= builder_csr_bankarray_csrbank12_ev_enable0_w;
            end
            3'd6: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= builder_csr_bankarray_csrbank12_txempty_w;
            end
            3'd7: begin
                builder_csr_bankarray_interface12_bank_bus_dat_r <= builder_csr_bankarray_csrbank12_rxfull_w;
            end
        endcase
    end
    main_uart_txfull_re <= builder_csr_bankarray_csrbank12_txfull_re;
    main_uart_rxempty_re <= builder_csr_bankarray_csrbank12_rxempty_re;
    main_uart_status_re <= builder_csr_bankarray_csrbank12_ev_status_re;
    if (builder_csr_bankarray_csrbank12_ev_pending_re) begin
        main_uart_pending_r[1:0] <= builder_csr_bankarray_csrbank12_ev_pending_r;
    end
    main_uart_pending_re <= builder_csr_bankarray_csrbank12_ev_pending_re;
    if (builder_csr_bankarray_csrbank12_ev_enable0_re) begin
        main_uart_enable_storage[1:0] <= builder_csr_bankarray_csrbank12_ev_enable0_r;
    end
    main_uart_enable_re <= builder_csr_bankarray_csrbank12_ev_enable0_re;
    main_uart_txempty_re <= builder_csr_bankarray_csrbank12_txempty_re;
    main_uart_rxfull_re <= builder_csr_bankarray_csrbank12_rxfull_re;
    if (sys_rst) begin
        main_reset_storage <= 2'd0;
        main_reset_re <= 1'd0;
        main_scratch_storage <= 32'd305419896;
        main_scratch_re <= 1'd0;
        main_bus_errors_re <= 1'd0;
        main_bus_errors <= 32'd0;
        main_cpu_dma_bus_inhibit <= 1'd0;
        main_soclinux_ram_bus_ack <= 1'd0;
        main_ram_bus_ram_bus_ack <= 1'd0;
        serial_tx <= 1'd1;
        main_tx_tick <= 1'd0;
        main_rx_tick <= 1'd0;
        main_rx_rx_d <= 1'd0;
        main_uart_txfull_re <= 1'd0;
        main_uart_rxempty_re <= 1'd0;
        main_uart_tx_pending <= 1'd0;
        main_uart_tx_trigger_d <= 1'd0;
        main_uart_rx_pending <= 1'd0;
        main_uart_rx_trigger_d <= 1'd0;
        main_uart_status_re <= 1'd0;
        main_uart_pending_re <= 1'd0;
        main_uart_pending_r <= 2'd0;
        main_uart_enable_storage <= 2'd0;
        main_uart_enable_re <= 1'd0;
        main_uart_txempty_re <= 1'd0;
        main_uart_rxfull_re <= 1'd0;
        main_uart_tx_fifo_readable <= 1'd0;
        main_uart_tx_fifo_level0 <= 5'd0;
        main_uart_tx_fifo_produce <= 4'd0;
        main_uart_tx_fifo_consume <= 4'd0;
        main_uart_rx_fifo_readable <= 1'd0;
        main_uart_rx_fifo_level0 <= 5'd0;
        main_uart_rx_fifo_produce <= 4'd0;
        main_uart_rx_fifo_consume <= 4'd0;
        main_timer_load_storage <= 32'd0;
        main_timer_load_re <= 1'd0;
        main_timer_reload_storage <= 32'd0;
        main_timer_reload_re <= 1'd0;
        main_timer_en_storage <= 1'd0;
        main_timer_en_re <= 1'd0;
        main_timer_update_value_storage <= 1'd0;
        main_timer_update_value_re <= 1'd0;
        main_timer_value_status <= 32'd0;
        main_timer_value_re <= 1'd0;
        main_timer_zero_pending <= 1'd0;
        main_timer_zero_trigger_d <= 1'd0;
        main_timer_status_re <= 1'd0;
        main_timer_pending_re <= 1'd0;
        main_timer_pending_r <= 1'd0;
        main_timer_enable_storage <= 1'd0;
        main_timer_enable_re <= 1'd0;
        main_timer_value <= 32'd0;
        main_usddrphy_rst_storage <= 1'd0;
        main_usddrphy_rst_re <= 1'd0;
        main_usddrphy_en_vtc_storage <= 1'd1;
        main_usddrphy_en_vtc_re <= 1'd0;
        main_usddrphy_half_sys8x_taps_re <= 1'd0;
        main_usddrphy_wlevel_en_storage <= 1'd0;
        main_usddrphy_wlevel_en_re <= 1'd0;
        main_usddrphy_cdly_value_re <= 1'd0;
        main_usddrphy_dly_sel_storage <= 8'd0;
        main_usddrphy_dly_sel_re <= 1'd0;
        main_usddrphy_wdly_dqs_inc_count_re <= 1'd0;
        main_usddrphy_rdphase_storage <= 2'd3;
        main_usddrphy_rdphase_re <= 1'd0;
        main_usddrphy_wrphase_storage <= 2'd3;
        main_usddrphy_wrphase_re <= 1'd0;
        main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline <= 1'd0;
        main_usddrphy_bitslip0_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count0 <= 9'd0;
        main_usddrphy_bitslip1_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count1 <= 9'd0;
        main_usddrphy_bitslip2_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count2 <= 9'd0;
        main_usddrphy_bitslip3_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count3 <= 9'd0;
        main_usddrphy_bitslip4_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count4 <= 9'd0;
        main_usddrphy_bitslip5_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count5 <= 9'd0;
        main_usddrphy_bitslip6_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count6 <= 9'd0;
        main_usddrphy_bitslip7_value0 <= 3'd7;
        main_usddrphy_wdly_dqs_inc_count7 <= 9'd0;
        main_usddrphy_bitslip0_value1 <= 3'd7;
        main_usddrphy_bitslip1_value1 <= 3'd7;
        main_usddrphy_bitslip2_value1 <= 3'd7;
        main_usddrphy_bitslip3_value1 <= 3'd7;
        main_usddrphy_bitslip4_value1 <= 3'd7;
        main_usddrphy_bitslip5_value1 <= 3'd7;
        main_usddrphy_bitslip6_value1 <= 3'd7;
        main_usddrphy_bitslip7_value1 <= 3'd7;
        main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline <= 1'd0;
        main_usddrphy_bitslip0_value2 <= 3'd7;
        main_usddrphy_bitslip0_value3 <= 3'd7;
        main_usddrphy_bitslip1_value2 <= 3'd7;
        main_usddrphy_bitslip1_value3 <= 3'd7;
        main_usddrphy_bitslip2_value2 <= 3'd7;
        main_usddrphy_bitslip2_value3 <= 3'd7;
        main_usddrphy_bitslip3_value2 <= 3'd7;
        main_usddrphy_bitslip3_value3 <= 3'd7;
        main_usddrphy_bitslip4_value2 <= 3'd7;
        main_usddrphy_bitslip4_value3 <= 3'd7;
        main_usddrphy_bitslip5_value2 <= 3'd7;
        main_usddrphy_bitslip5_value3 <= 3'd7;
        main_usddrphy_bitslip6_value2 <= 3'd7;
        main_usddrphy_bitslip6_value3 <= 3'd7;
        main_usddrphy_bitslip7_value2 <= 3'd7;
        main_usddrphy_bitslip7_value3 <= 3'd7;
        main_usddrphy_bitslip8_value0 <= 3'd7;
        main_usddrphy_bitslip8_value1 <= 3'd7;
        main_usddrphy_bitslip9_value0 <= 3'd7;
        main_usddrphy_bitslip9_value1 <= 3'd7;
        main_usddrphy_bitslip10_value0 <= 3'd7;
        main_usddrphy_bitslip10_value1 <= 3'd7;
        main_usddrphy_bitslip11_value0 <= 3'd7;
        main_usddrphy_bitslip11_value1 <= 3'd7;
        main_usddrphy_bitslip12_value0 <= 3'd7;
        main_usddrphy_bitslip12_value1 <= 3'd7;
        main_usddrphy_bitslip13_value0 <= 3'd7;
        main_usddrphy_bitslip13_value1 <= 3'd7;
        main_usddrphy_bitslip14_value0 <= 3'd7;
        main_usddrphy_bitslip14_value1 <= 3'd7;
        main_usddrphy_bitslip15_value0 <= 3'd7;
        main_usddrphy_bitslip15_value1 <= 3'd7;
        main_usddrphy_bitslip16_value0 <= 3'd7;
        main_usddrphy_bitslip16_value1 <= 3'd7;
        main_usddrphy_bitslip17_value0 <= 3'd7;
        main_usddrphy_bitslip17_value1 <= 3'd7;
        main_usddrphy_bitslip18_value0 <= 3'd7;
        main_usddrphy_bitslip18_value1 <= 3'd7;
        main_usddrphy_bitslip19_value0 <= 3'd7;
        main_usddrphy_bitslip19_value1 <= 3'd7;
        main_usddrphy_bitslip20_value0 <= 3'd7;
        main_usddrphy_bitslip20_value1 <= 3'd7;
        main_usddrphy_bitslip21_value0 <= 3'd7;
        main_usddrphy_bitslip21_value1 <= 3'd7;
        main_usddrphy_bitslip22_value0 <= 3'd7;
        main_usddrphy_bitslip22_value1 <= 3'd7;
        main_usddrphy_bitslip23_value0 <= 3'd7;
        main_usddrphy_bitslip23_value1 <= 3'd7;
        main_usddrphy_bitslip24_value0 <= 3'd7;
        main_usddrphy_bitslip24_value1 <= 3'd7;
        main_usddrphy_bitslip25_value0 <= 3'd7;
        main_usddrphy_bitslip25_value1 <= 3'd7;
        main_usddrphy_bitslip26_value0 <= 3'd7;
        main_usddrphy_bitslip26_value1 <= 3'd7;
        main_usddrphy_bitslip27_value0 <= 3'd7;
        main_usddrphy_bitslip27_value1 <= 3'd7;
        main_usddrphy_bitslip28_value0 <= 3'd7;
        main_usddrphy_bitslip28_value1 <= 3'd7;
        main_usddrphy_bitslip29_value0 <= 3'd7;
        main_usddrphy_bitslip29_value1 <= 3'd7;
        main_usddrphy_bitslip30_value0 <= 3'd7;
        main_usddrphy_bitslip30_value1 <= 3'd7;
        main_usddrphy_bitslip31_value0 <= 3'd7;
        main_usddrphy_bitslip31_value1 <= 3'd7;
        main_usddrphy_bitslip32_value0 <= 3'd7;
        main_usddrphy_bitslip32_value1 <= 3'd7;
        main_usddrphy_bitslip33_value0 <= 3'd7;
        main_usddrphy_bitslip33_value1 <= 3'd7;
        main_usddrphy_bitslip34_value0 <= 3'd7;
        main_usddrphy_bitslip34_value1 <= 3'd7;
        main_usddrphy_bitslip35_value0 <= 3'd7;
        main_usddrphy_bitslip35_value1 <= 3'd7;
        main_usddrphy_bitslip36_value0 <= 3'd7;
        main_usddrphy_bitslip36_value1 <= 3'd7;
        main_usddrphy_bitslip37_value0 <= 3'd7;
        main_usddrphy_bitslip37_value1 <= 3'd7;
        main_usddrphy_bitslip38_value0 <= 3'd7;
        main_usddrphy_bitslip38_value1 <= 3'd7;
        main_usddrphy_bitslip39_value0 <= 3'd7;
        main_usddrphy_bitslip39_value1 <= 3'd7;
        main_usddrphy_bitslip40_value0 <= 3'd7;
        main_usddrphy_bitslip40_value1 <= 3'd7;
        main_usddrphy_bitslip41_value0 <= 3'd7;
        main_usddrphy_bitslip41_value1 <= 3'd7;
        main_usddrphy_bitslip42_value0 <= 3'd7;
        main_usddrphy_bitslip42_value1 <= 3'd7;
        main_usddrphy_bitslip43_value0 <= 3'd7;
        main_usddrphy_bitslip43_value1 <= 3'd7;
        main_usddrphy_bitslip44_value0 <= 3'd7;
        main_usddrphy_bitslip44_value1 <= 3'd7;
        main_usddrphy_bitslip45_value0 <= 3'd7;
        main_usddrphy_bitslip45_value1 <= 3'd7;
        main_usddrphy_bitslip46_value0 <= 3'd7;
        main_usddrphy_bitslip46_value1 <= 3'd7;
        main_usddrphy_bitslip47_value0 <= 3'd7;
        main_usddrphy_bitslip47_value1 <= 3'd7;
        main_usddrphy_bitslip48_value0 <= 3'd7;
        main_usddrphy_bitslip48_value1 <= 3'd7;
        main_usddrphy_bitslip49_value0 <= 3'd7;
        main_usddrphy_bitslip49_value1 <= 3'd7;
        main_usddrphy_bitslip50_value0 <= 3'd7;
        main_usddrphy_bitslip50_value1 <= 3'd7;
        main_usddrphy_bitslip51_value0 <= 3'd7;
        main_usddrphy_bitslip51_value1 <= 3'd7;
        main_usddrphy_bitslip52_value0 <= 3'd7;
        main_usddrphy_bitslip52_value1 <= 3'd7;
        main_usddrphy_bitslip53_value0 <= 3'd7;
        main_usddrphy_bitslip53_value1 <= 3'd7;
        main_usddrphy_bitslip54_value0 <= 3'd7;
        main_usddrphy_bitslip54_value1 <= 3'd7;
        main_usddrphy_bitslip55_value0 <= 3'd7;
        main_usddrphy_bitslip55_value1 <= 3'd7;
        main_usddrphy_bitslip56_value0 <= 3'd7;
        main_usddrphy_bitslip56_value1 <= 3'd7;
        main_usddrphy_bitslip57_value0 <= 3'd7;
        main_usddrphy_bitslip57_value1 <= 3'd7;
        main_usddrphy_bitslip58_value0 <= 3'd7;
        main_usddrphy_bitslip58_value1 <= 3'd7;
        main_usddrphy_bitslip59_value0 <= 3'd7;
        main_usddrphy_bitslip59_value1 <= 3'd7;
        main_usddrphy_bitslip60_value0 <= 3'd7;
        main_usddrphy_bitslip60_value1 <= 3'd7;
        main_usddrphy_bitslip61_value0 <= 3'd7;
        main_usddrphy_bitslip61_value1 <= 3'd7;
        main_usddrphy_bitslip62_value0 <= 3'd7;
        main_usddrphy_bitslip62_value1 <= 3'd7;
        main_usddrphy_bitslip63_value0 <= 3'd7;
        main_usddrphy_bitslip63_value1 <= 3'd7;
        main_usddrphy_rddata_en_tappeddelayline0 <= 1'd0;
        main_usddrphy_rddata_en_tappeddelayline1 <= 1'd0;
        main_usddrphy_rddata_en_tappeddelayline2 <= 1'd0;
        main_usddrphy_rddata_en_tappeddelayline3 <= 1'd0;
        main_usddrphy_rddata_en_tappeddelayline4 <= 1'd0;
        main_usddrphy_rddata_en_tappeddelayline5 <= 1'd0;
        main_usddrphy_rddata_en_tappeddelayline6 <= 1'd0;
        main_usddrphy_rddata_en_tappeddelayline7 <= 1'd0;
        main_usddrphy_wrdata_en_tappeddelayline0 <= 1'd0;
        main_usddrphy_wrdata_en_tappeddelayline1 <= 1'd0;
        main_usddrphy_wrdata_en_tappeddelayline2 <= 1'd0;
        main_usddrphy_wrdata_en_tappeddelayline3 <= 1'd0;
        main_sdram_storage <= 4'd1;
        main_sdram_re <= 1'd0;
        main_sdram_phaseinjector0_command_storage <= 8'd0;
        main_sdram_phaseinjector0_command_re <= 1'd0;
        main_sdram_phaseinjector0_address_re <= 1'd0;
        main_sdram_phaseinjector0_baddress_re <= 1'd0;
        main_sdram_phaseinjector0_wrdata_re <= 1'd0;
        main_sdram_phaseinjector0_rddata_status <= 128'd0;
        main_sdram_phaseinjector0_rddata_re <= 1'd0;
        main_sdram_phaseinjector1_command_storage <= 8'd0;
        main_sdram_phaseinjector1_command_re <= 1'd0;
        main_sdram_phaseinjector1_address_re <= 1'd0;
        main_sdram_phaseinjector1_baddress_re <= 1'd0;
        main_sdram_phaseinjector1_wrdata_re <= 1'd0;
        main_sdram_phaseinjector1_rddata_status <= 128'd0;
        main_sdram_phaseinjector1_rddata_re <= 1'd0;
        main_sdram_phaseinjector2_command_storage <= 8'd0;
        main_sdram_phaseinjector2_command_re <= 1'd0;
        main_sdram_phaseinjector2_address_re <= 1'd0;
        main_sdram_phaseinjector2_baddress_re <= 1'd0;
        main_sdram_phaseinjector2_wrdata_re <= 1'd0;
        main_sdram_phaseinjector2_rddata_status <= 128'd0;
        main_sdram_phaseinjector2_rddata_re <= 1'd0;
        main_sdram_phaseinjector3_command_storage <= 8'd0;
        main_sdram_phaseinjector3_command_re <= 1'd0;
        main_sdram_phaseinjector3_address_re <= 1'd0;
        main_sdram_phaseinjector3_baddress_re <= 1'd0;
        main_sdram_phaseinjector3_wrdata_re <= 1'd0;
        main_sdram_phaseinjector3_rddata_status <= 128'd0;
        main_sdram_phaseinjector3_rddata_re <= 1'd0;
        main_sdram_dfi_p0_address <= 15'd0;
        main_sdram_dfi_p0_bank <= 3'd0;
        main_sdram_dfi_p0_cas_n <= 1'd1;
        main_sdram_dfi_p0_cs_n <= 1'd1;
        main_sdram_dfi_p0_ras_n <= 1'd1;
        main_sdram_dfi_p0_we_n <= 1'd1;
        main_sdram_dfi_p0_wrdata_en <= 1'd0;
        main_sdram_dfi_p0_rddata_en <= 1'd0;
        main_sdram_dfi_p1_address <= 15'd0;
        main_sdram_dfi_p1_bank <= 3'd0;
        main_sdram_dfi_p1_cas_n <= 1'd1;
        main_sdram_dfi_p1_cs_n <= 1'd1;
        main_sdram_dfi_p1_ras_n <= 1'd1;
        main_sdram_dfi_p1_we_n <= 1'd1;
        main_sdram_dfi_p1_wrdata_en <= 1'd0;
        main_sdram_dfi_p1_rddata_en <= 1'd0;
        main_sdram_dfi_p2_address <= 15'd0;
        main_sdram_dfi_p2_bank <= 3'd0;
        main_sdram_dfi_p2_cas_n <= 1'd1;
        main_sdram_dfi_p2_cs_n <= 1'd1;
        main_sdram_dfi_p2_ras_n <= 1'd1;
        main_sdram_dfi_p2_we_n <= 1'd1;
        main_sdram_dfi_p2_wrdata_en <= 1'd0;
        main_sdram_dfi_p2_rddata_en <= 1'd0;
        main_sdram_dfi_p3_address <= 15'd0;
        main_sdram_dfi_p3_bank <= 3'd0;
        main_sdram_dfi_p3_cas_n <= 1'd1;
        main_sdram_dfi_p3_cs_n <= 1'd1;
        main_sdram_dfi_p3_ras_n <= 1'd1;
        main_sdram_dfi_p3_we_n <= 1'd1;
        main_sdram_dfi_p3_wrdata_en <= 1'd0;
        main_sdram_dfi_p3_rddata_en <= 1'd0;
        main_sdram_cmd_payload_a <= 15'd0;
        main_sdram_cmd_payload_ba <= 3'd0;
        main_sdram_cmd_payload_cas <= 1'd0;
        main_sdram_cmd_payload_ras <= 1'd0;
        main_sdram_cmd_payload_we <= 1'd0;
        main_sdram_timer_count1 <= 10'd976;
        main_sdram_postponer_req_o <= 1'd0;
        main_sdram_postponer_count <= 1'd0;
        main_sdram_sequencer_done1 <= 1'd0;
        main_sdram_sequencer_counter <= 6'd0;
        main_sdram_sequencer_count <= 1'd0;
        main_sdram_zqcs_timer_count1 <= 27'd124999999;
        main_sdram_zqcs_executer_done <= 1'd0;
        main_sdram_zqcs_executer_counter <= 6'd0;
        main_sdram_bankmachine0_level <= 4'd0;
        main_sdram_bankmachine0_produce <= 3'd0;
        main_sdram_bankmachine0_consume <= 3'd0;
        main_sdram_bankmachine0_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine0_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine0_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine0_row <= 15'd0;
        main_sdram_bankmachine0_row_opened <= 1'd0;
        main_sdram_bankmachine0_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine0_twtpcon_count <= 3'd0;
        main_sdram_bankmachine0_trccon_ready <= 1'd0;
        main_sdram_bankmachine0_trccon_count <= 3'd0;
        main_sdram_bankmachine0_trascon_ready <= 1'd0;
        main_sdram_bankmachine0_trascon_count <= 3'd0;
        main_sdram_bankmachine1_level <= 4'd0;
        main_sdram_bankmachine1_produce <= 3'd0;
        main_sdram_bankmachine1_consume <= 3'd0;
        main_sdram_bankmachine1_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine1_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine1_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine1_row <= 15'd0;
        main_sdram_bankmachine1_row_opened <= 1'd0;
        main_sdram_bankmachine1_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine1_twtpcon_count <= 3'd0;
        main_sdram_bankmachine1_trccon_ready <= 1'd0;
        main_sdram_bankmachine1_trccon_count <= 3'd0;
        main_sdram_bankmachine1_trascon_ready <= 1'd0;
        main_sdram_bankmachine1_trascon_count <= 3'd0;
        main_sdram_bankmachine2_level <= 4'd0;
        main_sdram_bankmachine2_produce <= 3'd0;
        main_sdram_bankmachine2_consume <= 3'd0;
        main_sdram_bankmachine2_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine2_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine2_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine2_row <= 15'd0;
        main_sdram_bankmachine2_row_opened <= 1'd0;
        main_sdram_bankmachine2_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine2_twtpcon_count <= 3'd0;
        main_sdram_bankmachine2_trccon_ready <= 1'd0;
        main_sdram_bankmachine2_trccon_count <= 3'd0;
        main_sdram_bankmachine2_trascon_ready <= 1'd0;
        main_sdram_bankmachine2_trascon_count <= 3'd0;
        main_sdram_bankmachine3_level <= 4'd0;
        main_sdram_bankmachine3_produce <= 3'd0;
        main_sdram_bankmachine3_consume <= 3'd0;
        main_sdram_bankmachine3_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine3_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine3_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine3_row <= 15'd0;
        main_sdram_bankmachine3_row_opened <= 1'd0;
        main_sdram_bankmachine3_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine3_twtpcon_count <= 3'd0;
        main_sdram_bankmachine3_trccon_ready <= 1'd0;
        main_sdram_bankmachine3_trccon_count <= 3'd0;
        main_sdram_bankmachine3_trascon_ready <= 1'd0;
        main_sdram_bankmachine3_trascon_count <= 3'd0;
        main_sdram_bankmachine4_level <= 4'd0;
        main_sdram_bankmachine4_produce <= 3'd0;
        main_sdram_bankmachine4_consume <= 3'd0;
        main_sdram_bankmachine4_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine4_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine4_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine4_row <= 15'd0;
        main_sdram_bankmachine4_row_opened <= 1'd0;
        main_sdram_bankmachine4_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine4_twtpcon_count <= 3'd0;
        main_sdram_bankmachine4_trccon_ready <= 1'd0;
        main_sdram_bankmachine4_trccon_count <= 3'd0;
        main_sdram_bankmachine4_trascon_ready <= 1'd0;
        main_sdram_bankmachine4_trascon_count <= 3'd0;
        main_sdram_bankmachine5_level <= 4'd0;
        main_sdram_bankmachine5_produce <= 3'd0;
        main_sdram_bankmachine5_consume <= 3'd0;
        main_sdram_bankmachine5_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine5_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine5_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine5_row <= 15'd0;
        main_sdram_bankmachine5_row_opened <= 1'd0;
        main_sdram_bankmachine5_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine5_twtpcon_count <= 3'd0;
        main_sdram_bankmachine5_trccon_ready <= 1'd0;
        main_sdram_bankmachine5_trccon_count <= 3'd0;
        main_sdram_bankmachine5_trascon_ready <= 1'd0;
        main_sdram_bankmachine5_trascon_count <= 3'd0;
        main_sdram_bankmachine6_level <= 4'd0;
        main_sdram_bankmachine6_produce <= 3'd0;
        main_sdram_bankmachine6_consume <= 3'd0;
        main_sdram_bankmachine6_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine6_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine6_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine6_row <= 15'd0;
        main_sdram_bankmachine6_row_opened <= 1'd0;
        main_sdram_bankmachine6_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine6_twtpcon_count <= 3'd0;
        main_sdram_bankmachine6_trccon_ready <= 1'd0;
        main_sdram_bankmachine6_trccon_count <= 3'd0;
        main_sdram_bankmachine6_trascon_ready <= 1'd0;
        main_sdram_bankmachine6_trascon_count <= 3'd0;
        main_sdram_bankmachine7_level <= 4'd0;
        main_sdram_bankmachine7_produce <= 3'd0;
        main_sdram_bankmachine7_consume <= 3'd0;
        main_sdram_bankmachine7_pipe_valid_source_valid <= 1'd0;
        main_sdram_bankmachine7_pipe_valid_source_payload_we <= 1'd0;
        main_sdram_bankmachine7_pipe_valid_source_payload_addr <= 22'd0;
        main_sdram_bankmachine7_row <= 15'd0;
        main_sdram_bankmachine7_row_opened <= 1'd0;
        main_sdram_bankmachine7_twtpcon_ready <= 1'd0;
        main_sdram_bankmachine7_twtpcon_count <= 3'd0;
        main_sdram_bankmachine7_trccon_ready <= 1'd0;
        main_sdram_bankmachine7_trccon_count <= 3'd0;
        main_sdram_bankmachine7_trascon_ready <= 1'd0;
        main_sdram_bankmachine7_trascon_count <= 3'd0;
        main_sdram_choose_cmd_grant <= 3'd0;
        main_sdram_choose_req_grant <= 3'd0;
        main_sdram_trrdcon_ready <= 1'd0;
        main_sdram_trrdcon_count <= 1'd0;
        main_sdram_tfawcon_ready <= 1'd1;
        main_sdram_tfawcon_window <= 7'd0;
        main_sdram_tccdcon_ready <= 1'd0;
        main_sdram_tccdcon_count <= 1'd0;
        main_sdram_twtrcon_ready <= 1'd0;
        main_sdram_twtrcon_count <= 3'd0;
        main_sdram_time0 <= 5'd0;
        main_sdram_time1 <= 4'd0;
        main_ku_1000basex_storage <= 1'd0;
        main_ku_1000basex_re <= 1'd0;
        main_ku_1000basex_pll_reset <= 1'd1;
        main_ku_1000basex_reset_counter <= 16'd0;
        main_ethmac_re <= 1'd0;
        main_ethmac_tx_cdc_cdc_graycounter0_q <= 6'd0;
        main_ethmac_tx_cdc_cdc_graycounter0_q_binary <= 6'd0;
        main_ethmac_preamble_errors_status <= 32'd0;
        main_ethmac_preamble_errors_re <= 1'd0;
        main_ethmac_crc_errors_status <= 32'd0;
        main_ethmac_crc_errors_re <= 1'd0;
        main_ethmac_rx_cdc_cdc_graycounter1_q <= 6'd0;
        main_ethmac_rx_cdc_cdc_graycounter1_q_binary <= 6'd0;
        main_ethmac_sram9_re <= 1'd0;
        main_ethmac_sram12_re <= 1'd0;
        main_ethmac_sram13_status <= 32'd0;
        main_ethmac_sram15_re <= 1'd0;
        main_ethmac_sram24_re <= 1'd0;
        main_ethmac_sram28_re <= 1'd0;
        main_ethmac_sram29_r <= 1'd0;
        main_ethmac_sram31_storage <= 1'd0;
        main_ethmac_sram32_re <= 1'd0;
        main_ethmac_slot <= 1'd0;
        main_ethmac_sram35_length <= 11'd0;
        main_ethmac_sram55_level <= 2'd0;
        main_ethmac_sram57_produce <= 1'd0;
        main_ethmac_sram58_consume <= 1'd0;
        main_ethmac_sram96_re <= 1'd0;
        main_ethmac_sram99_re <= 1'd0;
        main_ethmac_sram101_re <= 1'd0;
        main_ethmac_sram103_re <= 1'd0;
        main_ethmac_sram106_pending <= 1'd0;
        main_ethmac_sram112_re <= 1'd0;
        main_ethmac_sram116_re <= 1'd0;
        main_ethmac_sram117_r <= 1'd0;
        main_ethmac_sram119_storage <= 1'd0;
        main_ethmac_sram120_re <= 1'd0;
        main_ethmac_sram122_length <= 11'd0;
        main_ethmac_sram141_level <= 2'd0;
        main_ethmac_sram143_produce <= 1'd0;
        main_ethmac_sram144_consume <= 1'd0;
        main_ethmac_interface0_ack <= 1'd0;
        main_ethmac_interface1_ack <= 1'd0;
        main_ethmac_interface2_ack <= 1'd0;
        main_ethmac_interface3_ack <= 1'd0;
        main_ethmac_slave_sel_r <= 4'd0;
        main_storage <= 8'd0;
        main_re <= 1'd0;
        main_chaser <= 8'd0;
        main_mode <= 1'd0;
        main_count <= 23'd7812500;
        card_detect_re <= 1'd0;
        clocker_storage <= 9'd256;
        clocker_re <= 1'd0;
        clocker_clks <= 9'd0;
        clocker_clk_d <= 1'd0;
        clocker_ce_delayed <= 1'd0;
        init_count <= 8'd0;
        cmdw_count <= 8'd0;
        cmdr_timeout <= 32'd125000000;
        cmdr_count <= 8'd0;
        cmdr_busy <= 1'd0;
        cmdr_cmdr_run <= 1'd0;
        cmdr_cmdr_converter_converter_source_payload_data <= 8'd0;
        cmdr_cmdr_converter_converter_source_payload_valid_token_count <= 4'd0;
        cmdr_cmdr_converter_converter_demux <= 3'd0;
        cmdr_cmdr_converter_converter_strobe_all <= 1'd0;
        cmdr_cmdr_buf_pipe_valid_source_valid <= 1'd0;
        cmdr_cmdr_buf_pipe_valid_source_payload_data <= 8'd0;
        cmdr_cmdr_reset <= 1'd0;
        dataw_re <= 1'd0;
        dataw_count <= 8'd0;
        dataw_accepted1 <= 1'd0;
        dataw_crc_error1 <= 1'd0;
        dataw_write_error1 <= 1'd0;
        dataw_crc_run <= 1'd0;
        dataw_crc_converter_converter_source_payload_data <= 8'd0;
        dataw_crc_converter_converter_source_payload_valid_token_count <= 4'd0;
        dataw_crc_converter_converter_demux <= 3'd0;
        dataw_crc_converter_converter_strobe_all <= 1'd0;
        dataw_crc_buf_pipe_valid_source_valid <= 1'd0;
        dataw_crc_buf_pipe_valid_source_payload_data <= 8'd0;
        datar_timeout <= 32'd125000000;
        datar_count <= 10'd0;
        datar_datar_run <= 1'd0;
        datar_datar_converter_converter_source_payload_data <= 8'd0;
        datar_datar_converter_converter_source_payload_valid_token_count <= 2'd0;
        datar_datar_converter_converter_demux <= 1'd0;
        datar_datar_converter_converter_strobe_all <= 1'd0;
        datar_datar_buf_pipe_valid_source_valid <= 1'd0;
        datar_datar_buf_pipe_valid_source_payload_data <= 8'd0;
        datar_datar_reset <= 1'd0;
        sdpads_data_i_ce <= 1'd0;
        clocker_clk_delay <= 2'd0;
        card_detect_irq <= 1'd0;
        card_detect_d <= 1'd0;
        sdcore_cmd_argument_storage <= 32'd0;
        sdcore_cmd_argument_re <= 1'd0;
        sdcore_cmd_command_storage <= 14'd0;
        sdcore_cmd_command_re <= 1'd0;
        sdcore_cmd_send_storage <= 1'd0;
        sdcore_cmd_send_re <= 1'd0;
        sdcore_cmd_response_status <= 128'd0;
        sdcore_cmd_response_re <= 1'd0;
        sdcore_cmd_event_re <= 1'd0;
        sdcore_data_event_re <= 1'd0;
        sdcore_block_length_storage <= 10'd0;
        sdcore_block_length_re <= 1'd0;
        sdcore_block_count_storage <= 32'd0;
        sdcore_block_count_re <= 1'd0;
        sdcore_crc7_inserter_reg0 <= 7'd0;
        sdcore_crc16_inserter_count <= 3'd0;
        sdcore_crc16_inserter_crc0_reg0 <= 16'd0;
        sdcore_crc16_inserter_crc1_reg0 <= 16'd0;
        sdcore_crc16_inserter_crc2_reg0 <= 16'd0;
        sdcore_crc16_inserter_crc3_reg0 <= 16'd0;
        sdcore_fifo_level <= 4'd0;
        sdcore_fifo_produce <= 3'd0;
        sdcore_fifo_consume <= 3'd0;
        sdcore_cmd_count <= 3'd0;
        sdcore_cmd_done <= 1'd0;
        sdcore_cmd_error <= 1'd0;
        sdcore_cmd_timeout <= 1'd0;
        sdcore_data_count <= 32'd0;
        sdcore_data_done <= 1'd0;
        sdcore_data_error <= 1'd0;
        sdcore_data_timeout <= 1'd0;
        sdblock2mem_irq <= 1'd0;
        sdblock2mem_fifo_readable <= 1'd0;
        sdblock2mem_fifo_level0 <= 10'd0;
        sdblock2mem_fifo_produce <= 9'd0;
        sdblock2mem_fifo_consume <= 9'd0;
        sdblock2mem_converter_source_payload_data <= 32'd0;
        sdblock2mem_converter_source_payload_valid_token_count <= 3'd0;
        sdblock2mem_converter_demux <= 2'd0;
        sdblock2mem_converter_strobe_all <= 1'd0;
        sdblock2mem_wishbonedmawriter_base_storage <= 64'd0;
        sdblock2mem_wishbonedmawriter_base_re <= 1'd0;
        sdblock2mem_wishbonedmawriter_length_storage <= 32'd0;
        sdblock2mem_wishbonedmawriter_length_re <= 1'd0;
        sdblock2mem_wishbonedmawriter_enable_storage <= 1'd0;
        sdblock2mem_wishbonedmawriter_enable_re <= 1'd0;
        sdblock2mem_wishbonedmawriter_done_re <= 1'd0;
        sdblock2mem_wishbonedmawriter_loop_storage <= 1'd0;
        sdblock2mem_wishbonedmawriter_loop_re <= 1'd0;
        sdblock2mem_wishbonedmawriter_offset_re <= 1'd0;
        sdblock2mem_wishbonedmawriter_offset <= 32'd0;
        sdblock2mem_connect <= 1'd0;
        sdblock2mem_done_d <= 1'd0;
        sdmem2block_irq <= 1'd0;
        sdmem2block_dma_fifo_level <= 5'd0;
        sdmem2block_dma_fifo_produce <= 4'd0;
        sdmem2block_dma_fifo_consume <= 4'd0;
        sdmem2block_dma_base_storage <= 64'd0;
        sdmem2block_dma_base_re <= 1'd0;
        sdmem2block_dma_length_storage <= 32'd0;
        sdmem2block_dma_length_re <= 1'd0;
        sdmem2block_dma_enable_storage <= 1'd0;
        sdmem2block_dma_enable_re <= 1'd0;
        sdmem2block_dma_done_re <= 1'd0;
        sdmem2block_dma_loop_storage <= 1'd0;
        sdmem2block_dma_loop_re <= 1'd0;
        sdmem2block_dma_offset_re <= 1'd0;
        sdmem2block_dma_offset <= 32'd0;
        sdmem2block_converter_converter_mux <= 2'd0;
        sdmem2block_fifo_readable <= 1'd0;
        sdmem2block_fifo_level0 <= 10'd0;
        sdmem2block_fifo_produce <= 9'd0;
        sdmem2block_fifo_consume <= 9'd0;
        sdmem2block_count <= 9'd0;
        sdmem2block_done_d <= 1'd0;
        card_detect_pending <= 1'd0;
        block2mem_dma_pending <= 1'd0;
        mem2block_dma_pending <= 1'd0;
        eventmanager_status_re <= 1'd0;
        eventmanager_pending_re <= 1'd0;
        eventmanager_pending_r <= 4'd0;
        eventmanager_enable_storage <= 4'd0;
        eventmanager_enable_re <= 1'd0;
        builder_soclinux_we <= 1'd0;
        builder_socbushandler0_slave_sel_r <= 6'd0;
        builder_socbushandler0_count <= 20'd1000000;
        builder_socbushandler1_grant <= 1'd0;
        builder_socbushandler1_slave_sel_r <= 1'd0;
        builder_socbushandler1_count <= 20'd1000000;
        builder_csr_bankarray_sel_r <= 1'd0;
        builder_soclinux_rs232phytx_state <= 1'd0;
        builder_soclinux_rs232phyrx_state <= 1'd0;
        builder_soclinux_refresher_state <= 2'd0;
        builder_soclinux_bankmachine0_state <= 4'd0;
        builder_soclinux_bankmachine1_state <= 4'd0;
        builder_soclinux_bankmachine2_state <= 4'd0;
        builder_soclinux_bankmachine3_state <= 4'd0;
        builder_soclinux_bankmachine4_state <= 4'd0;
        builder_soclinux_bankmachine5_state <= 4'd0;
        builder_soclinux_bankmachine6_state <= 4'd0;
        builder_soclinux_bankmachine7_state <= 4'd0;
        builder_soclinux_multiplexer_state <= 4'd0;
        builder_soclinux_roundrobin0_grant <= 1'd0;
        builder_soclinux_roundrobin1_grant <= 1'd0;
        builder_soclinux_roundrobin2_grant <= 1'd0;
        builder_soclinux_roundrobin3_grant <= 1'd0;
        builder_soclinux_roundrobin4_grant <= 1'd0;
        builder_soclinux_roundrobin5_grant <= 1'd0;
        builder_soclinux_roundrobin6_grant <= 1'd0;
        builder_soclinux_roundrobin7_grant <= 1'd0;
        builder_soclinux_new_master_wdata_ready0 <= 1'd0;
        builder_soclinux_new_master_wdata_ready1 <= 1'd0;
        builder_soclinux_new_master_wdata_ready2 <= 1'd0;
        builder_soclinux_new_master_wdata_ready3 <= 1'd0;
        builder_soclinux_new_master_wdata_ready4 <= 1'd0;
        builder_soclinux_new_master_wdata_ready5 <= 1'd0;
        builder_soclinux_new_master_rdata_valid0 <= 1'd0;
        builder_soclinux_new_master_rdata_valid1 <= 1'd0;
        builder_soclinux_new_master_rdata_valid2 <= 1'd0;
        builder_soclinux_new_master_rdata_valid3 <= 1'd0;
        builder_soclinux_new_master_rdata_valid4 <= 1'd0;
        builder_soclinux_new_master_rdata_valid5 <= 1'd0;
        builder_soclinux_new_master_rdata_valid6 <= 1'd0;
        builder_soclinux_new_master_rdata_valid7 <= 1'd0;
        builder_soclinux_new_master_rdata_valid8 <= 1'd0;
        builder_soclinux_new_master_rdata_valid9 <= 1'd0;
        builder_soclinux_new_master_rdata_valid10 <= 1'd0;
        builder_soclinux_new_master_rdata_valid11 <= 1'd0;
        builder_soclinux_new_master_rdata_valid12 <= 1'd0;
        builder_soclinux_new_master_rdata_valid13 <= 1'd0;
        builder_soclinux_new_master_rdata_valid14 <= 1'd0;
        builder_soclinux_new_master_rdata_valid15 <= 1'd0;
        builder_soclinux_new_master_rdata_valid16 <= 1'd0;
        builder_soclinux_new_master_rdata_valid17 <= 1'd0;
        builder_soclinux_liteethmacsramwriter_state <= 3'd0;
        builder_soclinux_liteethmacsramreader_state <= 2'd0;
        builder_soclinux_sdphyinit_state <= 1'd0;
        builder_soclinux_sdphycmdw_state <= 2'd0;
        builder_soclinux_sdphycmdr_state <= 3'd0;
        builder_soclinux_sdphydataw_state <= 3'd0;
        builder_soclinux_sdphydatar_state <= 3'd0;
        builder_soclinux_sdcore_crc16inserter_state <= 1'd0;
        builder_soclinux_sdcore_fsm_state <= 3'd0;
        builder_soclinux_sdblock2memdma_state <= 2'd0;
        builder_soclinux_sdmem2blockdma_state <= 2'd0;
        builder_soclinux_wishbone2csr_state <= 2'd0;
    end
    builder_xilinxmultiregimpl0_regs0 <= serial_rx;
    builder_xilinxmultiregimpl0_regs1 <= builder_xilinxmultiregimpl0_regs0;
    builder_xilinxmultiregimpl8_regs0 <= main_ethmac_tx_cdc_cdc_graycounter1_q;
    builder_xilinxmultiregimpl8_regs1 <= builder_xilinxmultiregimpl8_regs0;
    builder_xilinxmultiregimpl9_regs0 <= main_ethmac_pulsesynchronizer0_toggle_i;
    builder_xilinxmultiregimpl9_regs1 <= builder_xilinxmultiregimpl9_regs0;
    builder_xilinxmultiregimpl10_regs0 <= main_ethmac_pulsesynchronizer1_toggle_i;
    builder_xilinxmultiregimpl10_regs1 <= builder_xilinxmultiregimpl10_regs0;
    builder_xilinxmultiregimpl11_regs0 <= main_ethmac_rx_cdc_cdc_graycounter0_q;
    builder_xilinxmultiregimpl11_regs1 <= builder_xilinxmultiregimpl11_regs0;
end


//------------------------------------------------------------------------------
// Specialized Logic
//------------------------------------------------------------------------------

BUFG BUFG(
	.I(main_crg_clkout1),
	.O(main_crg_clkout_buf0)
);

BUFG BUFG_1(
	.I(main_crg_clkout2),
	.O(main_crg_clkout_buf1)
);

BUFGCE_DIV #(
	.BUFGCE_DIVIDE(3'd4)
) BUFGCE_DIV (
	.CE(1'd1),
	.I(pll4x_clk),
	.O(sys_clk)
);

BUFGCE BUFGCE(
	.CE(1'd1),
	.I(pll4x_clk),
	.O(sys4x_clk)
);

IDELAYCTRL #(
	.SIM_DEVICE("ULTRASCALE")
) IDELAYCTRL (
	.REFCLK(idelay_clk),
	.RST(main_crg_idelayctrl_ic_reset),
	.RDY(main_crg_idelayctrl_ic_ready)
);

//------------------------------------------------------------------------------
// Memory rom: 12388-words x 32-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: ---- | 
reg [31:0] rom[0:12387];
initial begin
	$readmemh("kcu105_rom.init", rom);
end
reg [31:0] rom_dat0;
always @(posedge sys_clk) begin
	rom_dat0 <= rom[main_soclinux_adr];
end
assign main_soclinux_dat_r = rom_dat0;


//------------------------------------------------------------------------------
// Memory sram: 1536-words x 32-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Write-First | Write-Granularity: 8 
reg [31:0] sram[0:1535];
initial begin
	$readmemh("kcu105_sram.init", sram);
end
reg [10:0] sram_adr0;
always @(posedge sys_clk) begin
	if (main_ram_we[0])
		sram[main_ram_adr][7:0] <= main_ram_dat_w[7:0];
	if (main_ram_we[1])
		sram[main_ram_adr][15:8] <= main_ram_dat_w[15:8];
	if (main_ram_we[2])
		sram[main_ram_adr][23:16] <= main_ram_dat_w[23:16];
	if (main_ram_we[3])
		sram[main_ram_adr][31:24] <= main_ram_dat_w[31:24];
	sram_adr0 <= main_ram_adr;
end
assign main_ram_dat_r = sram[sram_adr0];


//------------------------------------------------------------------------------
// Memory mem: 20-words x 8-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: ---- | 
reg [7:0] mem[0:19];
initial begin
	$readmemh("kcu105_mem.init", mem);
end
reg [4:0] mem_adr0;
always @(posedge sys_clk) begin
	mem_adr0 <= builder_csr_bankarray_adr;
end
assign builder_csr_bankarray_dat_r = mem[mem_adr0];


//------------------------------------------------------------------------------
// Memory storage: 16-words x 10-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 10 
// Port 1 | Read: Sync  | Write: ---- | 
reg [9:0] storage[0:15];
reg [9:0] storage_dat0;
reg [9:0] storage_dat1;
always @(posedge sys_clk) begin
	if (main_uart_tx_fifo_wrport_we)
		storage[main_uart_tx_fifo_wrport_adr] <= main_uart_tx_fifo_wrport_dat_w;
	storage_dat0 <= storage[main_uart_tx_fifo_wrport_adr];
end
always @(posedge sys_clk) begin
	if (main_uart_tx_fifo_rdport_re)
		storage_dat1 <= storage[main_uart_tx_fifo_rdport_adr];
end
assign main_uart_tx_fifo_wrport_dat_r = storage_dat0;
assign main_uart_tx_fifo_rdport_dat_r = storage_dat1;


//------------------------------------------------------------------------------
// Memory storage_1: 16-words x 10-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 10 
// Port 1 | Read: Sync  | Write: ---- | 
reg [9:0] storage_1[0:15];
reg [9:0] storage_1_dat0;
reg [9:0] storage_1_dat1;
always @(posedge sys_clk) begin
	if (main_uart_rx_fifo_wrport_we)
		storage_1[main_uart_rx_fifo_wrport_adr] <= main_uart_rx_fifo_wrport_dat_w;
	storage_1_dat0 <= storage_1[main_uart_rx_fifo_wrport_adr];
end
always @(posedge sys_clk) begin
	if (main_uart_rx_fifo_rdport_re)
		storage_1_dat1 <= storage_1[main_uart_rx_fifo_rdport_adr];
end
assign main_uart_rx_fifo_wrport_dat_r = storage_1_dat0;
assign main_uart_rx_fifo_rdport_dat_r = storage_1_dat1;


OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(8'd170),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_clk_o_nodelay)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_clk_o_nodelay),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.CNTVALUEOUT(main_usddrphy_cdly_value_status),
	.DATAOUT(main_usddrphy_clk_o_delayed)
);

OBUFDS OBUFDS(
	.I(main_usddrphy_clk_o_delayed),
	.O(ddram_clk_p),
	.OB(ddram_clk_n)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_1 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_reset_n, main_usddrphy_interface1_dfi_p3_reset_n, main_usddrphy_interface1_dfi_p2_reset_n, main_usddrphy_interface1_dfi_p2_reset_n, main_usddrphy_interface1_dfi_p1_reset_n, main_usddrphy_interface1_dfi_p1_reset_n, main_usddrphy_interface1_dfi_p0_reset_n, main_usddrphy_interface1_dfi_p0_reset_n}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay0)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_1 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay0),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_reset_n)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_2 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_cs_n, main_usddrphy_interface1_dfi_p3_cs_n, main_usddrphy_interface1_dfi_p2_cs_n, main_usddrphy_interface1_dfi_p2_cs_n, main_usddrphy_interface1_dfi_p1_cs_n, main_usddrphy_interface1_dfi_p1_cs_n, main_usddrphy_interface1_dfi_p0_cs_n, main_usddrphy_interface1_dfi_p0_cs_n}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay1)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_2 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay1),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_cs_n)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_3 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[0], main_usddrphy_interface1_dfi_p3_address[0], main_usddrphy_interface1_dfi_p2_address[0], main_usddrphy_interface1_dfi_p2_address[0], main_usddrphy_interface1_dfi_p1_address[0], main_usddrphy_interface1_dfi_p1_address[0], main_usddrphy_interface1_dfi_p0_address[0], main_usddrphy_interface1_dfi_p0_address[0]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay2)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_3 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay2),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[0])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_4 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[1], main_usddrphy_interface1_dfi_p3_address[1], main_usddrphy_interface1_dfi_p2_address[1], main_usddrphy_interface1_dfi_p2_address[1], main_usddrphy_interface1_dfi_p1_address[1], main_usddrphy_interface1_dfi_p1_address[1], main_usddrphy_interface1_dfi_p0_address[1], main_usddrphy_interface1_dfi_p0_address[1]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay3)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_4 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay3),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[1])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_5 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[2], main_usddrphy_interface1_dfi_p3_address[2], main_usddrphy_interface1_dfi_p2_address[2], main_usddrphy_interface1_dfi_p2_address[2], main_usddrphy_interface1_dfi_p1_address[2], main_usddrphy_interface1_dfi_p1_address[2], main_usddrphy_interface1_dfi_p0_address[2], main_usddrphy_interface1_dfi_p0_address[2]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay4)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_5 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay4),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[2])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_6 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[3], main_usddrphy_interface1_dfi_p3_address[3], main_usddrphy_interface1_dfi_p2_address[3], main_usddrphy_interface1_dfi_p2_address[3], main_usddrphy_interface1_dfi_p1_address[3], main_usddrphy_interface1_dfi_p1_address[3], main_usddrphy_interface1_dfi_p0_address[3], main_usddrphy_interface1_dfi_p0_address[3]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay5)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_6 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay5),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[3])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_7 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[4], main_usddrphy_interface1_dfi_p3_address[4], main_usddrphy_interface1_dfi_p2_address[4], main_usddrphy_interface1_dfi_p2_address[4], main_usddrphy_interface1_dfi_p1_address[4], main_usddrphy_interface1_dfi_p1_address[4], main_usddrphy_interface1_dfi_p0_address[4], main_usddrphy_interface1_dfi_p0_address[4]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay6)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_7 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay6),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[4])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_8 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[5], main_usddrphy_interface1_dfi_p3_address[5], main_usddrphy_interface1_dfi_p2_address[5], main_usddrphy_interface1_dfi_p2_address[5], main_usddrphy_interface1_dfi_p1_address[5], main_usddrphy_interface1_dfi_p1_address[5], main_usddrphy_interface1_dfi_p0_address[5], main_usddrphy_interface1_dfi_p0_address[5]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay7)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_8 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay7),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[5])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_9 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[6], main_usddrphy_interface1_dfi_p3_address[6], main_usddrphy_interface1_dfi_p2_address[6], main_usddrphy_interface1_dfi_p2_address[6], main_usddrphy_interface1_dfi_p1_address[6], main_usddrphy_interface1_dfi_p1_address[6], main_usddrphy_interface1_dfi_p0_address[6], main_usddrphy_interface1_dfi_p0_address[6]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay8)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_9 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay8),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[6])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_10 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[7], main_usddrphy_interface1_dfi_p3_address[7], main_usddrphy_interface1_dfi_p2_address[7], main_usddrphy_interface1_dfi_p2_address[7], main_usddrphy_interface1_dfi_p1_address[7], main_usddrphy_interface1_dfi_p1_address[7], main_usddrphy_interface1_dfi_p0_address[7], main_usddrphy_interface1_dfi_p0_address[7]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay9)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_10 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay9),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[7])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_11 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[8], main_usddrphy_interface1_dfi_p3_address[8], main_usddrphy_interface1_dfi_p2_address[8], main_usddrphy_interface1_dfi_p2_address[8], main_usddrphy_interface1_dfi_p1_address[8], main_usddrphy_interface1_dfi_p1_address[8], main_usddrphy_interface1_dfi_p0_address[8], main_usddrphy_interface1_dfi_p0_address[8]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay10)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_11 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay10),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[8])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_12 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[9], main_usddrphy_interface1_dfi_p3_address[9], main_usddrphy_interface1_dfi_p2_address[9], main_usddrphy_interface1_dfi_p2_address[9], main_usddrphy_interface1_dfi_p1_address[9], main_usddrphy_interface1_dfi_p1_address[9], main_usddrphy_interface1_dfi_p0_address[9], main_usddrphy_interface1_dfi_p0_address[9]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay11)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_12 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay11),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[9])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_13 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[10], main_usddrphy_interface1_dfi_p3_address[10], main_usddrphy_interface1_dfi_p2_address[10], main_usddrphy_interface1_dfi_p2_address[10], main_usddrphy_interface1_dfi_p1_address[10], main_usddrphy_interface1_dfi_p1_address[10], main_usddrphy_interface1_dfi_p0_address[10], main_usddrphy_interface1_dfi_p0_address[10]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay12)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_13 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay12),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[10])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_14 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[11], main_usddrphy_interface1_dfi_p3_address[11], main_usddrphy_interface1_dfi_p2_address[11], main_usddrphy_interface1_dfi_p2_address[11], main_usddrphy_interface1_dfi_p1_address[11], main_usddrphy_interface1_dfi_p1_address[11], main_usddrphy_interface1_dfi_p0_address[11], main_usddrphy_interface1_dfi_p0_address[11]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay13)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_14 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay13),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[11])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_15 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[12], main_usddrphy_interface1_dfi_p3_address[12], main_usddrphy_interface1_dfi_p2_address[12], main_usddrphy_interface1_dfi_p2_address[12], main_usddrphy_interface1_dfi_p1_address[12], main_usddrphy_interface1_dfi_p1_address[12], main_usddrphy_interface1_dfi_p0_address[12], main_usddrphy_interface1_dfi_p0_address[12]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay14)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_15 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay14),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[12])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_16 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_address[13], main_usddrphy_interface1_dfi_p3_address[13], main_usddrphy_interface1_dfi_p2_address[13], main_usddrphy_interface1_dfi_p2_address[13], main_usddrphy_interface1_dfi_p1_address[13], main_usddrphy_interface1_dfi_p1_address[13], main_usddrphy_interface1_dfi_p0_address[13], main_usddrphy_interface1_dfi_p0_address[13]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay15)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_16 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay15),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_a[13])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_17 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_bank[0], main_usddrphy_interface1_dfi_p3_bank[0], main_usddrphy_interface1_dfi_p2_bank[0], main_usddrphy_interface1_dfi_p2_bank[0], main_usddrphy_interface1_dfi_p1_bank[0], main_usddrphy_interface1_dfi_p1_bank[0], main_usddrphy_interface1_dfi_p0_bank[0], main_usddrphy_interface1_dfi_p0_bank[0]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay16)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_17 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay16),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_pads_ba[0])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_18 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_bank[1], main_usddrphy_interface1_dfi_p3_bank[1], main_usddrphy_interface1_dfi_p2_bank[1], main_usddrphy_interface1_dfi_p2_bank[1], main_usddrphy_interface1_dfi_p1_bank[1], main_usddrphy_interface1_dfi_p1_bank[1], main_usddrphy_interface1_dfi_p0_bank[1], main_usddrphy_interface1_dfi_p0_bank[1]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay17)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_18 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay17),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_pads_ba[1])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_19 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_bank[2], main_usddrphy_interface1_dfi_p3_bank[2], main_usddrphy_interface1_dfi_p2_bank[2], main_usddrphy_interface1_dfi_p2_bank[2], main_usddrphy_interface1_dfi_p1_bank[2], main_usddrphy_interface1_dfi_p1_bank[2], main_usddrphy_interface1_dfi_p0_bank[2], main_usddrphy_interface1_dfi_p0_bank[2]}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay18)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_19 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay18),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_pads_ba[2])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_20 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_ras_n, main_usddrphy_interface1_dfi_p3_ras_n, main_usddrphy_interface1_dfi_p2_ras_n, main_usddrphy_interface1_dfi_p2_ras_n, main_usddrphy_interface1_dfi_p1_ras_n, main_usddrphy_interface1_dfi_p1_ras_n, main_usddrphy_interface1_dfi_p0_ras_n, main_usddrphy_interface1_dfi_p0_ras_n}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay19)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_20 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay19),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_ras_n)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_21 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_cas_n, main_usddrphy_interface1_dfi_p3_cas_n, main_usddrphy_interface1_dfi_p2_cas_n, main_usddrphy_interface1_dfi_p2_cas_n, main_usddrphy_interface1_dfi_p1_cas_n, main_usddrphy_interface1_dfi_p1_cas_n, main_usddrphy_interface1_dfi_p0_cas_n, main_usddrphy_interface1_dfi_p0_cas_n}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay20)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_21 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay20),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_cas_n)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_22 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_we_n, main_usddrphy_interface1_dfi_p3_we_n, main_usddrphy_interface1_dfi_p2_we_n, main_usddrphy_interface1_dfi_p2_we_n, main_usddrphy_interface1_dfi_p1_we_n, main_usddrphy_interface1_dfi_p1_we_n, main_usddrphy_interface1_dfi_p0_we_n, main_usddrphy_interface1_dfi_p0_we_n}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay21)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_22 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay21),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_we_n)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_23 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_cke, main_usddrphy_interface1_dfi_p3_cke, main_usddrphy_interface1_dfi_p2_cke, main_usddrphy_interface1_dfi_p2_cke, main_usddrphy_interface1_dfi_p1_cke, main_usddrphy_interface1_dfi_p1_cke, main_usddrphy_interface1_dfi_p0_cke, main_usddrphy_interface1_dfi_p0_cke}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay22)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_23 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay22),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_cke)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_24 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_odt, main_usddrphy_interface1_dfi_p3_odt, main_usddrphy_interface1_dfi_p2_odt, main_usddrphy_interface1_dfi_p2_odt, main_usddrphy_interface1_dfi_p1_odt, main_usddrphy_interface1_dfi_p1_odt, main_usddrphy_interface1_dfi_p0_odt, main_usddrphy_interface1_dfi_p0_odt}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay23)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_24 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay23),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_odt)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_25 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D({main_usddrphy_interface1_dfi_p3_act_n, main_usddrphy_interface1_dfi_p3_act_n, main_usddrphy_interface1_dfi_p2_act_n, main_usddrphy_interface1_dfi_p2_act_n, main_usddrphy_interface1_dfi_p1_act_n, main_usddrphy_interface1_dfi_p1_act_n, main_usddrphy_interface1_dfi_p0_act_n, main_usddrphy_interface1_dfi_p0_act_n}),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_o_nodelay24)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_25 (
	.CE(main_usddrphy_cdly_inc_re),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_o_nodelay24),
	.RST(((ic_rst | main_usddrphy_cdly_rst_re) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_act_n)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_26 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip00),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay0),
	.T_OUT(main_usddrphy_dqs_t0)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_26 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay0),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy_half_sys8x_taps_status),
	.DATAOUT(main_usddrphy_dqs_delayed0)
);

IOBUFDSE3 IOBUFDSE3(
	.I(main_usddrphy_dqs_delayed0),
	.T(main_usddrphy_dqs_t0),
	.IO(ddram_dqs_p[0]),
	.IOB(ddram_dqs_n[0])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_27 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip10),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay1),
	.T_OUT(main_usddrphy_dqs_t1)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_27 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay1),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy0),
	.DATAOUT(main_usddrphy_dqs_delayed1)
);

IOBUFDSE3 IOBUFDSE3_1(
	.I(main_usddrphy_dqs_delayed1),
	.T(main_usddrphy_dqs_t1),
	.IO(ddram_dqs_p[1]),
	.IOB(ddram_dqs_n[1])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_28 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip20),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay2),
	.T_OUT(main_usddrphy_dqs_t2)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_28 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay2),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy1),
	.DATAOUT(main_usddrphy_dqs_delayed2)
);

IOBUFDSE3 IOBUFDSE3_2(
	.I(main_usddrphy_dqs_delayed2),
	.T(main_usddrphy_dqs_t2),
	.IO(ddram_dqs_p[2]),
	.IOB(ddram_dqs_n[2])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_29 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip30),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay3),
	.T_OUT(main_usddrphy_dqs_t3)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_29 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay3),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy2),
	.DATAOUT(main_usddrphy_dqs_delayed3)
);

IOBUFDSE3 IOBUFDSE3_3(
	.I(main_usddrphy_dqs_delayed3),
	.T(main_usddrphy_dqs_t3),
	.IO(ddram_dqs_p[3]),
	.IOB(ddram_dqs_n[3])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_30 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip40),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay4),
	.T_OUT(main_usddrphy_dqs_t4)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_30 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay4),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy3),
	.DATAOUT(main_usddrphy_dqs_delayed4)
);

IOBUFDSE3 IOBUFDSE3_4(
	.I(main_usddrphy_dqs_delayed4),
	.T(main_usddrphy_dqs_t4),
	.IO(ddram_dqs_p[4]),
	.IOB(ddram_dqs_n[4])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_31 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip50),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay5),
	.T_OUT(main_usddrphy_dqs_t5)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_31 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay5),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy4),
	.DATAOUT(main_usddrphy_dqs_delayed5)
);

IOBUFDSE3 IOBUFDSE3_5(
	.I(main_usddrphy_dqs_delayed5),
	.T(main_usddrphy_dqs_t5),
	.IO(ddram_dqs_p[5]),
	.IOB(ddram_dqs_n[5])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_32 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip60),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay6),
	.T_OUT(main_usddrphy_dqs_t6)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_32 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay6),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy5),
	.DATAOUT(main_usddrphy_dqs_delayed6)
);

IOBUFDSE3 IOBUFDSE3_6(
	.I(main_usddrphy_dqs_delayed6),
	.T(main_usddrphy_dqs_t6),
	.IO(ddram_dqs_p[6]),
	.IOB(ddram_dqs_n[6])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_33 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip70),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dqs_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dqs_nodelay7),
	.T_OUT(main_usddrphy_dqs_t7)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(9'd500),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_33 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dqs_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dqs_nodelay7),
	.RST(ic_rst),
	.CNTVALUEOUT(main_usddrphy6),
	.DATAOUT(main_usddrphy_dqs_delayed7)
);

IOBUFDSE3 IOBUFDSE3_7(
	.I(main_usddrphy_dqs_delayed7),
	.T(main_usddrphy_dqs_t7),
	.IO(ddram_dqs_p[7]),
	.IOB(ddram_dqs_n[7])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_34 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip01),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay0)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_34 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay0),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[0])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_35 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip11),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay1)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_35 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[1])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_36 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip21),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay2)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_36 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay2),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[2])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_37 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip31),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay3)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_37 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay3),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[3])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_38 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip41),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay4)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_38 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay4),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[4])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_39 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip51),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay5)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_39 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay5),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[5])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_40 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip61),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay6)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_40 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay6),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[6])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_41 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip71),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.OQ(main_usddrphy_dm_o_nodelay7)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_41 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dm_o_nodelay7),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(ddram_dm[7])
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_42 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip02),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay0),
	.T_OUT(main_usddrphy_dq_t0)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed0),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip03)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_42 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay0),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed0)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay0),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed0)
);

IOBUF IOBUF(
	.I(main_usddrphy_dq_o_delayed0),
	.T(main_usddrphy_dq_t0),
	.IO(ddram_dq[0]),
	.O(main_usddrphy_dq_i_nodelay0)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_43 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip12),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay1),
	.T_OUT(main_usddrphy_dq_t1)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_1 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed1),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip13)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_43 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed1)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_1 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay1),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed1)
);

IOBUF IOBUF_1(
	.I(main_usddrphy_dq_o_delayed1),
	.T(main_usddrphy_dq_t1),
	.IO(ddram_dq[1]),
	.O(main_usddrphy_dq_i_nodelay1)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_44 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip22),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay2),
	.T_OUT(main_usddrphy_dq_t2)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_2 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed2),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip23)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_44 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay2),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed2)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_2 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay2),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed2)
);

IOBUF IOBUF_2(
	.I(main_usddrphy_dq_o_delayed2),
	.T(main_usddrphy_dq_t2),
	.IO(ddram_dq[2]),
	.O(main_usddrphy_dq_i_nodelay2)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_45 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip32),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay3),
	.T_OUT(main_usddrphy_dq_t3)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_3 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed3),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip33)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_45 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay3),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed3)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_3 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay3),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed3)
);

IOBUF IOBUF_3(
	.I(main_usddrphy_dq_o_delayed3),
	.T(main_usddrphy_dq_t3),
	.IO(ddram_dq[3]),
	.O(main_usddrphy_dq_i_nodelay3)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_46 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip42),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay4),
	.T_OUT(main_usddrphy_dq_t4)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_4 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed4),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip43)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_46 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay4),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed4)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_4 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay4),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed4)
);

IOBUF IOBUF_4(
	.I(main_usddrphy_dq_o_delayed4),
	.T(main_usddrphy_dq_t4),
	.IO(ddram_dq[4]),
	.O(main_usddrphy_dq_i_nodelay4)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_47 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip52),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay5),
	.T_OUT(main_usddrphy_dq_t5)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_5 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed5),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip53)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_47 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay5),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed5)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_5 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay5),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed5)
);

IOBUF IOBUF_5(
	.I(main_usddrphy_dq_o_delayed5),
	.T(main_usddrphy_dq_t5),
	.IO(ddram_dq[5]),
	.O(main_usddrphy_dq_i_nodelay5)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_48 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip62),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay6),
	.T_OUT(main_usddrphy_dq_t6)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_6 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed6),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip63)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_48 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay6),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed6)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_6 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay6),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed6)
);

IOBUF IOBUF_6(
	.I(main_usddrphy_dq_o_delayed6),
	.T(main_usddrphy_dq_t6),
	.IO(ddram_dq[6]),
	.O(main_usddrphy_dq_i_nodelay6)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_49 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip72),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay7),
	.T_OUT(main_usddrphy_dq_t7)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_7 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed7),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip73)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_49 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay7),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed7)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_7 (
	.CE((main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay7),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[0] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed7)
);

IOBUF IOBUF_7(
	.I(main_usddrphy_dq_o_delayed7),
	.T(main_usddrphy_dq_t7),
	.IO(ddram_dq[7]),
	.O(main_usddrphy_dq_i_nodelay7)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_50 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip80),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay8),
	.T_OUT(main_usddrphy_dq_t8)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_8 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed8),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip81)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_50 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay8),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed8)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_8 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay8),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed8)
);

IOBUF IOBUF_8(
	.I(main_usddrphy_dq_o_delayed8),
	.T(main_usddrphy_dq_t8),
	.IO(ddram_dq[8]),
	.O(main_usddrphy_dq_i_nodelay8)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_51 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip90),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay9),
	.T_OUT(main_usddrphy_dq_t9)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_9 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed9),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip91)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_51 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay9),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed9)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_9 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay9),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed9)
);

IOBUF IOBUF_9(
	.I(main_usddrphy_dq_o_delayed9),
	.T(main_usddrphy_dq_t9),
	.IO(ddram_dq[9]),
	.O(main_usddrphy_dq_i_nodelay9)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_52 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip100),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay10),
	.T_OUT(main_usddrphy_dq_t10)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_10 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed10),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip101)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_52 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay10),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed10)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_10 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay10),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed10)
);

IOBUF IOBUF_10(
	.I(main_usddrphy_dq_o_delayed10),
	.T(main_usddrphy_dq_t10),
	.IO(ddram_dq[10]),
	.O(main_usddrphy_dq_i_nodelay10)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_53 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip110),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay11),
	.T_OUT(main_usddrphy_dq_t11)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_11 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed11),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip111)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_53 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay11),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed11)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_11 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay11),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed11)
);

IOBUF IOBUF_11(
	.I(main_usddrphy_dq_o_delayed11),
	.T(main_usddrphy_dq_t11),
	.IO(ddram_dq[11]),
	.O(main_usddrphy_dq_i_nodelay11)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_54 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip120),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay12),
	.T_OUT(main_usddrphy_dq_t12)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_12 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed12),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip121)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_54 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay12),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed12)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_12 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay12),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed12)
);

IOBUF IOBUF_12(
	.I(main_usddrphy_dq_o_delayed12),
	.T(main_usddrphy_dq_t12),
	.IO(ddram_dq[12]),
	.O(main_usddrphy_dq_i_nodelay12)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_55 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip130),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay13),
	.T_OUT(main_usddrphy_dq_t13)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_13 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed13),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip131)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_55 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay13),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed13)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_13 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay13),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed13)
);

IOBUF IOBUF_13(
	.I(main_usddrphy_dq_o_delayed13),
	.T(main_usddrphy_dq_t13),
	.IO(ddram_dq[13]),
	.O(main_usddrphy_dq_i_nodelay13)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_56 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip140),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay14),
	.T_OUT(main_usddrphy_dq_t14)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_14 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed14),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip141)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_56 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay14),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed14)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_14 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay14),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed14)
);

IOBUF IOBUF_14(
	.I(main_usddrphy_dq_o_delayed14),
	.T(main_usddrphy_dq_t14),
	.IO(ddram_dq[14]),
	.O(main_usddrphy_dq_i_nodelay14)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_57 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip150),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay15),
	.T_OUT(main_usddrphy_dq_t15)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_15 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed15),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip151)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_57 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay15),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed15)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_15 (
	.CE((main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay15),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[1] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed15)
);

IOBUF IOBUF_15(
	.I(main_usddrphy_dq_o_delayed15),
	.T(main_usddrphy_dq_t15),
	.IO(ddram_dq[15]),
	.O(main_usddrphy_dq_i_nodelay15)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_58 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip160),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay16),
	.T_OUT(main_usddrphy_dq_t16)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_16 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed16),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip161)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_58 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay16),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed16)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_16 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay16),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed16)
);

IOBUF IOBUF_16(
	.I(main_usddrphy_dq_o_delayed16),
	.T(main_usddrphy_dq_t16),
	.IO(ddram_dq[16]),
	.O(main_usddrphy_dq_i_nodelay16)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_59 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip170),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay17),
	.T_OUT(main_usddrphy_dq_t17)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_17 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed17),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip171)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_59 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay17),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed17)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_17 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay17),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed17)
);

IOBUF IOBUF_17(
	.I(main_usddrphy_dq_o_delayed17),
	.T(main_usddrphy_dq_t17),
	.IO(ddram_dq[17]),
	.O(main_usddrphy_dq_i_nodelay17)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_60 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip180),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay18),
	.T_OUT(main_usddrphy_dq_t18)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_18 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed18),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip181)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_60 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay18),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed18)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_18 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay18),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed18)
);

IOBUF IOBUF_18(
	.I(main_usddrphy_dq_o_delayed18),
	.T(main_usddrphy_dq_t18),
	.IO(ddram_dq[18]),
	.O(main_usddrphy_dq_i_nodelay18)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_61 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip190),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay19),
	.T_OUT(main_usddrphy_dq_t19)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_19 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed19),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip191)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_61 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay19),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed19)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_19 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay19),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed19)
);

IOBUF IOBUF_19(
	.I(main_usddrphy_dq_o_delayed19),
	.T(main_usddrphy_dq_t19),
	.IO(ddram_dq[19]),
	.O(main_usddrphy_dq_i_nodelay19)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_62 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip200),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay20),
	.T_OUT(main_usddrphy_dq_t20)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_20 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed20),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip201)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_62 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay20),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed20)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_20 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay20),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed20)
);

IOBUF IOBUF_20(
	.I(main_usddrphy_dq_o_delayed20),
	.T(main_usddrphy_dq_t20),
	.IO(ddram_dq[20]),
	.O(main_usddrphy_dq_i_nodelay20)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_63 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip210),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay21),
	.T_OUT(main_usddrphy_dq_t21)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_21 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed21),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip211)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_63 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay21),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed21)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_21 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay21),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed21)
);

IOBUF IOBUF_21(
	.I(main_usddrphy_dq_o_delayed21),
	.T(main_usddrphy_dq_t21),
	.IO(ddram_dq[21]),
	.O(main_usddrphy_dq_i_nodelay21)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_64 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip220),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay22),
	.T_OUT(main_usddrphy_dq_t22)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_22 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed22),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip221)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_64 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay22),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed22)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_22 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay22),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed22)
);

IOBUF IOBUF_22(
	.I(main_usddrphy_dq_o_delayed22),
	.T(main_usddrphy_dq_t22),
	.IO(ddram_dq[22]),
	.O(main_usddrphy_dq_i_nodelay22)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_65 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip230),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay23),
	.T_OUT(main_usddrphy_dq_t23)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_23 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed23),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip231)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_65 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay23),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed23)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_23 (
	.CE((main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay23),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[2] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed23)
);

IOBUF IOBUF_23(
	.I(main_usddrphy_dq_o_delayed23),
	.T(main_usddrphy_dq_t23),
	.IO(ddram_dq[23]),
	.O(main_usddrphy_dq_i_nodelay23)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_66 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip240),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay24),
	.T_OUT(main_usddrphy_dq_t24)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_24 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed24),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip241)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_66 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay24),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed24)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_24 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay24),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed24)
);

IOBUF IOBUF_24(
	.I(main_usddrphy_dq_o_delayed24),
	.T(main_usddrphy_dq_t24),
	.IO(ddram_dq[24]),
	.O(main_usddrphy_dq_i_nodelay24)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_67 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip250),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay25),
	.T_OUT(main_usddrphy_dq_t25)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_25 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed25),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip251)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_67 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay25),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed25)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_25 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay25),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed25)
);

IOBUF IOBUF_25(
	.I(main_usddrphy_dq_o_delayed25),
	.T(main_usddrphy_dq_t25),
	.IO(ddram_dq[25]),
	.O(main_usddrphy_dq_i_nodelay25)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_68 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip260),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay26),
	.T_OUT(main_usddrphy_dq_t26)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_26 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed26),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip261)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_68 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay26),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed26)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_26 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay26),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed26)
);

IOBUF IOBUF_26(
	.I(main_usddrphy_dq_o_delayed26),
	.T(main_usddrphy_dq_t26),
	.IO(ddram_dq[26]),
	.O(main_usddrphy_dq_i_nodelay26)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_69 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip270),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay27),
	.T_OUT(main_usddrphy_dq_t27)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_27 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed27),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip271)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_69 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay27),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed27)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_27 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay27),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed27)
);

IOBUF IOBUF_27(
	.I(main_usddrphy_dq_o_delayed27),
	.T(main_usddrphy_dq_t27),
	.IO(ddram_dq[27]),
	.O(main_usddrphy_dq_i_nodelay27)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_70 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip280),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay28),
	.T_OUT(main_usddrphy_dq_t28)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_28 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed28),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip281)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_70 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay28),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed28)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_28 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay28),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed28)
);

IOBUF IOBUF_28(
	.I(main_usddrphy_dq_o_delayed28),
	.T(main_usddrphy_dq_t28),
	.IO(ddram_dq[28]),
	.O(main_usddrphy_dq_i_nodelay28)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_71 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip290),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay29),
	.T_OUT(main_usddrphy_dq_t29)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_29 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed29),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip291)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_71 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay29),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed29)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_29 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay29),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed29)
);

IOBUF IOBUF_29(
	.I(main_usddrphy_dq_o_delayed29),
	.T(main_usddrphy_dq_t29),
	.IO(ddram_dq[29]),
	.O(main_usddrphy_dq_i_nodelay29)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_72 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip300),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay30),
	.T_OUT(main_usddrphy_dq_t30)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_30 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed30),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip301)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_72 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay30),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed30)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_30 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay30),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed30)
);

IOBUF IOBUF_30(
	.I(main_usddrphy_dq_o_delayed30),
	.T(main_usddrphy_dq_t30),
	.IO(ddram_dq[30]),
	.O(main_usddrphy_dq_i_nodelay30)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_73 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip310),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay31),
	.T_OUT(main_usddrphy_dq_t31)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_31 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed31),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip311)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_73 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay31),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed31)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_31 (
	.CE((main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay31),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[3] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed31)
);

IOBUF IOBUF_31(
	.I(main_usddrphy_dq_o_delayed31),
	.T(main_usddrphy_dq_t31),
	.IO(ddram_dq[31]),
	.O(main_usddrphy_dq_i_nodelay31)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_74 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip320),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay32),
	.T_OUT(main_usddrphy_dq_t32)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_32 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed32),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip321)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_74 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay32),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed32)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_32 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay32),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed32)
);

IOBUF IOBUF_32(
	.I(main_usddrphy_dq_o_delayed32),
	.T(main_usddrphy_dq_t32),
	.IO(ddram_dq[32]),
	.O(main_usddrphy_dq_i_nodelay32)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_75 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip330),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay33),
	.T_OUT(main_usddrphy_dq_t33)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_33 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed33),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip331)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_75 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay33),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed33)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_33 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay33),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed33)
);

IOBUF IOBUF_33(
	.I(main_usddrphy_dq_o_delayed33),
	.T(main_usddrphy_dq_t33),
	.IO(ddram_dq[33]),
	.O(main_usddrphy_dq_i_nodelay33)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_76 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip340),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay34),
	.T_OUT(main_usddrphy_dq_t34)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_34 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed34),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip341)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_76 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay34),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed34)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_34 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay34),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed34)
);

IOBUF IOBUF_34(
	.I(main_usddrphy_dq_o_delayed34),
	.T(main_usddrphy_dq_t34),
	.IO(ddram_dq[34]),
	.O(main_usddrphy_dq_i_nodelay34)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_77 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip350),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay35),
	.T_OUT(main_usddrphy_dq_t35)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_35 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed35),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip351)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_77 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay35),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed35)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_35 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay35),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed35)
);

IOBUF IOBUF_35(
	.I(main_usddrphy_dq_o_delayed35),
	.T(main_usddrphy_dq_t35),
	.IO(ddram_dq[35]),
	.O(main_usddrphy_dq_i_nodelay35)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_78 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip360),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay36),
	.T_OUT(main_usddrphy_dq_t36)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_36 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed36),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip361)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_78 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay36),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed36)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_36 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay36),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed36)
);

IOBUF IOBUF_36(
	.I(main_usddrphy_dq_o_delayed36),
	.T(main_usddrphy_dq_t36),
	.IO(ddram_dq[36]),
	.O(main_usddrphy_dq_i_nodelay36)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_79 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip370),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay37),
	.T_OUT(main_usddrphy_dq_t37)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_37 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed37),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip371)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_79 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay37),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed37)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_37 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay37),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed37)
);

IOBUF IOBUF_37(
	.I(main_usddrphy_dq_o_delayed37),
	.T(main_usddrphy_dq_t37),
	.IO(ddram_dq[37]),
	.O(main_usddrphy_dq_i_nodelay37)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_80 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip380),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay38),
	.T_OUT(main_usddrphy_dq_t38)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_38 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed38),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip381)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_80 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay38),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed38)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_38 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay38),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed38)
);

IOBUF IOBUF_38(
	.I(main_usddrphy_dq_o_delayed38),
	.T(main_usddrphy_dq_t38),
	.IO(ddram_dq[38]),
	.O(main_usddrphy_dq_i_nodelay38)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_81 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip390),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay39),
	.T_OUT(main_usddrphy_dq_t39)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_39 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed39),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip391)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_81 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay39),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed39)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_39 (
	.CE((main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay39),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[4] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed39)
);

IOBUF IOBUF_39(
	.I(main_usddrphy_dq_o_delayed39),
	.T(main_usddrphy_dq_t39),
	.IO(ddram_dq[39]),
	.O(main_usddrphy_dq_i_nodelay39)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_82 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip400),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay40),
	.T_OUT(main_usddrphy_dq_t40)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_40 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed40),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip401)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_82 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay40),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed40)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_40 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay40),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed40)
);

IOBUF IOBUF_40(
	.I(main_usddrphy_dq_o_delayed40),
	.T(main_usddrphy_dq_t40),
	.IO(ddram_dq[40]),
	.O(main_usddrphy_dq_i_nodelay40)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_83 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip410),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay41),
	.T_OUT(main_usddrphy_dq_t41)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_41 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed41),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip411)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_83 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay41),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed41)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_41 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay41),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed41)
);

IOBUF IOBUF_41(
	.I(main_usddrphy_dq_o_delayed41),
	.T(main_usddrphy_dq_t41),
	.IO(ddram_dq[41]),
	.O(main_usddrphy_dq_i_nodelay41)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_84 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip420),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay42),
	.T_OUT(main_usddrphy_dq_t42)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_42 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed42),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip421)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_84 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay42),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed42)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_42 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay42),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed42)
);

IOBUF IOBUF_42(
	.I(main_usddrphy_dq_o_delayed42),
	.T(main_usddrphy_dq_t42),
	.IO(ddram_dq[42]),
	.O(main_usddrphy_dq_i_nodelay42)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_85 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip430),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay43),
	.T_OUT(main_usddrphy_dq_t43)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_43 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed43),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip431)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_85 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay43),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed43)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_43 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay43),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed43)
);

IOBUF IOBUF_43(
	.I(main_usddrphy_dq_o_delayed43),
	.T(main_usddrphy_dq_t43),
	.IO(ddram_dq[43]),
	.O(main_usddrphy_dq_i_nodelay43)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_86 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip440),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay44),
	.T_OUT(main_usddrphy_dq_t44)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_44 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed44),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip441)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_86 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay44),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed44)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_44 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay44),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed44)
);

IOBUF IOBUF_44(
	.I(main_usddrphy_dq_o_delayed44),
	.T(main_usddrphy_dq_t44),
	.IO(ddram_dq[44]),
	.O(main_usddrphy_dq_i_nodelay44)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_87 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip450),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay45),
	.T_OUT(main_usddrphy_dq_t45)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_45 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed45),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip451)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_87 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay45),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed45)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_45 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay45),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed45)
);

IOBUF IOBUF_45(
	.I(main_usddrphy_dq_o_delayed45),
	.T(main_usddrphy_dq_t45),
	.IO(ddram_dq[45]),
	.O(main_usddrphy_dq_i_nodelay45)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_88 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip460),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay46),
	.T_OUT(main_usddrphy_dq_t46)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_46 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed46),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip461)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_88 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay46),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed46)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_46 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay46),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed46)
);

IOBUF IOBUF_46(
	.I(main_usddrphy_dq_o_delayed46),
	.T(main_usddrphy_dq_t46),
	.IO(ddram_dq[46]),
	.O(main_usddrphy_dq_i_nodelay46)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_89 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip470),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay47),
	.T_OUT(main_usddrphy_dq_t47)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_47 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed47),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip471)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_89 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay47),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed47)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_47 (
	.CE((main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay47),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[5] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed47)
);

IOBUF IOBUF_47(
	.I(main_usddrphy_dq_o_delayed47),
	.T(main_usddrphy_dq_t47),
	.IO(ddram_dq[47]),
	.O(main_usddrphy_dq_i_nodelay47)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_90 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip480),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay48),
	.T_OUT(main_usddrphy_dq_t48)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_48 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed48),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip481)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_90 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay48),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed48)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_48 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay48),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed48)
);

IOBUF IOBUF_48(
	.I(main_usddrphy_dq_o_delayed48),
	.T(main_usddrphy_dq_t48),
	.IO(ddram_dq[48]),
	.O(main_usddrphy_dq_i_nodelay48)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_91 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip490),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay49),
	.T_OUT(main_usddrphy_dq_t49)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_49 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed49),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip491)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_91 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay49),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed49)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_49 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay49),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed49)
);

IOBUF IOBUF_49(
	.I(main_usddrphy_dq_o_delayed49),
	.T(main_usddrphy_dq_t49),
	.IO(ddram_dq[49]),
	.O(main_usddrphy_dq_i_nodelay49)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_92 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip500),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay50),
	.T_OUT(main_usddrphy_dq_t50)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_50 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed50),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip501)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_92 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay50),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed50)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_50 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay50),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed50)
);

IOBUF IOBUF_50(
	.I(main_usddrphy_dq_o_delayed50),
	.T(main_usddrphy_dq_t50),
	.IO(ddram_dq[50]),
	.O(main_usddrphy_dq_i_nodelay50)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_93 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip510),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay51),
	.T_OUT(main_usddrphy_dq_t51)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_51 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed51),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip511)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_93 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay51),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed51)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_51 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay51),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed51)
);

IOBUF IOBUF_51(
	.I(main_usddrphy_dq_o_delayed51),
	.T(main_usddrphy_dq_t51),
	.IO(ddram_dq[51]),
	.O(main_usddrphy_dq_i_nodelay51)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_94 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip520),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay52),
	.T_OUT(main_usddrphy_dq_t52)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_52 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed52),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip521)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_94 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay52),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed52)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_52 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay52),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed52)
);

IOBUF IOBUF_52(
	.I(main_usddrphy_dq_o_delayed52),
	.T(main_usddrphy_dq_t52),
	.IO(ddram_dq[52]),
	.O(main_usddrphy_dq_i_nodelay52)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_95 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip530),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay53),
	.T_OUT(main_usddrphy_dq_t53)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_53 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed53),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip531)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_95 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay53),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed53)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_53 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay53),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed53)
);

IOBUF IOBUF_53(
	.I(main_usddrphy_dq_o_delayed53),
	.T(main_usddrphy_dq_t53),
	.IO(ddram_dq[53]),
	.O(main_usddrphy_dq_i_nodelay53)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_96 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip540),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay54),
	.T_OUT(main_usddrphy_dq_t54)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_54 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed54),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip541)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_96 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay54),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed54)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_54 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay54),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed54)
);

IOBUF IOBUF_54(
	.I(main_usddrphy_dq_o_delayed54),
	.T(main_usddrphy_dq_t54),
	.IO(ddram_dq[54]),
	.O(main_usddrphy_dq_i_nodelay54)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_97 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip550),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay55),
	.T_OUT(main_usddrphy_dq_t55)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_55 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed55),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip551)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_97 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay55),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed55)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_55 (
	.CE((main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay55),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[6] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed55)
);

IOBUF IOBUF_55(
	.I(main_usddrphy_dq_o_delayed55),
	.T(main_usddrphy_dq_t55),
	.IO(ddram_dq[55]),
	.O(main_usddrphy_dq_i_nodelay55)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_98 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip560),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay56),
	.T_OUT(main_usddrphy_dq_t56)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_56 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed56),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip561)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_98 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay56),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed56)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_56 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay56),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed56)
);

IOBUF IOBUF_56(
	.I(main_usddrphy_dq_o_delayed56),
	.T(main_usddrphy_dq_t56),
	.IO(ddram_dq[56]),
	.O(main_usddrphy_dq_i_nodelay56)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_99 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip570),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay57),
	.T_OUT(main_usddrphy_dq_t57)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_57 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed57),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip571)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_99 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay57),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed57)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_57 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay57),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed57)
);

IOBUF IOBUF_57(
	.I(main_usddrphy_dq_o_delayed57),
	.T(main_usddrphy_dq_t57),
	.IO(ddram_dq[57]),
	.O(main_usddrphy_dq_i_nodelay57)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_100 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip580),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay58),
	.T_OUT(main_usddrphy_dq_t58)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_58 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed58),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip581)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_100 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay58),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed58)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_58 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay58),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed58)
);

IOBUF IOBUF_58(
	.I(main_usddrphy_dq_o_delayed58),
	.T(main_usddrphy_dq_t58),
	.IO(ddram_dq[58]),
	.O(main_usddrphy_dq_i_nodelay58)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_101 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip590),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay59),
	.T_OUT(main_usddrphy_dq_t59)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_59 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed59),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip591)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_101 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay59),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed59)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_59 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay59),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed59)
);

IOBUF IOBUF_59(
	.I(main_usddrphy_dq_o_delayed59),
	.T(main_usddrphy_dq_t59),
	.IO(ddram_dq[59]),
	.O(main_usddrphy_dq_i_nodelay59)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_102 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip600),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay60),
	.T_OUT(main_usddrphy_dq_t60)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_60 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed60),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip601)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_102 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay60),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed60)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_60 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay60),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed60)
);

IOBUF IOBUF_60(
	.I(main_usddrphy_dq_o_delayed60),
	.T(main_usddrphy_dq_t60),
	.IO(ddram_dq[60]),
	.O(main_usddrphy_dq_i_nodelay60)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_103 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip610),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay61),
	.T_OUT(main_usddrphy_dq_t61)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_61 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed61),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip611)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_103 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay61),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed61)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_61 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay61),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed61)
);

IOBUF IOBUF_61(
	.I(main_usddrphy_dq_o_delayed61),
	.T(main_usddrphy_dq_t61),
	.IO(ddram_dq[61]),
	.O(main_usddrphy_dq_i_nodelay61)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_104 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip620),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay62),
	.T_OUT(main_usddrphy_dq_t62)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_62 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed62),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip621)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_104 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay62),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed62)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_62 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay62),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed62)
);

IOBUF IOBUF_62(
	.I(main_usddrphy_dq_o_delayed62),
	.T(main_usddrphy_dq_t62),
	.IO(ddram_dq[62]),
	.O(main_usddrphy_dq_i_nodelay62)
);

OSERDESE3 #(
	.DATA_WIDTH(4'd8),
	.INIT(1'd0),
	.IS_CLKDIV_INVERTED(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) OSERDESE3_105 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.D(main_usddrphy_bitslip630),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.T((~main_usddrphy_dq_oe_delay_tappeddelayline_tappeddelayline)),
	.OQ(main_usddrphy_dq_o_nodelay63),
	.T_OUT(main_usddrphy_dq_t63)
);

ISERDESE3 #(
	.DATA_WIDTH(4'd8),
	.IS_CLK_B_INVERTED(1'd1),
	.IS_CLK_INVERTED(1'd0),
	.SIM_DEVICE("ULTRASCALE")
) ISERDESE3_63 (
	.CLK(sys4x_clk),
	.CLKDIV(sys_clk),
	.CLK_B(sys4x_clk),
	.D(main_usddrphy_dq_i_delayed63),
	.FIFO_RD_EN(1'd0),
	.RST((ic_rst | main_usddrphy_rst_storage)),
	.Q(main_usddrphy_bitslip631)
);

ODELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) ODELAYE3_105 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.INC(1'd1),
	.ODATAIN(main_usddrphy_dq_o_nodelay63),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_wdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_o_delayed63)
);

IDELAYE3 #(
	.CASCADE("NONE"),
	.DELAY_FORMAT("TIME"),
	.DELAY_SRC("IDATAIN"),
	.DELAY_TYPE("VARIABLE"),
	.DELAY_VALUE(1'd0),
	.IS_CLK_INVERTED(1'd0),
	.IS_RST_INVERTED(1'd0),
	.REFCLK_FREQUENCY(200.0),
	.SIM_DEVICE("ULTRASCALE"),
	.UPDATE_MODE("ASYNC")
) IDELAYE3_63 (
	.CE((main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_inc_re)),
	.CLK(sys_clk),
	.EN_VTC(main_usddrphy_en_vtc_storage),
	.IDATAIN(main_usddrphy_dq_i_nodelay63),
	.INC(1'd1),
	.RST(((ic_rst | (main_usddrphy_dly_sel_storage[7] & main_usddrphy_rdly_dq_rst_re)) | main_usddrphy_rst_storage)),
	.DATAOUT(main_usddrphy_dq_i_delayed63)
);

IOBUF IOBUF_63(
	.I(main_usddrphy_dq_o_delayed63),
	.T(main_usddrphy_dq_t63),
	.IO(ddram_dq[63]),
	.O(main_usddrphy_dq_i_nodelay63)
);

//------------------------------------------------------------------------------
// Memory storage_2: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_2[0:7];
reg [24:0] storage_2_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine0_wrport_we)
		storage_2[main_sdram_bankmachine0_wrport_adr] <= main_sdram_bankmachine0_wrport_dat_w;
	storage_2_dat0 <= storage_2[main_sdram_bankmachine0_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine0_wrport_dat_r = storage_2_dat0;
assign main_sdram_bankmachine0_rdport_dat_r = storage_2[main_sdram_bankmachine0_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_3: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_3[0:7];
reg [24:0] storage_3_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine1_wrport_we)
		storage_3[main_sdram_bankmachine1_wrport_adr] <= main_sdram_bankmachine1_wrport_dat_w;
	storage_3_dat0 <= storage_3[main_sdram_bankmachine1_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine1_wrport_dat_r = storage_3_dat0;
assign main_sdram_bankmachine1_rdport_dat_r = storage_3[main_sdram_bankmachine1_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_4: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_4[0:7];
reg [24:0] storage_4_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine2_wrport_we)
		storage_4[main_sdram_bankmachine2_wrport_adr] <= main_sdram_bankmachine2_wrport_dat_w;
	storage_4_dat0 <= storage_4[main_sdram_bankmachine2_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine2_wrport_dat_r = storage_4_dat0;
assign main_sdram_bankmachine2_rdport_dat_r = storage_4[main_sdram_bankmachine2_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_5: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_5[0:7];
reg [24:0] storage_5_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine3_wrport_we)
		storage_5[main_sdram_bankmachine3_wrport_adr] <= main_sdram_bankmachine3_wrport_dat_w;
	storage_5_dat0 <= storage_5[main_sdram_bankmachine3_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine3_wrport_dat_r = storage_5_dat0;
assign main_sdram_bankmachine3_rdport_dat_r = storage_5[main_sdram_bankmachine3_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_6: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_6[0:7];
reg [24:0] storage_6_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine4_wrport_we)
		storage_6[main_sdram_bankmachine4_wrport_adr] <= main_sdram_bankmachine4_wrport_dat_w;
	storage_6_dat0 <= storage_6[main_sdram_bankmachine4_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine4_wrport_dat_r = storage_6_dat0;
assign main_sdram_bankmachine4_rdport_dat_r = storage_6[main_sdram_bankmachine4_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_7: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_7[0:7];
reg [24:0] storage_7_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine5_wrport_we)
		storage_7[main_sdram_bankmachine5_wrport_adr] <= main_sdram_bankmachine5_wrport_dat_w;
	storage_7_dat0 <= storage_7[main_sdram_bankmachine5_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine5_wrport_dat_r = storage_7_dat0;
assign main_sdram_bankmachine5_rdport_dat_r = storage_7[main_sdram_bankmachine5_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_8: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_8[0:7];
reg [24:0] storage_8_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine6_wrport_we)
		storage_8[main_sdram_bankmachine6_wrport_adr] <= main_sdram_bankmachine6_wrport_dat_w;
	storage_8_dat0 <= storage_8[main_sdram_bankmachine6_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine6_wrport_dat_r = storage_8_dat0;
assign main_sdram_bankmachine6_rdport_dat_r = storage_8[main_sdram_bankmachine6_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_9: 8-words x 25-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 25 
// Port 1 | Read: Async | Write: ---- | 
reg [24:0] storage_9[0:7];
reg [24:0] storage_9_dat0;
always @(posedge sys_clk) begin
	if (main_sdram_bankmachine7_wrport_we)
		storage_9[main_sdram_bankmachine7_wrport_adr] <= main_sdram_bankmachine7_wrport_dat_w;
	storage_9_dat0 <= storage_9[main_sdram_bankmachine7_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign main_sdram_bankmachine7_wrport_dat_r = storage_9_dat0;
assign main_sdram_bankmachine7_rdport_dat_r = storage_9[main_sdram_bankmachine7_rdport_adr];


//------------------------------------------------------------------------------
// Memory mem_6b5b: 64-words x 5-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: ---- | 
reg [4:0] mem_6b5b[0:63];
initial begin
	$readmemh("kcu105_mem_6b5b.init", mem_6b5b);
end
reg [5:0] mem_6b5b_adr0;
always @(posedge eth_rx_clk) begin
	if (main_ku_1000basex_pcsrx_re)
		mem_6b5b_adr0 <= main_ku_1000basex_pcsrx_adr;
end
assign main_ku_1000basex_pcsrx_dat_r = mem_6b5b[mem_6b5b_adr0];


GTHE3_CHANNEL #(
	.ACJTAG_DEBUG_MODE(1'd0),
	.ACJTAG_MODE(1'd0),
	.ACJTAG_RESET(1'd0),
	.ADAPT_CFG0(16'd63488),
	.ADAPT_CFG1(1'd0),
	.ALIGN_COMMA_DOUBLE("FALSE"),
	.ALIGN_COMMA_ENABLE(1'd0),
	.ALIGN_COMMA_WORD(1'd1),
	.ALIGN_MCOMMA_DET("FALSE"),
	.ALIGN_MCOMMA_VALUE(10'd643),
	.ALIGN_PCOMMA_DET("FALSE"),
	.ALIGN_PCOMMA_VALUE(9'd380),
	.A_RXOSCALRESET(1'd0),
	.A_RXPROGDIVRESET(1'd0),
	.A_TXPROGDIVRESET(1'd0),
	.CBCC_DATA_SOURCE_SEL("ENCODED"),
	.CDR_SWAP_MODE_EN(1'd0),
	.CHAN_BOND_KEEP_ALIGN("FALSE"),
	.CHAN_BOND_MAX_SKEW(1'd1),
	.CHAN_BOND_SEQ_1_1(1'd0),
	.CHAN_BOND_SEQ_1_2(1'd0),
	.CHAN_BOND_SEQ_1_3(1'd0),
	.CHAN_BOND_SEQ_1_4(1'd0),
	.CHAN_BOND_SEQ_1_ENABLE(4'd15),
	.CHAN_BOND_SEQ_2_1(1'd0),
	.CHAN_BOND_SEQ_2_2(1'd0),
	.CHAN_BOND_SEQ_2_3(1'd0),
	.CHAN_BOND_SEQ_2_4(1'd0),
	.CHAN_BOND_SEQ_2_ENABLE(4'd15),
	.CHAN_BOND_SEQ_2_USE("FALSE"),
	.CHAN_BOND_SEQ_LEN(1'd1),
	.CLK_CORRECT_USE("FALSE"),
	.CLK_COR_KEEP_IDLE("FALSE"),
	.CLK_COR_MAX_LAT(3'd6),
	.CLK_COR_MIN_LAT(3'd4),
	.CLK_COR_PRECEDENCE("TRUE"),
	.CLK_COR_REPEAT_WAIT(1'd0),
	.CLK_COR_SEQ_1_1(1'd0),
	.CLK_COR_SEQ_1_2(1'd0),
	.CLK_COR_SEQ_1_3(1'd0),
	.CLK_COR_SEQ_1_4(1'd0),
	.CLK_COR_SEQ_1_ENABLE(4'd15),
	.CLK_COR_SEQ_2_1(1'd0),
	.CLK_COR_SEQ_2_2(1'd0),
	.CLK_COR_SEQ_2_3(1'd0),
	.CLK_COR_SEQ_2_4(1'd0),
	.CLK_COR_SEQ_2_ENABLE(4'd15),
	.CLK_COR_SEQ_2_USE("FALSE"),
	.CLK_COR_SEQ_LEN(1'd1),
	.CPLL_CFG0(15'd26616),
	.CPLL_CFG1(16'd42156),
	.CPLL_CFG2(3'd7),
	.CPLL_CFG3(1'd0),
	.CPLL_FBDIV(3'd5),
	.CPLL_FBDIV_45(3'd5),
	.CPLL_INIT_CFG0(10'd690),
	.CPLL_INIT_CFG1(1'd0),
	.CPLL_LOCK_CFG(9'd488),
	.CPLL_REFCLK_DIV(2'd2),
	.DDI_CTRL(1'd0),
	.DDI_REALIGN_WAIT(4'd15),
	.DEC_MCOMMA_DETECT("FALSE"),
	.DEC_PCOMMA_DETECT("FALSE"),
	.DEC_VALID_COMMA_ONLY("FALSE"),
	.DFE_D_X_REL_POS(1'd0),
	.DFE_VCM_COMP_EN(1'd0),
	.DMONITOR_CFG0(1'd0),
	.DMONITOR_CFG1(1'd0),
	.ES_CLK_PHASE_SEL(1'd0),
	.ES_CONTROL(1'd0),
	.ES_ERRDET_EN("FALSE"),
	.ES_EYE_SCAN_EN("FALSE"),
	.ES_HORZ_OFFSET(1'd0),
	.ES_PMA_CFG(1'd0),
	.ES_PRESCALE(1'd0),
	.ES_QUALIFIER0(1'd0),
	.ES_QUALIFIER1(1'd0),
	.ES_QUALIFIER2(1'd0),
	.ES_QUALIFIER3(1'd0),
	.ES_QUALIFIER4(1'd0),
	.ES_QUAL_MASK0(1'd0),
	.ES_QUAL_MASK1(1'd0),
	.ES_QUAL_MASK2(1'd0),
	.ES_QUAL_MASK3(1'd0),
	.ES_QUAL_MASK4(1'd0),
	.ES_SDATA_MASK0(1'd0),
	.ES_SDATA_MASK1(1'd0),
	.ES_SDATA_MASK2(1'd0),
	.ES_SDATA_MASK3(1'd0),
	.ES_SDATA_MASK4(1'd0),
	.EVODD_PHI_CFG(1'd0),
	.EYE_SCAN_SWAP_EN(1'd0),
	.FTS_DESKEW_SEQ_ENABLE(4'd15),
	.FTS_LANE_DESKEW_CFG(4'd15),
	.FTS_LANE_DESKEW_EN("FALSE"),
	.GEARBOX_MODE(1'd0),
	.GM_BIAS_SELECT(1'd0),
	.LOCAL_MASTER(1'd1),
	.OOBDIVCTL(1'd0),
	.OOB_PWRUP(1'd0),
	.PCI3_AUTO_REALIGN("OVR_1K_BLK"),
	.PCI3_PIPE_RX_ELECIDLE(1'd0),
	.PCI3_RX_ASYNC_EBUF_BYPASS(1'd0),
	.PCI3_RX_ELECIDLE_EI2_ENABLE(1'd0),
	.PCI3_RX_ELECIDLE_H2L_COUNT(1'd0),
	.PCI3_RX_ELECIDLE_H2L_DISABLE(1'd0),
	.PCI3_RX_ELECIDLE_HI_COUNT(1'd0),
	.PCI3_RX_ELECIDLE_LP4_DISABLE(1'd0),
	.PCI3_RX_FIFO_DISABLE(1'd0),
	.PCIE_BUFG_DIV_CTRL(13'd4096),
	.PCIE_RXPCS_CFG_GEN3(10'd676),
	.PCIE_RXPMA_CFG(4'd10),
	.PCIE_TXPCS_CFG_GEN3(14'd11428),
	.PCIE_TXPMA_CFG(4'd10),
	.PCS_PCIE_EN("FALSE"),
	.PCS_RSVD0(1'd0),
	.PCS_RSVD1(1'd0),
	.PD_TRANS_TIME_FROM_P2(6'd60),
	.PD_TRANS_TIME_NONE_P2(5'd25),
	.PD_TRANS_TIME_TO_P2(7'd100),
	.PLL_SEL_MODE_GEN12(1'd0),
	.PLL_SEL_MODE_GEN3(2'd3),
	.PMA_RSV1(16'd61440),
	.PROCESS_PAR(2'd2),
	.RATE_SW_USE_DRP(1'd1),
	.RESET_POWERSAVE_DISABLE(1'd0),
	.RXBUFRESET_TIME(2'd3),
	.RXBUF_ADDR_MODE("FAST"),
	.RXBUF_EIDLE_HI_CNT(4'd8),
	.RXBUF_EIDLE_LO_CNT(1'd0),
	.RXBUF_EN("TRUE"),
	.RXBUF_RESET_ON_CB_CHANGE("TRUE"),
	.RXBUF_RESET_ON_COMMAALIGN("FALSE"),
	.RXBUF_RESET_ON_EIDLE("FALSE"),
	.RXBUF_RESET_ON_RATE_CHANGE("TRUE"),
	.RXBUF_THRESH_OVFLW(6'd61),
	.RXBUF_THRESH_OVRD("TRUE"),
	.RXBUF_THRESH_UNDFLW(1'd1),
	.RXCDRFREQRESET_TIME(1'd1),
	.RXCDRPHRESET_TIME(1'd1),
	.RXCDR_CFG0(1'd0),
	.RXCDR_CFG0_GEN3(1'd0),
	.RXCDR_CFG1(1'd0),
	.RXCDR_CFG1_GEN3(1'd0),
	.RXCDR_CFG2(11'd1990),
	.RXCDR_CFG2_GEN3(11'd2022),
	.RXCDR_CFG3(1'd0),
	.RXCDR_CFG3_GEN3(1'd0),
	.RXCDR_CFG4(1'd0),
	.RXCDR_CFG4_GEN3(1'd0),
	.RXCDR_CFG5(1'd0),
	.RXCDR_CFG5_GEN3(1'd0),
	.RXCDR_FR_RESET_ON_EIDLE(1'd0),
	.RXCDR_HOLD_DURING_EIDLE(1'd0),
	.RXCDR_LOCK_CFG0(15'd17536),
	.RXCDR_LOCK_CFG1(15'd24575),
	.RXCDR_LOCK_CFG2(15'd30659),
	.RXCDR_PH_RESET_ON_EIDLE(1'd0),
	.RXCFOK_CFG0(15'd16384),
	.RXCFOK_CFG1(7'd101),
	.RXCFOK_CFG2(6'd46),
	.RXDFELPMRESET_TIME(4'd15),
	.RXDFELPM_KL_CFG0(1'd0),
	.RXDFELPM_KL_CFG1(6'd50),
	.RXDFELPM_KL_CFG2(1'd0),
	.RXDFE_CFG0(12'd2560),
	.RXDFE_CFG1(1'd0),
	.RXDFE_GC_CFG0(1'd0),
	.RXDFE_GC_CFG1(15'd30832),
	.RXDFE_GC_CFG2(1'd0),
	.RXDFE_H2_CFG0(1'd0),
	.RXDFE_H2_CFG1(1'd0),
	.RXDFE_H3_CFG0(15'd16384),
	.RXDFE_H3_CFG1(1'd0),
	.RXDFE_H4_CFG0(14'd8192),
	.RXDFE_H4_CFG1(2'd3),
	.RXDFE_H5_CFG0(14'd8192),
	.RXDFE_H5_CFG1(2'd3),
	.RXDFE_H6_CFG0(14'd8192),
	.RXDFE_H6_CFG1(1'd0),
	.RXDFE_H7_CFG0(14'd8192),
	.RXDFE_H7_CFG1(1'd0),
	.RXDFE_H8_CFG0(14'd8192),
	.RXDFE_H8_CFG1(1'd0),
	.RXDFE_H9_CFG0(14'd8192),
	.RXDFE_H9_CFG1(1'd0),
	.RXDFE_HA_CFG0(14'd8192),
	.RXDFE_HA_CFG1(1'd0),
	.RXDFE_HB_CFG0(14'd8192),
	.RXDFE_HB_CFG1(1'd0),
	.RXDFE_HC_CFG0(1'd0),
	.RXDFE_HC_CFG1(1'd0),
	.RXDFE_HD_CFG0(1'd0),
	.RXDFE_HD_CFG1(1'd0),
	.RXDFE_HE_CFG0(1'd0),
	.RXDFE_HE_CFG1(1'd0),
	.RXDFE_HF_CFG0(1'd0),
	.RXDFE_HF_CFG1(1'd0),
	.RXDFE_OS_CFG0(16'd32768),
	.RXDFE_OS_CFG1(1'd0),
	.RXDFE_UT_CFG0(16'd32768),
	.RXDFE_UT_CFG1(2'd3),
	.RXDFE_VP_CFG0(16'd43520),
	.RXDFE_VP_CFG1(6'd51),
	.RXDLY_CFG(5'd31),
	.RXDLY_LCFG(6'd48),
	.RXELECIDLE_CFG("Sigcfg_4"),
	.RXGBOX_FIFO_INIT_RD_ADDR(3'd4),
	.RXGEARBOX_EN("FALSE"),
	.RXISCANRESET_TIME(1'd1),
	.RXLPM_CFG(1'd0),
	.RXLPM_GC_CFG(13'd4096),
	.RXLPM_KH_CFG0(1'd0),
	.RXLPM_KH_CFG1(2'd2),
	.RXLPM_OS_CFG0(16'd32768),
	.RXLPM_OS_CFG1(2'd2),
	.RXOOB_CFG(3'd6),
	.RXOOB_CLK_CFG("PMA"),
	.RXOSCALRESET_TIME(2'd3),
	.RXOUT_DIV(3'd4),
	.RXPCSRESET_TIME(2'd3),
	.RXPHBEACON_CFG(1'd0),
	.RXPHDLY_CFG(14'd8224),
	.RXPHSAMP_CFG(14'd8448),
	.RXPHSLIP_CFG(15'd26146),
	.RXPH_MONITOR_SEL(1'd0),
	.RXPI_CFG0(1'd1),
	.RXPI_CFG1(1'd1),
	.RXPI_CFG2(1'd1),
	.RXPI_CFG3(1'd1),
	.RXPI_CFG4(1'd1),
	.RXPI_CFG5(1'd1),
	.RXPI_CFG6(2'd3),
	.RXPI_LPM(1'd0),
	.RXPI_VREFSEL(1'd0),
	.RXPMACLK_SEL("DATA"),
	.RXPMARESET_TIME(2'd3),
	.RXPRBS_ERR_LOOPBACK(1'd0),
	.RXPRBS_LINKACQ_CNT(4'd15),
	.RXSLIDE_AUTO_WAIT(3'd7),
	.RXSLIDE_MODE("OFF"),
	.RXSYNC_MULTILANE(1'd0),
	.RXSYNC_OVRD(1'd0),
	.RXSYNC_SKIP_DA(1'd0),
	.RX_AFE_CM_EN(1'd0),
	.RX_BIAS_CFG0(12'd2740),
	.RX_BUFFER_CFG(1'd0),
	.RX_CAPFF_SARC_ENB(1'd0),
	.RX_CLK25_DIV(4'd8),
	.RX_CLKMUX_EN(1'd1),
	.RX_CLK_SLIP_OVRD(1'd0),
	.RX_CM_BUF_CFG(4'd10),
	.RX_CM_BUF_PD(1'd0),
	.RX_CM_SEL(2'd3),
	.RX_CM_TRIM(4'd10),
	.RX_CTLE3_LPF(1'd1),
	.RX_DATA_WIDTH(5'd20),
	.RX_DDI_SEL(1'd0),
	.RX_DEFER_RESET_BUF_EN("TRUE"),
	.RX_DFELPM_CFG0(3'd6),
	.RX_DFELPM_CFG1(1'd1),
	.RX_DFELPM_KLKH_AGC_STUP_EN(1'd1),
	.RX_DFE_AGC_CFG0(2'd2),
	.RX_DFE_AGC_CFG1(1'd0),
	.RX_DFE_KL_LPM_KH_CFG0(1'd1),
	.RX_DFE_KL_LPM_KH_CFG1(1'd0),
	.RX_DFE_KL_LPM_KL_CFG0(1'd1),
	.RX_DFE_KL_LPM_KL_CFG1(1'd0),
	.RX_DFE_LPM_HOLD_DURING_EIDLE(1'd0),
	.RX_DISPERR_SEQ_MATCH("TRUE"),
	.RX_DIVRESET_TIME(1'd1),
	.RX_EN_HI_LR(1'd0),
	.RX_EYESCAN_VS_CODE(1'd0),
	.RX_EYESCAN_VS_NEG_DIR(1'd0),
	.RX_EYESCAN_VS_RANGE(1'd0),
	.RX_EYESCAN_VS_UT_SIGN(1'd0),
	.RX_FABINT_USRCLK_FLOP(1'd0),
	.RX_INT_DATAWIDTH(1'd0),
	.RX_PMA_POWER_SAVE(1'd0),
	.RX_PROGDIV_CFG(20.0),
	.RX_SAMPLE_PERIOD(3'd7),
	.RX_SIG_VALID_DLY(4'd11),
	.RX_SUM_DFETAPREP_EN(1'd0),
	.RX_SUM_IREF_TUNE(4'd12),
	.RX_SUM_RES_CTRL(2'd3),
	.RX_SUM_VCMTUNE(1'd0),
	.RX_SUM_VCM_OVWR(1'd0),
	.RX_SUM_VREF_TUNE(1'd0),
	.RX_TUNE_AFE_OS(2'd2),
	.RX_WIDEMODE_CDR(1'd0),
	.RX_XCLK_SEL("RXDES"),
	.SAS_MAX_COM(7'd64),
	.SAS_MIN_COM(6'd36),
	.SATA_BURST_SEQ_LEN(4'd14),
	.SATA_CPLL_CFG("VCO_3000MHZ"),
	.SATA_MAX_BURST(4'd8),
	.SATA_MAX_INIT(5'd21),
	.SATA_MAX_WAKE(3'd7),
	.SATA_MIN_BURST(3'd4),
	.SATA_MIN_INIT(4'd12),
	.SATA_MIN_WAKE(3'd4),
	.SHOW_REALIGN_COMMA("FALSE"),
	.SIM_RECEIVER_DETECT_PASS("TRUE"),
	.SIM_RESET_SPEEDUP("TRUE"),
	.SIM_TX_EIDLE_DRIVE_LEVEL(1'd0),
	.SIM_VERSION(2'd2),
	.TAPDLY_SET_TX(1'd0),
	.TEMPERATUR_PAR(2'd2),
	.TERM_RCAL_CFG(15'd16912),
	.TERM_RCAL_OVRD(1'd0),
	.TRANS_TIME_RATE(4'd14),
	.TST_RSV0(1'd0),
	.TST_RSV1(1'd0),
	.TXBUF_EN("TRUE"),
	.TXBUF_RESET_ON_RATE_CHANGE("TRUE"),
	.TXDLY_CFG(4'd9),
	.TXDLY_LCFG(7'd80),
	.TXDRVBIAS_N(4'd10),
	.TXDRVBIAS_P(4'd10),
	.TXFIFO_ADDR_CFG("LOW"),
	.TXGBOX_FIFO_INIT_RD_ADDR(3'd4),
	.TXGEARBOX_EN("FALSE"),
	.TXOUT_DIV(3'd4),
	.TXPCSRESET_TIME(2'd3),
	.TXPHDLY_CFG0(14'd8224),
	.TXPHDLY_CFG1(7'd117),
	.TXPH_CFG(12'd2432),
	.TXPH_MONITOR_SEL(1'd0),
	.TXPI_CFG0(1'd1),
	.TXPI_CFG1(1'd1),
	.TXPI_CFG2(1'd1),
	.TXPI_CFG3(1'd1),
	.TXPI_CFG4(1'd1),
	.TXPI_CFG5(2'd3),
	.TXPI_GRAY_SEL(1'd0),
	.TXPI_INVSTROBE_SEL(1'd0),
	.TXPI_LPM(1'd0),
	.TXPI_PPMCLK_SEL("TXUSRCLK2"),
	.TXPI_PPM_CFG(1'd0),
	.TXPI_SYNFREQ_PPM(1'd1),
	.TXPI_VREFSEL(1'd0),
	.TXPMARESET_TIME(2'd3),
	.TXSYNC_MULTILANE(1'd0),
	.TXSYNC_OVRD(1'd0),
	.TXSYNC_SKIP_DA(1'd0),
	.TX_CLK25_DIV(4'd8),
	.TX_CLKMUX_EN(1'd1),
	.TX_DATA_WIDTH(5'd20),
	.TX_DCD_CFG(2'd2),
	.TX_DCD_EN(1'd0),
	.TX_DEEMPH0(1'd0),
	.TX_DEEMPH1(1'd0),
	.TX_DIVRESET_TIME(1'd1),
	.TX_DRIVE_MODE("DIRECT"),
	.TX_EIDLE_ASSERT_DELAY(3'd4),
	.TX_EIDLE_DEASSERT_DELAY(2'd3),
	.TX_EML_PHI_TUNE(1'd0),
	.TX_FABINT_USRCLK_FLOP(1'd0),
	.TX_IDLE_DATA_ZERO(1'd0),
	.TX_INT_DATAWIDTH(1'd0),
	.TX_LOOPBACK_DRIVE_HIZ("FALSE"),
	.TX_MAINCURSOR_SEL(1'd0),
	.TX_MARGIN_FULL_0(7'd79),
	.TX_MARGIN_FULL_1(7'd78),
	.TX_MARGIN_FULL_2(7'd76),
	.TX_MARGIN_FULL_3(7'd74),
	.TX_MARGIN_FULL_4(7'd72),
	.TX_MARGIN_LOW_0(7'd70),
	.TX_MARGIN_LOW_1(7'd69),
	.TX_MARGIN_LOW_2(7'd67),
	.TX_MARGIN_LOW_3(7'd66),
	.TX_MARGIN_LOW_4(7'd64),
	.TX_MODE_SEL(1'd0),
	.TX_PMADATA_OPT(1'd0),
	.TX_PMA_POWER_SAVE(1'd0),
	.TX_PROGCLK_SEL("CPLL"),
	.TX_PROGDIV_CFG(20.0),
	.TX_QPI_STATUS_EN(1'd0),
	.TX_RXDETECT_CFG(6'd50),
	.TX_RXDETECT_REF(3'd4),
	.TX_SAMPLE_PERIOD(3'd7),
	.TX_SARC_LPBK_ENB(1'd0),
	.TX_XCLK_SEL("TXOUT"),
	.USE_PCS_CLK_PHASE_SEL(1'd0),
	.WB_MODE(1'd0)
) GTHE3_CHANNEL (
	.CFGRESET(1'd0),
	.CLKRSVD0(1'd0),
	.CLKRSVD1(1'd0),
	.CPLLLOCKDETCLK(1'd0),
	.CPLLLOCKEN(1'd1),
	.CPLLPD(main_ku_1000basex_pll_reset),
	.CPLLREFCLKSEL(1'd1),
	.CPLLRESET(1'd0),
	.DMONFIFORESET(1'd0),
	.DMONITORCLK(1'd0),
	.DRPADDR(1'd0),
	.DRPCLK(1'd0),
	.DRPDI(1'd0),
	.DRPEN(1'd0),
	.DRPWE(1'd0),
	.EVODDPHICALDONE(1'd0),
	.EVODDPHICALSTART(1'd0),
	.EVODDPHIDRDEN(1'd0),
	.EVODDPHIDWREN(1'd0),
	.EVODDPHIXRDEN(1'd0),
	.EVODDPHIXWREN(1'd0),
	.EYESCANMODE(1'd0),
	.EYESCANRESET(1'd0),
	.EYESCANTRIGGER(1'd0),
	.GTGREFCLK(1'd0),
	.GTHRXN(sfp0_rxn),
	.GTHRXP(sfp0_rxp),
	.GTNORTHREFCLK0(1'd0),
	.GTNORTHREFCLK1(1'd0),
	.GTREFCLK0(eth_clk),
	.GTREFCLK1(1'd0),
	.GTRESETSEL(1'd0),
	.GTRSVD(1'd0),
	.GTRXRESET(main_ku_1000basex_rx_reset),
	.GTSOUTHREFCLK0(1'd0),
	.GTSOUTHREFCLK1(1'd0),
	.GTTXRESET(main_ku_1000basex_tx_reset),
	.LOOPBACK(1'd0),
	.LPBKRXTXSEREN(1'd0),
	.LPBKTXRXSEREN(1'd0),
	.PCIEEQRXEQADAPTDONE(1'd0),
	.PCIERSTIDLE(1'd0),
	.PCIERSTTXSYNCSTART(1'd0),
	.PCIEUSERRATEDONE(1'd0),
	.PCSRSVDIN(1'd0),
	.PCSRSVDIN2(1'd0),
	.PMARSVDIN(1'd0),
	.QPLL0CLK(1'd0),
	.QPLL0REFCLK(1'd0),
	.QPLL1CLK(1'd0),
	.QPLL1REFCLK(1'd0),
	.RESETOVRD(1'd0),
	.RSTCLKENTX(1'd0),
	.RX8B10BEN(1'd0),
	.RXBUFRESET(1'd0),
	.RXCDRFREQRESET(1'd0),
	.RXCDRHOLD(1'd0),
	.RXCDROVRDEN(1'd0),
	.RXCDRRESET(1'd0),
	.RXCDRRESETRSV(1'd0),
	.RXCHBONDEN(1'd0),
	.RXCHBONDI(1'd0),
	.RXCHBONDLEVEL(1'd0),
	.RXCHBONDMASTER(1'd0),
	.RXCHBONDSLAVE(1'd0),
	.RXCOMMADETEN(1'd0),
	.RXDFEAGCCTRL(1'd1),
	.RXDFEAGCHOLD(1'd0),
	.RXDFEAGCOVRDEN(1'd0),
	.RXDFELFHOLD(1'd0),
	.RXDFELFOVRDEN(1'd0),
	.RXDFELPMRESET(1'd0),
	.RXDFETAP10HOLD(1'd0),
	.RXDFETAP10OVRDEN(1'd0),
	.RXDFETAP11HOLD(1'd0),
	.RXDFETAP11OVRDEN(1'd0),
	.RXDFETAP12HOLD(1'd0),
	.RXDFETAP12OVRDEN(1'd0),
	.RXDFETAP13HOLD(1'd0),
	.RXDFETAP13OVRDEN(1'd0),
	.RXDFETAP14HOLD(1'd0),
	.RXDFETAP14OVRDEN(1'd0),
	.RXDFETAP15HOLD(1'd0),
	.RXDFETAP15OVRDEN(1'd0),
	.RXDFETAP2HOLD(1'd0),
	.RXDFETAP2OVRDEN(1'd0),
	.RXDFETAP3HOLD(1'd0),
	.RXDFETAP3OVRDEN(1'd0),
	.RXDFETAP4HOLD(1'd0),
	.RXDFETAP4OVRDEN(1'd0),
	.RXDFETAP5HOLD(1'd0),
	.RXDFETAP5OVRDEN(1'd0),
	.RXDFETAP6HOLD(1'd0),
	.RXDFETAP6OVRDEN(1'd0),
	.RXDFETAP7HOLD(1'd0),
	.RXDFETAP7OVRDEN(1'd0),
	.RXDFETAP8HOLD(1'd0),
	.RXDFETAP8OVRDEN(1'd0),
	.RXDFETAP9HOLD(1'd0),
	.RXDFETAP9OVRDEN(1'd0),
	.RXDFEUTHOLD(1'd0),
	.RXDFEUTOVRDEN(1'd0),
	.RXDFEVPHOLD(1'd0),
	.RXDFEVPOVRDEN(1'd0),
	.RXDFEVSEN(1'd0),
	.RXDFEXYDEN(1'd1),
	.RXDLYBYPASS(1'd1),
	.RXDLYEN(1'd0),
	.RXDLYOVRDEN(1'd0),
	.RXDLYSRESET(1'd0),
	.RXELECIDLEMODE(2'd3),
	.RXGEARBOXSLIP(1'd0),
	.RXLATCLK(1'd0),
	.RXLPMEN(1'd1),
	.RXLPMGCHOLD(1'd0),
	.RXLPMGCOVRDEN(1'd0),
	.RXLPMHFHOLD(1'd0),
	.RXLPMHFOVRDEN(1'd0),
	.RXLPMLFHOLD(1'd0),
	.RXLPMLFKLOVRDEN(1'd0),
	.RXLPMOSHOLD(1'd0),
	.RXLPMOSOVRDEN(1'd0),
	.RXMCOMMAALIGNEN(1'd0),
	.RXMONITORSEL(1'd0),
	.RXOOBRESET(1'd0),
	.RXOSCALRESET(1'd0),
	.RXOSHOLD(1'd0),
	.RXOSINTCFG(4'd13),
	.RXOSINTEN(1'd1),
	.RXOSINTHOLD(1'd0),
	.RXOSINTOVRDEN(1'd0),
	.RXOSINTSTROBE(1'd0),
	.RXOSINTTESTOVRDEN(1'd0),
	.RXOSOVRDEN(1'd0),
	.RXOUTCLKSEL(3'd5),
	.RXPCOMMAALIGNEN(1'd0),
	.RXPCSRESET(1'd0),
	.RXPD(1'd0),
	.RXPHALIGN(1'd0),
	.RXPHALIGNEN(1'd0),
	.RXPHDLYPD(1'd1),
	.RXPHDLYRESET(1'd0),
	.RXPHOVRDEN(1'd0),
	.RXPLLCLKSEL(1'd0),
	.RXPMARESET(1'd0),
	.RXPOLARITY(1'd0),
	.RXPRBSCNTRESET(1'd0),
	.RXPRBSSEL(1'd0),
	.RXPROGDIVRESET(1'd0),
	.RXQPIEN(1'd0),
	.RXRATE(1'd0),
	.RXRATEMODE(1'd0),
	.RXSLIDE(1'd0),
	.RXSLIPOUTCLK(1'd0),
	.RXSLIPPMA(1'd0),
	.RXSYNCALLIN(1'd0),
	.RXSYNCIN(1'd0),
	.RXSYNCMODE(1'd0),
	.RXSYSCLKSEL(1'd0),
	.RXUSERRDY(1'd1),
	.RXUSRCLK(eth_rx_half_clk),
	.RXUSRCLK2(eth_rx_half_clk),
	.SIGVALIDCLK(1'd0),
	.TSTIN(1'd0),
	.TX8B10BBYPASS(1'd0),
	.TX8B10BEN(1'd0),
	.TXBUFDIFFCTRL(1'd0),
	.TXCOMINIT(1'd0),
	.TXCOMSAS(1'd0),
	.TXCOMWAKE(1'd0),
	.TXCTRL0({main_ku_1000basex_tx_data0[18], main_ku_1000basex_tx_data0[8]}),
	.TXCTRL1({main_ku_1000basex_tx_data0[19], main_ku_1000basex_tx_data0[9]}),
	.TXCTRL2(1'd0),
	.TXDATA({main_ku_1000basex_tx_data0[17:10], main_ku_1000basex_tx_data0[7:0]}),
	.TXDATAEXTENDRSVD(1'd0),
	.TXDEEMPH(1'd0),
	.TXDETECTRX(1'd0),
	.TXDIFFCTRL(4'd12),
	.TXDIFFPD(1'd0),
	.TXDLYBYPASS(1'd1),
	.TXDLYEN(1'd0),
	.TXDLYHOLD(1'd0),
	.TXDLYOVRDEN(1'd0),
	.TXDLYSRESET(1'd0),
	.TXDLYUPDOWN(1'd0),
	.TXELECIDLE(1'd0),
	.TXHEADER(1'd0),
	.TXINHIBIT(1'd0),
	.TXLATCLK(1'd0),
	.TXMAINCURSOR(7'd64),
	.TXMARGIN(1'd0),
	.TXOUTCLKSEL(3'd5),
	.TXPCSRESET(1'd0),
	.TXPD(1'd0),
	.TXPDELECIDLEMODE(1'd0),
	.TXPHALIGN(1'd0),
	.TXPHALIGNEN(1'd0),
	.TXPHDLYPD(1'd1),
	.TXPHDLYRESET(1'd0),
	.TXPHDLYTSTCLK(1'd0),
	.TXPHINIT(1'd0),
	.TXPHOVRDEN(1'd0),
	.TXPIPPMEN(1'd0),
	.TXPIPPMOVRDEN(1'd0),
	.TXPIPPMPD(1'd0),
	.TXPIPPMSEL(1'd0),
	.TXPIPPMSTEPSIZE(1'd0),
	.TXPISOPD(1'd0),
	.TXPLLCLKSEL(1'd0),
	.TXPMARESET(1'd0),
	.TXPOLARITY(1'd0),
	.TXPOSTCURSOR(1'd0),
	.TXPOSTCURSORINV(1'd0),
	.TXPRBSFORCEERR(1'd0),
	.TXPRBSSEL(1'd0),
	.TXPRECURSOR(1'd0),
	.TXPRECURSORINV(1'd0),
	.TXPROGDIVRESET(1'd0),
	.TXQPIBIASEN(1'd0),
	.TXQPISTRONGPDOWN(1'd0),
	.TXQPIWEAKPUP(1'd0),
	.TXRATE(1'd0),
	.TXRATEMODE(1'd0),
	.TXSEQUENCE(1'd0),
	.TXSWING(1'd0),
	.TXSYNCALLIN(1'd0),
	.TXSYNCIN(1'd0),
	.TXSYNCMODE(1'd0),
	.TXSYSCLKSEL(1'd0),
	.TXUSERRDY(1'd1),
	.TXUSRCLK(eth_tx_half_clk),
	.TXUSRCLK2(eth_tx_half_clk),
	.BUFGTCE(main_ku_1000basex0),
	.BUFGTCEMASK(main_ku_1000basex1),
	.BUFGTDIV(main_ku_1000basex2),
	.BUFGTRESET(main_ku_1000basex3),
	.BUFGTRSTMASK(main_ku_1000basex4),
	.CPLLFBCLKLOST(main_ku_1000basex5),
	.CPLLLOCK(main_ku_1000basex_pll_locked),
	.CPLLREFCLKLOST(main_ku_1000basex6),
	.DMONITOROUT(main_ku_1000basex7),
	.DRPDO(main_ku_1000basex8),
	.DRPRDY(main_ku_1000basex9),
	.EYESCANDATAERROR(main_ku_1000basex10),
	.GTHTXN(sfp0_txn),
	.GTHTXP(sfp0_txp),
	.GTPOWERGOOD(main_ku_1000basex_gtpowergood),
	.GTREFCLKMONITOR(main_ku_1000basex11),
	.PCIERATEGEN3(main_ku_1000basex12),
	.PCIERATEIDLE(main_ku_1000basex13),
	.PCIERATEQPLLPD(main_ku_1000basex14),
	.PCIERATEQPLLRESET(main_ku_1000basex15),
	.PCIESYNCTXSYNCDONE(main_ku_1000basex16),
	.PCIEUSERGEN3RDY(main_ku_1000basex17),
	.PCIEUSERPHYSTATUSRST(main_ku_1000basex18),
	.PCIEUSERRATESTART(main_ku_1000basex19),
	.PCSRSVDOUT(main_ku_1000basex20),
	.PHYSTATUS(main_ku_1000basex21),
	.PINRSRVDAS(main_ku_1000basex22),
	.RESETEXCEPTION(main_ku_1000basex23),
	.RXBUFSTATUS(main_ku_1000basex24),
	.RXBYTEISALIGNED(main_ku_1000basex25),
	.RXBYTEREALIGN(main_ku_1000basex26),
	.RXCDRLOCK(main_ku_1000basex27),
	.RXCDRPHDONE(main_ku_1000basex28),
	.RXCHANBONDSEQ(main_ku_1000basex29),
	.RXCHANISALIGNED(main_ku_1000basex30),
	.RXCHANREALIGN(main_ku_1000basex31),
	.RXCHBONDO(main_ku_1000basex32),
	.RXCLKCORCNT(main_ku_1000basex33),
	.RXCOMINITDET(main_ku_1000basex34),
	.RXCOMMADET(main_ku_1000basex35),
	.RXCOMSASDET(main_ku_1000basex36),
	.RXCOMWAKEDET(main_ku_1000basex37),
	.RXCTRL0({main_ku_1000basex_rx_data0[18], main_ku_1000basex_rx_data0[8]}),
	.RXCTRL1({main_ku_1000basex_rx_data0[19], main_ku_1000basex_rx_data0[9]}),
	.RXCTRL2(main_ku_1000basex38),
	.RXCTRL3(main_ku_1000basex39),
	.RXDATA({main_ku_1000basex_rx_data0[17:10], main_ku_1000basex_rx_data0[7:0]}),
	.RXDATAEXTENDRSVD(main_ku_1000basex40),
	.RXDATAVALID(main_ku_1000basex41),
	.RXDLYSRESETDONE(main_ku_1000basex42),
	.RXELECIDLE(main_ku_1000basex43),
	.RXHEADER(main_ku_1000basex44),
	.RXHEADERVALID(main_ku_1000basex45),
	.RXMONITOROUT(main_ku_1000basex46),
	.RXOSINTDONE(main_ku_1000basex47),
	.RXOSINTSTARTED(main_ku_1000basex48),
	.RXOSINTSTROBEDONE(main_ku_1000basex49),
	.RXOSINTSTROBESTARTED(main_ku_1000basex50),
	.RXOUTCLK(main_ku_1000basex_rxoutclk),
	.RXOUTCLKFABRIC(main_ku_1000basex51),
	.RXOUTCLKPCS(main_ku_1000basex52),
	.RXPHALIGNDONE(main_ku_1000basex53),
	.RXPHALIGNERR(main_ku_1000basex54),
	.RXPMARESETDONE(main_ku_1000basex55),
	.RXPRBSERR(main_ku_1000basex56),
	.RXPRBSLOCKED(main_ku_1000basex57),
	.RXPRGDIVRESETDONE(main_ku_1000basex58),
	.RXQPISENN(main_ku_1000basex59),
	.RXQPISENP(main_ku_1000basex60),
	.RXRATEDONE(main_ku_1000basex61),
	.RXRECCLKOUT(main_ku_1000basex62),
	.RXRESETDONE(main_ku_1000basex_rx_reset_done),
	.RXSLIDERDY(main_ku_1000basex63),
	.RXSLIPDONE(main_ku_1000basex64),
	.RXSLIPOUTCLKRDY(main_ku_1000basex65),
	.RXSLIPPMARDY(main_ku_1000basex66),
	.RXSTARTOFSEQ(main_ku_1000basex67),
	.RXSTATUS(main_ku_1000basex68),
	.RXSYNCDONE(main_ku_1000basex69),
	.RXSYNCOUT(main_ku_1000basex70),
	.RXVALID(main_ku_1000basex71),
	.TXBUFSTATUS(main_ku_1000basex72),
	.TXCOMFINISH(main_ku_1000basex73),
	.TXDLYSRESETDONE(main_ku_1000basex74),
	.TXOUTCLK(main_ku_1000basex_txoutclk),
	.TXOUTCLKFABRIC(main_ku_1000basex75),
	.TXOUTCLKPCS(main_ku_1000basex76),
	.TXPHALIGNDONE(main_ku_1000basex77),
	.TXPHINITDONE(main_ku_1000basex78),
	.TXPMARESETDONE(main_ku_1000basex79),
	.TXPRGDIVRESETDONE(main_ku_1000basex80),
	.TXQPISENN(main_ku_1000basex81),
	.TXQPISENP(main_ku_1000basex82),
	.TXRATEDONE(main_ku_1000basex83),
	.TXRESETDONE(main_ku_1000basex_tx_reset_done),
	.TXSYNCDONE(main_ku_1000basex84),
	.TXSYNCOUT(main_ku_1000basex85)
);

BUFG_GT BUFG_GT(
	.DIV(1'd0),
	.I(main_ku_1000basex_txoutclk),
	.O(eth_tx_clk)
);

BUFG_GT BUFG_GT_1(
	.DIV(1'd1),
	.I(main_ku_1000basex_txoutclk),
	.O(eth_tx_half_clk)
);

BUFG_GT BUFG_GT_2(
	.DIV(1'd0),
	.I(main_ku_1000basex_rxoutclk),
	.O(eth_rx_clk)
);

BUFG_GT BUFG_GT_3(
	.DIV(1'd1),
	.I(main_ku_1000basex_rxoutclk),
	.O(eth_rx_half_clk)
);

//------------------------------------------------------------------------------
// Memory storage_10: 32-words x 42-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 42 
// Port 1 | Read: Sync  | Write: ---- | 
reg [41:0] storage_10[0:31];
reg [41:0] storage_10_dat0;
reg [41:0] storage_10_dat1;
always @(posedge sys_clk) begin
	if (main_ethmac_tx_cdc_cdc_wrport_we)
		storage_10[main_ethmac_tx_cdc_cdc_wrport_adr] <= main_ethmac_tx_cdc_cdc_wrport_dat_w;
	storage_10_dat0 <= storage_10[main_ethmac_tx_cdc_cdc_wrport_adr];
end
always @(posedge eth_tx_clk) begin
	storage_10_dat1 <= storage_10[main_ethmac_tx_cdc_cdc_rdport_adr];
end
assign main_ethmac_tx_cdc_cdc_wrport_dat_r = storage_10_dat0;
assign main_ethmac_tx_cdc_cdc_rdport_dat_r = storage_10_dat1;


//------------------------------------------------------------------------------
// Memory storage_11: 5-words x 12-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 12 
// Port 1 | Read: Async | Write: ---- | 
reg [11:0] storage_11[0:4];
reg [11:0] storage_11_dat0;
always @(posedge eth_rx_clk) begin
	if (main_ethmac_liteethmaccrc32checker_syncfifo_wrport_we)
		storage_11[main_ethmac_liteethmaccrc32checker_syncfifo_wrport_adr] <= main_ethmac_liteethmaccrc32checker_syncfifo_wrport_dat_w;
	storage_11_dat0 <= storage_11[main_ethmac_liteethmaccrc32checker_syncfifo_wrport_adr];
end
always @(posedge eth_rx_clk) begin
end
assign main_ethmac_liteethmaccrc32checker_syncfifo_wrport_dat_r = storage_11_dat0;
assign main_ethmac_liteethmaccrc32checker_syncfifo_rdport_dat_r = storage_11[main_ethmac_liteethmaccrc32checker_syncfifo_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_12: 32-words x 42-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 42 
// Port 1 | Read: Sync  | Write: ---- | 
reg [41:0] storage_12[0:31];
reg [41:0] storage_12_dat0;
reg [41:0] storage_12_dat1;
always @(posedge eth_rx_clk) begin
	if (main_ethmac_rx_cdc_cdc_wrport_we)
		storage_12[main_ethmac_rx_cdc_cdc_wrport_adr] <= main_ethmac_rx_cdc_cdc_wrport_dat_w;
	storage_12_dat0 <= storage_12[main_ethmac_rx_cdc_cdc_wrport_adr];
end
always @(posedge sys_clk) begin
	storage_12_dat1 <= storage_12[main_ethmac_rx_cdc_cdc_rdport_adr];
end
assign main_ethmac_rx_cdc_cdc_wrport_dat_r = storage_12_dat0;
assign main_ethmac_rx_cdc_cdc_rdport_dat_r = storage_12_dat1;


//------------------------------------------------------------------------------
// Memory storage_13: 2-words x 14-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 14 
// Port 1 | Read: Async | Write: ---- | 
reg [13:0] storage_13[0:1];
reg [13:0] storage_13_dat0;
always @(posedge sys_clk) begin
	if (main_ethmac_sram61_we)
		storage_13[main_ethmac_sram59_adr] <= main_ethmac_sram62_dat_w;
	storage_13_dat0 <= storage_13[main_ethmac_sram59_adr];
end
always @(posedge sys_clk) begin
end
assign main_ethmac_sram60_dat_r = storage_13_dat0;
assign main_ethmac_sram65_dat_r = storage_13[main_ethmac_sram64_adr];


//------------------------------------------------------------------------------
// Memory mem_1: 383-words x 32-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Write-First | Write-Granularity: 32 
// Port 1 | Read: Sync  | Write: ---- | 
reg [31:0] mem_1[0:382];
reg [8:0] mem_1_adr0;
reg [31:0] mem_1_dat1;
always @(posedge sys_clk) begin
	if (main_ethmac_sram77_we)
		mem_1[main_ethmac_sram75_adr] <= main_ethmac_sram78_dat_w;
	mem_1_adr0 <= main_ethmac_sram75_adr;
end
always @(posedge sys_clk) begin
	mem_1_dat1 <= mem_1[main_ethmac_sram2_adr];
end
assign main_ethmac_sram76_dat_r = mem_1[mem_1_adr0];
assign main_ethmac_sram2_dat_r = mem_1_dat1;


//------------------------------------------------------------------------------
// Memory mem_2: 383-words x 32-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Write-First | Write-Granularity: 32 
// Port 1 | Read: Sync  | Write: ---- | 
reg [31:0] mem_2[0:382];
reg [8:0] mem_2_adr0;
reg [31:0] mem_2_dat1;
always @(posedge sys_clk) begin
	if (main_ethmac_sram81_we)
		mem_2[main_ethmac_sram79_adr] <= main_ethmac_sram82_dat_w;
	mem_2_adr0 <= main_ethmac_sram79_adr;
end
always @(posedge sys_clk) begin
	mem_2_dat1 <= mem_2[main_ethmac_sram3_adr];
end
assign main_ethmac_sram80_dat_r = mem_2[mem_2_adr0];
assign main_ethmac_sram3_dat_r = mem_2_dat1;


//------------------------------------------------------------------------------
// Memory storage_14: 2-words x 14-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 14 
// Port 1 | Read: Async | Write: ---- | 
reg [13:0] storage_14[0:1];
reg [13:0] storage_14_dat0;
always @(posedge sys_clk) begin
	if (main_ethmac_sram147_we)
		storage_14[main_ethmac_sram145_adr] <= main_ethmac_sram148_dat_w;
	storage_14_dat0 <= storage_14[main_ethmac_sram145_adr];
end
always @(posedge sys_clk) begin
end
assign main_ethmac_sram146_dat_r = storage_14_dat0;
assign main_ethmac_sram151_dat_r = storage_14[main_ethmac_sram150_adr];


//------------------------------------------------------------------------------
// Memory mem_3: 383-words x 32-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: ---- | 
// Port 1 | Read: Sync  | Write: Sync | Mode: Write-First | Write-Granularity: 8 
reg [31:0] mem_3[0:382];
reg [8:0] mem_3_adr0;
reg [8:0] mem_3_adr1;
always @(posedge sys_clk) begin
	if (main_ethmac_sram163_re)
		mem_3_adr0 <= main_ethmac_sram161_adr;
end
always @(posedge sys_clk) begin
	if (main_ethmac_sram4_we[0])
		mem_3[main_ethmac_sram4_adr][7:0] <= main_ethmac_sram4_dat_w[7:0];
	if (main_ethmac_sram4_we[1])
		mem_3[main_ethmac_sram4_adr][15:8] <= main_ethmac_sram4_dat_w[15:8];
	if (main_ethmac_sram4_we[2])
		mem_3[main_ethmac_sram4_adr][23:16] <= main_ethmac_sram4_dat_w[23:16];
	if (main_ethmac_sram4_we[3])
		mem_3[main_ethmac_sram4_adr][31:24] <= main_ethmac_sram4_dat_w[31:24];
	mem_3_adr1 <= main_ethmac_sram4_adr;
end
assign main_ethmac_sram162_dat_r = mem_3[mem_3_adr0];
assign main_ethmac_sram4_dat_r = mem_3[mem_3_adr1];


//------------------------------------------------------------------------------
// Memory mem_4: 383-words x 32-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: ---- | 
// Port 1 | Read: Sync  | Write: Sync | Mode: Write-First | Write-Granularity: 8 
reg [31:0] mem_4[0:382];
reg [8:0] mem_4_adr0;
reg [8:0] mem_4_adr1;
always @(posedge sys_clk) begin
	if (main_ethmac_sram166_re)
		mem_4_adr0 <= main_ethmac_sram164_adr;
end
always @(posedge sys_clk) begin
	if (main_ethmac_sram5_we[0])
		mem_4[main_ethmac_sram5_adr][7:0] <= main_ethmac_sram5_dat_w[7:0];
	if (main_ethmac_sram5_we[1])
		mem_4[main_ethmac_sram5_adr][15:8] <= main_ethmac_sram5_dat_w[15:8];
	if (main_ethmac_sram5_we[2])
		mem_4[main_ethmac_sram5_adr][23:16] <= main_ethmac_sram5_dat_w[23:16];
	if (main_ethmac_sram5_we[3])
		mem_4[main_ethmac_sram5_adr][31:24] <= main_ethmac_sram5_dat_w[31:24];
	mem_4_adr1 <= main_ethmac_sram5_adr;
end
assign main_ethmac_sram165_dat_r = mem_4[mem_4_adr0];
assign main_ethmac_sram5_dat_r = mem_4[mem_4_adr1];


//------------------------------------------------------------------------------
// Memory storage_15: 8-words x 10-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 10 
// Port 1 | Read: Async | Write: ---- | 
reg [9:0] storage_15[0:7];
reg [9:0] storage_15_dat0;
always @(posedge sys_clk) begin
	if (sdcore_fifo_wrport_we)
		storage_15[sdcore_fifo_wrport_adr] <= sdcore_fifo_wrport_dat_w;
	storage_15_dat0 <= storage_15[sdcore_fifo_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign sdcore_fifo_wrport_dat_r = storage_15_dat0;
assign sdcore_fifo_rdport_dat_r = storage_15[sdcore_fifo_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_16: 512-words x 10-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 10 
// Port 1 | Read: Sync  | Write: ---- | 
reg [9:0] storage_16[0:511];
reg [9:0] storage_16_dat0;
reg [9:0] storage_16_dat1;
always @(posedge sys_clk) begin
	if (sdblock2mem_fifo_wrport_we)
		storage_16[sdblock2mem_fifo_wrport_adr] <= sdblock2mem_fifo_wrport_dat_w;
	storage_16_dat0 <= storage_16[sdblock2mem_fifo_wrport_adr];
end
always @(posedge sys_clk) begin
	if (sdblock2mem_fifo_rdport_re)
		storage_16_dat1 <= storage_16[sdblock2mem_fifo_rdport_adr];
end
assign sdblock2mem_fifo_wrport_dat_r = storage_16_dat0;
assign sdblock2mem_fifo_rdport_dat_r = storage_16_dat1;


//------------------------------------------------------------------------------
// Memory storage_17: 16-words x 34-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 34 
// Port 1 | Read: Async | Write: ---- | 
reg [33:0] storage_17[0:15];
reg [33:0] storage_17_dat0;
always @(posedge sys_clk) begin
	if (sdmem2block_dma_fifo_wrport_we)
		storage_17[sdmem2block_dma_fifo_wrport_adr] <= sdmem2block_dma_fifo_wrport_dat_w;
	storage_17_dat0 <= storage_17[sdmem2block_dma_fifo_wrport_adr];
end
always @(posedge sys_clk) begin
end
assign sdmem2block_dma_fifo_wrport_dat_r = storage_17_dat0;
assign sdmem2block_dma_fifo_rdport_dat_r = storage_17[sdmem2block_dma_fifo_rdport_adr];


//------------------------------------------------------------------------------
// Memory storage_18: 512-words x 10-bit
//------------------------------------------------------------------------------
// Port 0 | Read: Sync  | Write: Sync | Mode: Read-First  | Write-Granularity: 10 
// Port 1 | Read: Sync  | Write: ---- | 
reg [9:0] storage_18[0:511];
reg [9:0] storage_18_dat0;
reg [9:0] storage_18_dat1;
always @(posedge sys_clk) begin
	if (sdmem2block_fifo_wrport_we)
		storage_18[sdmem2block_fifo_wrport_adr] <= sdmem2block_fifo_wrport_dat_w;
	storage_18_dat0 <= storage_18[sdmem2block_fifo_wrport_adr];
end
always @(posedge sys_clk) begin
	if (sdmem2block_fifo_rdport_re)
		storage_18_dat1 <= storage_18[sdmem2block_fifo_rdport_adr];
end
assign sdmem2block_fifo_wrport_dat_r = storage_18_dat0;
assign sdmem2block_fifo_rdport_dat_r = storage_18_dat1;


FDCE FDCE(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(main_crg_reset),
	.Q(builder_soclinux_reset0)
);

FDCE FDCE_1(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_soclinux_reset0),
	.Q(builder_soclinux_reset1)
);

FDCE FDCE_2(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_soclinux_reset1),
	.Q(builder_soclinux_reset2)
);

FDCE FDCE_3(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_soclinux_reset2),
	.Q(builder_soclinux_reset3)
);

FDCE FDCE_4(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_soclinux_reset3),
	.Q(builder_soclinux_reset4)
);

FDCE FDCE_5(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_soclinux_reset4),
	.Q(builder_soclinux_reset5)
);

FDCE FDCE_6(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_soclinux_reset5),
	.Q(builder_soclinux_reset6)
);

FDCE FDCE_7(
	.C(main_crg_clkin),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_soclinux_reset6),
	.Q(builder_soclinux_reset7)
);

MMCME2_ADV #(
	.BANDWIDTH("OPTIMIZED"),
	.CLKFBOUT_MULT_F(4'd8),
	.CLKIN1_PERIOD(8.0),
	.CLKOUT0_DIVIDE_F(2'd2),
	.CLKOUT0_PHASE(1'd0),
	.CLKOUT1_DIVIDE(3'd5),
	.CLKOUT1_PHASE(1'd0),
	.CLKOUT2_DIVIDE(3'd5),
	.CLKOUT2_PHASE(1'd0),
	.DIVCLK_DIVIDE(1'd1),
	.REF_JITTER1(0.01)
) MMCME2_ADV (
	.CLKFBIN(builder_soclinux_mmcm_fb),
	.CLKIN1(main_crg_clkin),
	.PWRDWN(main_crg_power_down),
	.RST(builder_soclinux_reset7),
	.CLKFBOUT(builder_soclinux_mmcm_fb),
	.CLKOUT0(main_crg_clkout0),
	.CLKOUT1(main_crg_clkout1),
	.CLKOUT2(main_crg_clkout2),
	.LOCKED(main_crg_locked)
);

VexRiscvLitexSmpCluster_Cc4_Iw64Is8192Iy2_Dw64Ds8192Dy2_ITs4DTs4_Ldw512_Cdma_Ood VexRiscvLitexSmpCluster_Cc4_Iw64Is8192Iy2_Dw64Ds8192Dy2_ITs4DTs4_Ldw512_Cdma_Ood(
	.clintWishbone_ADR(main_clintbus_adr),
	.clintWishbone_CYC(main_clintbus_cyc),
	.clintWishbone_DAT_MOSI(main_clintbus_dat_w),
	.clintWishbone_STB(main_clintbus_stb),
	.clintWishbone_WE(main_clintbus_we),
	.dBridge_dram_cmd_ready(main_dbus_cmd_ready),
	.dBridge_dram_rdata_payload_data(main_dbus_rdata_payload_data),
	.dBridge_dram_rdata_valid(main_dbus_rdata_valid),
	.dBridge_dram_wdata_ready(main_dbus_wdata_ready),
	.debugCd_external_clk(sys_clk),
	.debugCd_external_reset((sys_rst | main_cpu_reset)),
	.debugPort_capture(main_cpu_jtag_capture),
	.debugPort_enable(main_cpu_jtag_enable),
	.debugPort_reset(main_cpu_jtag_reset),
	.debugPort_shift(main_cpu_jtag_shift),
	.debugPort_tdi(main_cpu_jtag_tdi),
	.debugPort_update(main_cpu_jtag_update),
	.dma_wishbone_ADR(main_cpu_dma_bus_adr),
	.dma_wishbone_CYC(main_cpu_dma_bus_cyc),
	.dma_wishbone_DAT_MOSI(main_cpu_dma_bus_dat_w),
	.dma_wishbone_SEL(main_cpu_dma_bus_sel),
	.dma_wishbone_STB((main_cpu_dma_bus_stb & (~main_cpu_dma_bus_inhibit))),
	.dma_wishbone_WE(main_cpu_dma_bus_we),
	.iBridge_dram_cmd_ready(main_ibus_cmd_ready),
	.iBridge_dram_rdata_payload_data(main_ibus_rdata_payload_data),
	.iBridge_dram_rdata_valid(main_ibus_rdata_valid),
	.iBridge_dram_wdata_ready(main_ibus_wdata_ready),
	.interrupts(main_cpu_interrupt),
	.jtag_clk(main_cpu_jtag_clk),
	.peripheral_ACK(main_cpu_pbus_ack),
	.peripheral_DAT_MISO(main_cpu_pbus_dat_r),
	.peripheral_ERR(main_cpu_pbus_err),
	.plicWishbone_ADR(main_plicbus_adr),
	.plicWishbone_CYC(main_plicbus_cyc),
	.plicWishbone_DAT_MOSI(main_plicbus_dat_w),
	.plicWishbone_STB(main_plicbus_stb),
	.plicWishbone_WE(main_plicbus_we),
	.clintWishbone_ACK(main_clintbus_ack),
	.clintWishbone_DAT_MISO(main_clintbus_dat_r),
	.dBridge_dram_cmd_payload_addr(main_dbus_cmd_payload_addr),
	.dBridge_dram_cmd_payload_we(main_dbus_cmd_payload_we),
	.dBridge_dram_cmd_valid(main_dbus_cmd_valid),
	.dBridge_dram_rdata_ready(main_dbus_rdata_ready),
	.dBridge_dram_wdata_payload_data(main_dbus_wdata_payload_data),
	.dBridge_dram_wdata_payload_we(main_dbus_wdata_payload_we),
	.dBridge_dram_wdata_valid(main_dbus_wdata_valid),
	.debugPort_tdo(main_cpu_jtag_tdo),
	.dma_wishbone_ACK(main_cpu_dma_bus_ack),
	.dma_wishbone_DAT_MISO(main_cpu_dma_bus_dat_r),
	.dma_wishbone_STALL(main_cpu_dma_bus_stall),
	.iBridge_dram_cmd_payload_addr(main_ibus_cmd_payload_addr),
	.iBridge_dram_cmd_payload_we(main_ibus_cmd_payload_we),
	.iBridge_dram_cmd_valid(main_ibus_cmd_valid),
	.iBridge_dram_rdata_ready(main_ibus_rdata_ready),
	.iBridge_dram_wdata_payload_data(main_ibus_wdata_payload_data),
	.iBridge_dram_wdata_payload_we(main_ibus_wdata_payload_we),
	.iBridge_dram_wdata_valid(main_ibus_wdata_valid),
	.peripheral_ADR(main_cpu_pbus_adr),
	.peripheral_BTE(main_cpu_pbus_bte),
	.peripheral_CTI(main_cpu_pbus_cti),
	.peripheral_CYC(main_cpu_pbus_cyc),
	.peripheral_DAT_MOSI(main_cpu_pbus_dat_w),
	.peripheral_SEL(main_cpu_pbus_sel),
	.peripheral_STB(main_cpu_pbus_stb),
	.peripheral_WE(main_cpu_pbus_we),
	.plicWishbone_ACK(main_plicbus_ack),
	.plicWishbone_DAT_MISO(main_plicbus_dat_r)
);

IBUFDS IBUFDS(
	.I(clk125_p),
	.IB(clk125_n),
	.O(main_crg_clkin)
);

(* ars_ff1 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE (
	.C(idelay_clk),
	.CE(1'd1),
	.D(1'd0),
	.PRE(builder_xilinxasyncresetsynchronizerimpl0),
	.Q(builder_xilinxasyncresetsynchronizerimpl0_rst_meta)
);

(* ars_ff2 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_1 (
	.C(idelay_clk),
	.CE(1'd1),
	.D(builder_xilinxasyncresetsynchronizerimpl0_rst_meta),
	.PRE(builder_xilinxasyncresetsynchronizerimpl0),
	.Q(idelay_rst)
);

(* ars_ff1 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_2 (
	.C(eth_clk),
	.CE(1'd1),
	.D(1'd0),
	.PRE(builder_xilinxasyncresetsynchronizerimpl1),
	.Q(builder_xilinxasyncresetsynchronizerimpl1_rst_meta)
);

(* ars_ff2 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_3 (
	.C(eth_clk),
	.CE(1'd1),
	.D(builder_xilinxasyncresetsynchronizerimpl1_rst_meta),
	.PRE(builder_xilinxasyncresetsynchronizerimpl1),
	.Q(eth_rst)
);

(* ars_ff1 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_4 (
	.C(ic_clk),
	.CE(1'd1),
	.D(1'd0),
	.PRE(main_crg_idelayctrl_ic_reset),
	.Q(builder_xilinxasyncresetsynchronizerimpl2_rst_meta)
);

(* ars_ff2 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_5 (
	.C(ic_clk),
	.CE(1'd1),
	.D(builder_xilinxasyncresetsynchronizerimpl2_rst_meta),
	.PRE(main_crg_idelayctrl_ic_reset),
	.Q(ic_rst)
);

(* ars_ff1 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_6 (
	.C(eth_tx_clk),
	.CE(1'd1),
	.D(1'd0),
	.PRE(builder_xilinxasyncresetsynchronizerimpl3),
	.Q(builder_xilinxasyncresetsynchronizerimpl3_rst_meta)
);

(* ars_ff2 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_7 (
	.C(eth_tx_clk),
	.CE(1'd1),
	.D(builder_xilinxasyncresetsynchronizerimpl3_rst_meta),
	.PRE(builder_xilinxasyncresetsynchronizerimpl3),
	.Q(eth_tx_rst)
);

(* ars_ff1 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_8 (
	.C(eth_rx_clk),
	.CE(1'd1),
	.D(1'd0),
	.PRE(builder_xilinxasyncresetsynchronizerimpl4),
	.Q(builder_xilinxasyncresetsynchronizerimpl4_rst_meta)
);

(* ars_ff2 = "true", async_reg = "true" *)
FDPE #(
	.INIT(1'd1)
) FDPE_9 (
	.C(eth_rx_clk),
	.CE(1'd1),
	.D(builder_xilinxasyncresetsynchronizerimpl4_rst_meta),
	.PRE(builder_xilinxasyncresetsynchronizerimpl4),
	.Q(eth_rx_rst)
);

FDCE FDCE_8(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D((~clocker_clk0)),
	.Q(sdcard_clk)
);

IOBUF IOBUF_64(
	.I(builder_xilinxsdrtristateimpl0__o),
	.T(builder_xilinxsdrtristateimpl0_oe_n),
	.IO(sdcard_cmd),
	.O(builder_xilinxsdrtristateimpl0__i)
);

IOBUF IOBUF_65(
	.I(builder_xilinxsdrtristateimpl1__o),
	.T(builder_xilinxsdrtristateimpl1_oe_n),
	.IO(sdcard_data[0]),
	.O(builder_xilinxsdrtristateimpl1__i)
);

IOBUF IOBUF_66(
	.I(builder_xilinxsdrtristateimpl2__o),
	.T(builder_xilinxsdrtristateimpl2_oe_n),
	.IO(sdcard_data[1]),
	.O(builder_xilinxsdrtristateimpl2__i)
);

IOBUF IOBUF_67(
	.I(builder_xilinxsdrtristateimpl3__o),
	.T(builder_xilinxsdrtristateimpl3_oe_n),
	.IO(sdcard_data[2]),
	.O(builder_xilinxsdrtristateimpl3__i)
);

IOBUF IOBUF_68(
	.I(builder_xilinxsdrtristateimpl4__o),
	.T(builder_xilinxsdrtristateimpl4_oe_n),
	.IO(sdcard_data[3]),
	.O(builder_xilinxsdrtristateimpl4__i)
);

FDCE FDCE_9(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(sdpads_cmd_o),
	.Q(builder_xilinxsdrtristateimpl0__o)
);

FDCE FDCE_10(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D((~sdpads_cmd_oe)),
	.Q(builder_xilinxsdrtristateimpl0_oe_n)
);

FDCE FDCE_11(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_xilinxsdrtristateimpl0__i),
	.Q(sdpads_cmd_i)
);

FDCE FDCE_12(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(sdpads_data_o[0]),
	.Q(builder_xilinxsdrtristateimpl1__o)
);

FDCE FDCE_13(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D((~sdpads_data_oe)),
	.Q(builder_xilinxsdrtristateimpl1_oe_n)
);

FDCE FDCE_14(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_xilinxsdrtristateimpl1__i),
	.Q(sdpads_data_i[0])
);

FDCE FDCE_15(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(sdpads_data_o[1]),
	.Q(builder_xilinxsdrtristateimpl2__o)
);

FDCE FDCE_16(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D((~sdpads_data_oe)),
	.Q(builder_xilinxsdrtristateimpl2_oe_n)
);

FDCE FDCE_17(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_xilinxsdrtristateimpl2__i),
	.Q(sdpads_data_i[1])
);

FDCE FDCE_18(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(sdpads_data_o[2]),
	.Q(builder_xilinxsdrtristateimpl3__o)
);

FDCE FDCE_19(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D((~sdpads_data_oe)),
	.Q(builder_xilinxsdrtristateimpl3_oe_n)
);

FDCE FDCE_20(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_xilinxsdrtristateimpl3__i),
	.Q(sdpads_data_i[2])
);

FDCE FDCE_21(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(sdpads_data_o[3]),
	.Q(builder_xilinxsdrtristateimpl4__o)
);

FDCE FDCE_22(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D((~sdpads_data_oe)),
	.Q(builder_xilinxsdrtristateimpl4_oe_n)
);

FDCE FDCE_23(
	.C(sys_clk),
	.CE(1'd1),
	.CLR(1'd0),
	.D(builder_xilinxsdrtristateimpl4__i),
	.Q(sdpads_data_i[3])
);

endmodule

// -----------------------------------------------------------------------------
//  Auto-Generated by LiteX on 2023-06-21 10:56:40.
//------------------------------------------------------------------------------
